! subroutine traitant l'vaporation des gouttes spcfiquement pour
! schma de KE
!  modifier  la moindre modif du schma de KE


      subroutine appel_stewart_vectall(lwork,ncum,
     :           PH,T,EVAP,XTWDTRAIN,
     :                   WDTRAIN,
     :            WATER,Q,XT, QS,QP,MP,WT, ! inputs physiques
     :            XTWATER,XTP,    ! outputs indispensables
     :           XTEVAP,     ! diagnostiques
     :          SIGD,  ! inputs tunables
     :          i,INB, ! altitude: car cas particulier en INB 
     :          NA,ND,nloc,cvflag_grav,ginv,Mpmin) ! dimensions  

      implicit none

!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl

      !*inputs et outputs
      integer ncum ! dimension horiz effective
      logical lwork(nloc)
      integer NA,ND,nloc ! dimensions officielles
      real PH(nloc,ND),T(nloc,ND),EVAP(nloc,NA)
      real XTWDTRAIN(ntraciso,nloc),WDTRAIN(nloc),
     :       WATER(nloc,NA), Q(nloc,NA), XT(ntraciso,nloc,ND),
     :            QS(nloc,ND),QP(nloc,NA),
     :       XTWATER(ntraciso,nloc,NA),XTP(ntraciso,nloc,NA),
     :     XTEVAP(ntraciso,nloc,NA),
     :       WT(nloc,NA), MP(nloc,NA)
      real SIGD
      integer i,INB(nloc)
      logical cvflag_grav
      real ginv
      real Mpmin

      !* variables intermediaires
      integer ixt,j,il
      real qeff(ncum)
      double precision xtp_avantevap(ntraciso,ncum),qp_avantevap(ncum)
!      double precision Exi(niso,ncum) ! equivalent  Eqi_prime
      double precision Pqisup(ncum),Pqiinf(ncum),Eqi(ncum) 
      double precision Pqiinf_par(ncum), Eqi_prime(ncum), 
     :            Eqi_plus1(ncum), Eqi_par(ncum)
      double precision Pqiinf_stewart(ncum), Eqi_stewart(ncum)
      double precision Exi_prime(ntraciso,ncum)
      double precision Pxtiinf_stewart(niso,ncum), 
     :           Exi_stewart(niso,ncum)
      double precision Exi_plus1(niso,ncum)
      double precision Pxtisup(ntraciso,ncum), Pxtiinf(niso,ncum)
      double precision xtnew(niso,ncum)
      double precision fac_ftmr(ncum) ! facteur de conversion des flux en mixing ratio
!      double precision Risup(ntraciso,ncum), Rcond(ntraciso,ncum), 
!     :           Renv(ntraciso,ncum) 
!      double precision  Revap(ntraciso,ncum), Riinf(ntraciso,ncum)
!      real xtice(ntraciso,ncum), xtliq(ntraciso,ncum)
!      real xtp0(ntraciso,ncum), qp0(ncum)
!     real fcond(ncum), fice(ncum), cond(ncum)
!      real zxtalphal(niso,ncum), zxtalphai(niso,ncum)
      real g
      real rat(ncum)
      real ztglace_kelvin
      parameter (ztglace_kelvin=273.15)

      integer frac_sublim
      real double_to_real     
      double precision real_to_double

      ! compteurs de parsage
      integer icas_condensation_facftmr,ncas_condensation_facftmr
      integer icas_condensation_nofacftmr,ncas_condensation_nofacftmr
      integer icas_noevap,ncas_noevap
      integer icas_evap_liq,ncas_evap_liq
      integer icas_evap_glace,ncas_evap_glace
      integer ncas_tot

      ! tableaux d'indice issus du parsage
      integer cas_condensation_facftmr(ncum)
      integer cas_condensation_nofacftmr(ncum)
      integer cas_noevap(ncum)
      integer cas_evap_liq(ncum)
      integer cas_evap_glace(ncum)

       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      

      ! outputs des calculs, compresss
      real xtevap_cas(niso,ncum),xtp_cas(niso,ncum),
     :            xtwater_cas(niso,ncum)

      ! inputs des calculs, comprsss
      real T_cas(ncum),delP_cas(ncum),
     :           xtevapsup_cas(niso,ncum),evap_cas(ncum),
     :           qp_cas(ncum),wt_cas(ncum),
     :           xt_cas(niso,ncum),q_cas(ncum),
     :           qs_cas(ncum),water_cas(ncum)           
      double precision  qp_avantevap_cas(ncum),
     :   xtp_avantevap_cas(niso,ncum),
     :   Pqisup_cas(ncum), Pxtisup_cas(niso,ncum), 
     :   Eqi_prime_cas(ncum),fac_ftmr_cas(ncum), 
     :   Eqi_cas(ncum)
      integer INB_cas(ncum)
              

!      write(*,*) 'appel stewart 48: entre, i=',i

      ! definition de quelques constantes:

      !gravit:
      if (cvflag_grav) then
          g=1/ginv
      else
          g=10.
      endif

      ! fractionne-t-on lors de la sublimation?
      frac_sublim=0 ! -> on ne fractionne pas
      !frac_sublim=1 ! -> oui, on fractionne
      

      ! ***** verification des inputs ************
      
      if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
         do il=1,ncum 
             if (i.le.inb(il) .and. lwork(il)) then   
                xt(iso_eau,il,i)=  q(il,i)
             endif !if (i.le.inb(il) .and. lwork(il)) then
           enddo !do il=1,ncum     
      endif !if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
      
      ! verif que les vapeurs du ddft plus haut sont bonnes
      ! si i=INB, on ne verifie rien car pas de vapeur au dessus de INB

      if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
       do il=1,ncum 
        if (i.lt.inb(il) .and. lwork(il)) then
         do j=i+1,INB(il)
          xtp(iso_eau,il,j)=qp(il,j)          
         enddo !do j=i+1,INB
        endif ! (i.lt.inb(il) .and. lwork(il)) then
       enddo !do il=1,ncum 
      endif !if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
      ! end verif des inputs 


      ! ****** calcul du facteur de conversion des flux en mixing ratio
      
      do il=1,ncum 
       if (i.le.inb(il) .and. lwork(il)) then
        if (Mp(il,i).gt.Mp(il,i+1)) then
          ! cas entrainant
          fac_ftmr(il)=1.0/Mp(il,i)
        else !if (Mp(il,i).gt.Mp(il,i+1)) then
          if (Mp(il,i+1).gt.Mpmin) then
              ! cas non entrainant, mais flux existe
              fac_ftmr(il)=1.0/Mp(il,i+1)
          else !if (Mp(il,i+1).gt.Mpmin) then
              ! pas de flux de masse, XTP reste constant
              fac_ftmr(il)=0.0
          endif !if (Mp(il,i+1).gt.Mpmin) then
        endif !if (Mp(il,i).gt.Mp(il,i+1)) then
       endif ! (i.le.inb(il) .and. lwork(il)) then
      enddo !do il=1,ncum

      ! ****** calcul de la vapeur dans le ddft avant rvap
            
      do il=1,ncum 
       if (i.le.inb(il) .and. lwork(il)) then      
        if (i.lt.INB(il)) then      
         if (Mp(il,i).gt.Mp(il,i+1)) then
          ! cas entrainant
          rat(il)=Mp(il,i+1)/Mp(il,i)
          qp_avantevap(il)=qp(il,i+1)*rat(il)+q(il,i)*(1-rat(il))
          do ixt=1,ntraciso
             xtp_avantevap(ixt,il)=xtp(ixt,il,i+1)*rat(il)
     :           +xt(ixt,il,i)*(1-rat(il))
          enddo
         else !if (Mp(il,i).gt.Mp(il,i+1)) then
           if (Mp(il,i+1).gt.Mpmin) then
              ! cas non entrainant, mais flux existe
              qp_avantevap(il)=qp(il,i+1)
              do ixt=1,ntraciso
                xtp_avantevap(ixt,il)=xtp(ixt,il,i+1)
              enddo
              
           else    !if (Mp(il,i+1).gt.0) then    
              
              ! pas de flux de masse, on ne calcule rien
              ! on garde le qp calcul dans cv3_unsat, original
              ! on suppose que le deltaD dans le ddft est celui de
              ! l'environnement
              qp_avantevap(il)=qp(il,i)
              if (qp(il,i).gt.0) then
                do ixt=1,ntraciso
                 xtp_avantevap(ixt,il)=xt(ixt,il,i)/q(il,i)*qp(il,i)
                enddo
              else !if (qp(il,i).gt.0) then
                  ! si qp est ngatif, on met les isos dedans  0
                write(*,*) 'appel_stewart temporaire 230: qp=',
     :         qp(il,i)
                do ixt=1,ntraciso
                 xtp_avantevap(ixt,il)=0.0
                enddo
              endif !if (qp(il,i).gt.0) then
               
          endif !if (Mp(il,i+1).gt.0) then
          
         endif  !if (Mp(il,i).gt.Mp(il,i+1)) then
      
        else ! if i.lt.INB
          ! cas ou i=inb
          ! on garde le qp calcul dans cv3_unsat, original
          ! on suppose que le deltaD dans le ddft est celui de
          ! l'environnement
          qp_avantevap(il)=qp(il,i)
          if (qp(il,i).gt.0) then
            do ixt=1,ntraciso
             xtp_avantevap(ixt,il)=xt(ixt,il,i)/q(il,i)*qp(il,i)
            enddo
          else !if (qp(il,i).gt.0) then
              ! si qp ngatif, on met les isotopes dedans  0
            do ixt=1,ntraciso
             xtp_avantevap(ixt,il)=0.0
            enddo
          endif !if (qp(il,i).gt.0) then
        endif ! if i.lt.INB(il)
       endif ! (i.le.inb(il) .and. lwork(il)) then
      enddo !do il=1,ncum


           
      ! ********* calculs des flux
      
      do il=1,ncum 
       if (i.le.inb(il) .and. lwork(il)) then
        Pqisup(il)=sigd/g*wt(il,i)*water(il,i+1)+wdtrain(il)/g
        Pqiinf(il)=sigd/g*wt(il,i)*water(il,i) ! ce qu'on aurait dans si ce
       ! ce qu s'vapore en i ne vient que de i, comme dans le schma de
       ! KE original.      
        Eqi_prime(il)=(evap(il,i)+evap(il,i+1))/2
     :            *100.*(PH(il,i)-PH(il,I+1))*SIGD/g
        Eqi(il)=evap(il,i)*100.*(PH(il,i)-PH(il,I+1))*SIGD/g
        Eqi_plus1(il)=evap(il,i+1)*100.*(PH(il,i)-PH(il,I+1))*SIGD/g
        Pqiinf_par(il)=Pqisup(il)-Eqi_prime(il)
        Eqi_par(il)=Pqisup(il)-Pqiinf(il)
        do ixt=1,ntraciso
          Pxtisup(ixt,il)=sigd/g*wt(il,i+1)*xtwater(ixt,il,i+1)
     :            +xtwdtrain(ixt,il)/g
        enddo
       endif !if (i.le.inb(il) .and. lwork(il)) then
      enddo !do il=1,ncum 


      ! petite vrif sur les flux
      do il=1,ncum 
       if (i.le.inb(il) .and. lwork(il)) then
         if ((Eqi_par(il).lt.0.0)
     :           .and.(Pqiinf_par(il).le.0.0)
     :          .and.(water(il,i).gt.ridicule/10.)) then
            ! dans ce cas, on a de l'eau sortant dont il faut dterminer la
            ! composition, mais pourtant le bilan de masse indique qu'il
            ! n'y a pas d'eau sortant. Et si on recalcule l'vap pour avoir de 
            ! l'eau sortant, Eqi_par<0 -> condensation! On est donc trs
            ! embtt car Eqi_prime indique qu'il y a vaporation...   
!            write(*,*) 'appel_stewart 239: cas gnant'  

            if (Eqi_prime(il)*fac_ftmr(il).lt.
     :           qp_avantevap(il)*errmaxrel*10) then
                ! ouf: Eqi_prime a peut d'effet sur la vapeur du ddft.
                ! on peut donc condenser tranquillement pour obtenir de
                ! l'eau en sortie, a ne changera pas grand chose sur la
                ! vapeur.
                Eqi_prime(il)=Eqi_par(il)
            else
             write(*,*) 'appel_stewart 222: ce cas est trs gnant'
             stop
            endif
          endif
        endif !if (i.le.inb(il) .and. lwork(il)) then
      enddo !do il=1,ncum

      if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
          do il=1,ncum
            xtp_avantevap(iso_eau,il)=qp_avantevap(il)
            Pxtisup(iso_eau,il)=Pqisup(il)
          enddo
      endif


      ! ******** parsage des diffrents cas + quelques vrifs
      icas_condensation_facftmr=0
      icas_condensation_nofacftmr=0
      icas_noevap=0
      icas_evap_glace=0
      icas_evap_liq=0
      do il=1,ncum 
       if (i.le.inb(il) .and. lwork(il)) then 
!        write(*,*) 'tmp 417: il,Eqi_prime=',il,Eqi_prime(il)   
        if ((Eqi_prime(il).lt.-ridicule*1e-3).or.
     :         (Eqi_prime(il)*fac_ftmr(il).lt.-ridicule*10)) then
            ! modif le 10 mai 2009: si Eqi_prime trs petit, on le
            ! traite comme du 0
            ! modif 15 mai 2009: on rajoute condition sur Eqi*fac_ftmr
            ! modif le 5 dec 2012: on change les seuils pour homo avec
            ! noevap
          ! 1: Eqi_prime<0: condensation
!          write(*,*) 'tmp 426: condensation'
          if (fac_ftmr(il).gt.ridicule/100.) then
            ! si fac_ftmr trs petit, on le traite comme du 0
            ! 1.1: si Mpi>0
            icas_condensation_facftmr=icas_condensation_facftmr+1    
            cas_condensation_facftmr(icas_condensation_facftmr)=il
          else !if (fac_ftmr.gt.0.0) then
            ! 1.2: si Mpi=0
            icas_condensation_nofacftmr=icas_condensation_nofacftmr+1  
            cas_condensation_nofacftmr(icas_condensation_nofacftmr)=il
          endif !if (fac_ftmr.gt.0.0) then
!        else if ((abs(Eqi_prime(il)).lt.ridicule*1e-3).and.
!     :      (abs(Eqi_prime(il)*fac_ftmr(il)).lt.ridicule*10)) then 
        else if ((Eqi_prime(il).lt.ridicule*1e-3).and.
     :      (Eqi_prime(il)*fac_ftmr(il).lt.ridicule*10)) then 
            ! 2: Eqi_prime est compris entre 1e-14 et -1e-14: rien 
!            ! 27 mai 2009: on remplace le seuil pour Eqi_prime(il)*fac_ftmr(il)
!            ! de errmax/10 par ridicule*10  
            ! 18 sept 2009: on remplace  ridicule*1e-2 par ridicule*1e-3 
            !pour viter Eqi_prime=-1.87e-15, Pqisup=0 et water=1.44e-12
            ! correction le 5 dcembre 2012: il y a incohrence entre
            ! conditions condensation et noevap: ex de cas patho:
            ! Eqi'=-5e-15 et Eqi'*facftmr=-4e-10. Dans ce cas, tombe
            ! dans le trou entre condensation et noevap, et a part dans
            ! l'vap positive! -> on enlve la valeur absolue.
!            write(*,*) 'tmp 457: noevap'
            icas_noevap=icas_noevap+1  
            cas_noevap(icas_noevap)=il
        else    !if (Eqi_prime.lt.0.0) then
        ! 3: Eqi_prime>0 
              if (T(il,i).ge.ztglace_kelvin) then
                ! 3.1: evap des gouttes
                icas_evap_liq=icas_evap_liq+1  
                cas_evap_liq(icas_evap_liq)=il
              else !if (T(il,i).ge.ztglace_kelvin) then
                ! 3.2: evap de la glace
                icas_evap_glace=icas_evap_glace+1  
                cas_evap_glace(icas_evap_glace)=il
              endif !if (T(il,i).ge.ztglace_kelvin) then
          endif ! !if (Eqi_prime.lt.0.0) then
       endif !if (i.le.inb(il) .and. lwork(il)) then 
      enddo  !do il=1,ncum 

      ncas_condensation_facftmr=icas_condensation_facftmr
      ncas_condensation_nofacftmr=icas_condensation_nofacftmr  
      ncas_noevap=icas_noevap
      ncas_evap_liq=icas_evap_liq
      ncas_evap_glace=icas_evap_glace



      ! ****** traitement vectoriel du cas 1.1

      if (ncas_condensation_facftmr.gt.0) then

      call compress_cond_facftmr(ncas_condensation_facftmr,  
     :    cas_condensation_facftmr,
     :    Eqi_prime_cas,Eqi_prime,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,  
     :    T_cas,T(1,i), 
     :    fac_ftmr_cas,fac_ftmr, 
     :    qp_avantevap_cas,qp_avantevap,
     :    xtp_avantevap_cas,xtp_avantevap, 
     :    xtevapsup_cas,xtevap(1,1,i+1),
     :    water_cas,water(1,i),
     :    delP_cas,Ph, 
     :    nloc,ncum,nd,i)

        call make_condensation_facftmr(ncas_condensation_facftmr,
     :         Eqi_prime_cas(1),Pqisup_cas(1),Pxtisup_cas(1,1),
     :         fac_ftmr_cas(1),T_cas(1),
     :         qp_avantevap_cas(1),xtp_avantevap_cas(1,1),water_cas(1),
     :         delP_cas(1),xtevapsup_cas(1,1),ztglace_kelvin,
     :         xtp_cas(1,1),xtwater_cas(1,1),xtevap_cas(1,1),g,SIGD
     :           )  


       call uncompress_commun(ncas_condensation_facftmr,
     :     cas_condensation_facftmr,
     :   xtp_cas,xtp(1,1,i),xtwater_cas,xtwater(1,1,i),
     :           xtevap_cas,xtevap(1,1,i),
     :           ncum)


        !#ifdef ISOTRAC    

           endif !if (ncas_condensation_facftmr.gt.0) then


        ! ****** traitement vectoriel du cas 1.2

      if (ncas_condensation_nofacftmr.gt.0) then

      call compress_cond_nofftmr(ncas_condensation_nofacftmr,
     :    cas_condensation_nofacftmr,
     :    Eqi_prime_cas,Eqi_prime(1),
     :    Pqisup_cas,Pqisup(1), 
     :    Pxtisup_cas,Pxtisup(1,1),
     :    water_cas,water(1,i), 
     :    T_cas,T(1,i), 
     :    qp_avantevap_cas,qp_avantevap(1),
     :    xtp_avantevap_cas,xtp_avantevap(1,1),
     :    xt_cas,xt(1,1,i),q_cas,q(1,i), 
     :    xtevapsup_cas,xtevap(1,1,i+1),
     :    delP_cas,Ph, 
     :    nloc,ncum,nd,i)


      call make_condensation_nofacftmr(ncas_condensation_nofacftmr,
     :     Eqi_prime_cas(1),Pqisup_cas(1),
     :     Pxtisup_cas(1,1),water_cas(1),T_cas(1),
     :     qp_avantevap_cas(1), xtp_avantevap_cas(1,1),
     :     q_cas(1),xt_cas(1,1), 
     :     xtevapsup_cas(1,1) ,delP_cas(1),   
     :     ztglace_Kelvin, g,SIGD,
     :     xtevap_cas(1,1),xtp_cas(1,1),xtwater_cas(1,1)
     :   )     

      call uncompress_commun(ncas_condensation_nofacftmr,
     :     cas_condensation_nofacftmr,
     :   xtp_cas,xtp(1,1,i),xtwater_cas,xtwater(1,1,i),
     :           xtevap_cas,xtevap(1,1,i),
     :           ncum)
                
       
        endif !if (ncas_condensation_nofacftmr.gt.0) then

        
        ! ****** traitement vectoriel du cas 2

      if (ncas_noevap.gt.0) then
      call compress_noevap(ncas_noevap,
     :    cas_noevap,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,  
     :    xtp_avantevap_cas,xtp_avantevap, 
     :    xtevapsup_cas,xtevap(1,1,i+1),
     :    water_cas,water(1,i),
     :    delP_cas,Ph, 
     :    nloc,ncum,nd,i) 


      call make_cas_noevap(ncas_noevap,
     :          xtp_avantevap_cas(1,1),xtevapsup_cas(1,1),
     :          Pxtisup_cas(1,1),Pqisup_cas(1),water_cas(1),
     :          xtevap_cas(1,1),xtp_cas(1,1),xtwater_cas(1,1)
     :          )      

       call uncompress_commun(ncas_noevap,cas_noevap,
     :   xtp_cas,xtp(1,1,i),xtwater_cas,xtwater(1,1,i),
     :           xtevap_cas,xtevap(1,1,i),
     :           ncum)


        endif !if (ncas_noevap.gt.0) then


        ! ****** traitement vectoriel du cas 3.1

      if (ncas_evap_liq.gt.0) then
          

      call compress_evap_liq(30,ncas_evap_liq,
     :    cas_evap_liq,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,  
     :    qp_avantevap_cas,qp_avantevap,
     :    xtp_avantevap_cas,xtp_avantevap, 
     :    xtevapsup_cas,xtevap(1,1,i+1),
     :    water_cas,water(1,i), 
     :    qs_cas,qs(1,i),
     :    Eqi_stewart,Pqiinf_stewart,Eqi_prime_cas,
     :    Pqiinf,Eqi_par,Pqiinf_par,Eqi_prime,  
     :    Eqi,Eqi_cas, 
     :    fac_ftmr_cas,fac_ftmr, 
     :    T_cas,T(1,i),
     :    wt_cas,wt(1,i),
     :    INB_cas,INB(1),
     :    delP_cas,Ph,
     :    qp_cas,qp(1,i),
     :    nloc,ncum,nd,i)

      do il=1,ncas_evap_liq     
        qeff(il)=thumxt1*Qs_cas(il)
     :     +(1.0-thumxt1)*qp_avantevap_cas(il)
      enddo   !do il=1,ncas_evap_liq

!      write(*,*) 'appel tmp 802: xtp_avantevap_cas(iso_eau,2)=',
!     :           xtp_avantevap_cas(iso_eau,2)
!      write(*,*) 'appel tmp 1490: qp_avantevap_cas(2)=',
!     :           qp_avantevap_cas(2)
!       write(*,*) 'appel_stewart 933: make_cas_evap_liq pr eau normale'

       ! ici, ptrac ne sera pas utilis
       call make_cas_evap_liq(ncas_evap_liq,
     :           water_cas(1),
     :           xtp_avantevap_cas(1,1),qp_avantevap_cas(1),
     :           xtp_avantevap_cas(1,1),qp_avantevap_cas(1),
     :           Pxtisup_cas(1,1),Pqisup_cas(1),
     :           Eqi_stewart(1),Pqiinf_stewart(1),fac_ftmr_cas(1),
     :           qs_cas(1), T_cas(1),wt_cas(1),  delP_cas(1),
     :           xtevapsup_cas(1,1),qeff(1),g,sigd, Eqi_prime_cas(1),
     :           qp_cas(1), INB_cas(1),i,0,
     :           xtp_cas(1,1),xtwater_cas(1,1),xtevap_cas(1,1))

       call uncompress_commun(ncas_evap_liq,cas_evap_liq,
     :   xtp_cas,xtp(1,1,i),xtwater_cas,xtwater(1,1,i),
     :           xtevap_cas,xtevap(1,1,i),
     :           ncum)


        endif !if (ncas_evap_liq.gt.0) then

       
        

                ! ****** traitement vectoriel du cas 3.2

      if (ncas_evap_glace.gt.0) then


      call compress_evap_glace(30,
     :    ncas_evap_glace,cas_evap_glace,
     :    water_cas,water(1,i), 
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup, 
     :    T_cas,T(1,i),  
     :    fac_ftmr_cas,fac_ftmr, 
     :    qp_avantevap_cas,qp_avantevap,
     :    xtp_avantevap_cas,xtp_avantevap, 
     :    xtevapsup_cas,xtevap(1,1,i+1),
     :    Eqi_stewart,Pqiinf_stewart,Eqi_prime_cas,Eqi_cas,
     :    Pqiinf,Eqi_par,Pqiinf_par,Eqi_prime,Eqi,
     :    INB_cas,INB(1), 
     :    delP_cas,Ph, 
     :    qp_cas,qp(1,i),
     :    nloc,ncum,nd,i,frac_sublim)

      
        call make_cas_evap_glace(ncas_evap_glace,
     :           water_cas(1),
     :           xtp_avantevap_cas(1,1),qp_avantevap_cas(1),
     :           xtp_avantevap_cas(1,1),qp_avantevap_cas(1),
     :           Pxtisup_cas(1,1),Pqisup_cas(1),
     :           Eqi_stewart(1),Eqi_prime_cas(1),
     :           Pqiinf_stewart(1),fac_ftmr_cas(1),
     :           qs_cas(1), T_cas(1),wt_cas(1),  delP_cas(1),
     :           xtevapsup_cas(1,1),g,sigd,INB_cas(1),i,
     :           frac_sublim,qp_cas(1),
     :           xtp_cas(1,1),xtwater_cas(1,1),xtevap_cas(1,1))

!#ifdef ISOVERIF    
!        write(*,*) 'appel_stewart tmp 1073 aprs make_cas_evap_glace'
!#endif

       call uncompress_commun(ncas_evap_glace,cas_evap_glace,
     :   xtp_cas,xtp(1,1,i),xtwater_cas,xtwater(1,1,i),
     :           xtevap_cas,xtevap(1,1,i),
     :           ncum)


        endif !if (ncas_evap_glace.gt.0) then


       ! ****** dernires vrifs et bidouilles



       if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then 
         do il=1,ncum 
           if (i.le.inb(il) .and. lwork(il)) then 
             xtwater(iso_eau,il,i)= water(il,i)
             xtp(iso_eau,il,i)=qp(il,i) 
             xtevap(iso_eau,il,i)= evap(il,i) 
           endif !if (i.le.inb(il) .and. lwork(il)) then     
          enddo !do il=1,ncum  
        endif !if (bidouille_anti_divergence) then

!#ifdef ISOVERIF
!        write(*,*) 'appel_stewart tmp 1197: sortie'
!#endif

        return
        end


        subroutine make_condensation_facftmr(ncas,
     :            Eqi_prime_cas,Pqisup_cas,Pxtisup_cas,
     :            fac_ftmr_cas,T_cas,
     :            qp_avantevap_cas,xtp_avantevap_cas,water_cas,
     :            delP_cas,xtevapsup_cas,ztglace_kelvin,
     :            xtp_cas,xtwater_cas,xtevap_cas,g,SIGD
     :           )   
        implicit none

!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      
        ! inputs
        integer ncas
        real ztglace_kelvin
        real T_cas(ncas),delP_cas(ncas),
     :           xtevapsup_cas(niso,ncas),water_cas(ncas)
        double precision  qp_avantevap_cas(ncas),
     :   xtp_avantevap_cas(niso,ncas),
     :   Pqisup_cas(ncas), Pxtisup_cas(niso,ncas), 
     :   Eqi_prime_cas(ncas),fac_ftmr_cas(ncas)
         real g,SIGD                  

        ! outputs
        real xtevap_cas(niso,ncas),xtp_cas(niso,ncas),
     :            xtwater_cas(niso,ncas)

        ! locals
        double precision Risup(niso,ncas), Rcond(niso,ncas)
        real xtice(ntraciso,ncas), xtliq(ntraciso,ncas)
        real xtp0(ntraciso,ncas), qp0(ncas)
        ! rq: xtice,xtliq,xtp0 sont de dimension ntraciso car condiso_liq_ice_vectall prend des choses de dimension ntraciso. Mais c'est une perte de mmoire. Seuls les premiers niso sont utiliss
        real fcond(ncas), fice(ncas), cond(ncas)
        double precision Exi_prime(niso,ncas)
        integer il,ixt
        real zxtalphal,zxtalphai

!        write(*,*) 'ncas=',ncas
       do il=1,ncas
        
        if ((Eqi_prime_cas(il).gt.-ridicule*1e-2).and.    
     :      (Eqi_prime_cas(il)*fac_ftmr_cas(il).gt.-ridicule*10).and.
     :      (Pqisup_cas(il).le.0.0)) then
          fcond(il)=1.0
          cond(il)=0.0
        else !if ((Eqi_prime_cas(il).gt.-ridicule*1e-2).and.    
         fcond(il)=-Eqi_prime_cas(il)/(Pqisup_cas(il)-Eqi_prime_cas(il))
         cond(il)=-Eqi_prime_cas(il)*fac_ftmr_cas(il)
        endif

         if (T_cas(il).ge.ztglace_kelvin) then
               fice(il)=0.0
         else
               fice(il)=1.0
         endif 

         if (cond(il).gt.qp_avantevap_cas(il)) then
             ! dans ce cas, qp doit tre nul. on vrifie et si oui, on
             ! met cond=qp_avantevap_cas
             ! cas ajout le 11 dec 2011
             cond(il)=qp_avantevap_cas(il)
             ! ajout le 10 juin 2012:
             qp0(il)=qp_avantevap_cas(il)
              do ixt=1,niso
                 xtp0(ixt,il)=xtp_avantevap_cas(ixt,il)
              enddo !do ixt=1,niso  
         else ! if (cond(il).gt.qp_avantevap_cas(il)) then    
           if (cond(il).lt.1e-11) then
              ! pour des raisons numriques, a ne marchera pas
              cond(il)=cond(il)*1e4
              qp0(il)=qp_avantevap_cas(il)*1e4
              do ixt=1,niso
                 xtp0(ixt,il)=xtp_avantevap_cas(ixt,il)*1e4
              enddo !do ixt=1,niso  
           else !if (cond(il).lt.1e-11) then
              qp0(il)=qp_avantevap_cas(il)  
              do ixt=1,niso
               xtp0(ixt,il)=xtp_avantevap_cas(ixt,il)
              enddo                             
           endif !if (cond(il).lt.1e-11) then
         endif ! if (cond(il).gt.qp0(il)) then
        enddo !do il=1,ncas_condensation_facftmr
        
        call condiso_liq_ice_vectall(xtp0(1,1), qp0(1),
     :         cond(1),T_cas(1),fice(1),xtice(1,1),xtliq(1,1),
     :           ncas)

        do il=1,ncas
          if (cond(il).gt.ridicule*1e-2) then              
            do ixt=1,niso
              Rcond(ixt,il)=(xtice(ixt,il)+xtliq(ixt,il))/cond(il)
            enddo !do ixt=1,niso
          else if ((cond(il).gt.0.0).and.(qp0(il).gt.ridicule)) then  
            do ixt=1,niso
              call fractcalk_vectall(ixt,T_cas(il),zxtalphal,zxtalphai) 
              Rcond(ixt,il)=xtp0(ixt,il)/qp0(il)*
     *             (fice(il)*zxtalphai+(1.0-fice(il))*zxtalphal)
            enddo !do ixt=1,niso   
          else !if (cond(il).gt.ridicule*1e-2) then   
            do ixt=1,niso
              Rcond(ixt,il)=Rdefault(ixt)
            enddo !do ixt=1,niso
          endif !Eqi_prime_cas(il)          
        enddo !do il=1,ncas_condensation_facftmr


        do il=1,ncas
          ! le 30 avril 2012: on remplace 0 par ridicule*1e-2
          ! le 2 juillet 2012: on remplace ridicule*1e-2 par ridicule*1e-4
          if (Pqisup_cas(il).gt.ridicule*1e-4) then
             do ixt=1,niso
               Risup(ixt,il)=Pxtisup_cas(ixt,il)/Pqisup_cas(il)
             enddo !do ixt=1,niso
          else !if (Pqisup.gt.0.0) then
              ! il n'y avait pas d'eau au dessus
              ! on vrifie que toute l'eau en i provient de la rose: on
              ! vrifie que fcond=1.0
!#ifdef ISOVERIF
!              call iso_verif_egalite_choix(fcond(il),1.0,
!     :            'appel_stewart 548',errmax,errmaxrel)
              ! il y a des cas pathos: ex: facftmr=8e7
              ! Eqi_prime=-3e-15 -> qp varie de 2e-7 -> pas ngligeable
              ! Pqisup=1e-15 -> fcond=70% 
!#endif
              ! c'est bon, Risup n'a pas d'importance
              ! ou alors, le flux Pqiinf n'a pas d'importance
             do ixt=1,niso
               Risup(ixt,il)=Rdefault(ixt)
             enddo !do ixt=1,niso
          endif  !if (Pqisup.gt.0.0) then 
         enddo  !do il=1,ncas_condensation_facftmr
         do il=1,ncas
!#ifdef ISOVERIF   
!          if (use_iso_eau.eq.1) then      
!             write(*,*) 'appel_stewart 1489: il,fac_ftmr_cas(il)=',
!     :           il,fac_ftmr_cas(il)
!             write(*,*) 'xtp_avantevap_cas(iso_eau,il)=',
!     :           xtp_avantevap_cas(iso_eau,il)
!             write(*,*) 'Eqi_prime_cas(il),Rcond(iso_eau,il)=',
!     :           Eqi_prime_cas(il),Rcond(iso_eau,il)
!          endif
!#endif          
          do ixt=1,niso             
                 Exi_prime(ixt,il)=Rcond(ixt,il)*Eqi_prime_cas(il)
                 xtevap_cas(ixt,il)=2*Exi_prime(ixt,il)
     :                   /100.0/delP_cas(il)/SIGD*g
     :                   -xtevapsup_cas(ixt,il)
                 xtwater_cas(ixt,il)=water_cas(il)
     :                  *(Rcond(ixt,il)*fcond(il)
     :                  +Risup(ixt,il)*(1.0-fcond(il)))
                 xtp_cas(ixt,il)=xtp_avantevap_cas(ixt,il)+
     :                   fac_ftmr_cas(il)*Exi_prime(ixt,il)
                 xtp_cas(ixt,il)=max(0.0,xtp_cas(ixt,il))
           enddo !do ixt=1,niso
          enddo !do il=1,ncas_condensation_facftmr
!          il=1
!          write(*,*) 'appel_stewart 1745: il=',il 
!          write(*,*) 'xtp_cas(iso_eau,il)=',xtp_cas(iso_eau,il)
!          write(*,*) 'xtp_avantevap_cas(iso_eau,il)=',
!     :        xtp_avantevap_cas(iso_eau,il)
!          write(*,*) 'qp_cas(il)=',qp_cas(il)
!          write(*,*) 'fac_ftmr_cas(il)=',fac_ftmr_cas(il)
!          write(*,*) 'Exi_prime(iso_eau,il)=',Exi_prime(iso_eau,il)
!          write(*,*) 'oktrac=',oktrac


        return
        end

        subroutine make_condensation_nofacftmr(ncas,
     :     Eqi_prime_cas,Pqisup_cas,Pxtisup_cas,water_cas,T_cas,
     :     qp_avantevap_cas, xtp_avantevap_cas,q_cas,xt_cas, 
     :     xtevapsup_cas ,delP_cas,   
     :     ztglace_Kelvin, g,SIGD,xtevap_cas,xtp_cas,xtwater_cas
     :   )
        implicit none

!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      
        ! inputs
        integer ncas
        real ztglace_kelvin
        real T_cas(ncas),delP_cas(ncas),
     :           xtevapsup_cas(niso,ncas),water_cas(ncas),
     :           q_cas(ncas),xt_cas(niso,ncas)
        double precision  qp_avantevap_cas(ncas),
     :   xtp_avantevap_cas(niso,ncas),
     :   Pqisup_cas(ncas), Pxtisup_cas(niso,ncas), 
     :   Eqi_prime_cas(ncas)
         real g,SIGD
         
        ! outputs
        real xtevap_cas(niso,ncas),xtp_cas(niso,ncas),
     :            xtwater_cas(niso,ncas)

        ! locals
        double precision Risup(niso,ncas), Rcond(niso,ncas),
     :           Renv(niso,ncas)
        real zxtalphal(niso,ncas), zxtalphai(niso,ncas)
        real fcond(ncas)
        double precision Exi_prime(niso,ncas)
        integer il,ixt
        real double_to_real

        call fractcalk_vectall(T_cas,zxtalphal,zxtalphai,ncas)
        do il=1,ncas
          if (Pqisup_cas(il)-Eqi_prime_cas(il).gt.0.0) then
            fcond(il)=-Eqi_prime_cas(il)
     :           /(Pqisup_cas(il)-Eqi_prime_cas(il))
          else
              fcond(il)=1.0
          endif
          if (qp_avantevap_cas(il).gt.0) then
             do ixt=1,niso  
               Renv(ixt,il)=xtp_avantevap_cas(ixt,il)
     :           /qp_avantevap_cas(il)
             enddo !do ixt=1,niso  
          else if (q_cas(il).gt.0.0) then !if (qp_avantevap_cas(il).gt.0) then
             do ixt=1,niso  
               Renv(ixt,il)=xt_cas(ixt,il)/q_cas(il)
             enddo !do ixt=1,niso
          else
              ! aucune vapeur dispo pour condenser ensuite. On vrifie
              ! que la condensation est nulle
              do ixt=1,niso  
               Renv(ixt,il)=Rdefault(ixt)
             enddo !do ixt=1,niso 
           endif !if (qp_avantevap_cas(il).gt.0) then
         enddo !do il=1,ncas
         do il=1,ncas
           if (T_cas(il).ge.ztglace_Kelvin) then
             do ixt=1,niso
              Rcond(ixt,il)=zxtalphal(ixt,il)*Renv(ixt,il)
             enddo ! do ixt=1,niso
           else !if (T(il).ge.ztglace_Kelvin) then
               do ixt=1,niso
                Rcond(ixt,il)=zxtalphai(ixt,il)*Renv(ixt,il)
               enddo ! do ixt=1,niso               
           endif !if (T(il).ge.ztglace_Kelvin) then 
         enddo !do il=1,ncas
        do il=1,ncas
          if (Pqisup_cas(il).gt.0.0) then
             do ixt=1,niso
               Risup(ixt,il)=Pxtisup_cas(ixt,il)/Pqisup_cas(il)
             enddo !do ixt=1,niso
          else !if (Pqisup.gt.0.0) then
             do ixt=1,niso
               Risup(ixt,il)=Rdefault(ixt)
             enddo !do ixt=1,niso
          endif  !if (Pqisup.gt.0.0) then 
         enddo !do il=1,ncas
         do il=1,ncas
          do ixt=1,niso             
                 Exi_prime(ixt,il)=Rcond(ixt,il)*Eqi_prime_cas(il)   
                 xtevap_cas(ixt,il)=2.0*Exi_prime(ixt,il)
     :                   /100.0/delP_cas(il)/SIGD*g
     :                   -xtevapsup_cas(ixt,il)    
                 xtwater_cas(ixt,il)=water_cas(il)
     :                  *(Rcond(ixt,il)*fcond(il)
     :                  +Risup(ixt,il)*(1.0-fcond(il)))
                 xtp_cas(ixt,il)=xtp_avantevap_cas(ixt,il)
           enddo !do ixt=1,niso
          enddo !do il=1,ncas


        return
        end

        subroutine make_cas_noevap(ncas,
     :          xtp_avantevap_cas,xtevapsup_cas,
     :          Pxtisup_cas,Pqisup_cas,water_cas,
     :          xtevap_cas,xtp_cas,xtwater_cas
     :           )
        implicit none

!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      
        ! inputs
        integer ncas
        real xtevapsup_cas(niso,ncas),water_cas(ncas)
        double precision  xtp_avantevap_cas(niso,ncas),
     :   Pqisup_cas(ncas), Pxtisup_cas(niso,ncas)
        ! outputs
        real xtevap_cas(niso,ncas),xtp_cas(niso,ncas),
     :            xtwater_cas(niso,ncas)

        ! locals
        double precision Risup(niso,ncas)
        integer il,ixt
        real double_to_real

!        write(*,*) 'appel_stewart tmp 1530: Pxtisup_cas(iso_eau,2)=',
!     :           Pxtisup_cas(iso_eau,2)
!        write(*,*) 'Pqisup_cas(2)=',Pqisup_cas(2)
        do il=1,ncas
         do ixt=1,niso
             xtp_cas(ixt,il)=xtp_avantevap_cas(ixt,il)
             xtevap_cas(ixt,il)=-xtevapsup_cas(ixt,il)
         enddo  !do ixt=1,niso 
       enddo !do il=1,ncas_noevap
        do il=1,ncas
         if (Pqisup_cas(il).gt.0.0) then
            do ixt=1,niso  
              Risup(ixt,il)=Pxtisup_cas(ixt,il)/Pqisup_cas(il)
              xtwater_cas(ixt,il)=water_cas(il)*Risup(ixt,il)
            enddo !do ixt=1,niso
         else !if (Pqisup.gt.0.0) then
           do ixt=1,niso
            xtwater_cas(ixt,il)=water_cas(il)*Rdefault(ixt)
           enddo !do ixt=1,niso  
         endif  !if (Pqisup.gt.0.0) then  
        enddo !do il=1,ncas_noevap 


        return
        end

        subroutine make_cas_evap_liq(ncas,
     :           water_cas,
     :           xtp_avantevap_cas,qp_avantevap_cas,
     :           xtp_avantevaptrac_cas,qp_avantevaptrac_cas,
     :           Pxtisup_cas,Pqisup_cas,
     :           Eqi_stewart,Pqiinf_stewart,fac_ftmr_cas,
     :           qs_cas, T_cas,wt_cas,  delP_cas,
     :           xtevapsup_cas,qeff, g,sigd,Eqi_prime_cas,
     :           qp_cas,INB_cas,i,oktrac
     :           ,xtp_cas,xtwater_cas,xtevap_cas)
        implicit none

!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      
        ! inputs
        integer ncas
        double precision xtp_avantevap_cas(niso,ncas),
     :           qp_avantevap_cas(ncas)
        double precision xtp_avantevaptrac_cas(niso,ncas),
     :           qp_avantevaptrac_cas(ncas)
        ! dans le cas des traceurs: xtp_avantevaptrac_cas est la
        ! quantit de traceur izone dans la vapeur
        ! alors que xtp_avantevap_cas est le total de toutes les zone
        ! on rquilibre la goutte avec le total de toutes les zones,
        ! mais c'est xtp_avantevaptrac_cas qui recoit l'vap
        double precision Pqisup_cas(ncas), Pxtisup_cas(niso,ncas)
        double precision Pqiinf_stewart(ncas), Eqi_stewart(ncas)
        double precision fac_ftmr_cas(ncas),Eqi_prime_cas(ncas)
        real T_cas(ncas),delP_cas(ncas),
     :           xtevapsup_cas(niso,ncas),
     :           wt_cas(ncas),qeff(ncas),
     :           qs_cas(ncas),water_cas(ncas),
     :           qp_cas(ncas)  
        integer oktrac      






        integer INB_cas(ncas),i
        real g,sigd
        ! outputs
        real  xtp_cas(niso,ncas),xtwater_cas(niso,ncas),
     :           xtevap_cas(niso,ncas)        

        ! locals        
        integer il,ixt        
        double precision Pxtiinf_stewart(niso,ncas), 
     :           Exi_stewart(niso,ncas) 
        double precision xtnew(niso,ncas)









        

        if (no_pce.eq.1) then
            call stewart_sublim_nofrac_vectall(
     :        ncas,qp_avantevap_cas(1),
     :        xtp_avantevap_cas(1,1),Pqisup_cas(1),
     :        Pxtisup_cas(1,1),Eqi_stewart(1),Pqiinf_stewart(1),
     :        Pxtiinf_stewart(1,1),xtnew(1,1),Exi_stewart(1,1),
     :        fac_ftmr_cas(1))
        else !if (no_pce.eq.1) then
      call stewart_explicite_vectall(ncas,
     :        qp_avantevap_cas(1),xtp_avantevap_cas(1,1),
     :        Pqisup_cas,Pxtisup_cas(1,1),Eqi_stewart(1),
     :           Pqiinf_stewart(1),qeff(1),
     :        Pxtiinf_stewart(1,1),xtnew(1,1),Exi_stewart(1,1),
     :           fac_ftmr_cas(1),
     :        qs_cas(1),T_cas(1),wt_cas(1),delP_cas(1)
     :   )
         endif !if (no_pce.eq.1) then


           
        ! deduction de XTWATER  partir de Pxtiinf:
! hypothse: l'eau en i a la mme composition que le flux d'eau
        ! qui sort de la boite i (Pqiinf_par)
        do il=1,ncas
          if (abs(water_cas(il)).lt.ridicule/10.) then
            do ixt=1,niso
               xtwater_cas(ixt,il)=0.0
            enddo !do ixt=1,niso
          else !if (water(il,i).eq.0.0) then
             if (Pqiinf_stewart(il).gt.0.0) then  !if (Pxtiinf_par(iso_eau).gt.0.0) then 
               do ixt=1,niso 
                 xtwater_cas(ixt,il)=water_cas(il)
     :              *Pxtiinf_stewart(ixt,il)/Pqiinf_stewart(il)
               enddo
             else !if (Pxtiinf_stewart(iso_eau).gt.0.0) then
                 ! normalement, ce cas a dj t interdit dans
                 ! compress_evp_glace
                do ixt=1,niso
                  xtwater_cas(ixt,il)=water_cas(il)*Rdefault(ixt)
                enddo !do ixt=1,niso
             endif
           endif !if (water(il,i).eq.0.0) then
         enddo !do il=1,ncas
        

      
        ! rappel, le Eqi_prime qu'on a mis en argument dans stewart est en
        ! fait gal  0.5*(Eqi+Eqi+1) -> en tenir compte quand on
        ! calcule xtevapi.    
       do il=1,ncas
        if (Eqi_stewart(il).gt.0.0) then
         do ixt=1,niso          
          xtevap_cas(ixt,il)=Eqi_prime_cas(il)
     :           *Exi_stewart(ixt,il)/Eqi_stewart(il)
     :           /100/delP_cas(il)/SIGD*g*2
     :            -xtevapsup_cas(ixt,il)        
         enddo ! do ixt=1,niso
        else !if (Eqi_stewart.gt.0.0) then
            ! il peut quand mme y a voir de la diffusion
            do ixt=1,niso
            xtevap_cas(ixt,il)=Exi_stewart(ixt,il)
     :           /100.0/delP_cas(il)/SIGD*g*2.0
     :            -xtevapsup_cas(ixt,il)
            enddo !do ixt=1,niso    
        endif !if (Eqi_stewart.gt.0.0) then
       enddo !do il=1,ncas
      

      ! deduction de XTP partir de Exi
      
      do il=1,ncas
       if (i.lt.INB_cas(il)) then
          if (fac_ftmr_cas(il).gt.0.0) then
             if (Eqi_stewart(il)*fac_ftmr_cas(il).gt.ridicule) then 
               do ixt=1,niso               
               !   xtp(ixt,il,i)=xtnew(ixt)*qp(il,i)/xtnew(4)
                  xtp_cas(ixt,il)=max(xtp_avantevaptrac_cas(ixt,il) 
     :                +fac_ftmr_cas(il)*Eqi_prime_cas(il)
     :           *Exi_stewart(ixt,il)/Eqi_stewart(il),0.0)
               enddo !do ixt=1,niso
             else ! if (Eqi_stewart.gt.ridicule) then
                if (qp_cas(il).gt.0.0) then 

                    if (Eqi_prime_cas(il)*fac_ftmr_cas(il).gt.ridicule)
     :                    then 
                        ! il va manquer quelque chose: il faut augmenter
                        ! xtp en lui ajoutant l'vap du niveau d'eau
                        ! dessus
                        ! pour l'instant, on bidouille:
                        write(*,*) 'appel_stewart 2487: il=',il
                        do ixt=1,niso               
                        xtnew(ixt,il)=xtnew(ixt,il)
     :                    *(qp_avantevap_cas(il)
     :                    +Eqi_prime_cas(il)*fac_ftmr_cas(il))
     :                    /(qp_avantevap_cas(il)
     :                    +Eqi_stewart(il)*fac_ftmr_cas(il))
                        enddo
                    endif !if (Eqi_prime_cas(il)*fac_ftmr_cas(il).gt.ridicule)

                    do ixt=1,niso               
!                      xtp_cas(ixt,il)=xtnew(ixt,il)
                      xtp_cas(ixt,il)=(xtp_avantevaptrac_cas(ixt,il)
     :                           +(xtnew(ixt,il)
     :                           -xtp_avantevap_cas(ixt,il)))
                      ! modif 1 mai 2009, pour le cas des traceurs
                    enddo !do ixt=1,niso
!                    write(*,*) 'appel_stewart 1963 tmp: ',
!     :                  'xtp_cas(iso_eau,il)=',xtp_cas(iso_eau,il)
                else !if (qp(il,i).gt.0.0) then 
                  do ixt=1,niso               
                    xtp_cas(ixt,il)=0.0
                  enddo !do ixt=1,niso
                endif  !if (qp(il,i).gt.0.0) then 
            endif !if (Eqi_stewart.gt.ridicule) then 


          else !if (fac_ftmr.gt.0.0) then
              ! ca veut dire que Mp=0, xtp pas dfinit
             do ixt=1,niso
               xtp_cas(ixt,il)=xtp_avantevaptrac_cas(ixt,il)
             enddo !do ixt=1,niso
         endif !if (fac_ftmr.gt.0.0) then
      else !if (i.lt.INB) then
          ! si i=inb, on ne change rien au calcul original, et on
          ! suppose que la composition du ddft est gale  celle de
          ! l'env. Ceci a dj t calcul plus haut
                  do ixt=1,niso
                    xtp_cas(ixt,il)=xtp_avantevaptrac_cas(ixt,il)
                    !xtp_avantevap(ixt) a dj t dfinit proprement
                    !dans ce cas l
                  enddo
      endif !if (i.lt.INB) then
      enddo !do il=1,ncas

      ! verif

      return
      end

      subroutine make_cas_evap_glace(ncas,
     :           water_cas,
     :           xtp_avantevap_cas,qp_avantevap_cas,
     :           xtp_avantevaptrac_cas,qp_avantevaptrac_cas,
     :           Pxtisup_cas,Pqisup_cas,
     :           Eqi_stewart,Eqi_prime_cas,
     :           Pqiinf_stewart,fac_ftmr_cas,
     :           qs_cas, T_cas,wt_cas,  delP_cas,
     :           xtevapsup_cas,g,sigd,INB_cas,i,
     :           frac_sublim,qp_cas
     :           ,xtp_cas,xtwater_cas,xtevap_cas)
      implicit none

!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      
        ! inputs
        integer ncas
        double precision xtp_avantevap_cas(niso,ncas),
     :           qp_avantevap_cas(ncas)
        double precision xtp_avantevaptrac_cas(niso,ncas),
     :           qp_avantevaptrac_cas(ncas)
        double precision Pqisup_cas(ncas), Pxtisup_cas(niso,ncas)
        double precision Pqiinf_stewart(ncas), Eqi_stewart(ncas)
        double precision fac_ftmr_cas(ncas),Eqi_prime_cas(ncas)
        real T_cas(ncas),delP_cas(ncas),
     :           xtevapsup_cas(niso,ncas),
     :           wt_cas(ncas),qeff(ncas),
     :           qs_cas(ncas),water_cas(ncas)
        real qp_cas(ncas)      
        real g,sigd
        integer frac_sublim
        integer INB_cas(ncas),i
        ! outputs
        real  xtp_cas(niso,ncas),xtwater_cas(niso,ncas),
     :           xtevap_cas(niso,ncas)
        ! locals        
        integer il,ixt
        double precision Pxtiinf_stewart(niso,ncas), 
     :           Exi_stewart(niso,ncas)   
        double precision xtnew(niso,ncas)     

     

      ! calculs des flux de masses  mettre en argument de stewart:
      ! comme l'eau n'est pas bien concerve dans les ddfts, on est
      ! oblig de bidouill.
      ! 1) soit on considre Pqisup, Eqi, et Pqiinf_par=Pqisup-Eqi
      !    et on suppose que dans la ralit les compositions de
      !    Pqiinf sont les mme que Pqiinf_par
      ! 2) soit on considre Pqisup, Eqi_par=Pqisup-Pqiinf, et Pqiinf,
      !    et on suppose que dans la ralit les compositions de
      !    Eqi_prime sont les mme que Eqi_par

      if (frac_sublim.eq.1) then
            call stewart_glace_vectall(ncas,
     :        qp_avantevap_cas(1),xtp_avantevap_cas(1,1),Pqisup_cas(1),
     :        Pxtisup_cas(1,1),Eqi_stewart(1),Pqiinf_stewart(1),
     :        Pxtiinf_stewart(1,1),xtnew(1,1),Exi_stewart(1,1),
     :        fac_ftmr_cas(1),
     :        qs_cas(1),T_cas(1))
      else !if (frac_sublim.eq.1) then
            call stewart_sublim_nofrac_vectall(
     :        ncas,qp_avantevap_cas(1),
     :        xtp_avantevap_cas(1,1),Pqisup_cas(1),
     :        Pxtisup_cas(1,1),Eqi_stewart(1),Pqiinf_stewart(1),
     :        Pxtiinf_stewart(1,1),xtnew(1,1),Exi_stewart(1,1),
     :        fac_ftmr_cas(1))
      endif !if (frac_sublim.eq.1) then
      


        ! deduction de XTWATER  partir de Pxtiinf:
! hypothse: l'eau en i a la mme composition que le flux d'eau
        ! qui sort de la boite i (Pqiinf_par)
        do il=1,ncas
          if (abs(water_cas(il)).lt.ridicule/10.) then
            do ixt=1,niso
               xtwater_cas(ixt,il)=water_cas(il)*Rdefault(ixt)
            enddo !do ixt=1,niso
          else !if (water(il,i).eq.0.0) then
             if (Pqiinf_stewart(il).gt.0.0) then  !if (Pxtiinf_par(iso_eau).gt.0.0) then 
               do ixt=1,niso 
                 xtwater_cas(ixt,il)=water_cas(il)
     :              *Pxtiinf_stewart(ixt,il)/Pqiinf_stewart(il)
               enddo
             else !if (Pxtiinf_stewart(iso_eau).gt.0.0) then
                 ! normalement, ce cas a dj t interdit dans
                 ! compress_evp_glace
                do ixt=1,niso
                  xtwater_cas(ixt,il)=water_cas(il)*Rdefault(ixt)
                enddo !do ixt=1,niso
             endif
           endif !if (water(il,i).eq.0.0) then
         enddo !do il=1,ncas
        

      
        ! rappel, le Eqi_prime qu'on a mis en argument dans stewart est en
        ! fait gal  0.5*(Eqi+Eqi+1) -> en tenir compte quand on
        ! calcule xtevapi.    
       do il=1,ncas
        if (Eqi_stewart(il).gt.0.0) then
         do ixt=1,niso          
          xtevap_cas(ixt,il)=Eqi_prime_cas(il)
     :           *Exi_stewart(ixt,il)/Eqi_stewart(il)
     :           /100.0/delP_cas(il)/SIGD*g*2.0
     :            -xtevapsup_cas(ixt,il)        
         enddo ! do ixt=1,niso
        else !if (Eqi_stewart.gt.0.0) then
            ! il peut quand mme y a voir de la diffusion
            do ixt=1,niso
            xtevap_cas(ixt,il)=Exi_stewart(ixt,il)
     :           /100.0/delP_cas(il)/SIGD*g*2.0
     :            -xtevapsup_cas(ixt,il)
            enddo !do ixt=1,niso    
        endif !if (Eqi_stewart.gt.0.0) then
       enddo !do il=1,ncas
      

!      write(*,*) 'appel_stewart tmp 2243: Eqi_stewart(1)=',
!     :           Eqi_stewart(1)
!      write(*,*) 'Eqi_prime_cas=',Eqi_prime_cas(1)
      ! deduction de XTP partir de Exi
      do il=1,ncas
       if (i.lt.INB_cas(il)) then
          if (fac_ftmr_cas(il).gt.0.0) then
            if (Eqi_stewart(il)*fac_ftmr_cas(il).gt.ridicule) then 
               do ixt=1,niso     
               !   xtp(ixt,il,i)=xtnew(ixt)*qp(il,i)/xtnew(4)           
                  xtp_cas(ixt,il)=max(xtp_avantevaptrac_cas(ixt,il) 
     :                +fac_ftmr_cas(il)*Eqi_prime_cas(il)
     :                *Exi_stewart(ixt,il)/Eqi_stewart(il),0.0)  
               enddo !do ixt=1,niso
             else ! if (Eqi_stewart.gt.ridicule) then
                if (qp_cas(il).gt.0.0) then 

                    if (Eqi_prime_cas(il)*fac_ftmr_cas(il).gt.ridicule)
     :                    then 
                        ! il va manquer quelque chose: il faut augmenter
                        ! xtp en lui ajoutant l'vap du niveau d'eau
                        ! dessus
                        ! pour l'instant, on bidouille:
                        write(*,*) 'appel_stewart 2930: il=',il
                        do ixt=1,niso               
                        xtnew(ixt,il)=xtnew(ixt,il)
     :                    *(qp_avantevap_cas(il)
     :                    +Eqi_prime_cas(il)*fac_ftmr_cas(il))
     :                    /(qp_avantevap_cas(il)
     :                    +Eqi_stewart(il)*fac_ftmr_cas(il))
                        enddo
                    endif !if (Eqi_prime_cas(il)*fac_ftmr_cas(il).gt.ridicule)

                    do ixt=1,niso               
                      xtp_cas(ixt,il)=xtnew(ixt,il)
     :                    +(xtp_avantevaptrac_cas(ixt,il) 
     :                   -xtp_avantevap_cas(ixt,il))                  
                    enddo !do ixt=1,niso
                else !if (qp(il,i).gt.0.0) then 
                  do ixt=1,niso               
                    xtp_cas(ixt,il)=0.0
                  enddo !do ixt=1,niso
                endif  !if (qp(il,i).gt.0.0) then 
             endif !if (Eqi_stewart.gt.ridicule) then 


          else !if (fac_ftmr.gt.0.0) then
              ! ca veut dire que Mp=0, xtp pas dfinit
             do ixt=1,niso
               xtp_cas(ixt,il)=xtp_avantevaptrac_cas(ixt,il)
             enddo !do ixt=1,niso
         endif !if (fac_ftmr.gt.0.0) then
      else !if (i.lt.INB) then
          ! si i=inb, on ne change rien au calcul original, et on
          ! suppose que la composition du ddft est gale  celle de
          ! l'env. Ceci a dj t calcul plus haut
                  do ixt=1,niso
                    xtp_cas(ixt,il)=xtp_avantevaptrac_cas(ixt,il)
                    !xtp_avantevap(ixt) a dj t dfinit proprement
                    !dans ce cas l
                  enddo
      endif !if (i.lt.INB) then      
      enddo !do il=1,ncas

      ! verif

      return
      end
      

