!
! $Id: calwake.F 1403 2010-07-01 09:02:53Z fairhead $
!
      SUBROUTINE CALWAKE(paprs,pplay,dtime
     :             ,t,q,omgb
     :             ,dt_dwn,dq_dwn,M_dwn,M_up
     :             ,dt_a,dq_a,sigd
     :             ,wdt_PBL,wdq_PBL
     :             ,udt_PBL,udq_PBL
     o             ,wake_deltat,wake_deltaq,wake_dth
     o             ,wake_h,wake_s,wake_dens
     o             ,wake_pe,wake_fip,wake_gfl
     o             ,dt_wake,dq_wake
     o             ,wake_k
     o             ,undi_t,undi_q
     o             ,wake_omgbdth,wake_dp_omgb
     o             ,wake_dtKE,wake_dqKE
     o             ,wake_dtPBL,wake_dqPBL
     o             ,wake_omg,wake_dp_deltomg
     o             ,wake_spread,wake_Cstar,wake_d_deltat_gw
     o             ,wake_ddeltat,wake_ddeltaq

     :               ,xt,dxt_dwn,dxt_a,wdxt_PBL,udxt_PBL
     :               ,wake_deltaxt,dxt_wake, undi_xt
     :               ,wake_dxtKE,wake_dxtPBL   

     :   )
***************************************************************
*                                                             *
* CALWAKE                                                     *
*           interface avec le schema de calcul de la poche    *
*           froide                                            *
*                                                             *
* written by   : CHERUY Frederique, 13/03/2000, 10.31.05      *
* modified by :  ROEHRIG Romain,    01/30/2007                *
***************************************************************
*
      USE dimphy
      IMPLICIT none
c======================================================================
!-----------------------------------------------------------------------
!   INCLUDE 'dimensions.h'
!
!   dimensions.h contient les dimensions du modele
!   ndm est tel que iim=2**ndm
!-----------------------------------------------------------------------

      INTEGER iim,jjm,llm,ndm

      PARAMETER (iim= 96,jjm=71,llm=39,ndm=1)

!-----------------------------------------------------------------------
!#include "dimphy.h"
!
! $Header$
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation
!                 (les placer en colonne 6 et en colonne 73)
!
!
! A1.0 Fundamental constants
      REAL RPI,RCLUM,RHPLA,RKBOL,RNAVO
! A1.1 Astronomical constants
      REAL RDAY,REA,REPSM,RSIYEA,RSIDAY,ROMEGA
! A1.1.bis Constantes concernant l'orbite de la Terre:
      REAL R_ecc, R_peri, R_incl
! A1.2 Geoide
      REAL RA,RG,R1SA
! A1.3 Radiation
!     REAL RSIGMA,RI0
      REAL RSIGMA
! A1.4 Thermodynamic gas phase
      REAL R,RMD,RMO3,RMV,RD,RV,RCPD,RCPV,RCVD,RCVV
      REAL RKAPPA,RETV
! A1.5,6 Thermodynamic liquid,solid phases
      REAL RCW,RCS
! A1.7 Thermodynamic transition of phase
      REAL RLVTT,RLSTT,RLMLT,RTT,RATM
! A1.8 Curve of saturation
      REAL RESTT,RALPW,RBETW,RGAMW,RALPS,RBETS,RGAMS
      REAL RALPD,RBETD,RGAMD
!
      COMMON/YOMCST/RPI   ,RCLUM ,RHPLA ,RKBOL ,RNAVO                   &
     &      ,RDAY  ,REA   ,REPSM ,RSIYEA,RSIDAY,ROMEGA                  &
     &      ,R_ecc, R_peri, R_incl                                      &
     &      ,RA    ,RG    ,R1SA                                         &
     &      ,RSIGMA                                                     &
     &      ,R     ,RMD   ,RMO3  ,RMV   ,RD    ,RV    ,RCPD             &
     &      ,RCPV  ,RCVD  ,RCVV  ,RKAPPA,RETV                           &
     &      ,RCW   ,RCS                                                 &
     &      ,RLVTT ,RLSTT ,RLMLT ,RTT   ,RATM                           &
     &      ,RESTT ,RALPW ,RBETW ,RGAMW ,RALPS ,RBETS ,RGAMS            &
     &      ,RALPD ,RBETD ,RGAMD
!    ------------------------------------------------------------------
!$OMP THREADPRIVATE(/YOMCST/)

c Arguments
c----------

      INTEGER  i,l,ktopw(klon)
      REAL   dtime

      REAL paprs(klon,klev+1),pplay(klon,klev)
      REAL t(klon,klev), q(klon,klev), omgb(klon,klev)
      REAL dt_dwn(klon,klev), dq_dwn(klon,klev),M_dwn(klon,klev)
      REAL M_up(klon,klev)
      REAL dt_a(klon,klev), dq_a(klon,klev)
      REAL wdt_PBL(klon,klev), wdq_PBL(klon,klev)
      REAL udt_PBL(klon,klev), udq_PBL(klon,klev)
      REAL wake_deltat(klon,klev),wake_deltaq(klon,klev)
      REAL dt_wake(klon,klev),dq_wake(klon,klev)
      REAL wake_d_deltat_gw(klon,klev)
      REAL wake_h(klon),wake_s(klon)
      REAL wake_dth(klon,klev)
      REAL wake_pe(klon),wake_fip(klon),wake_gfl(klon)
      REAL undi_t(klon,klev),undi_q(klon,klev)
      REAL wake_omgbdth(klon,klev),wake_dp_omgb(klon,klev)
      REAL wake_dtKE(klon,klev),wake_dqKE(klon,klev)
      REAL wake_dtPBL(klon,klev),wake_dqPBL(klon,klev)
      REAL wake_omg(klon,klev),wake_dp_deltomg(klon,klev)
      REAL wake_spread(klon,klev),wake_Cstar(klon)
      REAL wake_ddeltat(klon,klev),wake_ddeltaq(klon,klev)
      REAL d_deltatw(klon,klev), d_deltaqw(klon,klev)
      INTEGER wake_k(klon)
      REAL sigd(klon)
      REAL wake_dens(klon)

!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
      REAL xt(ntraciso,klon,klev)
      REAL dxt_dwn(ntraciso,klon,klev)
      REAL dxt_a(ntraciso,klon,klev)
      REAL wdxt_PBL(ntraciso,klon,klev)
      REAL udxt_PBL(ntraciso,klon,klev)
      REAL wake_deltaxt(ntraciso,klon,klev)
      REAL dxt_wake(ntraciso,klon,klev)
      REAL undi_xt(ntraciso,klon,klev)
      REAL wake_dxtKE(ntraciso,klon,klev)
      REAL wake_dxtPBL(ntraciso,klon,klev)
      REAL wake_ddeltaxt(ntraciso,klon,klev)
      REAL d_deltaxtw(ntraciso,klon,klev)      

C  Variable internes
C  -----------------

      REAL aire
      REAL p(klon,klev),ph(klon,klev+1),pi(klon,klev)
      REAL te(klon,klev),qe(klon,klev),omgbe(klon,klev+1)
      REAL dtdwn(klon,klev),dqdwn(klon,klev)
      REAL dta(klon,klev),dqa(klon,klev)
      REAL wdtPBL(klon,klev),wdqPBL(klon,klev)
      REAL udtPBL(klon,klev),udqPBL(klon,klev) 
      REAL amdwn(klon,klev),amup(klon,klev)
      REAL dtw(klon,klev),dqw(klon,klev),dth(klon,klev)
      REAL d_deltat_gw(klon,klev)
      REAL dtls(klon,klev),dqls(klon,klev)
      REAL tu(klon,klev),qu(klon,klev)
      REAL hw(klon),sigmaw(klon),wape(klon),fip(klon),gfl(klon)
      REAL omgbdth(klon,klev+1),dp_omgb(klon,klev)
      REAL dtKE(klon,klev),dqKE(klon,klev)
      REAL dtPBL(klon,klev),dqPBL(klon,klev)
      REAL omg(klon,klev+1),dp_deltomg(klon,klev),spread(klon,klev)
      REAL Cstar(klon)
      REAL sigd0(klon),wdens(klon)

      REAL RDCP

      REAL xte(ntraciso,klon,klev)
      REAL dxtdwn(ntraciso,klon,klev)
      REAL dxta(ntraciso,klon,klev)
      REAL wdxtPBL(ntraciso,klon,klev)
      REAL udxtPBL(ntraciso,klon,klev) 
      REAL dxtw(ntraciso,klon,klev)
      REAL dxtls(ntraciso,klon,klev)
      REAL xtu(ntraciso,klon,klev)
      REAL dxtKE(ntraciso,klon,klev)
      REAL dxtPBL(ntraciso,klon,klev)   
      integer ixt

c      print *, '-> calwake, wake_s ', wake_s(1)

      RDCP=1./3.5


c-----------------------------------------------------------
cIM 290108     DO 999 i=1,klon   ! a vectoriser
c----------------------------------------------------------
!        write(*,*) 'calwake tmp 139: entree'

      DO l=1,klev
      DO i=1,klon 
        p(i,l)= pplay(i,l)
        ph(i,l)= paprs(i,l)
        pi(i,l) = (pplay(i,l)/100000.)**RDCP

        te(i,l) = t(i,l)
        qe(i,l) = q(i,l)
        omgbe(i,l) = omgb(i,l)

        dtdwn(i,l)= dt_dwn(i,l)
        dqdwn(i,l)= dq_dwn(i,l)
        dta(i,l)= dt_a(i,l)
        dqa(i,l)= dq_a(i,l)
        wdtPBL(i,l)= wdt_PBL(i,l)
        wdqPBL(i,l)= wdq_PBL(i,l)
        udtPBL(i,l)= udt_PBL(i,l)
        udqPBL(i,l)= udq_PBL(i,l)
        do ixt=1,ntraciso
          xte(ixt,i,l) = xt(ixt,i,l)
          dxtdwn(ixt,i,l)= dxt_dwn(ixt,i,l)
          dxta(ixt,i,l)= dxt_a(ixt,i,l)
          wdxtPBL(ixt,i,l)= wdxt_PBL(ixt,i,l)
          udxtPBL(ixt,i,l)= udxt_PBL(ixt,i,l)
        enddo !do ixt=1,ntraciso
      ENDDO ! DO i=1,klon 
      ENDDO ! DO l=1,klev

      omgbe(:,klev+1) = 0.
      
      DO i=1,klon 
      sigd0(i)=sigd(i)
      ENDDO
c      print*, 'sigd0,sigd', sigd0, sigd(i)
      DO i=1,klon 
      ph(i,klev+1)=0.
      ENDDO

      DO i=1,klon 
      ktopw(i) = wake_k(i)
      ENDDO

      DO l=1,klev
      DO i=1,klon 
        dtw(i,l) = wake_deltat(i,l)
        dqw(i,l) = wake_deltaq(i,l)
        do ixt=1,ntraciso
          dxtw(ixt,i,l) = wake_deltaxt(ixt,i,l)
        enddo
      ENDDO
      ENDDO

      DO l=1,klev
      DO i=1,klon 
        dtls(i,l)=dt_wake(i,l)
        dqls(i,l)=dq_wake(i,l)
        do ixt=1,ntraciso
          dxtls(ixt,i,l)=dxt_wake(ixt,i,l)
        enddo
      ENDDO
      ENDDO

      DO i=1,klon 
      hw(i) = wake_h(i)
      sigmaw(i)= wake_s(i)
      ENDDO

cfkc les flux de masses sont evalues aux niveaux et valent 0 a la surface
cfkc  on veut le flux de masse au milieu des couches

      DO l=1,klev-1
      DO i=1,klon 
        amdwn(i,l)= 0.5*(M_dwn(i,l)+M_dwn(i,l+1))
        amdwn(i,l)= (M_dwn(i,l+1))
      ENDDO
      ENDDO

c au sommet le flux de masse est nul

      DO i=1,klon 
      amdwn(i,klev)=0.5*M_dwn(i,klev)
      ENDDO
c
      DO l = 1,klev
      DO i=1,klon 
        amup(i,l)=M_up(i,l)
      ENDDO
      ENDDO

      call WAKE(p,ph,pi,dtime,sigd0
     $                ,te,qe,omgbe
     $                ,dtdwn,dqdwn,amdwn,amup,dta,dqa
     $                ,wdtPBL,wdqPBL,udtPBL,udqPBL
     $                ,dtw,dqw,dth,hw,sigmaw,wape,fip,gfl
     $                ,dtls,dqls,ktopw
     $                ,omgbdth,dp_omgb,wdens
     $                ,tu,qu
     $                ,dtKE,dqKE
     $                ,dtPBL,dqPBL
     $                ,omg,dp_deltomg,spread
     $                ,Cstar,d_deltat_gw
     $                ,d_deltatw,d_deltaqw
     :                ,xte,dxtdwn,dxta,wdxtPBL,udxtPBL
     :                ,dxtw,dxtls,xtu,dxtKE,dxtPBL,d_deltaxtw
     :  )
c
      DO l=1,klev
       DO i=1,klon 
        IF (ktopw(i) .GT. 0) THEN
           wake_deltat(i,l)= dtw(i,l)
           wake_deltaq(i,l)= dqw(i,l)
           wake_d_deltat_gw(i,l)= d_deltat_gw(i,l)
           wake_omgbdth(i,l) = omgbdth(i,l)
           wake_dp_omgb(i,l) = dp_omgb(i,l)
           wake_dtKE(i,l) = dtKE(i,l)
           wake_dqKE(i,l) = dqKE(i,l)
 	   wake_dtPBL(i,l) = dtPBL(i,l)
	   wake_dqPBL(i,l) = dqPBL(i,l)
           wake_omg(i,l) = omg(i,l)
           wake_dp_deltomg(i,l) = dp_deltomg(i,l)
           wake_spread(i,l) = spread(i,l)
           wake_dth(i,l) = dth(i,l)
           dt_wake(i,l) = dtls(i,l)
           dq_wake(i,l) = dqls(i,l)
           undi_t(i,l) = tu(i,l)
           undi_q(i,l) = qu(i,l)
           wake_ddeltat(i,l) = d_deltatw(i,l)
           wake_ddeltaq(i,l) = d_deltaqw(i,l)
           do ixt=1,ntraciso
             wake_deltaxt(ixt,i,l)= dxtw(ixt,i,l)
             wake_dxtKE(ixt,i,l) = dxtKE(ixt,i,l)
	     wake_dxtPBL(ixt,i,l) = dxtPBL(ixt,i,l)
             dxt_wake(ixt,i,l) = dxtls(ixt,i,l)
             undi_xt(ixt,i,l) = xtu(ixt,i,l)
             wake_ddeltaxt(ixt,i,l) = d_deltaxtw(ixt,i,l)
           enddo  

        ELSE
           wake_deltat(i,l)= 0.
           wake_deltaq(i,l)= 0.
           wake_d_deltat_gw(i,l)= 0.
           wake_omgbdth(i,l) = 0.
           wake_dp_omgb(i,l) = 0.
           wake_dtKE(i,l) = 0.
           wake_dqKE(i,l) = 0.
 	   wake_dtPBL(i,l) = 0.
	   wake_dqPBL(i,l) = 0.
           wake_omg(i,l) = 0.
           wake_dp_deltomg(i,l) = 0.
           wake_spread(i,l) = 0.
           wake_dth(i,l)=0.
           dt_wake(i,l)=0.
           dq_wake(i,l)=0.
           undi_t(i,l)=te(i,l)
           undi_q(i,l)=qe(i,l)
           wake_ddeltat(i,l) = 0.
           wake_ddeltaq(i,l) = 0.
           do ixt=1,ntraciso
            wake_deltaxt(ixt,i,l)= 0.
            wake_dxtKE(ixt,i,l) = 0.
	    wake_dxtPBL(ixt,i,l) = 0.
            dxt_wake(ixt,i,l)=0.
            undi_xt(ixt,i,l)=xte(ixt,i,l)
            wake_ddeltaxt(ixt,i,l) = 0.
           enddo !do ixt=1,ntraciso
        ENDIF
       ENDDO
      ENDDO



c
      DO i=1,klon 
       wake_h(i)= hw(i)
       wake_s(i)= sigmaw(i)
       wake_pe(i)= wape(i)
       wake_fip(i)= fip(i)
       wake_gfl(i) = gfl(i)
       wake_k(i) =ktopw(i)
       wake_Cstar(i) = Cstar(i)
       wake_dens(i) = wdens(i)
      ENDDO
c
      RETURN
      END

      SUBROUTINE CALWAKE_scal(paprs,pplay,dtime
     :             ,t,q,omgb
     :             ,dt_dwn,dq_dwn,M_dwn,M_up
     :             ,dt_a,dq_a,sigd
     :             ,wdt_PBL,wdq_PBL
     :             ,udt_PBL,udq_PBL
     o             ,wake_deltat,wake_deltaq,wake_dth
     o             ,wake_h,wake_s,wake_dens
     o             ,wake_pe,wake_fip,wake_gfl
     o             ,dt_wake,dq_wake
     o             ,wake_k
     o             ,undi_t,undi_q
     o             ,wake_omgbdth,wake_dp_omgb
     o             ,wake_dtKE,wake_dqKE
     o             ,wake_dtPBL,wake_dqPBL
     o             ,wake_omg,wake_dp_deltomg
     o             ,wake_spread,wake_Cstar,wake_d_deltat_gw
     o             ,wake_ddeltat,wake_ddeltaq)
***************************************************************
*                                                             *
* CALWAKE                                                     *
*           interface avec le schema de calcul de la poche    *
*           froide                                            *
*                                                             *
* written by   : CHERUY Frederique, 13/03/2000, 10.31.05      *
* modified by :  ROEHRIG Romain,    01/30/2007                *
***************************************************************
*
      USE dimphy
      IMPLICIT none
c======================================================================

!-----------------------------------------------------------------------
!   INCLUDE 'dimensions.h'
!
!   dimensions.h contient les dimensions du modele
!   ndm est tel que iim=2**ndm
!-----------------------------------------------------------------------

      INTEGER iim,jjm,llm,ndm

      PARAMETER (iim= 96,jjm=71,llm=39,ndm=1)

!-----------------------------------------------------------------------
cccc#include "dimphy.h"
!
! $Header$
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation
!                 (les placer en colonne 6 et en colonne 73)
!
!
! A1.0 Fundamental constants
      REAL RPI,RCLUM,RHPLA,RKBOL,RNAVO
! A1.1 Astronomical constants
      REAL RDAY,REA,REPSM,RSIYEA,RSIDAY,ROMEGA
! A1.1.bis Constantes concernant l'orbite de la Terre:
      REAL R_ecc, R_peri, R_incl
! A1.2 Geoide
      REAL RA,RG,R1SA
! A1.3 Radiation
!     REAL RSIGMA,RI0
      REAL RSIGMA
! A1.4 Thermodynamic gas phase
      REAL R,RMD,RMO3,RMV,RD,RV,RCPD,RCPV,RCVD,RCVV
      REAL RKAPPA,RETV
! A1.5,6 Thermodynamic liquid,solid phases
      REAL RCW,RCS
! A1.7 Thermodynamic transition of phase
      REAL RLVTT,RLSTT,RLMLT,RTT,RATM
! A1.8 Curve of saturation
      REAL RESTT,RALPW,RBETW,RGAMW,RALPS,RBETS,RGAMS
      REAL RALPD,RBETD,RGAMD
!
      COMMON/YOMCST/RPI   ,RCLUM ,RHPLA ,RKBOL ,RNAVO                   &
     &      ,RDAY  ,REA   ,REPSM ,RSIYEA,RSIDAY,ROMEGA                  &
     &      ,R_ecc, R_peri, R_incl                                      &
     &      ,RA    ,RG    ,R1SA                                         &
     &      ,RSIGMA                                                     &
     &      ,R     ,RMD   ,RMO3  ,RMV   ,RD    ,RV    ,RCPD             &
     &      ,RCPV  ,RCVD  ,RCVV  ,RKAPPA,RETV                           &
     &      ,RCW   ,RCS                                                 &
     &      ,RLVTT ,RLSTT ,RLMLT ,RTT   ,RATM                           &
     &      ,RESTT ,RALPW ,RBETW ,RGAMW ,RALPS ,RBETS ,RGAMS            &
     &      ,RALPD ,RBETD ,RGAMD
!    ------------------------------------------------------------------
!$OMP THREADPRIVATE(/YOMCST/)

c Arguments
c----------

      INTEGER  i,l,ktopw
      REAL   dtime

      REAL paprs(klon,klev+1),pplay(klon,klev)
      REAL t(klon,klev), q(klon,klev), omgb(klon,klev)
      REAL dt_dwn(klon,klev), dq_dwn(klon,klev),M_dwn(klon,klev)
      REAL M_up(klon,klev)
      REAL dt_a(klon,klev), dq_a(klon,klev)
      REAL wdt_PBL(klon,klev), wdq_PBL(klon,klev)
      REAL udt_PBL(klon,klev), udq_PBL(klon,klev)
      REAL wake_deltat(klon,klev),wake_deltaq(klon,klev)
      REAL dt_wake(klon,klev),dq_wake(klon,klev)
      REAL wake_d_deltat_gw(klon,klev)
      REAL wake_h(klon),wake_s(klon)
      REAL wake_dth(klon,klev)
      REAL wake_pe(klon),wake_fip(klon),wake_gfl(klon)
      REAL undi_t(klon,klev),undi_q(klon,klev)
      REAL wake_omgbdth(klon,klev),wake_dp_omgb(klon,klev)
      REAL wake_dtKE(klon,klev),wake_dqKE(klon,klev)
      REAL wake_dtPBL(klon,klev),wake_dqPBL(klon,klev)
      REAL wake_omg(klon,klev+1),wake_dp_deltomg(klon,klev)
      REAL wake_spread(klon,klev),wake_Cstar(klon)
      REAL wake_ddeltat(klon,klev),wake_ddeltaq(klon,klev)
      REAL d_deltatw(klev), d_deltaqw(klev)
      INTEGER wake_k(klon)
      REAL sigd(klon)
      REAL wake_dens(klon)

C  Variable internes
C  -----------------

      REAL aire
      REAL p(klev),ph(klev+1),pi(klev)
      REAL te(klev),qe(klev),omgbe(klev),dtdwn(klev),dqdwn(klev)
      REAL dta(klev),dqa(klev)
      REAL wdtPBL(klev),wdqPBL(klev)
      REAL udtPBL(klev),udqPBL(klev) 
      REAL amdwn(klev),amup(klev)
      REAL dtw(klev),dqw(klev),dth(klev),d_deltat_gw(klev)
      REAL dtls(klev),dqls(klev)
      REAL tu(klev),qu(klev)
      REAL hw,sigmaw,wape,fip,gfl
      REAL omgbdth(klev),dp_omgb(klev)
      REAL dtKE(klev),dqKE(klev)
      REAL dtPBL(klev),dqPBL(klev)
      REAL omg(klev+1),dp_deltomg(klev),spread(klev),Cstar
      REAL sigd0,wdens

      REAL RDCP

c      print *, '-> calwake, wake_s ', wake_s(1)

      RDCP=1./3.5


        write(*,*) 'calwake 429: les isotopes ne sont pas mis ici'
        stop

c-----------------------------------------------------------
      DO 999 i=1,klon   ! a vectoriser
c----------------------------------------------------------


      DO l=1,klev
        p(l)= pplay(i,l)
        ph(l)= paprs(i,l)
        pi(l) = (pplay(i,l)/100000.)**RDCP

        te(l) = t(i,l)
        qe(l) = q(i,l)
        omgbe(l) = omgb(i,l)

        dtdwn(l)= dt_dwn(i,l)
        dqdwn(l)= dq_dwn(i,l)
        dta(l)= dt_a(i,l)
        dqa(l)= dq_a(i,l)
        wdtPBL(l)= wdt_PBL(i,l)
        wdqPBL(l)= wdq_PBL(i,l)
        udtPBL(l)= udt_PBL(i,l)
        udqPBL(l)= udq_PBL(i,l)
      ENDDO
      
      sigd0=sigd(i)
c      print*, 'sigd0,sigd', sigd0, sigd(i)
      ph(klev+1)=0.

      ktopw = wake_k(i)

      DO l=1,klev
        dtw(l) = wake_deltat(i,l)
        dqw(l) = wake_deltaq(i,l)
      ENDDO

      DO l=1,klev
        dtls(l)=dt_wake(i,l)
        dqls(l)=dq_wake(i,l)
      ENDDO

      hw = wake_h(i)
      sigmaw = wake_s(i)

cfkc les flux de masses sont evalues aux niveaux et valent 0 a la surface
cfkc  on veut le flux de masse au milieu des couches

      DO l=1,klev-1
        amdwn(l)= 0.5*(M_dwn(i,l)+M_dwn(i,l+1))
        amdwn(l)= (M_dwn(i,l+1))
      ENDDO

c au sommet le flux de masse est nul

      amdwn(klev)=0.5*M_dwn(i,klev)
c
      DO l = 1,klev
        amup(l)=M_up(i,l)
      ENDDO

      call WAKE_scal(p,ph,pi,dtime,sigd0
     $                ,te,qe,omgbe
     $                ,dtdwn,dqdwn,amdwn,amup,dta,dqa
     $                ,wdtPBL,wdqPBL,udtPBL,udqPBL
     $                ,dtw,dqw,dth,hw,sigmaw,wape,fip,gfl
     $                ,dtls,dqls,ktopw
     $                ,omgbdth,dp_omgb,wdens
     $                ,tu,qu
     $                ,dtKE,dqKE
     $                ,dtPBL,dqPBL
     $                ,omg,dp_deltomg,spread
     $                ,Cstar,d_deltat_gw
     $                ,d_deltatw,d_deltaqw)


       IF (ktopw .GT. 0) THEN
         DO l=1,klev
           wake_deltat(i,l)= dtw(l)
           wake_deltaq(i,l)= dqw(l)
           wake_d_deltat_gw(i,l)= d_deltat_gw(l)
           wake_omgbdth(i,l) = omgbdth(l)
           wake_dp_omgb(i,l) = dp_omgb(l)
           wake_dtKE(i,l) = dtKE(l)
           wake_dqKE(i,l) = dqKE(l)
 	   wake_dtPBL(i,l) = dtPBL(l)
	   wake_dqPBL(i,l) = dqPBL(l)
           wake_omg(i,l) = omg(l)
           wake_dp_deltomg(i,l) = dp_deltomg(l)
           wake_spread(i,l) = spread(l)
           wake_dth(i,l) = dth(l)
           dt_wake(i,l) = dtls(l)
           dq_wake(i,l) = dqls(l)
           undi_t(i,l) = tu(l)
           undi_q(i,l) = qu(l)
           wake_ddeltat(i,l) = d_deltatw(l)
           wake_ddeltaq(i,l) = d_deltaqw(l)
         ENDDO
       ELSE
         DO l = 1,klev
           wake_deltat(i,l)= 0.
           wake_deltaq(i,l)= 0.
           wake_d_deltat_gw(i,l)= 0.
           wake_omgbdth(i,l) = 0.
           wake_dp_omgb(i,l) = 0.
           wake_dtKE(i,l) = 0.
           wake_dqKE(i,l) = 0.
           wake_omg(i,l) = 0.
           wake_dp_deltomg(i,l) = 0.
           wake_spread(i,l) = 0.
           wake_dth(i,l)=0.
           dt_wake(i,l)=0.
           dq_wake(i,l)=0.
           undi_t(i,l)=te(l)
           undi_q(i,l)=qe(l)
         ENDDO
       ENDIF

       wake_h(i)= hw
       wake_s(i)= sigmaw
       wake_pe(i)= wape
       wake_fip(i)= fip
       wake_gfl(i) = gfl
       wake_k(i) =ktopw
       wake_Cstar(i) = Cstar
       wake_dens(i) = wdens
c
 999  CONTINUE
c
      RETURN
      END
