        SUBROUTINE CV3_CRIT (nloc,ncum,nd,icb,inb,p,ph,pzero
     $             ,v,threshold,kcrit,pcrit)
***************************************************************
*                                                             *
* CV3_CRIT   Find pressure level where vertical profile of    *
*            variable 'v' intersects 'threshold'              *
*                                                             *
* written by   : FROHWIRTH Julie, 13/08/2003, 21.55.12        *
* modified by :                                               *
***************************************************************
*

c------------------------------------------------------------
c Parameters for convectL, iflag_con=3:
c (includes - microphysical parameters,
c			- parameters that control the rate of approach
c               to quasi-equilibrium)
c			- noff & minorig (previously in input of convect1)
c------------------------------------------------------------

      integer noff, minorig, nl, nlp, nlm
      real sigdz, spfac
      integer flag_epKEorig,flag_wb
      real pbcrit, ptcrit
      real elcrit, tlcrit
      real omtrain
      real dtovsh, dpbase, dttrig
      real dtcrit, tau, beta, alpha, alpha1
      real wbmax
      real delta
      real betad

      COMMON /cv3param/  noff, minorig, nl, nlp, nlm
     :                ,  sigdz, spfac
     :                ,flag_epKEorig
     :                ,pbcrit, ptcrit
     :                ,elcrit, tlcrit
     :                ,omtrain
     :                ,dtovsh, dpbase, dttrig
     :                ,dtcrit, tau, beta, alpha, alpha1
     :                ,flag_wb,wbmax
     :                ,delta, betad
!$OMP THREADPRIVATE(/cv3param/)


c input:
      integer ncum, nd, nloc
      integer icb(nloc), inb(nloc)
      real p(nloc,nd), ph(nloc,nd+1)
      real pzero(nloc)
      real v(nloc,nd),threshold

c output:
      integer kcrit(nloc)
      real pcrit(nloc)

c local variables
      integer i,j,k,il
      logical ok(nloc)

      do il = 1,ncum
        ok(il) = .true.
        pcrit(il) = -1.
        kcrit(il) = 0
      enddo
c
      DO i = 1,nl
        DO il = 1,ncum
        IF (i .GT. icb(il) .AND. i .LE. inb(il)) THEN
        IF (P(il,i) .LE. Pzero(il) .AND. ok(il)) THEN
          IF ( (v(il,i)-threshold)*(v(il,i-1)-threshold) .LT. 0.) THEN
            pcrit(il) =
     $       ((threshold-v(il,i))*P(il,i-1)-
     $        (threshold-v(il,i-1))*P(il,i))
     $           /(v(il,i-1)-v(il,i))
           IF (pcrit(il) .gt. Pzero(il)) THEN
            pcrit(il) = -1.
           ELSE
            ok(il) = .false.
            kcrit(il) = i
            IF (pcrit(il) .LT. PH(il,i)) kcrit(il) = kcrit(il)+1
           ENDIF
          ENDIF  ! end IF (v(i) ...
        ENDIF    ! end IF (P(i) ...
        ENDIF    ! end IF (icb+1 le i le inb)
        ENDDO
      ENDDO
125   CONTINUE


      RETURN
      END
