      SUBROUTINE cv3a_uncompress(nloc,len,ncum,nd,ntra,idcum
     :         ,iflag,kbas,ktop
     :         ,precip,cbmf,plcl,plfc,wbeff,sig,w0,ptop2
     :         ,ft,fq,fu,fv,ftra
     :         ,sigd,Ma,mip,Vprecip,upwd,dnwd,dnwd0
     :         ,qcondc,wd,cape,cin
     :         ,tvp
     :         ,ftd,fqd
     :         ,Plim1,Plim2,asupmax,supmax0
     :         ,asupmaxmin
!
     :         ,da,phi                               !AC!
     :         ,mp,phi2,d1a,dam,sigij                  !RomP
     :         ,wdtrainA,wdtrainM,elij,clw           !RomP
     :         ,evap,ep                              !RomP
!
     o         ,iflag1,kbas1,ktop1
     :         ,precip1,cbmf1,plcl1,plfc1,wbeff1,sig1,w01,ptop21
     :         ,ft1,fq1,fu1,fv1,ftra1
     :         ,sigd1,Ma1,mip1,Vprecip1,upwd1,dnwd1,dnwd01
     :         ,qcondc1,wd1,cape1,cin1
     :         ,tvp1
     :         ,ftd1,fqd1
     :         ,Plim11,Plim21,asupmax1,supmax01
     :         ,asupmaxmin1     
!
     o         ,da1,phi1                             !AC!
     o         ,mp1,phi21,d1a1,dam1,sigij1             !RomP
     o         ,wdtrainA1,wdtrainM1,elij1,clw1       !RomP
     o         ,evap1,ep1

     :          ,xtprecip,fxt,fxtd  , xtVprecip        
     o         ,xtprecip1,fxt1,fxtd1, xtVprecip1
     :         )
***************************************************************
*                                                             *
* CV3A_UNCOMPRESS                                             *
*                                                             *
*                                                             *
* written by   : Sandrine Bony-Lena , 17/05/2003, 11.22.15    *
* modified by  : Jean-Yves Grandpeix, 23/06/2003, 10.36.17    *
***************************************************************
*
      implicit none

c------------------------------------------------------------
c Parameters for convectL, iflag_con=3:
c (includes - microphysical parameters,
c			- parameters that control the rate of approach
c               to quasi-equilibrium)
c			- noff & minorig (previously in input of convect1)
c------------------------------------------------------------

      integer noff, minorig, nl, nlp, nlm
      real sigdz, spfac
      integer flag_epKEorig,flag_wb
      real pbcrit, ptcrit
      real elcrit, tlcrit
      real omtrain
      real dtovsh, dpbase, dttrig
      real dtcrit, tau, beta, alpha, alpha1
      real wbmax
      real delta
      real betad

      COMMON /cv3param/  noff, minorig, nl, nlp, nlm
     :                ,  sigdz, spfac
     :                ,flag_epKEorig
     :                ,pbcrit, ptcrit
     :                ,elcrit, tlcrit
     :                ,omtrain
     :                ,dtovsh, dpbase, dttrig
     :                ,dtcrit, tau, beta, alpha, alpha1
     :                ,flag_wb,wbmax
     :                ,delta, betad
!$OMP THREADPRIVATE(/cv3param/)


c inputs:
      integer nloc, len, ncum, nd, ntra
      integer idcum(nloc)
      integer iflag(nloc),kbas(nloc),ktop(nloc)
      real precip(nloc),cbmf(nloc),plcl(nloc),plfc(nloc)
      real wbeff(len)
      real sig(nloc,nd), w0(nloc,nd),ptop2(nloc)
      real ft(nloc,nd), fq(nloc,nd), fu(nloc,nd), fv(nloc,nd)
      real ftra(nloc,nd,ntra)
      real sigd(nloc)
      real Ma(nloc,nd),mip(nloc,nd),Vprecip(nloc,nd+1)
      real upwd(nloc,nd),dnwd(nloc,nd),dnwd0(nloc,nd)
      real qcondc(nloc,nd)
      real wd(nloc),cape(nloc),cin(nloc)
      real tvp(nloc,nd)
      real ftd(nloc,nd), fqd(nloc,nd)
      real Plim1(nloc),Plim2(nloc)
      real asupmax(nloc,nd),supmax0(nloc)
      real asupmaxmin(nloc)
!
      real da(nloc,nd),phi(nloc,nd,nd)                    !AC!
      real mp(nloc,nd)                                    !RomP
      real phi2(nloc,nd,nd)                               !RomP
      real d1a(nloc,nd),dam(nloc,nd)                      !RomP
      real wdtrainA(nloc,nd), wdtrainM(nloc,nd)           !RomP
      real sigij(nloc,nd,nd)                                !RomP
      real elij(nloc,nd,nd),clw(nloc,nd)                  !RomP
      real evap(nloc,nd),ep(nloc,nd)                      !RomP
!
!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
      real xtprecip(ntraciso,nloc)
      real fxt(ntraciso,nloc,nd)
      real fxtd(ntraciso,nloc,nd)
      real xtVprecip(ntraciso,nloc,nd+1)
      

c outputs:
      integer iflag1(len),kbas1(len),ktop1(len)
      real precip1(len),cbmf1(len),plcl1(nloc),plfc1(nloc)
      real wbeff1(len)
      real sig1(len,nd), w01(len,nd),ptop21(len)
      real ft1(len,nd), fq1(len,nd), fu1(len,nd), fv1(len,nd)
      real ftra1(len,nd,ntra)
      real sigd1(len)
      real Ma1(len,nd),mip1(len,nd),Vprecip1(len,nd+1)
      real upwd1(len,nd),dnwd1(len,nd),dnwd01(len,nd)
      real qcondc1(len,nd)
      real wd1(len),cape1(len),cin1(len)
      real tvp1(len,nd)
      real ftd1(len,nd), fqd1(len,nd)
      real Plim11(len),Plim21(len)
      real asupmax1(len,nd),supmax01(len)
      real asupmaxmin1(len)
!
      real da1(nloc,nd),phi1(nloc,nd,nd)                  !AC!
      real mp1(nloc,nd)                                   !RomP
      real phi21(nloc,nd,nd)                              !RomP
      real d1a1(nloc,nd),dam1(nloc,nd)                    !RomP
      real wdtrainA1(len,nd), wdtrainM1(len,nd)           !RomP
      real sigij1(len,nd,nd)                                !RomP
      real elij1(len,nd,nd),clw1(len,nd)                  !RomP
      real evap1(len,nd),ep1(len,nd)                      !RomP
!
      real xtprecip1(ntraciso,len)
      real fxt1(ntraciso,len,nd)
      real fxtd1(ntraciso,len,nd)
      real xtVprecip1(ntraciso,len,nd+1)
c
c local variables:
      integer i,k,j,k1,k2
      integer ixt

      

        do 2000 i=1,ncum
         ptop21(idcum(i))=ptop2(i)
         sigd1(idcum(i))=sigd(i)
         precip1(idcum(i))=precip(i)
         cbmf1(idcum(i))=cbmf(i)
         plcl1(idcum(i))=plcl(i)
         plfc1(idcum(i))=plfc(i)
         wbeff1(idcum(i))=wbeff(i)
         iflag1(idcum(i))=iflag(i)
         kbas1(idcum(i))=kbas(i)
         ktop1(idcum(i))=ktop(i)
         wd1(idcum(i))=wd(i)
         cape1(idcum(i))=cape(i)
         cin1(idcum(i))=cin(i)
         Plim11(idcum(i))=Plim1(i)
         Plim21(idcum(i))=Plim2(i)
         supmax01(idcum(i))=supmax0(i)
         asupmaxmin1(idcum(i))=asupmaxmin(i)
         do ixt = 1, ntraciso
          xtprecip1(ixt,idcum(i))=xtprecip(ixt,i)
         enddo
 2000   continue

        do 2020 k=1,nd
          do 2010 i=1,ncum
            sig1(idcum(i),k)=sig(i,k)
            w01(idcum(i),k)=w0(i,k)
            ft1(idcum(i),k)=ft(i,k)
            fq1(idcum(i),k)=fq(i,k)
            fu1(idcum(i),k)=fu(i,k)
            fv1(idcum(i),k)=fv(i,k)
            Ma1(idcum(i),k)=Ma(i,k)
            mip1(idcum(i),k)=mip(i,k)
            Vprecip1(idcum(i),k)=Vprecip(i,k)
            upwd1(idcum(i),k)=upwd(i,k)
            dnwd1(idcum(i),k)=dnwd(i,k)
            dnwd01(idcum(i),k)=dnwd0(i,k)
            qcondc1(idcum(i),k)=qcondc(i,k)
            tvp1(idcum(i),k)=tvp(i,k)
            ftd1(idcum(i),k)=ftd(i,k)
            fqd1(idcum(i),k)=fqd(i,k)
            asupmax1(idcum(i),k)=asupmax(i,k)
!
            da1(idcum(i),k)=da(i,k)                       !AC!
            mp1(idcum(i),k)      = mp(i,k)                !RomP
            d1a1(idcum(i),k)     = d1a(i,k)               !RomP
            dam1(idcum(i),k)     = dam(i,k)               !RomP
            wdtrainA1(idcum(i),k)= wdtrainA(i,k)          !RomP
            wdtrainM1(idcum(i),k)= wdtrainM(i,k)          !RomP
            clw1(idcum(i),k)     = clw(i,k)               !RomP
            evap1(idcum(i),k)    = evap(i,k)              !RomP
            ep1(idcum(i),k)      = ep(i,k)                !RomP
!
            do ixt = 1, ntraciso
             fxt1(ixt,idcum(i),k)=fxt(ixt,i,k)
             fxtd1(ixt,idcum(i),k)=fxtd(ixt,i,k)
             xtVprecip1(ixt,idcum(i),k)=xtVprecip(ixt,i,k)
            enddo
 2010     continue
 2020   continue



        do 2040 i=1,ncum
          sig1(idcum(i),nd)=sig(i,nd)
2040    continue


!AC!        do 2100 j=1,ntra
!AC!c oct3         do 2110 k=1,nl
!AC!         do 2110 k=1,nd ! oct3
!AC!          do 2120 i=1,ncum
!AC!            ftra1(idcum(i),k,j)=ftra(i,k,j)
!AC! 2120     continue
!AC! 2110    continue
!AC! 2100   continue
c
!AC!
       do k2=1,nd
         do k1=1,nd 
          do i=1,ncum
            phi1(idcum(i),k1,k2)=phi(i,k1,k2)                 !AC!
            phi21(idcum(i),k1,k2)= phi2(idcum(i),k1,k2)   !RomP
            sigij1(idcum(i),k1,k2) = sigij(idcum(i),k1,k2)    !RomP
            elij1(idcum(i),k1,k2)= elij(idcum(i),k1,k2)   !RomP
          end do
         end do
        end do
!AC!
c        do 2220 k2=1,nd
c         do 2210 k1=1,nd
c          do 2200 i=1,ncum
c            ment1(idcum(i),k1,k2) = ment(i,k1,k2)
c            sigij1(idcum(i),k1,k2) = sigij(i,k1,k2)
c2200      enddo
c2210     enddo
c2220    enddo


       RETURN
      END

