      SUBROUTINE cv3p_mixing(nloc,ncum,nd,na,ntra,icb,nk,inb
     :                    ,ph,t,rr,rs,u,v,tra,h,lv,qnk
     :                    ,unk,vnk,hp,tv,tvp,ep,clw,sig
     :                    ,ment,qent,hent,uent,vent,nent
     :                   ,sigij,elij,supmax,ments,qents,traent

     :                   ,xt,xtnk,xtclw,xtent,xtelij,tg_save      

     :           )
***************************************************************
*                                                             *
* CV3P_MIXING : compute mixed draught properties and,         *
*               within a scaling factor, mixed draught        *
*               mass fluxes.                                  *
* written by  : VTJ Philips,JY Grandpeix, 21/05/2003, 09.14.15*
* modified by :                                               *
***************************************************************
*
      implicit none
c
!
! $Header$
!
c Thermodynamical constants for convectL:

      real cpd, cpv, cl, rrv, rrd, lv0, g, rowl, t0
      real clmcpv, clmcpd, cpdmcp, cpvmcpd, cpvmcl
      real eps, epsi, epsim1
      real ginv, hrd
      real grav

      COMMON /cvthermo/ cpd, cpv, cl, rrv, rrd, lv0, g, rowl, t0
     :                 ,clmcpv, clmcpd, cpdmcp, cpvmcpd, cpvmcl 
     :                 ,eps, epsi, epsim1, ginv, hrd, grav

c$OMP THREADPRIVATE(/cvthermo/)
c------------------------------------------------------------
c Parameters for convectL, iflag_con=3:
c (includes - microphysical parameters,
c			- parameters that control the rate of approach
c               to quasi-equilibrium)
c			- noff & minorig (previously in input of convect1)
c------------------------------------------------------------

      integer noff, minorig, nl, nlp, nlm
      real sigdz, spfac
      integer flag_epKEorig,flag_wb
      real pbcrit, ptcrit
      real elcrit, tlcrit
      real omtrain
      real dtovsh, dpbase, dttrig
      real dtcrit, tau, beta, alpha, alpha1
      real wbmax
      real delta
      real betad

      COMMON /cv3param/  noff, minorig, nl, nlp, nlm
     :                ,  sigdz, spfac
     :                ,flag_epKEorig
     :                ,pbcrit, ptcrit
     :                ,elcrit, tlcrit
     :                ,omtrain
     :                ,dtovsh, dpbase, dttrig
     :                ,dtcrit, tau, beta, alpha, alpha1
     :                ,flag_wb,wbmax
     :                ,delta, betad
!$OMP THREADPRIVATE(/cv3param/)


      INTEGER choice, iflag_mix
      REAL  gammas, alphas, betas, Fmax, qqa1, qqa2, qqa3, scut
      REAL  Qcoef1max,Qcoef2max,Supcrit1,Supcrit2
!
      COMMON/YOMCST2/gammas,    alphas, betas, Fmax, scut,              &
     &               qqa1, qqa2, qqa3,                                  &
     &               Qcoef1max,Qcoef2max,                               &
     &               Supcrit1, Supcrit2,                                &
     &               choice,iflag_mix
!$OMP THREADPRIVATE(/YOMCST2/)
!    --------------------------------------------------------------------


!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
      
c inputs:
      integer ncum, nd, na, ntra, nloc
      integer icb(nloc), inb(nloc), nk(nloc)
      real sig(nloc,nd)
      real qnk(nloc),unk(nloc),vnk(nloc)
      real ph(nloc,nd+1)
      real t(nloc,nd), rr(nloc,nd), rs(nloc,nd)
      real u(nloc,nd), v(nloc,nd)
      real tra(nloc,nd,ntra) ! input of convect3
      real lv(nloc,na)
      real h(nloc,na)  !liquid water static energy of environment
      real hp(nloc,na) !liquid water static energy of air shed from adiab. asc.
      real tv(nloc,na), tvp(nloc,na), ep(nloc,na), clw(nloc,na)
      real xt(ntraciso,nloc,na), xtclw(ntraciso,nloc,na)
      real xtnk(ntraciso,nloc) 
      real tg_save(nloc,nd)

c outputs:
      real ment(nloc,na,na), qent(nloc,na,na)
      real uent(nloc,na,na), vent(nloc,na,na)
      real sigij(nloc,na,na), elij(nloc,na,na)
      real supmax(nloc,na)     ! Highest mixing fraction of mixed updraughts
                               ! with the sign of (h-hp)
      real traent(nloc,nd,nd,ntra)
      real ments(nloc,nd,nd), qents(nloc,nd,nd)
      real hent(nloc,nd,nd)
      integer nent(nloc,nd)
      real xtent(ntraciso,nloc,nd,nd)
      real xtelij(ntraciso,nloc,nd,nd)  
      real qent_diag(nloc,na,na)
      real xtent_diag(ntraciso,nloc,nd,nd)    

c local variables:
      integer i, j, k, il, im, jm
      integer num1, num2
      real rti, bf2, anum, denom, dei, altem, cwat, stemp, qp
      real alt, delp, delm
      real Qmixmax(nloc), Rmixmax(nloc), SQmRmax(nloc)
      real Qmixmin(nloc), Rmixmin(nloc), SQmRmin(nloc)
      real signhpmh(nloc)
      real Sx(nloc), Scrit2
      real smid(nloc), sjmin(nloc), sjmax(nloc)
      real Sbef(nloc), Sup(nloc), Smin(nloc)
      real asij(nloc), smax(nloc), scrit(nloc)
      real sij(nloc,nd,nd)
      real csum(nloc,nd)
      real awat
      logical lwork(nloc)
c
      REAL amxupcrit, df, ff
      INTEGER nstep
C
c --   Mixing probability distribution functions
c
      real Qcoef1,Qcoef2,QFF,QFFF,Qmix,Rmix,Qmix1,Rmix1,Qmix2,Rmix2,F
      Qcoef1(F) = tanh(F/gammas)
      Qcoef2(F) = ( tanh(F/gammas) + gammas *
     $            log(cosh((1.- F)/gammas)/cosh(F/gammas)))
      QFF(F) = Max(Min(F,1.),0.)
      QFFF(F) = Min(QFF(F),scut)
      Qmix1(F) = ( tanh((QFF(F) - Fmax)/gammas)+Qcoef1max )/
     $           Qcoef2max
      Rmix1(F) = ( gammas*log(cosh((QFF(F)-Fmax)/gammas))
     1             +QFF(F)*Qcoef1max ) / Qcoef2max
      Qmix2(F) = -Log(1.-QFFF(F))/scut
      Rmix2(F) = (QFFF(F)+(1.-QFF(F))*Log(1.-QFFF(F)))/scut
      Qmix(F) = qqa1*Qmix1(F) + qqa2*Qmix2(F)
      Rmix(F) = qqa1*Rmix1(F) + qqa2*Rmix2(F)
C
      INTEGER, SAVE :: ifrst
      DATA ifrst/0/
c$OMP THREADPRIVATE(ifrst)


      integer ixt
      real xtrti(ntraciso)
      real xtres(ntraciso)
      real zfice(nloc),zxtliq(ntraciso,nloc),zxtice(ntraciso,nloc)
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      
C

c=====================================================================
c --- INITIALIZE VARIOUS ARRAYS USED IN THE COMPUTATIONS
c=====================================================================
c
c -- Initialize mixing PDF coefficients
      IF (ifrst .EQ. 0) THEN
        ifrst = 1
        Qcoef1max = Qcoef1(Fmax)
        Qcoef2max = Qcoef2(Fmax)
c
      ENDIF
c

c ori        do 360 i=1,ncum*nlp
        do 361 j=1,nl
        do 360 i=1,ncum
          nent(i,j)=0
c in convect3, m is computed in cv3_closure
c ori          m(i,1)=0.0
 360    continue
 361    continue

c ori      do 400 k=1,nlp
c ori       do 390 j=1,nlp
      do 400 j=1,nl
       do 390 k=1,nl
          do 385 i=1,ncum
            qent(i,k,j)=rr(i,j)
            uent(i,k,j)=u(i,j)
            vent(i,k,j)=v(i,j)
            elij(i,k,j)=0.0
            hent(i,k,j)=0.0
!AC!            ment(i,k,j)=0.0
!AC!            sij(i,k,j)=0.0
 385      continue
 390    continue
 400  continue

!AC!
      ment(1:ncum,1:nd,1:nd)=0.0
      sij(1:ncum,1:nd,1:nd)=0.0
!AC!

      do j=1,nd
       do k=1,nd
          do i=1,ncum
            do ixt =1,ntraciso
             xtent(ixt,i,k,j)=xt(ixt,i,j)
             xtent_diag(ixt,i,k,j)=xt(ixt,i,j)
             xtelij(ixt,i,k,j)=0.0
            enddo !do ixt =1,niso
            ! on initialise mieux que ça qent et elij, même si au final les
            ! valeurs en nd=nl+1 ne sont pas utilisées
            qent(i,k,j)=rr(i,j)
            qent_diag(i,k,j)=rr(i,j)
            elij(i,k,j)=0.0    
         enddo !do i=1,ncum
       enddo !do k=1,nl
      enddo   !do j=1,nl  

      do k=1,ntra
       do j=1,nd  ! instead nlp
        do i=1,nd ! instead nlp
         do il=1,ncum
            traent(il,i,j,k)=tra(il,j,k)
         enddo
        enddo
       enddo
      enddo

c=====================================================================
c --- CALCULATE ENTRAINED AIR MASS FLUX (ment), TOTAL WATER MIXING
c --- RATIO (QENT), TOTAL CONDENSED WATER (elij), AND MIXING
c --- FRACTION (sij)
c=====================================================================

      do 750 i=minorig+1, nl

       do 710 j=minorig,nl
       
        do 700 il=1,ncum
         if( (i.ge.icb(il)).and.(i.le.inb(il)).and.
     :      (j.ge.(icb(il)-1)).and.(j.le.inb(il)))then

          rti=qnk(il)-ep(il,i)*clw(il,i)
          bf2=1.+lv(il,j)*lv(il,j)*rs(il,j)/(rrv*t(il,j)*t(il,j)*cpd)
          anum=h(il,j)-hp(il,i)+(cpv-cpd)*t(il,j)*(rti-rr(il,j))
          denom=h(il,i)-hp(il,i)+(cpd-cpv)*(rr(il,i)-rti)*t(il,j)
          dei=denom
          if(abs(dei).lt.0.01)dei=0.01
          sij(il,i,j)=anum/dei
          sij(il,i,i)=1.0
          altem=sij(il,i,j)*rr(il,i)+(1.-sij(il,i,j))*rti-rs(il,j)
          altem=altem/bf2
          cwat=clw(il,j)*(1.-ep(il,j))
          stemp=sij(il,i,j)
          if((stemp.lt.0.0.or.stemp.gt.1.0.or.altem.gt.cwat)
     :                 .and.j.gt.i)then
           anum=anum-lv(il,j)*(rti-rs(il,j)-cwat*bf2)
           denom=denom+lv(il,j)*(rr(il,i)-rti)
           if(abs(denom).lt.0.01)denom=0.01
           sij(il,i,j)=anum/denom
           altem=sij(il,i,j)*rr(il,i)+(1.-sij(il,i,j))*rti-rs(il,j)
           altem=altem-(bf2-1.)*cwat
          end if
              if(sij(il,i,j).gt.0.0)then
ccc                 ment(il,i,j)=m(il,i)
                 ment(il,i,j)=1.
                 elij(il,i,j)=altem
                 elij(il,i,j)=amax1(0.0,elij(il,i,j))
                 nent(il,i)=nent(il,i)+1
              endif

         sij(il,i,j)=amax1(0.0,sij(il,i,j))
         sij(il,i,j)=amin1(1.0,sij(il,i,j))
         endif ! new
         if(sij(il,i,j).gt.0.0)then
               qent_diag(il,i,j)=sij(il,i,j)*rr(il,i)
     :                +(1.-sij(il,i,j))*rti
           ! question: pourquoi qent n'est-il pas recalculé ici?
         endif !if(sij(il,i,j).gt.0.0)then

 700   continue
         
       do il=1,ncum
         zfice(il) = 1.0-(tg_save(il,j)-pxtice)/(pxtmelt-pxtice)
         zfice(il) = MIN(MAX(zfice(il),0.0),1.0)

         if( (i.ge.icb(il)).and.(i.le.inb(il)).and.
     :      (j.ge.(icb(il)-1)).and.(j.le.inb(il))) then
          if (sij(il,i,j).gt.0.0) then  
           do ixt=1,ntraciso
            xtrti(ixt)=xtnk(ixt,il)-ep(il,i)*xtclw(ixt,il,i) 
            xtent_diag(ixt,il,i,j)=sij(il,i,j)*xt(ixt,il,i)
     :                +(1.-sij(il,i,j))*xtrti(ixt)   
           enddo ! do ixt=1,ntraciso 
           if (qent_diag(il,i,j).lt.elij(il,i,j)) then  
             do ixt=1,ntraciso
               xtent_diag(ixt,il,i,j)=  xtent_diag(ixt,il,i,j)
     :           / qent_diag(il,i,j)*elij(il,i,j)    
             enddo ! do ixt=1,ntraciso
             qent_diag(il,i,j)=elij(il,i,j)
           endif !if (qent_diag(il,i,j).lt.elij(il,i,j)) then

         else !if (sij(il,i,j).gt.0.0) then 
            ! ajout le 4 mai 2012: initialiser au cas où
            elij(il,i,j)=0.0 
            qent_diag(il,i,j)=rr(il,i)
            do ixt=1,ntraciso
              xtent_diag(ixt,il,i,j)=xt(ixt,il,i)
            enddo !do ixt=1,ntraciso
         endif  !if(sij(il,i,j).gt.0.0)then  
        else  !if( (i.ge.icb(il)).and.(i.le.inb(il)).and.
            ! ajout le 4 mai 2012: initialiser au cas où
            elij(il,i,j)=0.0 
            qent_diag(il,i,j)=rr(il,i)
            do ixt=1,ntraciso
              xtent_diag(ixt,il,i,j)=xt(ixt,il,i)
            enddo !do ixt=1,ntraciso
        endif !if( (i.ge.icb(il)).and.(i.le.inb(il)).and.
       enddo  !do il=1,ncum 

!       write(*,*) 'cv3p_mixing 265: call condiso' 
       call condiso_liq_ice_vectall(xtent_diag(1,1,i,j),
     :           qent_diag(1,i,j),elij(1,i,j),
     :           tg_save(1,j),zfice(1),zxtice(1,1),zxtliq(1,1),ncum)
        do il=1,ncum
         do ixt = 1, ntraciso
          xtelij(ixt,il,i,j)=zxtice(ixt,il)+zxtliq(ixt,il)
         enddo !do ixt = 1, ntraciso
        enddo !do il=1,ncum


! fractionation:
!        write(*,*) 'cv3p_routine tmp 1984: cond=',elij(il,i,j)                
 710  continue
!do 710 j=minorig,nl

c
c   ***   if no air can entrain at level i assume that updraft detrains  ***
c   ***   at that level and calculate detrained air flux and properties  ***
c

c@      do 170 i=icb(il),inb(il)

      do 740 il=1,ncum
      if ((i.ge.icb(il)).and.(i.le.inb(il))
     :                  .and.(nent(il,i).eq.0)) then
c@      if(nent(il,i).eq.0)then
ccc      ment(il,i,i)=m(il,i)
      ment(il,i,i)=1.
      qent(il,i,i)=qnk(il)-ep(il,i)*clw(il,i)
      uent(il,i,i)=unk(il)
      vent(il,i,i)=vnk(il)
      elij(il,i,i)=clw(il,i)*(1.-ep(il,i))
      sij(il,i,i)=0.0

      do ixt = 1, ntraciso
       xtent(ixt,il,i,i)=xtnk(ixt,il)-ep(il,i)*xtclw(ixt,il,i)
       xtelij(ixt,il,i,i)=xtclw(ixt,il,i) ! rq: ne sera pas utilise ensuite
      enddo ! do ixt = 1, ntraciso 
! endif ISOTRAC
! endif 1        
      end if !if ((i.ge.icb(il)).and.(i.le.inb(il))
 740  continue
      
 750  continue


      do j=1,ntra
       do i=minorig+1,nl
        do il=1,ncum
         if (i.ge.icb(il) .and. i.le.inb(il)
     :                    .and. nent(il,i).eq.0) then
          traent(il,i,i,j)=tra(il,nk(il),j)
         endif
        enddo
       enddo
      enddo

      do 100 j=minorig,nl
      do 101 i=minorig,nl
      do 102 il=1,ncum
      if ((j.ge.(icb(il)-1)).and.(j.le.inb(il))
     :    .and.(i.ge.icb(il)).and.(i.le.inb(il)))then
       sigij(il,i,j)=sij(il,i,j)
      endif
 102  continue
 101  continue
 100  continue
c@      enddo

c@170   continue

c=====================================================================
c   ---  NORMALIZE ENTRAINED AIR MASS FLUXES
c   ---  TO REPRESENT EQUAL PROBABILITIES OF MIXING
c=====================================================================

      call zilch(csum,nloc*nd)

      do il=1,ncum
       lwork(il) = .FALSE.
      enddo

c---------------------------------------------------------------
      DO 789 i=minorig+1,nl     !Loop on origin level "i"
c---------------------------------------------------------------

      num1=0
      do il=1,ncum
       if ( i.ge.icb(il) .and. i.le.inb(il) ) num1=num1+1
      enddo
      if (num1.le.0) goto 789

c
cjyg1    Find maximum of SIJ for J>I, if any.
c
       Sx(:) = 0.
c
       DO il = 1,ncum
        IF ( i.ge.icb(il) .and. i.le.inb(il) ) THEN
         Signhpmh(il) = sign(1.,hp(il,i)-h(il,i))
         Sbef(il) = max(0.,signhpmh(il))
        ENDIF
       ENDDO

       DO j = i+1,nl
        DO il = 1,ncum
         IF ( i.ge.icb(il) .and. i.le.inb(il)
     :         .and. j.le.inb(il) ) THEN
          IF (Sbef(il) .LT. Sij(il,i,j)) THEN
            Sx(il) = max(Sij(il,i,j),Sx(il))
          ENDIF
          Sbef(il) = Sij(il,i,j)
         ENDIF
        ENDDO
       ENDDO
c

      do 781 il=1,ncum
       if ( i.ge.icb(il) .and. i.le.inb(il) ) then
        lwork(il)=(nent(il,i).ne.0)
        qp=qnk(il)-ep(il,i)*clw(il,i)
        anum=h(il,i)-hp(il,i)-lv(il,i)*(qp-rs(il,i))
     :           +(cpv-cpd)*t(il,i)*(qp-rr(il,i))
        denom=h(il,i)-hp(il,i)+lv(il,i)*(rr(il,i)-qp)
     :           +(cpd-cpv)*t(il,i)*(rr(il,i)-qp)
        if(abs(denom).lt.0.01)denom=0.01
        scrit(il)=min(anum/denom,1.)
        alt=qp-rs(il,i)+scrit(il)*(rr(il,i)-qp)
c
cjyg1    Find new critical value Scrit2
c        such that : Sij > Scrit2  => mixed draught will detrain at J<I
c                    Sij < Scrit2  => mixed draught will detrain at J>I
c
       Scrit2 = min(Scrit(il),Sx(il))*max(0.,-signhpmh(il))
     :         +Scrit(il)*max(0.,signhpmh(il))
c
       Scrit(il) = Scrit2
c
cjyg    Correction pour la nouvelle logique; la correction pour ALT
c       est un peu au hazard
       if(scrit(il).le.0.0)scrit(il)=0.0
       if(alt.le.0.0) scrit(il)=1.0
C
        smax(il)=0.0
        asij(il)=0.0
       Sup(il)=0.     ! upper S-value reached by descending draughts
       endif
781   continue

c---------------------------------------------------------------
      do 175 j=minorig,nl   !Loop on destination level "j"
c---------------------------------------------------------------

      num2=0
      do il=1,ncum
       if ( i.ge.icb(il) .and. i.le.inb(il) .and.
     :      j.ge.(icb(il)-1) .and. j.le.inb(il)
     :      .and. lwork(il) ) num2=num2+1
      enddo
      if (num2.le.0) goto 175

c -----------------------------------------------
         IF (j .GT. i) THEN
c -----------------------------------------------
      do 782 il=1,ncum
      if ( i.ge.icb(il) .and. i.le.inb(il) .and.
     :      j.ge.(icb(il)-1) .and. j.le.inb(il)
     :      .and. lwork(il) ) then
       if(sij(il,i,j).gt.0.0)then
           Smid(il)=min(Sij(il,i,j),Scrit(il))
           Sjmax(il)=Smid(il)
           Sjmin(il)=Smid(il)
           IF (Smid(il) .LT. Smin(il) .AND.
     1                         Sij(il,i,j+1) .LT. Smid(il)) THEN
             Smin(il)=Smid(il)
             Sjmax(il)=min( (Sij(il,i,j+1)+Sij(il,i,j))/2. ,
     1                  Sij(il,i,j) ,
     1                  Scrit(il) )
             Sjmin(il)=max( (Sbef(il)+Sij(il,i,j))/2. ,
     1                  Sij(il,i,j) )
             Sjmin(il)=min(Sjmin(il),Scrit(il))
             Sbef(il) = Sij(il,i,j)
           ENDIF
      endif
      endif
782   continue
c -----------------------------------------------
         ELSE IF (j .EQ. i) THEN
c -----------------------------------------------
      do 783 il=1,ncum
      if ( i.ge.icb(il) .and. i.le.inb(il) .and.
     :      j.ge.(icb(il)-1) .and. j.le.inb(il)
     :      .and. lwork(il) ) then
       if(sij(il,i,j).gt.0.0)then
           Smid(il) = 1.
           Sjmin(il) = max((Sij(il,i,j-1)+Smid(il))/2.,Scrit(il))
     1                                         *max(0.,-signhpmh(il))
     1            +min((Sij(il,i,j+1)+Smid(il))/2.,Scrit(il))
     1                                         *max(0., signhpmh(il))
           Sjmin(il) = max(Sjmin(il),Sup(il))
           Sjmax(il) = 1.
c
c-           preparation des variables Scrit, Smin et Sbef pour la partie j>i
           Scrit(il) = min(Sjmin(il),Sjmax(il),Scrit(il))

           Smin(il) = 1.
           Sbef(il) = max(0.,signhpmh(il))
           Supmax(il,i) = sign(Scrit(il),-signhpmh(il))
      endif
      endif
783   continue
c -----------------------------------------------
         ELSE IF ( j .LT. i) THEN
c -----------------------------------------------
      do 784 il=1,ncum
      if ( i.ge.icb(il) .and. i.le.inb(il) .and.
     :      j.ge.(icb(il)-1) .and. j.le.inb(il)
     :      .and. lwork(il) ) then
       if(sij(il,i,j).gt.0.0)then
           Smid(il)=max(Sij(il,i,j),Scrit(il))
           Sjmax(il) = Smid(il)
           Sjmin(il) = Smid(il)
           IF (Smid(il) .GT. Smax(il) .AND.
     1                          Sij(il,i,j+1) .GT. Smid(il)) THEN
             Smax(il) = Smid(il)
             Sjmax(il) = max( (Sij(il,i,j+1)+Sij(il,i,j))/2. ,
     1                                               Sij(il,i,j) )
             Sjmax(il) = max(Sjmax(il),Scrit(il))
             Sjmin(il) = min( (Sbef(il)+Sij(il,i,j))/2. ,
     1                                               Sij(il,i,j) )
             Sjmin(il) = max(Sjmin(il),Scrit(il))
             Sbef(il) = Sij(il,i,j)
           ENDIF
          IF (abs(Sjmin(il)-Sjmax(il)) .GT. 1.e-10) Sup(il)=
     1                            max(Sjmin(il),Sjmax(il),Sup(il))
      endif
      endif
784   continue
c -----------------------------------------------
         END IF
c -----------------------------------------------
c
c
      do il=1,ncum
      if ( i.ge.icb(il) .and. i.le.inb(il) .and.
     :      j.ge.(icb(il)-1) .and. j.le.inb(il)
     :      .and. lwork(il) ) then
       if(sij(il,i,j).gt.0.0)then
         rti=qnk(il)-ep(il,i)*clw(il,i)
         Qmixmax(il)=Qmix(Sjmax(il))
         Qmixmin(il)=Qmix(Sjmin(il))
         Rmixmax(il)=Rmix(Sjmax(il))
         Rmixmin(il)=Rmix(Sjmin(il))
         SQmRmax(il)= Sjmax(il)*Qmix(Sjmax(il))-Rmix(Sjmax(il))
         SQmRmin(il)= Sjmin(il)*Qmix(Sjmin(il))-Rmix(Sjmin(il))
c
         Ment(il,i,j) = abs(Qmixmax(il)-Qmixmin(il))*Ment(il,i,j)
c
c    Sigij(i,j) is the 'true' mixing fraction of mixture Ment(i,j)
         IF (abs(Qmixmax(il)-Qmixmin(il)) .GT. 1.e-10) THEN
           Sigij(il,i,j) =
     :           (SQmRmax(il)-SQmRmin(il))/(Qmixmax(il)-Qmixmin(il))
         ELSE
           Sigij(il,i,j) = 0.
         ENDIF
c
c --    Compute Qent, uent, vent according to the true mixing fraction
        Qent(il,i,j) = (1.-Sigij(il,i,j))*rti
     :               + Sigij(il,i,j)*rr(il,i)
        uent(il,i,j) = (1.-Sigij(il,i,j))*unk(il)
     :               + Sigij(il,i,j)*u(il,i)
        vent(il,i,j) = (1.-Sigij(il,i,j))*vnk(il)
     :               + Sigij(il,i,j)*v(il,i)
c
c--     Compute liquid water static energy of mixed draughts
c       IF (j .GT. i) THEN
c        awat=elij(il,i,j)-(1.-ep(il,j))*clw(il,j)
c        awat=amax1(awat,0.0)
c       ELSE
c        awat = 0.
c       ENDIF
c       Hent(il,i,j) = (1.-Sigij(il,i,j))*HP(il,i)
c    :         + Sigij(il,i,j)*H(il,i)
c    :         + (LV(il,j)+(cpd-cpv)*t(il,j))*awat
cIM 301008 beg
        Hent(il,i,j) = (1.-Sigij(il,i,j))*HP(il,i)
     :         + Sigij(il,i,j)*H(il,i)

        Elij(il,i,j) = Qent(il,i,j)-rs(il,j)
        Elij(il,i,j) = Elij(il,i,j)
     :    + ((h(il,j)-Hent(il,i,j))*rs(il,j)*LV(il,j)
     :    / ((cpd*(1.-Qent(il,i,j))+Qent(il,i,j)*cpv)
     :    * rrv*t(il,j)*t(il,j)))
        Elij(il,i,j) = Elij(il,i,j)
     :    / (1.+LV(il,j)*LV(il,j)*rs(il,j)
     :    / ((cpd*(1.-Qent(il,i,j))+Qent(il,i,j)*cpv)
     :    * rrv*t(il,j)*t(il,j)))

        Elij(il,i,j) = max(elij(il,i,j),0.)

        Elij(il,i,j) = min(elij(il,i,j),Qent(il,i,j))

        IF (j .GT. i) THEN
         awat=elij(il,i,j)-(1.-ep(il,j))*clw(il,j)
         awat=amax1(awat,0.0)
        ELSE
         awat = 0.
        ENDIF

c        print *,h(il,j)-hent(il,i,j),LV(il,j)*rs(il,j)/(cpd*rrv*t(il,j)*
c    :         t(il,j))

        Hent(il,i,j) =  Hent(il,i,j)+(LV(il,j)+(cpd-cpv)*t(il,j))
     :         * awat
cIM 301008 end
c
c      print *,'mix : i,j,hent(il,i,j),sigij(il,i,j) ',
c     :               i,j,hent(il,i,j),sigij(il,i,j)
c
c --      ASij is the integral of P(F) over the relevant F interval
         ASij(il) = ASij(il)
     1               + abs(Qmixmax(il)*(1.-Sjmax(il))+Rmixmax(il)
     1                    -Qmixmin(il)*(1.-Sjmin(il))-Rmixmin(il))
c
      endif ! if(sij(il,i,j).gt.0.0)then
      endif ! if ( i.ge.icb(il) .and. i.le.inb(il) .and.
      enddo !do il=1,ncum

              
      do il=1,ncum
          zfice(il) = 1.0-(tg_save(il,j)-pxtice)/(pxtmelt-pxtice)
          zfice(il) = MIN(MAX(zfice(il),0.0),1.0)  
       if ( i.ge.icb(il) .and. i.le.inb(il) .and.
     :      j.ge.(icb(il)-1) .and. j.le.inb(il)
     :      .and. lwork(il) ) then
        if(sij(il,i,j).gt.0.0)then

          do ixt=1,ntraciso           
            xtrti(ixt)=xtnk(ixt,il)-ep(il,i)*xtclw(ixt,il,i)         
            xtent(ixt,il,i,j) = (1.-Sigij(il,i,j))*xtrti(ixt)
     :               + Sigij(il,i,j)*xt(ixt,il,i)
          enddo !do ixt = 1, ntraciso      
         endif  !if(sij(il,i,j).gt.0.0)then  
        endif !if( (i.ge.icb(il)).and.(i.le.inb(il)).and.
       enddo  !do il=1,ncum
   
      
       call condiso_liq_ice_vectall(xtent(1,1,i,j),qent(1,i,j),
     :           elij(1,i,j),
     :           tg_save(1,j),zfice(1),zxtice(1,1),zxtliq(1,1),ncum)
        do il=1,ncum
        if ( i.ge.icb(il) .and. i.le.inb(il) .and.
     :      j.ge.(icb(il)-1) .and. j.le.inb(il)
     :      .and. lwork(il) ) then
        if(sij(il,i,j).gt.0.0)then
         do ixt = 1, ntraciso
          xtelij(ixt,il,i,j)=zxtice(ixt,il)+zxtliq(ixt,il)
         enddo !do ixt = 1, ntraciso
        endif !if(sij(il,i,j).gt.0.0)then
        endif !if ( i.ge.icb(il) .and. i.le.inb(il) .and.
        enddo !do il=1,ncum

!#ifdef ISOVERIF  

! endif ISOTRAC

!!#ifdef 1
        
       do k=1,ntra
         do il=1,ncum
          if( (i.ge.icb(il)).and.(i.le.inb(il)).and.
     :       (j.ge.(icb(il)-1)).and.(j.le.inb(il))
     :      .and. lwork(il) ) then
          if(sij(il,i,j).gt.0.0)then
            traent(il,i,j,k)=sigij(il,i,j)*tra(il,i,k)
     :            +(1.-sigij(il,i,j))*tra(il,nk(il),k)
          endif
          endif
         enddo
       enddo
c
c --    If I=J (detrainement and entrainement at the same level), then only the
c --    adiabatic ascent part of the mixture is considered
        IF (I .EQ. J) THEN
      do il=1,ncum
      if ( i.ge.icb(il) .and. i.le.inb(il) .and.
     :      j.ge.(icb(il)-1) .and. j.le.inb(il)
     :      .and. lwork(il) ) then
       if(sij(il,i,j).gt.0.0)then
          rti=qnk(il)-ep(il,i)*clw(il,i)
ccc          Ment(il,i,i) = m(il,i)*abs(Qmixmax(il)*(1.-Sjmax(il))
          Ment(il,i,i) = abs(Qmixmax(il)*(1.-Sjmax(il))
     1                    +Rmixmax(il)
     1                    -Qmixmin(il)*(1.-Sjmin(il))-Rmixmin(il))
          Qent(il,i,i) = rti
          uent(il,i,i) = unk(il)
          vent(il,i,i) = vnk(il)
          Hent(il,i,i) = hp(il,i)
          Elij(il,i,i) = clw(il,i)*(1.-ep(il,i))
          Sigij(il,i,i) = 0.
      endif !if(sij(il,i,j).gt.0.0)then
      endif ! if ( i.ge.icb(il) .and. i.le.inb(il) .and.
      enddo !IF (I .EQ. J) THEN

      IF (I .EQ. J) THEN
      do il=1,ncum
          zfice(il) = 1.0-(tg_save(il,j)-pxtice)/(pxtmelt-pxtice)
          zfice(il) = MIN(MAX(zfice(il),0.0),1.0)  
       if ( i.ge.icb(il) .and. i.le.inb(il) .and.
     :      j.ge.(icb(il)-1) .and. j.le.inb(il)
     :      .and. lwork(il) ) then
        if(sij(il,i,j).gt.0.0)then
          do ixt=1,ntraciso           
            xtrti(ixt)=xtnk(ixt,il)-ep(il,i)*xtclw(ixt,il,i)         
            xtent(ixt,il,i,j) = xtrti(ixt)
          enddo !do ixt = 1, ntraciso
         endif  !if(sij(il,i,j).gt.0.0)then  
        endif !if( (i.ge.icb(il)).and.(i.le.inb(il)).and.
       enddo  !do il=1,ncum
      
!       write(*,*) 'cv3p_mixing 808: call condiso'
       call condiso_liq_ice_vectall(xtent(1,1,i,j),qent(1,i,j),
     :           elij(1,i,j),
     :           tg_save(1,j),zfice(1),zxtice(1,1),zxtliq(1,1),ncum)

       do il=1,ncum
         do ixt = 1, ntraciso
          xtelij(ixt,il,i,j)=zxtice(ixt,il)+zxtliq(ixt,il)
         enddo !do ixt = 1, ntraciso
        enddo !do il=1,ncum
        
!#ifdef ISOTRAC        
!#ifdef ISOVERIF           
        endif !IF (I .EQ. J) THEN
!#ifdef 1        

       do k=1,ntra
         do il=1,ncum
          if( (i.ge.icb(il)).and.(i.le.inb(il)).and.
     :       (j.ge.(icb(il)-1)).and.(j.le.inb(il))
     :      .and. lwork(il) ) then
          if(sij(il,i,j).gt.0.0)then
            traent(il,i,i,k)=tra(il,nk(il),k)
          endif
          endif
         enddo
       enddo
c
        ENDIF
c
175   continue

      do il=1,ncum
       if (i.ge.icb(il).and.i.le.inb(il).and.lwork(il)) then
        asij(il)=amax1(1.0e-16,asij(il))
        asij(il)=1.0/asij(il)
        csum(il,i)=0.0
       endif
      enddo

      do 180 j=minorig,nl
       do il=1,ncum
        if ( i.ge.icb(il) .and. i.le.inb(il) .and. lwork(il)
     :   .and. j.ge.(icb(il)-1) .and. j.le.inb(il) ) then
         ment(il,i,j)=ment(il,i,j)*asij(il)
        endif
       enddo
180   continue

      do 197 j=minorig,nl
       do il=1,ncum
        if ( i.ge.icb(il) .and. i.le.inb(il) .and. lwork(il)
     :   .and. j.ge.(icb(il)-1) .and. j.le.inb(il) ) then
         csum(il,i)=csum(il,i)+ment(il,i,j)
        endif
       enddo
197   continue

      do il=1,ncum
       if ( i.ge.icb(il) .and. i.le.inb(il) .and. lwork(il)
     :     .and. csum(il,i).lt.1. ) then
ccc     :     .and. csum(il,i).lt.m(il,i) ) then
        nent(il,i)=0
ccc        ment(il,i,i)=m(il,i)
        ment(il,i,i)=1.
        qent(il,i,i)=qnk(il)-ep(il,i)*clw(il,i)
        uent(il,i,i)=unk(il)
        vent(il,i,i)=vnk(il)
        elij(il,i,i)=clw(il,i)*(1.-ep(il,i))
        sij(il,i,i)=0.0
      do ixt = 1, ntraciso
        xtent(ixt,il,i,i)=xtnk(ixt,il)-ep(il,i)*xtclw(ixt,il,i)
        xtelij(ixt,il,i,i)=xtclw(ixt,il,i)*(1.-ep(il,i))
      enddo

       endif
      enddo ! il

      do j=1,ntra
       do il=1,ncum
        if ( i.ge.icb(il) .and. i.le.inb(il) .and. lwork(il)
     :     .and. csum(il,i).lt.1. ) then
ccc     :     .and. csum(il,i).lt.m(il,i) ) then
         traent(il,i,i,j)=tra(il,nk(il),j)
        endif
       enddo
      enddo
c
789   continue


c
      return
      end

