!
! $Id: hgardfou.F 1664 2012-10-09 13:29:15Z fairhead $
      SUBROUTINE hgardfou (t,tsol,text)
      use dimphy
      use phys_state_var_mod
      IMPLICIT none
c======================================================================
c Verifier la temperature
c======================================================================
!-----------------------------------------------------------------------
!   INCLUDE 'dimensions.h'
!
!   dimensions.h contient les dimensions du modele
!   ndm est tel que iim=2**ndm
!-----------------------------------------------------------------------

      INTEGER iim,jjm,llm,ndm

      PARAMETER (iim= 96,jjm=71,llm=39,ndm=1)

!-----------------------------------------------------------------------
!
! $Header$
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation
!                 (les placer en colonne 6 et en colonne 73)
!
!
! A1.0 Fundamental constants
      REAL RPI,RCLUM,RHPLA,RKBOL,RNAVO
! A1.1 Astronomical constants
      REAL RDAY,REA,REPSM,RSIYEA,RSIDAY,ROMEGA
! A1.1.bis Constantes concernant l'orbite de la Terre:
      REAL R_ecc, R_peri, R_incl
! A1.2 Geoide
      REAL RA,RG,R1SA
! A1.3 Radiation
!     REAL RSIGMA,RI0
      REAL RSIGMA
! A1.4 Thermodynamic gas phase
      REAL R,RMD,RMO3,RMV,RD,RV,RCPD,RCPV,RCVD,RCVV
      REAL RKAPPA,RETV
! A1.5,6 Thermodynamic liquid,solid phases
      REAL RCW,RCS
! A1.7 Thermodynamic transition of phase
      REAL RLVTT,RLSTT,RLMLT,RTT,RATM
! A1.8 Curve of saturation
      REAL RESTT,RALPW,RBETW,RGAMW,RALPS,RBETS,RGAMS
      REAL RALPD,RBETD,RGAMD
!
      COMMON/YOMCST/RPI   ,RCLUM ,RHPLA ,RKBOL ,RNAVO                   &
     &      ,RDAY  ,REA   ,REPSM ,RSIYEA,RSIDAY,ROMEGA                  &
     &      ,R_ecc, R_peri, R_incl                                      &
     &      ,RA    ,RG    ,R1SA                                         &
     &      ,RSIGMA                                                     &
     &      ,R     ,RMD   ,RMO3  ,RMV   ,RD    ,RV    ,RCPD             &
     &      ,RCPV  ,RCVD  ,RCVV  ,RKAPPA,RETV                           &
     &      ,RCW   ,RCS                                                 &
     &      ,RLVTT ,RLSTT ,RLMLT ,RTT   ,RATM                           &
     &      ,RESTT ,RALPW ,RBETW ,RGAMW ,RALPS ,RBETS ,RGAMS            &
     &      ,RALPD ,RBETD ,RGAMD
!    ------------------------------------------------------------------
!$OMP THREADPRIVATE(/YOMCST/)
!
! $Header$
!
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation
!                 (les placer en colonne 6 et en colonne 73)
!
!
      INTEGER nbsrf
      PARAMETER (nbsrf=4) ! nombre de sous-fractions pour une maille
!
      INTEGER is_oce
      PARAMETER (is_oce=3) ! ocean
      INTEGER is_sic
      PARAMETER (is_sic=4) ! glace de mer
      INTEGER is_ter
      PARAMETER (is_ter=1) ! terre
      INTEGER is_lic
      PARAMETER (is_lic=2) ! glacier continental
!
      REAL epsfra
      PARAMETER (epsfra=1.0E-05)
!
      CHARACTER(len=3) clnsurf(nbsrf)
      DATA clnsurf/'ter', 'lic', 'oce', 'sic'/
      SAVE clnsurf
!$OMP THREADPRIVATE(clnsurf)
!
! $Header$
!
!
! gestion des impressions de sorties et de dbogage
! lunout:    unit du fichier dans lequel se font les sorties 
!                           (par defaut 6, la sortie standard)
! prt_level: niveau d'impression souhait (0 = minimum)
!
      INTEGER lunout, prt_level
      COMMON /comprint/ lunout, prt_level
      REAL t(klon,klev), tsol(klon,nbsrf)
      CHARACTER*(*) text
      character (len=20) :: modname = 'hgardfou'
      character (len=80) :: abort_message
C
      INTEGER i, k, nsrf
      REAL zt(klon)
      INTEGER jadrs(klon), jbad
      LOGICAL ok
c
      LOGICAL firstcall
      SAVE firstcall
      DATA firstcall /.TRUE./
c$OMP THREADPRIVATE(firstcall)

      IF (firstcall) THEN
         WRITE(lunout,*) 
     $  'hgardfou garantit la temperature dans [100,370] K'
         firstcall = .FALSE.
c        DO i = 1, klon
c         WRITE(lunout,*)'i=',i,'rlon=',rlon(i),'rlat=',rlat(i)
c        ENDDO
c
      ENDIF
c
      ok = .TRUE.
      DO k = 1, klev
         DO i = 1, klon
            zt(i) = t(i,k)
         ENDDO
         jbad = 0
         DO i = 1, klon
         IF (zt(i) > 370.) THEN
            jbad = jbad + 1
            jadrs(jbad) = i
         ENDIF
         ENDDO
         IF (jbad .GT. 0) THEN
           ok = .FALSE.
           DO i = 1, jbad
             WRITE(lunout,*)
     $       'i,k,temperature,lon,lat,pourc ter,oce,lic,sic =',
     $       jadrs(i),k,zt(jadrs(i)),rlon(jadrs(i)),rlat(jadrs(i)),
     $       (pctsrf(jadrs(i),nsrf),nsrf=1,nbsrf)
           ENDDO
         ENDIF
         jbad = 0
         DO i = 1, klon
!         IF (zt(i).LT.100.0) THEN
         IF (zt(i).LT.50.0) THEN
            jbad = jbad + 1
            jadrs(jbad) = i
         ENDIF
         ENDDO
         IF (jbad .GT. 0) THEN
           ok = .FALSE.
           DO i = 1, jbad
             WRITE(lunout,*)
     $       'i,k,temperature,lon,lat,pourc ter,oce,lic,sic =',
     $       jadrs(i),k,zt(jadrs(i)),rlon(jadrs(i)),rlat(jadrs(i)),
     $       (pctsrf(jadrs(i),nsrf),nsrf=1,nbsrf)
           ENDDO
         ENDIF
      ENDDO
c
      DO nsrf = 1, nbsrf
         DO i = 1, klon
            zt(i) = tsol(i,nsrf)
         ENDDO
         jbad = 0
         DO i = 1, klon
         IF (zt(i).GT.370.0) THEN
            jbad = jbad + 1
            jadrs(jbad) = i
         ENDIF
         ENDDO
         IF (jbad .GT. 0) THEN
           ok = .FALSE.
           DO i = 1, jbad
            WRITE(lunout,*) 
     $      'i,nsrf,temperature,lon,lat,pourc ter,oce,lic,sic ='
     $      ,jadrs(i),nsrf,zt(jadrs(i)),rlon(jadrs(i)),rlat(jadrs(i))
     $      ,pctsrf(jadrs(i),nsrf)
           ENDDO
         ENDIF
         jbad = 0
         DO i = 1, klon
!         IF (zt(i).LT.100.0) THEN
         IF (zt(i).LT.50.0) THEN
            jbad = jbad + 1
            jadrs(jbad) = i
         ENDIF
         ENDDO
         IF (jbad .GT. 0) THEN
           ok = .FALSE.
           DO i = 1, jbad
            WRITE(lunout,*) 
     $      'i,nsrf,temperature,lon,lat,pourc ter,oce,lic,sic ='
     $      ,jadrs(i),nsrf,zt(jadrs(i)),rlon(jadrs(i)),rlat(jadrs(i))
     $      ,pctsrf(jadrs(i),nsrf)
           ENDDO
         ENDIF
      ENDDO
c
      IF (.NOT. ok) THEN
         abort_message= 'hgardfou s arrete '//text
         CALL abort_gcm (modname,abort_message,1)
      ENDIF

      RETURN
      END
