        subroutine integrale_Rieman_precision(binf,bsup,I,e,ntot
     :          ,qp0,A,m0,beta,gama,f0,g0) 
        implicit none


        ! calcul d'intgral par mthode de monte carlo.
        ! ***declarations: 
        
        ! **inputs:
        double precision binf,bsup ! bornes
        integer ntot ! nbre de bins
        double precision qp0
        double precision A,m0,beta,gama,f0,g0 
                ! arguments de la fonction  intgrer
        
        ! ** output
        double precision I ! integrale
        double precision e ! erreur
        
        ! **locals
        integer j
        double precision dxj, xj
        double precision Imin, Imax

        double precision func_precision


         ! verifs
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      
        
        ! *** verifs
        
        if (bsup.lt.binf) then
            write(*,*) 'integrale_rieman 25'
            write(*,*) 'binf=',binf,' bsup=',bsup
            stop
        endif

!        write(*,*) 'binf=',binf,' bsup=',bsup
!        write(*,*) 'A=',A
!        write(*,*) 'm0=',m0
!        write(*,*) 'beta=',beta
!        write(*,*) 'gama=',gama
!        write(*,*) 'qp0=',qp0
        
        !*** calculs
        
        I=0
        dxj=(bsup-binf)/ntot
!        write(*,*) 'bsup-binf=',bsup-binf
!        write(*,*) 'ntot=',ntot
        do j=2,ntot
          xj=binf+(j-1)*dxj
!          write(*,*) 'xj=',xj
           ! in-lining:
           I=I+dxj*((((qp0-A*(xj-m0))/qp0)/g0)**(beta*gama-1))
     :            *(((xj/m0)/f0)**(-beta-1))  
!#ifdef ISOVERIF        
!        if (abs(gama-1).lt.errmax) then           
!           write(*,*) 'rieman tmp 60: func=',
!     :           ((((qp0-A*(xj-m0))/qp0)/g0)**(beta*gama-1))
!     :            *(((xj/m0)/f0)**(-beta-1))
!        endif
!#endif                 
!          
       enddo
!       write(*,*) 'fin boucle'
       ! integrale avec valeur au dbut de l'intervalle
       xj=binf
           Imin=I+dxj*((((qp0-A*(xj-m0))/qp0)/g0)**(beta*gama-1))
     :            *(((xj/m0)/f0)**(-beta-1))
!#ifdef ISOVERIF        
!        if (abs(gama-1).lt.errmax) then           
!           write(*,*) 'rieman tmp 60: func,Imin=',
!     :           ((((qp0-A*(xj-m0))/qp0)/g0)**(beta*gama-1))
!     :            *(((xj/m0)/f0)**(-beta-1)),Imin
!           endif
!#endif
       ! integrale avec valeur en fin d'intervalle
       xj=bsup
           Imax=I+dxj*((((qp0-A*(xj-m0))/qp0)/g0)**(beta*gama-1))
     :            *(((xj/m0)/f0)**(-beta-1))
!#ifdef ISOVERIF        
!        if (abs(gama-1).lt.errmax) then           
!           write(*,*) 'rieman tmp 76: func,Imax=',
!     :           ((((qp0-A*(xj-m0))/qp0)/g0)**(beta*gama-1))
!     :            *(((xj/m0)/f0)**(-beta-1)),Imax
!           endif
!#endif

       e=abs(Imax-Imin)
       I=(Imin+Imax)/2
!       write(*,*) 'rieman tmp 86: I=',I
       

       ! verif
       if ((I.gt.-ridicule).and.(I.lt.borne)) then
       else
           write(*,*) 'I=',I,' e=',e
           write(*,*) 'Imin=',Imin,' Imax=',Imax
           write(*,*) 'qp0=',qp0,' A=',A,' m0=',m0
           write(*,*) 'beta=',beta,' gama=',gama
           write(*,*) 'binf=',binf,' bsup=',bsup
       endif
       ! end verif
            
!       write(*,*) 'I=',I
!       write(*,*) 'Imax=',Imax,'Imin=',Imin
!       write(*,*) 'e=',e

       return
       end
           
        
        
