
      subroutine integrale_gauss_vectall(ncas,m,I,
!     :          qp0,A,m0,beta,gama,g0,ntot) 
     :          qp0,A,m0,beta,gama,g0)  
        implicit none

        ! version vectorise en ncas. La vesrion _bak23fev2008 tait
        ! vectorise en ntot

        ! calcul d'intgral par mthode de gauss
        ! on vectorise sur toutes les intgrales  calculer
        ! ***declarations: 
!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl

        ! **inputs:
        integer ncas
        ! arguments de la fonction  intgrer:
        double precision qp0(ncas)
        double precision A(ncas),m(ncas),m0(ncas),beta(niso,ncas),
     :           gama(niso,ncas),f0(ncas),g0(ncas) 
!        integer ntot(ncas) 
!        integer ntot
!        parameter (ntot=40)        
        
        ! ** output
        double precision I(niso,ncas) ! integrale
        
        ! **locals
        ! ! nombre max d'itration dans integrale rieman
        integer j
        integer il,ixt,k
        double precision dxj(ncas)
        integer ndeg ! degrs du polynome de Legendre 
        parameter (ndeg=5)   
        double precision w(ndeg),z(ndeg)
        real fj
            
!        double precision xj        

         ! verifs
        
        ! *** verifs
!        write(*,*) 'ntot=',ntot
        

!        write(*,*) 'binf=',binf,' bsup=',bsup
        
        !*** calculs

        if (ndeg.eq.1) then
           z(1)=0.0
           w(1)=2.0
         else if (ndeg.eq.2) then
           z(1)=-0.577350269189
           z(2)=0.577350269189
           w(1)=1.0
           w(2)=1.0
        else if (ndeg.eq.3) then
           z(1)=-0.774596669241
           z(2)=0.0
           z(3)=0.774596669241
           w(1)=0.5555555555555
           w(2)=0.8888888888888
           w(3)=0.5555555555555
        else if (ndeg.eq.4) then
           z(1)=-0.861136311594
           z(2)=-0.3399810435848
           z(3)=0.3399810435848
           z(4)=0.861136311594
           w(1)=0.34785484513745
           w(2)=0.6521451548625 
           w(3)=0.6521451548625
           w(4)=0.34785484513745 
        else if (ndeg.eq.5) then
           z(1)=-0.90617984593866399280
           z(2)=-0.53846931010568309104
           z(3)=0.0
           z(4)=0.53846931010568309104
           z(5)=0.90617984593866399280
           w(1)=0.23692688505618908751
           w(2)=0.47862867049936646804 
           w(3)=0.568888888888888888889
           w(4)=0.47862867049936646804
           w(5)=0.23692688505618908751
        else
            write(*,*) 'integrale gauss: non prvu: ndeg=',ndeg
            stop
        endif  
        
        do il=1,ncas
!          dxj(il)=(m0(il)-m(il))/float(ntot(il))
          dxj(il)=(m0(il)-m(il))/float(ntot)
          do ixt=1,niso
            I(ixt,il)=0.0
          enddo
        enddo !do il=1,ncas   
        
        do j=1,ntot
          fj=float(j)
          do il=1,ncas      
            do ixt=1,niso
!                I(ixt,il)=I(ixt,il)
!     :            +w(k)*(
!     :                   ((((qp0(il)-A(il)
!     :           *((m(il)+0.5*(z(k)+2*float(j)-1.0)*dxj(il))-m0(il)))
!     :           /qp0(il))/g0(il))
!     :           **(beta(ixt,il)*gama(ixt,il)-1))
!     :           *((((m(il)+0.5*(z(k)+2*float(j)-1.0)*dxj(il))/m(il)))
!     :           **(-beta(ixt,il)-1))  ) 
              I(ixt,il)=I(ixt,il)+w(1)*(
     :                   ((((qp0(il)-A(il)
     :           *((m(il)+0.5*(z(1)+2*fj-1.0)*dxj(il))-m0(il)))
     :           /qp0(il))/g0(il))
     :           **(beta(ixt,il)*gama(ixt,il)-1))
     :           *((((m(il)+0.5*(z(1)+2*fj-1.0)*dxj(il))/m(il)))
     :           **(-beta(ixt,il)-1))  )
     :         +w(2)*(
     :                   ((((qp0(il)-A(il)
     :           *((m(il)+0.5*(z(2)+2*fj-1.0)*dxj(il))-m0(il)))
     :           /qp0(il))/g0(il))
     :           **(beta(ixt,il)*gama(ixt,il)-1))
     :           *((((m(il)+0.5*(z(2)+2*fj-1.0)*dxj(il))/m(il)))
     :           **(-beta(ixt,il)-1))  )
     :         +w(3)*(
     :                   ((((qp0(il)-A(il)
     :           *((m(il)+0.5*(z(3)+2*fj-1.0)*dxj(il))-m0(il)))
     :           /qp0(il))/g0(il))
     :           **(beta(ixt,il)*gama(ixt,il)-1))
     :           *((((m(il)+0.5*(z(3)+2*fj-1.0)*dxj(il))/m(il)))
     :           **(-beta(ixt,il)-1))  )
     :         +w(4)*(
     :                   ((((qp0(il)-A(il)
     :           *((m(il)+0.5*(z(4)+2*fj-1.0)*dxj(il))-m0(il)))
     :           /qp0(il))/g0(il))
     :           **(beta(ixt,il)*gama(ixt,il)-1))
     :           *((((m(il)+0.5*(z(4)+2*fj-1.0)*dxj(il))/m(il)))
     :           **(-beta(ixt,il)-1))  )
     :         +w(5)*(
     :                   ((((qp0(il)-A(il)
     :           *((m(il)+0.5*(z(5)+2*fj-1.0)*dxj(il))-m0(il)))
     :           /qp0(il))/g0(il))
     :           **(beta(ixt,il)*gama(ixt,il)-1))
     :           *((((m(il)+0.5*(z(5)+2*fj-1.0)*dxj(il))/m(il)))
     :           **(-beta(ixt,il)-1))  )
            enddo  !do ixt=1,niso
!           enddo !do k=1,ndeg   
          enddo !do j=2,ntot(il)
        enddo
        
       ! integrale avec valeur au dbut de l'intervalle (en m)
       do il=1,ncas
        do ixt=1,niso
           I(ixt,il)=I(ixt,il)*0.5*dxj(il)
         enddo !do ixt=1,niso
       enddo !do il=1,ncas 

       ! verif
       ! end verif
            
!       write(*,*) 'I=',I
!       write(*,*) 'Imax=',Imax,'Imin=',Imin
!       write(*,*) 'e=',e

       return
       end
           
        
