        subroutine iso_evap_sol_nu(qsol0,qevap,q10,Rsol0,R1,h,T,alphak,
     :    L, xtnu,Pveg)
      implicit none

      ! calcul de Rsol et Revap lors de l'vaporation de l'eau du sol
      ! par vap nue.

!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      
      ! inputs:
      real qsol0 ! eau du sol
      real qevap  ! eau perdue par le sol
      real Rsol0(niso) ! rapport iso initial dans sol
      real R1(niso) ! rapport iso dans couche 1, suppos constant
      real q10 ! humidit 1re couche, en mm
      real h ! humidit rel dans couche 1, suppose cosntante
      real T ! temprature
      real alphak(niso) ! coef cintique
      real L ! longueur de diffusion
      real Pveg ! just pour dbguage

      ! outputs!
      real xtnu(niso) !  flux iso dans l'vap
      
      ! locals
      real f ! fraction d'eau rsiduelle dans le sol   
      real interm(niso)        
      real betaprime(niso) ! beta de stewart75
      real gama(niso) ! le gama de Stewart75
      real zxtalphal(niso), zxtalphai(niso) ! coeffs frac
      integer ixt

      ! calcul de l'vap: ordre 1 (on prend l'vap en t0) ou bilan total
      ! (on prend l'vap tel que la 1re couche se mette  l'quilibre
      integer ordre1 ! 1: ordre 1: deltaDevap= si deltaDvap ne change pas
                     ! 2: deltaDvap change
      parameter (ordre1=2)

      
      ! ca ne marche que si dj de l'eau dans le sol au dpart
      if (qsol0.lt.ridicule_qsol) then
          do ixt=1,niso
             xtnu(ixt)=Rsol0(ixt)*qevap
          enddo
          return
      endif !if (qsol0.lt.ridicule_qsol) then

      ! vrif des rapports isotopiques en entre

      ! calcul de la fraction rsiduelle de liq dans sol
      ! cas gnral: f=(L-qevap)/L
      ! cas si qevap>L: f=0
      ! cas si qsol0<L -> f=(qsol0-qevap)/qsol0
        f=max((min(L,qsol0)-qevap)/min(L,qsol0),0.0)


      if (f.lt.ridicule) then
          ! il ne reste plus rien aprs l'vap
          ! -> evap sans frac  
          do ixt=1,niso
            xtnu(ixt)=qevap*Rsol0(ixt) 
          enddo

      else !if (f.lt.ridicule) then

      ! 2 e cas simple: h=1
      if (h.gt.0.99) then
          do ixt=1,niso
            call fractcalk(ixt,T,zxtalphal(ixt),zxtalphai(ixt))
          enddo ! do ixt=1,niso
          if (qevap.gt.min(L,qsol0)) then
              ! vap trop rapide pour fractionner
             do ixt=1,niso
               xtnu(ixt)=qevap*Rsol0(ixt) 
             enddo ! do ixt=1,niso
          else if (qsol0.lt.L) then
              ! il ne reste plus beaucou d'eau, tout diffuse
             
             ! cas simple o q10>>qevap
             if (ordre1.eq.1) then
               do ixt=1,niso
                 xtnu(ixt)=qsol0*(Rsol0(ixt)-zxtalphal(ixt)*R1(ixt))
     :          +qevap*zxtalphal(ixt)*R1(ixt)
               enddo ! do ixt=1,niso
             else !if (ordre1.eq.1) then
               ! cas gnral
               do ixt=1,niso
               xtnu(ixt)=(qsol0*q10*(Rsol0(ixt)-zxtalphal(ixt)*R1(ixt))
     :           +qevap*(qsol0*Rsol0(ixt)+zxtalphal(ixt)*q10*R1(ixt)))
     :           /(q10+qevap+(qsol0-qevap)*zxtalphal(ixt))
               enddo ! do ixt=1,niso
             endif !if (ordre1.eq.1) then
             
          else !if (qevap.gt.min(L,qsol0)) then
              ! vaporation non totale et plus d'eau que dans couche de
              ! diffusion                                  
             ! cas simple o q10>>qevap
             if (ordre1.eq.1) then
               do ixt=1,niso
                xtnu(ixt)=L*(Rsol0(ixt)-zxtalphal(ixt)*R1(ixt))
     :          +qevap*zxtalphal(ixt)*R1(ixt)
               enddo ! do ixt=1,niso
              else !if (ordre1.eq.1) then
                ! cas gnral
                do ixt=1,niso
                  xtnu(ixt)=(L*q10*(Rsol0(ixt)-zxtalphal(ixt)*R1(ixt))
     :           +qevap*(L*Rsol0(ixt)+zxtalphal(ixt)*q10*R1(ixt)))
     :           /(q10+qevap+(L-qevap)*zxtalphal(ixt))
                enddo ! do ixt=1,niso
              endif !if (ordre1.eq.1) then
          endif !if (qevap.gt.min(L,qsol0)) then
          
          


      ! 3 e cas limite : f=1
      else !if (h.gt.0.99) then

      if (f.gt.0.95) then
          do ixt=1,niso
            call fractcalk(ixt,T,zxtalphal(ixt),zxtalphai(ixt))
            interm(ixt)=zxtalphal(ixt)*alphak(ixt)*(1-h)          
            betaprime(ixt)=(1.0-interm(ixt))/interm(ixt)  
            gama(ixt)=zxtalphal(ixt)*h/(1.0-interm(ixt))
!            Rsol(ixt)=(Rsol0(ixt)-gama(ixt)*R1(ixt))
!     :           *f**(betaprime(ixt))+gama(ixt)*R1(ixt)
!          Revap(ixt)=(1+betaprime(ixt))*Rsol0(ixt)
!     :           -betaprime(ixt)*gama(ixt)*R1(ixt) ! 1er ordre
!!     :          +(1-f)*(-Rsol0(ixt)*(1+betaprime(ixt))*0.5 ! 2e ordre
!!     :             +betaprime(ixt)*(0.5+gama(ixt)*R1(ixt))) ! 2e ordre 
          ! 2e ordre conserve mal la masse -> ne pas utiliser
           xtnu(ixt)= qevap*((Rsol0(ixt)/zxtalphal(ixt)-h*R1(ixt) )
     :       /alphak(ixt)/(1-h)) ! =Revap0 <=>1er ordre               
          enddo !do ixt=1,niso

      else !if (f.gt.0.90) then

      ! 4e cas simple: si h=0
      if (h.lt.0.01) then
        do ixt=1,niso
          call fractcalk(ixt,T,zxtalphal(ixt),zxtalphai(ixt))
        enddo  
        do ixt=1,niso
          betaprime(ixt)=1.0/alphak(ixt)/zxtalphal(ixt)-1.0
          xtnu(ixt)=qevap*Rsol0(ixt)*(1-f**(1+betaprime(ixt)))/(1.0-f)  
        enddo !do ixt=1,niso
        

      else !if (h.lt.0.01) then     

      ! cas gnral
      do ixt=1,niso
        call fractcalk(ixt,T,zxtalphal(ixt),zxtalphai(ixt))
        interm(ixt)=zxtalphal(ixt)*alphak(ixt)*(1.0-h)
        betaprime(ixt)=((1.0-interm(ixt))/interm(ixt))      
        gama(ixt)=zxtalphal(ixt)*h/(1.0-interm(ixt))
        xtnu(ixt)=qevap*(Rsol0(ixt)*(1.0-f**(1.0+betaprime(ixt)))
     :           -f*gama(ixt)*R1(ixt)*(1.0-f**betaprime(ixt)))/(1.0-f)
      enddo !do ixt=1,niso
      
       endif !if (h.lt.0.01) then
       endif ! if f>0.9
       endif ! if h>0.99
       endif !if (f.lt.ridicule) then



      return
      end


