
! subroutines traitant l'vaporation en surface

      subroutine calcul_kcin(Vsurf,KCIN)
        implicit none
      ! calcul de kcin en fonction de Vsurf

!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
      ! input:
      real Vsurf ! vent de surface
      ! output:
      real kcin(niso) ! coef cin
      ! locals      
      integer ixt ! numro d'isotope

      
      IF ( VSURF .LT. tv0cin ) THEN
          do ixt=1,niso
              KCIN(IXT) = tkcin0(IXT)
          enddo    
      ELSE
          do ixt=1,niso
              KCIN(IXT) = tkcin1(IXT)*VSURF + tkcin2(IXT)
          enddo    
      ENDIF
      

      return
      end

      !*****************

!      subroutine iso_evap_sol(qsol0,qevap,Pveg,Rsol0,R1,h,T,alphak,
!     :    Rsol,Revap)
!      implicit none
!
!      ! calcul de Rsol et Revap lors de l'vaporation de l'eau du sol
!      ! par un mlange de transpitration et d'vap nue.

!      ! cette subroutine n'est plus utilise, ou prfre
!      ! iso_evap_sol_nu.
!
!#include "wateriso2.h"
!#include "iso_verif.h"
!      ! inputs:
!      real qsol0 ! eau du sol
!      real qevap  ! eau perdue par le sol
!      real Pveg ! fraction de l'vap sans fractionnement: soit par transpiration, soit par sublimation
!      real Rsol0(niso) ! rapport iso initial dans sol
!      real R1(niso) ! rapport iso dans couche 1, suppos constant
!      real h ! humidit rel dans couche 1, suppose cosntante
!      real T ! temprature
!      real alphak(niso) ! coef cintique
!
!      ! outputs!
!      real Rsol(niso) ! rapport iso dans sol aprs l'vap
!      real Revap(niso) ! rapport iso dans flux d'vap
!      
!      ! locals
!      real f ! fraction d'eau rsiduelle dans le sol   
!      real interm(niso)        
!      real betaprime(niso) ! beta*(1-Pveg) avec beta le beta de stewart75
!      real gama(niso) ! le gama de Stewart75
!      real zxtalphal(niso), zxtalphai(niso) ! coeffs frac
!      integer ixt
!      
!      ! ca ne marche que si dj de l'eau dans le sol au dpart
!      if (qsol0.lt.ridicule_qsol) then
!          do ixt=1,niso
!             Rsol(ixt)=Rsol0(ixt)
!             Revap(ixt)=Rsol0(ixt)
!          enddo
!#ifdef ISOVERIF
!            if (use_iso_HDO.eq.1) then
!!                write(*,*) 'iso_surf 66: deltaDsol(iso_HDO)=',         
!!     :           (Rsol(iso_HDO)/tnat(iso_HDO)-1)*1000
!!                write(*,*) 'deltaDevap(iso_HDO)=',(Revap(iso_HDO)/
!!     :           tnat(iso_HDO)-1)*1000
!            endif !if (use_iso_HDO.eq.1) then
!#endif
!          return
!      endif !if (qsol0.lt.ridicule_qsol) then
!
!      ! vrif des rapports isotopiques en entre
!#ifdef ISOVERIF
!        if (use_iso_eau.eq.1) then
!          call iso_verif_egalite_choix(Rsol0(iso_eau),1.0,
!     :           'iso_surf 83',errmax,errmaxrel)
!          call iso_verif_egalite_choix(R1(iso_eau),1.0,
!     :           'iso_surf 56',errmax,errmaxrel)
!        endif !if (use_iso_eau.eq.1) then
!        if (use_iso_HDO.eq.1) then     
!          call iso_verif_aberrant(Rsol0(iso_HDO),'iso_surf 58')
!          if (h.gt.0.01) then
!             call iso_verif_aberrant(R1(iso_HDO),'iso_surf 59')
!          endif !if (h.gt.0.01) then
!        endif  !if (use_iso_HDO.eq.1) then  
!#endif
!
!      
!      f=(qsol0-qevap)/qsol0
!
!      ! premier cas simple: tout est transpir
!      if (Pveg.gt.0.99) then
!          ! on suppose que tout est transpire
!          do ixt=1,niso
!           Rsol(ixt)=Rsol0(ixt)
!           Revap(ixt)=Rsol0(ixt)
!          enddo !do ixt=1,niso
!
!#ifdef ISOVERIF
!            if (use_iso_eau.eq.1) then          
!               call iso_verif_egalite_choix(Rsol(iso_eau),1.0,         
!     :                   'iso_surf 85',errmaxrel,errmaxrel)
!               call iso_verif_egalite_choix(Revap(iso_eau),1.0,
!     :                   'iso_surf 86',errmaxrel,errmaxrel)
!            endif !if (use_iso_eau.eq.1) then
!            if (use_iso_HDO.eq.1) then  
!!              write(*,*) 'iso_surf 108: deltaDsol(iso_HDO)=',
!!     :                   (Rsol(iso_HDO)/tnat(iso_HDO)-1)*1000
!!              write(*,*) 'deltaDevap(iso_HDO)=',
!!     :                   (Revap(iso_HDO)/tnat(iso_HDO)-1)*1000
!              call iso_verif_aberrant(Rsol(iso_HDO),'iso_surf 88')
!              if (qevap.gt.ridicule_qsol) then
!                 call iso_verif_aberrant(Revap(iso_HDO),'iso_surf 89')
!              endif !if (qevap.gt.ridicule_qsol) then
!            endif  !if (use_iso_HDO.eq.1) then  
!#endif
!          return
!      endif
!
!      if (T.lt.273.0) then
!          write(*,*) 'iso_surf 86: impossible: T,Pveg=',T,Pveg
!          write(*,*) 'si T<0, faire rvaporer sans frac -> Pveg=1'
!          stop
!      endif
!
!      ! 2 e cas simple: h=1
!      if (h.gt.0.99) then
!#ifdef ISOVERIF
!          write(*,*) 'iso_surf 102: h=',h
!#endif          
!          do ixt=1,niso
!            call fractcalk(ixt,T,zxtalphal(ixt),zxtalphai(ixt))
!            Rsol(ixt)=Pveg*Rsol0(ixt)+zxtalphal(ixt)*R1(ixt)*(1-Pveg)
!          enddo !do ixt=1,niso
!          
!          if (f.gt.0.99) then
!#ifdef ISOVERIF              
!              write(*,*) 'iso_surf 108: f=',f
!#endif              
!              ! l'vap n'est pas dfinie
!              do ixt=1,niso
!                Revap(ixt)=R1(ixt) ! non dfini,
!                        ! donc on fait en sorte que ne modifie pas la couche 1            
!              enddo
!
!#ifdef ISOVERIF
!                if (use_iso_eau.eq.1) then
!                  call iso_verif_egalite_choix(Rsol(iso_eau),1.0,
!     :                  'iso_surf 110',errmaxrel,errmaxrel)
!                  call iso_verif_egalite_choix(Revap(iso_eau),1.0,
!     :                   'iso_surf 111',errmaxrel,errmaxrel)
!                endif !if (use_iso_eau.eq.1) then
!                if (use_iso_HDO.eq.1) then 
!!                  write(*,*) 'iso_surf 151: deltaDsol(iso_HDO)=',
!!     :                   (Rsol(iso_HDO)/tnat(iso_HDO)-1)*1000  
!!                  write(*,*) 'deltaDevap(iso_HDO)=',
!!     :                   (Revap(iso_HDO)/tnat(iso_HDO)-1)*1000
!                  call iso_verif_aberrant(Rsol(iso_HDO),'iso_surf 112')
!                  if (qevap.gt.ridicule_evap*1800) then
!                     call iso_verif_aberrant(Revap(iso_HDO),
!     :                   'iso_surf 113')
!                  endif !if (qevap.gt.ridicule_evap*1800) then
!                endif  !if (use_iso_HDO.eq.1) then  
!#endif
!
!              return
!
!          else !if (f.gt.1-errmaxrel) then
!#ifdef ISOVERIF              
!              write(*,*) 'iso_surf 121: f=',f
!#endif              
!              do ixt=1,niso
!                Revap(ixt)=(Rsol0(ixt)-f*(Pveg*Rsol0(ixt)
!     :            +(1.-Pveg)*zxtalphal(ixt)*R1(ixt)))        
!     :            /(1.-f) 
!              enddo ! do ixt=1,niso
!
!#ifdef ISOVERIF
!                write(*,*) 'Pveg=',Pveg   
!                if (use_iso_eau.eq.1) then                               
!!              write(*,*) 'zxtalphal(2)=',zxtalphal(2)
!!              write(*,*) 'deltaD1(2)=',(R1(2)/tnat(2)-1)*1000
!!              write(*,*) 'Rsol0(2)=',Rsol0(2)
!!              write(*,*) 'Revap(2)=',Revap(2)
!!              write(*,*) 'numrateur=',Rsol0(ixt)-f*(Pveg*Rsol0(ixt)
!!     :          +(1.-Pveg)*zxtalphal(ixt)*R1(ixt))
!!              write(*,*) 'denom=',1.-f
!!              write(*,*) 't2=',Pveg*Rsol0(ixt)
!!     :          +(1.-Pveg)*zxtalphal(ixt)*R1(ixt)
!                 call iso_verif_egalite_choix(Rsol(iso_eau),1.0,        
!     :                   'iso_surf 125',errmaxrel,errmaxrel)
!                 call iso_verif_egalite_choix(Revap(iso_eau),1.0,
!     :                  'iso_surf 126',errmaxrel,errmaxrel)
!               endif !if (use_iso_eau.eq.1) then
!               if (use_iso_HDO.eq.1) then
!!                 write(*,*) 'iso_surf 191: deltaDevap(iso_HDO)=',
!!     :                   (Revap(iso_HDO)/tnat(iso_HDO)-1)*1000
!!                 write(*,*) 'deltaDsol0(iso_HDO)=',(Rsol0(iso_HDO)
!!     :                   /tnat(iso_HDO)-1)*1000
!                 call iso_verif_aberrant(Rsol(iso_HDO),'iso_surf 127')
!                 if (qevap.gt.ridicule_evap*1800) then
!                    call iso_verif_aberrant(Revap(iso_HDO),
!     :                   'iso_surf 128')
!                 endif !if (qevap.gt.ridicule_evap*1800) then
!               endif  !if (use_iso_HDO.eq.1) then  
!#endif
!
!              return
!          endif !if (f.gt.1-errmaxrel) then
!      endif !if (h.gt.0.99) then
!
!      ! 3 e cas limite : f=1
!      if (f.gt.0.90) then
!#ifdef ISOVERIF          
!          write(*,*) 'iso_surf 139: f=',f
!#endif          
!          do ixt=1,niso
!            call fractcalk(ixt,T,zxtalphal(ixt),zxtalphai(ixt))
!            interm(ixt)=zxtalphal(ixt)*alphak(ixt)*(1-h)          
!            betaprime(ixt)=(1-Pveg)*((1.0-interm(ixt))/interm(ixt))   
!            gama(ixt)=zxtalphal(ixt)*h/(1.0-interm(ixt))
!            Rsol(ixt)=(Rsol0(ixt)-gama(ixt)*R1(ixt))
!     :           *f**(betaprime(ixt))+gama(ixt)*R1(ixt)
!!          Revap(ixt)=(1+betaprime(ixt))*Rsol0(ixt)
!!     :           -betaprime(ixt)*gama(ixt)*R1(ixt) ! 1er ordre
!!!     :          +(1-f)*(-Rsol0(ixt)*(1+betaprime(ixt))*0.5 ! 2e ordre
!!!     :             +betaprime(ixt)*(0.5+gama(ixt)*R1(ixt))) ! 2e ordre 
!          ! 2e ordre conserve mal la masse -> ne pas utiliser
!           Revap(ixt)= (1-Pveg)*((Rsol0(ixt)/zxtalphal(ixt)-h*R1(ixt) )
!     :       /alphak(ixt)/(1-h))+Pveg*Rsol0(ixt) ! =Revap0 <=>1er ordre               
!          enddo !do ixt=1,niso
!
!#ifdef ISOVERIF
!            if (use_iso_eau.eq.1) then
!              call iso_verif_egalite_choix(Rsol(iso_eau),1.0,
!     :           'iso_surf 151',errmaxrel,errmaxrel)
!              call iso_verif_egalite_choix(Revap(iso_eau),1.0,
!     :           'iso_surf 152',errmaxrel,errmaxrel)
!            endif !if (use_iso_eau.eq.1) then
!            if (use_iso_HDO.eq.1) then    
!!                write(*,*) 'iso_surf 235: deltaDsol(iso_HDO)=',
!!     :                   (Rsol(iso_HDO)/tnat(iso_HDO)-1)*1000
!!                write(*,*) 'deltaDevap(iso_HDO)=',(Revap(iso_HDO)
!!     :                   /tnat(iso_HDO)-1)*1000
!                call iso_verif_aberrant(Rsol(iso_HDO),'iso_surf 153')
!                if (qevap.gt.ridicule_evap*1800) then
!                  call iso_verif_aberrant(Revap(iso_HDO),'iso_surf 154')
!                endif !if (qevap.gt.ridicule_evap*1800) then
!            endif  !if (use_iso_HDO.eq.1) then  
!#endif
!          return
!      endif
!
!      ! 4e cas simple: si h=0
!      if (h.lt.0.01) then
!#ifdef ISOVERIF          
!        write(*,*) 'iso_surf 165: h=',h
!#endif        
!        do ixt=1,niso
!          call fractcalk(ixt,T,zxtalphal(ixt),zxtalphai(ixt))
!        enddo  
!        do ixt=1,niso
!          betaprime(ixt)=(1-Pveg)*(1.0/alphak(ixt)/zxtalphal(ixt)-1)
!          Rsol(ixt)=Rsol0(ixt)*f**(betaprime(ixt))
!          Revap(ixt)=Rsol0(ixt)*(1-f**(1+betaprime(ixt)))/(1-f)        
!        enddo !do ixt=1,niso
!        
!#ifdef ISOVERIF
!          if (use_iso_eau.eq.1) then
!             call iso_verif_egalite_choix(Rsol(iso_eau),1.0,
!     :           'iso_surf 168',errmaxrel,errmaxrel)
!             call iso_verif_egalite_choix(Revap(iso_eau),1.0,
!     ;         'iso_surf 169',errmaxrel,errmaxrel)
!          endif !if (use_iso_eau.eq.1) then
!          if (use_iso_HDO.eq.1) then   
!!            write(*,*) 'iso_surf 266: alphak(iso_HDO)=',alphak(iso_HDO)
!!            write(*,*) 'zxtalphal(iso_HDO)=',zxtalphal(iso_HDO)
!!            write(*,*) 'betaprime(iso_HDO)=',betaprime(iso_HDO)
!!            write(*,*) 'f**betaprime(iso_HDO)=',f**betaprime(iso_HDO)
!!            write(*,*) 'Rsol(iso_HDO)=',Rsol(iso_HDO)
!!            write(*,*) 'deltaDsol(iso_HDO)=',(Rsol(iso_HDO)
!!     :                   /tnat(iso_HDO)-1)*1000
!!            write(*,*) 'deltaDevap(iso_HDO)=',(Revap(iso_HDO)
!!     :                   /tnat(iso_HDO)-1)*1000
!            call iso_verif_aberrant(Rsol(iso_HDO),'iso_surf 170')
!            if (qevap.gt.ridicule_qsol) then
!              call iso_verif_aberrant(Revap(iso_HDO),'iso_surf 171')
!            endif !if (qevap.gt.ridicule_qsol) then
!          endif  !if (use_iso_HDO.eq.1) then  
!#endif
!
!        return
!      endif        
!
!      ! cas gnral
!#ifdef ISOVERIF      
!      write(*,*) 'iso_surf 182: cas gnral'
!#endif      
!      do ixt=1,niso
!        call fractcalk(ixt,T,zxtalphal(ixt),zxtalphai(ixt))
!        interm(ixt)=zxtalphal(ixt)*alphak(ixt)*(1.0-h)
!        betaprime(ixt)=(1-Pveg)*((1.0-interm(ixt))/interm(ixt))      
!        gama(ixt)=zxtalphal(ixt)*h/(1.0-interm(ixt))
!        Rsol(ixt)=(Rsol0(ixt)-gama(ixt)*R1(ixt))
!     :           *f**(betaprime(ixt))+gama(ixt)*R1(ixt)
!        Revap(ixt)=(Rsol0(ixt)*(1.0-f**(1.0+betaprime(ixt)))
!     :           -f*gama(ixt)*R1(ixt)*(1.0-f**betaprime(ixt)))/(1.0-f)
!      enddo !do ixt=1,niso
!      
!#ifdef ISOVERIF
!        if (use_iso_eau.eq.1) then
!          call iso_verif_egalite_choix(Rsol(iso_eau),1.0,      
!     :           'iso_surf 185',errmaxrel,errmaxrel)
!          call iso_verif_egalite_choix(Revap(iso_eau),1.0,
!     :           'iso_surf 186',errmaxrel,errmaxrel)
!        endif !if (use_iso_eau.eq.1) then
!        if (use_iso_HDO.eq.1) then  
!!           write(*,*) 'iso_surf 307: betaprime(iso_HDO)=',
!!     :           betaprime(iso_HDO)
!!           write(*,*) 'gama(iso_HDO)=',gama(iso_HDO)
!!           write(*,*) 'deltaDsol(iso_HDO)=',(Rsol(iso_HDO)
!!     :           /tnat(iso_HDO)-1)*1000
!!           write(*,*) 'deltaDevap(iso_HDO)=',(Revap(iso_HDO)
!!     :           /tnat(iso_HDO)-1)*1000
!           call iso_verif_aberrant(Rsol(iso_HDO),'iso_surf 188')
!           if (qevap.gt.ridicule_evap*1800) then
!              call iso_verif_aberrant(Revap(iso_HDO),'iso_surf 189')
!           endif
!         endif  !if (use_iso_HDO.eq.1) then  
!#endif
!
!
!      return
!      end

!
       !*****************


      subroutine calcul_Rsol(qsol,evap,xtsol,xt1lay,q1lay,t1lay,
     :            i,Rsol,klon) 
      implicit none

      ! calcul de Rsol
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      
!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
      
      ! inputs
      integer klon
      integer i
      double precision qsol(klon)
      real evap(klon)
      double precision xtsol(niso,klon)
      real xt1lay(ntraciso,klon)
      real q1lay(klon)
      real t1lay(klon)
      ! outputs
      real Rsol(niso)
      ! locals
      integer ixt
      real zxtalphal(niso),zxtalphai(niso)
     

      ! verif
      ! end verif 

      if (qsol(i).gt.ridicule_qsol) then
        do ixt=1,niso
            Rsol(ixt)=xtsol(ixt,i)/qsol(i)             
        enddo !do ixt=1,niso

        ! verif
        ! end verif 

      else !if (qsol(i).gt.ridicule_rain) then
         if (q1lay(i).gt.ridicule) then
               ! on suppose que
               ! deltaDsol=deltaDprecip~deltaDcond(INB)~deltaDNK
             do ixt=1,niso
              call fractcalk(ixt,t1lay(i),zxtalphal(ixt),zxtalphai(ixt))
             enddo
             if (t1lay(i).ge.0.0) then   
                 do ixt=1,niso              
                    Rsol(ixt)=zxtalphal(ixt)*xt1lay(ixt,i)/q1lay(i) 
                 enddo !do ixt=1,niso

                 ! verif
                  ! end verif
                  !
             else !if (t1lay(i).ge.0.0) then   
                  do ixt=1,niso
                    Rsol(ixt)=zxtalphai(ixt)*xt1lay(ixt,i)/q1lay(i)  
                  enddo !do ixt=1,niso

                  ! verif
                      ! end verif
             endif !if (t1lay(i).ge.0.0) then   

         else !if (q1lay(i).gt.ridicule) then
                write(*,*) 'warning: iso_surf>calcul_Rsol 3209'
                write(*,*) 'qsol(i)=',qsol(i),' mais evap(i)=',evap(i)
                write(*,*) 'q1lay(i)=',q1lay(i)
                stop
         endif !if (q1lay(i).gt.ridicule) then
       endif !if (qsol(i).gt.ridicule_rain) then

       ! verif
                  ! end verif

         return
         end

         !***************

         subroutine iso_rosee_givre(xt1lay,q1lay,Tsurf_new,t_coup,evap,
     :          i,xtevap,klon)      
         implicit none
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      
!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
      ! inputs
      integer i
      integer klon
      real evap(klon) ! en kg d'eau/s
      real xt1lay(ntraciso,klon) ! en kg d'iso/kg d'air
      real q1lay(klon) ! en kg d'eau/kg d'air
      real Tsurf_new(klon)
      real t_coup
!      real dtime ! en s: typiquement: 1800s
!      real Mair ! en kg d'air

      ! outputs
      real xtevap(ntraciso,klon) ! en kg d'iso/s

      ! locals
      integer ixt
      real zxtalphal(niso),zxtalphai(niso)
      real zxtliq,zxtice ! en kg d'eau /kg d'air
!      real qevap ! en kg d'eau /kg d'air
      real deltaD ! juste pour vrif
      real R1eff

!      write(*,*) 'iso_surf>rose 527: entre dans rose'
      if (evap(i).eq.0.0) then
        do ixt=1,niso
          xtevap(ixt,i)=0.0
        enddo
        return
      endif

      if (q1lay(i).gt.ridicule) then
             ! verif de R1
             ! end verif R1   

!             qevap=-evap(i)*dtime/Mair ! en kg d'eau par kg d'air
!             write(*,*) 'iso_surf>ros 554: qevap=',qevap
!             write(*,*) 'evap(i),dtime,Mair,q1lay(i)=',
!     :                   evap(i),dtime,Mair,q1lay(i)            
          if (Tsurf_new(i).ge.t_coup) then
            !write(*,*) 'iso_surf>iso_rosee_givre 3181: Tsurf_new(i)=',Tsurf_new(i)
            do ixt=1,niso
               ! methode 1: condensation  l'quilibre, approx 1er ordre
               R1eff= xt1lay(ixt,i)/q1lay(i)  
               call fractcalk_liq(ixt,Tsurf_new(i),zxtalphal(ixt)) 
               xtevap(ixt,i)=evap(i)*zxtalphal(ixt)*R1eff 
               ! methode 2: condensation, approche sans approximation
!                call condiso_liq_ice(ixt,xt1lay(ixt,i),q1lay(i),
!     :           qevap,Tsurf_new(i),0.0,zxtice,zxtliq)    
!               xtevap(ixt,i)=-zxtliq/dtime*Mair       
!                write(*,*) 'iso_surf>rose 545: qevap=', qevap
!                write(*,*) 'q1lay(i)=',q1lay(i)
!                write(*,*) 'zxtice=',zxtice
!                write(*,*) 'zxtliq=',zxtliq               
                
            enddo !do ixt=1,niso


              
          else !if (Tsurf_new(i).ge.t_coup) then
            !write(*,*) 'iso_surf>iso_rosee_givre 3186: Tsurf_new(i)=',Tsurf_new(i)
            do ixt=1,niso
            ! methode 1: condensation  l'quilibre, approx 1er ordre
               R1eff= xt1lay(ixt,i)/q1lay(i)
               call fractcalk_glace(ixt,Tsurf_new(i),zxtalphai(ixt))
               xtevap(ixt,i)=evap(i)*zxtalphai(ixt)*R1eff
             ! methode 2: condensation, approche sans approximation
!                call condiso_liq_ice(ixt,xt1lay(ixt,i),q1lay(i),
!     :           qevap,Tsurf_new(i),1.0,zxtice,zxtliq)           
!                xtevap(ixt,i)=-zxtice/dtime*Mair
!                write(*,*) 'iso_surf>rose 558: qevap=',qevap
!                write(*,*) 'q1lay(i)=',q1lay(i)
!                write(*,*) 'zxtice=',zxtice
!                write(*,*) 'zxtliq=',zxtliq

            enddo !do ixt=1,niso  


          endif !if (Tsurf_new(i).ge.0.0) then 

          
          ! verif   
          ! end verif

        else !if (q1lay(i).gt.0) then
            write(*,*) 'iso_surf>iso_rosee_givre 3189: evap=',evap
            write(*,*) 'q1lay(i)=',q1lay(i)
            stop
        endif !if (q1lay(i).gt.0) then

        return
        end
