
      SUBROUTINE iso_tritium(iim,jjm,
     :           klon,klev,
     :           rlat,rlon,rlatd,rlond,
     :           paprs,pplay,
     :           zphi,dtime,
     :           airephy,
     :           d_xt_prod_nucl,
     :           d_xt_cosmo,
     :           d_xt_decroiss,
     :           xt_seri)
      implicit none

c1506 #include "dimiso.h"    
!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      
!
! $Header$
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation
!                 (les placer en colonne 6 et en colonne 73)
!
!
! A1.0 Fundamental constants
      REAL RPI,RCLUM,RHPLA,RKBOL,RNAVO
! A1.1 Astronomical constants
      REAL RDAY,REA,REPSM,RSIYEA,RSIDAY,ROMEGA
! A1.1.bis Constantes concernant l'orbite de la Terre:
      REAL R_ecc, R_peri, R_incl
! A1.2 Geoide
      REAL RA,RG,R1SA
! A1.3 Radiation
!     REAL RSIGMA,RI0
      REAL RSIGMA
! A1.4 Thermodynamic gas phase
      REAL R,RMD,RMO3,RMV,RD,RV,RCPD,RCPV,RCVD,RCVV
      REAL RKAPPA,RETV
! A1.5,6 Thermodynamic liquid,solid phases
      REAL RCW,RCS
! A1.7 Thermodynamic transition of phase
      REAL RLVTT,RLSTT,RLMLT,RTT,RATM
! A1.8 Curve of saturation
      REAL RESTT,RALPW,RBETW,RGAMW,RALPS,RBETS,RGAMS
      REAL RALPD,RBETD,RGAMD
!
      COMMON/YOMCST/RPI   ,RCLUM ,RHPLA ,RKBOL ,RNAVO                   &
     &      ,RDAY  ,REA   ,REPSM ,RSIYEA,RSIDAY,ROMEGA                  &
     &      ,R_ecc, R_peri, R_incl                                      &
     &      ,RA    ,RG    ,R1SA                                         &
     &      ,RSIGMA                                                     &
     &      ,R     ,RMD   ,RMO3  ,RMV   ,RD    ,RV    ,RCPD             &
     &      ,RCPV  ,RCVD  ,RCVV  ,RKAPPA,RETV                           &
     &      ,RCW   ,RCS                                                 &
     &      ,RLVTT ,RLSTT ,RLMLT ,RTT   ,RATM                           &
     &      ,RESTT ,RALPW ,RBETW ,RGAMW ,RALPS ,RBETS ,RGAMS            &
     &      ,RALPD ,RBETD ,RGAMD
!    ------------------------------------------------------------------
!$OMP THREADPRIVATE(/YOMCST/)

! input
      integer iim,jjm ! nombre de couches en lat et lon
      integer klon,klev
      real rlat(klon), rlon(klon) ! Latitude et longitude en degre
      real rlatd(klon), rlond(klon) ! Latitude et longitude en radian
      real paprs(klon,klev+1) ! input-R-pression pour chaque inter-couche (en Pa)
      real zphi(klon,klev) ! input-R-geopotentiel de chaque couche (reference ocean, en m2/s2)
      real pplay(klon,klev) ! input-R-pression pour le mileu de chaque couche (en Pa)
      real dtime ! pas de temps en secondes
      real airephy(klon) ! aire d'une grille (m2)

! output
      real d_xt_prod_nucl(ntraciso,klon,klev) ! tritium provenant des essais nucleaires
      real d_xt_cosmo(ntraciso,klon,klev) ! production naturelle de tritium
      real d_xt_decroiss(ntraciso,klon,klev) ! decroissance radioactive
      real xt_seri(ntraciso,klon,klev) ! quantite d'isotopes de l'eau

! local
      integer iso_verif_noNAN_nostop ! pour debuggage
      integer iso_verif_positif_strict_nostop ! pour debuggage
      integer ixt,i,k,k_ref,kb,nlev_prod
      real pi
      real rlat_geo(klon) ! latitude geomagnetique de la grille (en radians, entre 0 et 90 degres)
      real glat ! latitude du pole geomagnetique
      real glon ! longitude du pole geomagnetique
      real lat_geo,qcos
      parameter (nlev_prod=34)
      real p_ref ! grille de pression de reference
      dimension p_ref(nlev_prod)
      real masse_tritium ! masse d'une molecule de HTO en kg
      real tau_decroissance_tritium ! periode radioactive du tritium (17.77 ans en secondes)
      data p_ref /
     :      100062.00, 97119.00, 94176.00, 91233.00,
     :      88290.00, 85347.00, 82404.00, 79461.00,
     :      76518.00, 73575.00, 70632.00, 67689.00,
     :      64746.00, 61803.00, 58860.00, 55917.00,
     :      52974.00, 50031.00, 47088.00, 44145.00,
     :      41202.00, 38259.00, 35316.00, 32373.00,
     :      29430.00, 26487.00, 23544.00, 20601.00,
     :      17658.00, 14715.00, 11772.00, 8829.00,
     :      5886.00, 2943.00 /

      integer j_1ere_bombe !  numero du premier essai nucleaire de la journee en cours (486 au total)
      integer nbombe ! pour savoir si c'est un jour de bombe et le nombre de bombes durant ce jour

     
! ---------------------------------------------------------------------     
! initialisation
! ---------------------------------------------------------------------
      pi=4.*atan(1.)
      masse_tritium=33.3388E-27
      tau_decroissance_tritium=560520955.6
      
      do ixt=1,ntraciso
      do i=1,klon
      do k=1,klev
      d_xt_cosmo(ixt,i,k)=0.
      d_xt_prod_nucl(ixt,i,k)=0.
      d_xt_decroiss(ixt,i,k)=0.         
      enddo
      enddo
      enddo

!#ifdef ISOVERIFIDRIS
!      do kb=1,nlev_prod
!      write(*,*) 'iso_tritium 103'
!      write(*,*) 'kb, p_ref', kb, p_ref(kb)
!      enddo
!#endif


! ----------------------------------------------------------------------------
! Production naturelle de tritium --> d_xt_cosmo
! ----------------------------------------------------------------------------

! On passe des coordonnees geographiques a la latitude geomagnetique

       glat = 78.5*pi/180.
       glon = -69.0*pi/180.
       
       do i=1,klon
          qcos=sin(glat)*sin(rlatd(i))
          qcos=qcos+cos(glat)*cos(rlatd(i))*cos(rlond(i)-glon)
          if ( qcos .lt. -1.) qcos = -1.
          if ( qcos .gt. 1.) qcos = 1.
          rlat_geo(i)=pi/2.-acos(qcos)
       enddo


! Pour chaque niveau de pression atmospherique, on implemente a chaque bande de latitude
! la production de tritium
       
       if (use_iso_HTO.eq.1) then ! Tritium
       ixt=iso_HTO

       do i = 1,klon
       do k = 1,klev

! Determination du niveau k_ref dans la grille de reference
       k_ref = 1
       do kb = 1,nlev_prod
          if (p_ref(kb) .gt. pplay(i,k)) k_ref=kb
       enddo

       lat_geo=(180./pi)*abs(rlat_geo(i)) ! latitude geomagnetique
       ! Pour le moment, la production d_xt_cosmo est exprime en at/g/s

       if ( k_ref .eq. 1 ) then   
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 8.9433E-7
                   
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then 
                   d_xt_cosmo(ixt,i,k) = 8.9432E-7
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 8.9247E-7
                   
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 8.4992E-7
                   
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 7.655E-7
                   
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 6.9815E-7
                   
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 6.4847E-7
                   
           else    
                  d_xt_cosmo(ixt,i,k) = 6.2824E-7
           
           endif       
       endif
       
       
       if ( k_ref .eq. 2 ) then    
           if (lat_geo.ge.60.)                                  then
                   d_xt_cosmo(ixt,i,k) = 1.736E-6
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.171E-6
                   
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.1121E-6
                   
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 9.9709E-7
                   
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 9.0662E-7
                   
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 8.3986E-7
                   
           else    
                   d_xt_cosmo(ixt,i,k) = 8.1299E-7
           
           endif        
       endif
       
       
       if ( k_ref .eq. 3 ) then     
           if (lat_geo.ge.60.)                                  then
                   d_xt_cosmo(ixt,i,k) = 1.5402E-6
           
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.5365E-6
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.4552E-6
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.2989E-6
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.1775E-6
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.0879E-6
           
           else    
                   d_xt_cosmo(ixt,i,k) = 1.0522E-6
           
           endif    
       endif
       
       
       if ( k_ref .eq. 4 ) then     
           if (lat_geo.ge.60.)                                  then
                   d_xt_cosmo(ixt,i,k) = 2.0198E-6
           
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.0145E-6
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.9024E-6
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.6901E-6
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.5273E-6
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.4072E-6
           
           else    
                   d_xt_cosmo(ixt,i,k) = 1.3599E-6
           
           endif    
       endif
       
       
       if ( k_ref .eq. 5 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 2.6465E-6
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.6464E-6
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.6389E-6
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.4846E-6
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.1965E-6
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.9785E-6
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.8177E-6
           
           else    
                   d_xt_cosmo(ixt,i,k) = 1.755E-6
           
           endif    
       endif
       
       
       if ( k_ref .eq. 6 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 3.4646E-6
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.4645E-6
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.454E-6
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.2415E-6
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.851E-6
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.5595E-6
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.3444E-6
           
           else    
                   d_xt_cosmo(ixt,i,k) = 2.2613E-6
           
           endif    
       endif
       
       
       if ( k_ref .eq. 7 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 4.5316E-6
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.5315E-6
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.5166E-6
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.2244E-6
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.6958E-6
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.3062E-6
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.0191E-6
           
           else    
                   d_xt_cosmo(ixt,i,k) = 2.909E-6
           
           endif    
       endif
       
       
       if ( k_ref .eq. 8 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 5.9217E-6
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 5.9216E-6
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 5.9006E-6
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 5.499E-6
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.7842E-6
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.2644E-6
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.8815E-6
           
           else    
                   d_xt_cosmo(ixt,i,k) = 3.736E-6
           
           endif    
       endif
       
       
       if ( k_ref .eq. 9 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 7.7309E-6
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 7.7307E-6
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 7.701E-6
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 7.1498E-6
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 6.1842E-6
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 5.4915E-6
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.9818E-6
           
           else    
                   d_xt_cosmo(ixt,i,k) = 4.7894E-6
           
           endif    
       endif
       
       
       if ( k_ref .eq. 10 ) then     
           if (lat_geo.ge.60.)                                  then
                   d_xt_cosmo(ixt,i,k) = 1.0082E-5
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.004E-5
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 9.2843E-6
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 7.9817E-6
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 7.0598E-6
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 6.3824E-6
           
           else    
                   d_xt_cosmo(ixt,i,k) = 6.1283E-6
           
           endif    
       endif
       
       
       if ( k_ref .eq. 11 ) then     
           if (lat_geo.ge.60.)                                  then
                   d_xt_cosmo(ixt,i,k) = 1.3135E-5
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.3076E-5
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.204E-5
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.0285E-5
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 9.0599E-6
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 8.1612E-6
           
           else    
                   d_xt_cosmo(ixt,i,k) = 7.8258E-6
           
           endif    
       endif
       
       
       if ( k_ref .eq. 12 ) then     
           if (lat_geo.ge.60.)                                  then
                   d_xt_cosmo(ixt,i,k) = 1.7093E-5
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.701E-5
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.5592E-5
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.3231E-5
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.1605E-5
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.0414E-5
           
           else    
                   d_xt_cosmo(ixt,i,k) = 9.9722E-6
           
           endif    
       endif
       
       
       if ( k_ref .eq. 13 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 2.2217E-5
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.2216E-5
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.21E-5
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.0162E-5
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.6989E-5
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.4835E-5
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.3261E-5
           
           else    
                   d_xt_cosmo(ixt,i,k) = 1.2679E-5
           
           endif    
       endif
       
       
       if ( k_ref .eq. 14 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 2.8816E-5
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.8815E-5
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.8652E-5
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.6002E-5
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.1746E-5
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.8898E-5
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.6822E-5
           
           else    
                   d_xt_cosmo(ixt,i,k) = 1.6056E-5
           
           endif    
       endif
       
       
       if ( k_ref .eq. 15 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 3.7386E-5
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.7384E-5
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.7157E-5
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.3546E-5
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.7847E-5
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.4084E-5
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.1349E-5
           
           else    
                   d_xt_cosmo(ixt,i,k) = 2.0343E-5
           
           endif    
       endif
       
       
       if ( k_ref .eq. 16 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 4.8393E-5
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.8392E-5
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.8073E-5
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.3156E-5
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.5536E-5
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.0578E-5
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.6983E-5
           
           else    
                   d_xt_cosmo(ixt,i,k) = 2.5663E-5
           
           endif    
       endif
       
       
       if ( k_ref .eq. 17 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 6.2543E-5
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 6.2541E-5
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 6.2097E-5
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 5.541E-5
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.5241E-5
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.8722E-5
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.4007E-5
           
           else    
                   d_xt_cosmo(ixt,i,k) = 3.228E-5
           
           endif    
       endif
       
       
       if ( k_ref .eq. 18 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 8.0696E-5
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 8.0693E-5
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 8.0074E-5
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 7.0993E-5
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 5.7449E-5
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.8897E-5
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.273E-5
           
           else    
                   d_xt_cosmo(ixt,i,k) = 4.0472E-5
           
           endif    
       endif
       
       
       if ( k_ref .eq. 19 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 1.0393E-4
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.0392E-4
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.0306E-4
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 9.0753E-5
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 7.2752E-5
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 6.1561E-5
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 5.3513E-5
           
           else    
                   d_xt_cosmo(ixt,i,k) = 5.057E-5
           
           endif    
       endif
       
       
       if ( k_ref .eq. 20 ) then     
           if (lat_geo.ge.60.)                                  then
                   d_xt_cosmo(ixt,i,k) = 1.3358E-4
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.3238E-4
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.1573E-4
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 9.1859E-5
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 7.7254E-5
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 6.678E-5
           
           else    
                   d_xt_cosmo(ixt,i,k) = 6.2953E-5
           
           endif    
       endif
       
       
       if ( k_ref .eq. 21 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 1.7134E-4
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.7133E-4
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.6968E-4
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.4718E-4
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.1561E-4
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 9.661E-5
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 8.3017E-5
           
           else    
                   d_xt_cosmo(ixt,i,k) = 7.8054E-5
           
           endif    
       endif
       
       
       if ( k_ref .eq. 22 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 2.1926E-4
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.1925E-4
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.1696E-4
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.8664E-4
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.45E-4
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.2036E-4
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.0277E-4
           
           else    
                   d_xt_cosmo(ixt,i,k) = 9.6352E-5
           
           endif    
       endif
       
       
       if ( k_ref .eq. 23 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 2.7986E-4
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.7984E-4
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.7669E-4
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.3591E-4
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.8117E-4
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.4931E-4
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.2663E-4
           
           else    
                   d_xt_cosmo(ixt,i,k) = 1.1836E-4
           
           endif    
       endif
       
       
       if ( k_ref .eq. 24 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 3.5619E-4
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.5617E-4
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.5183E-4
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.9712E-4
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.2536E-4
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.8436E-4
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.552E-4
           
           else    
                   d_xt_cosmo(ixt,i,k) = 1.446E-4
           
           endif    
       endif
       
       
       if ( k_ref .eq. 25 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 4.5186E-4
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.5183E-4
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.4587E-4
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.7264E-4
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.7894E-4
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.2638E-4
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.8906E-4
           
           else    
                   d_xt_cosmo(ixt,i,k) = 1.7554E-4
           
           endif    
       endif
       
       
       if ( k_ref .eq. 26 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 5.7102E-4
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 5.7098E-4
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 5.628E-4
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.6503E-4
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.4318E-4
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.7618E-4
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.2861E-4
           
           else    
                   d_xt_cosmo(ixt,i,k) = 2.1146E-4
           
           endif    
       endif
       
       
       if ( k_ref .eq. 27 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 7.1820E-4
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 7.1815E-4
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 7.0693E-4
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 5.7675E-4
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.1904E-4
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.3416E-4
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.7389E-4
           
           else    
                   d_xt_cosmo(ixt,i,k) = 2.5228E-4
           
           endif    
       endif
       
       
       if ( k_ref .eq. 28 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 8.9801E-4
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 8.9794E-4
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 8.8255E-4
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 7.0966E-4
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 5.0671E-4
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.0001E-4
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.242E-4
           
           else    
                   d_xt_cosmo(ixt,i,k) = 2.9724E-4
           
           endif    
       endif
       
       
       if ( k_ref .eq. 29 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 1.1145E-3
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.1144E-3
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.0932E-3
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 8.6421E-4
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 6.0487E-4
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.7209E-4
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.7768E-4
           
           else    
                   d_xt_cosmo(ixt,i,k) = 3.4441E-4
           
           endif    
       endif
       
       
       if ( k_ref .eq. 30 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 1.3709E-3
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.3708E-3
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.3415E-3
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.0387E-3
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 7.1001E-4
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 5.4689E-4
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.3085E-4
           
           else    
                   d_xt_cosmo(ixt,i,k) = 3.9032E-4
           
           endif    
       endif
       
       
       if ( k_ref .eq. 31 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 1.6712E-3
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.671E-3
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.63E-3
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.2296E-3
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 8.1648E-4
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 6.1899E-4
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 4.787E-4
           
           else    
                   d_xt_cosmo(ixt,i,k) = 4.2993E-4
           
           endif    
       endif
       
       
       if ( k_ref .eq. 32 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 2.0296E-3
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.0293E-3
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.9704E-3
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.4366E-3
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 9.1906E-4
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 6.8278E-4
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 5.1594E-4
           
           else    
                   d_xt_cosmo(ixt,i,k) = 4.5743E-4
           
           endif    
       endif
       
       
       if ( k_ref .eq. 33 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 2.4971E-3
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.4967E-3
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 2.4078E-3
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.6751E-3
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.017E-3
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 7.3425E-4
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 5.3723E-4
           
           else    
                   d_xt_cosmo(ixt,i,k) = 4.662E-4
           
           endif    
       endif
       
       
       if ( k_ref .eq. 34 ) then     
           if (lat_geo.ge.70.)                                  then
                   d_xt_cosmo(ixt,i,k) = 3.2169E-3
           
           else if ( (lat_geo.ge.60.0) .and. (lat_geo.lt.70.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.2161E-3
                   
           else if ( (lat_geo.ge.50.0) .and. (lat_geo.lt.60.0) ) then
                   d_xt_cosmo(ixt,i,k) = 3.0665E-3
           
           else if ( (lat_geo.ge.40.0) .and. (lat_geo.lt.50.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.9861E-3
           
           else if ( (lat_geo.ge.30.0) .and. (lat_geo.lt.40.0) ) then
                   d_xt_cosmo(ixt,i,k) = 1.1059E-3
           
           else if ( (lat_geo.ge.20.0) .and. (lat_geo.lt.30.0) ) then
                   d_xt_cosmo(ixt,i,k) = 7.6337E-4
           
           else if ( (lat_geo.ge.10.0) .and. (lat_geo.lt.20.0) ) then
                   d_xt_cosmo(ixt,i,k) = 5.2801E-4
           
           else    
                   d_xt_cosmo(ixt,i,k) = 4.4129E-4
           
           endif    
       endif
       
!#ifdef ISOVERIFIDRIS
!          if (k.eq.klev) then
!          write(*,*) 'iso_tritium 1096'
!          write(*,*) 'ixt,i,k,klev=',ixt,i,k,klev
!          write(*,*) 'rlat,rlatd=',rlat(i),rlatd(i)
!          write(*,*) 'rlon,rlond=',rlon(i),rlond(i)
!          write(*,*) 'rlat_geo(i), lat_geo=',rlat_geo(i),lat_geo
!          write(*,*) 'pplay(i,k)=',pplay(i,k)
!          write(*,*) 'k_ref=',k_ref
!          write(*,*) 'd_xt_cosmo(ixt,i,k)=',d_xt_cosmo(ixt,i,k)
!          endif
!#endif


          
       enddo
       enddo
       endif
       
! Conversion de la production naturelle de tritium en kg(HTO)/kg(air)/s
! Facteur 1.3/0.7 : test augmentation/baisse de 30% de la production naturelle de tritium
      do ixt=1,ntraciso
      do i=1,klon
      do k=1,klev
         d_xt_cosmo(ixt,i,k)=d_xt_cosmo(ixt,i,k)*masse_tritium*1000.
      enddo
      enddo
      enddo
  




! --------------------------------------------------------------------------------
! Production de tritium liee aux essais nucleaires --> d_xt_prod_nucl
! --------------------------------------------------------------------------------
       
      if (ok_prod_nucl_tritium) then ! production nucleaire de tritium = true 
          
          if (use_iso_HTO.eq.1) then ! Tritium
             ixt=iso_HTO 
             
             ! on verifie si la date dans la simulation est un jour d'essai nucleaire 
             CALL date_prod_nucl_HTO(nessai, day_nucl, month_nucl,
     :                               year_nucl, j_1ere_bombe, nbombe)
           write(*,*) 'iso_tritium 1183, apres call date_prod_nucl_HTO'
           write(*,*) 'j_1ere_bombe, nbombe', j_1ere_bombe, nbombe
 
             if (nbombe.ge.1) then ! si c'est un jour avec un ou plusieurs essais nucleaires
                 CALL lancer_bombes(iim, jjm, nbombe, j_1ere_bombe,
     :                              klon, klev, zphi,
     :                              rlat, rlon, paprs, airephy,
     :                              lat_nucl, lon_nucl,
     :                              zmin_nucl, zmax_nucl,
     :                              HTO_nucl, nessai,
     :                              d_xt_prod_nucl)
             endif ! if (nbombe.ge.1)
                 
          endif ! if tritium
      
      endif ! if ok_prod_nucl_tritium





! ------------------------------------------------------------------------
! Definition de la decroissance radioactive du tritium --> d_xt_decroiss
! ------------------------------------------------------------------------

        do ixt=1,ntraciso ! boucler sur tous les isotopes
           if ((use_iso_HTO.eq.1).and.(ixt.eq.iso_HTO)) then ! Tritium
           do i=1,klon ! boucler sur toutes les points horizontaux
           do k=1,klev ! boucler sur l'échelle verticale
           d_xt_decroiss(ixt,i,k)=-xt_seri(ixt,i,k)
     :     *1./tau_decroissance_tritium
           enddo
           enddo
           endif
        enddo ! fin de la boucle en ntraciso



! ----------------------------------------------------------------------
! concentration totale de tritium --> calcul de xt_seri
! ----------------------------------------------------------------------

      do ixt=1,ntraciso ! boucler sur tous les isotopes
         do i=1,klon ! boucler sur toutes les points horizontaux
         do k=1,klev ! boucler sur l'échelle verticale
            xt_seri(ixt,i,k)=xt_seri(ixt,i,k)
     :      +d_xt_cosmo(ixt,i,k)*dtime
     :      +d_xt_prod_nucl(ixt,i,k)*dtime
     :      +d_xt_decroiss(ixt,i,k)*dtime


!#ifdef ISOVERIFIDRIS
!      if ((ixt.eq.iso_HTO).and.(k.ge.(klev-2))) then !ok
!         write(*,*) 'iso_tritium 1284 - test concentration totale' 
!         write(*,*) 'ixt,i,k,klev=',ixt,i,k,klev
!         write(*,*) 'rlat,rlon=',rlat(i),rlon(i)
!         write(*,*) 'dtime=', dtime
!         write(*,*) 'd_xt_cosmo(ixt,i,k)=',d_xt_cosmo(ixt,i,k)
!         write(*,*) 'd_xt_prod_nucl(ixt,i,k)=',d_xt_prod_nucl(ixt,i,k)
!      endif
!#endif

         enddo
         enddo
      enddo



      return
      end

!===================================================================
!
!   End subroutine iso_tritium
!
!===================================================================



!===================================================================
!
! Subroutine chargement des tableaux de donnees pour production 
! nucleaire de tritium --> call dans iso_init.F
!
!===================================================================

      SUBROUTINE table_tritium_nucl(ntest,
     :                              day_essai,month_essai,year_essai,
     :                              lat_essai,lon_essai,
     :                              zmin_essai,zmax_essai,
     :                              HTO_essai)
      implicit none

!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      

!     Arguments
      integer ntest
      integer day_essai(ntest), month_essai(ntest), year_essai(ntest)
      real lat_essai(ntest), lon_essai(ntest)
      real  zmin_essai(ntest) ,zmax_essai(ntest)
      real HTO_essai(ntest)

!     local
      integer iessai


      if (ok_prod_nucl_tritium) then

      ! tableau pour day_nucl
      open(30, file='day_nucl.txt')
         do iessai=1,ntest
         read(30,*) day_essai(iessai)
         enddo
      close(30)

      ! tableau pour month_nucl
      open(31, file='month_nucl.txt')
         do iessai=1,ntest
         read(31,*) month_essai(iessai)
         enddo
      close(31)

      ! tableau pour year_nucl
      open(32, file='year_nucl.txt')
         do iessai=1,ntest
         read(32,*) year_essai(iessai)
         enddo
      close(32)

      ! tableau pour lat_nucl
      open(33, file='lat_nucl.txt')
         do iessai=1,ntest
         read(33,*) lat_essai(iessai)
         enddo
      close(33)

      ! tableau pour lon_nucl
      open(34, file='lon_nucl.txt')
         do iessai=1,ntest
         read(34,*) lon_essai(iessai)
         enddo
      close(34)

      ! tableau pour zmin_nucl
      open(35, file='zmin_nucl.txt')
         do iessai=1,ntest
         read(35,*) zmin_essai(iessai)
         enddo
      close(35)

      ! tableau pour zmax_nucl
      open(36, file='zmax_nucl.txt')
         do iessai=1,ntest
         read(36,*) zmax_essai(iessai)
         enddo
      close(36)

      ! tableau pour HTO_nucl
      open(37, file='HTO_nucl.txt')
         do iessai=1,ntest
         read(37,*) HTO_essai(iessai)
         enddo
      close(37)



      else 

      do iessai=1,ntest
         day_essai(iessai)   = 0.
         month_essai(iessai) = 0.
         year_essai(iessai)  = 0. 
         lat_essai(iessai)   = 0.
         lon_essai(iessai)   = 0.
         zmin_essai(iessai)  = 0.
         zmax_essai(iessai)  = 0.
         HTO_essai(iessai)   = 0.
      enddo

      endif ! if (ok_prod_nucl_tritium)

      return
      end

!===================================================================
!
! Subroutines production nucleaire utilisees par iso_tritium
!
!===================================================================

! Subroutines pour la production nucleaire de tritium :
! 1. Les donnees (temps, localisation, quantite de tritium injecte) sont
!    chargees prealablement dans la subroutine table_tritium_nucl qui
!    est appelee dans iso_init.F. Ces donnees sont mis dans le COMMON
!    de wateriso2
! 2. Determiner si le jour dans la simulation correspond a un jour d'un
!    essai nucleaire, connaitre la ligne correspondante dans le
!    fichier de forcage de production nucleaire, et savoir le nombres 
!    de bombes nbombe dans cette journee --> subroutine 
!    date_prod_nucl_HTO
! 3. Si oui (nbombe > 0), on utilise la subroutine lancer_bombes qui va
!    definir les variables de localisation et quantite de tritium
!    produit avec le bon nombre de bombes dans la journee et appeler les
!    deux subroutines suivantes
! 4. subroutine coord_prod_nucl_HTO --> pour la localisation de l'essai
!    nucleaire sur (klon,klev)
! 5. calcul de la production de tritium (kg) (a partir de P_HTO dans le tableau 
!    repertoriant tous les essais nucleaires) etalee uniformement sur la journee 
!    entre zmin et zmax --> subroutine calcul_prod_nucl_HTO


! --------------------------------------------------------------------------------
! date_prod_nucl_HTO
! --------------------------------------------------------------------------------
       SUBROUTINE date_prod_nucl_HTO(ntest, day_essai, month_essai,
     :                               year_essai, j_1ere_bombe, nbombe)

      use phys_cal_mod ! pour le calendrier
      implicit none

      ! Arguments
      integer ntest,nbombe,j_1ere_bombe ! pour un jour dans la simulation, on cherche le nombre de bombes nbombe de la journee et la ligne correspondant a la 1ere bombe de cette journee
      integer day_essai(ntest),month_essai(ntest),year_essai(ntest) ! date (jour, mois, annee) des essais nucleaires

      ! local
      integer j ! indices
 
      ! initialisation
      nbombe=0
      j_1ere_bombe=0
      write(*,*) 'iso_tritium 1456, subroutine date_prod_nucl_HTO'
      write(*,*) 'Date dans la simulation:',day_cur,mth_cur,year_cur

      do j=1,ntest ! il faut que le tableau d'entree soit dans l'ordre chronologique
         if (nbombe.eq.0) then
            if ((day_cur.eq.day_essai(j)).and.
     :          (mth_cur.eq.month_essai(j)).and.
     :          (year_cur.eq.year_essai(j))) then
            nbombe=1
            j_1ere_bombe=j
            endif
         else
            if ((day_cur.eq.day_essai(j)).and.
     :         (mth_cur.eq.month_essai(j)).and.
     :         (year_cur.eq.year_essai(j))) then
               nbombe=nbombe+1
            else
               exit
            endif
         endif
!#ifdef ISOVERIFIDRIS
!      write(*,*) 'controle subroutine date_prod_nucl_HTO' !ok
!      write(*,*) 'day_cur, mth_cur, year_cur',day_cur,mth_cur,year_cur
!      write(*,*) 'j, nessai', j, ntest
!      write(*,*) 'nbombe,  j_1ere_bombe', nbombe, j_1ere_bombe
!      write(*,*) 'day_nucl(j), month_nucl(j), year_nucl(j)',
!     :            day_essai(j), month_essai(j), year_essai(j)
!#endif
      enddo
             

      return
      end



! --------------------------------------------------------------------------------
! lancer_bombes
! --------------------------------------------------------------------------------

      SUBROUTINE lancer_bombes(iim, jjm, nbombe, j_1ere_bombe, 
     :                         klon, klev, zphi,
     :                         rlat, rlon, paprs, airephy,
     :                         lat_essai, lon_essai,
     :                         zmin_essai, zmax_essai,
     :                         HTO_essai, ntest,
     :                         prod_nucl_HTO)
      implicit none

!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      

!     Arguments
      integer iim, jjm, nbombe, j_1ere_bombe
      integer klon, klev
      integer ntest
      real zphi(klon,klev)
      real rlat(klon), rlon(klon), paprs(klon,klev+1), airephy(klon)
      real lat_essai(ntest), lon_essai(ntest) ! latitude et longitude des essais nucleaires
      real zmin_essai(ntest), zmax_essai(ntest) ! altitudes min et max des nbombes champignons atomiques
      real HTO_essai(ntest) ! production de HTO en kg par les essais nucleaires
      real prod_nucl_HTO(ntraciso,klon,klev) ! calcul de la production de tritium (kg/kg d'air) liee aux essais nucleaire de la journee --> d_xt_prod_nucl(ntraciso,klon,klev)

!     local
      integer ibombe,jessai
      real lat_HTO, lon_HTO ! latitude et longitude de l'essai nucleaire jessai
      real zmin_HTO, zmax_HTO ! altitudes min et max du champignon atomique jessai
      real P_HTO ! production de HTO en kg de l'essai nucleaire jessai
      integer coord_HTO 
      integer kmin_HTO, kmax_HTO ! coordonnees lat, lon, zmin et zmax de l'essai nucleaire jessai

      do ibombe=1,nbombe
         jessai=j_1ere_bombe+ibombe-1
         lat_HTO = lat_essai(jessai)
         lon_HTO = lon_essai(jessai)
         zmin_HTO = zmin_essai(jessai)
         zmax_HTO = zmax_essai(jessai)
         P_HTO = HTO_essai(jessai)
!#ifdef ISOVERIFIDRIS !ok
!      write(*,*) 'controle subroutine lancer_bombes'
!      write(*,*) 'ibombe, nbombe', ibombe, nbombe
!      write(*,*) 'jessai, j_1ere_bombe', jessai, j_1ere_bombe
!      write(*,*) 'lat_HTO, lon_HTO', lat_HTO, lon_HTO
!      write(*,*) 'zmin_HTO, zmax_HTO', zmin_HTO, zmax_HTO
!      write(*,*) 'P_HTO', P_HTO 
!#endif
         
        CALL coord_prod_nucl_HTO(iim, jjm,
     :                            klon, klev, zphi,
     :                            rlat, rlon,
     :                            lat_HTO, lon_HTO,
     :                            zmin_HTO, zmax_HTO,
     :                            coord_HTO, 
     :                            kmin_HTO,kmax_HTO)
            
         if (coord_HTO.gt.0) then ! quand on trouve les coordonnees de l'essai nucleaire dans la simulation
       write(*,*) 'iso_tritium 1552 dans subroutine lancer_bombes'
       write(*,*) 'Apres call coord_prod_nucl_HTO pour coord_HTO>0'
       write(*,*) 'ibombe, nbombe', ibombe, nbombe
       write(*,*) 'coord_HTO',coord_HTO
       write(*,*) 'rlat(coord_HTO), rlon(coord_HTO)', 
     :             rlat(coord_HTO), rlon(coord_HTO)
       write(*,*) 'kmin_HTO, kmax_HTO', kmin_HTO, kmax_HTO

         CALL calcul_prod_nucl_HTO(P_HTO,coord_HTO,
     :                             kmin_HTO,kmax_HTO,
     :                             klon, klev,
     :                             paprs,airephy,
     :                             prod_nucl_HTO)
         endif

      enddo

      return
      end
! --------------------------------------------------------------------------------
! coord_prod_nucl_HTO
! --------------------------------------------------------------------------------
      SUBROUTINE coord_prod_nucl_HTO(iim, jjm,
     :                               klon, klev, zphi,
     :                               rlat, rlon,
     :                               lat_jessai, lon_jessai, 
     :                               zmin_jessai, zmax_jessai,
     :                               coord_jessai,
     :                               kmin_jessai,kmax_jessai)
      implicit none

!
! $Header$
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation
!                 (les placer en colonne 6 et en colonne 73)
!
!
! A1.0 Fundamental constants
      REAL RPI,RCLUM,RHPLA,RKBOL,RNAVO
! A1.1 Astronomical constants
      REAL RDAY,REA,REPSM,RSIYEA,RSIDAY,ROMEGA
! A1.1.bis Constantes concernant l'orbite de la Terre:
      REAL R_ecc, R_peri, R_incl
! A1.2 Geoide
      REAL RA,RG,R1SA
! A1.3 Radiation
!     REAL RSIGMA,RI0
      REAL RSIGMA
! A1.4 Thermodynamic gas phase
      REAL R,RMD,RMO3,RMV,RD,RV,RCPD,RCPV,RCVD,RCVV
      REAL RKAPPA,RETV
! A1.5,6 Thermodynamic liquid,solid phases
      REAL RCW,RCS
! A1.7 Thermodynamic transition of phase
      REAL RLVTT,RLSTT,RLMLT,RTT,RATM
! A1.8 Curve of saturation
      REAL RESTT,RALPW,RBETW,RGAMW,RALPS,RBETS,RGAMS
      REAL RALPD,RBETD,RGAMD
!
      COMMON/YOMCST/RPI   ,RCLUM ,RHPLA ,RKBOL ,RNAVO                   &
     &      ,RDAY  ,REA   ,REPSM ,RSIYEA,RSIDAY,ROMEGA                  &
     &      ,R_ecc, R_peri, R_incl                                      &
     &      ,RA    ,RG    ,R1SA                                         &
     &      ,RSIGMA                                                     &
     &      ,R     ,RMD   ,RMO3  ,RMV   ,RD    ,RV    ,RCPD             &
     &      ,RCPV  ,RCVD  ,RCVV  ,RKAPPA,RETV                           &
     &      ,RCW   ,RCS                                                 &
     &      ,RLVTT ,RLSTT ,RLMLT ,RTT   ,RATM                           &
     &      ,RESTT ,RALPW ,RBETW ,RGAMW ,RALPS ,RBETS ,RGAMS            &
     &      ,RALPD ,RBETD ,RGAMD
!    ------------------------------------------------------------------
!$OMP THREADPRIVATE(/YOMCST/)

!     Arguments
      integer klon, klev ! indices grilles horizontales et verticales
      integer iim, jjm ! nombre de mailles en longitude et latitude 
      real zphi(klon,klev) ! input-R-geopotentiel de chaque couche (reference ocean, en m2/s2)
      real rlat(klon), rlon(klon) ! latitude et longitude en degres
      real lat_jessai, lon_jessai ! latitude et longitude de l'essai nucleaire jessai
      real zmin_jessai, zmax_jessai ! altitudes min et max du champignon atomique jessai
      integer coord_jessai, kmin_jessai, kmax_jessai ! coordonnees lat, lon, zmin et zmax en sortie de la subroutine de l'essai nucleaire jessai

!     local
      integer i,k ! pour le boucles
      real dlat, dlon ! pas en latitude et longitude
      real alt(klon,klev) ! altitude a chaque niveau

!     initialisation
      kmin_jessai=0
      kmax_jessai=0
      coord_jessai=0

      dlat=180./jjm
      dlon=(2.*180.)/iim
      
       do i=1,klon
         do k=1,klev
           alt(i,k)=zphi(i,k)/RG
         enddo
       enddo

!#ifdef ISOVERIFIDRIS !ok
!       do i=1,klon
!       do k=1,klev
!          write(*,*) 'i,k,RG',i,k,RG
!          write(*,*) 'zphi', zphi(i,k)
!          write(*,*) 'alt', alt(i,k)
!       enddo
!       enddo
!#endif
      
      do i=1,klon
         if (((rlat(i)-dlat/2.).le.lat_jessai).and.
     :       ((rlat(i)+dlat/2.).gt.lat_jessai).and.
     :       ((rlon(i)-dlon/2.).le.lon_jessai).and.
     :       ((rlon(i)+dlon/2.).gt.lon_jessai)) then
                coord_jessai=i
                if (alt(i,1).ge.zmin_jessai)    kmin_jessai = 1 ! si base du champignon est plus bas que le niveau 1 dans le modele
                if (alt(i,1).ge.zmax_jessai)    kmax_jessai = 2 ! si le haut du champignon est plus bas que le niveau 1 du modele
                if (alt(i,klev).lt.zmin_jessai) kmin_jessai = klev  ! si base du champignon est plus haut que le niveau klev dans le modele
                if (alt(i,klev).lt.zmax_jessai) kmax_jessai = klev ! si le haut du champignon est plus haut que le niveau klev du modele
                do k=1,klev-1
                    if ((alt(i,k).lt.zmin_jessai).and.
     :                  (alt(i,k+1).ge.zmin_jessai)) then
                         kmin_jessai = max(1,k) ! si base du champignon est entre le niveau k et k+1
                    endif

                    if ((alt(i,k).lt.zmax_jessai).and.
     :                  (alt(i,k+1).ge.zmax_jessai)) then
                         kmax_jessai = min(k+1,klev) ! si le haut du champignon est entre le niveau k et k+1
                    endif
                enddo ! boucle klev
            exit ! on arrete la boucle le long de klon quand on a trouve les bonnes coordonnees
         endif ! trouve les bonnes coordonnees sur klon
      enddo ! boucle klon


!#ifdef ISOVERIFIDRIS 
!      write(*,*) 'controle subroutine coord_prod_nucl_HTO' !ok
!      write(*,*) 'iim,jjm,dlat,dlon',iim,jjm,dlat,dlon
!      write(*,*) 'indice coord_HTO', coord_jessai
!      write(*,*) 'rlat, lat_HTO',rlat(coord_jessai),lat_jessai
!      write(*,*) 'rlon, lon_HTO',rlon(coord_jessai),lon_jessai
!      write(*,*) 'kmin_HTO, kmax_HTO', kmin_jessai, kmax_jessai
!      write(*,*) 'alt_min(k), alt_min(k+1), zmin_HTO', 
!     :            alt(coord_jessai,kmin_jessai),
!     :            alt(coord_jessai,kmin_jessai+1),
!     :            zmin_jessai
!      write(*,*) 'alt_max(k), alt_max(k+1), zmax_HTO',
!     :            alt(coord_jessai,kmax_jessai),
!     :            alt(coord_jessai,kmax_jessai+1),
!     :            zmax_jessai
!#endif
      
      return
      end




! --------------------------------------------------------------------------------
! calcul_prod_nucl_HTO
! --------------------------------------------------------------------------------
      SUBROUTINE calcul_prod_nucl_HTO(P_jessai,coord_jessai,
     :                                kmin_jessai,kmax_jessai,
     :                                klon, klev, 
     :                                paprs,airephy,
     :                                prod_nucl)
      implicit none

!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      
!
! $Header$
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation
!                 (les placer en colonne 6 et en colonne 73)
!
!
! A1.0 Fundamental constants
      REAL RPI,RCLUM,RHPLA,RKBOL,RNAVO
! A1.1 Astronomical constants
      REAL RDAY,REA,REPSM,RSIYEA,RSIDAY,ROMEGA
! A1.1.bis Constantes concernant l'orbite de la Terre:
      REAL R_ecc, R_peri, R_incl
! A1.2 Geoide
      REAL RA,RG,R1SA
! A1.3 Radiation
!     REAL RSIGMA,RI0
      REAL RSIGMA
! A1.4 Thermodynamic gas phase
      REAL R,RMD,RMO3,RMV,RD,RV,RCPD,RCPV,RCVD,RCVV
      REAL RKAPPA,RETV
! A1.5,6 Thermodynamic liquid,solid phases
      REAL RCW,RCS
! A1.7 Thermodynamic transition of phase
      REAL RLVTT,RLSTT,RLMLT,RTT,RATM
! A1.8 Curve of saturation
      REAL RESTT,RALPW,RBETW,RGAMW,RALPS,RBETS,RGAMS
      REAL RALPD,RBETD,RGAMD
!
      COMMON/YOMCST/RPI   ,RCLUM ,RHPLA ,RKBOL ,RNAVO                   &
     &      ,RDAY  ,REA   ,REPSM ,RSIYEA,RSIDAY,ROMEGA                  &
     &      ,R_ecc, R_peri, R_incl                                      &
     &      ,RA    ,RG    ,R1SA                                         &
     &      ,RSIGMA                                                     &
     &      ,R     ,RMD   ,RMO3  ,RMV   ,RD    ,RV    ,RCPD             &
     &      ,RCPV  ,RCVD  ,RCVV  ,RKAPPA,RETV                           &
     &      ,RCW   ,RCS                                                 &
     &      ,RLVTT ,RLSTT ,RLMLT ,RTT   ,RATM                           &
     &      ,RESTT ,RALPW ,RBETW ,RGAMW ,RALPS ,RBETS ,RGAMS            &
     &      ,RALPD ,RBETD ,RGAMD
!    ------------------------------------------------------------------
!$OMP THREADPRIVATE(/YOMCST/)

!     Arguments
      real P_jessai ! production de HTO en kg par l'essai nucleaire jessai
      integer coord_jessai ! indice de coordonnee lat(coord_jessai) et lon(coord_jessai) de l'essai nucleaire jessai
      integer kmin_jessai, kmax_jessai ! indice de hauteur (ou pression) min et max du champignon atomique jessai
      integer klon, klev
      real paprs(klon,klev+1)  ! input-R-pression pour chaque inter-couche (en Pa) 
      real airephy(klon) ! aire d'une grille (m2)
      real prod_nucl(ntraciso,klon,klev) ! calcul de la production de HTO en kg par kg d'air sur la journee entre zmin et zmax --> d_xt_prod_nucl

!     local
      integer ixt,i,j,k ! pour les boucles
      real day_sec ! 1 jour en secondes
      real prod_nucl_tmp(klon,klev) ! calcul de la production de HTO en kg/kg d'air pour l'essai nucleaire jessai

      day_sec = 86400.
      ixt=iso_HTO
      j = coord_jessai
      do i=1,klon
      do k=1,klev
         prod_nucl_tmp(i,k)=0.
      enddo
      enddo
!#ifdef ISOVERIFIDRIS
!      write(*,*) 'ixt,j,coord_HTO',ixt,j,coord_jessai !ok
!      write(*,*) 'kmin_HTO, kmax_HTO', kmin_jessai, kmax_jessai
!      write(*,*) 'day_sec, P_HTO', day_sec, P_jessai
!#endif

      if (kmin_jessai.lt.klev) then ! si kmin < klev, normalement kmin < kmax
         do k=kmin_jessai,kmax_jessai
              prod_nucl_tmp(j,k) = 
     :          (P_jessai/day_sec)/( 
     :          (paprs(j,kmin_jessai)-paprs(j,kmax_jessai))
     :          /RG*airephy(j)       )
              prod_nucl(ixt,j,k)=prod_nucl(ixt,j,k)+prod_nucl_tmp(j,k)
         enddo
      else  ! si kmin = klev (et donc kmax = klev si tout va bien)
         do k=kmin_jessai,kmax_jessai
              prod_nucl_tmp(j,k) =
     :          (P_jessai/day_sec)/(
     :          (paprs(j,kmin_jessai)-paprs(j,kmax_jessai+1))
     :          /RG*airephy(j)       )
              prod_nucl(ixt,j,k)=prod_nucl(ixt,j,k)+prod_nucl_tmp(j,k)
         enddo
      endif

!#ifdef ISOVERIFIDRIS
!      do i=1,klon
!      do k=1,klev
!         write(*,*) 'controle calcul_prod_nucl_HTO' !ok
!         write(*,*) 'call if ok_prod_nucl_tritium, iso_HTO, nbombe>=1'
!         write(*,*) 'klon, klev', klon, klev
!         write(*,*) 'ixt, i, k', ixt, i, k
!         write(*,*) 'RG, airephy(i)', RG, airephy(i)
!         write(*,*) 'coord_HTO,kmin_HTO,kmax_HTO',
!     :               coord_jessai,kmin_jessai,kmax_jessai
!         write(*,*) 'P_HTO, day_sec', P_jessai, day_sec
!         write(*,*) 'paprs(coord_HTO,kmin),paprs(coord_HTO,kmax)',
!     :               paprs(coord_jessai,kmin_jessai), 
!     :               paprs(coord_jessai,kmax_jessai)
!         write(*,*) 'd_xt_prod_nucl(ixt,i,k)', prod_nucl(ixt,i,k)
!      enddo
!      enddo
!#endif

      return
      end


!===================================================================
!
!   End subroutines utilisees par iso_tritium
!
!===================================================================

