!
! $Header$
!
       SUBROUTINE  printflag( tabcntr0, radpas, 
     ,                        ok_journe,ok_instan,ok_region        )
c

c
c      Auteur :  P. Le Van 

       IMPLICIT NONE

       REAL tabcntr0( 100 )
       LOGICAL cycle_diurn0,soil_model0,new_oliq0,ok_orodr0
       LOGICAL ok_orolf0,ok_limitvr0
       LOGICAL ok_journe,ok_instan,ok_region
       INTEGER radpas , radpas0
c

!
! $Id: clesphys.h 1750 2013-04-25 15:27:27Z fairhead $
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation 
!                 (les placer en colonne 6 et en colonne 73)
!
!..include cles_phys.h
!
       LOGICAL cycle_diurne,soil_model,new_oliq,ok_orodr,ok_orolf 
       LOGICAL ok_limitvrai
       INTEGER nbapp_rad, iflag_con
       REAL co2_ppm, co2_ppm0, solaire
       REAL(kind=8) RCO2, RCH4, RN2O, RCFC11, RCFC12  
       REAL(kind=8) RCO2_act, RCH4_act, RN2O_act, RCFC11_act, RCFC12_act  
       REAL(kind=8) CH4_ppb, N2O_ppb, CFC11_ppt, CFC12_ppt
!IM ajout CFMIP2/CMIP5
       REAL co2_ppm_per
       LOGICAL ok_4xCO2atm
       REAL(kind=8) RCO2_per,RCH4_per,RN2O_per,RCFC11_per,RCFC12_per
       REAL(kind=8) CH4_ppb_per,N2O_ppb_per,CFC11_ppt_per,CFC12_ppt_per

!OM ---> correction du bilan d'eau global
!OM Correction sur precip KE
       REAL cvl_corr
!OM Fonte calotte dans bilan eau
       LOGICAL ok_lic_melt

!IM simulateur ISCCP 
       INTEGER top_height, overlap
!IM seuils cdrm, cdrh
       REAL cdmmax, cdhmax
!IM param. stabilite s/ terres et en dehors
       REAL ksta, ksta_ter
!IM ok_kzmin : clef calcul Kzmin dans la CL de surface cf FH
       LOGICAL ok_kzmin
!IM, MAFo fmagic, pmagic : parametres - additionnel et multiplicatif - 
!                          pour regler l albedo sur ocean
       REAL fmagic, pmagic
! Hauteur (imposee) du contenu en eau du sol
           REAL qsol0
! Frottement au sol (Cdrag)
       Real f_cdrag_ter,f_cdrag_oce
! Rugoro
       Real f_rugoro

!IM lev_histhf  : niveau sorties 6h
!IM lev_histday : niveau sorties journalieres
!IM lev_histmth : niveau sorties mensuelles
!IM lev_histdayNMC : on peut sortir soit sur 8 (comme AR5) ou bien 
!                    sur 17 niveaux de pression
       INTEGER lev_histhf, lev_histday, lev_histmth
       INTEGER lev_histdayNMC
       Integer lev_histins, lev_histLES  
!IM ok_histNMC  : sortie fichiers niveaux de pression (histmthNMC, histdayNMC, histhfNMC)
!IM freq_outNMC : frequences de sortie fichiers niveaux de pression (histmthNMC, histdayNMC, histhfNMC)
!IM freq_calNMC : frequences de calcul fis. hist*NMC.nc
!IM pasphys : pas de temps de physique (secondes)
       REAL pasphys
       LOGICAL ok_histNMC(3)
       REAL freq_outNMC(3) , freq_calNMC(3)
       CHARACTER(len=4) type_run
! aer_type: pour utiliser un fichier constant dans readaerosol 
       CHARACTER*8 :: aer_type 
       LOGICAL ok_isccp, ok_regdyn
       REAL lonmin_ins, lonmax_ins, latmin_ins, latmax_ins
       REAL ecrit_ins, ecrit_hf, ecrit_day
       REAL ecrit_mth, ecrit_tra, ecrit_reg 
       REAL ecrit_LES
       REAL freq_ISCCP, ecrit_ISCCP
       REAL freq_COSP
       LOGICAL :: ok_cosp,ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP
       INTEGER :: ip_ebil_phy, iflag_rrtm
       LOGICAL :: ok_strato
       LOGICAL :: ok_hines
       LOGICAL :: ok_qch4

       COMMON/clesphys/cycle_diurne, soil_model, new_oliq,              &
     &     ok_orodr, ok_orolf, ok_limitvrai, nbapp_rad, iflag_con       &
     &     , co2_ppm, solaire                                           &
     &     , RCO2, RCH4, RN2O, RCFC11, RCFC12                           &
     &     , RCO2_act, RCH4_act, RN2O_act, RCFC11_act, RCFC12_act       &
     &     , ok_4xCO2atm                                                & 
     &     , RCO2_per, RCH4_per, RN2O_per, RCFC11_per, RCFC12_per       &
     &     , CH4_ppb, N2O_ppb, CFC11_ppt, CFC12_ppt                     &
     &     , CH4_ppb_per, N2O_ppb_per, CFC11_ppt_per, CFC12_ppt_per     &
     &     , top_height, overlap, cdmmax, cdhmax, ksta, ksta_ter        &
     &     , ok_kzmin, fmagic, pmagic                                   &
     &     , f_cdrag_ter,f_cdrag_oce,f_rugoro                           &
     &     , lev_histhf, lev_histday, lev_histmth                       &
     &     , lev_histins, lev_histLES, lev_histdayNMC                   &
     &     , pasphys, ok_histNMC, freq_outNMC, freq_calNMC              &
     &     , type_run, ok_isccp, ok_regdyn, ok_cosp                     &
     &     , ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP                     &
     &     , lonmin_ins, lonmax_ins, latmin_ins, latmax_ins             &
     &     , ecrit_ins, ecrit_hf, ecrit_day                             &
     &     , ecrit_mth, ecrit_tra, ecrit_reg                            &
     &     , freq_ISCCP, ecrit_ISCCP, freq_COSP, ip_ebil_phy            &
     &     , ok_lic_melt, cvl_corr, aer_type                            &
     &     , qsol0, iflag_rrtm, ok_strato,ok_hines,ecrit_LES            &
     &     , co2_ppm0, ok_qch4
     
       save /clesphys/
!$OMP THREADPRIVATE(/clesphys/)
 
c
c
       PRINT 100
       PRINT *,' *******************************************************
     ,************'
       PRINT *,' ********   Choix  des principales  cles de la physique 
     ,   *********'
       PRINT *,' *******************************************************
     ,************'
       PRINT 100
       PRINT 10, cycle_diurne,  soil_model  
       PRINT 100

       IF   (    iflag_con.EQ. 1 )   THEN
           PRINT *,' *****           Shema  convection   LMD            
     ,          ******'
       ELSE IF ( iflag_con.EQ. 2 )   THEN
           PRINT *,' *****           Shema  convection  Tiedtke  
     ,          ******'
       ELSE IF ( iflag_con.GE. 3 )   THEN
           PRINT *,' *****           Shema  convection    Emanuel      
     ,          ******'
       ENDIF
       PRINT 100

       PRINT 11, new_oliq, ok_orodr, ok_orolf   
       PRINT 100

       PRINT 7,  ok_limitvrai   
       PRINT 100

       PRINT 12, nbapp_rad
       PRINT 100

       PRINT 8, radpas
       PRINT 100

       PRINT 4,ok_journe,ok_instan,ok_region
       PRINT 100
       PRINT 100
c
c
        cycle_diurn0  = .FALSE.
        soil_model0   = .FALSE.
        new_oliq0     = .FALSE.
        ok_orodr0     = .FALSE.
        ok_orolf0     = .FALSE.
        ok_limitvr0   = .FALSE.

        IF( tabcntr0( 7 ).EQ. 1. )   cycle_diurn0 = .TRUE.
        IF( tabcntr0( 8 ).EQ. 1. )    soil_model0 = .TRUE.
        IF( tabcntr0( 9 ).EQ. 1. )      new_oliq0 = .TRUE.
        IF( tabcntr0(10 ).EQ. 1. )      ok_orodr0 = .TRUE.
        IF( tabcntr0(11 ).EQ. 1. )      ok_orolf0 = .TRUE.
        IF( tabcntr0(12 ).EQ. 1. )    ok_limitvr0 = .TRUE.

        PRINT *,' $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
     ,$$$$$$$$$$$$$'
        PRINT 100
c
       IF( INT( tabcntr0( 5 ) ) .NE. iflag_con  )   THEN
        PRINT 20, INT(tabcntr0(5)), iflag_con
        PRINT 100
       ENDIF

       IF( INT( tabcntr0( 6 ) ) .NE. nbapp_rad  )   THEN
        PRINT 21,  INT(tabcntr0(6)), nbapp_rad
!        radpas0  = NINT( 86400./tabcntr0(1)/INT( tabcntr0(6) ) )
        PRINT 100
!        PRINT 22, radpas0, radpas
        PRINT 100
       ENDIF

       IF( cycle_diurn0.AND..NOT.cycle_diurne.OR..NOT.cycle_diurn0.AND.
     ,        cycle_diurne )     THEN
        PRINT 13, cycle_diurn0, cycle_diurne
        PRINT 100
       ENDIF

       IF( soil_model0.AND..NOT.soil_model.OR..NOT.soil_model0.AND.
     ,        soil_model )     THEN
        PRINT 14, soil_model0, soil_model
        PRINT 100
       ENDIF

       IF( new_oliq0.AND..NOT.new_oliq.OR..NOT.new_oliq0.AND.
     ,        new_oliq )     THEN
        PRINT 16, new_oliq0, new_oliq
        PRINT 100
       ENDIF

       IF( ok_orodr0.AND..NOT.ok_orodr.OR..NOT.ok_orodr0.AND.
     ,        ok_orodr )     THEN
        PRINT 15, ok_orodr0, ok_orodr
        PRINT 100
       ENDIF

       IF( ok_orolf0.AND..NOT.ok_orolf.OR..NOT.ok_orolf0.AND.
     ,        ok_orolf )     THEN
        PRINT 17, ok_orolf0, ok_orolf
        PRINT 100
       ENDIF

       IF( ok_limitvr0.AND..NOT.ok_limitvrai.OR..NOT.ok_limitvr0.
     ,     AND.ok_limitvrai )     THEN
        PRINT 18, ok_limitvr0, ok_limitvrai
        PRINT 100
       ENDIF

       PRINT 100
       PRINT *,' *******************************************************
     ,************'
       PRINT 100

 4    FORMAT(2x,5("*"),'  ok_journe= ',l3,3x,',ok_instan = ',
     , l3,3x,',ok_region = ',l3,3x,5("*") )

 7     FORMAT(2x,5("*"),15x,'      ok_limitvrai   = ',l3,16x,5("*") )

 8     FORMAT(2x,'*****             radpas    =                      ' ,
     , i4,6x,' *****')

 10    FORMAT(2x,5("*"),'    Cycle_diurne = ',l3,4x,', Soil_model = ',
     , l3,12x,6("*") )


 11    FORMAT(2x,5("*"),'  new_oliq = ',l3,3x,', Ok_orodr = ',
     , l3,3x,', Ok_orolf = ',l3,3x,5("*") )


 12    FORMAT(2x,'*****  Nb d appels /jour des routines de rayonn. = ' ,
     , i4,6x,' *****')

 13    FORMAT(2x,'$$$$$$$$   Attention !!  cycle_diurne  different  sur',
     , /1x,10x,' startphy = ',l3,2x,' et  run.def = ',l3)

 14    FORMAT(2x,'$$$$$$$$   Attention !!    soil_model  different  sur',
     , /1x,10x,' startphy = ',l3,2x,' et  run.def = ',l3)

 15    FORMAT(2x,'$$$$$$$$   Attention !!      ok_orodr  different  sur',
     , /1x,10x,' startphy = ',l3,2x,' et  run.def = ',l3)

 16    FORMAT(2x,'$$$$$$$$   Attention !!      new_oliq  different  sur',
     , /1x,10x,' startphy = ',l3,2x,' et  run.def = ',l3)

 17    FORMAT(2x,'$$$$$$$$   Attention !!      ok_orolf  different  sur',
     , /1x,10x,' startphy = ',l3,2x,' et  run.def = ',l3)

 18    FORMAT(2x,'$$$$$$$$   Attention !!  ok_limitvrai  different  sur',
     , /1x,10x,' startphy = ',l3,2x,' et  run.def = ',l3)

 20    FORMAT(/2x,'$$$$$$$$   Attention !!    iflag_con  different  sur',
     , /1x,10x,' startphy = ',i3,2x,' et  run.def = ',i3 )

 21    FORMAT(2x,'$$$$$$$$   Attention !!     nbapp_rad  different  sur',
     , /1x,10x,' startphy = ',i3,2x,' et  run.def = ',i3 )

 22    FORMAT(2x,'$$$$$$$$   Attention !!        radpas  different  sur',
     , /1x,10x,' startphy = ',i3,2x,' et  run.def = ',i3 )

 100   FORMAT(/)

       RETURN
       END
