! subroutine gnrique de traitement de l'vaporation des gouttes
!  ne pas modifier sauf si vous tes surs de ce que vous faites.      


      subroutine stewart_explicite_vectall(ncas,
     :           qp0,xtp0,Pqisup
     :           ,Pxtisup,Eqi,Pqiinf,qeff,
     :           Pxtiinf,xtnew,Exi,fac_ftmr,
     :           qs,Tevap,wt,deltaP



     :   )

        implicit none

        ! version vctorise: sur les isotopes et sur les points de
        ! grille
        ! on s'interresse  l'isotope ixt
        ! on a un air de proprit (q,xt) 
        ! on lui apporte une goutte de flux (Pqisup,Pxtisup)
        ! cette goutte s'vapore avec un flux Eqi
        ! on cherche le flux de sortie Pxtiinf et la nouvelle
        ! composition de l'air xtnew, sachant que qnew=q+Eqi*fac_ftmr
        
        ! declaration des variables      
!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
        ! **inputs
        integer ncas
        double precision qp0(ncas),xtp0(niso,ncas)
        double precision Pxtisup(niso,ncas)
        double precision Pqisup(ncas),Eqi(ncas),Pqiinf(ncas)
        real qs(ncas),qeff(ncas)
        double precision fac_ftmr(ncas)
        
        real Tevap(ncas)
        real deltaP(ncas),wt(ncas)
        
        ! **outputs
        double precision Pxtiinf(niso,ncas)
        double precision xtnew(niso,ncas)
        double precision Exi(niso,ncas)
        integer ixt
        
        ! **locals
        ! verifs
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      

        ! intermediaires
        real h(ncas)
        double precision gama(niso,ncas), beta(niso,ncas), 
     :           interm(niso,ncas)
        real alphap(niso,ncas)
        double precision Rl0(niso,ncas), Rb0(niso,ncas), Rl(niso,ncas), 
     :           Rb(niso,ncas)
        double precision m(ncas), m0(ncas), A(ncas), qp(ncas)
        double precision J(niso,ncas),e(niso,ncas)
        double precision r_l0qp0(ncas), r_jqp0(niso,ncas), 
     :           r_jl0(niso,ncas)
        double precision f(ncas),g(ncas)
        double precision Revap(niso,ncas)
        double precision Revap0(niso,ncas)
        double precision Revapfin(niso,ncas)
        real fv(ncas)

        real double_to_real ! debugage
        double precision real_to_double        
        integer il
        integer iso_verif_noNaN_nostop
! calcul d'intgrale: mtode?
        ! si rieman:
!#define rieman 
        ! sinon: gauss.
        

        ! parsage
        integer trace(ncas)
        integer icas_Jsimple,ncas_Jsimple
        integer icas_rieman,ncas_rieman
        integer cas_Jsimple(ncas)
        integer cas_rieman(ncas)
        
        double precision m_cas(ncas), m0_cas(ncas),
     :     qp0_cas(ncas),A_cas(ncas),
     :     beta_cas(niso,ncas),gama_cas(niso,ncas),f_cas(ncas),
     :     g_cas(ncas),
     :     Rb0_cas(niso,ncas),Rl0_cas(niso,ncas),r_l0qp0_cas(ncas),
     :     Exi_cas(niso,ncas),Pxtiinf_cas(niso,ncas),
     :     Pxtisup_cas(niso,ncas),
     :     xtnew_cas(niso,ncas),Pqiinf_cas(ncas),
     :     Eqi_cas(ncas),xtp0_cas(niso,ncas)
        double precision fac_ftmr_cas(ncas)
!        integer ntot_cas(ncas)

!        include "dimiso.h"
        

        ! quelques verifs de bilan d'eau
         
!          write(*,*) 'stewart_explicite 88: Pqisup=',Pqisup
         do il=1,ncas 
          Pqisup(il)=max(Pqisup(il),0.0)
          do ixt=1,niso
           Pxtisup(ixt,il)=max(Pxtisup(ixt,il),0.0)           
          enddo !do ixt=1,niso
         enddo !do il=1,ncas   

        
        ! ***************** dbut des calculs **********
        
        icas_Jsimple=0
        icas_rieman=0
        do il=1,ncas ! ******************************

!        write(*,*) 'stewart_explicite 78: il=',il
!        write(*,*) 'stewart_explicite 112: Pqisup=',Pqisup
        !****** traitement rapide du cas sans pluie:
        if (Pqisup(il).lt.ridicule**2) then
!            write(*,*) 'stewart_explicit 96: cas pas de goutte'
            ! pas de pluie, pas de Pqiinf, pas de changement de vap
            ! cam verif
            ! le 21 dec 2012: on change le.0 en lt.ridicule**2 pour
            ! viter des Pqisup pathologiquement petits
            ! end cam verif
            do ixt=1,niso
              Pxtiinf(ixt,il)=0.0
            enddo
            if (abs(Eqi(il)*fac_ftmr(il)).gt.ridicule) then
                ! attention: pour des raisons obscures, il y a parfois
                ! de le rvaporation significative alors qu'il n'y a
                ! aucune goutte  rvaporer.
                ! Dans ce cas, on admet cette rvaporation obscure et
                ! on suppose qu'elle ne change pas la composition
                ! isotopique de la vapeur. 
                if (qp0(il).gt.ridicule) then
                   do ixt=1,niso
                   Rb0(ixt,il)=xtp0(ixt,il)/qp0(il)  
                   enddo
                else !if (qp0.gt.ridicule) then
                   ! il n'y a pas encore de vapeur dans le ddft. On est
                   ! trs embtt, mais on se dit que le ddft sera
                   ! bientot recharg par de la vapeur plus lgitime
                   do ixt=1,niso
                   Rb0(ixt,il)=0.0     
                   enddo ! do ixt=1,niso
                   if (use_iso_eau.eq.1) then
                        Rb0(iso_eau,il)=1.0
                   endif
                endif   !if (qp0.gt.ridicule) then
                do ixt=1,niso
                 Exi(ixt,il)=Rb0(ixt,il)*Eqi(il)
                 xtnew(ixt,il)=xtp0(ixt,il)+Exi(ixt,il)*fac_ftmr(il)
                enddo ! do ixt=1,niso
            else !if (abs(Eqi*fac_ftmr).gt.ridicule) then
                ! a va, tout est logique, tous les flux d'eau sont nuls
                do ixt=1,niso
                  xtnew(ixt,il)=xtp0(ixt,il)
                  Exi(ixt,il)=0.0
                enddo !do ixt=1,niso
            endif !if (abs(Eqi*fac_ftmr).gt.ridicule) then
        else !if (Pqisup.eq.0) then

        h(il)=qeff(il)/qs(il)       
        h(il)= MAX(MIN(h(il),1.0),0.0)
        
        ! ******** cas avec eau: Pqisup>0
        ! cas ou pas d'vaporation -> tout reste pareil si pas de diff.
        ! en fait, tout reste pareil si h<1, car diff devient alors
        ! difficile
        if ((Eqi(il)*fac_ftmr(il).lt.ridicule).and.(h(il).lt.0.99)) then
!            write(*,*) 'stewart_explicite 137: cas pas d''vap'

            do ixt=1,niso
              Pxtiinf(ixt,il)=Pqiinf(il)*(Pxtisup(ixt,il)/Pqisup(il))
              Exi(ixt,il)=0.0
              xtnew(ixt,il)=xtp0(ixt,il)
            enddo !do ixt=1,niso

            ! verif
             ! end verif

         else !if ((Eqi(il)*fac_ftmr(il).lt.ridicule).and.(h(il).lt.0.99)) then     

        A(il)=wt(il)/deltaP(il)*fac_ftmr(il)
        m0(il)=max(Pqisup(il)*deltaP(il)/wt(il),0.0)
        m(il)=max(Pqiinf(il)*deltaP(il)/wt(il),0.0)      
        if (qp0(il).gt.ridicule*1e-3)  then
          do ixt=1,niso
           Rb0(ixt,il)=xtp0(ixt,il)/qp0(il)
          enddo
        else
          do ixt=1,niso  
           Rb0(ixt,il)=0.0 
          enddo !do ixt=1,niso
          if (use_iso_eau.eq.1) then
              Rb0(iso_eau,il)=1.0
          endif
        endif
        if (Pqisup(il).gt.ridicule*1e-3) then
          do ixt=1,niso  
           Rl0(ixt,il)=Pxtisup(ixt,il)/Pqisup(il)
          enddo !do ixt=1,niso 
        else ! if (Pqisup(il).gt.ridicule*1e-3) then
          do ixt=1,niso  
           Rl0(ixt,il)=0.0
          enddo !do ixt=1,niso 
          if (use_iso_eau.eq.1) then
              Rl0(iso_eau,il)=1.0
          endif
        endif ! if (Pqisup(il).gt.ridicule*1e-3) then
        f(il)=m(il)/m0(il)    
        ! verifs
        qp0(il)=max(0.0,qp0(il))
        m(il)=min(m(il),m0(il))
        f(il)=min(f(il),1.0)
        f(il)=max(f(il),0.0)


        ! end verif

                
        ! **** cas o m=0 <-> f=0
        if ((f(il).lt.1e-9).or.(Pqiinf(il).lt.ridicule/10.)) then
            !write(*,*) 'stewart_explicit 137: cas f=0: il=',il
          do ixt=1,niso 
            Pxtiinf(ixt,il)=0.0 ! plus rien ne ressors           
!            Exi(ixt,il)=Eqi(il)*(Pxtisup(ixt,il)/Pqisup(il)) ! tout se rvapore en totalit
            Exi(ixt,il)=Eqi(il)*  Rl0(ixt,il)  ! modif le 21 dec 2012
            !Exi=max(Exi,0) 
            !xtnew=(xtp0+Rl0*m0*A) 
            xtnew(ixt,il)=xtp0(ixt,il)+Exi(ixt,il)*fac_ftmr(il)
            xtnew(ixt,il)=max(xtnew(ixt,il),0.0)
          enddo !do ixt=1,niso      
                ! cam verifs



                ! end verifs                
          else !if ((f.lt.errmaxrel).or.(Pqiinf.lt.errmax)) then
                    
                    
        do ixt=1,niso            
        CALL FRACTCALK_liq(IXT, TEVAP(il), alphap(ixt,il))
        enddo !do ixt=1,niso 

        ! **** cas o h=1 -> equilibre
        ! on rajoute ce cas le 8 dec 2011 pour viter overflow errors
        ! dans le cas 1er ordre pour la vapeur
        ! on remplace aussi le alpha en gama pour tre plus prcis
        if ((h(il).gt.0.99).or.
     :           (h(il).gt.0.98).and.(f(il).lt.1e-3)) then



            do ixt=1,niso
            interm(ixt,il)=alphap(ixt,il)*(1.0-h(il))
     :           *tdifrel(IXT)**(tdifexp)
            gama(ixt,il)=alphap(ixt,il)*h(il)/(1.0-interm(ixt,il))
            Rb(ixt,il)=(Rb0(ixt,il)*qp0(il)+Rl0(ixt,il)*m0(il)*A(il))/
     :        (qp0(il)+A(il)*m0(il)*(1-f(il))+A(il)*f(il)*m0(il)
     :           *gama(ixt,il))
            Rl(ixt,il)=gama(ixt,il)*Rb(ixt,il)
            Pxtiinf(ixt,il)=Pqiinf(il)*Rl(ixt,il)            
            Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)   
            !xtnew=xtp0+Exi*fac_ftmr
            xtnew(ixt,il)=Rb(ixt,il)*(qp0(il)+Eqi(il)*fac_ftmr(il))    
            xtnew(ixt,il)=max(xtnew(ixt,il),0.0)
          enddo !do ixt=1,niso 
          if (fac_ftmr(il).gt.0.0) then
             do ixt=1,niso  
               Exi(ixt,il)=(xtnew(ixt,il)-xtp0(ixt,il))/fac_ftmr(il)
             enddo !do ixt=1,niso   
          else
            do ixt=1,niso   
               Exi(ixt,il)=Pxtisup(ixt,il)-Pxtiinf(ixt,il)
            enddo !do ixt=1,niso    
          endif
            !Exi=max(Exi,0)

            ! verif
            ! end verifs

        else if ((f(il).gt.0.998).and.
     :           (Eqi(il)*fac_ftmr(il).lt.1e-2*qp0(il))) then

        !*** cas particulier pour viter imprcisions numriques:
            ! dans ce cas, on fait l'hypoythse que Rl et Rb varient peu
            ! -> approx au premier ordre: Revap intgr = Revap initial
            ! f>0.998 veut dire que la goutte varie peu, tandis que
            ! Eqi<<qp0/fac_ftmr veut dire que la vapeur varie peu
           do ixt=1,niso
            Revap0(ixt,il)=tdifrel(IXT)**(tdifexp)
     :          *(Rl0(ixt,il)/alphap(ixt,il)
     :           -h(il)*Rb0(ixt,il))/(1-h(il))
            Exi(ixt,il)=Eqi(il)*Revap0(ixt,il)
            Pxtiinf(ixt,il)=Pxtisup(ixt,il)-Exi(ixt,il)          
            xtnew(ixt,il)=xtp0(ixt,il)+Exi(ixt,il)*fac_ftmr(il)

!            ! modif du 4 sept 2007: on simplifie
!            Revap(ixt,il)=Revap0(ixt,il)
            ! modif abandonne
            Revapfin(ixt,il)=tdifrel(IXT)**(tdifexp)
     :         *(Pxtiinf(ixt,il)/Pqiinf(il)/alphap(ixt,il)
     :         -h(il)*xtnew(ixt,il)/(qp0(il)+Eqi(il)*fac_ftmr(il)))
     :           /(1-h(il)) 
            Revap(ixt,il)=0.5*(Revap0(ixt,il)+Revapfin(ixt,il))

            Exi(ixt,il)=Eqi(il)*Revap(ixt,il)
            Exi(ixt,il)=max(min(Exi(ixt,il),Pxtisup(ixt,il)),
     :           -xtp0(ixt,il)/fac_ftmr(il))
            Pxtiinf(ixt,il)=Pxtisup(ixt,il)-Exi(ixt,il)            
            xtnew(ixt,il)=xtp0(ixt,il)+Exi(ixt,il)*fac_ftmr(il)
           enddo !do ixt=1,niso        
            ! verifs
            ! end verif

        else ! f.gt.0.99
        

          ! *** cas o pas d'air
          if ((h(il).lt.1e-3).or.(qp0(il).lt.1e-8)) then
!              write(*,*) 'stewart_explicit 349: cas pas d''air'
              !**** calcul de Rl
!                Rl=Rl0*f**beta ! on fait autrement pour viter
!                underflow exception si f trop petit et beta >1
              do ixt=1,niso
               interm(ixt,il)=alphap(ixt,il)*tdifrel(IXT)**(tdifexp)
               beta(ixt,il)=(1.0-interm(ixt,il))/(interm(ixt,il))
!                Rl(ixt,il)=Rl0(ixt,il)*puissance_double(f,beta(ixt,il))
                 ! on inline:
                Rl(ixt,il)=Rl0(ixt,il)
     :             *10.0**(min(max(beta(ixt,il)*log(f(il)),
     :             -expb_max),expb_max))
              enddo 
              ! **** calcul de Rb  
!                Rb=Rl0*(1-f**(beta+1))/(1-f) ! on fait autrement pour
!                viter underflow exception:
                
                do ixt=1,niso
                  Rb(ixt,il)=(A(il)*m0(il)*Rl0(ixt,il)*(1.0-exp
     :             (min(max((beta(ixt,il)+1.0)*log(f(il)),
     :             -expb_max),expb_max)))+qp0(il)*Rb0(ixt,il))
     :                   /(qp0(il)+A(il)*m0(il)*(1.0-f(il)))
                  ! correction bug 19 mars 2010: dnom tait faux
                  Pxtiinf(ixt,il)=Pqiinf(il)*Rl(ixt,il)
                  Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)
                  xtnew(ixt,il)=Rb(ixt,il)
     :                   *(qp0(il)+Eqi(il)*fac_ftmr(il))
                enddo
                if (fac_ftmr(il).gt.0.0) then
                    do ixt=1,niso
                        Exi(ixt,il)=(xtnew(ixt,il)-xtp0(ixt,il))
     :                   /fac_ftmr(il)
                    enddo    
                else !if (fac_ftmr.gt.0.0) then
                    do ixt=1,niso
                        Exi(ixt,il)=Pxtisup(ixt,il)-Pxtiinf(ixt,il)
                    enddo ! do ixt=1,niso    
                endif !if (fac_ftmr.gt.0.0) then
                !Exi=max(Exi,0) 

                ! cam verifs
                ! end verifs

            !else if (fac_ftmr(il).gt.1e18) then
            else if (fac_ftmr(il).gt.1e24) then

                ! *** cas o flux de masse nul
                do ixt=1,niso
                interm(ixt,il)=alphap(ixt,il)*(1.0-h(il))
     :           *tdifrel(IXT)**(tdifexp)
                beta(ixt,il)=(1.0-interm(ixt,il))/(interm(ixt,il))
                enddo


!                write(*,*) 'stewart_explicit 349: cas Mp=0'
              do ixt=1,niso 
                Rl(ixt,il)=Rl0(ixt,il)*f(il)**beta(ixt,il)
                Pxtiinf(ixt,il)=Pqiinf(il)*Rl(ixt,il)
                Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)
                Exi(ixt,il)=Pxtisup(ixt,il)-Pxtiinf(ixt,il)
                !Exi=max(Exi,0) 
                xtnew(ixt,il)=xtp0(ixt,il)
              enddo ! do ixt=1,niso   

                ! cam verifs
                ! end verifs

            else ! else if (fac_ftmr(il).gt.1e18) then


            !**** cas gnral

!            write(*,*) 'stewart_explicit 403: cas gnral'
            do ixt=1,niso
              interm(ixt,il)=alphap(ixt,il)*(1.0-h(il))
     :           *tdifrel(IXT)**(tdifexp)
              beta(ixt,il)=(1.0-interm(ixt,il))/(interm(ixt,il))
              gama(ixt,il)=alphap(ixt,il)*h(il)/(1-interm(ixt,il))
            enddo

            ! modif le 13 juin 2012: seuil 1e-2 -> 5e-2
            ! le 15 juin: on revient  1e-2 car sinon, vapeur varie trop
            if (Eqi(il)*fac_ftmr(il)/qp0(il).lt.1e-2) then
                        ! premier ordre pour la vapeur
                        ! cas ajout le 7 dec 2011 car le cas gnral
                        ! compliqu donne des choses aberrantes pour
                        ! l'O17excess
                    ! distinction ajoutee le 8 dec 2011 pour eviter les
                    ! underflow exceptions quand f**beta fait dans les
                    ! 1e-300.    
               if (-h(il)/(1-h(il))*log(f(il)).gt.30.0) then
                do ixt=1,niso
                   Rl(ixt,il) = Rl0(ixt,il)*f(il)**beta(ixt,il)
     :              +gama(ixt,il)*Rb0(ixt,il)*(1.0-f(il)**beta(ixt,il))
                enddo
               else !if (-h(il)/(1-h(il))*log(f(il)).gt.30.0) then
                do ixt=1,niso
                   Rl(ixt,il) = gama(ixt,il)*Rb0(ixt,il)
                enddo   
               endif !if (-h(il)/(1-h(il))*log(f(il)).gt.30.0) then
                do ixt=1,niso
                Rb(ixt,il)=((Rl0(ixt,il)-Rl(ixt,il)*f(il))
     :                  *Pqisup(il)*fac_ftmr(il)
     :                   +Rb0(ixt,il)*qp0(il))
     :                   /(qp0(il)+Eqi(il)*fac_ftmr(il))
                Pxtiinf(ixt,il)=Pqiinf(il)*Rl(ixt,il)
                Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)  
                xtnew(ixt,il)=Rb(ixt,il)*(qp0(il)+Eqi(il)*fac_ftmr(il)) 
                xtnew(ixt,il)=max(xtnew(ixt,il),0.0)              
                if (fac_ftmr(il).gt.0.0) then
                 Exi(ixt,il)=(xtnew(ixt,il)-xtp0(ixt,il))/fac_ftmr(il)
                else
                 Exi(ixt,il)=Pxtisup(ixt,il)-Pxtiinf(ixt,il)
                endif
                !Exi=max(Exi,0) 
                Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)
               enddo !do ixt=1,niso


            else if ((A(il)*m0(il)/qp0(il).gt.10.0).and.
     :                (1.0-f(il).lt.1e-5)) then
                ! beaucoup de liquide se rvaporant trs peu dans un
                ! tout petit peu de vapeur. Ca peut donner des cas
                ! pathologiques avec des vapeurs abrrantes -> on fait
                ! une approx de compo constante du liquide et on se
                ! concentre sur l'volution de la compo de la vapeur.

                fv(il)=1.0+Eqi(il)*fac_ftmr(il)/qp0(il)
                do ixt=1,niso
                  Rb(ixt,il)=(1+beta(ixt,il))/(1+beta(ixt,il)
     :                 *gama(ixt,il))*Rl0(ixt,il)
     :                 *(1-fv(il)**(-(1+beta(ixt,il)*gama(ixt,il))))
     :                 +Rb0(ixt,il)*fv(il)
     :                 **(-(1+beta(ixt,il)*gama(ixt,il)))
                  Rl(ixt,il)=(Rl0(ixt,il)*A(il)*m0(il)
     :                 +Rb0(ixt,il)*qp0(il)
     :                 -fv(il)*qp0(il)*Rb(ixt,il))
     :                 /(A(il)*m0(il)+qp0(il)*(1-fv(il)))
                  Pxtiinf(ixt,il)=Pqiinf(il)*Rl(ixt,il)
                  xtnew(ixt,il)=Rb(ixt,il)*
     :                 (qp0(il)+Eqi(il)*fac_ftmr(il)) 
                  Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)
                  xtnew(ixt,il)=max(xtnew(ixt,il),0.0)          
                  if (fac_ftmr(il).gt.0.0) then
                     Exi(ixt,il)=(xtnew(ixt,il)
     :                 -xtp0(ixt,il))/fac_ftmr(il)
                  else
                     Exi(ixt,il)=Pxtisup(ixt,il)-Pxtiinf(ixt,il)
                  endif
                enddo !do ixt=1,niso

                ! vrifs

            else !if (Eqi(il)*fac_ftmr(il)/qp0(il).lt.5e-2) then

            !**** cas gnral

!            if ((allow_ordre1v).and.
!     :           (Eqi(il)*fac_ftmr(il).lt.1e-2*qp0(il)).and.
!     :            (h.lt.0.97)) then
!               ! peu d'apport d'vap dans la vapeur, et peu diffusf ->
!               ! peu de modif de la vapeur -> on utilse l'ordre 1 pour
!               ! la vapeur
!            endif

            g(il)=(qp0(il)-A(il)*(m(il)-m0(il)))/qp0(il)

            ! encore un cas particulier!
            ! quand f trs petit et surtout f**beta trs petit, on
            ! traite  part.
            r_l0qp0(il)=A(il)*m0(il)/qp0(il)            
!            if (  ((f.lt.0.005).and.(h.gt.0.5)) ! orig: beta.gt.7
!     :           .or.((f.lt.0.01).and.(h.gt.0.85)) ! orig: beta.gt.8
!     :           .or.((f.lt.0.1).and.(h.gt.0.9))
!     :           .or.((f.lt.0.15).and.(h.gt.0.95))            
!     :           .or.((f.lt.0.2).and.(h.gt.0.98))) then 
            if ((h(il).gt.0.5).and.(f(il).lt.0.2).and.
     :           (f(il).lt.0.005+3*(h(il)-0.5)**4)) then
                ! la fonction flimite(h(il))=0.005+3*(h(il)-0.5)**4 est
                ! une courbe qui colle aux points de repres utiliss
                ! prcdemment. Elle est teste das GCMiso/tests_offline/integrale/gnuplot_cas_f_petit.plot

            do ixt=1,niso
               Rl(ixt,il) = gama(ixt,il)
     :           * (Rl0(ixt,il)*r_l0qp0(il)+Rb0(ixt,il)) 
     :             / (1+r_l0qp0(il))
     :              * (1-f(il)*r_l0qp0(il))
     :           /(1-f(il)*r_l0qp0(il)*gama(ixt,il))          
               Rb(ixt,il)= (Rl0(ixt,il)*r_l0qp0(il)+Rb0(ixt,il))
     :           / (1+r_l0qp0(il))

               Pxtiinf(ixt,il)=Pqiinf(il)*Rl(ixt,il) 
               Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)  
               xtnew(ixt,il)=Rb(ixt,il)*(qp0(il)+Eqi(il)*fac_ftmr(il)) 
               xtnew(ixt,il)=max(xtnew(ixt,il),0.0)
              
               if (fac_ftmr(il).gt.0.0) then
                 Exi(ixt,il)=(xtnew(ixt,il)-xtp0(ixt,il))/fac_ftmr(il)
               else
                 Exi(ixt,il)=Pxtisup(ixt,il)-Pxtiinf(ixt,il)
               endif
               !Exi=max(Exi,0) 
               Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)
               xtnew(ixt,il)=max(xtnew(ixt,il),0.0) 
               
             enddo !do ixt=1,niso

              ! cam verifs
          ! end verifs  
            
        else if (abs((g(il)**((1-2*h(il))/(1-h(il))))-1.0).lt.1e-2) then
                ! dans ce cas, le premier facteur de func (la fonction a
                ! intgrer) est environ constant et gal  1. on a alors
                ! func=(x/m)**(-beta-1), intgrable analytiquement:
!                write(*,*) 'stewart_explicite 684:calcul analytique'
                icas_Jsimple=icas_Jsimple+1
                cas_Jsimple(icas_Jsimple)=il
                        
        else !if ((g**(1-beta*gama))-1.0.lt.errmaxrel*10) then
                ! dans ce cas, la fonction est trop compliqu  intgrer
                ! analytiquement. On intgre donc numriquement.
!                write(*,*) 'stewart_explicite 684:calcul numrique'
                ! on traitera ce cas en vectoriel:
                icas_rieman=icas_rieman+1
                cas_rieman(icas_rieman)=il
          endif !if ((g**(1-beta*gama))-1.0.lt.errmaxrel*10) then

            
          ! end verifs
        endif !if (Eqi(il)*fac_ftmr(il)/qp0(il).lt.5e-2) then
      endif !if ((h.lt.1e-3).or.(qp0.lt.1e-8)) then   
      endif !if (h(il).gt.0.99) then
      endif !if ((f(il).lt.1e-9).or.(Pqiinf(il).lt.ridicule/10.)) then
      endif !!if ((Eqi(il)*fac_ftmr(il).lt.ridicule).and.(h(il).lt.0.99)) then 
      endif ! Pqisup.le.0
      enddo ! do il=1,ncas


      ncas_rieman=icas_rieman
      ncas_Jsimple=icas_Jsimple
!#ifdef ISOVERIF
!      write(*,*) 'stewart_explicite_vectall 812: ncas=',ncas
!      write(*,*) 'ncas_rieman=',ncas_rieman
!      write(*,*) 'ncas_Jsimple=',ncas_Jsimple      
!#endif      

      !******** traitement vectoriel des cas Rieman et Jsimple:
      ! compression
      if (ncas_Jsimple+ncas_rieman.gt.0) then
!#ifdef ISOVERIF          
!        write(*,*) 'stewart_explicite_vectall 873:compression_calculJ' 
!#endif        
        call compress_calculJ(ncas,ncas_Rieman,ncas_Jsimple, 
     :           cas_rieman,cas_Jsimple,
     :           m_cas,m, m0_cas,m0, 
     :           qp0_cas,qp0, A_cas,A,
     :           xtp0_cas,xtp0,   
     :           beta_cas,beta,gama_cas,gama,
!     :           f_cas,f, g_cas,g,ntot_cas,h,
     :           f_cas,f, g_cas,g,h,
     :           Rb0_cas,Rb0,
     :           Rl0_cas,Rl0,
     :           r_l0qp0_cas,r_l0qp0,   
     :           Eqi_cas,Eqi,
     :           fac_ftmr_cas,fac_ftmr,
     :           Pxtisup_cas,Pxtisup,
     :           Pqiinf_cas,Pqiinf)


      ! ************ traitement vectoriel du cas J simplifi
      if (ncas_Jsimple.gt.0) then
!#ifdef ISOVERIF
!          write(*,*) 'traitement vectoriel J simple: x',ncas_Jsimple
!#endif          
        do il=1,ncas_Jsimple
          do ixt=1,niso
            J(ixt,il)=m_cas(il)*(1.0-10.0
     :           **(min(max(beta_cas(ixt,il)*log(f_cas(il))/log(10.0),
     :             -expb_max),expb_max)))/beta_cas(ixt,il)            
            e(ixt,il)=0.0
          enddo  !do ixt=1,niso  
        enddo !do il=1,ncas_Jsimple
       endif !if (ncas_Jsimple.gt.0) then
              

            ! ******* traitement vectoriel du cas Rieman (=2533)
       if (ncas_rieman.gt.0) then
!#ifdef ISOVERIF
!!          write(*,*) 'traitement vectoriel rieman: x',ncas_rieman
!          do icas_rieman=1+ncas_Jsimple,ncas_rieman+ncas_Jsimple
!!            write(*,*) 'ntot_cas(icas_rieman)=',ntot_cas(icas_rieman)
!          call iso_verif_positif(float(ntot_cas(icas_rieman))-1.0,
!     :           'stewart_expl 984: ntot faux') 
!          enddo   !do icas_rieman=1,ncas_rieman       
!#endif            
           icas_rieman=1+ncas_Jsimple
!           write(*,*) 'stewart_expl 988 tmp: icas_rieman=',icas_rieman
!           write(*,*) 'qp0_cas(1)=',qp0_cas(1)
!           write(*,*) 'A_cas(1)=',A_cas(1)
!           write(*,*) 'm0_cas(1)=',m0_cas(1)
!           write(*,*) 'm_cas(1)=',m_cas(1)
!           if (use_iso_eau.eq.1) then
!           write(*,*) 'beta_cas(iso_eau,1)=',beta_cas(iso_eau,1)
!           write(*,*) 'gama_cas(iso_eau,1)=',gama_cas(iso_eau,1)
!           endif
!           write(*,*) 'f_cas(1)=',f_cas(1)
!           write(*,*) 'g_cas(1)=',g_cas(1)
!#ifdef rieman           
!           call integrale_rieman_vectall
!     :       (ncas_rieman,m_cas(icas_rieman),
!     :       J(1,icas_rieman),e(1,icas_rieman),
!     :       qp0_cas(icas_rieman),A_cas(icas_rieman),
!     :       m0_cas(icas_rieman),beta_cas(1,icas_rieman),
!     :       gama_cas(1,icas_rieman),f_cas(icas_rieman),
!     :       g_cas(icas_rieman),ntot_cas(icas_rieman))
!#else
           call integrale_gauss_vectall
     :       (ncas_rieman,m_cas(icas_rieman),
     :       J(1,icas_rieman),
     :       qp0_cas(icas_rieman),A_cas(icas_rieman),
     :       m0_cas(icas_rieman),beta_cas(1,icas_rieman),
     :       gama_cas(1,icas_rieman),
!     :       g_cas(icas_rieman),ntot_cas(icas_rieman))
     :       g_cas(icas_rieman))      
!#endif
!#ifdef ISOVERIF
!           do il=1+ncas_Jsimple,ncas_rieman+ncas_Jsimple
!             do ixt=1,niso
!               call integrale_Rieman_precision(m_cas(il),m0_cas(il),
!     :          Jtmp,etmp,ntot_cas(il)*1e2,
!     :           qp0_cas(il),A_cas(il),m0_cas(il),
!     :          beta_cas(ixt,il),gama_cas(ixt,il),f_cas(il),g_cas(il))
!               call iso_verif_egalite_choix(double_to_real(Jtmp),
!     :           double_to_real(J(ixt,il)),
!     :           'stewart_exp 999: test rieman',errmax,errmaxrel)
!               if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
!                 write(*,*) 'stew exp tmp 1005: il,J(iso_eau,il),Jtmp=',
!     :           il,J(iso_eau,il),Jtmp
!               endif
!             enddo             
!           enddo
!#endif           

          endif !if (ncas_rieman.gt.0) then


        ! ******* traitement vectoriel commun du cas Rieman et Jsimple           
           do il=1,ncas_Jsimple+ncas_rieman          
            do ixt=1,niso 
            r_jqp0(ixt,il)=A_cas(il)*J(ixt,il)/qp0_cas(il)
            r_jl0(ixt,il)=J(ixt,il)/m0_cas(il)                
            Rl(ixt,il)=Rl0_cas(ixt,il)*((f_cas(il)**beta_cas(ixt,il))
     :          *(g_cas(il)**(-beta_cas(ixt,il)*gama_cas(ixt,il)))
     :          +beta_cas(ixt,il)*gama_cas(ixt,il)*r_jqp0(ixt,il)
     :                   /f_cas(il)/g_cas(il))
     :          +Rb0_cas(ixt,il)*gama_cas(ixt,il)*beta_cas(ixt,il)
     :                   *r_jl0(ixt,il)/f_cas(il)/g_cas(il)
            Rb(ixt,il)=Rb0_cas(ixt,il)*(1/g_cas(il) 
     :           - 1/g_cas(il)/g_cas(il) 
     :          * gama_cas(ixt,il)*beta_cas(ixt,il)*r_jqp0(ixt,il))
     :          +Rl0_cas(ixt,il)*r_l0qp0_cas(il)* (1.0/g_cas(il)
     :          -(f_cas(il)**(beta_cas(ixt,il)+1.0))
     :          *(g_cas(il)**(-beta_cas(ixt,il)*gama_cas(ixt,il)-1.0)) 
     :          -beta_cas(ixt,il)*gama_cas(ixt,il)*r_jqp0(ixt,il)
     :                   /g_cas(il)/g_cas(il))
!#ifdef ISOVERIF            
!            if ((use_iso_eau.eq.1).and.(iso_eau.eq.ixt)) then
!              write(*,*) 'stewart_explicite tmp 1071: il=',il
!              if (il.le.ncas_Jsimple) then
!                write(*,*) 'cas_Jsimple(il)=',cas_Jsimple(il)
!              else !if (il.le.ncas_Jsimple) then
!                write(*,*) 'cas_rieman(il)=',cas_rieman(il)
!              endif !if (il.le.ncas_Jsimple) then
!              write(*,*) 'f_cas(il),beta_cas(ixt,il),gama_cas(ixt,il)=',
!     :                   f_cas(il),beta_cas(ixt,il),gama_cas(ixt,il)
!              write(*,*) 'g_cas(il),r_jqp0(ixt,il),r_jl0(ixt,il)=',
!     ;          g_cas(il),r_jqp0(ixt,il),r_jl0(ixt,il)
!              write(*,*) 'A_cas(il)=',A_cas(il)
!              write(*,*) 'pond Rl0=',(f_cas(il)**beta_cas(ixt,il))
!     :          *(g_cas(il)**(-beta_cas(ixt,il)*gama_cas(ixt,il)))
!     :          +beta(ixt,il)*gama_cas(ixt,il)*r_jqp0(ixt,il)
!     :                   /f_cas(il)/g_cas(il)
!              write(*,*) 'pond Rb0=',gama_cas(ixt,il)*beta_cas(ixt,il)
!     :                   *r_jl0(ixt,il)/f_cas(il)/g_cas(il)
!              write(*,*) 'pondRl0=fac1*fac2+t3'
!              write(*,*) 'fac1=',
!     :           f_cas(il)**beta_cas(ixt,il)
!              write(*,*) 'fac2=',
!     :             g_cas(il)**(-beta_cas(ixt,il)*gama_cas(ixt,il)) 
!              write(*,*) 't3=',
!     :           beta_cas(ixt,il)*gama_cas(ixt,il)*r_jqp0(ixt,il)
!     :                   /f_cas(il)/g_cas(il)     
!            endif
!#endif

            Pxtiinf_cas(ixt,il)=Pqiinf_cas(il)*Rl(ixt,il) 
            Pxtiinf_cas(ixt,il)=max(Pxtiinf_cas(ixt,il),0.0)   

            xtnew_cas(ixt,il)=Rb(ixt,il)*(qp0_cas(il)+Eqi_cas(il)
     :           *fac_ftmr_cas(il))    
            xtnew_cas(ixt,il)=max(xtnew_cas(ixt,il),0.0)
            
            if ((fac_ftmr_cas(il).gt.0.0).and.
     :           (Pqiinf_cas(il).gt.(Eqi_cas(il)+qp0_cas(il)
     :                   /fac_ftmr_cas(il)))) then 
                ! mthode (1)
!                write(*,*) 'stewart_explicite 739: methode 1'
                Exi_cas(ixt,il)=(xtnew_cas(ixt,il)-xtp0_cas(ixt,il))
     :                   /fac_ftmr_cas(il)
            else
               ! mthode (2): 
!               write(*,*) 'stewart_explicite 743: methode 2'
               Exi_cas(ixt,il)=Pxtisup_cas(ixt,il)-Pxtiinf_cas(ixt,il)
            endif
            enddo !do ixt=1,niso 
          enddo !do il=1,ncas_Jsimple+ncas_rieman 

          call uncompress_calculJ(ncas,ncas_rieman,ncas_Jsimple,
     :          cas_rieman,cas_Jsimple,Exi_cas,Exi,
     :           xtnew_cas,xtnew,Pxtiinf_cas,Pxtiinf)


        

            ! cam verifs
        endif !if (ncas_rieman+ncas_Jsimple.gt.0) then 

        
        return
                
        end
