!
! $Header$
!
      SUBROUTINE thermcell_init(ngrid,nlay,ztv,zlay,zlev,  &
     &                  lalim,lmin,alim_star,alim_star_tot,lev_out)

!----------------------------------------------------------------------
!thermcell_init: calcul du profil d alimentation du thermique
!----------------------------------------------------------------------
      IMPLICIT NONE
!
! $Header$
!
!
! gestion des impressions de sorties et de dbogage
! lunout:    unit du fichier dans lequel se font les sorties 
!                           (par defaut 6, la sortie standard)
! prt_level: niveau d'impression souhait (0 = minimum)
!
      INTEGER lunout, prt_level
      COMMON /comprint/ lunout, prt_level
      integer            :: iflag_thermals,nsplit_thermals

!!! nrlmd le 10/04/2012
      integer            :: iflag_trig_bl,iflag_clos_bl
      integer            :: tau_trig_shallow,tau_trig_deep
      real               :: s_trig
!!! fin nrlmd le 10/04/2012

      real,parameter     :: r_aspect_thermals=2.,l_mix_thermals=30.
      real               :: alp_bl_k
      real               :: tau_thermals
      integer,parameter  :: w2di_thermals=0
      integer            :: isplit

      integer            :: iflag_coupl,iflag_clos,iflag_wake
      integer            :: iflag_thermals_ed,iflag_thermals_optflux

      common/ctherm1/iflag_thermals,nsplit_thermals
      common/ctherm2/tau_thermals,alp_bl_k
      common/ctherm4/iflag_coupl,iflag_clos,iflag_wake
      common/ctherm5/iflag_thermals_ed,iflag_thermals_optflux

!!! nrlmd le 10/04/2012
      common/ctherm6/iflag_trig_bl,iflag_clos_bl
      common/ctherm7/tau_trig_shallow,tau_trig_deep
      common/ctherm8/s_trig
!!! fin nrlmd le 10/04/2012

!$OMP THREADPRIVATE(/ctherm1/,/ctherm2/,/ctherm4/,/ctherm5/)
!$OMP THREADPRIVATE(/ctherm6/,/ctherm7/,/ctherm8/)

      INTEGER l,ig
!arguments d entree
      INTEGER ngrid,nlay
      REAL ztv(ngrid,nlay)
      REAL zlay(ngrid,nlay)
      REAL zlev(ngrid,nlay+1)
!arguments de sortie
      INTEGER lalim(ngrid)
      INTEGER lmin(ngrid)
      REAL alim_star(ngrid,nlay)
      REAL alim_star_tot(ngrid)
      integer lev_out                           ! niveau pour les print
      
      REAL zzalim(ngrid)
!CR: ponderation entrainement des couches instables
!def des alim_star tels que alim=f*alim_star      


      write(lunout,*)'THERM INIT V20C '

      alim_star_tot(:)=0.
      alim_star(:,:)=0.
      lmin(:)=1
      lalim(:)=1

      do l=1,nlay-1
         do ig=1,ngrid
            if (ztv(ig,l)> ztv(ig,l+1) .and. ztv(ig,1)>=ztv(ig,l) ) then
               alim_star(ig,l)=MAX((ztv(ig,l)-ztv(ig,l+1)),0.)  &
     &                       *sqrt(zlev(ig,l+1)) 
               lalim(:)=l+1
               alim_star_tot(ig)=alim_star_tot(ig)+alim_star(ig,l)
            endif
         enddo
      enddo
      do l=1,nlay
         do ig=1,ngrid 
            if (alim_star_tot(ig) > 1.e-10 ) then
               alim_star(ig,l)=alim_star(ig,l)/alim_star_tot(ig)
            endif
         enddo
      enddo
      alim_star_tot(:)=1.

      return
      end  
