        subroutine write_2D(ind,pluc,nlat,nlon,itime,ntime)
        implicit none

        integer ind
        integer itime,nlat,nlon,ntime
        real pluc(ntime,nlat,nlon)
        real NaN
        parameter (NaN=999.999)

        call write_2D_choix(ind,pluc,nlat,nlon,itime,ntime,NaN)

        return
        end


        subroutine write_2D_choix(ind,pluc,nlat,nlon,itime,ntime,NaN)
        implicit none

        integer ind
        integer itime,nlat,nlon,ntime
        real pluc(ntime,nlat,nlon)
        integer ilat,ilon   
        real NaN

!        write(*,*) 'tmp 24: nlat,nlon,ind=',nlat,nlon,ind
        do ilat=1,nlat
            do ilon=1,nlon
              ind=ind+1
              if (abs(pluc(itime,ilat,ilon)-NaN).lt.1.0) then
                   write(20,rec=ind) NaN
              else
                write(20,rec=ind) pluc(itime,ilat,ilon)
              endif
            enddo !do ilon=1,nlon    
          enddo !do ilat=1,nlat
!          write(*,*) 'tmp 35: ind=',ind

          return
          end

        subroutine write_2D_choix_unit(ind,pluc,nlat,nlon,
     :           itime,ntime,NaN,unite)
        implicit none

        integer ind
        integer itime,nlat,nlon,ntime
        real pluc(ntime,nlat,nlon)
        integer ilat,ilon   
        real NaN
        integer unite

        do ilat=1,nlat
            do ilon=1,nlon
              ind=ind+1
              if (abs(pluc(itime,ilat,ilon)-NaN).lt.1.0) then
                   write(unite,rec=ind) NaN
              else
                write(unite,rec=ind) pluc(itime,ilat,ilon)
              endif
            enddo !do ilon=1,nlon    
          enddo !do ilat=1,nlat

          return
          end



        subroutine write_3D(ind,pluc,nlat,nlon,itime,ntime,nlev)
        implicit none

        integer ind
        integer itime,nlat,nlon,ntime,nlev
        real pluc(ntime,nlev,nlat,nlon)
        integer ilat,ilon,ilev

!        write(*,*) 'ind,nlat,nlon,ntime,nlev,itime=',
!     :            ind,nlat,nlon,ntime,nlev,itime
        do ilev=1,nlev
        do ilat=1,nlat
            do ilon=1,nlon
              ind=ind+1
              write(20,rec=ind) pluc(itime,ilev,ilat,ilon)
            enddo !do ilon=1,nlon    
          enddo !do ilat=1,nlat
        enddo

          return
          end

        subroutine write_3D_choix_unit(ind,pluc,nlat,nlon,itime,ntime,
     :           nlev,NaN,unite)
        implicit none

        integer ind
        integer itime,nlat,nlon,ntime,nlev
        real pluc(ntime,nlev,nlat,nlon)
        integer ilat,ilon,ilev
        integer unite
        real NaN

        do ilev=1,nlev
        do ilat=1,nlat
            do ilon=1,nlon
              ind=ind+1
              if (abs(pluc(itime,ilev,ilat,ilon)-NaN).lt.1.0) then
                   write(unite,rec=ind) NaN
              else
                write(unite,rec=ind) pluc(itime,ilev,ilat,ilon)
              endif
            enddo !do ilon=1,nlon    
          enddo !do ilat=1,nlat
        enddo

          return
          end

          subroutine write_3D_choix_unit_int2real(
     :           ind,pluc,nlat,nlon,itime,ntime,
     :           nlev,NaN,unite)
        implicit none

        integer ind
        integer itime,nlat,nlon,ntime,nlev
        integer pluc(ntime,nlev,nlat,nlon)
        integer ilat,ilon,ilev
        integer unite
        real NaN

        do ilev=1,nlev
        do ilat=1,nlat
          do ilon=1,nlon
              ind=ind+1
              write(unite,rec=ind) float(pluc(itime,ilev,ilat,ilon))
          enddo !do ilon=1,nlon    
          enddo !do ilat=1,nlat
        enddo

          return
          end

        subroutine write_3D_notime(ind,pluc,nlat,nlon,nlev)
        implicit none

        integer ind
        integer nlat,nlon,nlev
        real pluc(nlev,nlat,nlon)
        integer ilat,ilon,ilev

!        write(*,*) 'ind,nlat,nlon,ntime,nlev,itime=',
!     :            ind,nlat,nlon,ntime,nlev,itime
        do ilev=1,nlev
        do ilat=1,nlat
            do ilon=1,nlon
              ind=ind+1
              write(20,rec=ind) pluc(ilev,ilat,ilon)
            enddo !do ilon=1,nlon    
          enddo !do ilat=1,nlat
        enddo

          return
          end

          subroutine write_2D_notime(ind,pluc,nlat,nlon)
        implicit none

        integer ind
        integer nlat,nlon
        real pluc(nlat,nlon)
        integer ilat,ilon

        do ilat=1,nlat
            do ilon=1,nlon
              ind=ind+1
              write(20,rec=ind) pluc(ilat,ilon)
            enddo !do ilon=1,nlon    
          enddo !do ilat=1,nlat

          return
          end

          subroutine read_3D_notime(ind,pluc,nlat,nlon,nlev)
        implicit none

        integer ind
        integer nlat,nlon,nlev
        real pluc(nlev,nlat,nlon)
        integer ilat,ilon,ilev

        do ilev=1,nlev
        do ilat=1,nlat
            do ilon=1,nlon
              ind=ind+1
              read(50,rec=ind) pluc(ilev,ilat,ilon)
            enddo !do ilon=1,nlon    
          enddo !do ilat=1,nlat
        enddo

          return
          end

          subroutine read_2D_notime(ind,pluc,nlat,nlon)
        implicit none

        integer ind
        integer nlat,nlon
        real pluc(nlat,nlon)
        integer ilat,ilon

        do ilat=1,nlat
            do ilon=1,nlon
              ind=ind+1
              read(50,rec=ind) pluc(ilat,ilon)
            enddo !do ilon=1,nlon    
          enddo !do ilat=1,nlat

          return
          end




        !***********

         subroutine read_2D(ind,pluc,nlat,nlon,itime,ntime)         
        implicit none

        integer ind
        integer itime,nlat,nlon,ntime
        real pluc(ntime,nlat,nlon)
        integer ilat,ilon 
        real NaN
        parameter (NaN=999.999)

        do ilat=1,nlat
            do ilon=1,nlon              
              ind=ind+1
!              write(*,*) 'ilat,ilon,ind=',ilat,ilon,ind
              read(50,rec=ind) pluc(itime,ilat,ilon)
            enddo !do ilon=1,nlon    
          enddo !do ilat=1,nlat

          return
          end



          subroutine read_2D_int(ind,pluc,nlat,nlon,itime,ntime)
        implicit none

        integer ind
        integer itime,nlat,nlon,ntime
        integer pluc(ntime,nlat,nlon)
        integer ilat,ilon
        real NaN
        parameter (NaN=999.999)

        do ilat=1,nlat
            do ilon=1,nlon
!              write(*,*) 'ilat,ilon,ind=',ilat,ilon,ind
              ind=ind+1
              read(50,rec=ind) pluc(itime,ilat,ilon)
            enddo !do ilon=1,nlon    
          enddo !do ilat=1,nlat

          return
          end


        subroutine read_3D(ind,pluc,nlat,nlon,itime,ntime,nlev)
        implicit none

        integer ind
        integer itime,nlat,nlon,ntime,nlev
        real pluc(ntime,nlev,nlat,nlon)
        integer ilat,ilon,ilev

!        write(*,*) 'ind,nlat,nlon,ntime,nlev,itime=',
!     :            ind,nlat,nlon,ntime,nlev,itime
        do ilev=1,nlev
        do ilat=1,nlat
            do ilon=1,nlon
              ind=ind+1
!              write(*,*) 'ind=',ind
              read(50,rec=ind) pluc(itime,ilev,ilat,ilon)
            enddo !do ilon=1,nlon    
          enddo !do ilat=1,nlat
        enddo

          return
          end

        subroutine write_3Dto2D(ind,pluc,nlat,nlon,itime,ntime,
     :           nlev,ilev)
        implicit none

        integer ind
        integer itime,nlat,nlon,ntime,nlev,ilev
        real pluc(ntime,nlev,nlat,nlon)
        real NaN
        parameter (NaN=999.999)

        call write_3Dto2D_choix(ind,pluc,nlat,nlon,itime,ntime,
     :           nlev,ilev,NaN)
        return
        end

        subroutine write_3Dto2D_choix(ind,pluc,nlat,nlon,itime,ntime,
     :           nlev,ilev,NaN)
        implicit none

        integer ind
        integer itime,nlat,nlon,ntime,nlev
        real pluc(ntime,nlev,nlat,nlon)
        integer ilat,ilon,ilev
        real NaN

        do ilat=1,nlat
            do ilon=1,nlon
              ind=ind+1
              if (abs(pluc(itime,ilev,ilat,ilon)-NaN).lt.1.0) then
                   write(20,rec=ind) NaN
              else
                write(20,rec=ind) pluc(itime,ilev,ilat,ilon)
              endif
            enddo !do ilon=1,nlon    
          enddo !do ilat=1,nlat

          return
          end

        subroutine write_3D_nolatlon(ind,pluc,itime,ntime,nlev)
        implicit none

        integer ind
        integer itime,ntime,nlev
        real pluc(ntime,nlev)
        integer ilev

        do ilev=1,nlev
              ind=ind+1
              write(20,rec=ind) pluc(itime,ilev)
        enddo

          return
          end

        subroutine write_coupe_zlat(ind,champ,nlat,nlev)
        implicit none

        integer ind
        integer nlat,nlev
        real champ(nlev,nlat)
        integer ilev,ilat
        
        do ilev=1,nlev
          do ilat=1,nlat
            ind=ind+1
            write(20,rec=ind) champ(ilev,ilat)
          enddo
        enddo

        return
        end

        subroutine write_profile(ind,pluc,nlev)
        implicit none

        integer ind
        integer nlev
        real pluc(nlev)
        integer ilev

        do ilev=1,nlev
              ind=ind+1
              write(20,rec=ind) pluc(ilev)
        enddo

        return
        end

        subroutine write_0D(ind,pluc)
        implicit none

        integer ind
        real pluc

        ind=ind+1
        write(20,rec=ind) pluc

        return
        end
