!
! $Id: caladvtrac_p.F 1454 2010-11-18 12:01:24Z fairhead $
!
c
c
            SUBROUTINE caladvtrac_p(q,pbaru,pbarv ,
     *                   p ,masse, dq ,  teta,
     *                   flxw, pk, iapptrac
#ifdef ISO
     :          ,xt, dxt,rlat      
#ifdef DIAGISO
     :          ,dqdyn_horiz,dqdyn_vert,
     :           dxtdyn_horiz,dxtdyn_vert      
#endif 
#endif             
     :           )
      USE parallel
      USE infotrac, ONLY : nqtot
      USE control_mod, ONLY : iapp_tracvl,planet_type
c
      IMPLICIT NONE
c
c     Auteurs:   F.Hourdin , P.Le Van, F.Forget, F.Codron  
c
c     F.Codron (10/99) : ajout humidite specifique pour eau vapeur
c=======================================================================
c
c       Shema de  Van Leer
c
c=======================================================================


#include "dimensions.h"
#include "paramet.h"
#include "comconst.h"

c   Arguments:
c   ----------
      REAL pbaru( ip1jmp1,llm ),pbarv( ip1jm,llm),masse(ip1jmp1,llm)
      REAL p( ip1jmp1,llmp1),q( ip1jmp1,llm,nqtot)
      real :: dq( ip1jmp1,llm,nqtot)
      REAL teta( ip1jmp1,llm),pk( ip1jmp1,llm)
      REAL               :: flxw(ip1jmp1,llm)

#ifdef ISO
      ! arguments
      !integer niso
#include "wateriso2.h"      
      real xt( ip1jmp1,llm,2,ntraciso)
      real dxt( ip1jmp1,llm,2,ntraciso)
      real rlat(ip1jmp1)
      ! locals
      integer ixt
#ifdef DIAGISO
      real dqdyn_horiz(ip1jmp1,llm,nqtot),
     &    dqdyn_vert(ip1jmp1,llm,nqtot)
      real dxtdyn_horiz(ip1jmp1,llm,2,ntraciso),
     &    dxtdyn_vert(ip1jmp1,llm,2,ntraciso)
#endif      
#include "iso_verif.h"
#ifdef ISOVERIF      
      integer i,j
      integer iso_verif_egalite_choix_nostop
      real xtprec(ntraciso,ip1jmp1,llm,2), qprec(ip1jmp1,llm,2)
      real masseprec(ip1jmp1,llm)
      real xtiso(ip1jmp1,llm,2),xtisoprec(ip1jmp1,llm,2)
#endif      
#endif

      integer ijb,ije,jjb,jje

c  ..................................................................
c
c  .. dq n'est utilise et dimensionne que pour l'eau  vapeur et liqu.
c
c  ..................................................................
c
c   Local:
c   ------

      INTEGER ij,l, iq, iapptrac
      REAL finmasse(ip1jmp1,llm), dtvrtrac

#ifdef ISO
        ijb=ij_begin
        ije=ij_end
#ifdef ISOVERIF
        write(*,*) 'caladvtrac 88: entree'
        do iq=1,2
        do ij=ijb,ije
         do l=1,llm
           if (use_iso_eau.eq.1) then
               call iso_verif_egalite(xt(ij,l,iq,iso_eau),q(ij,l,iq),
     :           'caladvtrac 90: début de caladvtrac')
           endif !if (use_iso_eau.eq.1) then
           if (use_iso_HDO.eq.1) then    
              if (q(ij,l,iq).gt.ridicule) then
                 call iso_verif_aberrant(
     :                   xt(ij,l,iq,iso_HDO)/q(ij,l,iq),
     :                   'caladvtrac 102: entrée')
              endif !if (q(ij,l,iq).gt.errmax) then
            endif  !if (use_iso_HDO.eq.1) then 
            do ixt=1,ntraciso
              call iso_verif_noNaN(xt(ij,l,iq,ixt),
     :                   'caladvtrac 106: entrée')
            enddo !do ixt=1,ntraciso
#ifdef ISOTRAC
            call iso_verif_traceur_retourne3D(xt,ip1jmp1,llm,2,
     :                   ij,l,iq,'caladvtrac 114')
#endif            
           enddo !do iq=1,2
          enddo !DO l=1,llm
        enddo !DO ij=ijb,ije
#endif
#endif      
      
cc
c
C initialisation
cym      ijb=ij_begin
cym      ije=ij_end

      
cym      dq(ijb:ije,1:llm,1:2)=q(ijb:ije,1:llm,1:2)

c  test des valeurs minmax
cc        CALL minmaxq(q(1,1,1),1.e33,-1.e33,'Eau vapeur (a) ')
cc        CALL minmaxq(q(1,1,2),1.e33,-1.e33,'Eau liquide(a) ')

c   advection
c      print *,'appel a advtrac'

      CALL advtrac_p( pbaru,pbarv, 
     *             p,  masse,q,iapptrac, teta,
     .             flxw, pk
#ifdef ISO      
     :           ,xt,rlat
#ifdef DIAGISO
     :           ,dqdyn_horiz,dqdyn_vert,
     :           dxtdyn_horiz,dxtdyn_vert   
#endif       
#endif
     :          )


#ifdef ISO
#ifdef ISOVERIF
        write(*,*) 'caladvtrac 148: apres advtrac'
      do iq=1,2         
          do ij=ijb,ije
           do l=1,llm
             if (use_iso_eau.eq.1) then
!                 write(*,*) 'ij,l,iq=',ij,l,iq
               call iso_verif_egalite(xt(ij,l,iq,iso_eau),q(ij,l,iq),
     :           'caladvtrac 209: après appel advtrac')
             endif !if (use_iso_eau.eq.1) then
             do ixt=1,niso
               call iso_verif_noNAN(xt(ij,l,iq,ixt))
             enddo !do ixt=1,niso
             if (use_iso_HDO.eq.1) then        
              if (q(ij,l,iq).gt.ridicule) then
                  call iso_verif_aberrant(
     :                   xt(ij,l,iq,iso_HDO)/q(ij,l,iq),
     :                   'caladvtrac 210: après appel advtrac')
               endif !if (q(ij,l,iq).gt.errmax) then
              endif  !if (use_iso_HDO.eq.1) then  
              if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
               if ((q(ij,l,iq).gt.ridicule).and.(xt(ij,l,iq,iso_o18)
     :           .gt.ridicule*tnat(iso_o18)).and.
     :              (l.lt.nlevmaxO17)) then
                 call iso_verif_aberrant_o17(xt(ij,l,iq,iso_o17)
     :           /q(ij,l,iq),xt(ij,l,iq,iso_o18)/q(ij,l,iq),
     :           'caladvtrac 243: apres advtrac')
                endif !if (q(ij,l,iq).gt.ridicule) then
               endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
              do ixt=1,ntraciso
                call iso_verif_noNaN(xt(ij,l,iq,ixt),
     :                   'caladvtrac 178: apres advtrac')
              enddo !do ixt=1,ntraciso
#ifdef ISOTRAC
           call iso_verif_traceur_retourne3D(xt,ip1jmp1,llm,2,
     :          ij,l,iq,'caladvtrac 248')
#endif                 
            enddo   !DO ij=ijb,ije 
           enddo  !DO l=1,llm   

        enddo !do iq=1,2     
#endif
        ! end verif
        if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
              do iq=1,2
                do l=1,llm
                  do ij=ijb,ije
                        xt(ij,l,iq,iso_eau)=q(ij,l,iq)
                  enddo !do ij=ijb,ije
                enddo !l=1,llm
             enddo !iq=1,2
         endif !if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
#endif         
           

         goto 9999
         IF( iapptrac.EQ.iapp_tracvl ) THEN
c
cc          CALL minmaxq(q(1,1,1),1.e33,-1.e33,'Eau vapeur     ')
cc          CALL minmaxq(q(1,1,2),1.e33,-1.e33,'Eau liquide    ')

cc     ....  Calcul  de deltap  qu''on stocke dans finmasse   ...
c
          DO l = 1, llm
           DO ij = ijb, ije
             finmasse(ij,l) =  p(ij,l) - p(ij,l+1) 
           ENDDO
          ENDDO

	  if (planet_type.eq."earth") then
! Earth-specific treatment of first 2 tracers (water)
            CALL qminimum_p( q, 2, finmasse 
#ifdef ISO
     :          ,xt 
#endif      
     :            )
	  endif


cym   --> le reste ne set a rien
          goto 9999
	  
c          CALL SCOPY   ( ip1jmp1*llm, masse, 1, finmasse,       1 )
          finmasse(ijb:ije,:)=masse(ijb:ije,:)         
          
          jjb=jj_begin
          jje=jj_end
          CALL filtreg_p ( finmasse ,jjb,jje,  jjp1,  llm, 
     *                     -2, 2, .TRUE., 1 )
c
c   *****  Calcul de dq pour l''eau , pour le passer a la physique ******
c   ********************************************************************
c
          dtvrtrac = iapp_tracvl * dtvr
c
           DO iq = 1 , 2
            DO l = 1 , llm
             DO ij = ijb,ije
             dq(ij,l,iq) = ( q(ij,l,iq) - dq(ij,l,iq) ) * finmasse(ij,l)
     *                               /  dtvrtrac
             ENDDO
            ENDDO
           ENDDO
#ifdef ISO
           DO iq = 1 , 2
            DO l = 1 , llm
             DO ij = ijb,ije
              do ixt=1,niso
                dxt(ij,l,iq,ixt)=(xt(ij,l,iq,ixt)-dxt(ij,l,iq,ixt)) 
     *                               * finmasse(ij,l)/  dtvrtrac
              enddo !do ixt=1,niso
             ENDDO
            ENDDO
           ENDDO
#endif     
c
         ELSE
cym   --> le reste ne set a rien
          goto 9999
	  
           DO iq = 1 , 2
           DO l  = 1, llm
             DO ij = ijb,ije
              dq(ij,l,iq)  = 0.
#ifdef ISO
             do ixt=1,niso
                dxt(ixt,ij,l,iq)=0.
              enddo
#endif             
             ENDDO
           ENDDO
           ENDDO

         ENDIF
c


c  ... On appelle  qminimum uniquement  pour l''eau vapeur et liquide  ..

#ifdef ISO
#ifdef ISOVERIF
        do iq=1,2
         do l=1,llm           
           do ij=ijb,ije
            if (use_iso_eau.eq.1) then
                call iso_verif_egalite(xt(ij,l,iq,iso_eau),q(ij,l,iq),
     :           'caladvtrac 192: fin de caladvtrac')
            endif !if (use_iso_eau.eq.1) then
            if (use_iso_HDO.eq.1) then    
             if (q(ij,l,iq).gt.ridicule) then
                 call iso_verif_aberrant(
     :                   xt(ij,l,iq,iso_HDO)/q(ij,l,iq),
     :                   'caladvtrac 265: sortie')
               endif !if (q(ij,l,iq).gt.errmax) then
              endif  !if (use_iso_HDO.eq.1) then
            do ixt=1,ntraciso
              call iso_verif_noNaN(xt(ij,l,iq,ixt),
     :                   'caladvtrac 304: sortie')
            enddo !do ixt=1,ntraciso
#ifdef ISOTRAC
           call iso_verif_traceur_retourne3D(xt,ip1jmp1,llm,2,
     :                   1,ij,l,iq,'caladvtrac 445')
#endif                
             enddo !do iq=1,2
          enddo !DO l=1,llm
        enddo !DO ij=ijb,ije
#endif
#endif

 9999 RETURN
      END


