#ifdef ISO      
      
      subroutine calcul_R(xt,q,Rx,ixt)
      implicit none

      ! input
      real xt,q
      integer ixt
      ! output
      real Rx
      ! locals
#include "wateriso2.h"
#include "iso_verif.h"
        
      !******* calcul du champ R
      ! changement 17 juin 2012: ridicule -> ridicule*1e-3
      if (q.gt.ridicule*1e-3) then
            Rx=xt/q
      else !if (q.gt.ridicule) then
#ifdef ISOVERIF  
          write(*,*) 'vlxiso 2231: warning:'
          write(*,*) 'q=',q
          stop
#endif                  
          Rx=Rdefault(ixt) 
#ifdef ISOTRAC
          if (index_zone(ixt).eq.izone_poubelle) then       
              Rx=Rdefault(ixt) 
          else
              Rx=0.0
          endif 
#endif
        endif !if (q.gt.0.0) then
#ifdef ISOVERIFIDRIS
        call iso_verif_noNaN(Rx,'vlxiso 162')
#endif
#ifdef ISOVERIF
        if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then   
           call iso_verif_egalite_choix
     :           (Rx,1.,'vlxiso 2157',
     :           errmax*10,errmaxrel*10)
        endif !if (use_iso_eau.eq.1) then
        if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then     
           call iso_verif_aberrant_encadre(Rx,'vlxiso 92')
        endif !if (use_iso_HDO.eq.1) then
#endif
      if ((bidouille_anti_divergence).and.
     :      (use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
          Rx=1.0               
      endif


      return
      end

#endif


