#ifdef ISO
      subroutine dyniso_etat0_fichier(xt,q,nid)
      USE infotrac
      use netcdf, only: nf90_get_var
      implicit none

#include "dimensions.h"
#include "paramet.h"
#include "temps.h"
#include "comconst.h"
#include "comvert.h"
#include "comgeom2.h"
#include "ener.h"
#include "netcdf.inc"  
#include "description.h"
#include "serre.h"
#include "logic.h"
#include "iniprint.h"
#include "wateriso2.h"
#include "iso_verif.h"            

        ! input
        integer nid
        real q(iip1,jjp1,llm,nqtot)
        ! output
        real xt(iip1,jjp1,llm,2,ntraciso)
        ! locals      
        integer iq,i,j,k,ixt        
        INTEGER nvarid
        INTEGER ierr
!        character*2 str2
!        character*15 str15
        character*20 tnameiso
        integer lnblnk
        character*8 strdebug8
#ifdef ISOTRAC
        integer iiso
#endif        

        write(*,*) 'dyniso_etat0_fichier 3'
        write(*,*) 'niso,striso(1)=',niso,striso(1)
        

        IF(nqtot.GE.1) THEN
        DO iq=1,2
        write(*,*) 'dyniso_etat0_fichier 64: niso=',niso
!        write(*,*) 'iip1,jjp1=',iip1,jjp1,'; llm=',llm
        
        do ixt=1,niso 
          write(*,*) 'dyniso_etat0_fichier 68: ixt=',ixt
          if (ixt.gt.niso) then
             write(*,*) 'dyniso_etat0_fichier 49: ixt=',ixt
             stop
          endif

          tnameiso="xt"//tname(iq)
          write(*,*) 'dyniso_etat0_fichier 78: striso(ixt)=',striso(ixt)
          tnameiso=tnameiso(1:lnblnk(tnameiso))//'_'
          tnameiso=tnameiso(1:lnblnk(tnameiso))//striso(ixt)
          write(*,*) 'dyniso_etat0_fichier 78: tnameiso=<',
     :            tnameiso(1:lnblnk(tnameiso)),'>'

          ierr =  NF_INQ_VARID (nid, tnameiso(1:lnblnk(tnameiso)), 
     :           nvarid)
          IF (ierr .NE. NF_NOERR) THEN
             PRINT*, "dyniso_etat0_fichier: Le champ <"//
     :           tnameiso(1:lnblnk(tnameiso))// "> est absent"
!             PRINT*, "          Il est donc initialise a zero"
             write(*,*) 'on stop'
             stop
             ! initialisation  0 si champ absent:
             do i=1,iip1
               do j=1,jjp1
                 do k=1,llm
                   xt(i,j,k,iq,ixt)=0.0
                   if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
                        xt(i,j,k,iq,ixt)=q(i,j,k,iq)
                   endif
                 enddo !do k=1,llm
                enddo !do j=1,jjp1
              enddo !do i=1,iip1
             write(*,*) 'dynisoetat0_fichier 80'
             
        ELSE !IF (ierr .NE. NF_NOERR) THEN
          write(*,*) 'nvarid=',nvarid
          ierr = NF90_GET_VAR(nid, nvarid, xt(:,:,:,iq,ixt))
          IF (ierr .NE. NF_NOERR) THEN
             PRINT*, "dynisoetat0: Lecture echouee pour "
     :           //tnameiso(1:lnblnk(tnameiso))
             CALL abort
          ENDIF
          write(*,*) 'dynisoetat0_fichier 93'
        ENDIF !IF (ierr .NE. NF_NOERR) THEN
        enddo !do ixt=1,niso 

#ifdef ISOVERIF   
        do k=1,llm
         do i=1,iip1
          do j=1,jjp1
           do ixt=1,niso
              call iso_verif_noNaN(xt(i,j,k,iq,ixt),
     :             'dynisoetat0_fichier 106')
           enddo !do ixt=1,niso
           if (use_iso_eau.eq.1) then
               call iso_verif_egalite(xt(i,j,k,iq,iso_eau),
     :                q(i,j,k,iq),'dynisoetat0_etat0_fichier 107')
           endif ! if (use_iso_eau.eq.1) then
          enddo !do j=1,jjp1
         enddo !do i=1,iip1
        enddo !do k=1,llm  
#endif

#ifdef ISOTRAC
        if (initialisation_isotrac.eq.0) then
        do ixt=niso+1,ntraciso
         iiso=index_iso(ixt)
         write(*,*) 'dyniso_etat0_fichier 68: ixt,iiso=',ixt,iiso
          
          tnameiso="xt"//tname(iq)
          write(*,*) 'dyniso_etat0_fichier 78: striso(iiso)=',
     :           striso(iiso)
          tnameiso=tnameiso(1:lnblnk(tnameiso))//'_'
          tnameiso=tnameiso(1:lnblnk(tnameiso))//striso(iiso)
          tnameiso=tnameiso(1:lnblnk(tnameiso))//'_'
          tnameiso=tnameiso(1:lnblnk(tnameiso))//
     :           strtrac(index_zone(ixt))
          write(*,*) 'dyniso_etat0_fichier 78: tnameiso=<',
     :            tnameiso(1:lnblnk(tnameiso)),'>'

          ierr =  NF_INQ_VARID (nid, tnameiso(1:lnblnk(tnameiso)), 
     :           nvarid)
          IF (ierr .NE. NF_NOERR) THEN
             PRINT*, "dyniso_etat0_fichier: Le champ <"//
     :           tnameiso(1:lnblnk(tnameiso))// "> est absent"
!             PRINT*, "          Il est donc initialise a zero"
             write(*,*) 'on stop'
             stop             
             
        ELSE !IF (ierr .NE. NF_NOERR) THEN
            write(*,*) 'nvarid=',nvarid
          ierr = NF90_GET_VAR(nid, nvarid, xt(1,1,1,iq,ixt))
          IF (ierr .NE. NF_NOERR) THEN
             PRINT*, "dynisoetat0: Lecture echouee pour "
     :           //tnameiso(1:lnblnk(tnameiso))
             CALL abort
          ENDIF
        ENDIF !IF (ierr .NE. NF_NOERR) THEN
        enddo !do ixt=1,niso

      else !if (initialisation_isotrac.eq.0) then
          ! l'eau normale est mise dans la zone izone_init
        do i=1,iip1
         do j=1,jjp1
          do k=1,llm
           do ixt=niso+1,ntraciso
             if (index_zone(ixt).eq.izone_init) then
                   xt(i,j,k,iq,ixt)=xt(i,j,k,iq,index_iso(ixt)) ! eau normale
             else !if (index_zone(ixt).eq.izone_init) then
                   xt(i,j,k,iq,ixt)=0.
             endif !if (index_zone(ixt).eq.izone_init) then
            enddo  !do ixt=1,niso
           enddo !do k=1,llm
          enddo !do j=1,jjp1
         enddo !do i=1,iip1
      endif !if (initialisation_isotrac.eq.0) then
#endif
! #ifdef ISOTRAC
      ENDDO !DO iq=1,nqtot
      ENDIF !IF(nqtot.GE.1) THEN

        return
        end

#endif

