#ifdef ISO
      SUBROUTINE dynisoetat0(xt,q,nid)
      USE infotrac

      implicit none
              

#include "dimensions.h"
#include "paramet.h"
#include "temps.h"
#include "comconst.h"
#include "comvert.h"
#include "comgeom2.h"
#include "ener.h"
#include "netcdf.inc"
#include "description.h"
#include "serre.h"
#include "logic.h"
#include "iniprint.h"
#include "wateriso2.h"
#include "iso_verif.h"              

              ! input
              integer nid
              real q(iip1,jjp1,llm,nqtot)
              ! output
              real xt(iip1,jjp1,llm,2,ntraciso)
              ! locals      
              integer iq,i,j,k,ixt

#ifdef ISOVERIFIDRIS            
              write(*,*) 'dynisoetat0 20: entre,niso,striso(1)=',
     :           niso,'<',striso(1),'>'
#endif   
#ifdef ISOVERIF            
              call iso_verif_positif(100.0-float(iso_eau),
     :           'dynisoetat0 24')
              do iq=1,2
                do k=1,llm
                  do i=1,iip1
                   do j=1,jjp1
                      call iso_verif_noNaN(q(i,j,k,iq),
     :                   'dynisoetat0 39')
                   enddo !do j=1,jjp1
                  enddo ! do i=1,iip1
                enddo ! do k=1,llm
              enddo !do iq=1,2
#endif              
              write(*,*) 'initialisation_iso=',
     :                initialisation_iso
              if (initialisation_iso.eq.0) then
                 write(*,*) 'dynisoetat0 34: appel dyniso_etat0_fichier'
                 write(*,*) 'niso,striso(1),=', niso,striso(1)
                 call dyniso_etat0_fichier(xt,q,nid)
              else !if (initialisation_iso.eq.0) then
                  write(*,*) 'dynisoetat0 43: call iso_initprofiles_p'
                  call iso_initprofiles_p(xt,q)
              endif !if (initialisation_iso.eq.0) then


              !verif
#ifdef ISOVERIF
              write(*,*) 'dynisoetat0 58: apres iso_initprofiles'
              do iq=1,2
                do k=1,llm
                  do i=1,iip1
                   do j=1,jjp1
                    do ixt=1,ntraciso
                      call iso_verif_noNaN(xt(i,j,k,iq,ixt),
     :                   'dynisoetat0 48')
                    enddo !do ixt=1,niso
                    if (use_iso_eau.eq.1) then
                        call iso_verif_egalite(xt(i,j,k,iq,iso_eau),
     :                q(i,j,k,iq),'dynisoetat0 57')
                    endif ! if (use_iso_eau.eq.1) then
#ifdef ISOTRAC                    
                    call iso_verif_traceur_retourne4D(xt,iip1,jjp1,
     :                   llm,2,i,j,k,iq,'dynisoetat0 64')
#endif                    
                    if (use_iso_HDO.eq.1) then
                       if (q(i,j,k,iq).gt.ridicule) then
                                call iso_verif_aberrant_encadre(
     :                          xt(i,j,k,iq,iso_HDO)/q(i,j,k,iq),
     :                          'dyniso_etat0 88') 
                     endif !if (q(i,k,iq).gt.ridicule) then               
                    endif !if (use_iso_HDO) then
                   enddo ! do j=1,jjp1
                  enddo ! do i=1,iip1
                enddo !do k=1,llm
              enddo !do iq=1,2
#endif
              !end verif
              
              RETURN
              END

#endif





