#ifdef ISO
      SUBROUTINE dynisoredem0_p(nid,dims4)
#ifdef CPP_IOIPSL
      USE IOIPSL
#endif
      USE parallel
      USE infotrac      
      use netcdf95, only: NF95_PUT_VAR
      IMPLICIT NONE
c=======================================================================
c Ecriture du fichier de redemarrage sous format NetCDF (initialisation)
c=======================================================================
c   Declarations:
c   -------------
#include "dimensions.h"
#include "paramet.h"
#include "comconst.h"
#include "comvert.h"
#include "comgeom2.h"
#include "temps.h"
#include "ener.h"
#include "logic.h"
#include "netcdf.inc"
#include "description.h"
#include "serre.h"
#include "wateriso2.h"
      

c   Arguments:
c   ----------
      INTEGER  dims4(4)
      integer nid

c   Local:
c   ------
      INTEGER iq,l,ixt
      INTEGER ierr

c   Variables locales pour NetCDF:
c
      INTEGER nvarid
      character*20 tnameiso
      character*50 ttextiso
      integer lnblnk

      write(*,*) 'dynisoredem 169: dims4, niso=',dims4,', ',niso


      IF(nqtot.GE.1) THEN
      DO iq=1,2
        do ixt=1,niso
cIM 220306 BEG
        write(*,*) 'ixt=',ixt
        write(*,*) 'striso(ixt)=',striso(ixt)             
        tnameiso='xt'//tname(iq)
        tnameiso=tnameiso(1:lnblnk(tnameiso))//'_'
        tnameiso=tnameiso(1:lnblnk(tnameiso))//striso(ixt)
!        write(*,*) 'dynisoredem0 171: tnameiso='//
!     :           tnameiso(1:lnblnk(tnameiso))//'!'
        
        ttextiso=ttext(iq)
        ttextiso=ttextiso(1:lnblnk(ttextiso))//" pour l'isotope "
        ttextiso=ttextiso(1:lnblnk(ttextiso))//striso(ixt)
!        write(*,*) 'ttextiso=',ttextiso(1:lnblnk(ttextiso))
        
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid,tnameiso(1:lnblnk(tnameiso)),
     :           NF_DOUBLE,4,dims4,nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         WRITE(6,*)"dynisoredem 179: Pb d def variable "
     :           //tnameiso(1:lnblnk(tnameiso))
         write(*,*) NF_STRERROR(ierr)
         WRITE(6,*)' ierr = ', ierr
         CALL ABORT
      ENDIF
#else
      ierr = NF_DEF_VAR (nid,tnameiso(1:lnblnk(tnameiso)),
     :           NF_FLOAT,4,dims4,nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         WRITE(6,*)"dynisoredem 189: Pb d def variable "
     :           //tnameiso(1:lnblnk(tnameiso))//"!!"
         write(*,*) 'dims4=',dims4
         write(*,*) NF_STRERROR(ierr)
         WRITE(6,*)' ierr = ', ierr
         CALL ABORT
      ENDIF
#endif
cIM 220306 END
      ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", lnblnk(ttextiso),
     :            ttextiso(1:lnblnk(ttextiso)))
      enddo !do ixt=1,niso

#ifdef ISOTRAC
      do ixt=niso+1,ntraciso
cIM 220306 BEG
        write(*,*) 'ixt=',ixt
        write(*,*) 'striso(ixt)=',striso(index_iso(ixt))             
        tnameiso='xt'//tname(iq)
        tnameiso=tnameiso(1:lnblnk(tnameiso))//'_'
        tnameiso=tnameiso(1:lnblnk(tnameiso))//
     :            striso(index_iso(ixt))
        tnameiso=tnameiso(1:lnblnk(tnameiso))//'_'
        tnameiso=tnameiso(1:lnblnk(tnameiso))//
     :            strtrac(index_zone(ixt))
        write(*,*) 'dynisoredem0 252: tnameiso='//
     :           tnameiso(1:lnblnk(tnameiso))//'!'
        
        ttextiso=ttext(iq)
        ttextiso=ttextiso(1:lnblnk(ttextiso))//" pour l'isotope "
        ttextiso=ttextiso(1:lnblnk(ttextiso))//striso(index_iso(ixt))
!        write(*,*) 'ttextiso=',ttextiso(1:lnblnk(ttextiso))
        
#ifdef NC_DOUBLE
      ierr = NF_DEF_VAR (nid,tnameiso(1:lnblnk(tnameiso)),
     :           NF_DOUBLE,4,dims4,nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         WRITE(6,*)"dynisoredem 264: Pb d def variable "
     :           //tnameiso(1:lnblnk(tnameiso))
         write(*,*) NF_STRERROR(ierr)
         WRITE(6,*)' ierr = ', ierr
         CALL ABORT
      ENDIF
#else
      ierr = NF_DEF_VAR (nid,tnameiso(1:lnblnk(tnameiso)),
     :           NF_FLOAT,4,dims4,nvarid)
      IF (ierr.NE.NF_NOERR) THEN
         WRITE(6,*)"dynisoredem 274: Pb d def variable "
     :           //tnameiso(1:lnblnk(tnameiso))//"!!"
         write(*,*) 'dims4=',dims4
         write(*,*) NF_STRERROR(ierr)
         WRITE(6,*)' ierr = ', ierr
         CALL ABORT
      ENDIF
#endif
! #ifdef NC_DOUBLE      
cIM 220306 END
      ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", lnblnk(ttextiso),
     :            ttextiso(1:lnblnk(ttextiso)))
      enddo !do ixt=1,niso
#endif
!#ifdef ISOTRAC

      ENDDO !DO iq=1,nqtot
      ENDIF
c

      PRINT*,'iim,jjm,llm',iim,jjm,llm

      RETURN
      END


!**********************************


      SUBROUTINE dynisoredem1_p(nid,xt)
      USE parallel
      USE infotrac
      USE control_mod
      use netcdf, only: NF90_get_VAR
      use netcdf95, only: NF95_PUT_VAR

      IMPLICIT NONE
c=================================================================
c  Ecriture du fichier de redemarrage sous format NetCDF
c=================================================================
#include "dimensions.h"
#include "paramet.h"
#include "description.h"
#include "netcdf.inc"
#include "comvert.h"
#include "comgeom.h"
#include "temps.h"
#include "wateriso2.h"  

      integer nid
      real xt(iip1,jjp1,llm,2,ntraciso)

      ! locals
      INTEGER  l,ixt,i,j,k
      INTEGER  nvarid
      INTEGER ierr
      INTEGER iq
      character*20 tnameiso
      character*2 str2
      character*15 str15
      integer lnblnk

      write(*,*) 'dynisoredem_p1 156: entre, striso(1)=',striso(1)

       do iq=1,2 
        do ixt=1,niso  
         write(*,*) 'dynisoredem_p1 203: iq,ixt=',iq,ixt
!        WRITE(str2,'(i2.2)') ixt
        write(*,*) 'iq,ixt=',iq,ixt
!        write(*,*) 'str2='//str2
!        write(*,*) 'striso(ixt)=',striso(ixt)        
        tnameiso='xt'//tname(iq)
        tnameiso=tnameiso(1:lnblnk(tnameiso))//'_'
        tnameiso=tnameiso(1:lnblnk(tnameiso))//striso(ixt)

        write(*,*) 'dynisoredem1 279: tnameiso=<'
     :           //tnameiso(1:lnblnk(tnameiso))//'>'
#ifdef ISOVERIF
           if (len(tnameiso).gt.20) then
               write(*,*) 'dynisoredem1 351: len(tnameiso)=',
     :            len(tnameiso)
               write(*,*) 'lnblnk(tnameiso)=',
     :            lnblnk(tnameiso)
               write(*,*) 'striso(',ixt,')=<',striso(ixt),'>'
               write(*,*) 'tname(',iq,')=<',tname(iq),'>'
               write(*,*) 'tnameiso=<',tnameiso(1:lnblnk(tnameiso)),'>' 
               stop
           endif
#endif
        write(*,*) 'dynisoredem_p1 284 recherche de la variable'
        ierr = NF_INQ_VARID(nid, tnameiso(1:lnblnk(tnameiso)), nvarid)
        IF (ierr .NE. NF_NOERR) THEN
           PRINT*, "Variable  tnameiso n est pas definie"
           write(*,*) 'tnameiso<=',tnameiso(1:lnblnk(tnameiso)),'>'
           CALL abort
        ENDIF
        write(*,*) 'dynisoredem1 291: nvarid=',nvarid            
        call NF95_PUT_VAR(nid,nvarid,xt(:,:,:,iq,ixt))

        enddo !do ixt=1,niso  
        write(*,*) 'dynisoredem_p1 237'

#ifdef ISOTRAC
        do ixt=niso+1,ntraciso
        tnameiso='xt'//tname(iq)
        tnameiso=tnameiso(1:lnblnk(tnameiso))//'_'
        tnameiso=tnameiso(1:lnblnk(tnameiso))//
     :           striso(index_iso(ixt))
        tnameiso=tnameiso(1:lnblnk(tnameiso))//'_'
        tnameiso=tnameiso(1:lnblnk(tnameiso))//
     :           strtrac(index_zone(ixt))

!        write(*,*) 'dynisoredem1 279: tnameiso=<'
!     :           //tnameiso(1:lnblnk(tnameiso))//'>'
#ifdef ISOVERIF
           if (len(tnameiso).gt.20) then
               write(*,*) 'dynisoredem1 351: len(tnameiso)=',
     :            len(tnameiso)
               write(*,*) 'lnblnk(tnameiso)=',
     :            lnblnk(tnameiso)
               write(*,*) 'striso(',ixt,')=<',striso(index_iso(ixt)),'>'
               write(*,*) 'tname(',iq,')=<',tname(iq),'>'
               write(*,*) 'tnameiso=<',tnameiso(1:lnblnk(tnameiso)),'>' 
               stop
           endif
#endif
        write(*,*) 'dynisoredem_p1 284 recherche de la variable'
        ierr = NF_INQ_VARID(nid, tnameiso(1:lnblnk(tnameiso)), nvarid)
        IF (ierr .NE. NF_NOERR) THEN
           PRINT*, "Variable  tnameiso n est pas definie"
           write(*,*) 'tnameiso<=',tnameiso(1:lnblnk(tnameiso)),'>'
           CALL abort
        ENDIF       
        call NF95_PUT_VAR(nid,nvarid,xt(:,:,:,iq,ixt))

        enddo !do ixt=1,niso
#endif
! #endif ISOTRAC        

       ENDDO !do iq=1,2 
       write(*,*) 'dynisoredem_p 313: sortie de dynisoredem1'
c
c
      RETURN
      END

#endif
