#ifdef ISO
      subroutine iso_initprofiles_p(xt,q)

        USE infotrac
        implicit none

        ! initialisation des profils isotopiques
        ! on les initialise  un profil trs idalis.
        
        ! declarations
        ! inputs 
#include "dimensions.h"
#include "paramet.h"
#include "temps.h"
#include "comconst.h"
#include "comvert.h"
#include "comgeom2.h"
#include "ener.h"
#include "netcdf.inc"
#include "description.h"
#include "serre.h"
#include "logic.h"
#include "iniprint.h"
#include "wateriso2.h"
#include "iso_verif.h"        
        real q(iip1,jjp1,llm,nqtot)
        !integer niso
        ! output 
        real xt(iip1,jjp1,llm,2,ntraciso)
        ! locals
        integer ixt, i,j, l,iq
        real alpha(niso),kcin(niso)
        INTEGER iq_vap, iq_liq
        PARAMETER ( iq_vap = 1 ) ! indice pour l'eau vapeur
        PARAMETER ( iq_liq = 2 ) ! indice pour l'eau liquide
#ifdef ISOVERIF
        real xt3(iip1,jjp1,llm),xt5(iip1,jjp1,llm),xt4(iip1,jjp1,llm)
        integer indiso,ij
        integer iso_verif_o18_aberrant_nostop
#endif

        write(*,*) 'iso_ini_profiles 41: initialisation_iso=',
     :            initialisation_iso
       if (initialisation_iso.eq.1) then
           ! on met tout  0

         do iq=1,2
          do l=1,llm
            do i=1,iip1
             do j=1,jjp1   
              do ixt=1,niso
                if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
                   xt(i,j,l,iq,iso_eau)=q(i,j,l,iq) ! eau normale                   
                else
                   xt(i,j,l,iq,ixt)=0.
                endif
              enddo  !do ixt=1,niso  
#ifdef ISOTRAC
              ! l'eau normale est mise dans la zone izone_init
              do ixt=niso+1,ntraciso
                if (index_zone(ixt).eq.izone_init) then
                   xt(i,j,l,iq,ixt)=xt(i,j,l,iq,index_iso(ixt)) ! eau normale
                else
                   xt(i,j,l,iq,ixt)=0.
                endif
              enddo  !do ixt=1,niso 
#endif  
             enddo !do i=1,iip1  
            enddo !do j=1,jjp1   
           enddo !do l=1,llm
         enddo !do iq=1,2

        else if ((initialisation_iso.eq.2)
     :           .or.(initialisation_iso.eq.0)) then
            ! distill de rayleigh

          do ixt=1,niso
            call fractcalk_liq(ixt, 283.0, alpha(ixt))
          enddo
          do l=1,llm
            do i=1,iip1
             do j=1,jjp1               
                if (q(i,j,l,iq_vap).gt.0.0) then 
                 call calcul_kcin(5.0,kcin)   
                 do ixt=1,niso
                   xt(i,j,l,iq_vap,ixt)=q(i,j,l,iq_vap)*
     :                  toce(ixt)/alpha(ixt)
     :                  /(0.3/(1.0-kcin(ixt))+0.7)
     :                  *(q(i,j,l,iq_vap)/20.0e-3)
     :                  **(alpha(ixt)-1.0) ! liquide
!                   write(*,*) 'iso_init_profile 74: striso(ixt)=',
!     :                   striso(ixt)
!                   write(*,*) 'toce(ixt),alpha(ixt),kcin(ixt)=',
!     :                     toce(ixt),alpha(ixt),kcin(ixt)     
                   xt(i,j,l,iq_liq,ixt)=q(i,j,l,iq_liq)
     :               *xt(i,j,l,iq_vap,ixt)/q(i,j,l,iq_vap)
     :               *alpha(ixt)
                 enddo !do ixt=1,niso
#ifdef ISOTRAC
                do ixt=niso+1,ntraciso
                   if (index_zone(ixt).eq.izone_init) then
                     xt(i,j,l,iq_vap,ixt)=xt
     :                  (i,j,l,iq_vap,index_iso(ixt))
                     xt(i,j,l,iq_liq,ixt)=xt
     :                  (i,j,l,iq_liq,index_iso(ixt))
                   else
                     xt(i,j,l,iq_vap,ixt)=0.0
                     xt(i,j,l,iq_liq,ixt)=0.0
                   endif
                 enddo !do ixt=1,niso
#endif

#ifdef ISOVERIF
                if (use_iso_eau.eq.1) then
                   call iso_verif_egalite(xt(i,j,l,iq_liq,iso_eau),
     :                   q(i,j,l,iq_liq),'iso_init_profiles 63')
                   call iso_verif_egalite(xt(i,j,l,iq_vap,iso_eau),
     :                   q(i,j,l,iq_vap),'iso_init_profiles 64')
                endif
                if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
                 if ((q(i,j,l,iq_liq).gt.ridicule).and.
     :           (xt(i,j,l,iq_liq,iso_o18).gt.
     :           ridicule*tnat(iso_o18))) then
                 call iso_verif_aberrant_o17(xt(i,j,l,iq_liq,iso_o17)
     :              /q(i,j,l,iq_liq),xt(i,j,l,iq_liq,iso_o18)
     :              /q(i,j,l,iq_liq),'iso_init_profiles 73')
                endif !if (q(i,j,l,iq).gt.ridicule) then
                if ((q(i,j,l,iq_vap).gt.ridicule).and.
     :           (xt(i,j,l,iq_vap,iso_o18).gt.
     :           ridicule*tnat(iso_o18))) then
!                 write(*,*) 'i,j,l,f,alpha17,alpha18=',i,j,l,
!     :              q(i,j,l,iq_vap)/20.0e-3,alpha(iso_o17),alpha(iso_o18)
                 call iso_verif_aberrant_o17(xt(i,j,l,iq_vap,iso_o17)
     :              /q(i,j,l,iq_vap),xt(i,j,l,iq_vap,iso_o18)
     :              /q(i,j,l,iq_vap),'iso_init_profiles 82')
                endif !if (q(i,j,l,iq).gt.ridicule) then                
               endif ! if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
               if (use_iso_HDO.eq.1) then 
                 if (use_iso_O18.eq.1) then  
                   if (q(i,j,l,iq).gt.ridicule) then
                       call iso_verif_o18_aberrant(
     :                   xt(i,j,l,iq_vap,iso_HDO)/q(i,j,l,iq_vap),
     :                   xt(i,j,l,iq_vap,iso_O18)/q(i,j,l,iq_vap),
     :                   'iso_init_profiles 143')
                    endif !if (q(i,j,l,iq).gt.ridicule) then
                  endif  !if (use_iso_HDO.eq.1) then
                endif  !if (use_iso_O18.eq.1) then
#endif                 
              else !if (q(i,j,l,iq_vap).gt.0.0) then 
                  do ixt=1,niso  
                    if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
                       xt(i,j,l,iq_vap,ixt)=q(i,j,l,iq_vap)       
                    else  
                       xt(i,j,l,iq_vap,ixt)=0.0
                    endif
                    xt(i,j,l,iq_liq,ixt)=q(i,j,l,iq_liq)*Rdefault(ixt)
                  enddo !do ixt=1,niso 
#ifdef ISOTRAC
                  do ixt=niso+1,ntraciso
                    if (index_zone(ixt).eq.izone_init) then
                       xt(i,j,l,iq_vap,ixt)=
     :                   xt(index_iso(ixt),i,j,l,iq_vap) 
                       xt(i,j,l,iq_liq,ixt)=
     :                   xt(index_iso(ixt),i,j,l,iq_liq)
                    else  
                       xt(i,j,l,iq_vap,ixt)=0.0
                       xt(i,j,l,iq_liq,ixt)=0.0
                    endif
                  enddo !do ixt=1,niso 
#endif                  
               endif !if (q(i,j,l,iq_vap).gt.0.0) then   
             enddo !do i=1,iip1   
            enddo !do j=1,jjp1   
           enddo !do l=1,llm

        else if (initialisation_iso.eq.3) then
           ! on met tout au smow     

          do iq=1,2
           do l=1,llm
            do i=1,iip1  
             do j=1,jjp1   
              do ixt=1,niso        
                   xt(i,j,l,iq,ixt)=tnat(ixt)*q(i,j,l,iq) 
              enddo ! do ixt=1,niso  
#ifdef ISOTRAC
              do ixt=niso+1,ntraciso  
                if (index_zone(ixt).eq.izone_init) then      
                   xt(i,j,l,iq,ixt)=xt(index_iso(ixt),i,j,l,iq)
                else
                   xt(i,j,l,iq,ixt)=0.0
                endif
              enddo ! do ixt=1,niso   
#endif              
             enddo !do i=1,iip1  
            enddo !do j=1,jjp1   
           enddo !do l=1,llm
         enddo !do iq=1,2
        else !else if (initialisation_iso.eq.3) then
            write(*,*) 'iso_init_profiles 38: initialisation_iso=',
     :            initialisation_iso
            stop
            
        endif !else if (initialisation_iso.eq.3) then

#ifdef ISOVERIF
              do iq=1,2
                do l=1,llm
                 do i=1,iip1
                  do j=1,jjp1
                    do ixt=1,niso
                      call iso_verif_noNAN(xt(i,j,l,iq,ixt),
     :                   'iso_init_profile 193')
                    enddo !do ixt=1,niso
                    if (use_iso_eau.eq.1) then
                        call iso_verif_egalite(xt(i,j,l,iq,iso_eau),
     :                q(i,j,l,iq),'dynisoetat0 57')
                    endif ! if (use_iso_eau.eq.1) then
                    if (use_iso_HDO.eq.1) then 
                     if (use_iso_O18.eq.1) then  
                      if (q(i,j,l,iq).gt.ridicule) then
                        if (iso_verif_o18_aberrant_nostop(
     :                   xt(i,j,l,iq,iso_HDO)/q(i,j,l,iq),
     :                   xt(i,j,l,iq,iso_O18)/q(i,j,l,iq),
     :                   'iso_init_profiles 215').eq.1) then
                          write(*,*) 'i,j,l,iq=',i,j,l,iq
                          write(*,*) 'q=',q(i,j,l,iq)
                          stop
                        endif
                      endif !if (q(i,j,l,iq).gt.ridicule) then
                     endif  !if (use_iso_HDO.eq.1) then
                    endif  !if (use_iso_O18.eq.1) then
#ifdef ISOTRAC     
                    call iso_verif_traceur_retourne4D(xt,iip1,jjp1,
     :                   llm,2,i,j,l,iq,'iso_init_profile 200')
#endif                     
                  enddo ! do i=1,iip1
                 enddo ! do j=1,jjp1
                enddo !do k=1,llm
              enddo !do iq=1,nq

!        ! ecriture d'un gdat
!        if ((sorties_gdat).and.(use_iso_O17.eq.1).and.
!     :           (use_iso_O18.eq.1)) then 
!       write( *,*) 'iso_ini_profiles 210'
!#include "debug_iso_init.h"
!         endif !if (sorties_gdat) then
#endif
       write( *,*) 'iso_ini_profiles 214'
        
        
        return
        end

#endif        
