      SUBROUTINE qminimum_p( q,nq,deltap 
#ifdef ISO
     :          ,xt 
#endif      
     :            )
      USE parallel
      IMPLICIT none
c
c  -- Objet : Traiter les valeurs trop petites (meme negatives)
c             pour l'eau vapeur et l'eau liquide
c
#include "dimensions.h"
#include "paramet.h"
#include "comvert.h"
c
      INTEGER nq
      REAL q(ip1jmp1,llm,nq), deltap(ip1jmp1,llm)

#ifdef ISO
#include "wateriso2.h"       
      real xt(ip1jmp1,llm,2,ntraciso) ! nqmax est la dimension officielle
      ! nq=2: car ici, on ne considère que eau liq et eau vap
      ! locals:
      integer ixt
#include "iso_verif.h"
!      real xt_prec(ntraciso,ip1jmp1,llm,nqmx)
      real qprec(ip1jmp1,llm,2)
      real xtprec(ip1jmp1,llm,2,niso)
      real Rtmp(niso,ip1jmp1,llm)
#ifdef ISOVERIF
        integer iso_verif_aberrant_nostop
        integer iso_verif_egalite_choix_nostop
        integer iso_verif_aberrant_enc_nostop
        real deltaD
#endif      
#endif    

c
      INTEGER iq_vap, iq_liq
      PARAMETER ( iq_vap = 1 ) ! indice pour l'eau vapeur
      PARAMETER ( iq_liq = 2 ) ! indice pour l'eau liquide
      REAL seuil_vap, seuil_liq
      PARAMETER ( seuil_vap = 1.0e-10 ) ! seuil pour l'eau vapeur
      PARAMETER ( seuil_liq = 1.0e-11 ) ! seuil pour l'eau liquide
c
c  NB. ....( Il est souhaitable mais non obligatoire que les valeurs des
c            parametres seuil_vap, seuil_liq soient pareilles a celles 
c            qui  sont utilisees dans la routine    ADDFI       )
c     .................................................................
c
      INTEGER i, k, iq
      REAL zx_defau, zx_abc, zx_pump(ip1jmp1), pompe
#ifdef ISO
      ! on diagnostique les transferts de masse
        real zx_defau_diag(ip1jmp1,llm,2)
        real q_follow(ip1jmp1,llm,2)
#endif
#ifdef ISOTRAC
        integer iiso
#endif        
c
      REAL SSUM
      EXTERNAL SSUM
c
      INTEGER imprim
      SAVE imprim
      DATA imprim /0/
c$OMP THREADPRIVATE(imprim)
      INTEGER ijb,ije
      INTEGER Index_pump(ip1jmp1)
      INTEGER nb_pump

c
c Quand l'eau liquide est trop petite (ou negative), on prend
c l'eau vapeur de la meme couche et la convertit en eau liquide
c (sans changer la temperature !)
c

      ijb=ij_begin
      ije=ij_end

#ifdef ISO   
        ! verif   
#ifdef ISOVERIF  
        write(*,*) 'qminimum 57: entrée'
        do iq=1,2
         DO k = 1, llm
          DO i = ijb,ije
           if (use_iso_HDO.eq.1) then
             call iso_verif_aberrant_encadre(
     :           xt(i,k,iq,iso_HDO)/q(i,k,iq),
     :           'qminimum 79')
           endif !if (use_iso_HDO.eq.1) then
           if (use_iso_eau.eq.1) then
             call iso_verif_egalite(
     :           xt(i,k,iq,iso_eau),q(i,k,iq),
     :           'qminimum 59')
           endif
          enddo !DO i = ijb,ije
         enddo !DO k = 1, llm
        enddo !do iq=1,2
        do iq=1,2
         DO k = 1, llm
          DO i = 1, ip1jmp1
              do ixt=1,niso
                call iso_verif_noNAN(xt(i,k,iq,ixt),'qminimum 69')
              enddo !do ixt=1,niso    
#ifdef ISOTRAC
           call iso_verif_traceur_retourne3D(xt,ip1jmp1,llm,2,
     :           i,k,iq,'qminimum 94')
#endif 
              qprec(i,k,iq)=q(i,k,iq)
              do ixt=1,niso
                xtprec(i,k,iq,ixt)=xt(i,k,iq,ixt)        
              enddo                
          enddo !DO i = 1, ip1jmp1
         enddo !DO k = 1, llm
        enddo !do iq=1,2
#endif            
!end verif

        if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then  
              do iq=1,2
                do k=1,llm
                  do i=ijb, ije
                        xt(i,k,iq,iso_eau)=q(i,k,iq)    
                  enddo !do i=ijb, ije
                enddo !k=1,llm
             enddo !iq=1,2
         endif
        do iq=1,2
         DO k = 1, llm
          DO i = 1, ip1jmp1
           q_follow(i,k,iq)=q(i,k,iq)
           zx_defau_diag(i,k,iq)=0.0
          enddo !DO i = 1, ip1jmp1
         enddo !DO k = 1, llm
        enddo !do iq=1,2 
#endif
!#ifdef ISO  


c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)       
      DO 1000 k = 1, llm
      DO 1040 i = ijb, ije
            if (seuil_liq - q(i,k,iq_liq) .gt. 0.d0 ) then
#ifdef ISO
             zx_defau_diag(i,k,iq_liq)= AMAX1(
     :            seuil_liq - q(i,k,iq_liq),0.0)
#endif
               q(i,k,iq_vap) = q(i,k,iq_vap) + q(i,k,iq_liq) - seuil_liq
               q(i,k,iq_liq) = seuil_liq
            endif
 1040 CONTINUE
 1000 CONTINUE
c$OMP END DO NOWAIT
c$OMP BARRIER
c --->  SYNCHRO OPENMP ICI

c
c Quand l'eau vapeur est trop faible (ou negative), on complete
c le defaut en prennant de l'eau vapeur de la couche au-dessous.
c
      iq = iq_vap
c
      DO k = llm, 2, -1
ccc      zx_abc = dpres(k) / dpres(k-1)
c$OMP DO SCHEDULE(STATIC)
      DO i = ijb, ije
         if ( seuil_vap - q(i,k,iq) .gt. 0.d0 ) then
#ifdef ISO
           zx_defau_diag(i,k,iq)=AMAX1( seuil_vap - q(i,k,iq), 0.0 )
#endif           
            q(i,k-1,iq) =  q(i,k-1,iq) - ( seuil_vap - q(i,k,iq) ) *
     &           deltap(i,k) / deltap(i,k-1)
            q(i,k,iq)   =  seuil_vap  
         endif
      ENDDO
c$OMP END DO NOWAIT
      ENDDO
c$OMP BARRIER
c
c Quand il s'agit de la premiere couche au-dessus du sol, on
c doit imprimer un message d'avertissement (saturation possible).
c
      nb_pump=0
c$OMP DO SCHEDULE(STATIC)
      DO i = ijb, ije
         zx_pump(i) = AMAX1( 0.0, seuil_vap - q(i,1,iq) )
         q(i,1,iq)  = AMAX1( q(i,1,iq), seuil_vap )
         IF (zx_pump(i) > 0.0) THEN
            nb_pump = nb_pump+1
            Index_pump(nb_pump)=i
         ENDIF
      ENDDO
c$OMP END DO  
!      pompe = SSUM(ije-ijb+1,zx_pump(ijb),1)

      IF (imprim.LE.100 .AND. nb_pump .GT. 0 ) THEN
         PRINT *, 'ATT!:on pompe de l eau au sol'
         DO i = 1, nb_pump
               imprim = imprim + 1
               PRINT*,'  en ',index_pump(i),zx_pump(index_pump(i))
#ifdef VERIFNEGATIF
            write(*,*) 'qmin 198: zx_pump(',i,')=',zx_pump(i)
#ifdef ISO            
            write(*,*) 'q_follow(i,1,iq_vap)=',q_follow(i,1,iq_vap)
            write(*,*) 'zx_defau_diag(i,2,iq_vap)=',
     :           zx_defau_diag(i,2,iq_vap)
            write(*,*) 'zx_defau_diag(i,1,iq_liq)=',
     :           zx_defau_diag(i,1,iq_liq)
#endif            
            stop
#endif
         ENDDO
      ENDIF


#ifdef ISO   
      ! pour les isotopes, on fait comme pour l'eau, mais en partant à
      ! l'envers: comme ça, aucune eau n'est négative.
      ! 1) pompage dans le sol
        DO i = ijb, ije
          if (zx_pump(i).gt.0.0) then
            do ixt=1,niso
              xt(i,1,iq_vap,ixt)=xt(i,1,iq_vap,ixt)+zx_pump(i)
     :                    *Rdefault(ixt)
            enddo !do ixt=1,niso
#ifdef ISOTRAC
            ! ce qu'on pompe, on le met dans izone_poubelle
           do iiso=1,niso
             ixt=index_trac(izone_poubelle,ixt)
             xt(i,1,iq_vap,ixt)=xt(i,1,iq_vap,ixt)+zx_pump(i)
     :                   *Rdefault(iiso)
           enddo  
#endif          
            q_follow(i,1,iq_vap)=q_follow(i,1,iq_vap)+zx_pump(i)
          endif
        enddo !DO i = 1, ip1jmp1

      ! 2) transfert de vap vers les couches plus hautes  
       do k=2,llm
        DO i = ijb, ije
          if (zx_defau_diag(i,k,iq_vap).gt.0.0) then
#ifdef ISOVERIF           
           ! normalement, la couche d'en dessous a déjà été traitée pour
           ! ne pas être négative   
              call iso_verif_positif_choix(q(i,k-1,iq_vap),
     :         0.0,'qmin 185')
#endif           
             
              ! on ajoute la vapeur en k              
              do ixt=1,ntraciso
               xt(i,k,iq_vap,ixt)=xt(i,k,iq_vap,ixt)
     :              +zx_defau_diag(i,k,iq_vap)
     :              *xt(i,k-1,iq_vap,ixt)/q_follow(i,k-1,iq_vap)
              ! et on la retranche en k-1
               xt(i,k-1,iq_vap,ixt)=xt(i,k-1,iq_vap,ixt)
     :              -zx_defau_diag(i,k,iq_vap)
     :              *deltap(i,k)/deltap(i,k-1)
     :              *xt(i,k-1,iq_vap,ixt)/q_follow(i,k-1,iq_vap)   
              enddo !do ixt=1,niso
              q_follow(i,k,iq_vap)=   q_follow(i,k,iq_vap)
     :               +zx_defau_diag(i,k,iq_vap)
              q_follow(i,k-1,iq_vap)=   q_follow(i,k-1,iq_vap)
     :               -zx_defau_diag(i,k,iq_vap)
     :              *deltap(i,k)/deltap(i,k-1)
          endif !if (zx_defau_diag(i,k,iq_vap).gt.0.0) then
        enddo !DO i = 1, ip1jmp1
       enddo !do k=2,llm

        ! 3) transfert d'eau de la vapeur au liquide
        do k=1,llm
        DO i = ijb, ije
          if (zx_defau_diag(i,k,iq_liq).gt.0.0) then
#ifdef ISOVERIF           
           ! normalement, la vapeur a déjà été traitée pour
           ! ne pas être négative   
              call iso_verif_positif_choix(q(i,k,iq_vap),
     :         0.0,'qmin 209')
#endif              
              ! on ajoute au liquide en k en k              
              do ixt=1,ntraciso
               xt(i,k,iq_liq,ixt)=xt(i,k,iq_liq,ixt)
     :              +zx_defau_diag(i,k,iq_liq)
     :              *xt(i,k,iq_vap,ixt)/q_follow(i,k,iq_vap)
              ! et on la retranche à la vapeur en k
               xt(i,k,iq_vap,ixt)=xt(i,k,iq_vap,ixt)
     :              -zx_defau_diag(i,k,iq_liq)
     :              *xt(i,k,iq_vap,ixt)/q_follow(i,k,iq_vap)   
              enddo !do ixt=1,niso
              q_follow(i,k,iq_liq)=   q_follow(i,k,iq_liq)
     :               +zx_defau_diag(i,k,iq_liq)
              q_follow(i,k,iq_vap)=   q_follow(i,k,iq_vap)
     :               -zx_defau_diag(i,k,iq_liq)
          endif !if (zx_defau_diag(i,k,iq_vap).gt.0.0) then
        enddo !DO i = 1, ip1jmp1
       enddo !do k=2,llm

      ! vérification finale:
#ifdef ISOVERIF
        DO k = 1, llm
          DO i = ijb, ije
            do iq=1,2
              do ixt=1,niso
                call iso_verif_noNAN(xt(i,k,iq,ixt),'qminimum 189')
              enddo
              if (iso_verif_egalite_choix_nostop(q_follow(i,k,iq),
     :              q(i,k,iq),'qminimum 261',
     :              errmax,errmaxrel).eq.1) then
                write(*,*) 'i,k,iq,iq_vap=',i,k,iq,iq_vap
                write(*,*) 'zx_defau_diag(i,k,iq)=',
     :                   zx_defau_diag(i,k,iq)
                write(*,*) 'qprec(i,k,iq)=',
     :                   qprec(i,k,iq)
                stop
              endif
              if (use_iso_eau.eq.1) then
               call iso_verif_egalite_choix(xt(i,k,iq,iso_eau),
     :              q(i,k,iq),'qminimum 186',
     :              errmax,errmaxrel)              
              endif !if (use_iso_eau.eq.1) then
              if (use_iso_HDO.eq.1) then   
                 if (q(i,k,iq).gt.ridicule) then
                   if (iso_verif_aberrant_enc_nostop(xt(i,k,iq,iso_HDO)
     :                   /q(i,k,iq),'qminimum 322').eq.1) then
                        write(*,*) 'i,k,iq=',i,k,iq
                        write(*,*) 'qprec(i,k,iq)=',qprec(i,k,iq)
                        write(*,*) 'q(i,k,iq)=',q(i,k,iq)
                        write(*,*) 'xtprec(i,k,iq,iso_eau)=',
     :                   xtprec(i,k,iq,iso_eau)
                        write(*,*) 'zx_defau_diag(i,k,iq_vap)=',
     :                   zx_defau_diag(i,k,iq_vap)
                        if (k.lt.llm) then
                           write(*,*) 'zx_defau_diag(i,k+1,iq_vap)=',
     :                          zx_defau_diag(i,k+1,iq_vap)
                        endif ! if (k.lt.llm) then
                        write(*,*) 'zx_defau_diag(i,k,iq_liq)=',
     :                   zx_defau_diag(i,k,iq_liq)                 
                        write(*,*) 'q_follow(i,k,iq)=',q_follow(i,k,iq)
                    endif
                 endif !if (q(ij,k,iq).gt.errmax) then
               endif  !if (use_iso_HDO.eq.1) then 
#ifdef ISOTRAC
           call iso_verif_traceur_retourne3D(xt,ip1jmp1,llm,2,
     :                  i,k,iq,'qminimum 94')
#endif                
            enddo !do iq=1,2
          enddo !DO i = ijb, ije
        enddo !DO k = 1, llm
!        write(*,*) 'qminimum 548: sortie'
#endif       
#endif      
c
      RETURN
      END
