!
! $Header$
!
       SUBROUTINE vlspltgen_p( q,iadv,pente_max
#ifdef CAMMODIF   
     &            ,pente_maxz
#endif     
     &           ,masse,w,pbaru,pbarv,pdt,
     &           p,pk,teta 
#ifdef ISO
     &     ,xt 
#ifdef DIAGISO
     &           ,dqdyn_horiz,dqdyn_vert
     &           ,dxtdyn_horiz,dxtdyn_vert
#endif       
#endif     
     &     )
c
c     Auteurs:   P.Le Van, F.Hourdin, F.Forget, F.Codron 
c
c    ********************************************************************
c          Shema  d''advection " pseudo amont " .
c      + test sur humidite specifique: Q advecte< Qsat aval
c                   (F. Codron, 10/99)
c    ********************************************************************
c     q,pbaru,pbarv,w sont des arguments d''entree  pour le s-pg ....
c
c     pente_max facteur de limitation des pentes: 2 en general
c                                                0 pour un schema amont
c     pbaru,pbarv,w flux de masse en u ,v ,w
c     pdt pas de temps
c
c     teta temperature potentielle, p pression aux interfaces,
c     pk exner au milieu des couches necessaire pour calculer Qsat
c   --------------------------------------------------------------------
      USE parallel
      USE mod_hallo
      USE Write_Field_p
      USE VAMPIR
      USE infotrac, ONLY : nqtot
      IMPLICIT NONE

c
#include "dimensions.h"
#include "paramet.h"
#include "logic.h"
#include "comvert.h"
#include "comconst.h"

c
c   Arguments:
c   ----------
      INTEGER iadv(nqtot)
      REAL masse(ip1jmp1,llm),pente_max
#ifdef CAMMODIF  
      real pente_maxz
#endif
      REAL pbaru( ip1jmp1,llm ),pbarv( ip1jm,llm)
      REAL q(ip1jmp1,llm,nqtot)
      REAL w(ip1jmp1,llm),pdt
      REAL p(ip1jmp1,llmp1),teta(ip1jmp1,llm),pk(ip1jmp1,llm)
#ifdef ISO
#include "wateriso2.h"
      REAL xt(ip1jmp1,llm,2,ntraciso)
#ifdef DIAGISO
      real dqdyn_horiz(ip1jmp1,llm,nqtot),
     &    dqdyn_vert(ip1jmp1,llm,nqtot)
      real dxtdyn_horiz(ip1jmp1,llm,2,ntraciso),
     &    dxtdyn_vert(ip1jmp1,llm,2,ntraciso)
#endif
#endif
c
c      Local 
c   ---------
c
      INTEGER ij,l
c
      REAL,SAVE :: qsat(ip1jmp1,llm)
      REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: zm
      REAL,SAVE :: mu(ip1jmp1,llm)
      REAL,SAVE :: mv(ip1jm,llm)
      REAL,SAVE :: mw(ip1jmp1,llm+1)
      REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: zq
#ifdef ISO
      REAL,DIMENSION(:,:,:,:),ALLOCATABLE,SAVE :: zR 
      REAL,SAVE :: muq(ip1jmp1,llm)
      REAL,SAVE :: zmq(ip1jmp1,llm)
      REAL,SAVE :: mvq(ip1jm,llm)
      REAL,SAVE :: mwq(ip1jmp1,llm+1)   
      REAL,SAVE :: zmqR(ip1jmp1,llm)
      REAL,SAVE :: muqR(ip1jmp1,llm)
      integer ixt
      integer iso_verif_aberrant_enc_nostop
      integer iso_verif_aberrant_o17_nostop
      integer iso_verif_noNaN_nostop
#ifdef ISOVERIF
#include "iso_verif.h"
#endif      
#ifdef DIAGISO
      real qprec(ip1jmp1,llm,nqtot),Rprec(ip1jmp1,llm,2,ntraciso)
#endif
#endif      
      REAL zzpbar, zzw

      REAL qmin,qmax
      DATA qmin,qmax/0.,1.e33/

c--pour rapport de melange saturant--

      REAL rtt,retv,r2es,r3les,r3ies,r4les,r4ies,play
      REAL ptarg,pdelarg,foeew,zdelta
      REAL tempe(ip1jmp1)
      INTEGER ijb,ije,iq
      LOGICAL, SAVE :: firstcall=.TRUE.
!$OMP THREADPRIVATE(firstcall)
      type(request) :: MyRequest1
      type(request) :: MyRequest2

c    fonction psat(T)

       FOEEW ( PTARG,PDELARG ) = EXP (
     *          (R3LES*(1.-PDELARG)+R3IES*PDELARG) * (PTARG-RTT)
     * / (PTARG-(R4LES*(1.-PDELARG)+R4IES*PDELARG)) )

        r2es  = 380.11733 
        r3les = 17.269
        r3ies = 21.875
        r4les = 35.86
        r4ies = 7.66
        retv = 0.6077667
        rtt  = 273.16

#ifdef ISOVERIF
            write(*,*) 'vlspltgen_p 128: entree: iadv=',iadv
#endif

c Allocate variables depending on dynamic variable nqtot

         IF (firstcall) THEN
            firstcall=.FALSE.
!$OMP MASTER
            ALLOCATE(zm(ip1jmp1,llm,nqtot))
            ALLOCATE(zq(ip1jmp1,llm,nqtot))
#ifdef ISO
            ALLOCATE(zR(ip1jmp1,llm,2,ntraciso))
#endif
!$OMP END MASTER
!$OMP BARRIER
         END IF
c-- Calcul de Qsat en chaque point
c-- approximation: au milieu des couches play(l)=(p(l)+p(l+1))/2
c   pour eviter une exponentielle.

      call SetTag(MyRequest1,100)
      call SetTag(MyRequest2,101)

	ijb=ij_begin-iip1
	ije=ij_end+iip1
	if (pole_nord) ijb=ij_begin
	if (pole_sud) ije=ij_end


c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
	DO l = 1, llm
         DO ij = ijb, ije
          tempe(ij) = teta(ij,l) * pk(ij,l) /cpp
         ENDDO
         DO ij = ijb, ije
          zdelta = MAX( 0., SIGN(1., rtt - tempe(ij)) )
          play   = 0.5*(p(ij,l)+p(ij,l+1))
          qsat(ij,l) = MIN(0.5, r2es* FOEEW(tempe(ij),zdelta) / play )
          qsat(ij,l) = qsat(ij,l) / ( 1. - retv * qsat(ij,l) )
         ENDDO
        ENDDO
c$OMP END DO NOWAIT
c      PRINT*,'Debut vlsplt version debug sans vlyqs'

        zzpbar = 0.5 * pdt
        zzw    = pdt

      ijb=ij_begin
      ije=ij_end
      if (pole_nord) ijb=ijb+iip1
      if (pole_sud)  ije=ije-iip1

c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)       
      DO l=1,llm
        DO ij = ijb,ije
            mu(ij,l)=pbaru(ij,l) * zzpbar
         ENDDO
      ENDDO
c$OMP END DO NOWAIT
      
      ijb=ij_begin-iip1
      ije=ij_end
      if (pole_nord) ijb=ij_begin
      if (pole_sud)  ije=ij_end-iip1

c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
      DO l=1,llm
         DO ij=ijb,ije
            mv(ij,l)=pbarv(ij,l) * zzpbar
         ENDDO
      ENDDO
c$OMP END DO NOWAIT

      ijb=ij_begin
      ije=ij_end

c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
      DO l=1,llm
         DO ij=ijb,ije
            mw(ij,l)=w(ij,l) * zzw
         ENDDO
      ENDDO
c$OMP END DO NOWAIT

c$OMP MASTER
      DO ij=ijb,ije
         mw(ij,llm+1)=0.
      ENDDO
c$OMP END MASTER

c      CALL SCOPY(ijp1llm,q,1,zq,1)
c      CALL SCOPY(ijp1llm,masse,1,zm,1)

       ijb=ij_begin
       ije=ij_end
    
#ifdef ISO
#ifdef ISOVERIFNAN
      DO iq=1,nqtot
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (iq.le.2) then
         do l=1,llm
          do ij=ijb,ije     
           do ixt=1,ntraciso
            call iso_verif_noNaN(xt(ij,l,iq,ixt),
     &          'vlspltgen_p 230')
           enddo !do ixt=1,ntraciso       
          enddo !do ij=ijb,ije 
         enddo !do l=1,llm
        endif !if (iq.le.2) then
c$OMP END DO NOWAIT  
      enddo ! DO iq=1,nqtot
#endif
#ifdef ISOVERIF
      write(*,*) 'vlspltgen_p 231 tmp'
      DO iq=1,nqtot
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (iq.le.2) then
         do l=1,llm
          do ij=ijb,ije       
           if (use_iso_HDO.eq.1) then
            call iso_verif_aberrant_encadre(
     &           xt(ij,l,iq,iso_HDO)/q(ij,l,iq),
     &           'vlspltgen_p 216')
           endif !if (use_iso_HDO.eq.1) then
           if (use_iso_eau.eq.1) then
            call iso_verif_egalite(
     &           xt(ij,l,iq,iso_eau),q(ij,l,iq),
     &           'vlspltgen_p 221')
           endif !if (use_iso_eau.eq.1) then
           if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
             if ((q(ij,l,iq).gt.ridicule).and.(xt(ij,l,iq,iso_o18)
     &           .gt.ridicule*tnat(iso_o18)).and.
     &              (l.lt.nlevmaxO17)) then
               call iso_verif_aberrant_o17(xt(ij,l,iq,iso_o17)
     &           /q(ij,l,iq),xt(ij,l,iq,iso_o18)/q(ij,l,iq),
     &           'vlspltgen_p 253: debut')
              endif !if (q(ij,l,iq).gt.ridicule) then
            endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
          enddo !do ij=ijb,ije 
         enddo !do l=1,llm
        endif !if (iq.le.2) then
c$OMP END DO NOWAIT  
      enddo ! DO iq=1,nqtot
#endif
#endif

      DO iq=1,nqtot
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
        DO l=1,llm
          zq(ijb:ije,l,iq)=q(ijb:ije,l,iq)
          zm(ijb:ije,l,iq)=masse(ijb:ije,l)
#ifdef ISO
          if (iq.le.2) then
           do ixt=1,ntraciso   
            do ij=ijb,ije
             call calcul_R(xt(ij,l,iq,ixt),q(ij,l,iq),
     &           zR(ij,l,iq,ixt),ixt)

#ifdef ISOVERIFNAN                               
               ! temporaire:
               if (iso_verif_noNaN_nostop(zR(ij,l,iq,ixt),
     &           'vlspltgen_p 281').eq.1) then
                write(*,*) 'ij,l,iq,ixt=',ij,l,iq,ixt
                write(*,*) 'zR=',zR(ij,l,iq,ixt)
                write(*,*) 'xt=',xt(ij,l,iq,ixt)
                write(*,*) 'q=',q(ij,l,iq)
                stop
               endif ! if (iso_verif_noNaN_nostop(zR(ij,l,iq,ixt),
#endif

            enddo !do ij=ijb,ije
           enddo !do ixt=1,ntraciso 
#ifdef ISOVERIF   
        if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
          do ij=ijb,ije
             if ((zq(ij,l,iq).gt.ridicule).and.(zR(ij,l,iq,iso_o18)
     &           .gt.tnat(iso_o18)).and.
     &              (l.lt.nlevmaxO17)) then
               call iso_verif_aberrant_o17(zR(ij,l,iq,iso_o17)
     &           ,zR(ij,l,iq,iso_o18),'vlspltgen_p 285: zR debut')
              endif !if (q(ij,l,iq).gt.ridicule) then
            enddo !do ij=ijb,ije
         endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then 
#endif
          endif !if (iq.le.2) then
#endif          
        ENDDO !DO l=1,llm
c$OMP END DO NOWAIT
      ENDDO !DO iq=1,nqtot


c$OMP BARRIER           
        ! 1ère advection en x

      DO iq=1,nqtot

#ifdef DIAGISO
        do l=1,llm
          do ij=ijb,ije    
            qprec(ij,l,iq)=zq(ij,l,iq)
          enddo
        enddo
        if (iq.le.2) then
         do l=1,llm
          do ij=ijb,ije  
            do ixt=1,ntraciso
              Rprec(ij,l,iq,ixt)=zR(ij,l,iq,ixt)
            enddo !do ixt=1,ntraciso
           enddo
          enddo
         endif
#endif                          

        if(iadv(iq) == 0) then
	
	  cycle 
	
	else if (iadv(iq)==10) then


#ifdef ISOVERIF
        write(*,*) 'vlspltgen_p 349 tmp: iadv=10'
#endif
#ifdef _ADV_HALO        
	  call vlx_p(zq(1,1,iq),pente_max,zm(1,1,iq),mu,
     &	             ij_begin,ij_begin+2*iip1-1
#ifdef CAMMODIF          
     &               ,zmq,muq,1
#endif
     &   )
#ifdef ISO      
        if (iq.le.2) then
         do ixt=1,ntraciso
	  call vlx_p(zR(1,1,iq,ixt),pente_max,zmq,muq,
     &	             ij_begin,ij_begin+2*iip1-1
     &               ,zmqR,muqR,2)
         enddo !do ixt=1,ntraciso
#ifdef ISOVERIF
      write(*,*) 'vlspltgen_p 362 tmp'
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (use_iso_HDO.eq.1) then
        do l=1,llm
         do ij=ijb,ije
          if (zq(ij,l,iq).gt.ridicule) then
           call iso_verif_aberrant_encadre(zR(ij,l,iq,iso_HDO),     
     &              'vlspltgen_p 257')
          endif !if (zq(ij,l,iq).gt.ridicule) then
         enddo
        enddo
        endif
        if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
!         write(*,*) 'vlspltgen_p 349'
         do l=1,llm
          do ij=ijb,ije
             if ((zq(ij,l,iq).gt.ridicule).and.(zR(ij,l,iq,iso_o18)
     &           *zq(ij,l,iq).gt.ridicule*tnat(iso_o18)).and.
     &              (l.lt.nlevmaxO17)) then
               call iso_verif_aberrant_o17(zR(ij,l,iq,iso_o17),
     &           zR(ij,l,iq,iso_o18),
     &           'vlspltgen_p 355: apres adv en x')
              endif !if (q(ij,l,iq).gt.ridicule) then
            enddo !do ij=ijb,ije
           enddo !do l=1,llm
         endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then          
        endif !if (iq.le.2) then
c$OMP END DO NOWAIT  
#endif
        endif !if (iq.le.2) then
#endif     

          call vlx_p(zq(1,1,iq),pente_max,zm(1,1,iq),mu,
     &               ij_end-2*iip1+1,ij_end
#ifdef CAMMODIF          
     &               ,zmq,muq,3
#endif
     &   )
#ifdef ISO      
        if (iq.le.2) then
         do ixt=1,ntraciso
	  call vlx_p(zR(1,1,iq,ixt),pente_max,zmq,muq,
     &	             ij_end-2*iip1+1,ij_end
     &               ,zmqR,muqR,4)
         enddo !do ixt=1,ntraciso
        endif !if (iq.le.2) then
#endif     

#else
!#ifdef _ADV_HALO
	  call vlx_p(zq(1,1,iq),pente_max,zm(1,1,iq),mu,
     &	             ij_begin,ij_end
#ifdef CAMMODIF          
     &               ,zmq,muq,5
#endif
     &   )
#ifdef ISO      
        if (iq.le.2) then
         do ixt=1,ntraciso

#ifdef ISOVERIFNAN                               
               ! temporaire:
            DO l = 1, llm  
             do ij=ij_begin,ij_end   
               if (iso_verif_noNaN_nostop(zR(ij,l,iq,ixt),
     &           'vlspltgen_p 413').eq.1) then
                write(*,*) 'ij,l,iq,ixt=',ij,l,iq,ixt
                write(*,*) 'zR=',zR(ij,l,iq,ixt)
                write(*,*) 'xt=',xt(ij,l,iq,ixt)
                write(*,*) 'q=',q(ij,l,iq)
!                stop
               endif ! if (iso_verif_noNaN_nostop(zR(ij,l,iq,ixt),
              enddo !do ij=ij_begin,ij_end   
             enddo !DO l = 1, llm     
#endif

	  call vlx_p(zR(1,1,iq,ixt),pente_max,zmq,muq,
     &	             ij_begin,ij_end
     &               ,zmqR,muqR,6)
         enddo !do ixt=1,ntraciso
#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
             if ((zq(ij,l,iq).gt.ridicule).and.(zR(ij,l,iq,iso_o18)
     &           *zq(ij,l,iq).gt.ridicule*tnat(iso_o18)).and.
     &              (l.lt.nlevmaxO17)) then
                if (iso_verif_aberrant_o17_nostop(zR(ij,l,iq,iso_o17)
     &            ,zR(ij,l,iq,iso_o18),
     &            'vlspltgen_p 407: apres 1ere adv x').eq.1) then
                  write(*,*) 'ij,l,iq=',ij,l,iq
                  stop
                endif
              endif !if (q(ij,l,iq).gt.ridicule) then
           endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then 
         enddo !do ij=ijb,ije
        enddo !do l=1,llm 
c$OMP END DO NOWAIT  
#endif     
        endif !if (iq.le.2) then
#endif     
#endif
!#ifdef _ADV_HALO

c$OMP MASTER
          call VTb(VTHallo)
c$OMP END MASTER
          call Register_Hallo(zq(1,1,iq),ip1jmp1,llm,2,2,2,2,MyRequest1)
          call Register_Hallo(zm(1,1,iq),ip1jmp1,llm,1,1,1,1,MyRequest1)
#ifdef ISO
        ! ici, question à Y MdS: que veulent dire les 1,1,1,1 ou 2,2,2,2?
        ! c'est la taille des hallos de recouvrement: ex: pour q, il faut
        ! échanger une frange de 2 éléments.
        if (iq.le.2) then
         do ixt=1,ntraciso
           call Register_Hallo(zR(1,1,iq,ixt),ip1jmp1,llm,
     &          2,2,2,2,MyRequest1)
         enddo !do ixt=1,ntraciso
        endif ! if (iq.le.2) then
        ! Rq: ici, on Register_Hallo seulement les variables locales
#ifdef DIAGISO
        call Register_Hallo(qprec(1,1,iq),ip1jmp1,llm,
     &          2,2,2,2,MyRequest1)
!        call Register_Hallo(dqdyn_vert(1,1,iq),ip1jmp1,llm,
!     &          2,2,2,2,MyRequest1)
!        call Register_Hallo(dqdyn_horiz(1,1,iq),ip1jmp1,llm,
!     &          2,2,2,2,MyRequest1)
        if (iq.le.2) then
         do ixt=1,ntraciso
          call Register_Hallo(Rprec(1,1,iq,ixt),ip1jmp1,llm,
     &          2,2,2,2,MyRequest1) 
!          call Register_Hallo(dxtdyn_vert(1,1,iq,ixt),ip1jmp1,llm,
!     &          2,2,2,2,MyRequest1) 
!          call Register_Hallo(dxtdyn_horiz(1,1,iq,ixt),ip1jmp1,llm,
!     &          2,2,2,2,MyRequest1) 
         enddo !do ixt=1,ntraciso
        endif
#endif        
#endif          

c$OMP MASTER
          call VTe(VTHallo)
c$OMP END MASTER
	else if (iadv(iq)==14) then

#ifdef ISOVERIF
        write(*,*) 'vlspltgen_p 509 tmp: iadv=14'
#endif
#ifdef _ADV_HALO           
          call vlxqs_p(zq(1,1,iq),pente_max,zm(1,1,iq),mu,qsat,
     &                 ij_begin,ij_begin+2*iip1-1
#ifdef CAMMODIF      
     &    ,zmq,muq
#endif
     &    )

#ifdef ISO
        if (iq.le.2) then
         do ixt=1,ntraciso
           call vlx_p(zR(1,1,iq,ixt),pente_max,zmq,muq,
     &          ij_begin,ij_begin+2*iip1-1
     &          ,zmqR,muqR,7)
         enddo !do ixt=1,ntraciso
        endif !if (iq.le.2) then
#endif 

          call vlxqs_p(zq(1,1,iq),pente_max,zm(1,1,iq),mu,qsat,
     &                 ij_end-2*iip1+1,ij_end
#ifdef CAMMODIF      
     &    ,zmq,muq
#endif
     &    )

#ifdef ISO
        if (iq.le.2) then
         do ixt=1,ntraciso
           call vlx_p(zR(1,1,iq,ixt),pente_max,zmq,muq,
     &          ij_end-2*iip1+1,ij_end
     &          ,zmqR,muqR,8)
         enddo !do ixt=1,ntraciso
#ifdef ISOVERIF
      write(*,*) 'vlspltgen_p 540 tmp'
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (use_iso_HDO.eq.1) then
        do l=1,llm
         do ij=ijb,ije
          if (zq(ij,l,iq).gt.ridicule) then
           call iso_verif_aberrant_encadre(zR(ij,l,iq,iso_HDO),     
     &              'vlspltgen_p 389')
          endif !if (zq(ij,l,iq).gt.ridicule) then
         enddo !do ij=ijb,ije
        enddo !do l=1,llm
        endif !if (use_iso_HDO.eq.1) then
c$OMP END DO NOWAIT  
#endif
#ifdef ISOVERIFNAN
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 418')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm
c$OMP END DO NOWAIT  
#endif
        endif !if (iq.le.2) then
#endif 

#else
!#ifdef _ADV_HALO 
          call vlxqs_p(zq(1,1,iq),pente_max,zm(1,1,iq),mu,qsat,
     &                 ij_begin,ij_end
#ifdef CAMMODIF      
     &    ,zmq,muq
#endif
     &    )

#ifdef ISO
        if (iq.le.2) then
         do ixt=1,ntraciso
           call vlx_p(zR(1,1,iq,ixt),pente_max,zmq,muq,
     &          ij_begin,ij_end
     &          ,zmqR,muqR,9)
         enddo !do ixt=1,ntraciso
#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (use_iso_HDO.eq.1) then
        do l=1,llm
         do ij=ijb,ije
          if (zq(ij,l,iq).gt.ridicule) then
           call iso_verif_aberrant_encadre(zR(ij,l,iq,iso_HDO),     
     &              'vlspltgen_p 420')
          endif !if (zq(ij,l,iq).gt.ridicule) then
         enddo
        enddo
        endif !if (use_iso_HDO.eq.1) then
c$OMP END DO NOWAIT  
#endif
#ifdef ISOVERIFNAN
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 460')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm
c$OMP END DO NOWAIT  
#endif
        endif !if (iq.le.2) then
#endif 

#endif
!#ifdef _ADV_HALO 
c$OMP MASTER
          call VTb(VTHallo)
c$OMP END MASTER

          call Register_Hallo(zq(1,1,iq),ip1jmp1,llm,2,2,2,2,MyRequest1)
          call Register_Hallo(zm(1,1,iq),ip1jmp1,llm,1,1,1,1,MyRequest1)
#ifdef ISO
        if (iq.le.2) then
          do ixt=1,ntraciso
            call Register_Hallo(zR(1,1,iq,ixt),ip1jmp1,llm,
     &          2,2,2,2,MyRequest1)
          enddo !do ixt=1,ntraciso
        endif !if (iq.le.2) then
#ifdef DIAGISO
        call Register_Hallo(qprec(1,1,iq),ip1jmp1,llm,
     &          2,2,2,2,MyRequest1)
!        call Register_Hallo(dqdyn_vert(1,1,iq),ip1jmp1,llm,
!     &          2,2,2,2,MyRequest1)
!        call Register_Hallo(dqdyn_horiz(1,1,iq),ip1jmp1,llm,
!     &          2,2,2,2,MyRequest1)
        if (iq.le.2) then
         do ixt=1,ntraciso
          call Register_Hallo(Rprec(1,1,iq,ixt),ip1jmp1,llm,
     &          2,2,2,2,MyRequest1) 
!          call Register_Hallo(dxtdyn_vert(1,1,iq,ixt),ip1jmp1,llm,
!     &          2,2,2,2,MyRequest1) 
!          call Register_Hallo(dxtdyn_horiz(1,1,iq,ixt),ip1jmp1,llm,
!     &          2,2,2,2,MyRequest1) 
         enddo !do ixt=1,ntraciso
        endif
#endif        
#endif
c$OMP MASTER
          call VTe(VTHallo)
c$OMP END MASTER 
        else
	
	  stop 'vlspltgen_p : schema non parallelise'
      
        endif

#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
      if (iq.le.2) then
        do l=1,llm
         do ij=ijb,ije
          if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
             if ((zq(ij,l,iq).gt.ridicule).and.(zR(ij,l,iq,iso_o18)
     &           *zq(ij,l,iq).gt.ridicule*tnat(iso_o18)).and.
     &              (l.lt.nlevmaxO17)) then
               call iso_verif_aberrant_o17(zR(ij,l,iq,iso_o17)
     &           ,zR(ij,l,iq,iso_o18),
     &          'vlspltgen_p 547: apres 1ere adv x')
               !write(*,*) 'vlspltgen_p 588'
              endif !if (q(ij,l,iq).gt.ridicule) then
           endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then 
         enddo !do ij=ijb,ije
        enddo !do l=1,llm 
      endif !if (iq.le.2) then
c$OMP END DO NOWAIT  
#endif    
#ifdef ISOVERIFNAN
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
      if (iq.le.2) then
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 492')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm 
      endif !if (iq.le.2) then
c$OMP END DO NOWAIT  
#endif
      enddo !DO iq=1,nqtot
      
      
c$OMP BARRIER      
c$OMP MASTER      
      call VTb(VTHallo)
c$OMP END MASTER

      call SendRequest(MyRequest1)

c$OMP MASTER
      call VTe(VTHallo)
c$OMP END MASTER       
c$OMP BARRIER
      do iq=1,nqtot

      ! 2e advection en x

        if(iadv(iq) == 0) then
	
	  cycle 
	
	else if (iadv(iq)==10) then
        
#ifdef _ADV_HALLO
          call vlx_p(zq(1,1,iq),pente_max,zm(1,1,iq),mu,
     &               ij_begin+2*iip1,ij_end-2*iip1
#ifdef CAMMODIF      
     &    ,zmq,muq,10
#endif
     &    )
#ifdef ISO
        if (iq.le.2) then
         do ixt=1,ntraciso
           call vlx_p(zR(1,1,iq,ixt),pente_max,zmq,muq,
     &          ij_begin,ij_end
     &          ,zmqR,muqR,11)
         enddo !do ixt=1,ntraciso
#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 609')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm
c$OMP END DO NOWAIT  
#endif
#ifdef ISOVERIFNAN
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (use_iso_HDO.eq.1) then
        do l=1,llm
         do ij=ijb,ije
          if (zq(ij,l,iq).gt.ridicule) then
           call iso_verif_aberrant_encadre(zR(ij,l,iq,iso_HDO),     
     &              'vlspltgen_p 496')
          endif !if (zq(ij,l,iq).gt.ridicule) then
         enddo
        enddo
        endif !if (use_iso_HDO.eq.1) then
        if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
         do l=1,llm
          do ij=ijb,ije
             if ((zq(ij,l,iq).gt.ridicule).and.(zR(ij,l,iq,iso_o18)
     &           *zq(ij,l,iq).gt.ridicule*tnat(iso_o18)).and.
     &              (l.lt.nlevmaxO17)) then
               call iso_verif_aberrant_o17(zR(ij,l,iq,iso_o17),
     &           zR(ij,l,iq,iso_o18),
     &           'vlspltgen_p 622: apres adv en x')
              endif !if (q(ij,l,iq).gt.ridicule) then
            enddo !do ij=ijb,ije
           enddo !do l=1,llm
         endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then          
        endif !if (iq.le.2) then
c$OMP END DO NOWAIT  
#endif
        endif !if (iq.le.2) then
#endif 
#endif  
!#ifdef _ADV_HALLO
	else if (iadv(iq)==14) then
#ifdef _ADV_HALLO
          call vlxqs_p(zq(1,1,iq),pente_max,zm(1,1,iq),mu,qsat,
     &                 ij_begin+2*iip1,ij_end-2*iip1
#ifdef CAMMODIF      
     &    ,zmq,muq
#endif
     &    )
#ifdef ISO
        if (iq.le.2) then
         do ixt=1,ntraciso
           call vlx_p(zR(1,1,iq,ixt),pente_max,zmq,muq,
     &          ij_begin,ij_end
     &          ,zmqR,muqR,12)
         enddo !do ixt=1,ntraciso
#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (use_iso_HDO.eq.1) then
        do l=1,llm
         do ij=ijb,ije
          if (zq(ij,l,iq).gt.ridicule) then
           call iso_verif_aberrant_encadre(zR(ij,l,iq,iso_HDO),     
     &              'vlspltgen_p 515')
          endif !if (zq(ij,l,iq).gt.ridicule) then
         enddo
        enddo
        endif  !if (use_iso_HDO.eq.1) then
c$OMP END DO NOWAIT  
#endif
#ifdef ISOVERIFNAN
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 589')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm
c$OMP END DO NOWAIT  
#endif
        endif !if (iq.le.2) then
#endif 
#endif 
!#ifdef _ADV_HALLO
        else
	
	  stop 'vlspltgen_p : schema non parallelise'
      
        endif

#ifdef ISOVERIFNAN
      if (iq.le.2) then
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 601')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm
c$OMP END DO NOWAIT  
      endif !if (iq.le.2) then
#endif        
      
      enddo ! do iq=1,nqtot
c$OMP BARRIER      
c$OMP MASTER
      call VTb(VTHallo)
c$OMP END MASTER

!      call WaitRecvRequest(MyRequest1)
!      call WaitSendRequest(MyRequest1)
c$OMP BARRIER
       call WaitRequest(MyRequest1)


c$OMP MASTER
      call VTe(VTHallo)
c$OMP END MASTER
c$OMP BARRIER

      do iq=1,nqtot

      ! advection en y

        if(iadv(iq) == 0) then
	
	  cycle 
	
	else if (iadv(iq)==10) then
        
          call vly_p(zq(1,1,iq),pente_max,zm(1,1,iq),mv
#ifdef CAMMODIF      
     &    ,zmq,mvq,1
#endif
     &    )
#ifdef ISO
        if (iq.le.2) then
         do ixt=1,ntraciso
           call vly_p(zR(1,1,iq,ixt),pente_max,zmq,mvq,
     &          zmqR,muqR,2)
         enddo !do ixt=1,ntraciso
#ifdef ISOVERIFNAN
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 636')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm        
c$OMP END DO NOWAIT  
#endif    
#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
        ! write(*,*) 'vlspltgen_p 783'
         do l=1,llm
          do ij=ijb,ije
             if ((zq(ij,l,iq).gt.ridicule).and.(zR(ij,l,iq,iso_o18)
     &           *zq(ij,l,iq).gt.ridicule*tnat(iso_o18)).and.
     &              (l.lt.nlevmaxO17)) then
               call iso_verif_aberrant_o17(zR(ij,l,iq,iso_o17),
     &           zR(ij,l,iq,iso_o18),
     &           'vlspltgen_p 738: apres adv en y')
              endif !if (q(ij,l,iq).gt.ridicule) then
            enddo !do ij=ijb,ije
           enddo !do l=1,llm
         endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then          
c$OMP END DO NOWAIT  
#endif    
        endif !if (iq.le.2) then
#endif 
	else if (iadv(iq)==14) then
      
          call vlyqs_p(zq(1,1,iq),pente_max,zm(1,1,iq),mv,qsat
#ifdef CAMMODIF      
     &    ,zmq,mvq
#endif
     &    )
#ifdef ISO
        if (iq.le.2) then
         do ixt=1,ntraciso
           call vly_p(zR(1,1,iq,ixt),pente_max,zmq,mvq,
     &          zmqR,muqR,3)
         enddo !do ixt=1,ntraciso
#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (use_iso_HDO.eq.1) then
        do l=1,llm
         do ij=ijb,ije
          if (zq(ij,l,iq).gt.ridicule) then
           call iso_verif_aberrant_encadre(zR(ij,l,iq,iso_HDO),     
     &              'vlspltgen_p 557')
          endif !if (zq(ij,l,iq).gt.ridicule) then
         enddo
        enddo
        endif !if (use_iso_HDO.eq.1) then
c$OMP END DO NOWAIT  
#endif
#ifdef ISOVERIFNAN
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 674')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm
c$OMP END DO NOWAIT  
#endif
        endif !if (iq.le.2) then
#endif 

 
        else
	
	  stop 'vlspltgen_p : schema non parallelise'
      
        endif      

#ifdef ISOVERIFNAN
      if (iq.le.2) then
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 684')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm
c$OMP END DO NOWAIT  
      endif !if (iq.le.2) then
#endif        

! fin de l'advection en y
#ifdef DIAGISO
!         write(*,*) 'vlspltgen_p 859: ijb,ije,ip1jmp1=',ijb,ije,ip1jmp1
        do l=1,llm
          do ij=ijb,ije    
            dqdyn_horiz(ij,l,iq)=zq(ij,l,iq)-qprec(ij,l,iq) 
            qprec(ij,l,iq) =zq(ij,l,iq)
            if (iq.le.2) then
             do ixt=1,ntraciso
              dxtdyn_horiz(ij,l,iq,ixt)=zR(ij,l,iq,ixt)*zq(ij,l,iq)
     &           -Rprec(ij,l,iq,ixt)*qprec(ij,l,iq) 
              Rprec(ij,l,iq,ixt)=zR(ij,l,iq,ixt)
             enddo !do ixt=1,ntraciso
            endif !if (iq.le.2) then
          enddo !do ij=ijb,ije    
        enddo ! do l=1,llm
#endif         
       
       enddo !do iq=1,nqtot

      do iq=1,nqtot
!         write(*,*) 'vlspltgen_p 895: iq=',iq

      ! advection en z

        if(iadv(iq) == 0) then 
	  
	  cycle 
	
	else if (iadv(iq)==10 .or. iadv(iq)==14 ) then
            

c$OMP BARRIER   

#ifdef ISOVERIFNAN
!         write(*,*) 'vlspltgen_p 909'
      if (iq.le.2) then
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 697')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm
c$OMP END DO NOWAIT  
      endif !if (iq.le.2) then
#endif      

#ifdef _ADV_HALLO
          call vlz_p(zq(1,1,iq),
#ifdef CAMMODIF               
     &               pente_maxz,
#else
     &               pente_max,
#endif     
     &               zm(1,1,iq),mw,
     &               ij_begin,ij_begin+2*iip1-1
#ifdef CAMMODIF      
     &               ,zmq,mwq,1
#endif
     &    )
#ifdef ISO
        if (iq.le.2) then
         do ixt=1,ntraciso
           call vlz_p(zR(1,1,iq,ixt),pente_maxz,zmq,mwq,
     &          ij_begin,ij_begin+2*iip1-1
     &          ,zmqR,muqR,2)
         enddo !do ixt=1,ntraciso
#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (use_iso_HDO.eq.1) then
        do l=1,llm
         do ij=ijb,ije
          if (zq(ij,l,iq).gt.ridicule) then
           call iso_verif_aberrant_encadre(zR(ij,l,iq,iso_HDO),     
     &              'vlspltgen_p 618')
          endif !if (zq(ij,l,iq).gt.ridicule) then
         enddo
        enddo
        endif !if (use_iso_HDO.eq.1) then
c$OMP END DO NOWAIT  
#endif
#ifdef ISOVERIFNAN
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 737')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm
c$OMP END DO NOWAIT  
#endif
        endif !if (iq.le.2) then
#endif      

          call vlz_p(zq(1,1,iq),
#ifdef CAMMODIF               
     &               pente_maxz,
#else
     &               pente_max,
#endif     
     &               zm(1,1,iq),mw,
     &               ij_end-2*iip1+1,ij_end
#ifdef CAMMODIF      
     &    ,zmq,mwq,3
#endif
     &    )
#ifdef ISO
        if (iq.le.2) then
         do ixt=1,ntraciso
           call vlz_p(zR(1,1,iq,ixt),pente_maxz,zmq,mwq,
     &          ij_end-2*iip1+1,ij_end
     &          ,zmqR,muqR,4)
         enddo !do ixt=1,ntraciso
#ifdef ISOVERIFNAN
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 782')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm
c$OMP END DO NOWAIT  
#endif
#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (use_iso_HDO.eq.1) then
        do l=1,llm
         do ij=ijb,ije
          if (zq(ij,l,iq).gt.ridicule) then
           call iso_verif_aberrant_encadre(zR(ij,l,iq,iso_HDO),     
     &              'vlspltgen_p 639')
          endif ! if (zq(ij,l,iq).gt.ridicule) then!
         enddo
        enddo
        endif !if (use_iso_HDO.eq.1) then
        if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
         write(*,*) 'vlspltgen_p 992'
         do l=1,llm
          do ij=ijb,ije
             if ((zq(ij,l,iq).gt.ridicule).and.(zR(ij,l,iq,iso_o18)
     &           *zq(ij,l,iq).gt.ridicule*tnat(iso_o18)).and.
     &              (l.lt.nlevmaxO17)) then
               call iso_verif_aberrant_o17(zR(ij,l,iq,iso_o17),
     &           zR(ij,l,iq,iso_o18),
     &           'vlspltgen_p 933: apres adv en z')
              endif !if (q(ij,l,iq).gt.ridicule) then
            enddo !do ij=ijb,ije
           enddo !do l=1,llm
         endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then          
        endif !if (iq.le.2) then
c$OMP END DO NOWAIT  
#endif
        endif !if (iq.le.2) then
#endif 
#else
! #ifdef _ADV_HALLO
          call vlz_p(zq(1,1,iq),
#ifdef CAMMODIF               
     &               pente_maxz,
#else
     &               pente_max,
#endif     
     &               zm(1,1,iq),mw,
     &               ij_begin,ij_end
#ifdef CAMMODIF      
     &               ,zmq,mwq,5
#endif
     &    )

#ifdef ISO
        if (iq.le.2) then
#ifdef ISOVERIFNAN
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 800')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm
c$OMP END DO NOWAIT  
#endif            
         do ixt=1,ntraciso
           call vlz_p(zR(1,1,iq,ixt),pente_maxz,zmq,mwq,
     &          ij_begin,ij_end
     &          ,zmqR,muqR,6)
         enddo !do ixt=1,ntraciso
#ifdef ISOVERIFNAN
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 833')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm
c$OMP END DO NOWAIT  
#endif            
#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (use_iso_HDO.eq.1) then
        do l=1,llm
         do ij=ijb,ije
          if (zq(ij,l,iq).gt.ridicule) then
           if (iso_verif_aberrant_enc_nostop(zR(ij,l,iq,iso_HDO),     
     &              'vlspltgen_p 662').eq.1) then
             write(*,*) 'ij,l,iq,zq=',ij,l,iq,zq(ij,l,iq) 
             write(*,*) 'zR(ij,l,iq,:)=',zR(ij,l,iq,:)
             stop
           endif
          endif !if (zq(ij,l,iq).gt.ridicule) then
         enddo
        enddo
        endif !if (use_iso_HDO.eq.1) then
        if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
         write(*,*) 'vlspltgen_p 1069'
         do l=1,llm
          do ij=ijb,ije
             if ((zq(ij,l,iq).gt.ridicule).and.(zR(ij,l,iq,iso_o18)
     &           *zq(ij,l,iq).gt.ridicule*tnat(iso_o18)).and.
     &              (l.lt.nlevmaxO17)) then
               call iso_verif_aberrant_o17(zR(ij,l,iq,iso_o17),
     &           zR(ij,l,iq,iso_o18),
     &           'vlspltgen_p 995: apres adv en z')
              endif !if (q(ij,l,iq).gt.ridicule) then
            enddo !do ij=ijb,ije
           enddo !do l=1,llm
         endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then          
c$OMP END DO NOWAIT  
#endif
        endif !if (iq.le.2) then
#endif 
! #ifdef ISO
#endif
! #ifdef _ADV_HALLO
c$OMP BARRIER

c$OMP MASTER
          call VTb(VTHallo)
c$OMP END MASTER

          call Register_Hallo(zq(1,1,iq),ip1jmp1,llm,2,2,2,2,MyRequest2)
          call Register_Hallo(zm(1,1,iq),ip1jmp1,llm,1,1,1,1,MyRequest2)
#ifdef ISO
        if (iq.le.2) then
         do ixt=1,ntraciso
          call Register_Hallo(zR(1,1,iq,ixt),ip1jmp1,llm,
     &          2,2,2,2,MyRequest2) 
         enddo !do ixt=1,ntraciso
        endif
#ifdef DIAGISO
        call Register_Hallo(qprec(1,1,iq),ip1jmp1,llm,
     &          2,2,2,2,MyRequest2)
!        call Register_Hallo(dqdyn_vert(1,1,iq),ip1jmp1,llm,
!     &          2,2,2,2,MyRequest2)
!        call Register_Hallo(dqdyn_horiz(1,1,iq),ip1jmp1,llm,
!     &          2,2,2,2,MyRequest2)
        if (iq.le.2) then
         do ixt=1,ntraciso
          call Register_Hallo(Rprec(1,1,iq,ixt),ip1jmp1,llm,
     &          2,2,2,2,MyRequest2) 
!          call Register_Hallo(dxtdyn_vert(1,1,iq,ixt),ip1jmp1,llm,
!     &          2,2,2,2,MyRequest2) 
!          call Register_Hallo(dxtdyn_horiz(1,1,iq,ixt),ip1jmp1,llm,
!     &          2,2,2,2,MyRequest2) 
         enddo !do ixt=1,ntraciso
        endif
#endif
#endif
c$OMP MASTER
          call VTe(VTHallo)
c$OMP END MASTER	
c$OMP BARRIER
        else
	
	  stop 'vlspltgen_p : schema non parallelise'
      
        endif
        ! fin de la première advection en z

      enddo !do iq=1,nqtot
c$OMP BARRIER      

c$OMP MASTER        
      call VTb(VTHallo)
c$OMP END MASTER

      call SendRequest(MyRequest2)

c$OMP MASTER
      call VTe(VTHallo)
c$OMP END MASTER	

c$OMP BARRIER
      do iq=1,nqtot

      ! 2e advection en z

        if(iadv(iq) == 0) then
	  
	  cycle 
	
	else if (iadv(iq)==10 .or. iadv(iq)==14 ) then
c$OMP BARRIER        

#ifdef _ADV_HALLO
          call vlz_p(zq(1,1,iq),
#ifdef CAMMODIF               
     &               pente_maxz,
#else
     &               pente_max,
#endif     
     &               zm(1,1,iq),mw,
     &               ij_begin+2*iip1,ij_end-2*iip1
#ifdef CAMMODIF      
     &    ,zmq,mwq,7
#endif
     &    )

#ifdef ISO
        if (iq.le.2) then
         do ixt=1,ntraciso
           call vlz_p(zR(1,1,iq,ixt),pente_max,zmq,mwq,
     &          ij_begin+2*iip1,ij_end-2*iip1
     &          ,zmqR,muqR,8)
         enddo !do ixt=1,ntraciso
#ifdef ISOVERIFNAN
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 931')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm         
c$OMP END DO NOWAIT  
#endif
#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (use_iso_HDO.eq.1) then
        do l=1,llm
         do ij=ijb,ije
          if (zq(ij,l,iq).gt.ridicule) then
           call iso_verif_aberrant_encadre(zR(ij,l,iq,iso_HDO),     
     &              'vlspltgen_p 747')
          endif !if (zq(ij,l,iq).gt.ridicule) then
         enddo
        enddo
        endif !if (use_iso_HDO.eq.1) then
        if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
         write(*,*) 'vlspltgen_p 1193'
         do l=1,llm
          do ij=ijb,ije
             if ((zq(ij,l,iq).gt.ridicule).and.(zR(ij,l,iq,iso_o18)
     &           *zq(ij,l,iq).gt.ridicule*tnat(iso_o18)).and.
     &              (l.lt.nlevmaxO17)) then
               call iso_verif_aberrant_o17(zR(ij,l,iq,iso_o17),
     &           zR(ij,l,iq,iso_o18),
     &           'vlspltgen_p 1105: apres adv en z')
              endif !if (q(ij,l,iq).gt.ridicule) then
            enddo !do ij=ijb,ije
           enddo !do l=1,llm
         endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then          
c$OMP END DO NOWAIT  
#endif
        endif !if (iq.le.2) then
#endif 

#endif

c$OMP BARRIER        
        else
	
	  stop 'vlspltgen_p : schema non parallelise'
      
        endif
        ! fin de la 2e advection en z

#ifdef DIAGISO
        do l=1,llm
          do ij=ijb,ije  
            dqdyn_vert(ij,l,iq)=zq(ij,l,iq)-qprec(ij,l,iq) 
            qprec(ij,l,iq) =zq(ij,l,iq)
            if (iq.le.2) then
             do ixt=1,ntraciso
              dxtdyn_vert(ij,l,iq,ixt)=zR(ij,l,iq,ixt)*zq(ij,l,iq)
     &           -Rprec(ij,l,iq,ixt)*qprec(ij,l,iq) 
              Rprec(ij,l,iq,ixt)=zR(ij,l,iq,ixt)
             enddo !do ixt=1,ntraciso
            endif !if (iq.le.2) then
          enddo
        enddo ! do l=1,llm
#endif             
      
      enddo !do iq=1,nqtot

c$OMP BARRIER
c$OMP MASTER
      call VTb(VTHallo)
c$OMP END MASTER

!      call WaitRecvRequest(MyRequest2)
!      call WaitSendRequest(MyRequest2)
c$OMP BARRIER
       CALL WaitRequest(MyRequest2)

c$OMP MASTER
      call VTe(VTHallo)
c$OMP END MASTER
c$OMP BARRIER


      do iq=1,nqtot
      ! advection en y

        if(iadv(iq) == 0) then
	
	  cycle 
	
	else if (iadv(iq)==10) then
        
          call vly_p(zq(1,1,iq),pente_max,zm(1,1,iq),mv
#ifdef CAMMODIF      
     &    ,zmq,mvq,4
#endif
     &    )
#ifdef ISO
        if (iq.le.2) then
         do ixt=1,ntraciso
           call vly_p(zR(1,1,iq,ixt),pente_max,zmq,mvq,
     &          zmqR,muqR,5)
         enddo !do ixt=1,ntraciso
#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
         write(*,*) 'vlspltgen_p 1278'
         do l=1,llm
          do ij=ijb,ije
             if ((zq(ij,l,iq).gt.ridicule).and.(zR(ij,l,iq,iso_o18)
     &           *zq(ij,l,iq).gt.ridicule*tnat(iso_o18)).and.
     &              (l.lt.nlevmaxO17)) then
               call iso_verif_aberrant_o17(zR(ij,l,iq,iso_o17),
     &           zR(ij,l,iq,iso_o18),
     &           'vlspltgen_p 1174: apres adv en y')
              endif !if (q(ij,l,iq).gt.ridicule) then
            enddo !do ij=ijb,ije
           enddo !do l=1,llm
         endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
c$OMP END DO NOWAIT  
#endif           
        endif !if (iq.le.2) then
#endif 
  
	else if (iadv(iq)==14) then
      
          call vlyqs_p(zq(1,1,iq),pente_max,zm(1,1,iq),mv,qsat
#ifdef CAMMODIF      
     &    ,zmq,mvq
#endif
     &    )
#ifdef ISO
        if (iq.le.2) then
         do ixt=1,ntraciso
           call vly_p(zR(1,1,iq,ixt),pente_max,zmq,mvq,
     &          zmqR,muqR,6)
         enddo !do ixt=1,ntraciso
#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (use_iso_HDO.eq.1) then
        do l=1,llm
         do ij=ijb,ije
          if (zq(ij,l,iq).gt.ridicule) then
           call iso_verif_aberrant_encadre(zR(ij,l,iq,iso_HDO),     
     &              'vlspltgen_p 824')
          endif
         enddo
        enddo
        endif !if (use_iso_HDO.eq.1) then
c$OMP END DO NOWAIT  
#endif
#ifdef ISOVERIFNAN
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 1019')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm
c$OMP END DO NOWAIT  
#endif
        endif !if (iq.le.2) then
#endif 
 
        else
	
	  stop 'vlspltgen_p : schema non parallelise'
      
        endif
       ! fin de l'advection en y
       enddo !do iq=1,nqtot

      do iq=1,nqtot
      ! 3e advection en x

        if(iadv(iq) == 0) then 
	  
	  cycle 
	
	else if (iadv(iq)==10) then
        
          call vlx_p(zq(1,1,iq),pente_max,zm(1,1,iq),mu,
     &               ij_begin,ij_end
#ifdef CAMMODIF      
     &    ,zmq,muq,13
#endif
     &    )
#ifdef ISO
        if (iq.le.2) then
         do ixt=1,ntraciso
           call vlx_p(zR(1,1,iq,ixt),pente_max,zmq,muq,
     &          ij_begin,ij_end
     &          ,zmqR,muqR,14)
         enddo !do ixt=1,ntraciso

#ifdef ISOVERIFNAN
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 1253')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm       
c$OMP END DO NOWAIT  
#endif         
#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (use_iso_HDO.eq.1) then
        do l=1,llm
         do ij=ijb,ije
          if (zq(ij,l,iq).gt.ridicule) then
           call iso_verif_aberrant_encadre(zR(ij,l,iq,iso_HDO),     
     &              'vlspltgen_p 1244')
          endif !if (zq(ij,l,iq).gt.ridicule) then
         enddo
        enddo
        endif !if (use_iso_HDO.eq.1) then
        if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
         write(*,*) 'vlspltgen_p 1386'
         do l=1,llm
          do ij=ijb,ije
             if ((zq(ij,l,iq).gt.ridicule).and.(zR(ij,l,iq,iso_o18)
     &           *zq(ij,l,iq).gt.ridicule*tnat(iso_o18)).and.
     &              (l.lt.nlevmaxO17)) then
               call iso_verif_aberrant_o17(zR(ij,l,iq,iso_o17)
     &           ,zR(ij,l,iq,iso_o18),'vlspltgen_p 1264')
              endif !if (q(ij,l,iq).gt.ridicule) then
            enddo !do ij=ijb,ije
           enddo !do l=1,llm
         endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then        
c$OMP END DO NOWAIT  
#endif         
        endif !if (iq.le.2) then
#endif 
  
	else if (iadv(iq)==14) then
      
          call vlxqs_p(zq(1,1,iq),pente_max,zm(1,1,iq),mu,qsat,
     &                 ij_begin,ij_end
#ifdef CAMMODIF      
     &    ,zmq,muq
#endif
     &    )
#ifdef ISO
        if (iq.le.2) then
         do ixt=1,ntraciso
           call vlx_p(zR(1,1,iq,ixt),pente_max,zmq,muq,
     &          ij_begin,ij_end
     &          ,zmqR,muqR,15)
         enddo !do ixt=1,ntraciso
#ifdef ISOVERIFNAN
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        do l=1,llm
         do ij=ijb,ije
          do ixt=1,ntraciso
           call iso_verif_noNaN(zR(ij,l,iq,ixt),
     &          'vlspltgen_p 418')
          enddo !do ixt=1,ntraciso
         enddo !do ij=ijb,ije
        enddo !do l=1,llm      
c$OMP END DO NOWAIT  
#endif
#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (use_iso_HDO.eq.1) then
        do l=1,llm
         do ij=ijb,ije
          if (zq(ij,l,iq).gt.ridicule) then
           call iso_verif_aberrant_encadre(zR(ij,l,iq,iso_HDO),     
     &              'vlspltgen_p 886')
          endif !if (zq(ij,l,iq).gt.ridicule) then
         enddo
        enddo
        endif !if (use_iso_HDO.eq.1) then
        if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
         write(*,*) 'vlspltgen_p 1438'
         do l=1,llm
          do ij=ijb,ije
             if ((zq(ij,l,iq).gt.ridicule).and.(zR(ij,l,iq,iso_o18)
     &           *zq(ij,l,iq).gt.ridicule*tnat(iso_o18)).and.
     &              (l.lt.nlevmaxO17)) then
               call iso_verif_aberrant_o17(zR(ij,l,iq,iso_o17)
     &           ,zR(ij,l,iq,iso_o18),'vlspltgen_p 1259')
              endif !if (q(ij,l,iq).gt.ridicule) then
            enddo !do ij=ijb,ije
           enddo !do l=1,llm
         endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then        
c$OMP END DO NOWAIT  
#endif
        endif !if (iq.le.2) then
#endif 
 
        else
	
          stop 'vlspltgen_p : schema non parallelise'
      
        endif
        ! fin de la 3e et dernière advection en x
#ifdef DIAGISO
        do l=1,llm
          do ij=ijb,ije   
            dqdyn_horiz(ij,l,iq)=dqdyn_horiz(ij,l,iq)
     &            +(zq(ij,l,iq)-qprec(ij,l,iq))
            qprec(ij,l,iq) =zq(ij,l,iq)
            if (iq.le.2) then
             do ixt=1,ntraciso
              dxtdyn_horiz(ij,l,iq,ixt)=dxtdyn_horiz(ij,l,iq,ixt)
     &            +(zR(ij,l,iq,ixt)*zq(ij,l,iq)
     &           -Rprec(ij,l,iq,ixt)*qprec(ij,l,iq))
              Rprec(ij,l,iq,ixt)=zR(ij,l,iq,ixt)
             enddo !do ixt=1,ntraciso
            endif !if (iq.le.2) then
          enddo
        enddo ! do l=1,llm
#endif   
       
       enddo !do iq=1,nqtot

     
      ijb=ij_begin
      ije=ij_end
c$OMP BARRIER      


      DO iq=1,nqtot

c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)          
        DO l=1,llm
           DO ij=ijb,ije
c             print *,'zq-->',ij,l,iq,zq(ij,l,iq)
c	     print *,'q-->',ij,l,iq,q(ij,l,iq)
	     q(ij,l,iq)=zq(ij,l,iq)
           ENDDO
        ENDDO
c$OMP END DO NOWAIT    
       
#ifdef ISO
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)  
        do ixt=1,ntraciso
         if (iq.le.2) then
          DO l=1,llm
           DO ij=ijb,ije
              xt(ij,l,iq,ixt)=zR(ij,l,iq,ixt)*zq(ij,l,iq)              
           ENDDO !DO ij=ijb,ije
          ENDDO !DO l=1,llm
         endif !if (iq.le.2) then  
        enddo !do ixt=1,ntraciso         
c$OMP END DO NOWAIT 
#endif            

c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        DO l=1,llm
           DO ij=ijb,ije-iip1+1,iip1
              q(ij+iim,l,iq)=q(ij,l,iq)
           ENDDO
        ENDDO
c$OMP END DO NOWAIT  


#ifdef ISO
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)  
        do ixt=1,ntraciso
         if (iq.le.2) then
          DO l=1,llm
           DO ij=ijb,ije-iip1+1,iip1
              xt(ij,l,iq,ixt)=zR(ij,l,iq,ixt)*zq(ij,l,iq)
           ENDDO !DO ij=ijb,ije-iip1+1,iip1
          ENDDO !DO l=1,llm
         endif !if (iq.le.2) then          
        enddo !do ixt=1,ntraciso 
c$OMP END DO NOWAIT 
#endif

#ifdef ISO
#ifdef ISOVERIFNAN
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (iq.le.2) then
         DO l=1,llm
          DO ij=ijb,ije
           do ixt=1,ntraciso
            call iso_verif_noNaN(xt(ij,l,iq,ixt),
     &          'vlspltgen_p 1095')
           enddo !do ixt=1,ntraciso 
          enddo !DO ij=ijb,ije
         enddo !DO l=1,llm
        endif !if (iq.le.2) then
c$OMP END DO NOWAIT  
#endif
#ifdef ISOVERIF
c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
        if (iq.le.2) then
         DO l=1,llm
          DO ij=ijb,ije
           if (use_iso_HDO.eq.1) then
            call iso_verif_aberrant_encadre(
     :           xt(ij,l,iq,iso_HDO)/q(ij,l,iq),
     :           'vlspltgen_p 844')
           endif
           if (use_iso_eau.eq.1) then
            call iso_verif_egalite(
     :           xt(ij,l,iq,iso_eau),q(ij,l,iq),
     :           'vlspltgen_p 850')
           endif          
           if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
             if ((q(ij,l,iq).gt.ridicule).and.(xt(ij,l,iq,iso_o18)
     &           .gt.ridicule*tnat(iso_o18)).and.
     &              (l.lt.nlevmaxO17)) then
                if (iso_verif_aberrant_o17_nostop(xt(ij,l,iq,iso_o17)
     &           /q(ij,l,iq),xt(ij,l,iq,iso_o18)/q(ij,l,iq),
     &           'vlspltgen_p 1365: fin').eq.1) then
                   write(*,*) 'ij,l,iq,q=',ij,l,iq,q(ij,l,iq)
                   stop
                endif
              endif !if (q(ij,l,iq).gt.ridicule) then
            endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
          enddo !DO ij=ijb,ije
         enddo !DO l=1,llm
        endif !if (iq.le.2) then
c$OMP END DO NOWAIT  
#endif
#endif

      ENDDO ! do iq=1,nqtot
        
      
c$OMP BARRIER

cc$OMP MASTER      
c      call WaitSendRequest(MyRequest1) 
c      call WaitSendRequest(MyRequest2)
cc$OMP END MASTER
cc$OMP BARRIER

#ifdef ISOVERIF
        write(*,*) 'vlspltgen_p 1240: sortie'
#endif

      RETURN
      END
