! subroutine traitant l'vaporation des gouttes spcfiquement pour
! schma de KE
!  modifier  la moindre modif du schma de KE
#ifdef ISO
      subroutine appel_stewart_vectall_np(lwork,ncum,
     :           PH,T,EVAP,XTWDTRAIN,
     :                   WDTRAIN,
     :            WATER,Q,XT, QS,QP,MP,WT, ! inputs physiques
     :            XTWATER,XTP,    ! outputs indispensables
     :           XTEVAP,     ! diagnostiques
     :          SIGD,  ! inputs tunables
     :          i,INB, ! altitude: car cas particulier en INB 
     :          NA,ND,nloc,cvflag_grav,ginv,Mpmin) ! dimensions  

      implicit none

#include "wateriso2.h"

      !*inputs et outputs
      integer ncum ! dimension horiz effective
      logical lwork(nloc)
      integer NA,ND,nloc ! dimensions officielles
      real PH(nloc,ND),T(nloc,ND),EVAP(nloc,NA)
      real XTWDTRAIN(ntraciso,nloc),WDTRAIN(nloc),
     :       WATER(nloc,NA), Q(nloc,NA), XT(ntraciso,nloc,ND),
     :            QS(nloc,ND),QP(nloc,NA),
     :       XTWATER(ntraciso,nloc,NA),XTP(ntraciso,nloc,NA),
     :     XTEVAP(ntraciso,nloc,NA),
     :       WT(nloc,NA), MP(nloc,NA)
      real SIGD(nloc)
      integer i,INB(nloc)
      logical cvflag_grav
      real ginv
      real Mpmin

      !* variables intermediaires
      integer ixt,j,il
      real qeff(ncum)
      double precision xtp_avantevap(ntraciso,ncum),qp_avantevap(ncum)
!      double precision Exi(niso,ncum) ! equivalent  Eqi_prime
      double precision Pqisup(ncum),Pqiinf(ncum),Eqi(ncum) 
      double precision Pqiinf_par(ncum), Eqi_prime(ncum), 
     :            Eqi_plus1(ncum), Eqi_par(ncum)
      double precision Pqiinf_stewart(ncum), Eqi_stewart(ncum)
      double precision Exi_prime(ntraciso,ncum)
      double precision Pxtiinf_stewart(niso,ncum), 
     :           Exi_stewart(niso,ncum)
      double precision Exi_plus1(niso,ncum)
      double precision Pxtisup(ntraciso,ncum), Pxtiinf(niso,ncum)
      double precision xtnew(niso,ncum)
      double precision fac_ftmr(ncum) ! facteur de conversion des flux en mixing ratio
!      double precision Risup(ntraciso,ncum), Rcond(ntraciso,ncum), 
!     :           Renv(ntraciso,ncum) 
!      double precision  Revap(ntraciso,ncum), Riinf(ntraciso,ncum)
!      real xtice(ntraciso,ncum), xtliq(ntraciso,ncum)
!      real xtp0(ntraciso,ncum), qp0(ncum)
!     real fcond(ncum), fice(ncum), cond(ncum)
!      real zxtalphal(niso,ncum), zxtalphai(niso,ncum)
      real g
      real rat(ncum)
      real ztglace_kelvin
      parameter (ztglace_kelvin=273.15)

      integer frac_sublim
      real double_to_real     
      double precision real_to_double

      ! compteurs de parsage
      integer icas_condensation_facftmr,ncas_condensation_facftmr
      integer icas_condensation_nofacftmr,ncas_condensation_nofacftmr
      integer icas_noevap,ncas_noevap
      integer icas_evap_liq,ncas_evap_liq
      integer icas_evap_glace,ncas_evap_glace
      integer ncas_tot

      ! tableaux d'indice issus du parsage
      integer cas_condensation_facftmr(ncum)
      integer cas_condensation_nofacftmr(ncum)
      integer cas_noevap(ncum)
      integer cas_evap_liq(ncum)
      integer cas_evap_glace(ncum)

#include "iso_verif.h"      
      integer trace_cas(ncum)
#ifdef ISOVERIFIDRIS
      ! tracage des cas
        ! -1: ce n'est pas un point de travail
        ! 0: initialisation des points de travail
        ! 11: condensation_facftmr
        ! 12: condensation_nofacftmr
        ! 2: noevap
        ! 31: evap_liq
        ! 32: evap_glace
      integer iso_verif_positif_nostop
      integer iso_verif_positif_choix_nostop
      integer iso_verif_aberrant_nostop
      integer iso_verif_traceur_nostop
      integer iso_verif_egalite_nostop
      integer iso_verif_egalite_choix_nostop
      real deltaD
      double precision Exi_cas(niso,ncum),Exi(ntraciso,ncum)
#endif    
      integer iso_verif_noNAN_nostop


      ! outputs des calculs, compresss
      real xtevap_cas(niso,ncum),xtp_cas(niso,ncum),
     :            xtwater_cas(niso,ncum)

      ! inputs des calculs, comprsss
      real T_cas(ncum),delP_cas(ncum),
     :           xtevapsup_cas(niso,ncum),evap_cas(ncum),
     :           qp_cas(ncum),wt_cas(ncum),
     :           xt_cas(niso,ncum),q_cas(ncum),
     :           qs_cas(ncum),water_cas(ncum)           
      double precision  qp_avantevap_cas(ncum),
     :   xtp_avantevap_cas(niso,ncum),
     :   Pqisup_cas(ncum), Pxtisup_cas(niso,ncum), 
     :   Eqi_prime_cas(ncum),fac_ftmr_cas(ncum) , 
     :   Eqi_cas(ncum)
#ifdef ISOTRAC      
      double precision  qp_avantevaptrac_cas(ncum),
     :   xtp_avantevaptrac_cas(niso,ncum) 
        integer izone ,iiso
      real xtaddp_tag(niso,ncum)
      double precision ptrac(ncum)
      real hdiag(ncum)
#endif      
      integer INB_cas(ncum)
              

!      write(*,*) 'appel_stewart_np 48: entre, i=',i

      ! definition de quelques constantes:

      !gravit:
      if (cvflag_grav) then
          g=1/ginv
      else
          g=10.
      endif

      ! fractionne-t-on lors de la sublimation?
      frac_sublim=0 ! -> on ne fractionne pas
      !frac_sublim=1 ! -> oui, on fractionne
      

      ! ***** verification des inputs ************
      
#ifdef ISOVERIF
      if (use_iso_eau.eq.1) then
        do il=1,ncum 
         if (i.le.inb(il) .and. lwork(il)) then
          call iso_verif_egalite_choix(xt(iso_eau,il,i),q(il,i),
     :            'appel_stewart_np 58',errmax,errmaxrel)
         endif !if (i.le.inb(il) .and. lwork(il)) then
        enddo !do il=1,ncum    
      endif !if (use_iso_eau.eq.1) then
#ifdef ISOTRAC
      do il=1,ncum
         call iso_verif_traceur(xt(1,il,i),
     :         'appel_stewart_np 141')
      enddo  
#endif      
#endif
      if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
         do il=1,ncum 
             if (i.le.inb(il) .and. lwork(il)) then   
                xt(iso_eau,il,i)=  q(il,i)
             endif !if (i.le.inb(il) .and. lwork(il)) then
           enddo !do il=1,ncum     
      endif !if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
      
      ! verif que les vapeurs du ddft plus haut sont bonnes
      ! si i=INB, on ne verifie rien car pas de vapeur au dessus de INB
#ifdef ISOVERIFNAN
       do il=1,ncum 
         if (i.lt.inb(il) .and. lwork(il)) then
          do j=i+1,INB(il)
            do ixt=1,ntraciso
              call iso_verif_noNAN(xtevap(ixt,il,j),
     :         'appel_stewart_np 96')
            enddo
         enddo !do j=i+1,INB
        endif ! (i.lt.inb(il) .and. lwork(il)) then
       enddo !do il=1,ncum 
#endif
#ifdef ISOVERIF
       do il=1,ncum 
         if (i.lt.inb(il) .and. lwork(il)) then
          do j=i+1,INB(il)
            if (use_iso_eau.eq.1) then
              call iso_verif_egalite_choix(xtp(iso_eau,il,j),qp(il,j),
     :            'appel_stewart_np 66',errmax,errmaxrel)          
            endif !if (use_iso_eau.eq.1) then
#ifdef ISOTRAC
            call iso_verif_traceur(xtp(1,il,j),
     :          'appel_stewart_np 167')
#endif  
         enddo !do j=i+1,INB
        endif ! (i.lt.inb(il) .and. lwork(il)) then
       enddo !do il=1,ncum 
#endif

      if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
       do il=1,ncum 
        if (i.lt.inb(il) .and. lwork(il)) then
         do j=i+1,INB(il)
          xtp(iso_eau,il,j)=qp(il,j)          
         enddo !do j=i+1,INB
        endif ! (i.lt.inb(il) .and. lwork(il)) then
       enddo !do il=1,ncum 
      endif !if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
      ! end verif des inputs 


      ! ****** calcul du facteur de conversion des flux en mixing ratio
      
      do il=1,ncum 
       if (i.le.inb(il) .and. lwork(il)) then
        if ((Mp(il,i).gt.Mp(il,i+1)).and.(Mp(il,i).gt.Mpmin)) then
          ! cas entrainant
          fac_ftmr(il)=1.0/Mp(il,i)
        else !if ((Mp(il,i).gt.Mp(il,i+1))
          if (Mp(il,i+1).gt.Mpmin) then
              ! cas non entrainant, mais flux existe
              fac_ftmr(il)=1.0/Mp(il,i+1)
          else
              ! pas de flux de masse, XTP reste constant
              fac_ftmr(il)=0.0
          endif
        endif !if ((Mp(il,i).gt.Mp(il,i+1))
#ifdef ISOVERIF
        
#endif        
       endif ! (i.le.inb(il) .and. lwork(il)) then
      enddo !do il=1,ncum

      ! ****** calcul de la vapeur dans le ddft avant rvap
            
      do il=1,ncum 
       if (i.le.inb(il) .and. lwork(il)) then      
        if (i.lt.INB(il)) then      
         if ((Mp(il,i).gt.Mp(il,i+1)).and.(Mp(il,i).gt.Mpmin)) then
          ! cas entrainant
          rat(il)=Mp(il,i+1)/Mp(il,i)
          qp_avantevap(il)=qp(il,i+1)*rat(il)+q(il,i)*(1-rat(il)) 
          do ixt=1,ntraciso
             xtp_avantevap(ixt,il)=xtp(ixt,il,i+1)*rat(il)
     :           +xt(ixt,il,i)*(1-rat(il))
          enddo
         else !if (Mp(il,i).gt.Mp(il,i+1)) then
           if (Mp(il,i+1).gt.Mpmin) then
              ! cas non entrainant, mais flux existe
              qp_avantevap(il)=qp(il,i+1)
              do ixt=1,ntraciso
                xtp_avantevap(ixt,il)=xtp(ixt,il,i+1)
              enddo
              
           else    !if (Mp(il,i+1).gt.0) then    
              
              ! pas de flux de masse, on ne calcule rien
              ! on garde le qp calcul dans cv3_unsat, original
              ! on suppose que le deltaD dans le ddft est celui de
              ! l'environnement
              qp_avantevap(il)=qp(il,i)
              if (qp(il,i).gt.0) then
#ifdef ISOVERIF
                call iso_verif_positif_strict(q(il,i),
     :                'appel_stewart_np 226')
#endif                  
                do ixt=1,ntraciso
                 xtp_avantevap(ixt,il)=xt(ixt,il,i)/q(il,i)*qp(il,i)
                enddo
              else !if (qp(il,i).gt.0) then
                  ! si qp est ngatif, on met les isos dedans  0
                write(*,*) 'appel_stewart_np temporaire 230: qp=',
     :                          qp(il,i)
                do ixt=1,ntraciso
                 xtp_avantevap(ixt,il)=0.0
                enddo
              endif !if (qp(il,i).gt.0) then
               
          endif !if (Mp(il,i+1).gt.0) then
          
         endif  !if (Mp(il,i).gt.Mp(il,i+1)) then
      
        else ! if i.lt.INB
          ! cas ou i=inb
          ! on garde le qp calcul dans cv3_unsat, original
          ! on suppose que le deltaD dans le ddft est celui de
          ! l'environnement
          qp_avantevap(il)=qp(il,i)
          if (qp(il,i).gt.0) then
            do ixt=1,ntraciso
             xtp_avantevap(ixt,il)=xt(ixt,il,i)/q(il,i)*qp(il,i)
            enddo
          else !if (qp(il,i).gt.0) then
              ! si qp ngatif, on met les isotopes dedans  0
            qp_avantevap(il)=0.0  
            do ixt=1,ntraciso
             xtp_avantevap(ixt,il)=0.0
            enddo
          endif !if (qp(il,i).gt.0) then
        endif ! if i.lt.INB(il)
       endif ! (i.le.inb(il) .and. lwork(il)) then
      enddo !do il=1,ncum

#ifdef ISOVERIF
      if (use_iso_eau.eq.1) then
        do il=1,ncum 
          if (i.le.inb(il) .and. lwork(il)) then      
            call iso_verif_egalite_choix(
     :           double_to_real(xtp_avantevap(iso_eau,il)),
     :           double_to_real(qp_avantevap(il)),
     :            'appel_stewart_np 95',errmax,errmaxrel)
          endif ! (i.le.inb(il) .and. lwork(il)) then
        enddo !do il=1,ncum
      endif !if (use_iso_eau.eq.1) then
#endif

           
      ! ********* calculs des flux
      
      do il=1,ncum 
       if (i.le.inb(il) .and. lwork(il)) then
        Pqisup(il)=sigd(il)/g*wt(il,i)*water(il,i+1)+wdtrain(il)/g
        Pqiinf(il)=sigd(il)/g*wt(il,i)*water(il,i) ! ce qu'on aurait dans si ce
       ! ce qu s'vapore en i ne vient que de i, comme dans le schma de
       ! KE original.      
        Eqi_prime(il)=(evap(il,i)+evap(il,i+1))/2
     :            *100.*(PH(il,i)-PH(il,I+1))*SIGD(il)/g
        Eqi(il)=evap(il,i)*100.*(PH(il,i)-PH(il,I+1))*SIGD(il)/g
        Eqi_plus1(il)=evap(il,i+1)*100.*(PH(il,i)-PH(il,I+1))*SIGD(il)/g
        ! avant le 15 juillet 2012, on avait juste Pqiinf_par(il)=Pqisup(il)-Eqi(il)
        ! mais donne pbs en 1D. On met une rustine, mais c'est pas bien
        ! justifi. Il faudrait reprendre a proprement un jour.
        if ((Eqi_prime(il).gt.0.0).and.
     :       (Pqiinf(il).ge.Pqisup(il)).and.
     :       (Pqisup(il).gt.0.0).and.
     :       (Pqisup(il)-Eqi_prime(il).gt.0.0)) then
                ! rustine au cas patho en 1D pour -90hPa/d
                Pqiinf_par(il)=Pqisup(il)-Eqi_prime(il)
        else
                Pqiinf_par(il)=Pqisup(il)-Eqi(il)
        endif
        Eqi_par(il)=Pqisup(il)-Pqiinf(il)
        do ixt=1,ntraciso
          Pxtisup(ixt,il)=sigd(il)/g*wt(il,i+1)*xtwater(ixt,il,i+1)
     :            +xtwdtrain(ixt,il)/g
        enddo
       endif !if (i.le.inb(il) .and. lwork(il)) then
      enddo !do il=1,ncum 

#ifdef ISOVERIF 
!      write(*,*) 'appel_stewart_np 335 nostop' 
!      il=1
!      write(*,*) 'Pqisup=',Pqisup(il)
!      write(*,*) 'Pqiinf=',Pqiinf(il)
!      write(*,*) 'Eqi_prime=',Eqi_prime(il)
!      write(*,*) 'Eqi=',Eqi(il)
!      write(*,*) 'Eqi_plus1=',Eqi_plus1(il)
!      write(*,*) 'Pqiinf_par=',Pqiinf_par(il)
!      write(*,*) 'Eqi_par=',Eqi_par(il)
!      write(*,*) 'qp=',qp(il,i)
!      write(*,*) 'qp_avantevap=',qp_avantevap(il)
      do il=1,ncum 
       if (i.le.inb(il) .and. lwork(il)) then
         do ixt=1,niso
          if (iso_verif_noNaN_nostop(double_to_real(Pxtisup(ixt,il)),
     :         'appel_setwart_vectall_np 338').eq.1) then
            write(*,*) 'il,i,ixt=',il,i,ixt
            write(*,*) 'xtwater(ixt,il,i+1)=',xtwater(ixt,il,i+1)
            write(*,*) 'xtwdtrain(ixt,il)=',xtwdtrain(ixt,il)
            write(*,*) 'wt(il,i+1)=',wt(il,i+1)
            write(*,*) 'water(il,i+1)=',water(il,i+1)
            write(*,*) 'wdtrain(il)=',wdtrain(il)
            stop
          endif
         enddo !do ixt=1,niso
       endif !if (i.le.inb(il) .and. lwork(il)) then
      enddo !do il=1,ncum 
#endif

#ifdef ISOVERIF   
!      il =243
!      write(*,*) 'appel_stewart 327: il=',il
!      write(*,*) 'Pqisup,Pqiinf,Eqi_prime,Eqi,Pqiinf_par,Eqi_par=',
!     :     Pqisup(il),Pqiinf(il),Eqi_prime(il),Eqi(il),
!     :     Pqiinf_par(il),Eqi_par(il)
      do il=1,ncum 
       if (i.le.inb(il) .and. lwork(il)) then
         call iso_verif_egalite_choix(double_to_real(Pqiinf(il)),
     :         double_to_real(Pqiinf_par(il)),'appel_stewart_np 218',
     ;         errmax,errmaxrel)
       endif
!#ifdef ISOTRAC
!        if ((option_traceurs.eq.17).or.
!     :           (option_traceurs.eq.18)) then
!        if (iso_verif_positif_nostop(double_to_real(        
!     :          Pxtisup(index_trac(izone_cond,iso_eau),il)
!     :          -Pxtisup(iso_eau,il)),
!     :          'appel_stewart_np 332').eq.1) then
!          write(*,*) 'Pxtisup(:,il)=',Pxtisup(:,il)
!          write(*,*) 'xtwater(:,il,i+1)=',xtwater(:,il,i+1)
!          write(*,*) 'xtwdtrain(:,il)=',xtwdtrain(:,il)
!          stop
!        endif !if (iso_verif_positif_nostop(Pxtisup(iso_eau,il)-
!        endif !if ((option_traceurs.eq.17).or.    
!#endif       
      enddo !do il=1,ncum 
!      il=243     
!         write(*,*) 'il,Pqisup,Pqiinf,Pqiinf_par=',
!     ;         il,Pqisup(il),Pqiinf(il),Pqiinf_par(il)
!         write(*,*) 'Eqi_prime,Eqi,Eqi_plus1,Eqi_par=',
!     ;         Eqi_prime(il),Eqi(il),Eqi_plus1(il),Eqi_par(il)
!         write(*,*) 'evap(il,i:i+1)=',evap(il,i:i+1)
#endif      

      ! petite vrif sur les flux
      do il=1,ncum 
       if (i.le.inb(il) .and. lwork(il)) then
         if ((Eqi_par(il).lt.0.0)
     :           .and.(Pqiinf_par(il).le.0.0)
     :          .and.(water(il,i).gt.ridicule/10.)) then
            ! dans ce cas, on a de l'eau sortant dont il faut dterminer la
            ! composition, mais pourtant le bilan de masse indique qu'il
            ! n'y a pas d'eau sortant. Et si on recalcule l'vap pour avoir de 
            ! l'eau sortant, Eqi_par<0 -> condensation! On est donc trs
            ! embtt car Eqi_prime indique qu'il y a vaporation... 
#ifdef ISOVERIF  
            write(*,*) 'appel_stewart_np 239: cas gnant'  
#endif                

            if (Eqi_prime(il)*fac_ftmr(il).lt.
     :           qp_avantevap(il)*errmaxrel*10) then
                ! ouf: Eqi_prime a peut d'effet sur la vapeur du ddft.
                ! on peut donc condenser tranquillement pour obtenir de
                ! l'eau en sortie, a ne changera pas grand chose sur la
                ! vapeur.
                Eqi_prime(il)=Eqi_par(il)
#ifdef ISOVERIF
                write(*,*) 'appel_stewart 409: Eqi_prime=Eqi_par'
#endif                
            else
             write(*,*) 'appel_stewart_np 222: ce cas est trs gnant'
             stop
            endif
          endif
        endif !if (i.le.inb(il) .and. lwork(il)) then
      enddo !do il=1,ncum

      if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
          do il=1,ncum
            xtp_avantevap(iso_eau,il)=qp_avantevap(il)
            Pxtisup(iso_eau,il)=Pqisup(il)
          enddo
      endif !if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then


      ! ******** parsage des diffrents cas + quelques vrifs
      icas_condensation_facftmr=0
      icas_condensation_nofacftmr=0
      icas_noevap=0
      icas_evap_glace=0
      icas_evap_liq=0
!#ifdef ISOVERIFIDRIS
      ! initialisation de l'outil de tracage de cas:
      do il=1,ncum
        if (i.le.inb(il) .and. lwork(il)) then
          trace_cas(il)=0
        else
          trace_cas(il)=-1
        endif
      enddo !do il=1,ncum
!      if (ncum.ge.602) then
!          write(*,*) 'appel_stewart_np tmp 379: avant parsage'
!          il=602
!          write(*,*) 'fac_ftmr(il)=',fac_ftmr(il)
!          write(*,*) 'ridicule,errmax=',ridicule,errmax
!      endif
!#endif      
      do il=1,ncum 
       if (i.le.inb(il) .and. lwork(il)) then 
        if ((Eqi_prime(il).lt.-ridicule*1e-3).or.
     :         (Eqi_prime(il)*fac_ftmr(il).lt.-ridicule*10)) then
            ! modif le 10 mai 2009: si Eqi_prime trs petit, on le
            ! traite comme du 0
            ! modif 15 mai 2009: on rajoute condition sur Eqi*fac_ftmr
            ! 1: Eqi_prime<0: condensation
          if (fac_ftmr(il).gt.ridicule/100.) then
            ! si fac_ftmr trs petit, on le traite comme du 0
            ! 1.1: si Mpi>0
            icas_condensation_facftmr=icas_condensation_facftmr+1    
            cas_condensation_facftmr(icas_condensation_facftmr)=il
!#ifdef ISOVERIFIDRIS
            trace_cas(il)=11
!#endif            
          else !if (fac_ftmr.gt.0.0) then
            ! 1.2: si Mpi=0
            icas_condensation_nofacftmr=icas_condensation_nofacftmr+1  
            cas_condensation_nofacftmr(icas_condensation_nofacftmr)=il
!#ifdef ISOVERIFIDRIS
            trace_cas(il)=12
!#endif
          endif !if (fac_ftmr.gt.0.0) then
        else if ((Eqi_prime(il).lt.ridicule*1e-3).and.
     :      (Eqi_prime(il)*fac_ftmr(il).lt.ridicule*10)) then 
            ! 2: Eqi_prime est compris entre 1e-14 et -1e-14: rien 
!            ! 27 mai 2009: on remplace le seuil pour Eqi_prime(il)*fac_ftmr(il)
!            ! de errmax/10 par ridicule*10  
            ! 18 sept 2009: on remplace  ridicule*1e-2 par ridicule*1e-3 
            !pour viter Eqi_prime=-1.87e-15, Pqisup=0 et water=1.44e-12
            icas_noevap=icas_noevap+1  
            cas_noevap(icas_noevap)=il
!#ifdef ISOVERIFIDRIS
            trace_cas(il)=2
!#endif
            qp_avantevap(il)=max(0.0,qp_avantevap(il))            
            qp(il,i)=max(0.0,qp(il,i))
            do ixt=1,ntraciso
            xtp_avantevap(ixt,il)=max(0.0,xtp_avantevap(ixt,il))
            enddo
#ifdef ISOVERIF
            if ((Pqisup(il).le.0.0).and.
     :           (water(il,i).gt.ridicule)) then
              write(*,*) 'appel_stewart_np 420: water=',water(il,i)
              write(*,*) 'Pqisup,Eqi_prime,fac_ftmr=',Pqisup(il),
     :            Eqi_prime(il),fac_ftmr(il)
              stop
            endif    
            if (use_iso_eau.eq.1) then
             if (iso_verif_egalite_choix_nostop(
     :           double_to_real(qp_avantevap(il)),
     :           qp(il,i),'appel_stewart_np 521',
     :           errmax,errmaxrel).eq.1) then
               write(*,*) 'Mp(il,i)=',Mp(il,i)
               write(*,*) 'Mp(il,i+1)=',Mp(il,i+1)
               write(*,*) 'qp(il,i)=',qp(il,i)
               write(*,*) 'qp(il,i+1)=',qp(il,i+1)
               write(*,*) 'q(il,i)=',q(il,i)
               write(*,*) 'evap(il,i)=',evap(il,i)
               write(*,*) 'evap(il,i+1)=',evap(il,i+1)
               write(*,*) 'Eqi_prime(il)=',Eqi_prime(il)
               write(*,*) 'fac_ftmr(il)=',fac_ftmr(il)
               stop
             endif
            endif !if (use_iso_eau.eq.1) then
#endif
        else    !if (Eqi_prime.lt.0.0) then
        ! 3: Eqi_prime>0 
#ifdef ISOVERIF  
!        ! quelques vrifs du bilan de masse d'eau 
!             if (iso_verif_positif_nostop(double_to_real(
!     :            Pqisup(il)-Eqi_prime(il)),
!     :            'appel_stewart_np 388 nostop').eq.1) then
!               write(*,*) 'il,Pqisup=',il,Pqisup(il)
!               write(*,*) 'Eqi_prime=',Eqi_prime(il)
!               write(*,*) 'Pqiinf=',Pqiinf(il)
!!               write(*,*) 'stop temporaire,  enlever'
!!               stop
!              endif
              if (iso_verif_positif_choix_nostop(double_to_real(
     :           Pqisup(il)-Pqiinf_par(il)),errmax,
     :           'appel_stewart_np 442').eq.1) then
                write(*,*) 'appel_stewart_np 174'
                write(*,*) 'Pqisup=',Pqisup(il),
     :           ' Pqiinf_par=',Pqiinf_par(il)
                stop
              endif               
              if (iso_verif_positif_nostop(double_to_real(Eqi_par(il)),
     :           'appel_stewart_np 559b').eq.1) then
                write(*,*) 'Eqi(il),Eqi_plus1(il),Eqi_prime(il)=',
     :                  Eqi(il),Eqi_plus1(il),Eqi_prime(il) 
                write(*,*) 'Pqisup(il),Pqiinf(il),Eqi_par(il)=',
     :                   Pqisup(il),Pqiinf(il),Eqi_par(il)
              endif
#endif              
              if (T(il,i).ge.ztglace_kelvin) then
                ! 3.1: evap des gouttes
                icas_evap_liq=icas_evap_liq+1  
                cas_evap_liq(icas_evap_liq)=il
!#ifdef ISOVERIFIDRIS
                trace_cas(il)=31
!#endif
              else !if (T(il,i).ge.ztglace_kelvin) then
                ! 3.2: evap de la glace
                icas_evap_glace=icas_evap_glace+1  
                cas_evap_glace(icas_evap_glace)=il
!#ifdef ISOVERIFIDRIS
                trace_cas(il)=32
!#endif  
              endif !if (T(il,i).ge.ztglace_kelvin) then
          endif ! !if (Eqi_prime.lt.0.0) then
       endif !if (i.le.inb(il) .and. lwork(il)) then 
      enddo  !do il=1,ncum 

      ncas_condensation_facftmr=icas_condensation_facftmr
      ncas_condensation_nofacftmr=icas_condensation_nofacftmr  
      ncas_noevap=icas_noevap
      ncas_evap_liq=icas_evap_liq
      ncas_evap_glace=icas_evap_glace

#ifdef ISOVERIF
!      write(*,*) 'appel_stewart_np vectoriel 355: parsage des cas:'
!      if (ncum.ge.602) then
!          write(*,*) 'trace_cas(602)=',trace_cas(602)
!      endif  
      ncas_tot=0
      do il=1,ncum
        if (i.le.inb(il) .and. lwork(il)) then 
            ncas_tot=ncas_tot+1
        endif
      enddo
!      write(*,*) 'i,ncum,ncas_tot=',i,ncum,ncas_tot
!      write(*,*) 'ncas_condensation_facftmr=',ncas_condensation_facftmr
!      write(*,*) 'ncas_condensation_nofacftmr=',
!     :            ncas_condensation_nofacftmr
!      write(*,*) 'ncas_noevap=',ncas_noevap
!      write(*,*) 'ncas_evap_liq_=',ncas_evap_liq
!      write(*,*) 'ncas_evap_glace=',ncas_evap_glace
      if (ncas_tot.ne.ncas_condensation_facftmr
     :          +ncas_condensation_nofacftmr
     :          +ncas_noevap
     :          +ncas_evap_liq
     :          +ncas_evap_glace) then
         write(*,*) 'mauvais parsage'
         stop
       endif
#endif      


      ! ****** traitement vectoriel du cas 1.1

      if (ncas_condensation_facftmr.gt.0) then
#ifdef ISOVERIF        
      write(*,*) 'cas_condensation_facftmr(1)=',
     :           cas_condensation_facftmr(1)
#endif
      call compress_cond_facftmr(ncas_condensation_facftmr,  
     :    cas_condensation_facftmr,
     :    Eqi_prime_cas,Eqi_prime,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,  
     :    T_cas,T(1,i), 
     :    fac_ftmr_cas,fac_ftmr, 
     :    qp_avantevap_cas,qp_avantevap,
     :    xtp_avantevap_cas,xtp_avantevap, 
     :    xtevapsup_cas,xtevap(1,1,i+1),
     :    water_cas,water(1,i),
     :    delP_cas,Ph, 
#ifdef ISOVERIF        
     :    evap_cas(1),evap(1,i),qp_cas(1),qp(1,i),   
#endif        
     :    nloc,ncum,nd,i)

#ifdef ISOVERIF
      ! vrif de la compression
!      write(*,*) 'appel_stewart_np tmp 506: ',
!     :           'aprs compress_condensation_facftmr'
      if (ncas_condensation_facftmr.ge.4) then
          write(*,*) 'cas_condensation_facftmr(4)=',
     :           cas_condensation_facftmr(4)
      endif
      do il=1,ncas_condensation_facftmr
        call iso_verif_egalite_choix(double_to_real(Pqisup_cas(il)),
     :         double_to_real(Pqisup(cas_condensation_facftmr(il))),
     :         'appel_stewart_np 457: compress condensation_facftmr',
     :         errmax,errmax)
        call iso_verif_egalite_choix(water_cas(il),
     :         water(cas_condensation_facftmr(il),i),
     :         'appel_stewart_np 460: compress condensation_facftmr',
     :         errmax,errmax)
        if (use_iso_eau.eq.1) then
         call iso_verif_egalite_choix(
     :         double_to_real(xtp_avantevap_cas(iso_eau,il)),
     :         double_to_real(qp_avantevap_cas(il)),
     :         'appel_stewart_np 520: compress condensation_facftmr',
     :         errmax,errmax)
        endif ! if (use_iso_eau.eq.1) then
      enddo
#endif                  
        call make_condensation_facftmr(ncas_condensation_facftmr,
     :         Eqi_prime_cas(1),Pqisup_cas(1),Pxtisup_cas(1,1),
     :         fac_ftmr_cas(1),T_cas(1),
     :         qp_avantevap_cas(1),xtp_avantevap_cas(1,1),water_cas(1),
     :         delP_cas(1),xtevapsup_cas(1,1),ztglace_kelvin,
     :         xtp_cas(1,1),xtwater_cas(1,1),xtevap_cas(1,1),g,SIGD(1)
#ifdef ISOVERIF        
     :          ,evap_cas,qp_cas,1
#endif
     :           )  

#ifdef ISOVERIF
        do   il=1,ncas_condensation_facftmr
          do ixt=1,niso
            call iso_verif_noNaN(xtwater_cas(ixt,il),
     :           'appel_stewart_np 539')
          enddo          
        enddo     
#endif        

       call uncompress_commun(ncas_condensation_facftmr,
     :     cas_condensation_facftmr,
     :   xtp_cas,xtp(1,1,i),xtwater_cas,xtwater(1,1,i),
     :           xtevap_cas,xtevap(1,1,i),
#ifdef ISOVERIF
     :           Exi_cas(1,1),Exi,   
#endif
     :           ncum)


#ifdef ISOTRAC
       do izone=1,ntraceurs_zone

!#ifdef ISOVERIF     
!       write(*,*) 'appel_stewart_np tmp 538: condensation_facftmr, izone=',
!     :          izone
!#endif      

        call compress_cond_facftmr_zone(
     :    ncas_condensation_facftmr,  
     :    cas_condensation_facftmr,
     :    Eqi_prime_cas,Eqi_prime,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,  
     :    qp_avantevap_cas,qp_avantevap,
     :    xtp_avantevap_cas,xtp_avantevap, 
     :    xtevapsup_cas,xtevap(1,1,i+1),
     :    water_cas,water(1,i),
#ifdef ISOVERIF        
     :    evap_cas(1),evap(1,i),  
#endif        
     :    nloc,ncum,nd,i,izone)

#ifdef ISOVERIF 
        if (use_iso_eau.eq.1) then
          do il=1,ncas_condensation_facftmr
            call iso_verif_egalite_choix(
     :           double_to_real(qp_avantevap_cas(il)),
     :           double_to_real(xtp_avantevap_cas(iso_eau,il)),
     :           'appel_stewart_np 558',errmax,errmaxrel)
          enddo !do il=1,ncas_condensation_nofacftmr
        endif !if (use_iso_eau.eq.1) then
#endif
        call make_condensation_facftmr(ncas_condensation_facftmr,
     :         Eqi_prime_cas(1),Pqisup_cas(1),Pxtisup_cas(1,1),
     :         fac_ftmr_cas(1),T_cas(1),
     :         qp_avantevap_cas(1),xtp_avantevap_cas(1,1),water_cas(1),
     :         delP_cas(1),xtevapsup_cas(1,1),ztglace_kelvin,
     :         xtp_cas(1,1),xtwater_cas(1,1),xtevap_cas(1,1),g,SIGD
#ifdef ISOVERIF        
     :            ,evap_cas,qp_cas,1
#endif
     :           )

#ifdef ISOVERIF
        do   il=1,ncas_condensation_facftmr
          do ixt=1,niso
            call iso_verif_noNaN(xtwater_cas(ixt,il),
     :           'appel_stewart_np 588')
          enddo
        enddo      
#endif
        !#ifdef ISOVERIF

       call uncompress_commun_zone(ncas_condensation_facftmr,
     :     cas_condensation_facftmr,
     :   xtp_cas,xtp(1,1,i),xtwater_cas,xtwater(1,1,i),
     :           xtevap_cas,xtevap(1,1,i),
     :           ncum,izone)
        
      enddo !do izone=1,ntraceurs_zone

#ifdef ISOVERIF
!        write(*,*) 'appel_stewart_np tmp 574: ',
!     :           'fin cas condensation_facftmr'
            do il=1,ncas_condensation_facftmr
!               write(*,*) 'il,cas_condensation_facftmr(il)=',
!     :           il,cas_condensation_facftmr(il)
!               write(*,*) 'xtp(1:ntraciso:3)=',xtp(1:ntraciso:3,
!     :           cas_condensation_facftmr(il),i)
!               write(*,*) 'xtp_avantevap(1:ntraciso:3)=',
!     :           xtp_avantevap(1:ntraciso:3,
!     :           cas_condensation_facftmr(il))
!               if (il.eq.cas_condensation_facftmr(602)) then
!                write(*,*) 'appel_stewart_np 638: il=602'
!                write(*,*) 'xtp(iso_eau:ntraciso:3,il,i)=',
!     :           xtp(iso_eau:ntraciso:3,cas_condensation_facftmr(il),i)
!               endif
               call iso_verif_traceur(xtp
     :           (1,cas_condensation_facftmr(il),i),
     :           'appel_stewart_np 557')
               call iso_verif_traceur(xtwater
     :           (1,cas_condensation_facftmr(il),i),
     :           'appel_stewart_np 560')
               call iso_verif_traceur_justmass(xtevap
     :           (1,cas_condensation_facftmr(il),i),
     :           'appel_stewart_np 563')
            enddo !do il=1,ncas_condensation_nofacftmr 
#endif     
         !#ifdef ISOVERIF   
#endif    
        !#ifdef ISOTRAC    

           endif !if (ncas_condensation_facftmr.gt.0) then


        ! ****** traitement vectoriel du cas 1.2

      if (ncas_condensation_nofacftmr.gt.0) then

      call compress_cond_nofftmr(ncas_condensation_nofacftmr,
     :    cas_condensation_nofacftmr,
     :    Eqi_prime_cas,Eqi_prime(1),
     :    Pqisup_cas,Pqisup(1), 
     :    Pxtisup_cas,Pxtisup(1,1),
     :    water_cas,water(1,i), 
     :    T_cas,T(1,i), 
     :    qp_avantevap_cas,qp_avantevap(1),
     :    xtp_avantevap_cas,xtp_avantevap(1,1),
     :    xt_cas,xt(1,1,i),q_cas,q(1,i), 
     :    xtevapsup_cas,xtevap(1,1,i+1),
     :    delP_cas,Ph, 
#ifdef ISOVERIF
     :    evap_cas(1),evap(1,i),qp_cas(1),qp(1,i),
#endif      
     :    nloc,ncum,nd,i)

#ifdef ISOVERIF
      ! vrif de la compression
      write(*,*) 'appel_stewart_np tmp 616: ',
     :           'apres compress condensation_nofacftmr'
      do il=1,ncas_condensation_nofacftmr
        call iso_verif_egalite_choix(double_to_real(Pqisup_cas(il)),
     :         double_to_real(Pqisup(cas_condensation_nofacftmr(il))),
     :         'appel_stewart_np 594: compress condensation_nofacftmr',
     :           errmax,errmax)
        call iso_verif_egalite_choix(T_cas(il),
     :         T(cas_condensation_nofacftmr(il),i),
     :         'appel_stewart_np 597: compress condensation_nofacftmr',
     :           errmax,errmax)
      enddo
#endif    

      call make_condensation_nofacftmr(ncas_condensation_nofacftmr,
     :     Eqi_prime_cas(1),Pqisup_cas(1),
     :     Pxtisup_cas(1,1),water_cas(1),T_cas(1),
     :     qp_avantevap_cas(1), xtp_avantevap_cas(1,1),
     :     q_cas(1),xt_cas(1,1), 
     :     xtevapsup_cas(1,1) ,delP_cas(1),   
     :     ztglace_Kelvin, g,SIGD,
     :     xtevap_cas(1,1),xtp_cas(1,1),xtwater_cas(1,1)
#ifdef ISOVERIF
     :     ,evap_cas(1),qp_cas(1),0
#endif
     :   )    

#ifdef ISOVERIF
        do   il=1,ncas_condensation_nofacftmr
          do ixt=1,niso
            call iso_verif_noNaN(xtwater_cas(ixt,il),
     :           'appel_stewart_np 803')
          enddo          
        enddo      
#endif

      call uncompress_commun(ncas_condensation_nofacftmr,
     :     cas_condensation_nofacftmr,
     :   xtp_cas,xtp(1,1,i),xtwater_cas,xtwater(1,1,i),
     :           xtevap_cas,xtevap(1,1,i),
#ifdef ISOVERIF
     :           Exi_cas(1,1),Exi,   
#endif
     :           ncum)
                
#ifdef ISOTRAC
       do izone=1,ntraceurs_zone
!         write(*,*) 'appel_stewart_np 718: izone=',izone

         call compress_cond_nofftmr_zone(
     :    ncas_condensation_nofacftmr,
     :    cas_condensation_nofacftmr,
     :    Eqi_prime_cas,Eqi_prime(1),
     :    Pqisup_cas,Pqisup(1), 
     :    Pxtisup_cas,Pxtisup(1,1),
     :    water_cas,water(1,i), 
     :    qp_avantevap_cas,qp_avantevap(1),
     :    xtp_avantevap_cas,xtp_avantevap(1,1),
     :    xt_cas,xt(1,1,i),q_cas,q(1,i), 
     :    xtevapsup_cas,xtevap(1,1,i+1), 
#ifdef ISOVERIF
     :    evap_cas(1),evap(1,i),
#endif      
     :    nloc,ncum,nd,i,izone)

         call make_condensation_nofacftmr(ncas_condensation_nofacftmr,
     :     Eqi_prime_cas(1),Pqisup_cas(1),
     :     Pxtisup_cas(1,1),water_cas(1),T_cas(1),
     :     qp_avantevap_cas(1), xtp_avantevap_cas(1,1),
     :     q_cas(1),xt_cas(1,1), 
     :     xtevapsup_cas(1,1) ,delP_cas(1),   
     :     ztglace_Kelvin, g,SIGD,
     :     xtevap_cas(1,1),xtp_cas(1,1),xtwater_cas(1,1)
#ifdef ISOVERIF
     :     ,evap_cas(1),qp_cas(1),1
#endif
     :   )
 

            call uncompress_commun_zone(ncas_condensation_nofacftmr,
     :           cas_condensation_nofacftmr,
     :           xtp_cas,xtp(1,1,i),xtwater_cas,xtwater(1,1,i),
     :           xtevap_cas,xtevap(1,1,i),
     :           ncum,izone)

       enddo !do izone=1,ntraceurs_zone
#ifdef ISOVERIF
       write(*,*) 'appel_stewart_np tmp 690: ',
     :           'fin du cas condensation_nofacftmr'
            do il=1,ncas_condensation_nofacftmr
               call iso_verif_traceur(xtp
     :           (1,cas_condensation_nofacftmr(il),i),
     :           'appel_stewart_np 651')
               call iso_verif_traceur(xtwater
     :           (1,cas_condensation_nofacftmr(il),i),
     :           'appel_stewart_np 653')
               call iso_verif_traceur_justmass(xtevap
     :           (1,cas_condensation_nofacftmr(il),i),
     :           'appel_stewart_np 655')
            enddo !do il=1,ncas_condensation_nofacftmr 
       
#endif  
#endif            
       
        endif !if (ncas_condensation_nofacftmr.gt.0) then

        
        ! ****** traitement vectoriel du cas 2

      if (ncas_noevap.gt.0) then

      call compress_noevap(ncas_noevap,
     :    cas_noevap,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,  
     :    xtp_avantevap_cas,xtp_avantevap, 
     :    xtevapsup_cas,xtevap(1,1,i+1),
     :    water_cas,water(1,i),
     :    delP_cas,Ph, 
#ifdef ISOVERIF        
     :    evap_cas(1),evap(1,i),qp_cas(1),qp(1,i),
#endif 
     :    nloc,ncum,nd,i) 

#ifdef ISOVERIF
      ! vrif de la compression
!      write(*,*) 'appel_stewart_np 719: apres compression iso noevap'
      do il=1,ncas_noevap
        call iso_verif_egalite_choix(double_to_real(Pqisup_cas(il)),
     :           double_to_real(Pqisup(cas_noevap(il))),
     :           'appel_stewart_np 692: compression',errmax,errmaxrel)
        call iso_verif_egalite_choix(water_cas(il),
     :           water(cas_noevap(il),i),
     :           'appel_stewart_np 693: compression',errmax,errmaxrel)
        if (use_iso_eau.eq.1) then
        call iso_verif_egalite_choix(
     :           double_to_real(Pxtisup_cas(iso_eau,il)),
     :           double_to_real(Pqisup_cas(il)),
     :           'appel_stewart_np 759',errmax,errmaxrel)
        if (iso_verif_egalite_choix_nostop(
     :           double_to_real(xtp_avantevap(iso_eau,cas_noevap(il))),
     :           qp(cas_noevap(il),i),
     :           'appel_stewart_np 739',errmax,errmaxrel).eq.1) then
           write(*,*) 'il,cas_noevap=',il,cas_noevap(il)
           stop
        endif
        call iso_verif_egalite_choix(
     :           double_to_real(xtp_avantevap_cas(iso_eau,il)),
     :           qp_cas(il),
     :           'appel_stewart_np 735',errmax,errmaxrel)        
        endif !if (use_iso_eau.eq.1) then
      enddo !do il=1,ncas_noevap
#endif      

      call make_cas_noevap_np(ncas_noevap,
     :          xtp_avantevap_cas(1,1),xtevapsup_cas(1,1),
     :          Pxtisup_cas(1,1),Pqisup_cas(1),water_cas(1),
     :          xtevap_cas(1,1),xtp_cas(1,1),xtwater_cas(1,1)
#ifdef ISOVERIF
     :          ,evap_cas(1),qp_cas(1),0 
#endif        
     :          )
   
#ifdef ISOVERIF
        do   il=1,ncas_noevap
          do ixt=1,niso
            call iso_verif_noNaN(xtwater_cas(ixt,il),
     :           'appel_stewart_np 935')
          enddo          
        enddo      
#endif    

       call uncompress_commun(ncas_noevap,cas_noevap,
     :   xtp_cas,xtp(1,1,i),xtwater_cas,xtwater(1,1,i),
     :           xtevap_cas,xtevap(1,1,i),
#ifdef ISOVERIF
     :           Exi_cas(1,1),Exi,   
#endif
     :           ncum)

#ifdef ISOTRAC
       do izone=1,ntraceurs_zone
        call compress_noevap_zone(ncas_noevap,
     :    cas_noevap,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,  
     :    xtp_avantevap_cas,xtp_avantevap, 
     :    xtevapsup_cas,xtevap(1,1,i+1),
     :    water_cas,water(1,i),
#ifdef ISOVERIF        
     :    evap_cas(1),evap(1,i),
#endif 
     :    nloc,ncum,nd,i,izone)

#ifdef ISOVERIF
!        write(*,*) 'appel_stewart_np 765: aprs compression isotrac'
        do il=1,ncas_noevap
          call iso_verif_egalite_choix(
     :           double_to_real(Pxtisup_cas(iso_eau,il)),
     :           double_to_real(Pqisup_cas(il)),
     :           'appel_stewart_np 759',errmax,errmaxrel)
        enddo !do il=1,ncas_noevap
#endif        
        
        call make_cas_noevap_np(ncas_noevap,
     :          xtp_avantevap_cas(1,1),xtevapsup_cas(1,1),
     :          Pxtisup_cas(1,1),Pqisup_cas(1),water_cas(1),
     :          xtevap_cas(1,1),xtp_cas(1,1),xtwater_cas(1,1)
#ifdef ISOVERIF
     :          ,evap_cas(1),qp_cas(1),1
#endif        
     :          )

        call uncompress_commun_zone(ncas_noevap,cas_noevap,
     :   xtp_cas,xtp(1,1,i),xtwater_cas,xtwater(1,1,i),
     :           xtevap_cas,xtevap(1,1,i),
     :           ncum,izone)
        enddo !do izone=1,ntraceurs_zone

#ifdef ISOVERIF
!        write(*,*) 'appel_stewart_np tmp 806: ',
!     :           'fin du cas noevap'
       do il=1,ncas_noevap
           call iso_verif_traceur(xtp(1,cas_noevap(il),i),
     :           'appel_stewart_np 734')
           call iso_verif_traceur(xtevap(1,cas_noevap(il),i),
     :           'appel_stewart_np 736')
           call iso_verif_traceur(xtwater(1,cas_noevap(il),i),
     :           'appel_stewart_np 738')
       enddo !do il=1,ncas_noevap
#endif
       
#endif       

        endif !if (ncas_noevap.gt.0) then


        ! ****** traitement vectoriel du cas 3.1

      if (ncas_evap_liq.gt.0) then
          

      call compress_evap_liq(3,ncas_evap_liq,
     :    cas_evap_liq,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,  
     :    qp_avantevap_cas,qp_avantevap,
     :    xtp_avantevap_cas,xtp_avantevap, 
     :    xtevapsup_cas,xtevap(1,1,i+1),
     :    water_cas,water(1,i), 
     :    qs_cas,qs(1,i),
     :    Eqi_stewart,Pqiinf_stewart,Eqi_prime_cas,
     :    Pqiinf,Eqi_par,Pqiinf_par,Eqi_prime,  
     :    Eqi,Eqi_cas, 
     :    fac_ftmr_cas,fac_ftmr, 
     :    T_cas,T(1,i),
     :    wt_cas,wt(1,i),
     :    INB_cas,INB(1),
     :    delP_cas,Ph,
     :    qp_cas,qp(1,i),
#ifdef ISOVERIF         
     :    evap_cas,evap(1,i),
#endif      
     :    nloc,ncum,nd,i)

#ifdef ISOVERIF
      ! vrif de la compression
!      write(*,*) 'appel_stewart_np tmp 899: ',
!     :           'apres compress_evap_liq'
!      write(*,*) 'cas_evap_liq(1)=',cas_evap_liq(1)
!      if (ncas_evap_liq.ge.85) then
!      write(*,*) 'cas_evap_liq(85)=',cas_evap_liq(85)
!      endif
!      write(*,*) 'Eqi_stewart,Pqiinf_stewart,Eqi_prime_cas,Eqi_cas',
!     :    Eqi_stewart(1),Pqiinf_stewart(1),
!     :    Eqi_prime_cas(1),Eqi_cas(1)
      do il=1,ncas_evap_liq
!       write(*,*) 'il=',il
!      write(*,*) 'qp_avantevap_cas(il),xtp_avantevap_cas(iso_eau,il)=',
!     :    qp_avantevap_cas(il),xtp_avantevap_cas(iso_eau,il) 
        call iso_verif_egalite_choix(double_to_real(Pqisup_cas(il)),
     :           double_to_real(Pqisup(cas_evap_liq(il))),
     :           'appel_stewart_np 822: compression evap_liq',
     :           errmax,errmax)
        call iso_verif_egalite_choix(water_cas(il),
     :           water(cas_evap_liq(il),i),
     :           'appel_stewart_np 825: compression evap_liq',
     :           errmax,errmax)
        call iso_verif_egalite_choix(
     :         double_to_real(qp_avantevap_cas(il)),
     :         double_to_real(qp_avantevap(cas_evap_liq(il))),
     :         'appel_stewart_np 783: compression evap_liq',
     :           errmax,errmax)
        if (use_iso_eau.eq.1) then
        call iso_verif_egalite_choix(
     :         double_to_real(xtp_avantevap_cas(iso_eau,il)),
     :         double_to_real(qp_avantevap_cas(il)),
     :         'appel_stewart_np 789: compression evap_liq',
     :          errmax,errmax) 
        endif ! if (use_iso_eau.eq.1) then  
        call iso_verif_positif(double_to_real(Eqi_stewart(il),
     :           'appel_stewart_np 1124: compression evap_liq')) 
      enddo !do il=1,ncas_evap_liq
#endif       
      do il=1,ncas_evap_liq     
        qeff(il)=thumxt1*Qs_cas(il)
     :     +(1.0-thumxt1)*qp_avantevap_cas(il)
      enddo   !do il=1,ncas_evap_liq

!      write(*,*) 'appel tmp 802: xtp_avantevap_cas(iso_eau,2)=',
!     :           xtp_avantevap_cas(iso_eau,2)
!      write(*,*) 'appel tmp 1490: qp_avantevap_cas(2)=',
!     :           qp_avantevap_cas(2)
!       write(*,*) 'appel_stewart_np 933: make_cas_evap_liq_np pr eau normale'

       ! ici, ptrac ne sera pas utilis
       call make_cas_evap_liq_np(ncas_evap_liq,
     :           water_cas(1),
     :           xtp_avantevap_cas(1,1),qp_avantevap_cas(1),
     :           xtp_avantevap_cas(1,1),qp_avantevap_cas(1),
     :           Pxtisup_cas(1,1),Pqisup_cas(1),
     :           Eqi_stewart(1),Pqiinf_stewart(1),fac_ftmr_cas(1),
     :           qs_cas(1), T_cas(1),wt_cas(1),  delP_cas(1),
     :           xtevapsup_cas(1,1),qeff(1),g,sigd, Eqi_prime_cas(1),
     :           Eqi_cas(1),
     :           qp_cas(1), INB_cas(1),i,0,
#ifdef ISOTRAC       
     :           ptrac(1),hdiag(1),
#endif                
#ifdef ISOVERIF
     :           evap_cas(1),Exi_cas(1,1),      
#endif       
     :           xtp_cas(1,1),xtwater_cas(1,1),xtevap_cas(1,1))


#ifdef ISOVERIF
        do   il=1,ncas_evap_liq
          do ixt=1,niso
            call iso_verif_noNaN(xtwater_cas(ixt,il),
     :           'appel_stewart_np 1105')
          enddo          
        enddo      
#endif        

       call uncompress_commun(ncas_evap_liq,cas_evap_liq,
     :   xtp_cas,xtp(1,1,i),xtwater_cas,xtwater(1,1,i),
     :           xtevap_cas,xtevap(1,1,i),
#ifdef ISOVERIF
     :           Exi_cas(1,1),Exi,   
#endif
     :           ncum)

#ifdef ISOTRAC

       ! initialisation dans le cas o la revap est tagge:
       if (option_revap.eq.1) then
         do il=1,ncas_evap_liq  
           do iiso=1,niso
             ixt=index_trac(izone_revap,iiso)
             xtevap(ixt,cas_evap_liq(il),i)=0.0
             xtp(ixt,cas_evap_liq(il),i)=
     :           xtp_avantevap(ixt,cas_evap_liq(il)) 
             enddo  !do iiso=1,niso  
         enddo !do il=1,ncas_evap_glace  
       endif



      do izone=1,ntraceurs_zone      
      
!       write(*,*) 'appel_stewart_np 924 tmp: cas liq: izone=',izone 
!       write(*,*) 'appel 924: xtp_avantevap(c,cas(2))=',
!     :           xtp_avantevap(1:ntraciso:3,cas_evap_liq(2))
!       write(*,*) 'Pxtisup(1:ntraciso:3,cas(2))=',
!     :           Pxtisup(1:ntraciso:3,cas_evap_liq(2))
       call compress_evap_liq_zone(3,ncas_evap_liq,
     :    cas_evap_liq,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,  
     :    xtp_avantevap_cas,xtp_avantevap,
     :    xtp_avantevaptrac_cas, qp_avantevaptrac_cas,
     :    xtevapsup_cas,xtevap(1,1,i+1),
     :    water_cas,water(1,i), 
     :    Eqi_stewart,Pqiinf_stewart,Eqi_prime_cas,
     :    Pqiinf,Eqi_par,Pqiinf_par,Eqi_prime,ptrac,
!     :    qp_cas,
#ifdef ISOVERIF       
     :    evap_cas,evap(1,i), 
#endif       
     :    nloc,ncum,nd,izone)

#ifdef ISOVERIF
!       write(*,*) 'appel_stewart_np tmp 941'
!       if (ncas_evap_liq.ge.162) then
!          write(*,*) 'Eqi_prime_cas=',Eqi_prime_cas(162)
!           write(*,*) 'Pqisup=',Pqisup(cas_evap_liq(162))
!           write(*,*) 'Eqi_prime=',Eqi_prime(cas_evap_liq(162))
!           write(*,*) 'Pxtisup=',
!     :           Pxtisup(iso_eau:ntraciso:3,cas_evap_liq(162))
!       endif
!        write(*,*) 'qp_avantevap_cas(2)=',
!     :           qp_avantevap_cas(2)
!       write(*,*) 'xtp_avantevap(iso_eau,cas_evap_liq(1))=',
!     :           xtp_avantevap(iso_eau,cas_evap_liq(1))
!       write(*,*) 'xtp_avantevap_cas(iso_eau,2)=',
!     :           xtp_avantevap_cas(iso_eau,2)
!       write(*,*) 'xtp_avantevaptrac_cas(iso_eau,2)=',
!     :           xtp_avantevaptrac_cas(iso_eau,2)
       if (use_iso_eau.eq.1) then
           do il=1,ncas_evap_liq
!             write(*,*) 'appel_stewart_np tmp 943: il=',il
             call iso_verif_egalite_choix(double_to_real
     :         (qp_avantevap(cas_evap_liq(il))),
     :         double_to_real(xtp_avantevap(iso_eau,cas_evap_liq(il))),
     :         'appel_stewart_np 944',
     :         errmax,errmaxrel)
             call iso_verif_egalite_choix(double_to_real
     :         (qp_avantevap(cas_evap_liq(il))),
     :         double_to_real(qp_avantevap_cas(il)),
     :         'appel_stewart_np 951',
     :         errmax,errmaxrel)
             call iso_verif_egalite_choix(double_to_real
     :         (xtp_avantevap(iso_eau,cas_evap_liq(il))),
     :         double_to_real(xtp_avantevap_cas(iso_eau,il)),
     :         'appel_stewart_np 956',
     :         errmax,errmaxrel)
             call iso_verif_egalite_choix(double_to_real
     :           (qp_avantevap_cas(il)),
     :           double_to_real(xtp_avantevap_cas(iso_eau,il)),
     :           'appel_stewart_np 961',
     :           errmax,errmaxrel)
!             if ((option_traceurs.eq.17).or.
!     :           (option_traceurs.eq.18)) then
!               if (izone.eq.izone_cond) then
!                call iso_verif_positif(double_to_real(
!     :           Pxtisup_cas(iso_eau,il)
!     :           -Pxtisup(iso_eau,cas_evap_liq(il))),
!     :           'appel_stewart_np 1114')
!               else !if (izone.eq.izone_cond) then
!                call iso_verif_positif(double_to_real(
!     :           -Pxtisup_cas(iso_eau,il)),
!     :           'appel_stewart_np 1118')
!               endif !if (izone.eq.izone_cond) then
!             endif   !if ((option_traceurs.eq.17).or.
           enddo !do il=1,ncas_evap_liq
       endif !if (use_iso_eau.eq.1) then
#endif       

       call make_cas_evap_liq_np(ncas_evap_liq,
     :           water_cas(1),
     :           xtp_avantevap_cas(1,1),qp_avantevap_cas(1),
     :           xtp_avantevaptrac_cas(1,1),qp_avantevaptrac_cas(1),
     :           Pxtisup_cas(1,1),Pqisup_cas(1),
     :           Eqi_stewart(1),Pqiinf_stewart(1),fac_ftmr_cas(1),
     :           qs_cas(1), T_cas(1),wt_cas(1),  delP_cas(1),
     :           xtevapsup_cas(1,1),qeff(1),  g,sigd,Eqi_prime_cas(1),
     :           Eqi_cas(1),  
     :           qp_cas(1),INB_cas(1),i,1,
     :           ptrac(1),hdiag(1),
#ifdef ISOVERIF
     :           evap_cas(1),Exi_cas(1,1),
#endif          
     :           xtp_cas(1,1),xtwater_cas(1,1),xtevap_cas(1,1))

      ! verif
#ifdef ISOVERIFNAN
      do il=1,ncas_evap_liq
        do ixt=1,niso
         call iso_verif_noNaN(xtp_cas(ixt,il),'appel_stewart_np 198')
         call iso_verif_noNaN(xtevap_cas(ixt,il),
     :         'appel_stewart_np 745')
         call iso_verif_noNaN(xtwater_cas(ixt,il),
     :         'appel_stewart_np 745')
        enddo !do ixt=1,niso
      enddo !do il=1,ncas_evap_liq
#endif       

       call uncompress_commun_zone_revap(ncas_evap_liq,cas_evap_liq,
     :   xtp_cas,xtp(1,1,i),xtwater_cas,xtwater(1,1,i),
     :           xtevap_cas,xtevap(1,1,i),
     :           ncum,izone,Eqi_stewart,fac_ftmr_cas,
#ifdef ISOVERIF
     :           Exi_cas(1,1),Exi(1,1),
#endif       
     :           xtp_avantevaptrac_cas,1,hdiag(1))
        
      enddo ! do izone=ntraceurs_zone

#ifdef ISOVERIF
       do il=1,ncas_evap_liq
           
           if (iso_verif_traceur_nostop(xtp(1,cas_evap_liq(il),i),
     :           'appel_stewart_np 1256').eq.1) then
             write(*,*) 'il,cas_evap_liq(il)=',il,cas_evap_liq(il)
             write(*,*) 'trace_cas(cas_evap_liq(il))=',
     :           trace_cas(cas_evap_liq(il))
             if (trace_cas(cas_evap_liq(il)).eq.31) then
                 write(*,*) 'cas evap_liq'
                 write(*,*) 'xtp(:,cas_evap_liq(il),i)=',
     :              xtp(:,cas_evap_liq(il),i)
                 write(*,*) 'fac_ftmr_cas(il)=',fac_ftmr_cas(il)
                 write(*,*) 'Eqi_stewart(il),Eqi_prime=',
     :                   Eqi_stewart(il),Eqi_prime(cas_evap_liq(il))
                 write(*,*) 'Pxtisup(:,cas_evap_liq(il))=',
     :                   Pxtisup(:,cas_evap_liq(il))
                 write(*,*) 'xtp_avantevap(:,cas_evap_liq(il))=',
     :                  xtp_avantevap(:,cas_evap_liq(il))
                 write(*,*) 'Exi(:,cas_evap_liq(il))=',
     :                  Exi(:,cas_evap_liq(il))
                 write(*,*) 'T_cas(il)=',T_cas(il)
                 write(*,*) 'h(il)=',thumxt1+(1.0-thumxt1)*
     :                   qp_avantevap_cas(il)/qs_cas(il) 
             endif !if (trace_cas(il).eq.31) then
                ! en cas de problme ci, activer l'option dbug de
                ! stewart_explicit
!                stop
                ! le 22 aout: on replace errmaxrel*20 par errmaxrel*25
                ! pour que a marche  l'idris
             call iso_verif_traceur_choix(xtp(1,cas_evap_liq(il),i),
     :           'appel_stewart_np 1154',
     :            errmax,errmaxrel*25,ridicule_trac,deltalimtrac) 
           endif !if (iso_verif_traceur_nostop
           ! dans le test suivant, c'est errmaxrel*50
           call iso_verif_traceur_pbidouille(
     :           xtp(1,cas_evap_liq(il),i),
     :           'appel_stewart_np 1124')
           call iso_verif_traceur_justmass(xtevap(1,cas_evap_liq(il),i),
     :           'appel_stewart_np 1258') 
!           write(*,*) 'appel_stewart_np tmp 1172: il,i=',il,i          
           call iso_verif_traceur(xtwater(1,cas_evap_liq(il),i),
     :           'appel_stewart_np 1260')           
       enddo !do il=1,ncas_evap_liq
#endif
       
#endif

        endif !if (ncas_evap_liq.gt.0) then

       
        

                ! ****** traitement vectoriel du cas 3.2

      if (ncas_evap_glace.gt.0) then


      call compress_evap_glace(3,
     :    ncas_evap_glace,cas_evap_glace,
     :    water_cas,water(1,i), 
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup, 
     :    T_cas,T(1,i),  
     :    fac_ftmr_cas,fac_ftmr, 
     :    qp_avantevap_cas,qp_avantevap,
     :    xtp_avantevap_cas,xtp_avantevap, 
     :    xtevapsup_cas,xtevap(1,1,i+1),
     :    Eqi_stewart,Pqiinf_stewart,Eqi_prime_cas,Eqi_cas,
!     :    Pqiinf,Eqi_par,Pqiinf_par,Eqi_prime,
     :    Pqiinf,Eqi_par,Pqiinf_par,Eqi_prime,Eqi, ! modif 22 dec 2011
     :    INB_cas,INB(1), 
     :    delP_cas,Ph, 
     :    qp_cas,qp(1,i),
#ifdef ISOVERIF      
     :    evap_cas,evap(1,i),
#endif      
     :    nloc,ncum,nd,i,frac_sublim)

#ifdef ISOVERIF
      write(*,*) 'appel_stewart_np tmp 898 aprs compress glace'
!      write(*,*) 'qp_avantevap_cas(1),qp_avantevap(cas(1))=',
!     :    qp_avantevap_cas(1),qp_avantevap(cas_evap_glace(1))   
      write(*,*) 'Pqiinf_stewart(1)=',Pqiinf_stewart(1)
      ! vrif de la compression
      do il=1,ncas_evap_glace
!       write(*,*) 'il=',il
!      write(*,*) 'qp_avantevap_cas(il),qp_avantevap(cas(il))=',
!     :    qp_avantevap_cas(il),qp_avantevap(cas_evap_glace(il)) 
        call iso_verif_egalite_choix(double_to_real(Pqisup_cas(il)),
     :         double_to_real(Pqisup(cas_evap_glace(il))),
     :         'appel_stewart_np 1096: compression evap_glace',
     :           errmax,errmax)
        call iso_verif_egalite_choix(water_cas(il),
     :         water(cas_evap_glace(il),i),
     :         'appel_stewart_np 1099: compression evap_glace',
     :           errmax,errmax)
        call iso_verif_egalite_choix(evap_cas(il),
     :         evap(cas_evap_glace(il),i),
     :         'appel_stewart_np 910: compression evap_glace',
     :           errmax,errmax)
        
        call iso_verif_egalite_choix(xtevapsup_cas(iso_eau,il),
     :         xtevap(iso_eau,cas_evap_glace(il),i+1),
     :         'appel_stewart_np 1106: compression evap_glace',
     :           errmax,errmax) 
        call iso_verif_egalite_choix(
     :         double_to_real(qp_avantevap_cas(il)),
     :         double_to_real(qp_avantevap(cas_evap_glace(il))),
     :         'appel_stewart_np 914: compression evap_glace',
     :           errmax,errmax)
        if (use_iso_eau.eq.1) then
        call iso_verif_egalite_choix(
     :         double_to_real(xtp_avantevap_cas(iso_eau,il)),
     :         double_to_real(qp_avantevap_cas(il)),
     :         'appel_stewart_np 919: compression evap_glace',
     :          errmax,errmax) 
        endif      
      enddo
!       write(*,*) 'appel_stewart_np tmp 1054:',
!     :   ' appel make_cas_evap_glace_np'
!       write(*,*) 'cas_evap_glace(1)=',cas_evap_glace(1)
!       write(*,*) 'Pqiinf_stewart(1)=',Pqiinf_stewart(1)
#endif   
      
        call make_cas_evap_glace_np(ncas_evap_glace,
     :           water_cas(1),
     :           xtp_avantevap_cas(1,1),qp_avantevap_cas(1),
     :           xtp_avantevap_cas(1,1),qp_avantevap_cas(1),
     :           Pxtisup_cas(1,1),Pqisup_cas(1),
     :           Eqi_stewart(1),Eqi_prime_cas(1),Eqi_cas(1),
     :           Pqiinf_stewart(1),fac_ftmr_cas(1),
     :           qs_cas(1), T_cas(1),wt_cas(1),  delP_cas(1),
     :           xtevapsup_cas(1,1),g,sigd,INB_cas(1),i,
     :           frac_sublim,qp_cas(1),
#ifdef ISOVERIF        
     :           evap_cas(1),0,Exi_cas(1,1),
#endif        
     :           xtp_cas(1,1),xtwater_cas(1,1),xtevap_cas(1,1))

!#ifdef ISOVERIF    
!        write(*,*) 'appel_stewart_np tmp 1073 aprs make_cas_evap_glace_np'
!#endif

#ifdef ISOVERIF
        do   il=1,ncas_evap_glace
          do ixt=1,niso
            call iso_verif_noNaN(xtwater_cas(ixt,il),
     :           'appel_stewart_np 1402')
          enddo          
        enddo      
#endif         

       call uncompress_commun(ncas_evap_glace,cas_evap_glace,
     :   xtp_cas,xtp(1,1,i),xtwater_cas,xtwater(1,1,i),
     :           xtevap_cas,xtevap(1,1,i),
#ifdef ISOVERIF
     :           Exi_cas(1,1),Exi,   
#endif
     :           ncum)

#ifdef ISOTRAC

       ! initialisation dans le cas o la revap est tagge:
       if (option_revap.eq.1) then
         do il=1,ncas_evap_glace   
           do iiso=1,niso
             ixt=index_trac(izone_revap,iiso)
             xtevap(ixt,cas_evap_glace(il),i)=0.0
             xtp(ixt,cas_evap_glace(il),i)=
     :           xtp_avantevap(ixt,cas_evap_glace(il)) 
           enddo  !do iiso=1,niso  
         enddo !do il=1,ncas_evap_glace  
       endif

       do izone=1,ntraceurs_zone
!       write(*,*) 'tmp appel_stewart_np 1284: izone=',izone

       call compress_evap_glace_zone(3,
     :    ncas_evap_glace,cas_evap_glace,
     :    water_cas,water(1,i), 
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup, 
     :    xtp_avantevap_cas,xtp_avantevap,  
     :    xtp_avantevaptrac_cas,qp_avantevaptrac_cas, 
     :    xtevapsup_cas,xtevap(1,1,i+1),
     :    Eqi_stewart,Pqiinf_stewart,Eqi_prime_cas,Eqi_cas,
     :    Pqiinf,Eqi_par,Pqiinf_par,Eqi_prime,Eqi,
!     :    qp_cas,
#ifdef ISOVERIF       
     :    evap_cas,evap(1,i),
#endif       
     :    nloc,ncum,nd,i,frac_sublim,izone)

!#ifdef ISOVERIF    
!        write(*,*) 'appel_stewart_np tmp 1101 call make_cas_evap_glace_np'
!#endif       
       call make_cas_evap_glace_np(ncas_evap_glace,
     :           water_cas(1),
     :           xtp_avantevap_cas(1,1),qp_avantevap_cas(1),
     :           xtp_avantevaptrac_cas(1,1),qp_avantevaptrac_cas(1),
     :           Pxtisup_cas(1,1),Pqisup_cas(1),
     :           Eqi_stewart(1),Eqi_prime_cas(1),
     :           Pqiinf_stewart(1),fac_ftmr_cas(1),
     :           qs_cas(1), T_cas(1),wt_cas(1),  delP_cas(1),
     :           xtevapsup_cas(1,1),g,sigd,INB_cas(1),i,
     :           frac_sublim,qp_cas(1),
#ifdef ISOVERIF       
     :           evap_cas(1),1,Exi_cas(1,1),
#endif       
     :           xtp_cas(1,1),xtwater_cas(1,1),xtevap_cas(1,1))


       call uncompress_commun_zone_revap(ncas_evap_glace,cas_evap_glace,
     :   xtp_cas,xtp(1,1,i),xtwater_cas,xtwater(1,1,i),
     :           xtevap_cas,xtevap(1,1,i),
     :           ncum,izone,Eqi_stewart,fac_ftmr_cas,
#ifdef ISOVERIF
     :           Exi_cas(1,1),Exi(1,1),
#endif       
     :           xtp_avantevaptrac_cas,0,hdiag(1)) ! hdiag ne sera pas utilis

       enddo ! do izone=1,ntraceurs_zone

#ifdef ISOVERIF    
!        write(*,*) 'appel_stewart_np tmp 1117: ',
!     :           'fin du cas evap_glace'   
        do il=1,ncas_evap_glace
!           write(*,*) 'appel_stewart_np tmp 1146: il=',il            
!           write(*,*) 'xtp_avantevap=',xtp_avantevap
!     :           (1:ntraciso,cas_evap_glace(il))
!           write(*,*) 'xtp=',xtp(1:ntraciso,cas_evap_glace(il),i)
           if (iso_verif_traceur_nostop(xtp(1,cas_evap_glace(il),i),
     :           'appel_stewart_np 1314').eq.1) then
             write(*,*) 'il,cas_evap_glace(il)=',il,cas_evap_glace(il)
             write(*,*) 'trace_cas(cas_evap_glace(il))=',
     :           trace_cas(cas_evap_glace(il))
             write(*,*) 'cas evap_glace'
             write(*,*) 'xtp(:,cas_evap_glace(il),i)=',
     :              xtp(:,cas_evap_glace(il),i)
             write(*,*) 'fac_ftmr_cas(il)=',fac_ftmr_cas(il)
             write(*,*) 'Eqi_stewart(il)=',Eqi_stewart(il)
             write(*,*) 'Pxtisup(:,cas_evap_glace(il))=',
     :                   Pxtisup(:,cas_evap_glace(il))
             write(*,*) 'xtp_avantevap(:,cas_evap_glace(il))=',
     :                  xtp_avantevap(:,cas_evap_glace(il))
             write(*,*) 'Exi(:,cas_evap_glace(il))=',
     :                  Exi(:,cas_evap_glace(il))
             ! on laisse quand mme une chance
             call iso_verif_traceur_pbidouille(
     :           xtp(1,cas_evap_glace(il),i),
     :           'appel_stewart_np 1331')
           endif
           call iso_verif_traceur(xtevap(1,cas_evap_glace(il),i),
     :           'appel_stewart_np 2150')
           call iso_verif_traceur(xtwater(1,cas_evap_glace(il),i),
     :           'appel_stewart_np 2152')
        enddo !do il=1,ncas_evap_glace        
#endif
#endif

        endif !if (ncas_evap_glace.gt.0) then


       ! ****** dernires vrifs et bidouilles


#ifdef ISOVERIFNAN
        do il=1,ncum 
           if (i.le.inb(il) .and. lwork(il)) then
             do ixt=1,ntraciso
               if ((iso_verif_noNAN_nostop(xtevap(ixt,il,i),
     :             'appel_stewart_np 1661').eq.1).or.
     :             (iso_verif_noNAN_nostop(xtp(ixt,il,i),
     :             'appel_stewart_np 1382').eq.1).or.
     :             (iso_verif_noNAN_nostop(xtwater(ixt,il,i),
     :             'appel_stewart_np 1381').eq.1)) then
                 write(*,*) 'il,i,trace_cas=',il,i,trace_cas(il)
                 stop
               endif
             enddo
         endif !if (i.le.inb(il) .and. lwork(il)) then
       enddo !do il=1,ncum 
#endif  
#ifdef ISOVERIF
        do il=1,ncum 
           if (i.le.inb(il) .and. lwork(il)) then
             if (use_iso_eau.eq.1) then
              if (iso_verif_egalite_choix_nostop(xtwater(iso_eau,il,i),
     :         water(il,i),'appel_stewart_np 1277, fin, water',
     :         errmax,errmaxrel).eq.1) then 
               write(*,*) 'il,i,trace_cas=',il,i,trace_cas(il)
               stop 
              endif  !if (iso_verif_egalite_choix_nostop(  
              if (iso_verif_egalite_choix_nostop(
     :         xtp(iso_eau,il,i),qp(il,i),'appel_stewart_np 1278',
     :         errmax,errmaxrel*50).eq.1) then 
               write(*,*) 'il,i,trace_cas=',il,i,trace_cas(il)
               stop 
              endif  !if (iso_verif_egalite_choix_nostop(
              if (iso_verif_egalite_choix_nostop(
     :         xtevap(iso_eau,il,i),evap(il,i),
     :         'appel_stewart_np 1279',
     :         errmax,errmaxrel).eq.1) then 
               write(*,*) 'il,i,trace_cas=',il,i,trace_cas(il)
               stop 
              endif  !if (iso_verif_egalite_choix_nostop(
             endif !if (use_iso_eau.eq.1) then
             if ((use_iso_HDO.eq.1).and.
     :           (qp(il,i).gt.ridicule)) then
                call iso_verif_aberrant(
     :           xtp(iso_HDO,il,i)/qp(il,i),
     :           'appel_stewart_np 1498')
             endif  ! if (use_iso_HDO.eq.1) then
#ifdef ISOTRAC
!           if (il.eq.602) then
!              write(*,*) 'appel_stewart_np 1334: il,i=',il,i
!              write(*,*) 'xtp(iso_eau:ntraciso:3,il,i)=',
!     :          xtp(iso_eau:ntraciso:3,il,i) 
!           endif
           call iso_verif_traceur(xtp(1,il,i),
     :           'appel_stewart_np 1632')
           call iso_verif_traceur_justmass(xtevap(1,il,i),
     :           'appel_stewart_np 1634')
           call iso_verif_traceur(xtwater(1,il,i),
     :           'appel_stewart_np 1636')
!           if ((option_traceurs.eq.17).or.
!     :           (option_traceurs.eq.18)) then
!            if (iso_verif_positif_nostop(xtwater(
!     :           index_trac(izone_cond,iso_eau),il,i)
!     :           -xtwater(iso_eau,il,i),
!     :           'appel_stewart_np 1457').eq.1) then
!             write(*,*) 'il,trace_cas=',il,trace_cas(il)
!             stop
!            endif !if (iso_verif_positif_nostop(xtwater(iso_eau,il,i)-
!           endif !if ((option_traceurs.eq.17).or.
#endif  
           endif !if (i.le.inb(il) .and. lwork(il)) then 
        enddo !do il=1,ncum 
#endif

       if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then 
         do il=1,ncum 
           if (i.le.inb(il) .and. lwork(il)) then 
             xtwater(iso_eau,il,i)= water(il,i)
             xtp(iso_eau,il,i)=qp(il,i) 
             xtevap(iso_eau,il,i)= evap(il,i) 
#ifdef ISOTRAC       
#ifdef ISOVERIF
             call iso_verif_traceur_pbidouille(xtp(1,il,i),
     :           'appel_stewart_np 1362') 
             call iso_verif_traceur_pbidouille(
     :           xtwater(1,il,i),
     :           'appel_stewart_np 1381')                       
#else
             call iso_verif_traceur_jbidouille(xtp(1,il,i))
             call iso_verif_traceur_jbidouille(xtwater(1,il,i))
#endif            
#endif             
           endif !if (i.le.inb(il) .and. lwork(il)) then     
          enddo !do il=1,ncum  
        endif !if (bidouille_anti_divergence) then

!#ifdef ISOVERIF
!        write(*,*) 'appel_stewart_np tmp 1197: sortie'
!#endif

        return
        end

         
        subroutine make_cas_noevap_np(ncas,
     :          xtp_avantevap_cas,xtevapsup_cas,
     :          Pxtisup_cas,Pqisup_cas,water_cas,
     :          xtevap_cas,xtp_cas,xtwater_cas
#ifdef ISOVERIF
     :          ,evap_cas,qp_cas,oktrac 
#endif        
     :           )
        implicit none

#include "wateriso2.h"  
#include "iso_verif.h"        
        ! inputs
        integer ncas
        real xtevapsup_cas(niso,ncas),water_cas(ncas)
        double precision  xtp_avantevap_cas(niso,ncas),
     :   Pqisup_cas(ncas), Pxtisup_cas(niso,ncas)
#ifdef ISOVERIF        
        real evap_cas(ncas),qp_cas(ncas)
        integer oktrac ! si traceurs, certaines verifs ne sont pas
                !valides
#endif
        integer iso_verif_noNaN_nostop
        ! outputs
        real xtevap_cas(niso,ncas),xtp_cas(niso,ncas),
     :            xtwater_cas(niso,ncas)

        ! locals
        double precision Risup(niso,ncas)
        integer il,ixt
        real double_to_real

!        write(*,*) 'appel_stewart_np tmp 1530: Pxtisup_cas(iso_eau,2)=',
!     :           Pxtisup_cas(iso_eau,2)
!        write(*,*) 'Pqisup_cas(2)=',Pqisup_cas(2)
        do il=1,ncas
         do ixt=1,niso
             xtp_cas(ixt,il)=xtp_avantevap_cas(ixt,il)
             xtevap_cas(ixt,il)=0.0
         enddo  !do ixt=1,niso 
       enddo !do il=1,ncas_noevap
#ifdef ISOVERIF       
       do il=1,ncas
        if ((Pqisup_cas(il).le.0.0).and.
     :           (water_cas(il).gt.ridicule*10)) then
            ! 27 mai 2009: on est plus laxiste dans le cas des traceurs
            ! d'eau: on met ridicule*10
            write(*,*) 'appel_stewart_np 372: water(il,i)=',
     :         water_cas(il)
            write(*,*) 'appel_stewart_np 372: Pqisup=',Pqisup_cas(il)
            stop
         endif
         if (use_iso_eau.eq.1) then
             call iso_verif_egalite_choix(
     :           double_to_real(Pxtisup_cas(iso_eau,il)),
     :           double_to_real(Pqisup_cas(il)),
     :           'appel_stewart_np 1548',errmax,errmaxrel)
         endif
         call iso_verif_noNaN(water_cas(il),
     :                   'appel_stewart_np 1583')
        enddo !do il=1,ncas_noevap
#endif        
        do il=1,ncas
         ! changement: >0 -> >ridicule*1e-2
         if (Pqisup_cas(il).gt.ridicule*1e-2) then
            do ixt=1,niso  
              Risup(ixt,il)=Pxtisup_cas(ixt,il)/Pqisup_cas(il)
              xtwater_cas(ixt,il)=water_cas(il)*Risup(ixt,il)
            enddo !do ixt=1,niso
         else !if (Pqisup.gt.0.0) then
           do ixt=1,niso
            xtwater_cas(ixt,il)=water_cas(il)*Rdefault(ixt)
           enddo !do ixt=1,niso  
         endif  !if (Pqisup.gt.0.0) then  
        enddo !do il=1,ncas_noevap 

#ifdef ISOVERIFNAN
          do il=1,ncas
            do ixt=1,niso   
              call iso_verif_noNaN(xtp_cas(ixt,il),
     :                   'appel stewart 265.2: cas 1.1')
              call iso_verif_noNaN(xtevap_cas(ixt,il),
     :             'appel_stewart_np 286')
              if (iso_verif_noNaN_nostop(xtwater_cas(ixt,il),
     :             'appel_stewart_np 1594').eq.1) then
                 write(*,*) 'il,ixt=',il,ixt
                 write(*,*) 'water_cas(il)=',water_cas(il)
                 write(*,*) 'Pxtisup_cas(ixt,il),Pqisup_cas(il)=',
     :             Pxtisup_cas(ixt,il),Pqisup_cas(il)
                 stop
              endif
            enddo !do ixt=1,niso   
          enddo !do il=1,ncas_noevap  
#endif
#ifdef ISOVERIF   
          if (use_iso_eau.eq.1) then
            do il=1,ncas
              call iso_verif_egalite_choix(xtwater_cas(iso_eau,il),
     :           water_cas(il),'appel_stewart_np 262.2, cas 1.1',
     :           errmax,errmaxrel)
              if ((xtwater_cas(iso_eau,il).eq.0).and.
     :           (water_cas(il).gt.ridicule)) then
               write(*,*) 'appel_stewart_np 263.2, cas 1.1'
               write(*,*) 'xtwater(iso_eau,il)=',xtwater_cas(iso_eau,il)
               write(*,*) 'water(il)=',water_cas(il)
               stop
              endif
              if (oktrac.eq.0) then
!                  write(*,*) 'appel_stewart_np 1743 noevap tmp: il=',il
             call iso_verif_egalite_choix(xtp_cas(iso_eau,il),
     :           qp_cas(il)
     :           ,'appel_stewart_np 269.2, cas 1.1',errmax,errmaxrel)
              call iso_verif_egalite_choix(xtevap_cas(iso_eau,il),
     :           evap_cas(il),
     :           'appel_stewart_np 275.2, cas 1.1',
     :           errmax,errmaxrel)
             endif !if (oktrac.eq.0) then
             enddo !do il=1,ncas
            endif ! if (use_iso_eau.eq.1) then
            if (oktrac.eq.0) then
            if (use_iso_HDO.eq.1) then
              do il=1,ncas
                if (qp_cas(il).gt.ridicule) then              
                call iso_verif_aberrant(
     :           xtp_cas(iso_HDO,il)/qp_cas(il),
     :           'appel_stewart_np 613')
                endif !if (qp(cas_noevap(il),i).gt.ridicule) then   
              enddo !do il=1,ncas 
            endif  ! if (use_iso_HDO.eq.1) then
            endif !if (oktrac.eq.0) then
#endif           

        return
        end



      subroutine make_cas_evap_liq_np(ncas,
     :           water_cas,
     :           xtp_avantevap_cas,qp_avantevap_cas,
     :           xtp_avantevaptrac_cas,qp_avantevaptrac_cas,
     :           Pxtisup_cas,Pqisup_cas,
     :           Eqi_stewart,Pqiinf_stewart,fac_ftmr_cas,
     :           qs_cas, T_cas,wt_cas,  delP_cas,
     :           xtevapsup_cas,qeff, g,sigd,Eqi_prime_cas,
     :           Eqi_cas,
     :           qp_cas,INB_cas,i,oktrac
#ifdef ISOTRAC        
     :           ,ptrac,hdiag
#endif                
#ifdef ISOVERIF
     :           ,evap_cas,Exi_stewart
#endif        
     :           ,xtp_cas,xtwater_cas,xtevap_cas)
        implicit none

#include "wateriso2.h"
#include "iso_verif.h"
        ! inputs
        integer ncas
        double precision xtp_avantevap_cas(niso,ncas),
     :           qp_avantevap_cas(ncas)
        double precision xtp_avantevaptrac_cas(niso,ncas),
     :           qp_avantevaptrac_cas(ncas)
        ! dans le cas des traceurs: xtp_avantevaptrac_cas est la
        ! quantit de traceur izone dans la vapeur
        ! alors que xtp_avantevap_cas est le total de toutes les zone
        ! on rquilibre la goutte avec le total de toutes les zones,
        ! mais c'est xtp_avantevaptrac_cas qui recoit l'vap
        double precision Pqisup_cas(ncas), Pxtisup_cas(niso,ncas)
        double precision Pqiinf_stewart(ncas), Eqi_stewart(ncas)
        double precision fac_ftmr_cas(ncas),Eqi_prime_cas(ncas)
        double precision Eqi_cas(ncas)
        real T_cas(ncas),delP_cas(ncas),
     :           xtevapsup_cas(niso,ncas),
     :           wt_cas(ncas),qeff(ncas),
     :           qs_cas(ncas),water_cas(ncas),
     :           qp_cas(ncas)  
        integer oktrac      
#ifdef ISOTRAC        
        double precision ptrac(ncas)  
        real hdiag(ncas)
#endif        
#ifdef ISOVERIF        
        real evap_cas(ncas)   
#endif        
        integer INB_cas(ncas),i
        real g,sigd
        ! outputs
        real  xtp_cas(niso,ncas),xtwater_cas(niso,ncas),
     :           xtevap_cas(niso,ncas)        

        ! locals        
        integer il,ixt        
        double precision Pxtiinf_stewart(niso,ncas), 
     :           Exi_stewart(niso,ncas) 
        double precision xtnew(niso,ncas)
#ifdef ISOVERIFIDRIS
        integer iso_verif_egalite_choix_nostop
        integer iso_verif_aberrant_nostop
        real deltaD
        integer iso_verif_aberrant_choix_nostop
#endif        
        real double_to_real
        integer iso_verif_noNaN_nostop

#ifdef ISOVERIF
!        if (ncas.ge.162) then
!        write(*,*) 'appel tmp 1975: xtp_avantevap_cas(iso_eau,162)=',
!     :           xtp_avantevap_cas(iso_eau,162)
!        write(*,*) 'appel tmp 1975b: qp_avantevap_cas(162)=',
!     :           qp_avantevap_cas(162)
!        endif !if (ncas_evap_liq.ge.162) then
      if (use_iso_eau.eq.1) then
          do il=1,ncas
!            write(*,*) 'appel tmp 1492: il=',il
            call iso_verif_egalite_choix(
     :        double_to_real(xtp_avantevap_cas(iso_eau,il)),
     :        double_to_real(qp_avantevap_cas(il)),
     :        'appel_stewart_np 473',
     :        errmax,errmaxrel)
            call iso_verif_egalite_choix(
     :        double_to_real(xtp_avantevaptrac_cas(iso_eau,il)),
     :        double_to_real(qp_avantevaptrac_cas(il)),
     :        'appel_stewart_np 473b',errmax,errmaxrel)
            call iso_verif_egalite_choix(
     :        double_to_real(Pxtisup_cas(iso_eau,il)),
     :        double_to_real(Pqisup_cas(il)),'appel_stewart_np 475',
     :        errmax,errmaxrel)
            call iso_verif_positif(
     :        double_to_real(Eqi_stewart(il)),'appel_stewart_np 1908')
           enddo !do il=1,ncas
       endif !if (use_iso_eau.eq.1) then
       do il=1,ncas
          call iso_verif_positif(double_to_real(Eqi_stewart(il)),
     :        'appel_stewart_np 1913')
       enddo !do il=1,ncas
#endif   

#ifdef ISOTRAC       
       !  l'avenir, il faudra faire les choses plus proprement!
       if (oktrac.eq.1) then
           ! on renormalise le flux de prcip et d'vap
           ! on suppose que la seule diffrence entre les diffrentes
           ! zones, c'est la compo du liquide
           do il=1,ncas
            if (ptrac(il).gt.1e-20) then
             Pqisup_cas(il)=Pqisup_cas(il)/ptrac(il)
             Eqi_stewart(il)=Eqi_stewart(il)/ptrac(il)
             Pqiinf_stewart(il)=Pqiinf_stewart(il)/ptrac(il)
             do ixt=1,niso
               Pxtisup_cas(ixt,il)=Pxtisup_cas(ixt,il)/ptrac(il)
             enddo
            else !if (ptrac(il).gt.0.0) then
#ifdef ISOVERIF                
             call iso_verif_egalite(double_to_real(Pqisup_cas(il)),
     :           0.0,'appel 2104')  
             call iso_verif_egalite(double_to_real(Eqi_stewart(il)),
     :           0.0,'appel 2105')
             call iso_verif_egalite(double_to_real(Pqiinf_stewart(il)),
     :           0.0,'appel 2106')
#endif             
             Pqisup_cas(il)=0.0
             Eqi_stewart(il)=0.0
             Pqiinf_stewart(il)=0.0
             do ixt=1,niso
               Pxtisup_cas(ixt,il)=0.0
             enddo   
            endif !if (ptrac(il).gt.0.0) then
           enddo !do il=1,ncas
       endif !if (oktrac.eq.1) then
#endif       
        

        if (no_pce.eq.1) then
            call stewart_sublim_nofrac_vectall(
     :        ncas,qp_avantevap_cas(1),
     :        xtp_avantevap_cas(1,1),Pqisup_cas(1),
     :        Pxtisup_cas(1,1),Eqi_stewart(1),Pqiinf_stewart(1),
     :        Pxtiinf_stewart(1,1),xtnew(1,1),Exi_stewart(1,1),
     :        fac_ftmr_cas(1))
        else !if (no_pce.eq.1) then
#ifdef ISOVERIF                    
            write(*,*) 'appel_stewart_np 1957 tmp'
#endif            
      call stewart_explicite_vectall(ncas,
     :        qp_avantevap_cas(1),xtp_avantevap_cas(1,1),
     :        Pqisup_cas,
     :           Pxtisup_cas(1,1),Eqi_stewart(1),
     :           Pqiinf_stewart(1),qeff(1),
     :        Pxtiinf_stewart(1,1),xtnew(1,1),Exi_stewart(1,1),
     :           fac_ftmr_cas(1),
     :        qs_cas(1),T_cas(1),wt_cas(1),delP_cas(1)
#ifdef ISOVERIF
     :          ,0,73
#endif
     :   )
         endif !if (no_pce.eq.1) then

#ifdef ISOTRAC      
      !  l'avenir, il faudra faire les choses plus proprement!
      if (oktrac.eq.1) then
           ! on renormalise le flux de prcip et d'vap
           ! on suppose que la seule diffrence entre les diffrentes
           ! zones, c'est la compo du liquide
           do il=1,ncas
             Pqisup_cas(il)=Pqisup_cas(il)*ptrac(il)
             Eqi_stewart(il)=Eqi_stewart(il)*ptrac(il)
             Pqiinf_stewart(il)=Pqiinf_stewart(il)*ptrac(il)
             do ixt=1,niso
               Pxtisup_cas(ixt,il)=Pxtisup_cas(ixt,il)*ptrac(il)
               Exi_stewart(ixt,il)=Exi_stewart(ixt,il)*ptrac(il)
               Pxtiinf_stewart(ixt,il)=Pxtiinf_stewart(ixt,il)*ptrac(il)
               xtnew(ixt,il)=xtp_avantevap_cas(ixt,il)
     :           +(xtnew(ixt,il)-xtp_avantevap_cas(ixt,il))*ptrac(il)
             enddo
             hdiag(il)=qeff(il)/qs_cas(il)
           enddo !do il=1,ncas
       endif !if (oktrac.eq.1) then
#endif

#ifdef ISOVERIF
       if (use_iso_eau.eq.1) then
          do il=1,ncas     
                call iso_verif_egalite_choix(
     :            double_to_real(Exi_stewart(iso_eau,il)
     :            *fac_ftmr_cas(il)),
     :            double_to_real(Eqi_stewart(il)*fac_ftmr_cas(il)),
     :            'appel stewart 520',errmax*80,errmaxrel*80)
                call iso_verif_egalite_choix(
     :           double_to_real(Pxtiinf_stewart(iso_eau,il)),
     :           double_to_real(Pqiinf_stewart(il)),
     :           'appel_stewart_np 586',
     :           errmax,errmaxrel)
                if (Pqiinf_stewart(il).gt.ridicule) then
                  call iso_verif_egalite_choix(double_to_real(
     :              Pxtiinf_stewart(iso_eau,il)/Pqiinf_stewart(il)),
     :              1.,'appel_setwart 575a', errmax*10, errmaxrel*10)
                endif !if (Pqiinf_par.gt.ridicule) then
           enddo !do il=1,ncas     
        endif !if (use_iso_eau.eq.1) then  
#endif  
#ifdef ISOVERIFNAN
        do il=1,ncas 
           call iso_verif_noNAN(water_cas(il), 
     :           'appel_stewart_np 2009') 
           call iso_verif_noNAN(double_to_real(Pqiinf_stewart(il)), 
     :           'appel_stewart_np 2011')
           do ixt=1,niso
           call iso_verif_noNAN(double_to_real(
     :           Pxtiinf_stewart(ixt,il)),'appel_stewart_np 2014')
           call iso_verif_noNAN(double_to_real(
     :           xtnew(ixt,il)),'appel_stewart_np 2014')
           enddo
        enddo      
#endif 
           
        ! deduction de XTWATER  partir de Pxtiinf:
! hypothse: l'eau en i a la mme composition que le flux d'eau
        ! qui sort de la boite i (Pqiinf_par)
        do il=1,ncas
          if (abs(water_cas(il)).lt.ridicule/10.) then
            do ixt=1,niso
               xtwater_cas(ixt,il)=0.0
            enddo !do ixt=1,niso
          else !if (water(il,i).eq.0.0) then
             if (Pqiinf_stewart(il).gt.0.0) then  !if (Pxtiinf_par(iso_eau).gt.0.0) then 
               do ixt=1,niso 
                 xtwater_cas(ixt,il)=water_cas(il)
     :              *Pxtiinf_stewart(ixt,il)/Pqiinf_stewart(il)
               enddo
             else !if (Pxtiinf_stewart(iso_eau).gt.0.0) then
                 ! normalement, ce cas a dj t interdit dans
                 ! compress_evp_glace
                do ixt=1,niso
                  xtwater_cas(ixt,il)=water_cas(il)*Rdefault(ixt)
                enddo !do ixt=1,niso
             endif
           endif !if (water(il,i).eq.0.0) then
         enddo !do il=1,ncas
        
#ifdef ISOVERIF
       do il=1,ncas
        do ixt=1,niso
          call iso_verif_noNAN(xtwater_cas(ixt,il), 
     :          'appel_stewart_np 566')
        enddo !do ixt=1,niso
        if (use_iso_eau.eq.1) then
         call iso_verif_egalite_choix(xtwater_cas(iso_eau,il),
     :           water_cas(il),'appel_stewart_np 568',errmax,errmaxrel)
         if (water_cas(il).gt.ridicule*10) then
             if (iso_verif_egalite_choix_nostop(
     :           xtwater_cas(iso_eau,il)/water_cas(il),1.0,
     :           'appel stewart 155',errmax*10,errmaxrel*10).eq.1) then
!               write(*,*) 'i=',i
               write(*,*) 'Tevap=',T_cas(il)
               write(*,*) 'xtwater(iso_eau,il,i)=',
     :                   xtwater_cas(iso_eau,il)
               write(*,*) 'water(il,i)=',water_cas(il)
               write(*,*) 'Pxtiinf_stewart(iso_eau)=',
     :                    Pxtiinf_stewart(iso_eau,il)
!               write(*,*) 'Pqiinf_par,Pqiinf_stewart=',
!     :              Pqiinf_par(cas_evap_liq(il)),Pqiinf_stewart(il)
               stop
             endif  !if (iso_verif_egalite_nostop(
         endif !if (water(il,i).gt.ridicule) then
        endif !if (use_iso_eau.eq.1) then
       enddo !do il=1,ncas
#endif

      
        ! rappel, le Eqi_prime qu'on a mis en argument dans stewart est en
        ! fait gal  0.5*(Eqi+Eqi+1) -> en tenir compte quand on
        ! calcule xtevapi.    
       do il=1,ncas
        if (Eqi_stewart(il)*fac_ftmr_cas(il).gt.ridicule) then
            ! changement le 20avril 2012: >0 -> >ridicule
         do ixt=1,niso          
          xtevap_cas(ixt,il)=Eqi_cas(il)
     :           *Exi_stewart(ixt,il)/Eqi_stewart(il)
     :           /100/delP_cas(il)/SIGD*g
         enddo ! do ixt=1,niso
        else !if (Eqi_stewart.gt.0.0) then
            ! il peut quand mme y a voir de la diffusion
            do ixt=1,niso
            xtevap_cas(ixt,il)=Exi_stewart(ixt,il)
     :           /100.0/delP_cas(il)/SIGD*g
            enddo !do ixt=1,niso    
        endif !if (Eqi_stewart.gt.0.0) then
       enddo !do il=1,ncas
      
#ifdef ISOVERIFNAN
      do il=1,ncas
        do ixt=1,niso
         if ((iso_verif_noNAN_nostop(xtevap_cas(ixt,il),
     :     'appel stewart 131').eq.1).or.
     :      (iso_verif_noNAN_nostop(xtnew(ixt,il),
     :     'appel stewart 131b').eq.1)) then
           write(*,*) 'Exi_stewart(ixt,il)=',Exi_stewart(ixt,il)
           write(*,*) 'Eqi_stewart(il)=',Eqi_stewart(il)     
           write(*,*) 'fac_ftmr_cas(il)=',fac_ftmr_cas(il)    
           write(*,*) 'Eqi_cas(il)=',Eqi_cas(il)     
           write(*,*) 'xtevap_cas(ixt,il)=',xtevap_cas(ixt,il)
           stop
         endif
        enddo ! do ixt=1,nisio
      enddo
#endif      
#ifdef ISOVERIF
      do il=1,ncas
        if (oktrac.eq.0) then 
            ! dans le cas traceur, le calcul de evap_cas est plus
            ! compliqu: il faut le faire plus proprement dans
            ! compress_stewart
        if (use_iso_eau.eq.1) then
            if (iso_verif_egalite_choix_nostop(xtevap_cas(iso_eau,il),
     ;           evap_cas(il),'appel stewart 142',
     :           errmax,errmaxrel).eq.1) then
              write(*,*) 'il=',il
              write(*,*) 'Eqi_prime_cas(il)=',Eqi_prime_cas(il)
              write(*,*) 'Eqi_stewart(il)=',Eqi_stewart(il)
              write(*,*) 'Exi_stewart(iso_eau,il)=',
     :           Exi_stewart(iso_eau,il)
              write(*,*) '1/100/delP_cas(il)/SIGD*g*2=',
     ;           1.0/100.0/delP_cas(il)/SIGD*g*2.0
              write(*,*) 'xtevapsup_cas(iso_eau,il)=',
     :           xtevapsup_cas(iso_eau,il)
              stop
            endif
        endif !if (use_iso_eau.eq.1) then
        endif !if (oktrac.eq.0) then 
        if (oktrac.eq.1) then 
        if ((use_iso_eau.eq.1).and.(use_iso_HDO.eq.1)) then
             call iso_verif_aberrant_choix(
     :           double_to_real(xtp_avantevaptrac_cas(iso_HDO,il)),
     :           double_to_real(xtp_avantevaptrac_cas(iso_eau,il)),
     :           ridicule_trac,deltalimtrac,
     :           'appel_stewart_np 2053')
        endif !if ((use_iso_eau.eq.1).and.(use_iso_HDO.eq.1)) then
        endif
      enddo !do il=1,ncas 
#endif

      ! deduction de XTP partir de Exi
      
      do il=1,ncas
       if (i.lt.INB_cas(il)) then
          if (fac_ftmr_cas(il).gt.0.0) then
             if (Eqi_stewart(il)*fac_ftmr_cas(il).gt.ridicule) then 
               do ixt=1,niso               
               !   xtp(ixt,il,i)=xtnew(ixt)*qp(il,i)/xtnew(4)
                  xtp_cas(ixt,il)=max(xtp_avantevaptrac_cas(ixt,il) 
     :                +fac_ftmr_cas(il)*Eqi_prime_cas(il)
     :                *Exi_stewart(ixt,il)/Eqi_stewart(il),0.0)
               enddo !do ixt=1,niso
             else ! if (Eqi_stewart.gt.ridicule) then
                if (qp_cas(il).gt.0.0) then 

                    if (Eqi_prime_cas(il)*fac_ftmr_cas(il).gt.ridicule)
     :                    then 
                        ! il va manquer quelque chose: il faut augmenter
                        ! xtp en lui ajoutant l'vap du niveau d'eau
                        ! dessus
                        ! pour l'instant, on bidouille:
!                        write(*,*) 'appel_stewart_np 2041: il=',il
                        do ixt=1,niso               
                        xtnew(ixt,il)=xtnew(ixt,il)
     :                    *(qp_avantevap_cas(il)
     :                    +Eqi_prime_cas(il)*fac_ftmr_cas(il))
     :                    /(qp_avantevap_cas(il)
     :                    +Eqi_stewart(il)*fac_ftmr_cas(il))
                        enddo
                    endif !if (Eqi_prime_cas(il)*fac_ftmr_cas(il).gt.ridicule)

                    do ixt=1,niso               
!                      xtp_cas(ixt,il)=xtnew(ixt,il)
                      xtp_cas(ixt,il)=(xtp_avantevaptrac_cas(ixt,il)
     :                           +(xtnew(ixt,il)
     :                           -xtp_avantevap_cas(ixt,il)))
                      ! modif 1 mai 2009, pour le cas des traceurs
                    enddo !do ixt=1,niso
!                    write(*,*) 'appel_stewart_np 1963 tmp: ',
!     :                  'xtp_cas(iso_eau,il)=',xtp_cas(iso_eau,il)
                else !if (qp(il,i).gt.0.0) then 
                  do ixt=1,niso               
                    xtp_cas(ixt,il)=0.0
                  enddo !do ixt=1,niso
                endif  !if (qp(il,i).gt.0.0) then 
            endif !if (Eqi_stewart.gt.ridicule) then 

#ifdef ISOVERIFNAN       
!            if (il.eq.87) then
!                write(*,*) 'appel_stewart_np 2244: tmp, aprs calcul xtp'
!                write(*,*) 'xtnew(:,il)=',xtnew(:,il)
!                write(*,*) 'Pxtiinf_stewart(:,il)=',
!     :             Pxtiinf_stewart(:,il)
!            endif  !if (il.eq.87) then    
            do ixt=1,niso
              if (iso_verif_noNAN_nostop(xtp_cas(ixt,il),
     :                  'appel stewart 684').eq.1) then
                write(*,*) 'i,INB_cas(il)=',i,INB_cas(il)
                write(*,*) 'fac_ftmr_cas(il)=',fac_ftmr_cas(il)
                write(*,*) 'Eqi_prime_cas(il)=',Eqi_prime_cas(il)
                write(*,*) 'Eqi_stewart(il)=',Eqi_stewart(il)
                write(*,*) 'xtp_avantevaptrac_cas(ixt,il)=',
     :                  xtp_avantevaptrac_cas(ixt,i)
                write(*,*) 'Exi_stewart(ixt,il)=',Exi_stewart(ixt,il)
                write(*,*) 'xtnew(ixt,il)=',xtnew(ixt,il)
                write(*,*) 'xtp_avantevap_cas(ixt,il)=',
     :                  xtp_avantevap_cas(ixt,il)
                write(*,*) 'qp_cas(il)=',qp_cas(il)
                stop
              endif !if (iso_verif_noNAN(xtp_cas(ixt,il),
            enddo ! do ixt=1,niso
#endif
#ifdef ISOVERIF   
            if (oktrac.eq.1) then
            if ((use_iso_HDO.eq.1).and.(use_iso_eau.eq.1)) then
                ! le 10 mai 2009: on remonte le seuil de vrif de deltaD
                ! aberrant car dans le cas des traceurs, des trs
                ! petites concentrations sont trs facilement
                ! influences par des vaps qui peuvent tre aberantes
                ! si ces evaps sont petites
                if (iso_verif_aberrant_choix_nostop(
     :           xtp_cas(iso_HDO,il),xtp_cas(iso_eau,il),
     :           ridicule_trac,deltalimtrac,
     :           'appel_stewart_np 2090').eq.1) then
                  write(*,*) 'xtp_avantevaptrac_cas(iso_eau),deltaD=',
     :              xtp_avantevaptrac_cas(iso_eau,il),deltaD
     :              (double_to_real(xtp_avantevaptrac_cas(iso_HDO,il))
     :              /double_to_real(xtp_avantevaptrac_cas(iso_eau,il)))
                  write(*,*) 'xtp_avantevap_cas(iso_eau),deltaD=',
     :              xtp_avantevap_cas(iso_eau,il),deltaD
     :              (double_to_real(xtp_avantevap_cas(iso_HDO,il))
     :              /double_to_real(xtp_avantevap_cas(iso_eau,il)))
                  write(*,*) 'xtnew(iso_eau),deltaD=',
     :              xtnew(iso_eau,il),deltaD
     :              (double_to_real(xtnew(iso_HDO,il))
     :              /double_to_real(xtnew(iso_eau,il)))
                  write(*,*) 'xtp_cas(iso_eau),deltaD=',
     :              xtp_cas(iso_eau,il),deltaD
     :              (xtp_cas(iso_HDO,il)/xtp_cas(iso_eau,il))
                  write(*,*) 'Eqi_stewart(il),fac_ftmr_cas(il)=',
     :                   Eqi_stewart(il),fac_ftmr_cas(il)
                  write(*,*) 'Eqi_prime_cas(il)=',
     :                   Eqi_prime_cas(il)
                  write(*,*) 'deltaD_Eqi_stewart=',
     :                   deltaD(double_to_real(
     :                   Exi_stewart(iso_HDO,il)/Eqi_stewart(il)))
                  write(*,*) 'xtnew-xtp_avantevap_cas,deltaD=',
     :                 xtnew(iso_eau,il)-xtp_avantevap_cas(iso_eau,il),
     :                 deltaD(double_to_real((xtnew(iso_HDO,il)
     :                 -xtp_avantevap_cas(iso_HDO,il))/
     :                 (xtnew(iso_eau,il)
     :                 -xtp_avantevap_cas(iso_eau,il))))  
                  write(*,*) 'Pqisup,deltaD=',
     :                   Pqisup_cas(il),deltaD(double_to_real(
     :                   Pxtisup_cas(iso_HDO,il)/Pqisup_cas(il)))
                  stop
                endif
        endif !if (use_iso_HDO.eq.1) then
       endif !if (oktrac.eq.1) then
          if (oktrac.eq.0) then
            if (use_iso_eau.eq.1) then
              if (iso_verif_egalite_choix_nostop(xtp_cas(iso_eau,il),
     :         qp_cas(il),'appel stewart 688',
     :           errmax,errmaxrel*30).eq.1) then    
                  write(*,*) 'il=',il                   
                  write(*,*) 'q,xtp_avantevap_cas(iso_eau)=',
     :              qp_avantevap_cas(il),
     :              xtp_avantevap_cas(iso_eau,il)
                  write(*,*) 'xtnew,qp,xtpcas=',
     :              xtnew(iso_eau,il),qp_cas(il),xtp_cas(iso_eau,il)
                  write(*,*) 'fac_ftmr_cas(il)=',fac_ftmr_cas(il)
                  write(*,*) 'Eqi_prime_cas(il)=',
     :                   Eqi_prime_cas(il)
                  write(*,*) 'Eqi_stewart, Exi_stewart=',
     :                   Eqi_stewart(il),
     :                   Exi_stewart(iso_eau,il)
                  write(*,*) 'Pqisup=',Pqisup_cas(il)
                 stop
              endif !if (iso_verif_egalite_choix_nostop(xtp_cas(iso_eau,il),
           endif !if (use_iso_eau.eq.1) then

           if ((use_iso_HDO.eq.1).and.
     :           (qp_cas(il).gt.ridicule)) then
             if (iso_verif_aberrant_nostop(xtp_cas(iso_HDO,il)/
     :         qp_cas(il),
     :         'appel_stewart_np 1079').eq.1) then
               write(*,*) 'i,qp(cas_evap_liq(il),i)=',
     :                   i,qp_cas(il) 
               write(*,*) 'fac_ftmr_cas(il)=',fac_ftmr_cas(il)
               write(*,*) 'deltaDxtnew=',deltaD(double_to_real(
     :           xtnew(iso_HDO,il))/qp_cas(il))
               stop
             endif
           endif !if (use_iso_HDO.eq.1) then 
        endif ! if (oktrac.eq.0) then
#endif              

          else !if (fac_ftmr.gt.0.0) then
              ! ca veut dire que Mp=0, xtp pas dfinit
             do ixt=1,niso
               xtp_cas(ixt,il)=xtp_avantevaptrac_cas(ixt,il)
             enddo !do ixt=1,niso
         endif !if (fac_ftmr.gt.0.0) then
      else !if (i.lt.INB) then
          ! si i=inb, on ne change rien au calcul original, et on
          ! suppose que la composition du ddft est gale  celle de
          ! l'env. Ceci a dj t calcul plus haut
                  do ixt=1,niso
                    xtp_cas(ixt,il)=xtp_avantevaptrac_cas(ixt,il)
                    !xtp_avantevap(ixt) a dj t dfinit proprement
                    !dans ce cas l
                  enddo
      endif !if (i.lt.INB) then
      enddo !do il=1,ncas

      ! verif
#ifdef ISOVERIFNAN
      do il=1,ncas
        do ixt=1,niso
         call iso_verif_noNAN(xtp_cas(ixt,il),'appel stewart 198')
         call iso_verif_noNAN(xtevap_cas(ixt,il),'appel stewart 745')
        enddo !do ixt=1,niso
        enddo !do il=1,ncas  
#endif
#ifdef ISOVERIF
      do il=1,ncas
        if ((use_iso_HDO.eq.1).and.(use_iso_eau.eq.1)) then
          if (oktrac.eq.1) then
              call iso_verif_aberrant_choix(
     :           xtp_cas(iso_HDO,il),xtp_cas(iso_eau,il),
     :           ridicule_trac,deltalimtrac,'appel_stewart_np 2138')
          endif
        endif !if (use_iso_HDO.eq.1) then
      enddo !do il=1,ncas  
      
      if (oktrac.eq.0) then
      if (use_iso_eau.eq.1) then
       do il=1,ncas       
        if (iso_verif_egalite_choix_nostop(
     :            xtp_cas(iso_eau,il),
     :            qp_cas(il),
     :           'appel stewart 197',
     :           errmax,errmaxrel*50).eq.1) then   
          write(*,*) 'i=',i,' INB=',INB_cas(il)
          write(*,*) 'Tevap=',T_cas(il)
          write(*,*) 'xtp(iso_eau,il,i)=',xtp_cas(iso_eau,il)
          write(*,*) 'qp(il,i)=',qp_cas(il)
          write(*,*) 'xtnew(iso_eau)=',xtnew(iso_eau,il)
          write(*,*) 'fac_ftmr=',fac_ftmr_cas(il)
!          write(*,*) 'Mp(il,i)=',Mp(cas_evap_liq(il),i)
          write(*,*) 'xtp_avantevap(iso_eau)=',
     :           xtp_avantevap_cas(iso_eau,il)
          write(*,*) 'qp_avantevap=',qp_avantevap_cas(il)
!          write(*,*) 'Exi_prime(iso_eau)=',Exi_prime(iso_eau,il)
!          write(*,*) 'Eqi_prime=',Eqi_prime(il)       
          write(*,*) 'Pxtiinf_stewart(iso_eau)=',
     :            Pxtiinf_stewart(iso_eau,il)
!          write(*,*) 'Pqiinf_par=',Pqiinf_par(cas_evap_liq(il))
          write(*,*) 'Pxtisup(iso_eau)=',Pxtisup_cas(iso_eau,il)
          write(*,*) 'Pqisup=',Pqisup_cas(il)
          stop
         endif !if iso_verif_egalite_choix_nostop
        enddo !do il=1,ncas
      endif !if (use_iso_eau.eq.1) then
      if (use_iso_HDO.eq.1) then            
       do il=1,ncas
!        write(*,*) 'appel_stewart_np 2166: fin make_cas_evap_liq_np, ',
!     :        'il,deltaDqp=',il,deltaD(xtp_cas(iso_HDO,il)/qp_cas(il))
        if (qp_cas(il).gt.ridicule) then
          call iso_verif_aberrant(
     :           xtp_cas(iso_HDO,il)/qp_cas(il),
     :           'appel_stewart_np 1130')
        endif !if (qp(cas_evap_liq(il),i).gt.ridicule) then
       enddo !do il=1,ncas     
      endif 
      endif ! if (oktrac.eq.0) then
#endif

      return
      end

      

      subroutine make_cas_evap_glace_np(ncas,
     :           water_cas,
     :           xtp_avantevap_cas,qp_avantevap_cas,
     :           xtp_avantevaptrac_cas,qp_avantevaptrac_cas,
     :           Pxtisup_cas,Pqisup_cas,
     :           Eqi_stewart,Eqi_prime_cas,Eqi_cas,
     :           Pqiinf_stewart,fac_ftmr_cas,
     :           qs_cas, T_cas,wt_cas,  delP_cas,
     :           xtevapsup_cas,g,sigd,INB_cas,i,
     :           frac_sublim,qp_cas
#ifdef ISOVERIF      
     :           ,evap_cas,oktrac,Exi_stewart
#endif
     :           ,xtp_cas,xtwater_cas,xtevap_cas)
      implicit none

#include "wateriso2.h"
#include "iso_verif.h"
        ! inputs
        integer ncas
        double precision xtp_avantevap_cas(niso,ncas),
     :           qp_avantevap_cas(ncas)
        double precision xtp_avantevaptrac_cas(niso,ncas),
     :           qp_avantevaptrac_cas(ncas)
        double precision Pqisup_cas(ncas), Pxtisup_cas(niso,ncas)
        double precision Pqiinf_stewart(ncas), Eqi_stewart(ncas)
        double precision fac_ftmr_cas(ncas),Eqi_prime_cas(ncas),
     :           Eqi_cas(ncas)
        real T_cas(ncas),delP_cas(ncas),
     :           xtevapsup_cas(niso,ncas),
     :           wt_cas(ncas),qeff(ncas),
     :           qs_cas(ncas),water_cas(ncas)
        real qp_cas(ncas)      
#ifdef ISOVERIF
        real evap_cas(ncas)
        integer oktrac
#endif        
        real g,sigd
        integer frac_sublim
        integer INB_cas(ncas),i
        ! outputs
        real  xtp_cas(niso,ncas),xtwater_cas(niso,ncas),
     :           xtevap_cas(niso,ncas)
        ! locals        
        integer il,ixt
        double precision Pxtiinf_stewart(niso,ncas), 
     :           Exi_stewart(niso,ncas)   
        double precision xtnew(niso,ncas)     
#ifdef ISOVERIFIDRIS
        real double_to_real
        integer iso_verif_egalite_choix_nostop
        integer iso_verif_aberrant_nostop
        real deltaD
#endif        

#ifdef ISOVERIF  
!      write(*,*) 'appel_stewart_np 2052: entre dans make_cas_evap_glace'
      if (use_iso_eau.eq.1) then
          do il=1,ncas
            call iso_verif_egalite_choix(
     :        double_to_real(xtp_avantevap_cas(iso_eau,il)),
     :        double_to_real(qp_avantevap_cas(il)),
     :           'appel_stewart_np 473b',
     :        errmax,errmaxrel)
            call iso_verif_egalite_choix(
     :        double_to_real(Pxtisup_cas(iso_eau,il)),
     :        double_to_real(Pqisup_cas(il)),'appel_stewart_np 475b',
     :        errmax,errmaxrel)
           enddo !do il=1,ncas 
       endif !if (use_iso_eau.eq.1) then
#endif    
     

      ! calculs des flux de masses  mettre en argument de stewart:
      ! comme l'eau n'est pas bien concerve dans les ddfts, on est
      ! oblig de bidouill.
      ! 1) soit on considre Pqisup, Eqi, et Pqiinf_par=Pqisup-Eqi
      !    et on suppose que dans la ralit les compositions de
      !    Pqiinf sont les mme que Pqiinf_par
      ! 2) soit on considre Pqisup, Eqi_par=Pqisup-Pqiinf, et Pqiinf,
      !    et on suppose que dans la ralit les compositions de
      !    Eqi_prime sont les mme que Eqi_par

      if (frac_sublim.eq.1) then
            call stewart_glace_vectall(ncas,
     :        qp_avantevap_cas(1),xtp_avantevap_cas(1,1),Pqisup_cas(1),
     :        Pxtisup_cas(1,1),Eqi_stewart(1),Pqiinf_stewart(1),
     :        Pxtiinf_stewart(1,1),xtnew(1,1),Exi_stewart(1,1),
     :        fac_ftmr_cas(1),
     :        qs_cas(1),T_cas(1))
      else !if (frac_sublim.eq.1) then
#ifdef ISOVERIF
            write(*,*) 'appel_stewart_explicite_np 2269'
            write(*,*) 'Pqiinf_stewart(1)=',Pqiinf_stewart(1) 
            write(*,*) 'Pqisup_cas(1)=',Pqisup_cas(1) 
            write(*,*) 'Eqi_cas(1)=',Eqi_cas(1) 
            write(*,*) 'Eqi_prime_cas(1)=',Eqi_prime_cas(1) 
            write(*,*) 'Eqi_stewart(1)=',Eqi_stewart(1)
#endif          
            call stewart_sublim_nofrac_vectall(
     :        ncas,qp_avantevap_cas(1),
     :        xtp_avantevap_cas(1,1),Pqisup_cas(1),
     :        Pxtisup_cas(1,1),
     :        Eqi_stewart(1),Pqiinf_stewart(1),
     :        Pxtiinf_stewart(1,1),xtnew(1,1),Exi_stewart(1,1),
     :        fac_ftmr_cas(1))
      endif !if (frac_sublim.eq.1) then
      

#ifdef ISOVERIF
!       write(*,*) 'appel_stewart_np 2096: dans make_cas_evap_glace'
       if (use_iso_eau.eq.1) then
          do il=1,ncas       
             call iso_verif_egalite_choix(
     :        double_to_real(Exi_stewart(iso_eau,il)*fac_ftmr_cas(il)),
     :        double_to_real(Eqi_stewart(il)*fac_ftmr_cas(il)),
     :        'appel stewart 520b',errmax*80,errmaxrel*80)
             call iso_verif_egalite_choix(
     :          double_to_real(Pxtiinf_stewart(iso_eau,il)),
     :          double_to_real(Pqiinf_stewart(il)),
     :           'appel_stewart_np 586',
     :          errmax,errmaxrel)
             if (Pqiinf_stewart(il).gt.ridicule) then
                if (iso_verif_egalite_choix_nostop(double_to_real(
     :           Pxtiinf_stewart(iso_eau,il)/Pqiinf_stewart(il)),
     :           1.,'appel_setwart 575b', errmax*10, errmaxrel*10)
     :            .eq.1) then
                   write(*,*) 'Pqiinf_stewart(il)=',Pqiinf_stewart(il)
!                   write(*,*) 'Pqiinf_par(il)=',Pqiinf_par(il)
                   write(*,*) 'Pxtiinf_stewart(iso_eau,il)=',
     :                   Pxtiinf_stewart(iso_eau,il)
                   stop
                endif
             endif !if (Pqiinf_par.gt.ridicule) then
           enddo !do il=1,ncas       
        endif !if (use_iso_eau.eq.1) then
#endif     

        ! deduction de XTWATER  partir de Pxtiinf:
! hypothse: l'eau en i a la mme composition que le flux d'eau
        ! qui sort de la boite i (Pqiinf_par)
        do il=1,ncas
          if (abs(water_cas(il)).lt.ridicule/10.) then
            do ixt=1,niso
               xtwater_cas(ixt,il)=water_cas(il)*Rdefault(ixt)
            enddo !do ixt=1,niso
          else !if (water(il,i).eq.0.0) then
             if (Pqiinf_stewart(il).gt.0.0) then  !if (Pxtiinf_par(iso_eau).gt.0.0) then 
               do ixt=1,niso 
                 xtwater_cas(ixt,il)=water_cas(il)
     :              *Pxtiinf_stewart(ixt,il)/Pqiinf_stewart(il)
               enddo
             else !if (Pxtiinf_stewart(iso_eau).gt.0.0) then
                 ! normalement, ce cas a dj t interdit dans
                 ! compress_evp_glace
                do ixt=1,niso
                  xtwater_cas(ixt,il)=water_cas(il)*Rdefault(ixt)
                enddo !do ixt=1,niso
             endif
           endif !if (water(il,i).eq.0.0) then
         enddo !do il=1,ncas
        
#ifdef ISOVERIF
!       write(*,*) 'appel_stewart_np 2563: dans make_cas_evap_glace'
       do il=1,ncas
        do ixt=1,niso
         call iso_verif_noNAN(xtwater_cas(ixt,il), 
     :           'appel_stewart_np 566b')
        enddo !do ixt=1,niso
        if (use_iso_eau.eq.1) then
         call iso_verif_egalite_choix(xtwater_cas(iso_eau,il),
     :           water_cas(il),'appel_stewart_np 568b',errmax,errmaxrel)
         if (water_cas(il).gt.ridicule*10) then
             if (iso_verif_egalite_choix_nostop(
     :           xtwater_cas(iso_eau,il)/water_cas(il),1.0,
     :           'appel stewart 155b',errmax*10,errmaxrel*10).eq.1) then
               write(*,*) 'i=',i
               write(*,*) 'Tevap=',T_cas(il)
               write(*,*) 'xtwater(iso_eau,il,i)=',
     :                   xtwater_cas(iso_eau,il)
               write(*,*) 'water(il,i)=',water_cas(il)
               write(*,*) 'Pxtiinf_stewart(iso_eau)=',
     :                    Pxtiinf_stewart(iso_eau,il)
!               write(*,*) 'Pqiinf_par,Pqiinf_stewart=',
!     :                   Pqiinf_par(il),Pqiinf_stewart(il)
               stop
             endif  !if (iso_verif_egalite_nostop(
         endif !if (water(il,i).gt.ridicule) then
        endif !if (use_iso_eau.eq.1) then
       enddo !do il=1,ncas
#endif

      
        ! rappel, le Eqi_prime qu'on a mis en argument dans stewart est en
        ! fait gal  0.5*(Eqi+Eqi+1) -> en tenir compte quand on
        ! calcule xtevapi.    
       do il=1,ncas
        if (Eqi_stewart(il)*fac_ftmr_cas(il).gt.0.0) then
         do ixt=1,niso          
          xtevap_cas(ixt,il)=Eqi_cas(il)
     :           *Exi_stewart(ixt,il)/Eqi_stewart(il)
     :           /100.0/delP_cas(il)/SIGD*g    
         enddo ! do ixt=1,niso
        else !if (Eqi_stewart.gt.0.0) then
            ! il peut quand mme y a voir de la diffusion
            do ixt=1,niso
            xtevap_cas(ixt,il)=Exi_stewart(ixt,il)
     :           /100.0/delP_cas(il)/SIGD*g
            enddo !do ixt=1,niso    
        endif !if (Eqi_stewart.gt.0.0) then
       enddo !do il=1,ncas
      
#ifdef ISOVERIF
      do il=1,ncas
        do ixt=1,niso
          call iso_verif_noNAN(xtevap_cas(ixt,il),'appel stewart 131b')
        enddo ! do ixt=1,niso
        if (oktrac.eq.0) then 
            ! dans le cas traceur, le calcul de evap_cas est plus
            ! compliqu: il faut le faire plus proprement dans
            ! compress_stewart
        if (use_iso_eau.eq.1) then
            if (iso_verif_egalite_choix_nostop(xtevap_cas(iso_eau,il),
     :         evap_cas(il),
     :         'appel stewart 142b',errmax,errmaxrel).eq.1) then
                write(*,*) 'i,il=',i,il
                write(*,*) 'Exi_stewart(iso_eau,il),Eqi_stewart(il)=',
     :                   Exi_stewart(iso_eau,il),Eqi_stewart(il) 
                write(*,*) 'Eqi_prime_cas(il)=',Eqi_prime_cas(il)
                write(*,*) 'xtevapsup_cas(iso_eau,il)=',
     :             xtevapsup_cas(iso_eau,il)
!                write(*,*) 'evap,evapsup=',evap(cas_evap_glace(il),i),
!     :             evap(cas_evap_glace(il),i+1)
              stop 
            endif !if (iso_verif_egalite_choix_nostop(xtevap_cas(iso_eau,il),
        endif !if (use_iso_eau.eq.1) then
       endif ! if (oktrac.eq.0) then
      enddo !do il=1,ncas 
#endif

!      write(*,*) 'appel_stewart_np tmp 2243: Eqi_stewart(1)=',
!     :           Eqi_stewart(1)
!      write(*,*) 'Eqi_prime_cas=',Eqi_prime_cas(1)
      ! deduction de XTP partir de Exi
        ! temporaire:
!        il=2
!        ixt=iso_eau
!        write(*,*) 'tmp 2619: Eqi_stewart(il)=',Eqi_stewart(il)
!        write(*,*) 'fac_ftmr_cas(il)=',fac_ftmr_cas(il)
!        write(*,*) 'xtp_avantevaptrac_cas(ixt,il)=',
!     :                xtp_avantevaptrac_cas(ixt,il)
!        write(*,*) 'Eqi_prime_cas(il)=',Eqi_prime_cas(il)
!        write(*,*) 'Exi_stewart(ixt,il)=',Exi_stewart(ixt,il)
!        write(*,*) 'tmp 2625: xtnew(ixt,il)=',xtnew(ixt,il)

      do il=1,ncas
       if (i.lt.INB_cas(il)) then
          if (fac_ftmr_cas(il).gt.0.0) then
!           if (Eqi_stewart(il).gt.ridicule) then 
            if (Eqi_stewart(il)*fac_ftmr_cas(il).gt.ridicule) then
!               write(*,*) 'appel_stewart_v_np 2633 tmp: il=',il 
               do ixt=1,niso     
               !   xtp(ixt,il,i)=xtnew(ixt)*qp(il,i)/xtnew(4)           
                  xtp_cas(ixt,il)=max(xtp_avantevaptrac_cas(ixt,il) 
     :                +fac_ftmr_cas(il)*Eqi_prime_cas(il)
     :                *Exi_stewart(ixt,il)/Eqi_stewart(il),0.0)  
               enddo !do ixt=1,niso
               
#ifdef ISOVERIF
               if (use_iso_eau.eq.1) then
                 call iso_verif_egalite_choix(
     :               xtp_cas(iso_eau,il),qp_cas(il),
     :               'appel stewart 2643a',errmax,errmaxrel*30)
               endif
#endif

             else ! if (Eqi_stewart.gt.ridicule) then
                if (qp_cas(il).gt.0.0) then 

!                    if (Eqi_prime_cas(il)*fac_ftmr_cas(il).gt.ridicule)
!     :                    then 
                        if ((Eqi_prime_cas(il)-Eqi_stewart(il))
     :                  *fac_ftmr_cas(il).gt.ridicule) then
                        ! il va manquer quelque chose: il faut augmenter
                        ! xtp en lui ajoutant l'vap du niveau d'eau
                        ! dessus
                        ! pour l'instant, on bidouille:

                        if (qp_avantevap_cas(il)+Eqi_stewart(il)
     :                    *fac_ftmr_cas(il).gt.ridicule) then
                        write(*,*) 'appel_stewart_np 2500: il=',il
                        do ixt=1,niso               
                        xtnew(ixt,il)=xtnew(ixt,il)
     :                    *(qp_avantevap_cas(il)
     :                    +Eqi_prime_cas(il)*fac_ftmr_cas(il)) 
     :                    /(qp_avantevap_cas(il)
     :                    +Eqi_stewart(il)*fac_ftmr_cas(il))
                        enddo
                        else
#ifdef ISOVERIF
                          write(*,*) 'appel_stewart_np 2672: on stoppe'
                          stop
#endif                            
                        endif !if ((Eqi_prime_cas(il)-Eqi_stewart(il))

                    endif !if (Eqi_prime_cas(il)*fac_ftmr_cas(il).gt.ridicule)

                    do ixt=1,niso               
                      xtp_cas(ixt,il)=xtnew(ixt,il)
     :                    +(xtp_avantevaptrac_cas(ixt,il) 
     :                   -xtp_avantevap_cas(ixt,il))                  
                    enddo !do ixt=1,niso
#ifdef ISOVERIF
                    if (use_iso_eau.eq.1) then
                      call iso_verif_egalite_choix(
     :               xtp_cas(iso_eau,il),qp_cas(il),
     :               'appel stewart 2643c',errmax,errmaxrel*30)
                    endif !if (use_iso_eau.eq.1) then
#endif                       
                else !if (qp(il,i).gt.0.0) then 
                  do ixt=1,niso               
                    xtp_cas(ixt,il)=0.0
                  enddo !do ixt=1,niso
                endif  !if (qp(il,i).gt.0.0) then 
             endif !if (Eqi_stewart.gt.ridicule) then 

#ifdef ISOVERIFNAN
             do ixt=1,niso
                call iso_verif_noNAN(xtp_cas(ixt,il),
     :                  'appel stewart 684b')
             enddo ! do ixt=1,niso
#endif
#ifdef ISOVERIF
             if (oktrac.eq.0) then
                if (use_iso_eau.eq.1) then
                  if (iso_verif_egalite_choix_nostop(
     :               xtp_cas(iso_eau,il),qp_cas(il),
     :               'appel stewart 688b',errmax,errmaxrel*30)
     :               .eq.1) then
                    write(*,*) 'il=',il
                    write(*,*) 'xtp_avantevaptrac_cas(iso_eau,il)=',
     :                   xtp_avantevaptrac_cas(iso_eau,il)
                    write(*,*) 'qp_avantevap_cas(il)=',
     :                   qp_avantevap_cas(il)
                    write(*,*) 'fac_ftmr_cas(il),Eqi_prime_cas(il)=',
     :                   fac_ftmr_cas(il),Eqi_prime_cas(il)
                    write(*,*) 'Exi_stewart(iso_eau,il),Eqi_stewart=',
     :                   Exi_stewart(iso_eau,il),Eqi_stewart(il)
                    stop
                  endif
               endif !if (use_iso_eau.eq.1) then 
              if ((use_iso_HDO.eq.1).and.
     :           (qp_cas(il).gt.ridicule)) then
                call iso_verif_aberrant(
     :           xtp_cas(iso_HDO,il)/qp_cas(il),
     :           'appel_stewart_np 1384')
              endif  ! if (use_iso_HDO.eq.1) then
            endif ! if (oktrac.eq.0) then
#endif 

          else !if (fac_ftmr.gt.0.0) then
              ! ca veut dire que Mp=0, xtp pas dfinit
             do ixt=1,niso
               xtp_cas(ixt,il)=xtp_avantevaptrac_cas(ixt,il)
             enddo !do ixt=1,niso
         endif !if (fac_ftmr.gt.0.0) then
      else !if (i.lt.INB) then
          ! si i=inb, on ne change rien au calcul original, et on
          ! suppose que la composition du ddft est gale  celle de
          ! l'env. Ceci a dj t calcul plus haut
                  do ixt=1,niso
                    xtp_cas(ixt,il)=xtp_avantevaptrac_cas(ixt,il)
                    !xtp_avantevap(ixt) a dj t dfinit proprement
                    !dans ce cas l
                  enddo
      endif !if (i.lt.INB) then      
      enddo !do il=1,ncas

      ! verif
#ifdef ISOVERIFNAN
        do il=1,ncas
         do ixt=1,niso
         call iso_verif_noNAN(xtp_cas(ixt,il),'appel stewart 198b')
         call iso_verif_noNAN(xtevap_cas(ixt,il),'appel stewart 745b')
         enddo !do ixt=1,niso
        enddo ! do il=1,ncas
#endif
#ifdef ISOVERIF
        if (oktrac.eq.0) then
        if (use_iso_eau.eq.1) then
        do il=1,ncas
        if (iso_verif_egalite_choix_nostop(
     :            xtp_cas(iso_eau,il),
     :            qp_cas(il),
     :           'appel stewart 197b: cas_evap_glace',
     :           errmax,errmaxrel*50).eq.1) then   
          write(*,*) 'i,il=',i,il,' INB(il)=',INB_cas(il)
!     :           ,' cas(il)=',cas_evap_glace(il)
          write(*,*) 'Tevap=',T_cas(il)
          write(*,*) 'xtp(iso_eau,il,i)=',xtp_cas(iso_eau,il)
          write(*,*) 'qp(il,i)=',qp_cas(il)
          write(*,*) 'xtnew(iso_eau)=',xtnew(iso_eau,il)
          write(*,*) 'fac_ftmr=',fac_ftmr_cas(il)
!          write(*,*) 'Mp(il,i)=',Mp(cas_evap_glace(il),i)
          write(*,*) 'xtp_avantevap(iso_eau)=',
     :           xtp_avantevap_cas(iso_eau,il)
          write(*,*) 'qp_avantevap=',qp_avantevap_cas(il)
          write(*,*) 'Exi_stewart(iso_eau)=',Exi_stewart(iso_eau,il)
          write(*,*) 'Eqi_stewart=',Eqi_stewart(il)
!          write(*,*) 'Eqi_prime=',Eqi_prime_cas(il)        
          write(*,*) 'Pxtiinf_stewart(iso_eau)=',
     :            Pxtiinf_stewart(iso_eau,il)
!          write(*,*) 'Pqiinf_par=',Pqiinf_par(cas_evap_glace(il))
          write(*,*) 'Pxtisup(iso_eau)=',Pxtisup_cas(iso_eau,il)
          write(*,*) 'Pqisup=',Pqisup_cas(il)
          stop
         endif !if iso_verif_egalite_choix_nostop
         enddo !do il=1,ncas
        endif
        if (use_iso_HDO.eq.1) then
          do il=1,ncas
            if (qp_cas(il).gt.ridicule) then
                call iso_verif_aberrant(
     :           xtp_cas(iso_HDO,il)/qp_cas(il),
     :           'appel_stewart_np 1449')
            endif !if (qp_cas(il).gt.ridicule) then
          enddo !do il=1,ncas
        endif  ! if (use_iso_HDO.eq.1) then
       endif ! if (oktrac.eq.0) then
!       write(*,*) 'appel_stewart_np 2331: sortie de make_cas_evap_glace'
#endif

      return
      end        
     
#endif
