
#ifdef ISO
      ! subroutines permettant de calculer les flux de surface pour
        ! les isos

        subroutine calcul_iso_surf_oce_vectall(klon, knon,t_coup,
     &    ps,tsurf,q1lay,u1lay, v1lay, xt1lay,dtime,
     &    evap,tsurf_new, Roce,xtevap,h1
#ifdef ISOTRAC
     &    ,bassin_map,knindex
#endif        
     &   )
        implicit none

#include "wateriso2.h"
#include "iso_verif.h" 
#include "YOETHF.h"         
#include "FCTTRE.h"   
#include "YOMCST.h"
        
        ! inputs
        integer klon,knon
        real ps(klon), tsurf(klon), q1lay(klon)
        real u1lay(klon), v1lay(klon)
        real xt1lay(ntraciso,klon)
        real evap(klon)
        real tsurf_new(klon)
        real Roce(niso,klon)
        real dtime
        real T_coup
        ! output
        real xtevap(ntraciso,klon)

        ! locals
        integer ixt
        real VSURF
        real kcin(niso,klon)
        real h1(klon)
        real zqs(klon)
        real R1(niso)
        real Revap(niso)
        real zxtalphal(niso,klon), zxtalphai(niso)        
        integer i
        integer ncas_evap,ncas_noevap,ncas_rosee
        integer cas_evap(klon),cas_noevap(klon),cas_rosee(klon)
        integer icas
        real zxtalphal_tmp
#ifdef ISOVERIF
        real deltaD,O17excess,deltaO
        integer trace_cas(klon)
        integer iso_verif_aberrant_nostop ! juste debug
        integer iso_verif_aberrant_o17_nostop
#endif
#ifdef ISOTRAC
        ! inputs
        integer bassin_map(klon)
        integer knindex(klon)
        ! locals
        integer izone_recoit  
#endif


!#ifdef ISOVERIFIDRIS
!       if (use_iso_HTO.eq.1) then
!        do i=1,knon
!         write(*,*) 'Controle Roce tritium'
!         write(*,*) 'i,knon,Roce(iso_HTO,i)',i,knon,Roce(iso_HTO,i)
!        enddo
!       endif
!#endif

        ! vrif prliminaire
#ifdef ISOVERIF
        write(*,*) 'calcul_iso_surf_oce 41'
        do i=1,knon
          if (use_iso_eau.eq.1) then            
                 call iso_verif_egalite_choix(Roce(iso_eau,i),1.0,
     :                  'calcul_iso_surf_oce 47',errmax,errmaxrel) 
                 call iso_verif_egalite_choix(xt1lay(iso_eau,i),
     :                  q1lay(i),'calcul_iso_surf_oce 69',
     :                  errmax,errmaxrel) 
           endif !if (use_iso_eau.eq.1) then
           if (use_iso_HDO.eq.1) then 
              call iso_verif_positif(deltaD(Roce(iso_HDO,i)),
     :           'calcul_iso_surf_oce 54')
            endif !if (use_iso_eau.eq.1) then      

            call iso_verif_noNaN(Tsurf_new,'calcul_iso_surf_ice 62')
         enddo  
#endif        

         ! parsage des cas
         ncas_evap=0
         ncas_noevap=0
         ncas_rosee=0
         do i=1,knon
          if (evap(i).gt.0.0) then
           ncas_evap=ncas_evap+1
           cas_evap(ncas_evap)=i 
#ifdef ISOVERIF
           trace_cas(i)=1
#endif
          else if (evap(i).eq.0.0) then
           ncas_noevap=ncas_noevap+1
           cas_noevap(ncas_noevap)=i
#ifdef ISOVERIF
           trace_cas(i)=2
#endif           
          else
           ncas_rosee=ncas_rosee+1
           cas_rosee(ncas_rosee)=i
#ifdef ISOVERIF
           trace_cas(i)=3
#endif           
          endif          
         enddo !do i=1,knon

         ! traitement vectoriel du cas d'vaporation
         do icas=1,ncas_evap
            i=cas_evap(icas)
            if (tsurf(i).lt.t_coup) then
             zqs(i)=qsats(tsurf(i))/ps(i)
#ifdef ISOVERIF             
             call iso_verif_positif(zqs(i),'calcul_iso_surf 183')
             call iso_verif_positif(0.1-zqs(i),'calcul_iso_surf 184')
#endif             
           else
             zqs(i)=qsatl(tsurf(i))/ps(i)
#ifdef ISOVERIF             
             call iso_verif_positif(zqs(i),'calcul_iso_surf 187')
             call iso_verif_positif(0.1-zqs(i),'calcul_iso_surf 188')
#endif             
           endif       
           h1(i)=q1lay(i)/zqs(i)
           h1(i)=min(1.0,max(0.0,h1(i)))
           if (cste_surf_cond.eq.2) then
               ! on suppose la temprature de surface constante dans le
               ! calcul des coefs de frac, pour faire un test de
               ! sensibilit
            do ixt=1,niso
              call fractcalk_liq(ixt,T_cste_surf_cond,
     :                   zxtalphal(ixt,i)) 
            enddo
           else !if (cste_surf_cond.eq.2) then
            do ixt=1,niso
              call fractcalk_liq(ixt,Tsurf_new(i),
     :                   zxtalphal(ixt,i)) 
            enddo
           endif !if (cste_surf_cond.eq.2) then
            if (q1lay(i).gt.0.0) then
              do ixt=1,niso  
                R1(ixt)=xt1lay(ixt,i)/q1lay(i)
              enddo
            else
#ifdef ISOVERIF
                write(*,*) 'calcul_iso_surf 124: q1lay=',q1lay(i)
                stop
#endif
                do ixt=1,niso  
                  R1(ixt)=Rdefault(ixt)           
                enddo                
            endif
          VSURF=sqrt(u1lay(i)**2+v1lay(i)**2)
          call calcul_kcin(vsurf,kcin(1,i))   
          if (cste_surf_cond.eq.0) then
            if (h1(i).lt.0.98) then              
              do ixt=1,niso
                xtevap(ixt,i)=evap(i)*
     :           (Roce(ixt,i)/zxtalphal(ixt,i)-h1(i)*R1(ixt))
     :           /(1.0-h1(i))*(1.0-kcin(ixt,i))
               enddo !do ixt=1,niso
            else !if (h1(i).lt.0.98) then
              do ixt=1,niso
                xtevap(ixt,i)=evap(i)*Roce(ixt,i)/zxtalphal(ixt,i)
              enddo
            endif !if (h1(i).lt.0.98) then
          else !if (cste_surf_cond.eq.0) then
              do ixt=1,niso
                xtevap(ixt,i)=evap(i)*
     :           (Roce(ixt,i)/zxtalphal(ixt,i)
     :           -rh_cste_surf_cond*R1(ixt))
     :           /(1.0-rh_cste_surf_cond)*(1.0-kcin(ixt,i))
              enddo !do ixt=1,niso
          endif !if (cste_surf_cond.eq.0) then

#ifdef ISOTRAC
          if ((option_traceurs.eq.3).or.
     :           (option_traceurs.eq.20)) then 
             izone_recoit=bassin_map(knindex(i))
         else
             izone_recoit=izone_oce 
          endif     

          do ixt=niso+1,ntraciso
            if (index_zone(ixt).eq.izone_recoit) then
               xtevap(ixt,i)=xtevap(index_iso(ixt),i)
            else
               xtevap(ixt,i)=0.0
            endif
          enddo   !do ixt=niso+1,ntraciso        
#endif          

#ifdef ISOVERIFNAN
         do ixt=1,ntraciso
           call iso_verif_noNAN(xtevap(ixt,i),
     :           'calcul_iso_surf_oce 3038, sur ocan')
         enddo       
#endif          
#ifdef ISOVERIF
          if (use_iso_eau.eq.1) then
              call iso_verif_egalite_choix(xtevap(iso_eau,i),evap(i),
     :           'calcul_iso_surf_oce 3309: sur ocean',
     :            errmax,errmaxrel)
          endif !if (use_iso_eau.eq.1) then
          if (use_iso_HDO.eq.1) then    
           if (abs(evap(i)).gt.ridicule_evap) then
             if (iso_verif_aberrant_nostop(xtevap(iso_HDO,i)/evap(i),
     :           'calcul_iso_surf_oce 3308: sur ocean').eq.1) then
               write(*,*) 'h1(i),kcin(iso_HDO,i)=',h1(i),kcin(iso_HDO,i)
               write(*,*) 'deltaD(R1)=',deltaD(R1(iso_HDO))
               write(*,*) 'deltaD(Roce/alpha)=',
     :               deltaD(Roce(iso_HDO,i)/zxtalphal(iso_HDO,i))
               ! si deltaD vap trs faible, c'est normale d'avoir deltaD
               ! trs fort dans l'vap
               if ((evap(i).gt.faible_evap).and.
     :                   (deltaD(R1(iso_HDO)).gt.deltaDfaible)) then
                 stop
               endif
             endif
           endif !if (abs(evap(i)).gt.ridicule_evap) then
           if ((xtevap(iso_HDO,i)/evap(i).lt.R1(iso_HDO)-20.0)
     :           .and.(evap(i).gt.ridicule_evap)) then
               write(*,*) 'calcul_iso_surf_oce 106, i=',i
               write(*,*) 'deltaDevap=',
     :           deltaD(xtevap(iso_HDO,i)/evap(i))
               write(*,*) 'deltaDv1=',deltaD(R1(iso_HDO))
               write(*,*) 'Tsurf, kcin(iso_HDO,i)=',Tsurf_new(i)-273.5, 
     :                   kcin(iso_HDO,i)
               write(*,*) 'deltaD(Roce/alpha)=',
     :                   deltaD(Roce(iso_HDO,i)/zxtalphal(iso_HDO,i))
               write(*,*) 'h1(i),evap(i)=',h1(i),evap(i)
               stop
           endif ! if (xtevap(iso_HDO,i)/evap(i).lt.R1(iso_HDO)) then
          endif  !if (use_iso_HDO.eq.1) then 
          if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
            if (abs(evap(i)).gt.ridicule_evap) then
                if (iso_verif_aberrant_o17_nostop(xtevap(iso_O17,i)
     :           /evap(i),xtevap(iso_O18,i)
     :           /evap(i),'calcul_iso_surf > oce 232').eq.1) then
                  write(*,*) 'deltaO18,O17excess v1=',deltaO(
     :                   R1(iso_O18)),O17excess(
     :                   R1(iso_O17),R1(iso_O18))
                  write(*,*) 'Tsurf, kcin(iso_O17,i)=',
     :                   Tsurf_new(i)-273.5, kcin(iso_O17,i)
                  write(*,*) 'deltaO18,O17excess(Roce/alpha)=',
     :                   deltaO(Roce(iso_O18,i)/zxtalphal(iso_O18,i)),
     :                   O17excess(Roce(iso_O17,i)/zxtalphal(iso_O17,i),
     :                           Roce(iso_O18,i)/zxtalphal(iso_O18,i))
                  write(*,*) 'h1(i),evap(i)=',h1(i),evap(i)
                  if (xtevap(iso_O18,i)/evap(i).lt.tnat(iso_O18)) then
                     stop
                  endif
                endif !if (iso_verif_aberrant_o17_nostop(xtevap(iso_O17,i)
            endif !if (abs(evap(i)).gt.ridicule_evap) then
          endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
#ifdef ISOTRAC
          call iso_verif_traceur_justmass(xtevap(1,i),
     :           'calcul_iso_surf_oce 213')
#endif          
#endif

         enddo !do icas_evap=1,ncas_evap

        ! traitement vectoriel du cas pas d'vap
        do icas=1,ncas_noevap
          i=cas_noevap(icas)
          do ixt=1,ntraciso
            xtevap(ixt,i)=0.0
          enddo !do ixt=1,niso
        enddo !do icas_evap=1,ncas_evap

        ! traitement vectoriel du cas rose
        do icas=1,ncas_rosee
          i=cas_rosee(icas)          
          call iso_rosee_givre(xt1lay,q1lay,Tsurf_new,t_coup,evap,i, 
     :            xtevap,klon)
          ! traceurs d'eau et d'isos mis directement dans iso_rosee_givre      
        enddo !do icas_evap=1,ncas_evap
        
        

#ifdef ISOVERIF
        do i=1,knon
           if (use_iso_eau.eq.1) then  
              call iso_verif_egalite_choix(xtevap(iso_eau,i),evap(i),
     :                  'calcul_iso_surf_oce 115',errmax,errmaxrel)
           endif !if (use_iso_eau.eq.1) then
           if (use_iso_HDO.eq.1) then  
              if (evap(i).gt.ridicule_evap) then 
                if (deltaD(R1(iso_HDO)).gt.200.0) then   
                call iso_verif_aberrant(xtevap(iso_HDO,i)/evap(i),
     :                  'calcul_iso_surf_oce 119')
                endif
              endif  !if (evap.gt.ridicule_evap) then   
           endif !if (use_iso_eau.eq.1) then
        enddo !do i=1,knon
!        write(*,*) 'calcul_iso_surf 274: stop temporaire'
!        stop
#endif


        return
        end ! subroutine calcul_iso_surf_oce

        !*****************************


        subroutine calcul_iso_surf_sic_vectall(klon,knon, 
     :           evap,snow_evap,Tsurf_new,Roce,snow, 
     :           fqfonte_neige,dtime, t_coup,
     :           precip_snow,xtprecip_snow, snow_prec,xtsnow_prec, 
     :           xt1lay,q1lay,ps,  
     :           xtevap,xtsnow,fqcalving
#ifdef ISOTRAC
     &    ,bassin_map,knindex
#endif        
     &   )
        implicit none

#include "wateriso2.h"
#include "iso_verif.h"        
        ! inputs
        integer klon,knon
        real snow(klon),snow_prec(klon)
        real xtsnow(niso,klon),xtsnow_prec(niso,klon)
        real precip_snow(klon),xtprecip_snow(ntraciso,klon)
        real evap(klon), snow_evap(klon)
        real fqfonte_neige(klon)
        real xt1lay(ntraciso,klon),ps(klon),q1lay(klon)
        real tsurf_new(klon)
        real Roce(niso,klon)
        real dtime
        real t_coup
        real fqcalving(klon)
        ! output
        real xtevap(ntraciso,klon)

        ! locals
        real fxtfonte_neige(niso,klon)
!        real zxtalphals
        real sol_evap(klon)
        real xtsol_evap(ntraciso,klon)
        real xtsnow_evap(ntraciso,klon)
        integer i,ixt
        integer ncas_evap,ncas_noevap,ncas_rosee
        integer cas_evap(klon),cas_noevap(klon),cas_rosee(klon)
        integer icas        
#ifdef ISOVERIF
        real deltaD
        integer trace_cas(klon)
        integer iso_verif_egalite_nostop
#endif        
#ifdef ISOTRAC
        ! inputs
        integer bassin_map(klon)
        integer knindex(klon)
        ! locals
        integer izone_recoit
#endif   

#ifdef ISOVERIF
        write(*,*) 'calcul_iso_surf_sic 175: entree'
#endif  
#ifdef ISOVERIFNAN
        do i=1,knon
         do ixt=1,ntraciso
           call iso_verif_noNaN(xtprecip_snow(ixt,i),
     :           'calcul_iso_surf 365')
         enddo
        enddo
#endif        
        ! gestion de la neige
        call gestion_neige(klon,knon,snow,xtsnow,
     :           snow_prec,xtsnow_prec,dtime,
     :           precip_snow,xtprecip_snow,fqfonte_neige,
     :           fqcalving,snow_evap,xtsnow_evap,fxtfonte_neige,
     :           xt1lay,q1lay,Tsurf_new,t_coup) 


#ifdef ISOVERIF
       if (use_iso_eau.eq.1) then  
        do i=1,knon
          call iso_verif_egalite_choix(xtsnow(iso_eau,i),snow(i), 
     &         'calcul_iso_surf_sic_vectall 363',errmax,errmaxrel)
        enddo
      endif
#endif             

      ! les traceurs d'isotopes sont dj dans gestion neige
      ! on suppose que l'vaporation de la neige est tagge "continent"
      ! en fait, il n'y a pas de neige sur sea-ice de toutes faon.
        
       do i=1,knon  
         sol_evap(i)=evap(i)-snow_evap(i)
       enddo !do i=1,knon  

        ! parsage des cas
         ncas_evap=0
         ncas_noevap=0
         ncas_rosee=0
         do i=1,knon
         ! modif 2 octobre 2008
         ! c'est sol_evap plutot que evap
!          if (evap(i).gt.0.0) then
         if (sol_evap(i).gt.0.0) then
           ncas_evap=ncas_evap+1
           cas_evap(ncas_evap)=i 
#ifdef ISOVERIF
           trace_cas(i)=1
#endif
          else if (sol_evap(i).eq.0.0) then
           ncas_noevap=ncas_noevap+1
           cas_noevap(ncas_noevap)=i
#ifdef ISOVERIF
           trace_cas(i)=2
#endif           
          else
           ncas_rosee=ncas_rosee+1
           cas_rosee(ncas_rosee)=i
#ifdef ISOVERIF
           trace_cas(i)=3
#endif           
          endif          
         enddo !do i=1,knon
   

        ! traitement vectoriel du cas d'vaporation
         do icas=1,ncas_evap
            i=cas_evap(icas)   
            do ixt=1,niso       
!          call fractcalk_liq_sol(ixt,tsurf_new(i),zxtalphals)
!             xtsol_evap(ixt,i)=sol_evap(i)*Roce(ixt,i)
!     :           *alpha_liq_sol(ixt)
            ! non car Roce n'est lu que sur les ocans et par sur les
            ! zones de sea ice
               xtsol_evap(ixt,i)=sol_evap(i)*tcorr(ixt)*toce(ixt)
     :           *alpha_liq_sol(ixt) 
            enddo !do ixt=1,niso 

#ifdef ISOTRAC
          if (option_traceurs.eq.3) then  
            izone_recoit=izone_poubelle
          else if (option_traceurs.eq.3) then  
              izone_recoit=bassin_map(knindex(i))
          else
            izone_recoit=izone_oce
          endif            

          do ixt=niso+1,ntraciso
            if (index_zone(ixt).eq.izone_recoit) then
             xtsol_evap(ixt,i)=xtsol_evap(index_iso(ixt),i)
            else
                xtsol_evap(ixt,i)=0.0
            endif
          enddo

#endif            
#ifdef ISOVERIF
          if (use_iso_HDO.eq.1) then
              if (deltaD(xtsol_evap(iso_HDO,i)/sol_evap(i)).lt.0.0) then
                write(*,*) 'calcul_iso_surf_lic 255'
                write(*,*) 'sol_evap(i),xtsol_evap(iso_HDO,i)=',
     :               sol_evap(i),xtsol_evap(iso_HDO,i) 
                stop  
              endif
              call iso_verif_egalite_choix(deltaD
     :          (xtsol_evap(iso_HDO,i)/sol_evap(i)),25.2847,
     :           'calcul_iso_surf_sic 398',0.5,0.5)
          endif
#endif 
#ifdef ISOVERIFNAN
         do ixt=1,niso
          call iso_verif_noNaN(xtsol_evap(ixt,i),
     :           'calcul_iso_surf_lic 142')
         enddo !do ixt=1,niso
#endif          
        enddo !!do icas_evap=1,ncas_evap


        ! traitement vectoriel du cas pas d'vap
!#ifdef ISOVERIF
!        write(*,*) 'calcul_iso_surf_sic 455: pas d''evap'
!#endif
        do icas=1,ncas_noevap
          i=cas_noevap(icas)
          do ixt=1,ntraciso
          xtsol_evap(ixt,i)=0.0
          enddo !do ixt=1,niso
        enddo !do icas_evap=1,ncas_evap

        ! traitement vectoriel du cas rose
!#ifdef ISOVERIF
!        write(*,*) 'calcul_iso_surf_sic 465: cas rosee'
!#endif
        do icas=1,ncas_rosee
          i=cas_rosee(icas)         
        ! evap<0 -> on condense.
        !write(*,*) 'calcul_iso_surf_oce 3176: on condense: evap(i)=',evap(i)
          call iso_rosee_givre(xt1lay,q1lay,Tsurf_new,
     :            t_coup,sol_evap,i,xtsol_evap,klon) 
#ifdef ISOVERIF  
        if (use_iso_HDO.eq.1) then
            call iso_verif_aberrant_choix(-xtsol_evap(iso_HDO,i),
     :           sol_evap(i),ridicule_evap,deltalim,
     :           'calcul_iso_surf_sic 257')
        endif
#endif            
          
        enddo !do icas=1,ncas_rosee

        do i=1,knon
          do ixt=1,ntraciso
            xtevap(ixt,i)=xtsol_evap(ixt,i)+xtsnow_evap(ixt,i)
          enddo !do ixt=1,niso
        enddo

        ! verif
#ifdef ISOVERIF
        do i=1,knon
              if (use_iso_eau.eq.1) then  
                 call iso_verif_egalite_choix(xtevap(iso_eau,i),evap(i),
     :                  'calcul_iso_surf_sic 248',errmax,errmaxrel)
              endif !if (use_iso_eau.eq.1) then
              if (use_iso_HDO.eq.1) then
                if (evap(i).gt.ridicule_evap) then  
                   call iso_verif_aberrant(xtevap(iso_HDO,i)/evap(i),
     :                  'calcul_iso_surf_sic 257')
               endif !if (evap(i).gt.ridicule_evap) then  
              endif !if (use_iso_eau.eq.1) then
#ifdef ISOTRAC
           call iso_verif_tracnps(xtevap(1,i),
     :          'calcul_iso_surf_sic 431')
#endif              
           enddo  
!        write(*,*) 'calcul_iso_surf_sic 507: sortie'    
#endif   
           ! end verif


      return
      end !subroutine calcul_iso_surf_sic


      !*****************************


        subroutine calcul_iso_surf_lic_vectall(klon,knon, 
     :           evap,snow_evap,Tsurf_new,snow, 
     :           fqfonte_neige,dtime, t_coup, 
     :           precip_snow,xtprecip_snow, snow_prec,xtsnow_prec, 
     :           xt1lay,q1lay,ps,Rland_ice,run_off_lic_0,
     :           xtevap,xtsnow,xtrun_off_lic_0,fqcalving,knindex
#ifdef ISOTRAC
     &    ,bassin_map
#endif        
     &   )
        implicit none

#include "wateriso2.h"
#include "iso_verif.h"        
        ! inputs
        integer klon,knon
        real snow(klon),snow_prec(klon)
        real xtsnow(niso,klon),xtsnow_prec(niso,klon)
        real precip_snow(klon),xtprecip_snow(ntraciso,klon)
        real evap(klon), snow_evap(klon)
        real fqfonte_neige(klon)
        real xt1lay(ntraciso,klon),ps(klon),q1lay(klon)
        real tsurf_new(klon)
        real Rland_ice(niso,klon)
        real run_off_lic_0(klon)
        real dtime
        real t_coup
        real fqcalving(klon)
        integer knindex(klon)
        ! output
        real xtevap(ntraciso,klon)
        real xtrun_off_lic_0(niso,klon)

        ! locals
        real fxtfonte_neige(niso,klon)
        real sol_evap(klon)
        real xtsol_evap(ntraciso,klon)
        real xtsnow_evap(ntraciso,klon)
        integer i,ixt,j
        integer ncas_evap,ncas_noevap,ncas_rosee
        integer cas_evap(klon),cas_noevap(klon),cas_rosee(klon)
        integer icas
#ifdef ISOVERIF        
        integer trace_cas(klon)
        real deltaD 
        integer iso_verif_positif_strict_nostop
        real Rland_ice_prec(niso,klon)
        integer iso_verif_egalite_choix_nostop
#endif
#ifdef ISOTRAC
        ! inputs
        integer bassin_map(klon)
        ! locals
        integer izone_recoit
#endif        
!        real mair ! masse d'air en kg concerne par rose

!#ifdef ISOVERIF
!        write(*,*) 'calcul_iso_surf_lic 306'
!#endif
#ifdef ISOVERIFNAN
        do i=1,knon
         do ixt=1,ntraciso
           call iso_verif_noNaN(xtprecip_snow(ixt,i),
     :           'calcul_iso_surf 609')
         enddo
        enddo
#endif   
        ! initialisation:
        xtevap=0.
        xtrun_off_lic_0=0.

! gestion de la neige
        call gestion_neige(klon,knon,snow,xtsnow,
     :           snow_prec,xtsnow_prec,dtime,
     :           precip_snow,xtprecip_snow,fqfonte_neige,
     :           fqcalving,snow_evap,xtsnow_evap,fxtfonte_neige,
     :           xt1lay,q1lay,Tsurf_new,t_coup)
        ! les traceurs d'isotopes sont dj dans gestion neige
      ! on suppose que l'vaporation de la neige est tagge "continent"

        ! on incorpore la composition neige  celle du glacier
        ! on suppose que l'paisseur caractristique du glacier est hland_ice
       do i=1,knon
#ifdef ISOVERIF
        do ixt=1,niso
          Rland_ice_prec(ixt,i)=Rland_ice(ixt,i)
        enddo !do ixt=1,niso
#endif        
        if (precip_snow(i).gt.ridicule) then
           do ixt=1,niso
              Rland_ice(ixt,i)=(h_land_ice*Rland_ice(ixt,i)
     :           +xtprecip_snow(ixt,i)*dtime)/
     :           (h_land_ice+precip_snow(i)*dtime)
           enddo     
        endif
        enddo !do i=1,knon

#ifdef ISOVERIF     
        ! vrifier que Rland_ice a bien t modifi. A l'tat initiale,
            ! Rland_ice vaut -150 permil pour le deltaD
        if (use_iso_hdo.eq.1) then
        do i=1,knon        
        if (precip_snow(i).gt.1e-5) then
           if (abs(deltaD(xtprecip_snow(iso_hdo,i)/precip_snow(i))
     :                   +150).gt.5.0) then
           if (iso_verif_positif_strict_nostop
     :           (abs(deltaD(Rland_ice(iso_hdo,i))+150.0) 
     :         -1e-6,'calcul_iso_surf_lic 565').eq.1) then
              write(*,*) 'calcul_iso_surf_lic 575 tmp: i=',i
              write(*,*) 'h_land_ice,precip_snow(i)*dtime=' ,
     :             h_land_ice,precip_snow(i)*dtime
              write(*,*) 'deltaDsnow=',deltaD(xtprecip_snow(iso_hdo,i)
     :                   /precip_snow(i))
              write(*,*) 'deltaDland_ice=',deltaD(Rland_ice(iso_hdo,i))
              write(*,*) 'deltaDland_ice_prec=',deltaD(
     :           Rland_ice_prec(iso_hdo,i))
!             stop
           endif
           endif
        endif !if (precip_snow(i).gt.0.0) then        
        enddo !do i=1,knon
        endif !if (use_iso_hdo.eq.1) then
        
        if (use_iso_eau.eq.1) then  
        do i=1,knon
          call iso_verif_egalite_choix(xtsnow(iso_eau,i),snow(i), 
     &         'calcul_iso_surf_lic_vectall 587',errmax,errmaxrel)
        enddo
        endif
#endif             
        
       do i=1,knon  
         sol_evap(i)=evap(i)-snow_evap(i)
       enddo !do i=1,knon   

      ! vaporation du sol

        ! parsage des cas
         ncas_evap=0
         ncas_noevap=0
         ncas_rosee=0
         do i=1,knon
!          if (evap(i).gt.0.0) then
           if (sol_evap(i).gt.0.0) then
               ! modif le 2 octobre 2008: c'est le signe de sol_evap qui
               ! doit tre important ici
           ncas_evap=ncas_evap+1
           cas_evap(ncas_evap)=i 
#ifdef ISOVERIF
           trace_cas(i)=1
#endif
!          else if (evap(i).eq.0.0) then
           else if (sol_evap(i).eq.0.0) then
           ncas_noevap=ncas_noevap+1
           cas_noevap(ncas_noevap)=i
#ifdef ISOVERIF
           trace_cas(i)=2
#endif           
          else
           ncas_rosee=ncas_rosee+1
           cas_rosee(ncas_rosee)=i
#ifdef ISOVERIF
           trace_cas(i)=3
#endif           
          endif          
         enddo !do i=1,knon


        ! traitement vectoriel du cas d'vaporation
         do icas=1,ncas_evap
            i=cas_evap(icas)  
              
#ifdef ISOVERIF
              if (use_iso_eau.eq.1) then  
               call iso_verif_egalite_choix(Rland_ice(iso_eau,i),1.0,
     :                  'calcul_iso_surf_lic 740',errmax,errmaxrel)
              endif !if (use_iso_eau.eq.1) then  
#endif
          do ixt=1,niso       
            xtsol_evap(ixt,i)=sol_evap(i)*Rland_ice(ixt,i)   
          enddo !do ixt=1,niso  

#ifdef ISOTRAC
        if (option_traceurs.eq.20) then
            izone_recoit=bassin_map(knindex(i))
        else
            izone_recoit=izone_cont
        endif

        do ixt=niso+1,ntraciso
            if (index_zone(ixt).eq.izone_recoit) then
               xtsol_evap(ixt,i)=xtsol_evap(index_iso(ixt),i)
            else
               xtsol_evap(ixt,i)=0.0
            endif
        enddo 
#endif          

#ifdef ISOVERIF
              if (use_iso_eau.eq.1) then  
               call iso_verif_egalite_choix(sol_evap(i),
     :           xtsol_evap(iso_eau,i),
     :           'calcul_iso_surf_lic 365',errmax,errmaxrel)
              endif !if (use_iso_eau.eq.1) then  
#endif 

        enddo !!do icas_evap=1,ncas_evap


        ! traitement vectoriel du cas pas d'vap
        do icas=1,ncas_noevap
          i=cas_noevap(icas)
          do ixt=1,ntraciso
            xtsol_evap(ixt,i)=0.0
          enddo !do ixt=1,niso

        enddo !do icas_evap=1,ncas_evap

        ! traitement vectoriel du cas rose
        do icas=1,ncas_rosee
          i=cas_rosee(icas)        
        ! evap<0 -> on condense.
        !write(*,*) 'calcul_iso_surf_oce 3176: on condense: evap(i)=',evap(i)
!        write(*,*) 'calcul_iso_surf_lic 391: dtime=',dtime
!          Mair=100*100/9.8
          call iso_rosee_givre(xt1lay,q1lay,Tsurf_new,t_coup,sol_evap,i,
     :            xtsol_evap,klon) 

#ifdef ISOVERIF
              if (use_iso_eau.eq.1) then  
               call iso_verif_egalite_choix(sol_evap(i),
     :           xtsol_evap(iso_eau,i),
     :           'calcul_iso_surf_lic 365',errmax,errmaxrel)
              endif !if (use_iso_eau.eq.1) then
              if (use_iso_HDO.eq.1) then 
                  call iso_verif_aberrant_choix(-xtsol_evap(iso_hdo,i),
     :             -sol_evap(i),ridicule_evap,deltalim,
     :              'calcul_iso_surf_lic 747')
              endif !if (use_iso_eau.eq.1) then  
#endif   
        enddo  !do icas=1,ncas_rosee

        ! fin du calcul de xtsol_evap

        do i=1,knon
         do ixt=1,ntraciso
           xtevap(ixt,i)=xtsol_evap(ixt,i)+xtsnow_evap(ixt,i)
         enddo
        enddo !do i=1,knon
        do i=1,knon
        j = knindex(i)
         do ixt=1,niso
           xtrun_off_lic_0(ixt,j)=run_off_lic_0(j)*Rland_ice(ixt,i) ! peu importe
         enddo !do ixt=1,niso
#ifdef ISOVERIF
        if (use_iso_eau.eq.1) then  
         if ((j.eq.291).or.(j.eq.231).or.(j.eq.418).or.
     :                 (j.eq.38).or.(j.eq.60)) then
           write(*,*) 'calcul_iso_surf 776 tmp: i,j,klon,knon,',
     :           'run_off_lic_0,xt=',i,j,klon,knon,      
     :           run_off_lic_0(j),xtrun_off_lic_0(iso_eau,j)
         endif
        endif
#endif
        enddo !do i=1,knon

        ! verif
#ifdef ISOVERIF
        do i=1,knon
              if (use_iso_eau.eq.1) then  
                 call iso_verif_egalite_choix(evap(i),xtevap(iso_eau,i),
     :                  'calcul_iso_surf_lic 361',errmax,errmaxrel)
                 call iso_verif_egalite_choix(snow(i),xtsnow(iso_eau,i),
     :                  'calcul_iso_surf_lic 363',errmax,errmaxrel)  
              endif !if (use_iso_eau.eq.1) then
              if (use_iso_HDO.eq.1) then  
                if (snow(i).gt.ridicule_snow) then  
                 call iso_verif_aberrant(xtsnow(iso_HDO,i)/snow(i),
     :                  'calcul_iso_surf_lic 367')
                endif !if (snow(i).gt.ridicule_snow) then 
                call iso_verif_aberrant_choix(xtsnow(iso_HDO,i),
     :               snow(i),ridicule,deltalim_snow,
     :               'calcul_iso_surf_lic 797') 
                if (abs(evap(i)).gt.ridicule_evap) then  
                 call iso_verif_aberrant(xtevap(iso_HDO,i)/evap(i),
     :                  'calcul_iso_surf_lic 369')
                endif ! if (evap(i).gt.ridicule_evap) then 
              endif !if (use_iso_eau.eq.1) then
#ifdef ISOTRAC
           call iso_verif_tracnps(xtevap(1,i),
     :          'calcul_iso_surf_lic 723')
#endif               
          enddo !do i=1,knon 
          if (use_iso_eau.eq.1) then  
            do i=1,klon 
             if (iso_verif_egalite_choix_nostop(run_off_lic_0(i),
     :         xtrun_off_lic_0(iso_eau,i),'calcul_iso_surf_lic 783',
     :         errmax,errmaxrel).eq.1) then
               write(*,*) 'i,knon,klon=',i,knon,klon
               stop
             endif
            enddo !do i=1,klon 
          endif ! if (use_iso_eau.eq.1) then 
#endif


        return
        end !subroutine calcul_iso_surf_lic



!*****************************


        subroutine calcul_iso_surf_ter_vectall(klon,knon, 
     :           evap,snow_evap,Tsurf_new,snow, 
     :           fqfonte_neige,dtime, precip_rain,xtprecip_rain,
     :           precip_snow,xtprecip_snow, snow_prec,xtsnow_prec, 
     :           tsurf,xt1lay,ps,q1lay,t_coup,u1lay,v1lay,p1lay,
     :           qsol,xtsol,qsol_prec,xtsol_prec,P_vegetation,
     :           max_eau_sol,           
     :           xtevap,xtsnow,h1,run_off,xtrun_off,fqcalving
#ifdef ISOTRAC
     &    ,bassin_map,knindex
#endif        
     &   )
        implicit none

#include "wateriso2.h"
#include "iso_verif.h"
#include "YOETHF.h" 
#include "FCTTRE.h"   
#include "YOMCST.h"
#include "dimensions.h"
#include "paramet.h"
        
        ! inputs
        integer klon,knon
        real snow(klon),snow_prec(klon)
        real xtsnow(niso,klon),xtsnow_prec(niso,klon)
        real precip_snow(klon),xtprecip_snow(ntraciso,klon)
        real precip_rain(klon),xtprecip_rain(ntraciso,klon)
        real qsol(klon),qsol_prec(klon) ! hauteur d'eau, en mm.
        real xtsol(niso,klon),xtsol_prec(niso,klon)
        real evap(klon), snow_evap(klon)
        real fqfonte_neige(klon)
        real xt1lay(ntraciso,klon),q1lay(klon)
        real u1lay(klon),v1lay(klon)
        real p1lay(klon)
        real ps(klon),tsurf(klon)
        real tsurf_new(klon)
        real dtime
        real t_coup
        real P_vegetation(klon)
        real max_eau_sol
        real run_off(klon)
        real fqcalving(klon)
        ! output
        real xtevap(ntraciso,klon)
        real xtrun_off(niso,klon)     

        ! locals
        real sol_evap(klon)
        real xtsol_evap(ntraciso,klon)
        real xtnu(niso,klon)
        real L
        real xtsnow_evap(ntraciso,klon)
        double precision qsol_avant_evap(klon),
     :          xtsol_avant_evap(niso,klon)
        real fxtfonte_neige(niso,klon)
        real VSURF
        real kcin(niso)
        real alphak(niso)
        real fxtcalving(niso,klon)
!        integer alphak_stewart
!        parameter (alphak_stewart=1)
                ! si 1: alphak=(D/Diso)^nsol
                ! si 0: alphak=1/(1-kcin(vsurf))
             ! 31 aout: ce param est maintenant dans wateriso
!        real tdifexp_sol
!        parameter (tdifexp_sol=0.8)
                ! tdifexp_sol est l'exposant de D/Diso. Il paramtrise
                ! la turbulence. D'abitude, il est de 0.58. Mais d'aprs
                ! Mathieu et Bariac, il est entre 0.67 et 1: 0.67 pour
                ! les sols secs et 1 pour les sols saturs.
               ! 31 aout: ce param est maintenant dans wateriso 
        real h1(klon)
        real zqs(klon)
        real R1(niso)
        real Revap(niso)
        real zxtalphal(niso), zxtalphai(niso)        
        real qevap(klon)
        real q10 ! humidit 1re couche en mm
        real rowl ! densit eau en kg/m3
        parameter (rowl=1000.0)
        real Pveg
        integer i,ixt,j
        real Rsol_new(niso), Rsol(niso)
        double precision qsol_avant_deversement(klon)

        ! qu'est-ce qui ruisselle?
!        integer ruissellement_pluie
!        parameter (ruissellement_pluie=0)
                ! si 1: c'est la pluie qui ruisselle. elle ne s'infiltre
                ! donc jamais dans un sol satur.
                ! si 0: c'est le sol qui ruisselle. La pluie s'inglitre
                ! donc dans le sol satur.
           ! 31 aout: ce param est maintenant dans wateriso    
        double precision precip_rain_eff(klon),fqfonte_neige_eff(klon)
        double precision sol_evap_eff(klon)
        double precision xtsol_evap_eff(niso,klon)
        double precision xtprecip_rain_eff(niso,klon),
     :          fxtfonte_neige_eff(niso,klon)
        integer ncas_evap,ncas_noevap,ncas_rosee
        integer cas_evap(klon),cas_noevap(klon),cas_rosee(klon)
        integer icas
        real runoff_tmp(knon)
        real double_to_real
#ifdef ISOVERIF
        integer trace_cas(klon)
        integer iso_verif_aberrant_nostop ! juste debug
        integer iso_verif_aberrant_O17_nostop ! juste debug
        integer iso_verif_aberrant_choix_nostop
        integer iso_verif_egalite_choix_nostop
        integer iso_verif_positif_nostop
        integer iso_verif_egalite_nostop
        integer iso_verif_positif_choix_nostop
        real deltaD,o17excess
        real dqdiag
#endif       
#ifdef ISOVERIFNAN
        integer iso_verif_noNaN_nostop
#endif       
#ifdef ISOTRAC
        ! inputs
        integer bassin_map(klon)
        integer knindex(klon)
        ! locals   
        integer izone_recoit
#endif

        ! variables pour sortie grads
        integer indiso
        real chp2d(iip1,jjp1)
        real qsol_phys(klon),qsol_prec_phys(klon),
     :        qsol_avant_evap_phys(klon),evap_phys(klon),
     :        snow_evap_phys(klon),sol_evap_phys(klon),
     :        fqfonte_phys(klon),precip_rain_phys(klon),
     :        xtsol2(klon),xtsol4(klon),xtsol_prec2(klon),
     :        xtsol_prec4(klon),xtsol_avant_evap2(klon),
     :        xtsol_avant_evap4(klon),xtsol_evap2(klon),         
     :        xtsol_evap4(klon),xtevap4(klon),xtevap2(klon),        
     :        xtsnow_evap4(klon),xtsnow_evap2(klon),fxtfonte2(klon),
     :        fxtfonte4(klon),xtprecip_rain2(klon),xtprecip_rain4(klon),
     :        xtnu2(klon),xtnu4(klon),
     :        xt1lay2(klon),xt1lay4(klon), h1_phys(klon),
     :        tsurf_phys(klon), qsat_phys(klon),
     :        xtsol_evap2_pos(klon), xtsol_evap4_pos(klon),
     :        xtsol_evap2_neg(klon), xtsol_evap4_neg(klon)      

       
#ifdef ISOVERIF   
!      write(*,*) 'calcul_iso_surf_ter 494'
      do i=1,knon         
        if (use_iso_eau.eq.1) then  
           call iso_verif_egalite_choix(
     :               xtsnow_prec(iso_eau,i),
     :               snow_prec(i),'calcul_iso_surf_ter 1019',
     :               errmax,errmaxrel)
           call iso_verif_egalite_choix(
     :               xtprecip_snow(iso_eau,i),
     :               precip_snow(i),'calcul_iso_surf_ter 1023',
     :               errmax,errmaxrel)
        endif !if (use_iso_eau.eq.1) then
       enddo
#endif    
#ifdef ISOVERIFNAN
        do i=1,knon
         do ixt=1,ntraciso
           call iso_verif_noNaN(xtprecip_snow(ixt,i),
     :           'calcul_iso_surf 1025')
         enddo
        enddo
#endif   

        ! gestion de la neige
        call gestion_neige(klon,knon,snow,xtsnow,
     :           snow_prec,xtsnow_prec,dtime,
     :           precip_snow,xtprecip_snow,fqfonte_neige,
     :           fqcalving,snow_evap,xtsnow_evap,fxtfonte_neige,
     :           xt1lay,q1lay,Tsurf_new,t_coup)   
        ! les traceurs d'isotopes sont dj dans gestion neige
        ! on suppose que l'vaporation de la neige est tagge "continent"
      
       ! calcul de la partition entre snow_evap et sol_evap
       do i=1,knon   
         sol_evap(i)=evap(i)-snow_evap(i)
       enddo !do i=1,knon
        
        ! bilan du sol avant evap
        ! verif    
#ifdef ISOVERIFNAN
      do i=1,knon         
      do ixt=1,niso
        call iso_verif_noNaN(xtsol_prec(ixt,i),'surf_ter 974')
      enddo
      enddo
#endif      
#ifdef ISOVERIF
!        write(*,*) 'calcul_iso_surf_ter 910'
        do i=1,knon
          if (use_iso_eau.eq.1) then
            call iso_verif_egalite_choix(qsol_prec(i),
     :          xtsol_prec(iso_eau,i),'calcul_iso_surf_ter 504',
     :          errmax,errmaxrel)
            call iso_verif_egalite_choix(
     &               xtsnow(iso_eau,i),snow(i), 
     &               'calcul_iso_surf_tic_vectall 964',
     :               errmax,errmaxrel)
          endif          
          if (use_iso_hdo.eq.1) then
           if (qsol_prec(i).gt.ridicule_qsol*1e2) then
            call iso_verif_aberrant(xtsol_prec(iso_HDO,i)/
     :            qsol_prec(i)/faccond,'calcul_iso_surf_ter 506')
           endif  !if (qsol_prec(i).gt.ridicule_qsol) 
          endif !if (use_iso_eau.eq.1) then
          if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
            if (qsol_prec(i).gt.ridicule_qsol) then
              call iso_verif_aberrant_o17(xtsol_prec(iso_O17,i)
     :           /qsol_prec(i),xtsol_prec(iso_O18,i)
     :           /qsol_prec(i),'iso_surf_ter 1035')
            endif !if ((qsol_prec(i).gt.ridicule).and.(xtsol_prec(iso_O18,i)
          endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
       enddo !do i=1,knon
#endif
#ifdef ISOVERIFNAN
        do i=1,knon
         do ixt=1,niso
          call iso_verif_noNaN(xtsol_prec(ixt,i),
     :           'iso_surf_ter 1061')
         enddo !do ixt=1,niso
       enddo !do i=1,knon
#endif     
        ! end verif


      do i=1,knon 

        ! flux efficaces, en tenant compte du ruissellement  
        precip_rain_eff(i)=precip_rain(i)
        fqfonte_neige_eff(i)=fqfonte_neige(i)
        sol_evap_eff(i)=sol_evap(i)
        do ixt=1,niso
          xtprecip_rain_eff(ixt,i)=max(xtprecip_rain(ixt,i),0.0)
          fxtfonte_neige_eff(ixt,i)=fxtfonte_neige(ixt,i)
        enddo
#ifdef ISOVERIF
        call iso_verif_positif(precip_rain(i),'calcul_iso_surf_ter 655')
        call iso_verif_positif(fqfonte_neige(i),
     :                   'calcul_iso_surf_ter 656')
        call iso_verif_positif(max_eau_sol-qsol_prec(i),
     :           'calcul_iso_surf_ter 882')
        if (use_iso_eau.eq.1) then
          call iso_verif_positif(xtprecip_rain(iso_eau,i),
     :           'calcul_iso_surf_ter 655')
        endif
#endif        
      enddo !do i=1,knon    
              
        if (ruissellement_pluie.eq.1) then   
          do i=1,knon
             ! c'est la pluie que l'on fait ruisseller
!             write(*,*) ''
!             write(*,*) 'calcul_iso_surf_ter 676, tmp:'
!             write(*,*) 'qsol,qsol_prec',qsol(i),qsol_prec(i)
!             write(*,*) 'precip_rain*dtime=',precip_rain(i)*dtime
!             write(*,*) 'sol_evap*dtime=',sol_evap(i)*dtime
!             write(*,*) 'fqfonte_neige=',fqfonte_neige(i)
!             write(*,*) 'max_eau_sol=',max_eau_sol
             do ixt=1,niso
               xtrun_off(ixt,i)=0.0               
             enddo
             runoff_tmp(i)=0.0
             if (qsol_prec(i)
     :           +(precip_rain(i)-sol_evap(i))*dtime
     :           +fqfonte_neige(i).gt.max_eau_sol) then
                ! a dborde
                ! on rduit l'infiltration de la pluie:
                precip_rain_eff(i)=min(sol_evap(i)
     :            +(max_eau_sol-qsol_prec(i)-fqfonte_neige(i))/dtime,
     :             precip_rain(i)) 
                if (precip_rain_eff(i).lt.0.0) then
                       ! a dborderait mme sans pluie
                    ! on rduit donc la fonte
                    precip_rain_eff(i)=0.0
                    fqfonte_neige_eff(i)=min(sol_evap(i)*dtime
     :                   +max_eau_sol-qsol_prec(i),fqfonte_neige(i))  
                    if (fqfonte_neige_eff(i).lt.0.0) then
                      ! ca dborderait mme sans precip ni fonte car il
                      ! y a de la rose
#ifdef ISOVERIF                      
                      call iso_verif_positif(-sol_evap(i),
     :                   'calcul_iso_surf_ter 912')
#endif                      
                      fqfonte_neige_eff(i)=0.0
                      sol_evap_eff(i)=(qsol_prec(i)-max_eau_sol)/dtime
                    endif !if (fqfonte_neige_eff(i).lt.0.0) then   
                  endif !if (precip_rain_eff(i).lt.0.0) then      
            endif !if (qsol_prec(i)

#ifdef ISOVERIF    
!            write(*,*) 'calcul_iso_surf_ter 706 tmp:'     
!            write(*,*) 'precip_rain_eff(i)*dtime=',
!     :           precip_rain_eff(i)*dtime
!            write(*,*) 'fqfonte_neige_eff(i)*dtime=',
!     :           fqfonte_neige_eff(i)*dtime
!            write(*,*) 'sol_evap(i)*dtime=',    
!     :           sol_evap(i)*dtime
!            write(*,*) 'sol_evap_eff(i)*dtime=',    
!     :           sol_evap_eff(i)*dtime
!            write(*,*) 'max_eau_sol,qsol_prec(i)=',    
!     :           max_eau_sol,qsol_prec(i)
            call iso_verif_positif_choix(max_eau_sol-
     :           (qsol_prec(i)+double_to_real(
     :           (precip_rain_eff(i)-sol_evap_eff(i))*dtime
     :           +fqfonte_neige_eff(i))),ridicule_qsol*10,
     :           'calcul iso_surf_ter 669')
            ! 12 mai 2009: ridicule_qsol*10 car erreurs nums en 32 bits
            call iso_verif_positif(double_to_real(fqfonte_neige_eff(i)),
     :           'calcul iso_surf_ter 702')
            call iso_verif_positif(double_to_real(precip_rain_eff(i)),
     :           'calcul iso_surf_ter 703')
            if (sol_evap(i).ge.0.0) then
                call iso_verif_egalite_choix(
     :             sol_evap(i),
     :             double_to_real(sol_evap_eff(i)),
     :             'calcul iso_surf_ter 724',errmax,errmaxrel)
            endif
#endif  
            ! pour les isostopes:
            if (abs(precip_rain(i)-precip_rain_eff(i))
     :           .gt.ridicule*1e-2) then
             ! *  pour precip_rain_eff:            
             if (precip_rain_eff(i).gt.ridicule_rain) then 
               if (precip_rain(i).gt.ridicule_rain) then 
                do ixt=1,niso
                  xtprecip_rain_eff(ixt,i)=xtprecip_rain(ixt,i)
     :                   /precip_rain(i)*precip_rain_eff(i)
                enddo 
               else !if (precip_rain(i).gt.ridicule_rain) then 
                  write(*,*) 'calcul_iso_surf_ter 723'
                  stop
               endif !if (precip_rain(i).gt.ridicule_rain) then 
             else !if (precip_rain_eff(i).gt.ridicule_rain) then 
                do ixt=1,niso
                  xtprecip_rain_eff(ixt,i)=0.0
                enddo
                if ((bidouille_anti_divergence).and.
     :           (use_iso_eau.eq.1))  then
                  xtprecip_rain_eff(iso_eau,i)=precip_rain_eff(i)
                endif
             endif !if (precip_rain_eff(i).gt.ridicule_rain) then 
             runoff_tmp(i)=runoff_tmp(i)
     :           +(precip_rain(i)-precip_rain_eff(i))*dtime
             do ixt=1,niso
               xtrun_off(ixt,i)=xtrun_off(ixt,i)
     :            +(xtprecip_rain(ixt,i)-xtprecip_rain_eff(ixt,i))*dtime
             enddo
            endif !if (abs(precip_rain(i)-precip_rain_eff(i)).gt.ridicule) then
           
#ifdef ISOVERIF            
            if (use_iso_eau.eq.1) then  
              call iso_verif_egalite_choix(
     :           runoff_tmp(i),xtrun_off(iso_eau,i),
     :           'calcul_iso_surf_ter 1142',
     :           errmax,errmaxrel)
            endif !if (use_iso_eau.eq.1) then  
#endif   

            if (abs(fqfonte_neige_eff(i)-fqfonte_neige(i))
     :           .gt.ridicule) then
             ! *  pour fqfonte_neige_eff:
             if (fqfonte_neige_eff(i).gt.ridicule_rain) then 
               if (fqfonte_neige(i).gt.ridicule_rain) then 
                do ixt=1,niso
                  fxtfonte_neige_eff(ixt,i)=fxtfonte_neige(ixt,i)
     :                    /fqfonte_neige(i)*fqfonte_neige_eff(i)
                enddo 
               else !if (fqfonte_neige(i).gt.ridicule_rain) then 
                  write(*,*) 'calcul_iso_surf_ter 723'
                  stop
               endif !if (fqfonte_neige(i).gt.ridicule_rain) then 
             else !if (fqfonte_neige_eff(i).gt.ridicule_rain) then 
                do ixt=1,niso
                  fxtfonte_neige_eff(ixt,i)=0.0
                enddo
             endif !if (fqfonte_neige_eff(i).gt.ridicule_rain) then 
             runoff_tmp(i)=runoff_tmp(i)
     :           +(fqfonte_neige(i)-fqfonte_neige_eff(i))
             do ixt=1,niso
               xtrun_off(ixt,i)=xtrun_off(ixt,i)
     :            +(fxtfonte_neige(ixt,i)-fxtfonte_neige_eff(ixt,i))
             enddo
           endif !if (abs(fqfonte_neige_eff(i)-fqfonte_neige(i))

#ifdef ISOVERIF            
            if (use_iso_eau.eq.1) then    
              call iso_verif_egalite_choix(double_to_real(
     :           fqfonte_neige_eff(i)),
     :           double_to_real(fxtfonte_neige_eff(iso_eau,i)),
     :           'calcul_iso_surf_ter 705',
     :           errmax,errmaxrel)
              call iso_verif_egalite_choix(
     :           double_to_real(precip_rain_eff(i)),
     :           double_to_real(xtprecip_rain_eff(iso_eau,i)),
     :           'calcul_iso_surf_ter 711',
     :           errmax,errmaxrel)
              call iso_verif_egalite_choix(
     :           runoff_tmp(i),xtrun_off(iso_eau,i),
     :           'calcul_iso_surf_ter 1179',
     :           errmax,errmaxrel)
            endif
#endif    
          enddo !do i=1,knon   
        endif   !if (ruissellement_pluie) then

        ! on ajoute les flux entrants dans le sol
        ! attention, c'est facile si qsol>=0.
        ! mais par contre, si qsol<0, on est oblig de mettre
        ! Rsol=Rflux_entrants, sinon on a des aberrances.
        ! la conservation de la masse d'iso dans le sol ne sera donc pas
        ! vrifie... Donc prudence!
       do i=1,knon  
        qsol_avant_evap(i)=qsol_prec(i)
     :        +precip_rain_eff(i)*dtime+fqfonte_neige_eff(i)
       enddo !do i=1,knon 
       do i=1,knon
        if (qsol_prec(i).ge.0.0) then            
          do ixt=1,niso
           xtsol_avant_evap(ixt,i)=xtsol_prec(ixt,i)
     :        +xtprecip_rain_eff(ixt,i)*dtime+fxtfonte_neige_eff(ixt,i)
          enddo !do ixt=1,niso
        else !if (qsol_prec(i).ge.0.0) then  
            if (precip_rain_eff(i)*dtime+fqfonte_neige_eff(i)
     :           .gt.ridicule_qsol) then  
              do ixt=1,niso
               xtsol_avant_evap(ixt,i)=qsol_avant_evap(i)*
     :        (xtprecip_rain_eff(ixt,i)*dtime+fxtfonte_neige_eff(ixt,i))
     :         /(precip_rain_eff(i)*dtime+fqfonte_neige_eff(i))
              enddo !do ixt=1,niso  
            else
                ! il n'y a pas de flux entrants
                ! on a donc qsol_avant_evap(i)=qsol_prec(i)
                do ixt=1,niso
                 xtsol_avant_evap(ixt,i)=xtsol_prec(ixt,i)
                enddo !do ixt=1,niso
            endif
        endif !if (qsol_prec(i).ge.0.0) then 
       enddo !do i=1,knon  

        ! verif
#ifdef ISOVERIFNAN
      do i=1,knon         
      do ixt=1,niso
        if (iso_verif_noNaN_nostop(double_to_real(
     :    xtsol_avant_evap(ixt,i)),'surf_ter 1239').eq.1) then
          write(*,*) 'qsol_prec(i)=',qsol_prec(i)
          write(*,*) 'xtsol_prec(ixt,i)=',xtsol_prec(ixt,i)
          write(*,*) 'xtprecip_rain_eff(ixt,i)=',
     :          xtprecip_rain_eff(ixt,i)
          write(*,*) 'fxtfonte_neige_eff(ixt,i)=',
     :          fxtfonte_neige_eff(ixt,i)
          write(*,*) 'precip_rain_eff(i)=',precip_rain_eff(i)
          write(*,*) 'fqfonte_neige_eff(i)=',fqfonte_neige_eff(i)
          write(*,*) 'qsol_avant_evap(i)=',qsol_avant_evap(i)
          write(*,*) 'xtsol_avant_evap(ixt,i)=',xtsol_avant_evap(ixt,i)
          write(*,*) 'dtime=',dtime
          stop
        endif
      enddo
      enddo
#endif      
#ifdef ISOVERIF
        do i=1,knon
          if (use_iso_eau.eq.1) then
!            write(*,*) 'qsol_prec=',qsol_prec(i)
!            write(*,*) 'xtsol_prec=',xtsol_prec(iso_eau,i)
!            write(*,*) 'precip_rain_eff=',precip_rain_eff(i)
!            write(*,*) 'fqfonte_neige_eff=',fqfonte_neige_eff(i)
!            write(*,*) 'qsol_avant_evap=',qsol_avant_evap(i)
!            write(*,*) 'xtsol_avant_evap=',xtsol_avant_evap(iso_eau,i) 
!            write(*,*) 'xtprecip_rain_eff=',xtprecip_rain_eff(iso_eau,i)
!            write(*,*) 'fxtfonte_neige_eff=',
!     :                   fxtfonte_neige_eff(iso_eau,i)
            call iso_verif_egalite_choix(double_to_real
     :           (qsol_avant_evap(i)),
     :            double_to_real(xtsol_avant_evap(iso_eau,i)),
     :           'calcul_iso_surf_ter 527',errmax,errmaxrel)
          endif          
          if (use_iso_HDO.eq.1) then
           if (qsol_avant_evap(i).gt.ridicule_qsol*1e2) then   
             if (iso_verif_aberrant_nostop(double_to_real(
     :           xtsol_avant_evap(iso_HDO,i)/qsol_avant_evap(i))
     :           /faccond,'calcul_iso_surf_ter 5032').eq.1) then
               write(*,*) 'qsol_avant_evap(i)=',qsol_avant_evap(i)
               write(*,*) 'ridicule_qsol=',ridicule_qsol
               write(*,*) 'qsol_prec(i)=',qsol_prec(i)
               write(*,*) 'precip_rain_eff(i)*dtime=',
     :           precip_rain_eff(i)*dtime
               write(*,*) 'fqfonte_neige_eff(i)=',fqfonte_neige_eff(i)
               write(*,*) 'deltaD_sol_prec=',
     :           deltaD(xtsol_prec(iso_HDO,i)/qsol_prec(i))
               write(*,*) 'deltaDprecip_rain_eff=',
     :           deltaD(double_to_real(
     :           xtprecip_rain_eff(iso_HDO,i)/precip_rain_eff(i)))
               write(*,*) 'deltaD_finte_neige_eff=',
     :           deltaD(double_to_real(
     :           fxtfonte_neige_eff(iso_HDO,i)/fqfonte_neige_eff(i)))
               write(*,*) 'precip_rain(i)*dtime=',
     :           precip_rain(i)*dtime
               write(*,*) 'fqfonte_neige(i)=',fqfonte_neige(i)
               stop
             endif !if (iso_verif_aberrant_nostop(
           endif ! if ( qsol_avant_evap(i).gt.ridicule_qsol)  
          endif !if (use_iso_eau.eq.1) then
          if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
            if (qsol_avant_evap(i).gt.ridicule_qsol) then
              call iso_verif_aberrant_o17(double_to_real(
     :           xtsol_avant_evap(iso_O17,i)/qsol_avant_evap(i)),
     :           double_to_real(xtsol_avant_evap(iso_O18,i)
     :           /qsol_avant_evap(i)),'iso_surf_ter 1263')
            endif !if ((qsol_prec(i).gt.ridicule).and.(xtsol_prec(iso_O18,i)
          endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
        enddo !do i=1,knon   
#endif
        ! end verif
        
        do i=1,knon
        qsol_avant_deversement(i)=qsol_avant_evap(i)
     :                   -sol_evap_eff(i)*dtime
        enddo !do i=1,knon 

        ! verif du bilan du sol
#ifdef ISOVERIF       
!        write(*,*) 'calcul_iso_surf_ter 1200'
        do i=1,knon      
            call iso_verif_egalite_choix(min(double_to_real(
     :         qsol_avant_deversement(i)),max_eau_sol),
     :          qsol(i),
     :         'calcul_iso_surf_ter 587',errmax,errmaxrel)
           if (ruissellement_pluie.eq.1) then
             if (iso_verif_positif_choix_nostop(
     :           max_eau_sol-double_to_real(qsol_avant_deversement(i)),
     :           ridicule_qsol,'calcul_iso_surf_ter 843')
     :           .eq.1) then
               write(*,*) 'qsol_avant_evap(i)=',qsol_avant_evap(i)
               write(*,*) 'qsol_avant_deversement(i)=',
     :           qsol_avant_deversement(i)
               write(*,*) 'sol_evap_eff(i)*dtime=',sol_evap_eff(i)*dtime
               stop
             endif
           endif
         enddo ! do i=1,knon    
#endif

          ! parsage des cas
         ncas_evap=0
         ncas_noevap=0
         ncas_rosee=0
         do i=1,knon
         ! modif 2 octobre! sol_evap au lie de evap
         ! modif 5 oct: gt au lieu de ge.
          if (sol_evap(i).gt.0.0) then
           ncas_evap=ncas_evap+1
           cas_evap(ncas_evap)=i 
#ifdef ISOVERIF
           trace_cas(i)=1
#endif
          else if (sol_evap(i).lt.0.0) then
           ncas_rosee=ncas_rosee+1
           cas_rosee(ncas_rosee)=i
#ifdef ISOVERIF
           trace_cas(i)=3
#endif           
          else !if (sol_evap(i).gt.0.0) then
           ncas_noevap=ncas_noevap+1
           cas_noevap(ncas_noevap)=i
#ifdef ISOVERIF
           trace_cas(i)=2
#endif
          endif !if (sol_evap(i).gt.0.0) then       
         enddo !do i=1,knon

        ! vaporation du sol:        
        ! traitement vectoriel du cas d'vaporation
        ! calcul longueur de diffusion
         L=1e3*sqrt(dtime*Kd) ! en mm
         do icas=1,ncas_evap
            i=cas_evap(icas)   
          
          ! verif du sol
#ifdef ISOVERIFNAN
              do ixt=1,niso
                call iso_verif_noNAN(xtsol(ixt,i),
     :                   'calcul_iso_surf_ter 2960')
              enddo !do ixt=1,niso
#endif           
#ifdef ISOVERIF
!              write(*,*) 'calcul_iso_surf_ter 767: i,sol_evap=',
!     :           i,sol_evap(i)
!              write(*,*) 'xtsol_avant_evap,qsol_avant_evap=',
!     :           xtsol_avant_evap(iso_eau,i),qsol_avant_evap(i) 
          if  (iso_verif_egalite_nostop(sol_evap(i),
     :         double_to_real(sol_evap_eff(i)),
     :          'calcul_iso_surf_ter 1100').eq.1) then
            write(*,*) 'calcul_iso_surf_ter 543: qsol(',i,')=',qsol(i)
            write(*,*) 'qsol_avant_evap(',i,')=',qsol_avant_evap(i)
            write(*,*) 'sol_evap(',i,')*dtime=',sol_evap(i)*dtime
            write(*,*) 'qsol_prec(',i,')=',qsol_prec(i)
            write(*,*) 'precip_rain(',i,')*dtime=',precip_rain(i)*dtime
            write(*,*) 'fqfonte_neige(',i,')=',fqfonte_neige(i)
            stop
            endif 
              if (use_iso_eau.eq.1) then
                call iso_verif_egalite_choix(double_to_real(
     :           xtsol_avant_evap(iso_eau,i))
     :                  ,double_to_real(qsol_avant_evap(i)),
     :           'calcul_iso_surf_ter 2952',
     :                   errmax,errmaxrel)
                if (qsol_avant_evap(i).gt.ridicule_qsol) then
                  if (iso_verif_egalite_choix_nostop(double_to_real(
     :              xtsol_avant_evap(iso_eau,i)/qsol_avant_evap(i)),
     :              1.0,'calcul_iso_surf_ter 2952',
     :              errmax,errmaxrel*10).eq.1) then 
                      write(*,*) 'xtsol_avant_evap(iso_eau,i)=',
     :                   xtsol_avant_evap(iso_eau,i)       
                      write(*,*) 'qsol_avant_evap(i)=',
     :                   qsol_avant_evap(i)   
                      write(*,*) 'xtsol_prec(iso_eau,i)=',
     :                   xtsol_prec(iso_eau,i)       
                      write(*,*) 'qsol_prec(i)=',
     :                   qsol_prec(i)       
                      write(*,*) 'xtprecip_rain_eff(iso_eau,i)=',
     :                   xtprecip_rain_eff(iso_eau,i)  
                      write(*,*) 'precip_rain_eff(i)=',
     :                   precip_rain_eff(i)
                      write(*,*) 'fxtfonte_neige_eff(iso_eau,i)=',
     :                   fxtfonte_neige_eff(iso_eau,i)        
                      write(*,*) 'fqfonte_neige_eff(i)=',
     :                   fqfonte_neige_eff(i)     
                      stop                 
                  endif !if (iso_verif_egalite_choix(
                endif !if (qsol(i).gt.ridicule_qsol) then
              endif !if (use_iso_eau.eq.1) then  
              if (use_iso_HDO.eq.1) then  
                if (qsol_avant_evap(i).gt.ridicule_qsol*1e2) then
                  call iso_verif_aberrant(double_to_real(
     :           xtsol_avant_evap(iso_HDO,i)/qsol_avant_evap(i))
     :                  /faccond ,'calcul_iso_surf_ter 3181')
                endif !if (qsol(i).gt.ridicule_qsol) then
              endif  !if (use_iso_HDO.eq.1) then
              if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
               if (qsol_avant_evap(i).gt.ridicule_qsol) then
                   call iso_verif_aberrant_o17(double_to_real(
     :              xtsol_avant_evap(iso_O17,i)/qsol_avant_evap(i)),
     :              double_to_real(xtsol_avant_evap(iso_O18,i)
     :              /qsol_avant_evap(i)),'iso_surf_ter 1390')
                endif !if ((qsol_prec(i).gt.ridicule).and.(xtsol_prec(iso_O18,i)
              endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then  
#endif
           ! end verif du sol
       
       ! calcul de h1
       if (tsurf(i).lt.t_coup) then
           zqs(i)=qsats(tsurf(i))/ps(i)
#ifdef ISOVERIF            
           call iso_verif_positif(zqs(i),'calcul_iso_surf 1183')
           call iso_verif_positif(0.1-zqs(i),'calcul_iso_surf 1184')
#endif           
       else
           zqs(i)=qsatl(tsurf(i))/ps(i)
#ifdef ISOVERIF            
           call iso_verif_positif(zqs(i),'calcul_iso_surf 1187')   
           if (iso_verif_positif_nostop(0.15-zqs(i),
     :            'calcul_iso_surf 1188').eq.1) then
                write(*,*) 'tsurf(i)=',tsurf(i)-t_coup,'C'
                if (tsurf(i)-t_coup.lt.50.0) then
                   stop
                endif
           endif
#endif           
       endif       
       h1(i)=q1lay(i)/zqs(i)
       h1(i)=min(1.0,max(0.0,h1(i)))

       ! calcul de Rsol
       call calcul_Rsol(qsol_avant_evap,
     :         sol_evap,xtsol_avant_evap,
     :         xt1lay, q1lay,tsurf, i,Rsol,klon)       
       
#ifdef ISOVERIFNAN
         do ixt=1,niso
            call iso_verif_noNAN(Rsol(ixt),
     :                   'calcul_iso_surf_ter 3217, sur terre')
         enddo !do ixt=1,niso
#endif  
#ifdef ISOVERIF       
         if (use_iso_eau.eq.1) then
          call iso_verif_egalite_choix(Rsol(iso_eau),1.0,
     :           'calcul_iso_surf_ter 700',errmax*10,errmaxrel*10)
         endif !if (use_iso_eau.eq.1) then
         if ((use_iso_HDO.eq.1).and.
     :           (qsol_avant_evap(i).gt.ridicule_qsol*1e2)) then     
          call iso_verif_aberrant(Rsol(iso_HDO)/faccond,
     :           'calcul_iso_surf_ter 703')
         endif
         if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
            if (qsol_avant_evap(i).gt.ridicule_qsol) then
              call iso_verif_aberrant_o17(Rsol(iso_o17),Rsol(iso_o18),
     :           'iso_surf_ter 1447')
            endif !if ((qsol_prec(i).gt.ridicule).and.(xtsol_prec(iso_O18,i)
          endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
#endif
        if ((bidouille_anti_divergence).and.
     :           (use_iso_eau.eq.1))  then
            Rsol(iso_eau)=1.0
        endif


        ! CALCUL de R1
             
#ifdef ISOVERIFNAN
          do ixt=1,niso
                call iso_verif_noNAN(xt1lay(ixt,i),
     :                  'calcul_iso_surf_ter 3222')
                call iso_verif_noNAN(q1lay(i),
     :                   'calcul_iso_surf_ter 3223')
          enddo   
#endif
          if (q1lay(i).gt.0.0) then
              do ixt=1,niso  
                R1(ixt)=xt1lay(ixt,i)/q1lay(i)
              enddo
          else
#ifdef ISOVERIF              
              write(*,*) 'calcul_iso_surf 1415: q1lay=',q1lay(i)
              stop  
#endif              
              do ixt=1,niso  
                R1(ixt)=Rdefault(ixt)              
              enddo  
           endif

           ! calcul humidit de la couche 1, en mm
           ! cela servira en cas de rvaporation en h=1, pour viter
           ! instabilits.
           ! deltaP=2.0*(ps(i)-p1lay(i))
!            q10=1.0e3*2.0*(ps(i)-p1lay(i))*q1lay(i)/rowl/RG
           q10=1.0e3*deltaP_BL*q1lay(i)/rowl/RG
           ! modif 31 aout 2008


#ifdef ISOVERIFNAN
           do ixt=1,niso
             call iso_verif_noNAN(R1(ixt),
     :          'calcul_iso_surf_ter 3227, sur terre')   
           enddo !do ixt=1,niso
#endif

         ! calcul de l'vap
         if (alphak_stewart.eq.1) then
             ! calcul de alphak en accord avec stewart, mathieu et
             ! Bariac
            do ixt=1,niso
             alphak(ixt)=tdifrel(ixt)**tdifexp_sol
            enddo !do ixt=1,niso 
        else
            ! calcul de alphak comme une surfacae ouvert, fonction du
            ! vent
            VSURF=sqrt(u1lay(i)**2+v1lay(i)**2)
            call calcul_kcin(vsurf,kcin) 
            do ixt=1,niso
              alphak(ixt)=1.0/(1-kcin(ixt))
            enddo !do ixt=1,niso   
        endif            
         
         qevap(i)=sol_evap(i)*dtime ! quantit d'eau du sol perdue par evap
         if (Tsurf_new(i).gt.t_coup) then
             ! Pveg est la fraction d'eau vapore sans fractionnement
             Pveg=P_vegetation(i)
         else !if (Tsurf_new(i).gt.t_coup) then
             !  0C, on sublime, donc on rvap tout sans fractionnement
             Pveg=1.0
         endif !if (Tsurf_new(i).gt.t_coup) then

         ! calcul de ce que donnerait l'vap du sol nu
         
#ifdef ISOVERIF         
         if (P_veg.eq.1.0) then
         call iso_verif_egalite(Pveg,1.0,'calcul_iso_surf_ter 1314')
         call iso_verif_egalite(P_vegetation(i),1.0,
     :           'calcul_iso_surf_ter 1315')
        endif
#endif         
        if (Pveg.gt.1.0-1e-3) then
            do ixt=1,niso
              xtnu(ixt,i)=0.0
            enddo
        else
         call iso_evap_sol_nu(double_to_real(qsol_avant_evap(i)),
     :           qevap(i),q10,Rsol,R1,h1(i),
     &      Tsurf_new(i),alphak, L, xtnu(1,i),Pveg)  
#ifdef ISOVERIF
         if (use_iso_eau.eq.1) then        
           call iso_verif_egalite_choix(xtnu(iso_eau,i),qevap(i),
     :           'calcul_iso_surf_ter 1253',errmax,errmaxrel)
         endif
         if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
            if (qevap(i).gt.ridicule_evap) then
              call iso_verif_aberrant_o17(xtnu(iso_O17,i)
     :           /qevap(i),xtnu(iso_O18,i)/qevap(i),
     :           'iso_surf_ter 1623')
          endif !if (qevap(i).gt.ridicule_evap) then
        endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then

#endif                  
        endif     
!         call iso_evap_sol(double_to_real(qsol_avant_evap(i)),
!     :           qevap,Pveg,Rsol,R1,h1(i),
!     &      Tsurf_new(i),alphak, Rsol_new,Revap)

         ! bilan de masse
         do ixt=1,niso         
!            xtsol_evap(ixt,i)=sol_evap(i)*Revap(ixt)
!            xtsol(ixt,i)=qsol_avant_deversement(i)*Rsol_new(ixt)
            xtsol_evap(ixt,i)=(1.0-Pveg)*xtnu(ixt,i)
     :          +Pveg*Rsol(ixt)*qevap(i) ! mm
            xtsol(ixt,i)=xtsol_avant_evap(ixt,i)-xtsol_evap(ixt,i) ! mm
            xtsol_evap(ixt,i)=xtsol_evap(ixt,i)/dtime ! mm/s
         enddo !do ixt=1,niso

         if (evap_cont_cste.eq.1) then
             ! on fixe la compo de l'vap continentale
             if (use_iso_eau.eq.1) then
                 xtsol_evap(iso_eau,i)=sol_evap(i)
             endif
             if (use_iso_O18.eq.1) then
                 xtsol_evap(iso_O18,i)=sol_evap(i)
     :             *(deltaO18_evap_cont/1000.+1.)*tnat(iso_O18)
             endif
             if (use_iso_HDO.eq.1) then
                 xtsol_evap(iso_HDO,i)=sol_evap(i)
     :            *((d_evap_cont+8*deltaO18_evap_cont)/1000.+1.)
     :            *tnat(iso_HDO)
             endif
             if (use_iso_O17.eq.1) then
                 xtsol_evap(iso_O17,i)=0.0
             endif
             if (use_iso_HTO.eq.1) then
                 xtsol_evap(iso_HTO,i)=0.0
             endif
         endif

#ifdef ISOTRAC
        if (option_traceurs.eq.20) then
           izone_recoit=bassin_map(knindex(i))
        else
           izone_recoit=izone_cont
        endif

        do ixt=niso+1,ntraciso
           if (index_zone(ixt).eq.izone_recoit) then
             xtsol_evap(ixt,i)=xtsol_evap(index_iso(ixt),i)
           else
             xtsol_evap(ixt,i)=0.0
           endif
        enddo !do ixt=niso+1,ntraciso
#endif         
         

         ! verif
#ifdef ISOVERIFNAN
           do ixt=1,niso
             call iso_verif_noNAN(xtsol_evap(ixt,i),
     &               'calcul_iso_surf_ter 3002, sur terre')
             call iso_verif_noNAN(xtsol(ixt,i),
     :           'calcul_iso_surf_ter 680')
           enddo !do ixt=1,niso
#endif           
#ifdef ISOVERIF
           if (use_iso_eau.eq.1) then 
             call iso_verif_egalite_choix(
     &           xtsol_evap(iso_eau,i),
     :           sol_evap(i),
     &           'calcul_iso_surf_ter 741',errmax,errmaxrel)
             call iso_verif_egalite_choix(xtsol(iso_eau,i),
     &           double_to_real(qsol_avant_deversement(i)),
     &           'calcul_iso_surf_ter 2976',errmax,errmaxrel)
           endif !if (use_iso_eau.eq.1) then  
           if (use_iso_HDO.eq.1) then
             if (abs(sol_evap(i)).gt.ridicule_evap) then
              if (iso_verif_aberrant_nostop(
     &           xtsol_evap(iso_HDO,i)/sol_evap(i),
     &           'calcul_iso_surf_ter 3273: sur terre').eq.1) then  
!                   write(*,*) 'deltaDsol=',deltaD(Rsol(ixt))
                   ! on ne plante que si ca donne lieu  des valeurs
                   ! aberrante de deltaD1
                   write(*,*) 'deltaD1new=',deltaD(
     :                   (xtsol_evap(iso_hdo,i)*dtime+q10*R1(iso_hdo))
     :                   /(sol_evap(i)*dtime+q10))
                   call iso_verif_aberrant(
     :                   (xtsol_evap(iso_hdo,i)*dtime+q10*R1(iso_hdo))
     :                   /(sol_evap(i)*dtime+q10),
     :                  'calcul_iso_surf_ter 1390')
              endif  !if (iso_verif_aberrant  
             endif !if (abs(evap(i)).gt.ridicule_rain*1e-2) then
             if (iso_verif_aberrant_choix_nostop(xtsol_evap(iso_HDO,i),
     :           sol_evap(i),ridicule,1e5,
     :           'calcul_iso_surf_ter 1403').eq.1) then
                call iso_verif_aberrant(
     :                   (xtsol_evap(iso_hdo,i)*dtime+q10*R1(iso_hdo))
     :                   /(sol_evap(i)*dtime+q10),
     :                  'calcul_iso_surf_ter 1390')
              endif
              if (qsol_avant_deversement(i).gt.ridicule_qsol*1e2) then
                if (iso_verif_aberrant_nostop(xtsol(iso_HDO,i)
     :                   /double_to_real(qsol_avant_deversement(i))
     :                 /faccond, 'calcul_iso_surf_ter 1542').eq.1) then
                  write(*,*) 'i, qsol(i)=',i, qsol(i)
                  write(*,*) 'qsol_avant_evap,qevap,L=',
     :                   qsol_avant_evap(i),qevap(i),L
                  write(*,*) 'deltaDsol_avant_evap',deltaD(
     :                 double_to_real(xtsol_avant_evap(iso_HDO,i)
     :                  /qsol_avant_evap(i)))
                  write(*,*) 'deltaDRsol=',deltaD(Rsol(iso_HDO))
                  write(*,*) 'deltaDsol_evap=',deltaD(
     :                 xtnu(iso_HDO,i)/qevap(i))
                  write(*,*) 'h1(i),f=',h1(i),max((min(L,
     :                   double_to_real(qsol_avant_evap(i)))-qevap(i))
     :                   /min(L,double_to_real(qsol_avant_evap(i))),0.0)
                  stop
                endif
              endif !if (qsol(i).gt.ridicule_qsol) then
           endif  !if (use_iso_HDO.eq.1) then 
           if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
             if (qevap(i).gt.ridicule_evap) then 
               call iso_verif_aberrant_o17(xtnu(iso_O17,i)
     :           /qevap(i),xtnu(iso_O18,i)/qevap(i),
     :           'iso_surf_ter 1626')   
            endif 
            if (sol_evap(i).gt.ridicule_evap) then 
               call iso_verif_aberrant_o17(xtsol_evap(iso_O17,i)
     :           /sol_evap(i),xtsol_evap(iso_O18,i)/sol_evap(i),
     :           'iso_surf_ter 1631')   
            endif
            if (qsol(i).gt.ridicule_qsol) then               
              if (iso_verif_aberrant_o17_nostop(xtsol(iso_O17,i)
     :           /double_to_real(qsol_avant_deversement(i)),
     :           xtsol(iso_O18,i)
     :           /double_to_real(qsol_avant_deversement(i)),
     :           'iso_surf_ter 1623').eq.1) then
                  write(*,*) 'i, qsol(i)=',i,qsol_avant_deversement(i)
                  write(*,*) 'qsol_avant_evap,qevap,L=',
     :                   qsol_avant_evap(i),qevap(i),L
                  write(*,*) 'o17excess_sol_avant_evap',o17excess(
     :                 double_to_real(xtsol_avant_evap(iso_o17,i)
     :                  /qsol_avant_evap(i)),double_to_real(
     :                  xtsol_avant_evap(iso_o18,i)/qsol_avant_evap(i)))
                  write(*,*) 'o17excess_sol_evap=',o17excess(
     :               xtsol_evap(iso_o17,i)/sol_evap(i),
     :               xtsol_evap(iso_o18,i)/sol_evap(i))
                  write(*,*) 'h1(i),f=',h1(i),max((min(L,
     :                   double_to_real(qsol_avant_evap(i)))-qevap(i))
     :                   /min(L,double_to_real(qsol_avant_evap(i))),0.0)
                  write(*,*) 'qsol_avant_evap,sol_evap,qsol,dt=',
     :                  qsol_avant_evap(i),sol_evap(i),
     :                  qsol_avant_deversement(i),dtime 
                  write(*,*) 'qsol_avant_evap17,sol_evap17,qsol17=',
     :                   xtsol_avant_evap(iso_o17,i),
     :                   xtsol_evap(iso_o17,i),xtsol(iso_o17,i)
                  write(*,*) 'qsol_avant_evap18,sol_evap17,qsol18=',
     :                   xtsol_avant_evap(iso_o18,i),
     :                   xtsol_evap(iso_o18,i),xtsol(iso_o18,i)
                stop
              endif !if (iso_verif_aberrant_o17_nostop(xtsol(iso_O17,i)
            endif !if ((qsol(i).gt.ridicule).and.(xtsol(iso_O18,i)
          endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then     
#ifdef ISOTRAC
          call iso_verif_traceur(xtsol_evap(1,i),
     :           'calcul_iso_surf_ter 1558')
#endif          
#endif
          ! end verif   
       enddo  !do icas_evap=1,ncas_evap

! traitement vectoriel du cas pas d'vap
        do icas=1,ncas_noevap
          i=cas_noevap(icas)
!          write(*,*) 'calcul_iso_surf_oce 3175: pas d''vap'
          do ixt=1,ntraciso
            xtsol_evap(ixt,i)=0.0
          enddo
          do ixt=1,niso      
            xtsol(ixt,i)=xtsol_avant_evap(ixt,i)
          enddo !do ixt=1,niso
        enddo !do icas_evap=1,ncas_evap

        ! traitement vectoriel du cas rose
        do icas=1,ncas_rosee
          i=cas_rosee(icas)      
          ! evap<0 -> on condense.
!          write(*,*) 'calcul_iso_surf_oce 3176: condense: sol_evap(i)=',
!     :           sol_evap(i)          
!          write(*,*) 'calcul_iso_surf_ter 716: dtime=',dtime
!          Mair=100*100/9.8
          call iso_rosee_givre(xt1lay,q1lay,Tsurf_new,t_coup, 
     :            sol_evap,i,xtsol_evap,klon)
         ! les traceurs d'eau sont dj dans iso_rosee_givre
         ! sol_evap est le flux d'eau sortant de la premire couche         
          ! calcul de la rose s'inflitrant dans le sol:      
          ! sol_evap est divis sans fractionnement en une partie   
          ! dirige vers le sol, et une partie partant en ruissellement
          if (abs(sol_evap(i)).gt.0.0) then
            do ixt=1,niso
             xtsol_evap_eff(ixt,i)=xtsol_evap(ixt,i)
     :           /sol_evap(i)*sol_evap_eff(i)
#ifdef ISOVERIFNAN
             if (iso_verif_noNaN_nostop(double_to_real(
     :           xtsol_evap_eff(ixt,i)),'iso_surf_ter 1790')
     :           .eq.1) then
               write(*,*) 'xtsol_evap,sol_evap,sol_evap_eff=',
     :           xtsol_evap(ixt,i),sol_evap(i),sol_evap_eff(i)
               stop
              endif !if (iso_verif_noNaN_nostop(double_to_real(
#endif             
            enddo !do ixt=1,niso
          else ! if (sol_evap.gt.0.0) then
#ifdef ISOVERIF           
             call iso_verif_egalite(sol_evap_eff(i),0.0,
     :           'iso_surf_ter 1862')
#endif             
           do ixt=1,niso
             xtsol_evap_eff(ixt,i)=0.0
           enddo !do ixt=1,niso
          endif !if (sol_evap.gt.0.0) then

          if (ruissellement_pluie.eq.1) then
            do ixt=1,niso
              xtrun_off(ixt,i)=xtrun_off(ixt,i)+(xtsol_evap_eff(ixt,i)
     :           -xtsol_evap(ixt,i))*dtime
            enddo
             runoff_tmp(i)=runoff_tmp(i)
     :           +(sol_evap_eff(i)-sol_evap(i))*dtime
          endif !if (ruissellement_pluie.eq.1) then

#ifdef ISOVERIFNAN
          do ixt=1,niso
                call iso_verif_noNAN(
     :           double_to_real(xtsol_evap_eff(ixt,i)),
     :           'calcul_iso_surf_ter 1020')
          enddo !do ixt=1,niso   
#endif
#ifdef ISOVERIF   
          if (use_iso_eau.eq.1) then  
                call iso_verif_egalite_choix(
     :           double_to_real(xtsol_evap_eff(iso_eau,i)),
     :           double_to_real(sol_evap_eff(i)),
     :           'calcul_iso_surf_ter 1025',
     :           errmax,errmaxrel)
          endif
          if (use_iso_hdo.eq.1) then
              ! si il y a rose, il faut que le flux d'isotopes soit
              ! aussi ngatif
              call iso_verif_positif(-xtsol_evap(iso_hdo,i),
     :           'calcul_iso_surf_ter 1448')
          endif
#endif
          ! calcul de la nouvelle composition du sol en prenant en
          ! compte la rsoe infiltre
          do ixt=1,niso      
             xtsol(ixt,i)=xtsol_avant_evap(ixt,i)
     :            -xtsol_evap_eff(ixt,i)*dtime             
          enddo

#ifdef ISOVERIFNAN
              do ixt=1,niso
                call iso_verif_noNAN(double_to_real(
     :           xtsol_avant_evap(ixt,i)),
     :           'calcul_iso_surf_ter 1826')
                call iso_verif_noNAN(double_to_real(
     :           xtsol_evap_eff(ixt,i)),
     :           'calcul_iso_surf_ter 1832')
                call iso_verif_noNAN(xtsol(ixt,i),
     :           'calcul_iso_surf_ter 1828')
              enddo !do ixt=1,niso
#endif
#ifdef ISOVERIF
              if (use_iso_eau.eq.1) then  
                call iso_verif_egalite_choix(xtsol(iso_eau,i),
     :            double_to_real(qsol_avant_deversement(i)),
     :           'calcul_iso_surf_ter 1967',
     :            errmax,errmaxrel)
                call iso_verif_egalite_choix(
     :              xtsol_evap(iso_eau,i),
     :              sol_evap(i),
     :              'calcul_iso_surf_ter 771',errmax,errmaxrel)
              endif !if (use_iso_eau.eq.1) then  
              if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
               if (abs(evap(i)).gt.ridicule_evap) then
                call iso_verif_aberrant_o17(xtsol_evap(iso_O17,i)
     :           /sol_evap(i),xtsol_evap(iso_O18,i)
     :           /sol_evap(i),'calcul_iso_surf 1754')
              endif !if (qsol(i).gt.ridicule) then
             endif ! if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
#endif
                    
        enddo !do icas_evap=1,ncas_rosee
        
        ! deversement du trop plein  
        ! seulement si c'est le sol qu'on fait ruisseller:
        if (ruissellement_pluie.eq.0) then  
          do i=1,knon  
          if (qsol_avant_deversement(i).gt.max_eau_sol) then     
              do ixt=1,niso
                xtrun_off(ixt,i)=run_off(i)*xtsol(ixt,i)
     :                   /qsol_avant_deversement(i)
                xtsol(ixt,i)=min(xtsol(ixt,i)/qsol_avant_deversement(i)
     :                   *max_eau_sol,max_eau_sol) 
#ifdef ISOVERIF 
                if (use_iso_eau.eq.1) then
                  call iso_verif_egalite_choix(run_off(i),
     :                 xtrun_off(iso_eau,i),'calcul_iso_surf_ter 1774',
     :                 errmax,errmaxrel)
                endif
#endif                
              enddo  
          else !if (qsol_avant_deversement(i).gt.max_eau_sol) then
#ifdef ISOVERIF               
               call iso_verif_egalite(run_off(i),0.0,
     :                   'calcul_iso_surf_ter 1672')  
#endif               
              do ixt=1,niso
               xtrun_off(ixt,i)=0.0 
              enddo               
          endif !if (qsol(i).gt.max_eau_sol) then
          enddo ! do i=1,knon  
      else if (ruissellement_pluie.eq.1) then
            ! on vrifie que rien ne dborde
#ifdef ISOVERIF  
          do i=1,knon  
            call iso_verif_positif_choix(
     :           max_eau_sol-double_to_real(qsol_avant_deversement(i)),
     :           ridicule_qsol,'calcul_iso_surf_ter 935')
            if (use_iso_eau.eq.1) then
            call  iso_verif_egalite_choix(runoff_tmp(i),
     :                 xtrun_off(iso_eau,i),'calcul_iso_surf_ter 1794',
     :                 errmax,errmaxrel)
            endif !if (use_iso_eau.eq.1) then
            
!            write(*,*) 'tmp ter 1929: i,runoff_tmp,run_off=',
!     :           i,runoff_tmp(i),run_off(i)
           if (iso_verif_egalite_choix_nostop(runoff_tmp(i),
     :          run_off(i),'calcul_iso_surf_ter 1772',
     :          errmax_sol*max(qsol_prec(i),1.0),errmaxrel).eq.1) then
           ! il y a beaucoup d'inprecision associe  runoff, car dans
           ! LMDZ, runoff=qsol-max_eau_sol (cf fonte_neige).
           ! en R4, qsol a 6 chiffres significatifs aprs la virgule ->
           ! la precision sur le rsultat ne peut pas tre meilleure que
           ! 1e-5.
            write(*,*) 'i,max_eau_sol=',i,max_eau_sol            
            write(*,*) 'qsol_prec=',qsol_prec(i) 
            write(*,*) 'precip_rain*dt=',precip_rain(i)*dtime
            write(*,*) 'fqfonte_neige=',fqfonte_neige(i)
            write(*,*) 'sol_evap*dt=',sol_evap(i)*dtime
            write(*,*) 'precip_rain_eff*dt=',precip_rain_eff(i)*dtime
            write(*,*) 'fqfonte_neige_eff=',fqfonte_neige_eff(i)
            write(*,*) 'sol_evap_eff*dt=',sol_evap_eff(i)*dtime
            write(*,*) 'qsol_avant_evap=',qsol_avant_evap(i)
            write(*,*) 'qsol_avant_deversement=',
     :                   qsol_avant_deversement(i)
            write(*,*) 'run_off=',run_off(i)
            write(*,*) 'runoff_tmp=',runoff_tmp(i)
!            write(*,*) 'xtsol_prec=',xtsol_prec(iso_eau,i)
!            write(*,*) 'xtsol_avant_evap=',xtsol_avant_evap(iso_eau,i) 
!            write(*,*) 'xtprecip_rain_eff=',xtprecip_rain_eff(iso_eau,i)
!            write(*,*) 'fxtfonte_neige_eff=',
!     :                   fxtfonte_neige_eff(iso_eau,i)
              stop
              endif  !if (iso_verif_egalite_choix_nostop
            
          enddo !do i=1,knon
#endif          
         ! rectification ventuelle du runoff
        do i=1,knon
         if (runoff_tmp(i).gt.0.0) then
          do ixt=1,niso   
           xtrun_off(ixt,i)=xtrun_off(ixt,i)/runoff_tmp(i)*run_off(i)
          enddo !do ixt=1,niso   
         endif
        enddo  
#ifdef ISOVERIF
        do i=1,knon
        if (use_iso_eau.eq.1) then
            call iso_verif_egalite_choix(run_off(i),
     :        xtrun_off(iso_eau,i),'calcul_iso_surf_ter 1834',
     :        errmax,errmaxrel)            
        endif
        enddo !do i=1,knon
#endif       
        else
          write(*,*) 'calcul_iso_surf 1764: option non valide:'  
          write(*,*) 'ruissellement_pluie=',ruissellement_pluie
          stop
        endif !if (ruissellement_pluie.eq.0) then 

        ! on en dduit l'vap vers l'atm:
        do i=1,knon
        do ixt=1,ntraciso
           xtevap(ixt,i)=xtsol_evap(ixt,i)+xtsnow_evap(ixt,i)
        enddo !do ixt=1,niso
        enddo !do i=1,knon

        ! verif
#ifdef ISOVERIFNAN
        do i=1,knon
              do ixt=1,niso
                call iso_verif_noNAN(xtsol_evap(ixt,i),     
     :                   'calcul_iso_surf_ter 800')
                call iso_verif_noNAN(xtsnow_evap(ixt,i),     
     :                   'calcul_iso_surf_ter 801')
                call iso_verif_noNAN(xtevap(ixt,i),     
     :                   'calcul_iso_surf_ter 802')
                call iso_verif_noNAN(xtsnow(ixt,i),     
     :                   'calcul_iso_surf_ter 803')
                call iso_verif_noNAN(xtsol(ixt,i),     
     :                   'calcul_iso_surf_ter 804')                
              enddo   !do ixt=1,niso
        enddo ! do i=1,knon
#endif              
#ifdef ISOVERIF
        do i=1,knon
              if (use_iso_eau.eq.1) then  
                 if (iso_verif_egalite_choix_nostop(
     :               xtevap(iso_eau,i),evap(i),
     :               'calcul_iso_surf_ter 1059',errmax,errmaxrel)
     :               .eq.1) then
                   write(*,*) 'xtevap(iso_eau,i)=',xtevap(iso_eau,i)
                   write(*,*) 'evap(i)=',evap(i)
                   write(*,*) 'xtsol_evap(iso_eau,i)=',
     :                   xtsol_evap(iso_eau,i)
                   write(*,*) 'sol_evap(i)=',sol_evap(i)
                   write(*,*) 'xtsnow_evap(iso_eau,i)=',
     :                   xtsnow_evap(iso_eau,i)
                   write(*,*) 'snow_evap(i)=',snow_evap(i)
                   stop                   
                 endif
                 call iso_verif_egalite_choix(xtsnow(iso_eau,i),snow(i),
     :                  'calcul_iso_surf_ter 743',errmax,errmaxrel)
                 call iso_verif_egalite_choix(xtsol(iso_eau,i),qsol(i),
     :                  'calcul_iso_surf_ter 745',errmax,errmaxrel)
                 call iso_verif_positif(max_eau_sol-qsol(i),
     :                   'calcul_iso_surf_ter 746a')
                 if (iso_verif_positif_nostop(
     :                   max_eau_sol-xtsol(iso_eau,i),
     :                   'calcul_iso_surf_ter 746b').eq.1) then
                   write(*,*) 'i=',i
                   write(*,*) 'max_eau_sol=',max_eau_sol
                   write(*,*) 'qsol(i)=',qsol(i)
                   write(*,*) 'xtsol(iso_eau,i)=',xtsol(iso_eau,i)
                   write(*,*) 'qsol_avant_deversement(i)=',
     :                   qsol_avant_deversement(i)
                   write(*,*) 'precip_rain(i)=',precip_rain(i)
                   write(*,*) 'precip_rain_eff(i)=',precip_rain_eff(i)
                   write(*,*) 'fqfonte_neige(i)=',fqfonte_neige(i)
                   write(*,*) 'qsol_avant_evap(i)=',qsol_avant_evap(i)
                   write(*,*) 'qsol_prec(i)=',qsol_prec(i)
                   write(*,*) 'sol_evap(i)=',sol_evap(i)
                   write(*,*) 'xtprecip_rain(iso_eau,i)=',
     :                   xtprecip_rain(iso_eau,i)
                   write(*,*) 'xtprecip_rain_eff(iso_eau,i)=',
     :                   xtprecip_rain_eff(iso_eau,i)
                   write(*,*) 'xtsol_avant_evap(iso_eau,i)=',
     :                   xtsol_avant_evap(iso_eau,i)
                   write(*,*) 'xtsol_prec(iso_eau,i)=',
     :                   xtsol_prec(iso_eau,i)
                   write(*,*) 'xtsol_evap(iso_eau,i)=',
     :                   xtsol_evap(iso_eau,i)
                   if (xtsol(iso_eau,i)-max_eau_sol.gt.1e-9) then
                      stop
                   else
                      xtsol(iso_eau,i)=min(xtsol(iso_eau,i),
     :                   max_eau_sol)
                   endif
                 endif
              endif !if (use_iso_eau.eq.1) then
              if (use_iso_HDO.eq.1) then  
                 if (snow(i).gt.ridicule_snow) then 
                    call iso_verif_aberrant(xtsnow(iso_HDO,i)/snow(i),
     :                  'calcul_iso_surf_ter 749')
                 endif !if (snow(i).gt.ridicule_snow) then
                 call iso_verif_aberrant_choix(xtsnow(iso_HDO,i),
     :               snow(i),ridicule,deltalim_snow,
     :               'calcul_iso_surf_lic 1955')
                 if (evap(i).gt.ridicule_evap) then
                   if (iso_verif_aberrant_nostop(
     :                   xtevap(iso_HDO,i)/evap(i),
     :                  'calcul_iso_surf_ter 751').eq.1) then
                     write(*,*) 'i=',i
                     write(*,*) 'sol_evap,snow_evap=',
     ;                   sol_evap(i),snow_evap(i)
                     write(*,*) 'deltaDsol_evap=',
     :                   deltaD(xtsol_evap(iso_hdo,i)/sol_evap(i))
                     write(*,*) 'deltaDsnow_evap=',
     :                   deltaD(xtsnow_evap(iso_hdo,i)/snow_evap(i))
                     write(*,*) 'deltaD1new=',deltaD(
     :                   (xtevap(iso_hdo,i)*dtime+q10*R1(iso_hdo))
     :                   /(evap(i)*dtime+q10))
                     write(*,*) 'deltaD1=',   deltaD(R1(iso_hdo))
                     call iso_verif_aberrant(
     :                   (xtevap(iso_hdo,i)*dtime+q10*R1(iso_hdo))
     :                   /(evap(i)*dtime+q10),
     :                  'calcul_iso_surf_ter 1571')
                   endif
                 endif !if (evap(i).gt.ridicule_evap) then
                 if (iso_verif_aberrant_choix_nostop(xtevap(iso_HDO,i),
     :             evap(i),ridicule,1e5,'calcul_iso_surf_ter 1578')
     :                   .eq.1) then
                     write(*,*) 'i=',i
                     write(*,*) 'sol_evap,snow_evap=',
     ;                   sol_evap(i),snow_evap(i)
                     write(*,*) 'deltaDsol_evap=',
     :                   deltaD(xtsol_evap(iso_hdo,i)/sol_evap(i))
                     write(*,*) 'deltaDsnow_evap=',
     :                   deltaD(xtsnow_evap(iso_hdo,i)/snow_evap(i))
                     call iso_verif_aberrant(
     :                   (xtevap(iso_hdo,i)*dtime+q10*R1(iso_hdo))
     :                   /(evap(i)*dtime+q10),
     :                  'calcul_iso_surf_ter 1590')
                endif
                 if (qsol(i).gt.ridicule_qsol*1e2) then
                   call iso_verif_aberrant(xtsol(iso_HDO,i)/qsol(i)
     :                  /faccond,'calcul_iso_surf_ter 752')
                 endif !if (qsol(i).gt.ridicule_qsol) then
              endif !if (use_iso_eau.eq.1) then
              if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
               if (abs(evap(i)).gt.ridicule_qsol) then
                 call iso_verif_aberrant_o17(xtevap(iso_O17,i)
     :           /evap(i),xtevap(iso_O18,i)
     :           /evap(i),'iso_surf_ter 1827')
              endif !if ((evap(i).gt.ridicule).and.(xtevap(iso_O18,i)
             endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
#ifdef ISOTRAC
           call iso_verif_tracnps(xtevap(1,i),
     :          'calcul_iso_surf_ter 1847')
#endif              
           enddo !do i=1,knon 
                  
#endif
        if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
         do i=1,knon     
          xtsol(iso_eau,i)=qsol(i) 
         enddo !do i=1,knon   
        endif

      if (sorties_gdat) then
!#include "debug_iso_sol.h"    
      ! on commente car necessite de passer le ni en argument      
      endif

#ifdef ISOVERIF
      ! verif du bilan de masse d'eau et d'isotopes pour le sol

      do i=1,knon
         dqdiag=precip_rain(i)*dtime+fqfonte_neige(i)
     :            -(evap(i)-snow_evap(i))*dtime-run_off(i)
         if (iso_verif_egalite_choix_nostop(dqdiag,
     :           qsol(i)-qsol_prec(i),'ter 2087',
     :           errmax_sol*max(qsol(i),1.0),errmaxrel).eq.1) then
             write(*,*) 'calcul_iso_surf_ter 2050: bilan qsol,i=',i
             write(*,*) 'qsol(i)=',qsol(i)
             write(*,*) 'qsol_prec(i)=',qsol_prec(i)
             write(*,*) 'precip_rain(i)*dt=',precip_rain(i)*dtime
             write(*,*) 'fqfonte_neige(i)=',fqfonte_neige(i)
             write(*,*) 'evap(i)*dt=',evap(i)*dtime
             write(*,*) 'snow_evap(i)*dt=',snow_evap(i)*dtime
             write(*,*) 'run_off(i) (diag)=',run_off(i)
             write(*,*) 'runoff_tmp(i)=',runoff_tmp(i)
             stop
         endif !if (iso_verif_egalite_choix_nostop(dqdiag,
         if (evap_cont_cste.ne.1) then
             ! si evap_cont_cste=1, on prescrit compo de l'vap du sol
             ! -> normal de ne pas conserver la masse d'isotopes
         do ixt=1,niso
            dqdiag=xtprecip_rain(ixt,i)*dtime+fxtfonte_neige(ixt,i)
     :            -(xtevap(ixt,i)-xtsnow_evap(ixt,i))*dtime
     :            -xtrun_off(ixt,i)   
            if (iso_verif_egalite_choix_nostop(dqdiag,
     :           xtsol(ixt,i)-xtsol_prec(ixt,i),'ter 1887',
     :           errmax_sol*max(qsol(i),1.0),errmaxrel).eq.1) then
             write(*,*) 'calcul_iso_surf_ter 2066: bilan xtsol, ixt=',
     :           ixt
             write(*,*) 'xtsol(ixt,i)=',xtsol(ixt,i)
             write(*,*) 'xtsol_prec(i)=',xtsol_prec(ixt,i)
             write(*,*) 'xtprecip_rain(i)*dt=',xtprecip_rain(ixt,i)
     :           *dtime
             write(*,*) 'fxtfonte_neige(i)=',fxtfonte_neige(ixt,i)
             write(*,*) 'xtevap(i)*dt=',xtevap(ixt,i)*dtime
             write(*,*) 'xtsnow_evap(i)*dt=',xtsnow_evap(ixt,i)*dtime
             write(*,*) 'xtrun_off(i)=',xtrun_off(ixt,i)
             write(*,*) 'i=',i
             write(*,*) 'qsol(i)=',qsol(i)
             write(*,*) 'qsol_prec(i)=',qsol_prec(i)
             write(*,*) 'precip_rain(i)*dt=',precip_rain(i)*dtime
             write(*,*) 'fqfonte_neige(i)=',fqfonte_neige(i)
             write(*,*) 'evap(i)*dt=',evap(i)*dtime
             write(*,*) 'snow_evap(i)*dt=',snow_evap(i)*dtime
             write(*,*) 'run_off(i) (diag)=',run_off(i)
             write(*,*) 'runoff_tmp(i)=',runoff_tmp(i)
             if (qsol_prec(i).gt.-ridicule) then
                 stop
                 ! sinon, si qsolprec<0, on fait compo du sol=compo des
                 ! inputs pour viyer deltaD aberrants -> masse pas tout
                 !  fait conserve. On croise les doigts pour que ce
                 ! cas pathologique arrive rarement.
             endif             
           endif    
          enddo
         endif !if (evap_cont_cste.ne.1) then
      enddo !do i=1,knon

#endif      

      ! on rescale le runoff pour qu'il soit en kg/m2/s
        do i=1,knon
        run_off(i)=run_off(i)/dtime
        runoff_tmp(i)=runoff_tmp(i)/dtime
        do ixt=1,niso
           xtrun_off(ixt,i)=xtrun_off(ixt,i)/dtime           
        enddo !do ixt=1,niso
        enddo !do i=1,knon

        return
        end !subroutine calcul_iso_surf_ter

        subroutine gestion_neige(klon,knon,snow,xtsnow,
     :           snow_prec,xtsnow_prec,dtime,
     :           precip_snow,xtprecip_snow,fqfonte_neige,
     :           fqcalving,snow_evap,xtsnow_evap,fxtfonte_neige,
     :           xt1lay,q1lay,Tsurf_new,t_coup)
        implicit none

        ! gestion de la neige: on precipte dessus, sublime, effondre,
        ! fond, etc...
        ! commun aux dffrentes sous-surfaces.

#include "wateriso2.h"
#include "iso_verif.h"
#include "YOETHF.h" 
#include "FCTTRE.h"   
#include "YOMCST.h"
#include "dimensions.h"
#include "paramet.h"

         ! inputs
        integer klon,knon
        real dtime
        real snow(klon),snow_prec(klon)
        real xtsnow_prec(niso,klon)
        real precip_snow(klon),xtprecip_snow(ntraciso,klon)
        real snow_evap(klon)
        real fqfonte_neige(klon)
        real fqcalving(klon)
        real t_coup
        real q1lay(klon)
        real xt1lay(ntraciso,klon)
        real Tsurf_new(klon)
        
        ! inouts
        real xtsnow(niso,klon)

        ! outputs
        real xtsnow_evap(ntraciso,klon)
        real fxtfonte_neige(niso,klon)

        ! locals
        real snow_apres_precip(klon),xtsnow_apres_precip(niso,klon)
        real snow_avant_evap(klon),xtsnow_avant_evap(niso,klon)
        real Rsnow_apres_precip(niso,klon), Rsnow_avant_evap(niso,klon)
        real snow_avant_calving(klon), xtsnow_avant_calving(niso,klon)
        real fxtcalving(niso,klon)
        integer i,ixt
#ifdef ISOVERIF
        integer iso_verif_aberrant_O17_nostop ! juste debug
        real o17excess        
        real dqdiag        
        real snow_max
        parameter (snow_max=3000.)
#endif        
#ifdef ISOVERIF
        integer iso_verif_aberrant_nostop ! juste debug        
        integer iso_verif_aberrant_choix_nostop
        integer iso_verif_egalite_choix_nostop
        integer iso_verif_positif_nostop
        integer iso_verif_egalite_nostop
        integer iso_verif_positif_choix_nostop
        real deltaD
#endif  
#ifdef ISOVERIFNAN
        integer iso_verif_noNaN_nostop
#endif  

#ifdef ISOVERIF  
       if (use_iso_eau.eq.1) then  
        do i=1,knon
          call iso_verif_egalite_choix(
     &          xtsnow(iso_eau,i),snow_prec(i), 
     &         'calcul_iso_surf_vectall 2157',errmax,errmaxrel)
        enddo
      endif
#endif
        do i=1,knon
        
        ! on precipe sur la neige
        snow_apres_precip(i)=snow_prec(i)+precip_snow(i)*dtime
        do ixt=1,niso
         xtsnow_apres_precip(ixt,i)=xtsnow_prec(ixt,i)
     :           +xtprecip_snow(ixt,i)*dtime
#ifdef ISOVERIFNAN
         if (iso_verif_noNaN_nostop(xtsnow_apres_precip(ixt,i), 
     &         'calcul_iso_surf_vectall 2260').eq.1) then
            write(*,*) 'xtsnow_prec(ixt,i)=',xtsnow_prec(ixt,i)
            write(*,*) 'xtprecip_snow(ixt,i)=',xtprecip_snow(ixt,i)
            stop
         endif
#endif        
        enddo      
        ! peu importe la compo en traceurs de la neige, car de toute
        ! faon la nege est vapore avec un certain tagging: izone_cont
      enddo !do i=1,knon

#ifdef ISOVERIF  
      do i=1,knon         
        if (use_iso_eau.eq.1) then  
            if (iso_verif_egalite_choix_nostop(
     :               xtsnow_apres_precip(iso_eau,i),
     :               snow_apres_precip(i),'calcul_iso_surf_ter 1028',
     :               errmax,errmaxrel).eq.1) then
              write(*,*) 'snow_prec(i),xtsnow_prec(iso_eau,i)=',
     ;           snow_prec(i),xtsnow_prec(iso_eau,i)
              write(*,*) 'precip_snow(i),xtprecip_snow(iso_eau,i)=',
     ;           precip_snow(i),xtprecip_snow(iso_eau,i)
              stop
            endif
        endif !if (use_iso_eau.eq.1) then
        if (use_iso_hdo.eq.1) then                   
             call iso_verif_aberrant_choix(
     :             xtsnow_apres_precip(iso_hdo,i),
     :             snow_apres_precip(i),ridicule_snow,deltalim_snow,
     :             'calcul_iso_surf_ter 1931')
         endif !if (use_iso_eau.eq.1) then
       enddo
#endif
        
        ! on fond la neige
      do i=1,knon  
        if (fqfonte_neige(i).gt.ridicule) then
          if (snow_apres_precip(i).gt.ridicule) then
            do ixt=1,niso
              Rsnow_apres_precip(ixt,i)=xtsnow_apres_precip(ixt,i)/
     :                   snow_apres_precip(i)
            ! (H) pas de frac pendant la fonte neige
              fxtfonte_neige(ixt,i)=fqfonte_neige(i)
     :           *Rsnow_apres_precip(ixt,i)
#ifdef ISOVERIFNAN
              if ((iso_verif_noNaN_nostop(Rsnow_apres_precip(ixt,i),
     :           'calcul_iso_surf_ter 2294a').eq.1).or.
     :           (iso_verif_noNaN_nostop(fxtfonte_neige(ixt,i),
     :           'calcul_iso_surf_ter 2294b').eq.1)) then
                write(*,*) 'ixt,i=',ixt,i
                write(*,*) 'xtsnow_apres_precip,snow_apres_precip=',
     :                   xtsnow_apres_precip(ixt,i),
     :                   snow_apres_precip(i)
                write(*,*) 'fqfonte_neige(i)=',fqfonte_neige(i)
                stop
              endif
#endif
            enddo !do ixt=1,niso
          else !if (snow_apres_precip(i).gt.0) then
                ! fonte de quoi? pas de neige!!
              write(*,*) 'calcul_iso_surf_ter 588: fqfonte_neige(i)=',
     :           fqfonte_neige(i)
              write(*,*) 'snow_apres_precip(i)=',snow_apres_precip(i)
              stop
          endif !if (snow_apres_precip(i).gt.0) then
        else !endif !if (fqfonte_neige(i).gt.0.0) then
           do ixt=1,niso
              fxtfonte_neige(ixt,i)=0.0
           enddo !do ixt=1,niso          
        endif !if (fqfonte_neige(i).gt.0.0) then
      enddo !do i=1,knon   
#ifdef ISOVERIFNAN
      do i=1,knon
        do ixt=1,niso
          call iso_verif_noNaN(xtsnow_apres_precip(ixt,i),
     :           'calcul_iso_surf_ter 2312')
          call iso_verif_noNaN(fxtfonte_neige(ixt,i),
     :           'calcul_iso_surf_ter 2315')
        enddo !do ixt=1,niso
       enddo !do i=1,knon  
#endif
      do i=1,knon
        snow_avant_evap(i)=snow_apres_precip(i)-fqfonte_neige(i)
        do ixt=1,niso
          xtsnow_avant_evap(ixt,i)=xtsnow_apres_precip(ixt,i)
     :           -fxtfonte_neige(ixt,i)
#ifdef ISOVERIFNAN
          if (iso_verif_noNaN_nostop(xtsnow_avant_evap(ixt,i),
     :          'calcul_iso_surf_ter 2363').eq.1) then
                  write(*,*) 'xtsnow_apres_precip(ixt,i)=',
     :                  xtsnow_apres_precip(ixt,i)
                  write(*,*) 'fxtfonte_neige(ixt,i)=',
     :                  fxtfonte_neige(ixt,i)
                  stop
          endif
#endif          
        enddo !do ixt=1,niso
       enddo !do i=1,knon                  

         ! calcul de xtsnow_evap et du nouveau xtsnow:
#ifdef ISOVERIF
       do i=1,knon   
         ! on verifie que snow_avant_evap-snow_evap-fqcalving=snow
         if (iso_verif_egalite_choix_nostop(snow_avant_evap(i)
     :           -snow_evap(i)*dtime-fqcalving(i)*dtime,snow(i),
     :           'calcul_iso_surf_ter 224',errmax_sol*max(snow(i),1.0),
     :            errmaxrel)
     :           .eq.1) then
             write(*,*) 'snow(i)=',snow(i)
             write(*,*) 'snow_prec(i)=',snow_prec(i)
             write(*,*) 'precip_snow(i)*dt=',precip_snow(i)*dtime
             write(*,*) 'fqfonte_neige(i)=',fqfonte_neige(i)
             write(*,*) 'snow_evap(i)*dt=',snow_evap(i)*dtime
             write(*,*) 'fqcalving(i)=',fqcalving(i)*dtime
             write(*,*) 'snow_avant_evap(i)=',snow_avant_evap(i)
             write(*,*) 'snow_apres_precip(i)=',snow_apres_precip(i)
             stop
         endif
         if (use_iso_eau.eq.1) then  
                 call iso_verif_egalite_choix(
     :               xtsnow_avant_evap(iso_eau,i),
     :               snow_avant_evap(i),'calcul_iso_surf_ter 1082',
     :               errmax,errmaxrel)
          endif !if (use_iso_eau.eq.1) then
           if (use_iso_hdo.eq.1) then                   
             call iso_verif_aberrant_choix(xtsnow_avant_evap(iso_hdo,i),
     :                  snow_avant_evap(i),ridicule_snow,deltalim_snow,
     :                  'calcul_iso_surf_ter 1991')
          endif !if (use_iso_eau.eq.1) then
       enddo !do i=1,knon  
#endif            

        do i=1,knon   
         snow_avant_calving(i)=snow_avant_evap(i)-snow_evap(i)*dtime
        enddo !do i=1,knon    

        do i=1,knon
         if (snow_evap(i).gt.0.0) then
            ! sublimation positive, sans fractionnement            
            if (snow_avant_evap(i).gt.ridicule**2) then    
              ! on sublime sans fractionnement une partie de la neige.
              ! on en profite pour en effonfrer aussi ventuellement une
              ! partie.  
              do ixt=1,niso
               Rsnow_avant_evap(ixt,i)=xtsnow_avant_evap(ixt,i)/
     :           snow_avant_evap(i)
               xtsnow(ixt,i)=Rsnow_avant_evap(ixt,i)
     :                   *snow_avant_calving(i)
               xtsnow_evap(ixt,i)=snow_evap(i)*Rsnow_avant_evap(ixt,i)
              enddo   !do ixt=1,niso 
#ifdef ISOVERIFNAN
             do ixt=1,niso 
!              call iso_verif_noNaN(xtsnow_evap(ixt,i),
!     :          'calcul_iso_surf_ter 2543')
               if (iso_verif_noNaN_nostop(xtsnow_evap(ixt,i),
     :          'calcul_iso_surf_ter 2543').eq.1) then
                  write(*,*) 'xtsnow_avant_evap(ixt,i)=',
     :                  xtsnow_avant_evap(ixt,i)
                  write(*,*) 'snow_avant_evap(i)=',snow_avant_evap(i)
                  write(*,*) 'Rsnow_avant_evap(ixt,i)=',
     :                  Rsnow_avant_evap(ixt,i)
                  write(*,*) 'snow_evap(i)=',snow_evap(i)
                  write(*,*) 'ixt,i=',ixt,i
                  stop
               endif !if (iso_verif_noNaN_nostop(xtsnow_evap(ixt,i),
             enddo !do ixt=1,niso    
#endif
             
            else !if (snow_avant_evap(i).gt.0.0) then  
#ifdef ISOVERIF                
                write(*,*) 'iso_surf_lic 952: quoi evaporer?'
                write(*,*) 'snow_evap(i),snow_avant_evap(i)=',
     :                   snow_evap(i),snow_avant_evap(i)
                write(*,*) 'snow(i)=',snow(i)
!                stop                
#endif               
                if (snow_apres_precip(i).gt.0.0) then
                   ! on vapore la snow apres precip
                  do ixt=1,niso
                    xtsnow(ixt,i)=Rsnow_apres_precip(ixt,i)*snow(i)
                    xtsnow_evap(ixt,i)=snow_evap(i)
     :                  *Rsnow_apres_precip(ixt,i) 
#ifdef ISOVERIFIDRIS
          call iso_verif_noNaN(xtsnow_evap(ixt,i),
     :          'calcul_iso_surf_ter 2414')   
#endif              
                  enddo
                else  !if (snow_apres_precip(i).gt.0.0) then
#ifdef ISOVERIF                
                  write(*,*) 'iso_surf_lic 967: quoi evaporer? '//
     :                   'sans espoir'
                  write(*,*) 'snow_apres_precip(i)=',
     :                   snow_apres_precip(i)
                  stop                
#endif                       
                    ! on prend la compo par dfaut
                    do ixt=1,niso
                     Rsnow_avant_evap(ixt,i)=Rdefault(ixt)
                     xtsnow(ixt,i)=Rsnow_avant_evap(ixt,i)
     :                   *snow_avant_calving(i)
                     xtsnow_evap(ixt,i)=snow_evap(i)
     :                   *Rsnow_avant_evap(ixt,i)  
#ifdef ISOVERIF
          call iso_verif_noNaN(xtsnow_evap(ixt,i),
     :          'calcul_iso_surf_ter 2430')   
#endif              
                    enddo
                endif !if (snow_apres_precip(i).gt.0.0) then
              
                
            endif !if (snow_avant_evap(i).gt.0.0) then  
        else if (snow_evap(i).lt.0.0) then ! if (snow_evap(i).gt.0.0) then
            ! on a de la rose
            call iso_rosee_givre(xt1lay,q1lay,Tsurf_new,
     :            t_coup,snow_evap,i,xtsnow_evap,klon)
            ! les traceurs d'isotopes sont dj dans la rose
            do ixt=1,niso
              xtsnow(ixt,i)=xtsnow_avant_evap(ixt,i)-xtsnow_evap(ixt,i)
#ifdef ISOVERIF
          call iso_verif_noNaN(xtsnow_evap(ixt,i),
     :          'calcul_iso_surf_ter 2442')   
#endif          
            enddo
        else
            ! vaporation nulle            
            do ixt=1,ntraciso
              xtsnow_evap(ixt,i)=0.0
            enddo  
            do ixt=1,niso  
              xtsnow(ixt,i)=xtsnow_avant_evap(ixt,i)            
            enddo
        endif !if (snow_evap(i).gt.0.0) then

#ifdef ISOTRAC
              do ixt=niso+1,ntraciso
                if (index_zone(ixt).eq.izone_cont) then
                  xtsnow_evap(ixt,i)=xtsnow_evap(index_iso(ixt),i)
                else
                  xtsnow_evap(ixt,i)=0.0
                endif
             enddo
#endif   

      enddo !do i=1,knon    

        ! calving de la neige
#ifdef ISOVERIFNAN
       do i=1,knon        
        do ixt=1,ntraciso
          call iso_verif_noNaN(xtsnow_evap(ixt,i),
     :          'calcul_iso_surf_ter 2167')
        enddo   
       enddo
#endif   
#ifdef ISOVERIF
        ! on verifie que snow_avant_evap-snow_evap-fqcalving=snow
       do i=1,knon           
        if (iso_verif_egalite_choix_nostop(snow_avant_calving(i)
     :           -fqcalving(i)*dtime,snow(i),
     :           'calcul_iso_surf_ter 1087',errmax_sol*max(snow(i),1.0),
     :           errmaxrel)
     :           .eq.1) then
             write(*,*) 'snow(i)=',snow(i)
             write(*,*) 'snow_prec(i)=',snow_prec(i)
             write(*,*) 'precip_snow(i)*dt=',precip_snow(i)*dtime
             write(*,*) 'fqfonte_neige(i)=',fqfonte_neige(i)
             write(*,*) 'snow_evap(i)*dt=',snow_evap(i)*dtime
             write(*,*) 'fqcalving(i)*dt=',fqcalving(i)*dtime
             write(*,*) 'snow_avant_evap(i)=',snow_avant_evap(i)
             write(*,*) 'snow_apres_precip(i)=',snow_apres_precip(i)
             write(*,*) 'snow_avant_calving(i)=',snow_avant_calving(i)
             stop
         endif
         if (use_iso_eau.eq.1) then  
                 call iso_verif_egalite_choix(xtsnow(iso_eau,i),
     :               snow_avant_calving(i),'calcul_iso_surf_ter 1172',
     :               errmax,errmaxrel)
                 call iso_verif_egalite_choix(xtsnow_evap(iso_eau,i),
     :               snow_evap(i),'calcul_iso_surf_ter 1198',
     :               errmax,errmaxrel)
          endif !if (use_iso_eau.eq.1) then
          if (use_iso_hdo.eq.1) then                   
             call iso_verif_aberrant_choix(xtsnow(iso_hdo,i),
     :           snow_avant_calving(i),ridicule_snow,deltalim_snow,
     :           'calcul_iso_surf_ter 2090')
          endif !if (use_iso_eau.eq.1) then
#ifdef ISOTRAC
          call iso_verif_traceur(xtsnow_evap(1,i),
     :           'calcul_iso_surf gestion neige 2146')
#endif          
        enddo !do i=1,knon  
#endif         
       do i=1,knon   
        if (fqcalving(i).gt.0.0) then
#ifdef ISOVERIF   
            call iso_verif_positif_strict(snow_avant_calving(i),
     :           'calcul_iso_surf_ter 1092')
#endif            
          do ixt=1,niso
            xtsnow(ixt,i)=xtsnow(ixt,i)
     :           /snow_avant_calving(i)*snow(i)
            fxtcalving(ixt,i)=xtsnow(ixt,i)
     :           /snow_avant_calving(i)*fqcalving(i)
          enddo !do ixt=1,niso
        else
            do ixt=1,niso
              ! xtsnow(ixt,i) non modifi
              fxtcalving(ixt,i)=0.0
            enddo
        endif !if (fqcalving(i).gt.0.0) then

      enddo ! do i=1,knon

!#ifdef ISOVERIF
!      do i=1,knon
!              if (use_iso_eau.eq.1) then                   
!                 call iso_verif_egalite_choix(xtsnow(iso_eau,i),
!     :                  snow(i),'calcul_iso_surf_ter 1201a',
!     :                  errmax_sol,errmaxrel)
!             endif !if (use_iso_eau.eq.1) then 
!             if (use_iso_hdo.eq.1) then                   
!                 call iso_verif_aberrant_choix(xtsnow(iso_hdo,i),
!     :                  snow(i),ridicule_snow,deltalim_snow,
!     :                  'calcul_iso_surf_ter 1201b')
!             endif !if (use_iso_eau.eq.1) then
!      enddo !do i=1,knon               
!endif
      
      ! bidouille anti-divergence: utile pour viter propagation des
      ! erreurs numriques
      if ((use_iso_eau.eq.1).and.(bidouille_anti_divergence)) then
          do i=1,knon
            xtsnow(iso_eau,i)=snow(i)
          enddo
      endif !if ((use_iso_eau.eq.1).and.(bidouille_anti_divergence)) then  

      ! verif cons masse de la neige
#ifdef ISOVERIF      
        do i=1,knon
         dqdiag=min(precip_snow(i)*dtime-fqfonte_neige(i)
     :            -snow_evap(i)*dtime-fqcalving(i)*dtime,
     :             snow_max-snow_prec(i))
         if (iso_verif_egalite_choix_nostop(dqdiag,
     :           snow(i)-snow_prec(i),'ter 2128',
     :           errmax_sol*max(snow(i),1.0),errmaxrel).eq.1) then
             write(*,*) 'calcul_iso_surf_ter 2086: bilan qsnow'
             write(*,*) 'snow(i)=',snow(i)
             write(*,*) 'snow_prec(i)=',snow_prec(i)
             write(*,*) 'precip_snow(i)*dt=',precip_snow(i)*dtime
             write(*,*) 'fqfonte_neige(i)=',fqfonte_neige(i)
             write(*,*) 'snow_evap(i)*dt=',snow_evap(i)*dtime
             write(*,*) 'fqcalving(i)=',fqcalving(i)*dtime
             stop
         endif
         if (snow(i).lt.snow_max) then
         do ixt=1,niso
            dqdiag=xtprecip_snow(ixt,i)*dtime-fxtfonte_neige(ixt,i)
     :            -xtsnow_evap(ixt,i)*dtime-fxtcalving(ixt,i)
            if (iso_verif_egalite_choix_nostop(dqdiag,
     :           xtsnow(ixt,i)-xtsnow_prec(ixt,i),'ter 2144',
     :           errmax_sol*max(snow(i),1.0),errmaxrel).eq.1) then
             write(*,*) 'calcul_iso_surf_ter 2101: bilan xtsnow, ixt=',
     :           ixt
             write(*,*) 'i=',i
             write(*,*) 'snow(i)=',snow(i)
             write(*,*) 'snow_prec(i)=',snow_prec(i)
             write(*,*) 'precip_snow(i)*dt=',precip_snow(i)*dtime
             write(*,*) 'fqfonte_neige(i)=',fqfonte_neige(i)
             write(*,*) 'snow_evap(i)*dt=',snow_evap(i)*dtime
             write(*,*) 'fqcalving(i)=',fqcalving(i)*dtime
             write(*,*) 'xtsnow(ixt,i)=',xtsnow(ixt,i)
             write(*,*) 'xtsnow_prec(i)=',xtsnow_prec(ixt,i)
             write(*,*) 'xtprecip_snow(i)*dt=',xtprecip_snow(ixt,i)
     :                   *dtime
             write(*,*) 'fxtfonte_neige(i)=',fxtfonte_neige(ixt,i)
             write(*,*) 'xtsnow_evap(i)*dt=',xtsnow_evap(ixt,i)*dtime
             write(*,*) 'fxtcalving(i)=',fxtcalving(ixt,i)
             stop
           endif    
           enddo ! do ixt=1,niso
         endif ! if (snow(i).lt.snow_max) then
      enddo !do i=1,knon      
#endif
       
        return
        end

#endif
! endif ifdef iso

