#ifdef ISO
      subroutine compress_calculJ(ncas,ncas_Rieman,ncas_Jsimple,
     :           cas_rieman,cas_Jsimple,
     :           m_cas,m, m0_cas,m0, 
     :           qp0_cas,qp0, A_cas,A,
     :           xtp0_cas,xtp0,   
     :           beta_cas,beta,gama_cas,gama,
!     :           f_cas,f, g_cas,g,ntot_cas,h,
     :           f_cas,f, g_cas,g,h,
     :           Rb0_cas,Rb0,
     :           Rl0_cas,Rl0,
     :           r_l0qp0_cas,r_l0qp0,
     :           Eqi_cas,Eqi,
     :           fac_ftmr_cas,fac_ftmr,
     :           Pxtisup_cas,Pxtisup,
     :           Pqiinf_cas,Pqiinf)
         implicit none

         ! compression des variables en tableaux spcifiques pour le
         ! calcul d'intgral soit simple, soit par Rieman.

#include "wateriso2.h"  
  
         integer ncas ! dimension officielle des variables
         integer ncas_rieman,ncas_Jsimple ! nombre de variables  compresser
         integer cas_rieman(ncas),cas_Jsimple(ncas) ! tableaux d'index
         double precision m_cas(ncas),m(ncas),
     : m0_cas(ncas),m0(ncas),
     : qp0_cas(ncas),qp0(ncas),
     : xtp0_cas(niso,ncas),xtp0(niso,ncas),    
     : A_cas(ncas),A(ncas),
     : beta_cas(niso,ncas),beta(niso,ncas),
     : gama_cas(niso,ncas),gama(niso,ncas),
     : f_cas(ncas),f(ncas),
     : g_cas(ncas),g(ncas),
     : Rb0_cas(niso,ncas),Rb0(niso,ncas),
     : Rl0_cas(niso,ncas),Rl0(niso,ncas),
     : r_l0qp0_cas(ncas),r_l0qp0(ncas),
     : Eqi_cas(ncas),Eqi(ncas),
     : Pxtisup_cas(niso,ncas),Pxtisup(niso,ncas),
     : Pqiinf_cas(ncas),Pqiinf(ncas),
     : fac_ftmr_cas(ncas),fac_ftmr(ncas)
         real h(ncas)
!         integer ntot_cas(ncas)
         integer il,ixt        
         integer coeff_precision
         parameter (coeff_precision=0.2)


         ! mthode de calcul d'intgrale
         ! si rieman:
!#define rieman
        ! sinon: mthode de gauss         

#ifdef ISOVERIFIDRIS         
#include "iso_verif.h" 
        real double_to_real      
#endif         

#ifdef ISOVERIF
!         write(*,*) 'compress_stewart 45: entre compress_calculJ'
!         write(*,*) 'ncas_Jsimple=',ncas_Jsimple
#endif      
        if (ncas_Jsimple.gt.0) then   
         do il=1,ncas_Jsimple
!           write(*,*) 'compress_stewart 50: il=',il
           m0_cas(il)=m0(cas_Jsimple(il))
!           write(*,*) 'compress_stewart 51: il=',il
           m_cas(il)=m(cas_Jsimple(il))
           qp0_cas(il)=qp0(cas_Jsimple(il))
!           write(*,*) 'compress_stewart 54: il=',il
           A_cas(il)=A(cas_Jsimple(il))                     
           f_cas(il)=f(cas_Jsimple(il))
#ifdef ISOVERIF           
           call iso_verif_egalite_choix(double_to_real(f_cas(il)),
     :          double_to_real(m_cas(il)/m0_cas(il)),
     :          'compress_stewart 66',errmax,errmaxrel)
#endif           
!           write(*,*) 'compress_stewart 56: il=',il
           g_cas(il)=g(cas_Jsimple(il))
           r_l0qp0_cas(il)=r_l0qp0(cas_Jsimple(il))
           Eqi_cas(il)=Eqi(cas_Jsimple(il))
!           write(*,*) 'compress_stewart 60: il=',il
           fac_ftmr_cas(il)=fac_ftmr(cas_Jsimple(il))
           Pqiinf_cas(il)=Pqiinf(cas_Jsimple(il))
!           write(*,*) 'compress_stewart 61: il=',il
           do ixt=1,niso
!             write(*,*) 'il,ixt=',il,ixt
             xtp0_cas(ixt,il)=xtp0(ixt,cas_Jsimple(il))
             beta_cas(ixt,il)=beta(ixt,cas_Jsimple(il))
             gama_cas(ixt,il)=gama(ixt,cas_Jsimple(il))
             Rb0_cas(ixt,il)=Rb0(ixt,cas_Jsimple(il))
             Rl0_cas(ixt,il)=Rl0(ixt,cas_Jsimple(il))
             Pxtisup_cas(ixt,il)=Pxtisup(ixt,cas_Jsimple(il))
           enddo !do ixt=1,niso
         enddo !do il=1,ncas_Jsimple
        endif !if (ncas_Jsimple.gt.0) then   

        if (ncas_rieman.gt.0) then 
         do il=1,ncas_rieman
           m0_cas(il+ncas_Jsimple)=m0(cas_rieman(il))
           m_cas(il+ncas_Jsimple)=m(cas_rieman(il))
           qp0_cas(il+ncas_Jsimple)=qp0(cas_rieman(il))
           A_cas(il+ncas_Jsimple)=A(cas_rieman(il))          
           f_cas(il+ncas_Jsimple)=f(cas_rieman(il))
           r_l0qp0_cas(il+ncas_Jsimple)=r_l0qp0(cas_rieman(il))
#ifdef ISOVERIF          
           call iso_verif_egalite_choix_nostop(
     :         double_to_real(f_cas(il+ncas_Jsimple)),
     :         double_to_real(m_cas(il+ncas_Jsimple)
     :         /m0_cas(il+ncas_Jsimple)),'compress_stewart 66',
     :         errmax,errmaxrel)
#endif           

           g_cas(il+ncas_Jsimple)=g(cas_rieman(il))
           Eqi_cas(il+ncas_Jsimple)=Eqi(cas_rieman(il))
           fac_ftmr_cas(il+ncas_Jsimple)=fac_ftmr(cas_rieman(il))
           Pqiinf_cas(il+ncas_Jsimple)=Pqiinf(cas_rieman(il))
           do ixt=1,niso
             xtp0_cas(ixt,il+ncas_Jsimple)=xtp0(ixt,cas_rieman(il))
             beta_cas(ixt,il+ncas_Jsimple)=beta(ixt,cas_rieman(il))
             gama_cas(ixt,il+ncas_Jsimple)=gama(ixt,cas_rieman(il))
             Rb0_cas(ixt,il+ncas_Jsimple)=Rb0(ixt,cas_rieman(il))
             Rl0_cas(ixt,il+ncas_Jsimple)=Rl0(ixt,cas_rieman(il))
             Pxtisup_cas(ixt,il+ncas_Jsimple)=
     :           Pxtisup(ixt,cas_rieman(il))
           enddo !do ixt=1,niso
!#ifdef rieman           
!           ntot_cas(il+ncas_Jsimple)=10
!     :           +int((1-0.5*f(cas_rieman(il)))
!     :           *0.02*(exp(2*h(cas_rieman(il))))**6)
!#else
!           ntot_cas(il+ncas_Jsimple)=300
!     :         +35*(1-f(cas_rieman(il)))**3
!     :         +2.1e4*(h(cas_rieman(il))-0.9)**3
!     :         +2.5e5*((1-f(cas_rieman(il)))**6)
!     :                   *((h(cas_rieman(il))-0.9)**3)

!#endif     
!#ifdef ISOVERIF           
!!           write(*,*) ' f,h,ntot_cas=',f(cas_rieman(il)),
!!     :           h(cas_rieman(il)),ntot_cas(il+ncas_Jsimple)     
!           call iso_verif_positif(float(ntot_cas(il+ncas_Jsimple))-1.0,
!     :           'compress_stewart 136: ntot faux')
!#endif           
         enddo !do il=1,ncas_rieman
       endif !if (ncas_rieman.gt.0) then 
                
#ifdef ISOVERIF
        ! vrif de la compression:
        do il=1,ncas_Jsimple
          call iso_verif_egalite_choix(
     :           double_to_real(Pqiinf_cas(il)),
     :           double_to_real(Pqiinf(cas_Jsimple(il))),
     :           'compress_stewart 111',errmax,errmaxrel)
        enddo !do icas_Jsimple=1,ncas_Jsimple
        
        do il=1,ncas_rieman
          call iso_verif_egalite_choix(
     :           double_to_real(Pqiinf_cas(ncas_Jsimple+il)),
     :           double_to_real(Pqiinf(cas_rieman(il))),
     :           'compress_stewart  117',errmax,errmaxrel)
        enddo !do icas_Jsimple=1,ncas_Jsimple
!       write(*,*) 'compress_stewart 91: fin compress_calculJ'   
#endif  
       
         return
         end

         !*******************

         subroutine uncompress_calculJ(ncas,ncas_rieman,ncas_Jsimple,
     :          cas_rieman,cas_Jsimple,Exi_cas,Exi,
     :           xtnew_cas,xtnew,Pxtiinf_cas,Pxtiinf)
         implicit none 

         ! des compressions des cas de calcul de J dans stewart_explicit
#include "wateriso2.h"         
         integer ncas,ncas_rieman,ncas_Jsimple
         integer cas_rieman(ncas),cas_Jsimple(ncas)
         double precision Exi_cas(niso,ncas),Exi(niso,ncas),
     :       xtnew_cas(niso,ncas),xtnew(niso,ncas),
     :       Pxtiinf_cas(niso,ncas),Pxtiinf(niso,ncas)
         integer il,ixt


         do il=1,ncas_Jsimple
          do ixt=1,niso
           Exi(ixt,cas_Jsimple(il))=Exi_cas(ixt,il)
           xtnew(ixt,cas_Jsimple(il))=xtnew_cas(ixt,il)
           Pxtiinf(ixt,cas_Jsimple(il))=Pxtiinf_cas(ixt,il)
          enddo
         enddo

         do il=1,ncas_rieman
          do ixt=1,niso
           Exi(ixt,cas_rieman(il))=Exi_cas(ixt,il+ncas_Jsimple)
           xtnew(ixt,cas_rieman(il))=xtnew_cas(ixt,il+ncas_Jsimple)
           Pxtiinf(ixt,cas_rieman(il))=Pxtiinf_cas(ixt,il+ncas_Jsimple)
          enddo
         enddo

         return
         end

         ! ****************


         subroutine uncompress_commun(ncas, cas,
     :   xtp_cas,xtp,xtwater_cas,xtwater,xtevap_cas,xtevap,
#ifdef ISOVERIF
     :           Exi_cas,Exi,   
#endif
     :           ncum)
         implicit none 

         ! decompression des outputs communs  tous les cas dans
         ! appel_stewart

#include "wateriso2.h"         
         integer ncas,ncum
         integer cas(ncum)
         real xtevap_cas(niso,ncum)
         real xtp_cas(niso,ncum)
         real xtwater_cas(niso,ncum)

         ! outputs
         real xtwater(ntraciso,ncum)
         real xtp(ntraciso,ncum)
         real xtevap(ntraciso,ncum)

         ! locals
         integer il,ixt
#ifdef ISOVERIF
         double precision Exi_cas(niso,ncum)
         double precision Exi(ntraciso,ncum)
#endif         


         do il=1,ncas
          do ixt=1,niso
           xtevap(ixt,cas(il))=xtevap_cas(ixt,il)
           xtp(ixt,cas(il))=xtp_cas(ixt,il)
           xtwater(ixt,cas(il))=xtwater_cas(ixt,il)
#ifdef ISOVERIF
           Exi(ixt,cas(il))=Exi_cas(ixt,il)
#endif           
          enddo
         enddo

         return
         end


#ifdef ISOTRAC         
         subroutine uncompress_commun_zone(ncas, cas,
     :   xtp_cas,xtp,xtwater_cas,xtwater,xtevap_cas,xtevap,
     :           ncum,izone)
         implicit none 

         ! decompression des outputs communs  tous les cas dans
         ! appel_stewart
         ! cas des traceurs. Ici, aucun risque de revap franche.

#include "wateriso2.h"
         ! inputs
         integer ncas,ncum
         integer cas(ncum)
         real xtevap_cas(niso,ncum)
         real xtp_cas(niso,ncum)
         real xtwater_cas(niso,ncum)
         integer izone
         ! outputs
         real xtwater(ntraciso,ncum)
         real xtp(ntraciso,ncum)
         real xtevap(ntraciso,ncum)

         ! locals
         integer il,ixt,iiso,ixt_revap


         do il=1,ncas
             do iiso=1,niso 
               ixt=index_trac(izone,iiso) 
               xtevap(ixt,cas(il))=xtevap_cas(iiso,il)
               xtp(ixt,cas(il))=xtp_cas(iiso,il)
               xtwater(ixt,cas(il))=xtwater_cas(iiso,il)
           enddo !do iiso=1,niso
         enddo !do il=1,ncas

         return
         end

         subroutine uncompress_commun_zone_revap(ncas, cas,
     :          xtp_cas,xtp,xtwater_cas,xtwater,
     :          xtevap_cas,xtevap,
     :          ncum,izone,Eqi_stewart,fac_ftmr_cas,
#ifdef ISOVERIF
     :           Exi_cas,Exi,   
#endif
     ;          xtp_avantevap_cas,liq,hdiag)
         implicit none 

         ! decompression des outputs communs  tous les cas dans
         ! appel_stewart
         ! cas des traceurs: mais ici, risque de rvap franche -> on fat
         ! plus attention

#include "wateriso2.h"
         ! inputs
         integer ncas,ncum
         integer cas(ncum)
         real xtevap_cas(niso,ncum)
         real xtp_cas(niso,ncum)
         real xtwater_cas(niso,ncum)
         integer izone
         double precision Eqi_stewart(ncum)
         double precision xtp_avantevap_cas(niso,ncum)
         double precision fac_ftmr_cas(ncum) 
         integer liq  
         real hdiag(ncas)      
         
         ! outputs
         real xtwater(ntraciso,ncum)
         real xtp(ntraciso,ncum)
         real xtevap(ntraciso,ncum)

         ! locals
         integer il,ixt,iiso,ixt_revap
         real xtaddp_tag(niso,ncum)
#ifdef ISOVERIF
         integer ieau,iHDO
         double precision Exi_cas(niso,ncum)
         double precision Exi(ntraciso,ncum)
#include "iso_verif.h"
#endif         

!        write(*,*) 'compress_stewart 315 tmp: ',
!     :           'entre dans uncompress_commun_zone_revap'

         do il=1,ncas       
          if ((option_revap.eq.1).and.
     :        ((((liq.eq.1).and.
     :        (Eqi_stewart(il)*fac_ftmr_cas(il).gt.evap_franche)
     :        .and.(hdiag(il).lt.0.99)).or.
     :        ((liq.eq.0).and.
     :        (Eqi_stewart(il)*fac_ftmr_cas(il).ge.0.0))).or.
     :        (izone.eq.izone_revap))) then
!          if ((option_revap.eq.1).and.
!     :           (((Eqi_stewart(il)*fac_ftmr_cas(il).gt.evap_franche)
!     :           .or.((liq.eq.0).and.
!     :           (Eqi_stewart(il)*fac_ftmr_cas(il).ge.0.0))).or.
!     :           (izone.eq.izone_revap))) then
            ! on met la revap dans izone_revap si option_revap=1 et si:
            ! * evap glace (non fractionnante)
            ! * ou evap liq suffisemment forte pour que pas de flux
            ! d'isotopes ngatifs.
            ! si option_revap=1 et izone=izone_revap, on met aussi dans izone_revap
!#ifdef ISOVERIF            
!            if (il.eq.1) then
!            write(*,*) 'compress tmp 341: revap dans izone_revap'
!            write(*,*) 'Eqi_stewart(il),fac_ftmr_cas(il),evap_franche=',
!     :           Eqi_stewart(il),fac_ftmr_cas(il),evap_franche
!            write(*,*) 'il,xtp_cas(iso_eau,il)=',il,xtp_cas(iso_eau,il)
!            write(*,*) 'il,xtp_avantevap_cas(iso_eau,il)=',il,
!     :            xtp_avantevap_cas(iso_eau,il)
!            write(*,*) 'xtp(ixt_revap,cas(il))=',
!     :            xtp(index_trac(izone_revap,iso_eau),cas(il))
!            endif
!#endif           

            ! toute la rvap franche va dans izone_revap
            do iiso=1,niso
               ixt=index_trac(izone,iiso)           
               ixt_revap=index_trac(izone_revap,iiso)  
               ! le terme d'vap qui tait pour la zone izone devient
               ! nul, et  la place on le met dans izone_revap:               
               xtevap(ixt_revap,cas(il))=xtevap(ixt_revap,cas(il))
     :                   +xtevap_cas(iiso,il)

               ! ce qui a t ajout  xtp par rapport  xtp_avantevap
               ! est ajout  izone_revap, au lieu de izone
               xtaddp_tag(iiso,il)=xtp_cas(iiso,il)
     :                   -xtp_avantevap_cas(iiso,il)        
               xtp(ixt_revap,cas(il))=
     :                  xtp(ixt_revap,cas(il))
     :                  +xtaddp_tag(iiso,il)
            enddo !do iiso=1,niso
#ifdef ISOVERIF
            if (use_iso_HDO.eq.1) then
                if (xtevap_cas(iso_eau,il).gt.ridicule_evap) then
                    call iso_verif_aberrant_choix(
     :                 xtevap_cas(iso_HDO,il),xtevap_cas(iso_eau,il),
     :                 ridicule_trac,deltalimtrac*2,'compress 344a')
                endif
                ieau=index_trac(izone_revap,iso_eau)
                iHDO=index_trac(izone_revap,iso_HDO) 
                call iso_verif_aberrant_choix(xtevap(iHDO,cas(il)),
     :              xtevap(ieau,cas(il)),ridicule_trac,deltalimtrac*2,
     :              'compress 344b')
            endif !if (use_iso_HDO.eq.1) then
#endif            

            ! l'vap des autres zones devient nulle
            if (izone.ne.izone_revap) then
                do iiso=1,niso
                  ixt=index_trac(izone,iiso)
                  xtevap(ixt,cas(il))=0.0
                  xtp(ixt,cas(il))=xtp_avantevap_cas(iiso,il)
                enddo
            endif

!#ifdef ISOVERIF            
!            if (il.eq.1) then
!            write(*,*) 'compress tmp 341: revap dans izone_revap'
!            write(*,*) 'xtp(ixt_revap,cas(il))=',
!     :           xtp(index_trac(izone_revap,iso_eau),cas(il))
!            write(*,*) 'xtp(ixt,cas(il))=',
!     :            xtp(index_trac(izone,iso_eau),cas(il))
!            endif
!#endif            

           else !if ((Eqi_stewart(il).gt.ridicule_evap*100)

             do iiso=1,niso 
               ixt=index_trac(izone,iiso) 
               xtevap(ixt,cas(il))=xtevap_cas(iiso,il)
               xtp(ixt,cas(il))=xtp_cas(iiso,il)
             enddo !do iiso=1,niso
           endif !if ((Eqi_stewart(il).gt.ridicule_evap*100)
        enddo !do il=1,ncas

        do il=1,ncas
           do iiso=1,niso
             ixt=index_trac(izone,iiso)
             xtwater(ixt,cas(il))=xtwater_cas(iiso,il)
#ifdef ISOVERIF
             Exi(ixt,cas(il))=Exi_cas(iiso,il)
#endif             
           enddo !do iiso=1,niso
         enddo !do il=1,ncas
!         write(*,*) 'compress_stewart 361 tmp: ',
!     :           'sortie de uncompress_commun_zone_revap'
         
         return
         end
#endif
         !**************

         subroutine compress_cond_facftmr(
     :    ncas,  cas,
     :    Eqi_prime_cas,Eqi_prime,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,  
     :    T_cas,T, 
     :    fac_ftmr_cas,fac_ftmr, 
     :    qp_avantevap_cas,qp_avantevap,
     :    xtp_avantevap_cas,xtp_avantevap, 
     :    xtevapsup_cas,xtevap,
     :    water_cas,water,
     :    delP_cas,Ph,
#ifdef ISOVERIF        
     :    evap_cas,evap,qp_cas,qp,   
#endif           
     :    nloc,ncum,nd,i)
         implicit none

         ! compression dans le cas condensation_facftmr
#include "wateriso2.h"
         integer nd,ncum,nloc
         integer ncas
         integer cas(ncum)
         integer i
         real T_cas(ncum),T(ncum),
     :    xtevapsup_cas(niso,ncum),xtevap(ntraciso,ncum),
     :    water_cas(ncum),water(ncum),
     :    delP_cas(ncum),Ph(nloc,ND)
         double precision Eqi_prime_cas(ncum),Eqi_prime(ncum),
     :    Pqisup_cas(ncum),Pqisup(ncum), 
     :    Pxtisup_cas(niso,ncum),Pxtisup(ntraciso,ncum), 
     :    qp_avantevap_cas(ncum),qp_avantevap(ncum),
     :    xtp_avantevap_cas(niso,ncum),xtp_avantevap(ntraciso,ncum),
     :    fac_ftmr_cas(ncum),fac_ftmr(ncum)
         real evap_cas(ncum),evap(ncum),qp_cas(ncum),qp(ncum)
         integer il,ixt

          do il=1,ncas
            Eqi_prime_cas(il)=Eqi_prime(cas(il))
            Pqisup_cas(il)=Pqisup(cas(il))
            T_cas(il)=T(cas(il))
            fac_ftmr_cas(il)=fac_ftmr(cas(il))
            qp_avantevap_cas(il)=qp_avantevap(cas(il))
            water_cas(il)=water(cas(il))
            delP_cas(il)=Ph(cas(il),i)
     :         -Ph(cas(il),i+1)
#ifdef ISOVERIF              
            evap_cas(il)=evap(cas(il))
            qp_cas(il)=qp(cas(il))
#endif            
            do ixt=1,niso
              Pxtisup_cas(ixt,il)=Pxtisup(ixt,cas(il))
              xtp_avantevap_cas(ixt,il)=xtp_avantevap(ixt,cas(il))
              xtevapsup_cas(ixt,il)=xtevap(ixt,cas(il))
            enddo
          enddo 

         return
         end

#ifdef ISOTRAC
         subroutine compress_cond_facftmr_zone(
     :    ncas,  cas,
     :    Eqi_prime_cas,Eqi_prime,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,  
     :    qp_avantevap_cas,qp_avantevap,
     :    xtp_avantevap_cas,xtp_avantevap, 
     :    xtevapsup_cas,xtevap,
     :    water_cas,water,
#ifdef ISOVERIF        
     :    evap_cas,evap, 
#endif        
     :    nloc,ncum,nd,i,izone)
         implicit none

         ! compression dans le cas condensation_facftmr
#include "wateriso2.h"
         ! inputs
         integer nd,ncum,nloc
         integer ncas
         integer cas(ncum)
         integer i
         integer izone
         real 
     :    xtevapsup_cas(niso,ncum),xtevap(ntraciso,ncum),
     :    water_cas(ncum),water(ncum)
         double precision Eqi_prime_cas(ncum),Eqi_prime(ncum),
     :    Pqisup_cas(ncum),Pqisup(ncum), 
     :    Pxtisup_cas(niso,ncum),Pxtisup(ntraciso,ncum), 
     :    qp_avantevap_cas(ncum),qp_avantevap(ncum),
     :    xtp_avantevap_cas(niso,ncum),xtp_avantevap(ntraciso,ncum)
#ifdef ISOVERIFIDRIS      
         real evap_cas(ncum),evap(ncum)
#include "iso_verif.h" 
         real double_to_real        
#endif         
         ! locals
         integer il,ixt,ieau,iiso

          ieau=index_trac(izone,iso_eau)
          do il=1,ncas
            if (qp_avantevap(cas(il)).gt.0.0) then
               Eqi_prime_cas(il)=Eqi_prime(cas(il))
     :        *(xtp_avantevap(ieau,cas(il))/qp_avantevap(cas(il)))
            else !if (qp_avantevap_cas(cas(il)).gt.0.0) then
#ifdef ISOVERIF
                call iso_verif_egalite_choix(double_to_real
     :                   (Eqi_prime(cas(il))),0.0,
     :                   'compress_stewart 495',errmax,errmaxrel)
#endif
                Eqi_prime_cas(il)=0.0
            endif !if (qp_avantevap_cas(cas(il)).gt.0.0) thens
            
            if (Pqisup(cas(il))-Eqi_prime(cas(il)).gt.0.0) then
               water_cas(il)=water(cas(il))
     :           *((Pxtisup(ieau,cas(il))-Eqi_prime_cas(il))
     :           /(Pqisup(cas(il))-Eqi_prime(cas(il))))
            else !if (Pqisup(cas(il)).gt.0.0) then
#ifdef ISOVERIF
                call iso_verif_egalite_choix(water(cas(il)),0.0,
     :                   'compress_stewart 507',errmax,errmaxrel)
#endif
                water_cas(il)=0.0
            endif !if (Pqisup(cas(il)).gt.0.0) then

            Pqisup_cas(il)=Pxtisup(ieau,cas(il))
            qp_avantevap_cas(il)=xtp_avantevap(ieau,cas(il))

!#ifdef ISOVERIF
!            call iso_verif_noNaN(water_cas(il),'compress_stewart 518')
!            evap_cas(il)=evap(cas(il))
!     :        *(xtp_avantevap(ieau,cas(il))/qp_avantevap(cas(il)))
!!           qp_cas(il)=xtp(ieau,cas(il))     
!#endif
            do iiso=1,niso
              ixt=index_trac(izone,iiso)
              Pxtisup_cas(iiso,il)=Pxtisup(ixt,cas(il))
              xtp_avantevap_cas(iiso,il)=xtp_avantevap(ixt,cas(il))
              xtevapsup_cas(iiso,il)=xtevap(ixt,cas(il))
            enddo
          enddo 

         return
         end
#endif
         ! **************

        subroutine compress_cond_nofftmr(
     :    ncas,  cas,
     :    Eqi_prime_cas,Eqi_prime,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,
     :    water_cas,water,  
     :    T_cas,T,        
     :    qp_avantevap_cas,qp_avantevap,
     :    xtp_avantevap_cas,xtp_avantevap,
     :    xt_cas,xt,q_cas,q, 
     :    xtevapsup_cas,xtevap,
     :    delP_cas,Ph, 
#ifdef ISOVERIF
     :    evap_cas,evap,qp_cas,qp,
#endif      
     :    nloc,ncum,nd,i)
         implicit none

         ! compression dans le cas condensation_facftmr
#include "wateriso2.h"
         integer nloc,nd,ncum
         integer ncas
         integer cas(ncum)
         integer i
         real T_cas(ncum),T(ncum), 
     :    xt_cas(niso,ncum),q_cas(ncum),xt(ntraciso,ncum),q(ncum), 
     :    xtevapsup_cas(niso,ncum),xtevap(ntraciso,ncum),
     :    water_cas(ncum),water(ncum),          
     :    delP_cas(ncum),Ph(nloc,ND)
         double precision Eqi_prime_cas(ncum),Eqi_prime(ncum),
     :    Pqisup_cas(ncum),Pqisup(ncum), 
     :    Pxtisup_cas(niso,ncum),Pxtisup(ntraciso,ncum),
     :    qp_avantevap_cas(ncum),qp_avantevap(ncum),
     :    xtp_avantevap_cas(niso,ncum),xtp_avantevap(ntraciso,ncum)
#ifdef ISOVERIF         
         real evap_cas(ncum),evap(ncum),qp_cas(ncum),qp(ncum)
#endif         
         integer il,ixt

          do il=1,ncas
            Eqi_prime_cas(il)=Eqi_prime(cas(il))
            Pqisup_cas(il)=Pqisup(cas(il))
            water_cas(il)=water(cas(il))
            T_cas(il)=T(cas(il))
            qp_avantevap_cas(il)=qp_avantevap(cas(il))
            q_cas(il)=q(cas(il))
            delP_cas(il)=Ph(cas(il),i)
     :         -Ph(cas(il),i+1)
#ifdef ISOVERIF
            qp_cas(il)=qp(cas(il))
            evap_cas(il)=evap(cas(il))
#endif            
            do ixt=1,niso              
              Pxtisup_cas(ixt,il)=Pxtisup(ixt,cas(il))
              xtp_avantevap_cas(ixt,il)=xtp_avantevap(ixt,cas(il))
              xt_cas(ixt,il)=xt(ixt,cas(il))
              xtevapsup_cas(ixt,il)=xtevap(ixt,cas(il))
            enddo
          enddo 

         return
         end

#ifdef ISOTRAC
         subroutine compress_cond_nofftmr_zone(
     :    ncas,  cas,
     :    Eqi_prime_cas,Eqi_prime,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,
     :    water_cas,water,  
     :    qp_avantevap_cas,qp_avantevap,
     :    xtp_avantevap_cas,xtp_avantevap,
     :    xt_cas,xt,q_cas,q, 
     :    xtevapsup_cas,xtevap,
#ifdef ISOVERIF
     :    evap_cas,evap,
#endif      
     :    nloc,ncum,nd,i,izone)
         implicit none

         ! compression dans le cas condensation_facftmr
#include "wateriso2.h"
         ! inputs
         integer nloc,nd,ncum
         integer ncas
         integer cas(ncum)
         integer i
         integer izone
         real 
     :    xt_cas(niso,ncum),q_cas(ncum),xt(ntraciso,ncum),q(ncum), 
     :    xtevapsup_cas(niso,ncum),xtevap(ntraciso,ncum),
     :    water_cas(ncum),water(ncum)
         double precision Eqi_prime_cas(ncum),Eqi_prime(ncum),
     :    Pqisup_cas(ncum),Pqisup(ncum), 
     :    Pxtisup_cas(niso,ncum),Pxtisup(ntraciso,ncum),
     :    qp_avantevap_cas(ncum),qp_avantevap(ncum),
     :    xtp_avantevap_cas(niso,ncum),xtp_avantevap(ntraciso,ncum)
#ifdef ISOVERIF
         real evap_cas(ncum),evap(ncum)
#include "iso_verif.h"         
#endif         
         ! locals
          integer il,ixt,ieau,iiso

          ieau=index_trac(izone,iso_eau)
          do il=1,ncas
            if (qp_avantevap(cas(il)).gt.0) then
              Eqi_prime_cas(il)=Eqi_prime(cas(il))
     :           *(xtp_avantevap(ieau,cas(il))/qp_avantevap(cas(il)))
            else
                Eqi_prime_cas(il)=Eqi_prime(cas(il))
     :           *(xt(ieau,cas(il))/q(cas(il)))
            endif
            
            if (Pqisup(cas(il))-Eqi_prime(cas(il)).gt.0.0) then
              water_cas(il)=water(cas(il))
     :           *((Pxtisup(ieau,cas(il))-Eqi_prime_cas(il))
     :           /(Pqisup(cas(il))-Eqi_prime(cas(il))))
            else !if (Pqisup(cas(il)).gt.0.0) then
#ifdef ISOVERIF
                call iso_verif_egalite_choix(water(cas(il)),0.0,
     :                   'compress_stewart 654',errmax,errmaxrel)
#endif
                water_cas(il)=0.0
            endif !if (Pqisup(cas(il)).gt.0.0) then  

            Pqisup_cas(il)=Pxtisup(ieau,cas(il))
            qp_avantevap_cas(il)=xtp_avantevap(ieau,cas(il))
            q_cas(il)=xt(ieau,cas(il))
!#ifdef ISOVERIF
!            if (qp_avantevap(cas(il)).gt.0.0) then
!              evap_cas(il)=evap(cas(il))
!     :           *(xtp_avantevap(ieau,cas(il))/qp_avantevap(cas(il)))
!            else
!                evap_cas(il)=evap(cas(il))
!     :           *(xt(ieau,cas(il))/q(cas(il)))
!            endif
!            qp_cas(il)=xtp(ieau,cas(il))
!#endif            
            do iiso=1,niso 
              ixt=index_trac(izone,iiso)            
              Pxtisup_cas(iiso,il)=Pxtisup(ixt,cas(il))
              xtp_avantevap_cas(iiso,il)=xtp_avantevap(ixt,cas(il))
              xt_cas(iiso,il)=xt(ixt,cas(il))
              xtevapsup_cas(iiso,il)=xtevap(ixt,cas(il))
            enddo
          enddo 

         return
         end
#endif
         ! **************         

         subroutine compress_noevap(
     :    ncas,  cas,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,  
     :    xtp_avantevap_cas,xtp_avantevap,
     :    xtevapsup_cas,xtevap,
     :    water_cas,water,
     :    delP_cas,Ph, 
#ifdef ISOVERIF        
     :    evap_cas,evap,qp_cas,qp,
#endif 
     :    nloc,ncum,nd,i)
         implicit none

         ! compression dans le cas condensation_facftmr
#include "wateriso2.h"
         integer nloc,nd,ncum
         integer ncas
         integer cas(ncum)
         integer i
         real xtevapsup_cas(niso,ncum),xtevap(ntraciso,ncum),
     :    water_cas(ncum),water(ncum),
     :    delP_cas(ncum),Ph(nloc,ND)
         double precision Pqisup_cas(ncum),Pqisup(ncum), 
     :    Pxtisup_cas(niso,ncum),Pxtisup(ntraciso,ncum),  
     :    xtp_avantevap_cas(niso,ncum),xtp_avantevap(ntraciso,ncum)
#ifdef ISOVERIF         
         real evap_cas(ncum),evap(ncum),qp_cas(ncum),qp(ncum)
#endif         
         integer il,ixt

          do il=1,ncas
            Pqisup_cas(il)=Pqisup(cas(il))
            water_cas(il)=water(cas(il))
            delP_cas(il)=Ph(cas(il),i)
     :         -Ph(cas(il),i+1)
#ifdef ISOVERIF 
            evap_cas(il)=evap(cas(il))
            qp_cas(il)=qp(cas(il))        
#endif            
            do ixt=1,niso              
              Pxtisup_cas(ixt,il)=Pxtisup(ixt,cas(il))
              xtp_avantevap_cas(ixt,il)=xtp_avantevap(ixt,cas(il))
              xtevapsup_cas(ixt,il)=xtevap(ixt,cas(il))
            enddo
          enddo 

         return
         end

#ifdef ISOTRAC
         subroutine compress_noevap_zone(
     :    ncas,  cas,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,  
     :    xtp_avantevap_cas,xtp_avantevap,
     :    xtevapsup_cas,xtevap,
     :    water_cas,water,
#ifdef ISOVERIF        
     :    evap_cas,evap,
#endif 
     :    nloc,ncum,nd,i,izone)
         implicit none

         ! compression dans le cas condensation_facftmr
#include "wateriso2.h"
         integer nloc,nd,ncum
         integer ncas
         integer cas(ncum)
         integer i
         integer izone
         real xtevapsup_cas(niso,ncum),xtevap(ntraciso,ncum),
     :    water_cas(ncum),water(ncum)
         double precision Pqisup_cas(ncum),Pqisup(ncum), 
     :    Pxtisup_cas(niso,ncum),Pxtisup(ntraciso,ncum),  
     :    xtp_avantevap_cas(niso,ncum),xtp_avantevap(ntraciso,ncum)
#ifdef ISOVERIF        
        real evap_cas(ncum),evap(ncum)
#include "iso_verif.h"
#endif 
         integer il,ixt,ieau,iiso

          ieau=index_trac(izone,iso_eau)
          do il=1,ncas
            Pqisup_cas(il)=Pxtisup(ieau,cas(il))
            if (Pqisup(cas(il)).gt.0.0) then
               water_cas(il)=water(cas(il))
     :           *(Pxtisup(ieau,cas(il))/Pqisup(cas(il)))
            else
                water_cas(il)=0.0
#ifdef ISOVERIF                 
                call iso_verif_egalite_choix(water(cas(il)),
     :               0.0,'compress_stewart 709',errmax,errmaxrel)
#endif                
            endif
#ifdef ISOVERIF 
!            evap_cas(il)=evap(cas(il))
!     :           *(Pxtisup(ieau,cas(il))/Pqisup(cas(il)))
!            qp_cas(il)=xtp(ieau,cas(il))
#endif
            do iiso=1,niso
              ixt=index_trac(izone,iiso)            
              Pxtisup_cas(iiso,il)=Pxtisup(ixt,cas(il))
              xtp_avantevap_cas(iiso,il)=xtp_avantevap(ixt,cas(il))
              xtevapsup_cas(iiso,il)=xtevap(ixt,cas(il))
            enddo
          enddo 

         return
         end
#endif
         ! **************   

         subroutine compress_evap_liq(iflag_con,
     :    ncas,  
     :    cas,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,  
     :    qp_avantevap_cas,qp_avantevap,
     :    xtp_avantevap_cas,xtp_avantevap,
     :    xtevapsup_cas,xtevap,
     :    water_cas,water,
     :    qs_cas,qs,
     :    Eqi_stewart,Pqiinf_stewart,Eqi_prime_cas,
     :    Pqiinf,Eqi_par,Pqiinf_par,Eqi_prime, 
     :    Eqi,Eqi_cas, 
     :    fac_ftmr_cas,fac_ftmr,
     :    T_cas,T,
     :    wt_cas,wt,
     :    INB_cas,INB,          
     :    delP_cas,Ph,
     :    qp_cas,qp,
#ifdef ISOVERIF         
     :    evap_cas,evap,
#endif         
     :    nloc,ncum,nd,i)
         implicit none

         ! compression dans le cas condensation_facftmr
#include "wateriso2.h"
#include "iso_verif.h" 
        ! inputs et outputs  
         integer iflag_con   
         integer nloc,nd,ncum
         integer ncas
         integer cas(ncum)
         integer i
         real xtevapsup_cas(niso,ncum),xtevap(ntraciso,ncum),
     :    water_cas(ncum),water(ncum),
     :    qs_cas(ncum),qs(ncum),
     :    T_cas(ncum),T(ncum),
     :    wt_cas(ncum),wt(ncum),      
     :    delP_cas(ncum),Ph(nloc,ND)
         real qp_cas(ncum),qp(ncum)
#ifdef ISOVERIFIDRIS
         real evap_cas(ncum),evap(ncum)
         real double_to_real
         integer iso_verif_positif_nostop
#endif         
         double precision 
     :    qp_avantevap_cas(ncum),qp_avantevap(ncum),
     :    xtp_avantevap_cas(niso,ncum),xtp_avantevap(ntraciso,ncum),
     :    Eqi_stewart(ncum),Pqiinf_stewart(ncum),Eqi_prime_cas(ncum),
     :    Pqiinf(ncum),Eqi_par(ncum),Pqiinf_par(ncum),
     :    Eqi_prime(ncum),Pqisup(ncum),Pqisup_cas(ncum),
     :    Pxtisup(ntraciso,ncum),Pxtisup_cas(niso,ncum),
     :    fac_ftmr_cas(ncum),fac_ftmr(ncum),
     :    Eqi(ncum),Eqi_cas(ncum)
         integer INB_cas(ncum),INB(ncum)
         ! locals
         integer il,ixt

          do il=1,ncas
            Pqisup_cas(il)=Pqisup(cas(il))
            water_cas(il)=water(cas(il))
            qp_avantevap_cas(il)=qp_avantevap(cas(il))
            qs_cas(il)=qs(cas(il))
            Eqi_prime_cas(il)=Eqi_prime(cas(il))
            Eqi_cas(il)=Eqi(cas(il))
            fac_ftmr_cas(il)=fac_ftmr(cas(il))
            T_cas(il)=T(cas(il))
            qp_cas(il)=qp(cas(il))
#ifdef ISOVERIF              
            evap_cas(il)=evap(cas(il))
#endif            
            wt_cas(il)=wt(cas(il))
            INB_cas(il)=INB(cas(il))
            delP_cas(il)=Ph(cas(il),i)-Ph(cas(il),i+1)
            do ixt=1,niso              
              Pxtisup_cas(ixt,il)=Pxtisup(ixt,cas(il))
              xtp_avantevap_cas(ixt,il)=xtp_avantevap(ixt,cas(il))
              xtevapsup_cas(ixt,il)=xtevap(ixt,cas(il))
            enddo !do ixt=1,niso  
          enddo 

          ! calculs des flux de masses  mettre en argument de stewart:
      ! comme l'eau n'est pas bien concerve dans les ddfts, on est
      ! oblig de bidouill.
      ! 1) soit on considre Pqisup, Eqi, et Pqiinf_par=Pqisup-Eqi
      !    et on suppose que dans la ralit les compositions de
      !    Pqiinf sont les mme que Pqiinf_par
      ! 2) soit on considre Pqisup, Eqi_par=Pqisup-Pqiinf, et Pqiinf,
      !    et on suppose que dans la ralit les compositions de
      !    Eqi_prime sont les mme que Eqi_par
          do il=1,ncas
            if ((water(cas(il)).gt.ridicule/100).and.
     :            (Pqiinf_par(cas(il)).le.0.0)) then
             ! on ne peut pas utiliser la mthode 1, car KE prdit de l'eau
             ! alors que le bilan de masse n'enprdit pas.
             ! Peut-on utiliser la mthode 2?
             Pqiinf_stewart(il)=Pqiinf(cas(il))
             Eqi_stewart(il)=Eqi_par(cas(il))
           else !if ((water(il,i).gt.ridicule/100).and.(Pqiinf_par.le.0.0)) then
             ! il n'y a pas d'obstacles  l'utilisation de 1)
             Pqiinf_stewart(il)=Pqiinf_par(cas(il))
             if (iflag_con.eq.30) then
                Eqi_stewart(il)=Eqi_prime(cas(il))
             else !if (iflag_con.eq.30) then
                if (Eqi(cas(il)).ge.0.0) then
                   Eqi_stewart(il)=Eqi(cas(il))
                else !if (Eqi(cas(il)).gt.0.0) then
                    ! cas ajout le 7 dec 2012: si Eqi est ngatif,
                    ! alors on plante dans compress_stewart 977b
                    ! Parfois, Eqi' est positif grace  Eqi+1 qui est
                    ! positif, mais Eqi est faiblement ngatif (mme si
                    ! trs faible)
                   Eqi_stewart(il)=Eqi_prime(cas(il))
                endif !if (Eqi(cas(il)).gt.0.0) then
             endif !if (iflag_con.eq.30) then
           endif !if ((water(il,i).gt.ridicule/100).and.(Pqiinf_par.le.0.0)) then
         enddo !do il=1,ncas

         ! petite vrif
#ifdef ISOVERIF
         do il=1,ncas 
          if ((iso_verif_positif_nostop(double_to_real(
     :        Eqi_stewart(il)),'compress_stewart 977a').eq.1)
     :        .or.(iso_verif_positif_nostop(double_to_real(
     :        Eqi_stewart(il))*fac_ftmr_cas(il),
     :        'compress_stewart 977b').eq.1)) then
              write(*,*) 'Pqiinf=',Pqiinf(cas(il))
              write(*,*) 'Pqisup=',Pqisup(cas(il))
              write(*,*) 'Pqiinf_par=',Pqiinf_par(cas(il))
              write(*,*) 'Eqi=',Eqi(cas(il))
              write(*,*) 'Eqi_par=',Eqi_par(cas(il))
              write(*,*) 'Eqi_prime=',Eqi_prime(cas(il))
              write(*,*) 'Eqi_stewart=',Eqi_stewart(il)
              write(*,*) 'il,cas=',il,cas(il)
              write(*,*) 'fac_ftmr_cas=',fac_ftmr_cas(il)
              write(*,*) 'qp_avantevap_cas=',qp_avantevap_cas(il)
              write(*,*) 'qp_cas=',qp_cas(il)
              stop
          endif
          do ixt=1,niso  
           call iso_verif_noNaN(double_to_real(Pxtisup_cas(ixt,il)),
     :           'compress_stewart 976')
          enddo !do ixt=1,niso  
         enddo
#endif  
#ifdef ISOVERIF
        do il=1,ncas
          if ((abs(water_cas(il)).ge.ridicule/10.)
     :           .and.(Pqiinf_stewart(il).le.0.0)) then
              write(*,*) 'compress_stewart 498: evap liq:'
              write(*,*) 'water(il,i)=', water_cas(il)
              write(*,*) 'Pqiinf=',Pqiinf(cas(il))
              write(*,*) 'Pqiinf_par=',Pqiinf_par(cas(il))
              write(*,*) 'Pqiinf_stewart=',Pqiinf_stewart(il)
              stop                   
          endif
        enddo !do il=1,ncas_evap_glace
#endif

         return
         end

#ifdef ISOTRAC         
         subroutine compress_evap_liq_zone(iflag_con,ncas,  
     :    cas,
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup,    
     :    xtp_avantevap_cas,xtp_avantevap,
     :    xtp_avantevaptrac_cas,qp_avantevaptrac_cas,
     :    xtevapsup_cas,xtevap,
     :    water_cas,water,
     :    Eqi_stewart,Pqiinf_stewart,Eqi_prime_cas,
     :    Pqiinf,Eqi_par,Pqiinf_par,Eqi_prime,ptrac,
     :    Eqi,Eqi_cas, 
!     :    qp_cas,
#ifdef ISOVERIF           
     :    evap_cas,evap,  
#endif         
     :    nloc,ncum,nd,izone)
         implicit none

         ! compression dans le cas condensation_facftmr
#include "wateriso2.h"
#include "iso_verif.h" 
        ! inputs et outputs 
         integer iflag_con
         integer izone    
         integer nloc,nd,ncum
         integer ncas
         integer cas(ncum)
!         integer i
         real xtevapsup_cas(niso,ncum),xtevap(ntraciso,ncum)
         double precision xtp_avantevap_cas(niso,ncum),
     :           xtp_avantevap(ntraciso,ncum)
         real water_cas(ncum),water(ncum)
         double precision xtp_avantevaptrac_cas(niso,ncum),
     :           qp_avantevaptrac_cas(ncum)
         double precision ptrac(ncum)
!         real qp_cas(ncum)
#ifdef ISOVERIFIDRIS           
         real evap_cas(ncum),evap(ncum)
         real double_to_real
#endif         
         double precision 
     :    Eqi_stewart(ncum),Pqiinf_stewart(ncum),Eqi_prime_cas(ncum),
     :    Pqiinf(ncum),Eqi_par(ncum),Pqiinf_par(ncum),
     :    Eqi_prime(ncum),Pqisup(ncum),Pqisup_cas(ncum),
     :    Pxtisup(ntraciso,ncum),Pxtisup_cas(niso,ncum),
     :    Eqi(ncum),Eqi_cas(ncum)    
         ! locals
          integer il,ixt,iiso,ieau

!          write(*,*) 'compress 910: xtp_avantevap(iso_eau,cas(1))=',
!     :           xtp_avantevap(iso_eau,cas(1))

          ieau=index_trac(izone,iso_eau)
          do il=1,ncas            
            Pqisup_cas(il)=Pxtisup(ieau,cas(il))

            if (Pqisup(cas(il)).gt.0.0) then
              ptrac(il)=Pxtisup(ieau,cas(il))/Pqisup(cas(il))
              Eqi_prime_cas(il)=Eqi_prime(cas(il))
     :           *ptrac(il)
            else
#ifdef ISOVERIF 
                call iso_verif_egalite(double_to_real(
     :                   Eqi_prime(cas(il))),0.0,
     :                   'compress_stewart 979')
#endif                
              Eqi_prime_cas(il)=0.0 
            endif

            if (Pqisup(cas(il))-Eqi_prime(cas(il)).gt.0.0) then
               water_cas(il)=water(cas(il))
     :           *((Pxtisup(ieau,cas(il))-Eqi_prime_cas(il))
     :           /(Pqisup(cas(il))-Eqi_prime(cas(il))))
            else !if (Pqisup(cas(il)).gt.0.0) then
#ifdef ISOVERIF
                call iso_verif_egalite_choix(water(cas(il)),0.0,
     :                   'compress_stewart 507',errmax,errmaxrel)
#endif
                water_cas(il)=0.0
            endif !if (Pqisup(cas(il)).gt.0.0) then

            
!            qp_cas(il)=qp(cas(il))
#ifdef ISOVERIF              
!            evap_cas(il)=evap(cas(il))
!     :           *(Pxtisup(ieau,cas(il))/Pqisup(cas(il)))
!            ! ce calcul est faux: normalement, 
!        evap_cas(il)=Eqi_prime_cas(il)//100.0/delP_cas(il)/SIGD*g*2.0
!     :         -(ieau,cas(il))
#endif            
            qp_avantevaptrac_cas(il)=xtp_avantevap(ieau,cas(il))
            do iiso=1,niso  
              ixt=index_trac(izone,iiso)            
              Pxtisup_cas(iiso,il)=Pxtisup(ixt,cas(il))
              xtp_avantevap_cas(iiso,il)=xtp_avantevap(iiso,cas(il))
              xtp_avantevaptrac_cas(iiso,il)=xtp_avantevap(ixt,cas(il))
              xtevapsup_cas(iiso,il)=xtevap(ixt,cas(il))
            enddo
          enddo !do il=1,ncas
!         write(*,*) 'compress_stewart 931: ',
!     :           'xtp_avantevap_cas(iso_eau,1)=', 
!     :           xtp_avantevap_cas(iso_eau,1)
!         write(*,*) 'xtp_avantevap(iso_eau,cas(1))=',
!     :           xtp_avantevap(iso_eau,cas(1))

      ! calculs des flux de masses  mettre en argument de stewart:
      ! comme l'eau n'est pas bien concerve dans les ddfts, on est
      ! oblig de bidouill.
      ! 1) soit on considre Pqisup, Eqi, et Pqiinf_par=Pqisup-Eqi
      !    et on suppose que dans la ralit les compositions de
      !    Pqiinf sont les mme que Pqiinf_par
      ! 2) soit on considre Pqisup, Eqi_par=Pqisup-Pqiinf, et Pqiinf,
      !    et on suppose que dans la ralit les compositions de
      !    Eqi_prime sont les mme que Eqi_par
          do il=1,ncas  
           if (Pqisup(cas(il)).gt.0.0) then            
            if ((water(cas(il)).gt.ridicule/100).and.
     :            (Pqiinf_par(cas(il)).le.0.0)) then
             ! on ne peut pas utiliser la mthode 1, car KE prdit de l'eau
             ! alors que le bilan de masse n'enprdit pas.
             ! Peut-on utiliser la mthode 2?
             Pqiinf_stewart(il)=Pqiinf(cas(il))*ptrac(il)
             Eqi_stewart(il)=Eqi_par(cas(il)) *ptrac(il)
           else !if ((water(il,i).gt.ridicule/100).and.(Pqiinf_par.le.0.0)) then
             ! il n'y a pas d'obstacles  l'utilisation de 1)
             Pqiinf_stewart(il)=Pqiinf_par(cas(il))*ptrac(il)
             if (iflag_con.eq.30) then
                Eqi_stewart(il)=Eqi_prime(cas(il))*ptrac(il)
             else
                Eqi_stewart(il)=Eqi(cas(il))*ptrac(il)
             endif
           endif !if ((water(il,i).gt.ridicule/100).and.(Pqiinf_par.le.0.0)) then
          else ! if (Pqisup(cas(il).gt.0.0) then
#ifdef ISOVERIF
               call iso_verif_egalite(double_to_real(Pqiinf(cas(il))),
     :           0.0,'compress_stewart 1047a')
               call iso_verif_egalite(double_to_real(
     :           Eqi_prime(cas(il))),0.0,'compress_stewart 1047b') 
               call iso_verif_egalite(double_to_real(
     :           Pqiinf_par(cas(il))),0.0,'compress_stewart 1047c')
               call iso_verif_egalite(double_to_real(Eqi_par(cas(il))),
     :           0.0,'compress_stewart 1047d') 
#endif              
               Pqiinf_stewart(il)=0.0
               Eqi_stewart(il)=0.0
          endif ! if (Pqisup(cas(il).gt.0.0) then 
         enddo !do il=1,ncas_evap_glace

         ! petite vrif
#ifdef ISOVERIF        
        do il=1,ncas
          if ((abs(water_cas(il)).ge.ridicule/10.)
     :           .and.(Pqiinf_stewart(il).le.0.0)) then
              write(*,*) 'compress_stewart 498: evap liq:'
              write(*,*) 'water(il,i)=', water_cas(il)
              write(*,*) 'Pqiinf=',Pqiinf(cas(il))
              write(*,*) 'Pqiinf_par=',Pqiinf_par(cas(il))
              write(*,*) 'Pqiinf_stewart=',Pqiinf_stewart(il)
              stop                   
          endif
        enddo !do il=1,ncas_evap_glace
#endif

         return
         end
#endif

         ! **************

         subroutine compress_evap_glace(iflag_con,
     :    ncas, cas,
     :    water_cas,water,    
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup, 
     :    T_cas,T, 
     :    fac_ftmr_cas,fac_ftmr,     
     :    qp_avantevap_cas,qp_avantevap,
     :    xtp_avantevap_cas,xtp_avantevap,
     :    xtevapsup_cas,xtevap,
     :    Eqi_stewart,Pqiinf_stewart,Eqi_prime_cas,Eqi_cas,
     :    Pqiinf,Eqi_par,Pqiinf_par,Eqi_prime,Eqi,
     :    INB_cas,INB,    
     :    delP_cas,Ph,  
     :    qp_cas,qp,
#ifdef ISOVERIF           
     :    evap_cas,evap,
#endif         
     :    nloc,ncum,nd,i,frac_sublim)
         implicit none

         ! compression dans le cas condensation_facftmr
#include "wateriso2.h"
#include "iso_verif.h"      
         integer iflag_con      
         integer nloc,nd,ncum
         integer ncas
         integer cas(ncum)
         integer i
         real 
     :    T_cas(ncum),T(ncum),
     :    delP_cas(ncum),Ph(nloc,ND),
     :    water_cas(ncum),water(ncum),
     :    xtevapsup_cas(niso,ncum),xtevap(ntraciso,ncum)
         real qp_cas(ncum),qp(ncum)
#ifdef ISOVERIF  
         real evap_cas(ncum),evap(ncum)
#endif         
         double precision  fac_ftmr_cas(ncum),fac_ftmr(ncum),
     :    Pqisup_cas(ncum),Pqisup(ncum), 
     :    Pxtisup_cas(niso,ncum),Pxtisup(ntraciso,ncum),  
     :    qp_avantevap_cas(ncum),qp_avantevap(ncum),    
     :    xtp_avantevap_cas(niso,ncum),xtp_avantevap(ntraciso,ncum),
     :    Eqi_stewart(ncum),Pqiinf_stewart(ncum),Eqi_prime_cas(ncum),
     :    Pqiinf(ncum),Eqi_par(ncum),Pqiinf_par(ncum),Eqi_prime(ncum),
     :    Eqi(ncum),Eqi_cas(ncum)
          integer frac_sublim
          integer INB_cas(ncum),INB(ncum)
          integer il,ixt

          do il=1,ncas
            Pqisup_cas(il)=Pqisup(cas(il))            
            qp_avantevap_cas(il)=qp_avantevap(cas(il))
            Eqi_prime_cas(il)=Eqi_prime(cas(il))
            Eqi_cas(il)=Eqi(cas(il))
            fac_ftmr_cas(il)=fac_ftmr(cas(il)) 
            water_cas(il)=water(cas(il))
            INB_cas(il)=INB(cas(il)) 
            qp_cas(il)=qp(cas(il))
#ifdef ISOVERIF              
            evap_cas(il)=evap(cas(il))
#endif            
            delP_cas(il)=Ph(cas(il),i)
     :         -Ph(cas(il),i+1)
            do ixt=1,niso              
              Pxtisup_cas(ixt,il)=Pxtisup(ixt,cas(il))
              xtp_avantevap_cas(ixt,il)=xtp_avantevap(ixt,cas(il))
              xtevapsup_cas(ixt,il)=xtevap(ixt,cas(il))
            enddo
          enddo  !do il=1,ncas  

!       write(*,*) 'qp_avantevap_cas(1),qp_avantevap(cas(1))=',
!     :   qp_avantevap_cas(1),qp_avantevap(cas(1))   

          if (frac_sublim.eq.1) then
            do il=1,ncas           
             T_cas(il)=T(cas(il))           
            enddo !do il=1,ncas     
          endif !if (frac_sublim) then

          ! calculs des flux de masses  mettre en argument de stewart:
      ! comme l'eau n'est pas bien concerve dans les ddfts, on est
      ! oblig de bidouill.
      ! 1) soit on considre Pqisup, Eqi, et Pqiinf_par=Pqisup-Eqi
      !    et on suppose que dans la ralit les compositions de
      !    Pqiinf sont les mme que Pqiinf_par
      ! 2) soit on considre Pqisup, Eqi_par=Pqisup-Pqiinf, et Pqiinf,
      !    et on suppose que dans la ralit les compositions de
      !    Eqi_prime sont les mme que Eqi_par
          do il=1,ncas
            if ((water(cas(il)).gt.ridicule/100).and.
     :            (Pqiinf_par(cas(il)).le.0.0)) then
             ! on ne peut pas utiliser la mthode 1, car KE prdit de l'eau
             ! alors que le bilan de masse n'enprdit pas.
             ! Peut-on utiliser la mthode 2?
             Pqiinf_stewart(il)=Pqiinf(cas(il))
             Eqi_stewart(il)=Eqi_par(cas(il))
           else !if ((water(il,i).gt.ridicule/100).and.(Pqiinf_par.le.0.0)) then
             ! il n'y a pas d'obstacles  l'utilisation de 1)
             Pqiinf_stewart(il)=Pqiinf_par(cas(il))
             if (iflag_con.eq.30) then
                Eqi_stewart(il)=Eqi_prime(cas(il))
             else !if (iflag_con.eq.30) then
                ! pour quoi avait-on fait un traitement diffrent dans
                ! le cas  iflag_con=3?? C'est vraiment le bordel ici!
                if ((Eqi_prime(cas(il)).gt.0.0).and.
     :               (Pqiinf(cas(il)).ge.Pqisup(cas(il))).and.
     :               (Pqisup(cas(il)).gt.0.0).and.
     :               (Pqisup(cas(il))-Eqi_prime(cas(il)).gt.0.0)) then
                     ! rustine au cas patho en 1D pour -90hPa/d   
                     Eqi_stewart(il)=Eqi_prime(cas(il))
                else !if (Eqi_prime(il).gt.0.0).and.
                     Eqi_stewart(il)=Eqi(cas(il))
                endif !if (Eqi_prime(il).gt.0.0).and.
             endif !if (iflag_con.eq.30) then
           endif !if ((water(il,i).gt.ridicule/100).and.(Pqiinf_par.le.0.0)) then
         enddo !do il=1,ncas_evap_glace 

        ! petite vrif
#ifdef ISOVERIF        
!        il=1  
!        write(*,*) 'compress_stewart 1249: il=',il
!        write(*,*) 'Pqiinf_stewart(il)=',Pqiinf_stewart(il)
!        write(*,*) 'Eqi_stewart(il)=',Eqi_stewart(il)
!        write(*,*) 'Pqisup_cas=',Pqisup_cas(il)
        do il=1,ncas
          if ((abs(water_cas(il)).ge.ridicule/10.)
     :           .and.(Pqiinf_stewart(il).le.0.0)) then
              write(*,*) 'compress_stewart 498: evap glace:'
              write(*,*) 'water(il,i)=', water_cas(il)
              write(*,*) 'Pqiinf=',Pqiinf(cas(il))
              write(*,*) 'Pqiinf_par=',Pqiinf_par(cas(il))
              write(*,*) 'Pqiinf_stewart=',Pqiinf_stewart(il)
              stop                   
          endif
        enddo !do il=1,ncas_evap_glace
#endif             

         return
         end

#ifdef ISOTRAC         
         subroutine compress_evap_glace_zone(iflag_con,
     :    ncas, cas,
     :    water_cas,water,    
     :    Pqisup_cas,Pqisup, 
     :    Pxtisup_cas,Pxtisup, 
     :    xtp_avantevap_cas,xtp_avantevap, 
     :    xtp_avantevaptrac_cas,qp_avantevaptrac_cas,
     :    xtevapsup_cas,xtevap,
     :    Eqi_stewart,Pqiinf_stewart,Eqi_prime_cas,Eqi_cas,
     :    Pqiinf,Eqi_par,Pqiinf_par,Eqi_prime,Eqi,
!     :    qp_cas,
#ifdef ISOVERIF           
     :    evap_cas,evap,
#endif         
     :    nloc,ncum,nd,i,frac_sublim,izone)
         implicit none

         ! compression dans le cas condensation_facftmr
#include "wateriso2.h"
#include "iso_verif.h"   
         integer iflag_con         
         integer nloc,nd,ncum
         integer ncas
         integer cas(ncum)
         integer i
         integer izone
         real 
     :    water_cas(ncum),water(ncum),
     :    xtevapsup_cas(niso,ncum),xtevap(ntraciso,ncum)
!         real qp_cas(ncum)    
#ifdef ISOVERIFIDRIS           
         real evap_cas(ncum),evap(ncum)
         real double_to_real
#endif         
         double precision 
     :    Pqisup_cas(ncum),Pqisup(ncum), 
     :    Pxtisup_cas(niso,ncum),Pxtisup(ntraciso,ncum),  
     :    xtp_avantevap_cas(niso,ncum),xtp_avantevap(ntraciso,ncum),
     :    Eqi_stewart(ncum),Pqiinf_stewart(ncum),Eqi_prime_cas(ncum),
     :    Pqiinf(ncum),Eqi_par(ncum),Pqiinf_par(ncum),Eqi_prime(ncum),
     :    Eqi(ncum),Eqi_cas(ncum)

         double precision xtp_avantevaptrac_cas(niso,ncum),
     :           qp_avantevaptrac_cas(ncum)
          integer frac_sublim
          ! locals
          integer il,ixt,ieau,iiso

          ieau=index_trac(izone,iso_eau)
          do il=1,ncas
            Pqisup_cas(il)=Pxtisup(ieau,cas(il))  

            if (Pqisup(cas(il)).gt.0.0) then
              Eqi_prime_cas(il)=Eqi_prime(cas(il))
     :           *(Pxtisup(ieau,cas(il))/Pqisup(cas(il)))
              Eqi_cas(il)=Eqi(il)
     :           *(Pxtisup(ieau,cas(il))/Pqisup(cas(il)))
            else
#ifdef ISOVERIF 
                call iso_verif_egalite(double_to_real(
     :                   Eqi_prime(cas(il))),0.0,
     :                   'compress_stewart 979')
#endif                
              Eqi_prime_cas(il)=0.0 
              Eqi_cas(il)=0.0
            endif

            if (Pqisup(cas(il))-Eqi_prime(cas(il)).gt.0.0) then
               water_cas(il)=water(cas(il))
     :           *((Pxtisup(ieau,cas(il))-Eqi_prime_cas(il))
     :           /(Pqisup(cas(il))-Eqi_prime(cas(il))))
            else !if (Pqisup(cas(il)).gt.0.0) then
#ifdef ISOVERIF
                call iso_verif_egalite_choix(water(cas(il)),0.0,
     :                   'compress_stewart 507',errmax,errmaxrel)
#endif
                water_cas(il)=0.0
            endif !if (Pqisup(cas(il)).gt.0.0) then


            qp_avantevaptrac_cas(il)=xtp_avantevap(ieau,cas(il))
!            qp_cas(il)=xtp(ieau,cas(il))
#ifdef ISOVERIF              
!            evap_cas(il)=evap(cas(il))
!     :           *(Pxtisup(ieau,cas(il))/Pqisup(cas(il)))
            ! ce calcul est faux: faire plutot:
!            evap_cas(il)=Eqi_prime_cas(il)//100.0/delP_cas(il)/SIGD*g*2.0
!     :         -(ieau,cas(il))
#endif            
            do iiso=1,niso  
              ixt=index_trac(izone,iiso)            
              Pxtisup_cas(iiso,il)=Pxtisup(ixt,cas(il))
              xtp_avantevap_cas(iiso,il)=xtp_avantevap(iiso,cas(il))
              xtp_avantevaptrac_cas(iiso,il)=xtp_avantevap(ixt,cas(il))
              xtevapsup_cas(iiso,il)=xtevap(ixt,cas(il))
            enddo
          enddo  !do il=1,ncas     

          ! calculs des flux de masses  mettre en argument de stewart:
      ! comme l'eau n'est pas bien concerve dans les ddfts, on est
      ! oblig de bidouill.
      ! 1) soit on considre Pqisup, Eqi, et Pqiinf_par=Pqisup-Eqi
      !    et on suppose que dans la ralit les compositions de
      !    Pqiinf sont les mme que Pqiinf_par
      ! 2) soit on considre Pqisup, Eqi_par=Pqisup-Pqiinf, et Pqiinf,
      !    et on suppose que dans la ralit les compositions de
      !    Eqi_prime sont les mme que Eqi_par
          do il=1,ncas  
           if (Pqisup(cas(il)).gt.0.0) then  

            if ((water(cas(il)).gt.ridicule/100).and.
     :            (Pqiinf_par(cas(il)).le.0.0)) then
             ! on ne peut pas utiliser la mthode 1, car KE prdit de l'eau
             ! alors que le bilan de masse n'enprdit pas.
             ! Peut-on utiliser la mthode 2?
             Pqiinf_stewart(il)=Pqiinf(cas(il))
     :          *(Pxtisup(ieau,cas(il))/Pqisup(cas(il)))
             Eqi_stewart(il)=Eqi_par(cas(il))
     :          *(Pxtisup(ieau,cas(il))/Pqisup(cas(il)))
           else !if ((water(il,i).gt.ridicule/100).and.(Pqiinf_par.le.0.0)) then
             ! il n'y a pas d'obstacles  l'utilisation de 1)
             Pqiinf_stewart(il)=Pqiinf_par(cas(il))
     :            *(Pxtisup(ieau,cas(il))/Pqisup(cas(il)))
             if (iflag_con.eq.30) then
                Eqi_stewart(il)=Eqi_prime(cas(il))
     :            *(Pxtisup(ieau,cas(il))/Pqisup(cas(il)))
             else
                Eqi_stewart(il)=Eqi(cas(il))
     :            *(Pxtisup(ieau,cas(il))/Pqisup(cas(il)))
             endif
           endif !if ((water(il,i).gt.ridicule/100).and.(Pqiinf_par.le.0.0)) then

          else !if (Pqisup(cas(il).gt.0.0) then  

#ifdef ISOVERIF
              call iso_verif_egalite(double_to_real(Pqiinf(cas(il))),
     :           0.0,'compress_stewart 1347a')
               call iso_verif_egalite(double_to_real(
     :           Eqi_prime(cas(il))),0.0,'compress_stewart 1347b') 
               call iso_verif_egalite(double_to_real(
     :           Pqiinf_par(cas(il))),0.0,'compress_stewart 1347c')
               call iso_verif_egalite(double_to_real(Eqi_par(cas(il))),
     :           0.0,'compress_stewart 1347d') 
#endif              
               Pqiinf_stewart(il)=0.0
               Eqi_stewart(il)=0.0              
          endif !if (Pqisup(cas(il).gt.0.0) then  
         enddo !do il=1,ncas_evap_glace

        ! petite vrif
#ifdef ISOVERIF        
        do il=1,ncas
          if ((abs(water_cas(il)).ge.ridicule/10.)
     :           .and.(Pqiinf_stewart(il).le.0.0)) then
              write(*,*) 'compress_stewart 498: evap glace:'
              write(*,*) 'water(il,i)=', water_cas(il)
              write(*,*) 'Pqiinf=',Pqiinf(cas(il))
              write(*,*) 'Pqiinf_par=',Pqiinf_par(cas(il))
              write(*,*) 'Pqiinf_stewart=',Pqiinf_stewart(il)
              stop                   
          endif
        enddo !do il=1,ncas_evap_glace
#endif             

         return
         end
#endif

         ! **************

         subroutine uncompress_ilp(
     :       ncas,cas,
     :       zxtrfln_cas,zxt_cas,zxtrfl,zxtrfln,zxt,klon)
         implicit none

#include "wateriso2.h"
#include "iso_verif.h" 
        ! inputs         
         integer ncas
         integer cas(ncas)
         integer klon         
         double precision zxt_cas(niso,ncas),zxtrfln_cas(niso,ncas)

         ! outputs
         real zxt(ntraciso,klon)
         real zxtrfl(ntraciso,klon),zxtrfln(ntraciso,klon)

         ! locals
         integer il,ixt

         do il=1,ncas
          do ixt=1,niso
            zxt(ixt,cas(il))=zxt_cas(ixt,il)
            zxtrfln(ixt,cas(il))=zxtrfln_cas(ixt,il)
            zxtrfl(ixt,cas(il))=zxtrfln_cas(ixt,il)
          enddo
         enddo


         return
         end

         ! **************
#ifdef ISOTRAC
         subroutine uncompress_ilp_zone(
     :       ncas,cas,
     :       zxtrfln_cas,zxt_cas,zxtrfl,zxtrfln,zxt,klon,
     :       izone,Eqi,Exi,fac_ftmr,
     :       xtrevap_tag,liq,hdiag)
         implicit none

#include "wateriso2.h"
#include "iso_verif.h" 
        ! inputs         
         integer ncas
         integer cas(ncas)
         integer klon
         integer izone                  
         double precision zxt_cas(niso,ncas),zxtrfln_cas(niso,ncas)
         double precision Exi(niso,ncas)
         double precision Eqi(ncas)
         double precision fac_ftmr(ncas)
         integer liq
         real hdiag(ncas)

         ! output
         real zxt(ntraciso,klon)
         real zxtrfl(ntraciso,klon),zxtrfln(ntraciso,klon)
         real xtrevap_tag(ntraciso,ncas)

         ! locals
         integer il,ixt,iiso

!         write(*,*) 'uncompress_stewart 1420 tmp: zxt=',
!     :            zxt(iso_eau:ntraciso:3,cas(1))
!         write(*,*) 'Exi,fac_ftmr=',
!     :            Exi(iso_eau,1),fac_ftmr(1)
         do il=1,ncas
          do iiso=1,niso
            ixt=index_trac(izone,iiso)
            zxtrfln(ixt,cas(il))=zxtrfln_cas(iiso,il)
            zxtrfl(ixt,cas(il))=zxtrfln_cas(iiso,il)            
          enddo
!#ifdef ISOVERIF
!          if (il.eq.9) then
!            write(*,*) 'uncompress 1521'
!            write(*,*) 'il,Eqi,fac_ftmr,evap_franche,Exi(2,il)=',
!     :         il,Eqi(il),fac_ftmr(il),evap_franche,Exi(2,il)
!          endif
!#endif

          if ((option_revap.eq.1).and.
     :         (((liq.eq.1).and.(Eqi(il)*fac_ftmr(il).gt.evap_franche)
     :         .and.(hdiag(il).lt.0.99)).or.
     :         ((liq.eq.0).and.
     :         (Eqi(il)*fac_ftmr(il).ge.0.0)))) then 
          ! le flux d'vap va dans un tag particulier
          ! -> zxt est inchang mais xtrevap_tag(ixt,il) est incrment
             do iiso=1,niso
              ixt=index_trac(izone,iiso)
              xtrevap_tag(ixt,il)=fac_ftmr(il)*Exi(iiso,il)
!              zxt(ixt,cas(il))=zxt_cas(iiso,il)
!     :                   -xtrevap_tag(ixt,il)
             enddo
                
          else !if ((Eqi(il)*fac_ftmr(il).gt.evap_franche).and.
            ! reequilibration standard
            do iiso=1,niso
              ixt=index_trac(izone,iiso)
              zxt(ixt,cas(il))=zxt(ixt,cas(il))
     :                   +fac_ftmr(il)*Exi(iiso,il)
              zxt(ixt,cas(il))=max(0.0,zxt(ixt,cas(il)))
              xtrevap_tag(ixt,il)=0.0
#ifdef ISOVERIF
              call iso_verif_positif_choix(zxt(ixt,cas(il)),
     :              0.0,'compress 1508')
#endif              
            enddo            
          endif !if ((Eqi(il)*fac_ftmr(il).gt.evap_franche).and.
#ifdef ISOVERIF
          if (il.eq.9) then            
            ixt=index_trac(2,2)
            write(*,*) 'il,ixt,xtrevap_tag(ixt,il)=',
     :           il,xtrevap_tag(ixt,il)
          endif
#endif          
         enddo !do il=1,ncas
!         write(*,*) 'compress_stewart 1453 tmp: zxt=',
!     :            zxt(iso_eau:ntraciso:3,cas(1))

         return
         end
#endif
         ! **************

         subroutine compress_ilp_evap_tot(
     :       ncas,cas,
     :       zxt_cas,zxt,zxtrfl_cas,zxtrfl,
     :       delP,paprs,k,klon,klev)
         implicit none

#include "wateriso2.h"
#include "iso_verif.h"             
         integer ncas
         integer cas(ncas)
         integer klon,klev
         real zxt(niso,klon)
         real zxtrfl(niso,klon)
         real delP(ncas),paprs(klon,klev+1)
         double precision zxt_cas(niso,ncas), zxtrfl_cas(niso,ncas)
         integer k
         integer il,ixt

         do il=1,ncas
          do ixt=1,niso
            zxt_cas(ixt,il)=zxt(ixt,cas(il))
            zxtrfl_cas(ixt,il)=zxtrfl(ixt,cas(il))
          enddo
          delP(il)=paprs(cas(il),k)-paprs(cas(il),k+1)
         enddo

         return
         end

         ! **************

         subroutine compress_ilp_evap_liq(
     :       ncas,cas,
     :       zq_cas,zq,
     :       zqs_cas,zqs,       
     :       zxt_cas,zxt,
     :       zxtrfl_cas,zxtrfl_ancien,
     :       zrfln_cas,zrfln,  
     :       zrfl_cas,zrfl_ancien,    
     :       zqev_diag_cas,zqev_diag, 
     :       zt_cas,zt,  
     :       delP,paprs,k,klon,klev)
         implicit none

#include "wateriso2.h"
#include "iso_verif.h"             
         integer ncas
         integer cas(ncas)
         integer klon,klev
         real zq(klon), zxt(ntraciso,klon)
         double precision zq_cas(ncas),zxt_cas(niso,ncas)         
         double precision zxtrfl_cas(niso,ncas)
         real zxtrfl_ancien(ntraciso,klon)
         real delP(ncas),paprs(klon,klev+1)
         real zqs(klon),zqs_cas(ncas)
         real zt_cas(ncas),zt(klon) 
         real zqev_diag_cas(ncas),zqev_diag(klon)
         double precision zrfln_cas(ncas)
         real zrfln(klon)
         double precision zrfl_cas(ncas)
         real zrfl_ancien(klon)
         integer k
         integer il,ixt

         do il=1,ncas
          do ixt=1,niso
            zxt_cas(ixt,il)=zxt(ixt,cas(il))
            zxtrfl_cas(ixt,il)=zxtrfl_ancien(ixt,cas(il))
          enddo
          zqs_cas(il)=zqs(cas(il))
          zrfln_cas(il)=zrfln(cas(il))
          zrfl_cas(il)=zrfl_ancien(cas(il))
          zq_cas(il)=zq(cas(il))
          zqev_diag_cas(il)=zqev_diag(cas(il))
          zt_cas(il)=zt(cas(il))
          delP(il)=paprs(cas(il),k)-paprs(cas(il),k+1)
         enddo

         return
         end

! **************
#ifdef ISOTRAC
         subroutine compress_ilp_evap_liq_zone(
     :       ncas,cas,
     :       zxt_cas,zxt,
     :       zxtrfl_cas,zxtrfl_ancien,
     :       zrfln_cas,zrfln,  
     :       zrfl_cas,zrfl_ancien,    
     :       zqev_diag_cas,zqev_diag, 
     :       klon,izone,ptrac)
         implicit none

#include "wateriso2.h"
#include "iso_verif.h" 
        ! inputs         
         integer ncas
         integer cas(ncas)
         integer klon
         real zxt(ntraciso,klon)
         real zxtrfl(ntraciso,klon)
         real zrfl_ancien(klon)
         real zqev_diag(klon)
         real zrfln(klon)
         real zxtrfl_ancien(ntraciso,klon)
         integer izone

         ! outputs
         double precision zxt_cas(niso,ncas)         
         double precision zxtrfl_cas(niso,ncas)         
         real zqev_diag_cas(ncas)
         double precision zrfln_cas(ncas)         
         double precision zrfl_cas(ncas)
         double precision ptrac(ncas)
         
         ! locals
         integer il,ixt,ieau,iiso

         ieau=index_trac(izone,iso_eau)
         do il=1,ncas
          do iiso=1,niso
            ixt=index_trac(izone,iiso)
            ! la compo de la vap  l'extrieure reste la vapeur totale
            zxt_cas(iiso,il)=zxt(iiso,cas(il))
            ! le flux de pluie est celui le flux de pluie li  la zone
            zxtrfl_cas(iiso,il)=zxtrfl_ancien(ixt,cas(il))
          enddo
          zrfl_cas(il)=zxtrfl_ancien(ieau,cas(il))

          if (zrfl_ancien(cas(il)).gt.0.0) then
          ! proportion de izone dans l'vap = celle dans la goutte          
            ptrac(il)=zxtrfl_ancien(ieau,cas(il))/zrfl_ancien(cas(il))
            zrfln_cas(il)=zrfln(cas(il))*ptrac(il)
            zqev_diag_cas(il)=zqev_diag(cas(il))*ptrac(il)
!#ifdef ISOVERIF              
!            if (il.eq.9) then
!              write(*,*) 'compress tmp: il, ptrac=',il,ptrac(il)
!              write(*,*) 'ieau,zxtrfl_ancien(ieau,cas(il))=',
!     :           ieau,zxtrfl_ancien(ieau,cas(il))
!              write(*,*) 'zrfl_ancien(cas(il))=',zrfl_ancien(cas(il))
!              write(*,*) 'zrfl_cas(il)=',zrfl_cas(il)
!            endif
!#endif

          else !if (zrfl_ancien(cas(il)).gt.0.0) then
#ifdef ISOVERIF  
!              write(*,*) 'il,cas(il),zrfln,zrfl_ancien,zqev_diag=',
!     :              il,cas(il),zrfln(cas(il)),zrfl_ancien(cas(il)),
!     :              zqev_diag(cas(il))   
              call iso_verif_egalite(zqev_diag(cas(il)),0.0,
     :           'compress_stewart 1591a')
              call iso_verif_egalite(zrfln(cas(il)),0.0,
     :           'compress_stewart 1591b')
#endif               
                zrfln_cas(il)=0.0
                zqev_diag_cas(il)=0.0
               
          endif !if (zrfl_ancien(cas(il)).gt.0.0) then
          ! les lignes suvantes ne sont pas  recalculer
!          zt_cas(il)=zt(cas(il))
!          delP(il)=paprs(cas(il),k)-paprs(cas(il),k+1)
         enddo !do il=1,ncas

         return
         end         
#endif
         ! **************

         subroutine compress_ilp_evap_glace(
     :       ncas,cas,
     :       zq_cas,zq,    
     :       zxt_cas,zxt,
     :       zxtrfl_cas,zxtrfl_ancien,
     :       zrfln_cas,zrfln,  
     :       zrfl_cas,zrfl_ancien,    
     :       zqev_diag_cas,zqev_diag, 
     :       zt_cas,zt,  
     :       delP,paprs,k,klon,klev,frac_sublim)
         implicit none

#include "wateriso2.h"
#include "iso_verif.h"
        ! inputs         
         integer ncas
         integer cas(ncas)
         integer klon
         real zq(klon), zxt(ntraciso,klon)
         real zxtrfl_ancien(ntraciso,klon)
         real zt(klon) 
         real zqev_diag(klon)
         real zrfln(klon)
         integer k,klev
         real paprs(klon,klev+1)
         integer frac_sublim

         ! outputs
         double precision zq_cas(ncas),zxt_cas(niso,ncas)         
         double precision zxtrfl_cas(niso,ncas)         
         real zt_cas(ncas)
         real zqev_diag_cas(ncas)
         double precision zrfln_cas(ncas)         
         double precision zrfl_cas(ncas)
         real zrfl_ancien(klon)
         real delP(ncas)
         
         ! locals
         integer il,ixt 
#ifdef ISOVERIFIDRIS
         real double_to_real
#endif        

         do il=1,ncas
          do ixt=1,niso
            zxt_cas(ixt,il)=zxt(ixt,cas(il))
            zxtrfl_cas(ixt,il)=zxtrfl_ancien(ixt,cas(il))
          enddo
          delP(il)=paprs(cas(il),k)-paprs(cas(il),k+1)
          zrfln_cas(il)=zrfln(cas(il))
          zrfl_cas(il)=zrfl_ancien(cas(il))
          zq_cas(il)=zq(cas(il))
          zqev_diag_cas(il)=zqev_diag(cas(il))   
          if (frac_sublim.eq.1) then
            zt_cas(il)=zt(cas(il))
          endif
         enddo
         
#ifdef ISOVERIF
        if (use_iso_eau.eq.1) then
            do il=1,ncas
!              write(*,*) 'il=',il
              call iso_verif_egalite_choix(zrfl_ancien(cas(il)),
     :           zxtrfl_ancien(iso_eau,cas(il)),
     :           'compress 1655a: compress evap_glace pour ilp',
     :           errmax,errmaxrel)
              call iso_verif_egalite_choix(double_to_real(zrfl_cas(il)),
     :           double_to_real(zxtrfl_cas(iso_eau,il)),
     :           'compress 1655b: compress evap_glace pour ilp',
     :           errmax,errmaxrel)
            enddo
        endif  !if (use_iso_eau.eq.1) then
#endif


         return
         end     

! **************

#ifdef ISOTRAC         
         subroutine compress_ilp_evap_glace_zone(
     :       ncas,cas,
     :       zxt_cas,zxt,
     :       zxtrfl_cas,zxtrfl_ancien,
     :       zrfln_cas,zrfln,  
     :       zrfl_cas, zrfl_ancien,
     :       zqev_diag_cas,zqev_diag, 
     :       klon,izone)
         implicit none

#include "wateriso2.h"
#include "iso_verif.h"
        ! inputs         
         integer ncas
         integer cas(ncas)
         integer klon
         real zxt(ntraciso,klon)
         real zxtrfl_ancien(ntraciso,klon)
         real zqev_diag(klon)
         real zrfln(klon)
         integer izone
         real zrfl_ancien(klon)

         ! outputs
         double precision zxt_cas(niso,ncas)         
         double precision zxtrfl_cas(niso,ncas)         
         real zqev_diag_cas(ncas)
         double precision zrfln_cas(ncas)         
         double precision zrfl_cas(ncas)
         
         
         ! locals
         integer il,ixt,ieau,iiso     

         ieau=index_trac(izone,iso_eau)
         do il=1,ncas
          do iiso=1,niso
            ixt=index_trac(izone,iiso)
            zxt_cas(iiso,il)=zxt(iiso,cas(il))
            zxtrfl_cas(iiso,il)=zxtrfl_ancien(ixt,cas(il))
          enddo          
          zrfl_cas(il)=zxtrfl_ancien(ieau,cas(il))

          if (zrfl_ancien(cas(il)).gt.0.0) then
             zrfln_cas(il)=zrfln(cas(il))
     :           *(zxtrfl_ancien(ieau,cas(il))/zrfl_ancien(cas(il)))
            ! car la proportion de traceurs dans zqev_diag et la mme
            ! que dans zrfl_ancien. Comme zrfln=zrfl-zqev_diag*fac_ftmr
            ! alors cette proportion de traceurs est aussi la mme dans
            ! zrfln
             zqev_diag_cas(il)=zqev_diag(cas(il))
     :         *zxtrfl_ancien(ieau,cas(il))/zrfl_ancien(cas(il))
          else !if (zrfl_ancien(cas(il)).gt.0.0) then
#ifdef ISOVERIF  
              call iso_verif_egalite(zqev_diag(cas(il)),0.0,
     :           'compress_stewart 1791a')
              call iso_verif_egalite(zrfln(cas(il)),0.0,
     :           'compress_stewart 1791b')
#endif               
                zrfln_cas(il)=0.0
                zqev_diag_cas(il)=0.0
          endif !if (zrfl_ancien(cas(il)).gt.0.0) then
         enddo

         return
         end     
#endif         
         
#endif

         



