        subroutine condiso_liq_ice(ixt,xt,qt,cond,
     :           tcond,zfice,zxtice,zxtliq)

        implicit none

        ! on s'interresse  l'isotope ixt.
        ! de l'air de proprits (qt,xt) condense cond,  la temprature
        ! tcond, donc zfice*cond est sous forme de glace.
        ! on cherche alors les isotopes contenus dans les phases liquide
        ! et glace: zxtliq et zxtice
        
        ! dclarations
        ! **inputs
        real xt,qt,cond,tcond,zfice ! tcond en K
        integer ixt
        ! **outputs
        real zxtice,zxtliq
        ! **locals
        real zxtalphal,zxtalphai
#include "wateriso2.h"
#include "iso_verif.h"
        integer iso_verif_aberrant_nostop ! debugage
        
        ! ********* dbut des calculs *********

        ! traitement rapide du cas o cond=0
        if (cond.eq.0) then
            zxtliq=0
            zxtice=0
            return
        endif

        ! verif que qt n'est pas nul
        if (qt.eq.0) then
            if (cond.lt.ridicule) then
                zxtliq=0
                zxtice=0
                return
            else
                ! c'est impossible de condenser qi pas d'eau au dpart
                write(*,*) 'condiso_liq_ice 35'
                write(*,*) 'qt=',qt
                write(*,*) 'cond=',cond
                stop
            endif
        endif

        ! verif xt et qt
#ifdef ISOVERIF
          if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
              call iso_verif_egalite_choix
     :          (qt,xt,'condiso_liq_ice 51',errmax,errmaxrel)
          endif  !if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then  
          call iso_verif_positif(qt-cond,'condiso_liq_ice 56: cond>qt')     
#endif
        cond=min(cond,qt)
            
        ! maintenant, qt et cond ne sont pas nuls:

        call fractcalk(ixt,tcond,zxtalphal,zxtalphai)
#ifdef ISOVERIF
            call iso_verif_noNAN(zxtalphal,'condiso_liq_ice 65')
            call iso_verif_noNAN(zxtalphai,'condiso_liq_ice 66')
            if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
                call iso_verif_egalite(zxtalphal,1.0,'condiso 21')
                call iso_verif_egalite(zxtalphai,1.0,'condiso 21')
            endif !if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
#endif

#ifdef ISOVERIF
          if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then
            if (qt.gt.ridicule) then
               if (iso_verif_aberrant_nostop(xt/qt*zxtalphai/faccond,
     :           'condiso_liq_ice 64').eq.1) then
!                write(*,*) 'deltaDt=',(xt/qt/tnat(iso_HDO)-1)*1000
!                write(*,*) 'tcond,fcond,zxtalphai=',
!     :                   tcond,cond/qt,zxtalphai
!                stop
              endif !if (iso_verif_aberrant_nostop(xt/qt*zxtalphai/faccond,
            endif !if (qt.gt.ridicule) then
          endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then
#endif
        
        
        zxtliq=zxtalphal*xt*cond/(qt+cond*(zxtalphal-1))
        if (cond/qt.lt.1e-5) then
           ! cas particulier pour viter FI quand cond/qt->0  
           zxtice=xt/qt*cond*zxtalphai 

        else if (1.0-cond/qt.lt.ridicule) then
           ! condensation totale
           ! on ajoute ce cas particulier le 9 avril 2012 car sur vargas
           ! en batch, 0**alpha est NaN
             zxtice=xt

        else  
           ! cas gnral 
           zxtice=xt*(1-(1-cond/qt)**zxtalphai)
        endif

        ! verif
        ! verif egalit pour ixt=4 et eau normale:
#ifdef ISOVERIF
          if (zfice.lt.1) then  
            call iso_verif_noNAN(zxtliq,'condiso_liq_ice 91')
            if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then            
              call iso_verif_egalite(zxtliq,cond,'condiso_liq_ice 30')
            endif ! if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then  
            if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then 
                if (cond.gt.ridicule) then
                    call iso_verif_aberrant(zxtliq/cond,
     :                    'condiso_liq_ice 32')
                endif !if (cond.gt.ridicule) then 
            endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then      
          endif !if (zfice.lt.1) then
          if (zfice.gt.0) then  
            call iso_verif_noNAN(zxtice,'condiso_liq_ice 92')
            if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then      
              call iso_verif_egalite(zxtice,cond,'condiso_liq_ice 31')             
            endif ! if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then  
            if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then 
              if (cond.gt.ridicule) then
                if (iso_verif_aberrant_nostop(zxtice/cond,
     :                  'condiso_liq_ice 33').eq.1) then
                  write(*,*) 'debug condiso 88: zfice=',zfice 
                  write(*,*) 'cond/qt=',cond/qt
                  write(*,*) 'xt/qt=',xt/qt
                  write(*,*) '(xt/qt/tnat(iso_HDO)-1)*1000=',
     :                           (xt/qt/tnat(iso_HDO)-1)*1000
                  write(*,*) 'zxtalphai=',zxtalphai
                  write(*,*) 'qt/cond*(1-(1-cond/qt)**zxtalphai)=',
     :                   (qt/cond)*1-(1-cond/qt)**zxtalphai
                  write(*,*) 'zxtice/cond=',zxtice/cond 
                  stop
                  endif
                endif !if (cond.gt.ridicule) then 
            endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then
          endif !if (zfice.gt.0) then       
        ! verif que deltaD n'est pas abberant:
          
#endif
        ! end verif

        zxtliq=(1-zfice)*zxtliq
        zxtice=zfice*zxtice
        
        ! cam verif
#ifdef ISOVERIF
          call iso_verif_noNAN(zxtliq,'condiso_liq_ice 132')
          call iso_verif_noNAN(zxtice,'condiso_liq_ice 92')
          if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
            call iso_verif_egalite(zxtice+zxtliq,cond,
     :           'condiso_liq_ice 79')
          endif ! if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
          call iso_verif_noNAN(zxtice+zxtliq,'condiso_liq_ice 108')     
#endif

        if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
          if (ixt.eq.iso_eau) then
            ! assurer convergence
            if (zfice.eq.1.0) then
                zxtice=cond
            endif !if (zfice.eq.1.0) then
        endif !if (ixt.eq.iso_eau) then
       endif !if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
        
        zxtice=max(0.0,zxtice)
        zxtliq=max(0.0,zxtliq)
        ! end verif
        
        ! *********** fin des calculs *********
        
        return
        end


        !************
        subroutine calcul_zfice(T,zfice)
        implicit none

        ! inputs
        real T ! temprature en K
#include "wateriso2.h"
        ! output:
        real zfice ! fraction de condensation en glace

        zfice = 1.0-(T-pxtice)/(pxtmelt-pxtice)
        zfice = MIN(MAX(zfice,0.0),1.0)    

        return
        end    
