#ifdef ISO
      subroutine condiso_liq_ice_vectiso(xt,qt,cond,
     :           tcond,zfice,zxtice,zxtliq)

        implicit none

        ! version vectorise de condiso_liq_ice
        ! on fait d'un coup tous les iso de 1  niso
        !d'un point de grille donne
        
        ! dclarations
#include "wateriso2.h"
        ! **inputs
        real xt(ntraciso),qt,cond,tcond,zfice ! tcond en K        
        ! **outputs
        real zxtice(ntraciso),zxtliq(ntraciso)
        ! Rq: on met ntraciso au cas o on passe direct en argument les
        ! tableaux comportant les traceurs. Mais on ne fait que des
        ! isotopes normaux ici.
        ! **locals
        real zxtalphal(niso),zxtalphai(niso)
        real t_coup
        parameter (t_coup=273.15)
        integer ixt
        real zcond
#include "iso_verif.h"
#ifdef ISOVERIF    
        integer iso_verif_aberrant_nostop ! debugage
        integer iso_verif_aberrant_choix_nostop
        real deltaD
#endif    
        
        ! ********* dbut des calculs *********

        ! traitement rapide du cas o cond=0
        if (cond.eq.0) then
          do ixt=1,niso
            zxtliq(ixt)=0
            zxtice(ixt)=0
          enddo
          return
        endif

        ! verif que qt n'est pas nul
        if (qt.eq.0) then
            if (cond.lt.ridicule) then
              do ixt=1,niso  
                zxtliq(ixt)=0
                zxtice(ixt)=0
              enddo
              return
            else !if (cond.lt.ridicule) then
                ! c'est impossible de condenser qi pas d'eau au dpart
                write(*,*) 'condiso_liq_ice_vectiso 35'
                write(*,*) 'qt=',qt
                write(*,*) 'cond=',cond
                stop
            endif
        endif !if (cond.lt.ridicule) then

        ! verif xt et qt
#ifdef ISOVERIF
          if (use_iso_eau.eq.1) then
              call iso_verif_egalite_choix(qt,xt(iso_eau),
     :          'condiso_liq_ice_vectiso 62',errmax,errmaxrel)
          endif  !if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then  
          call iso_verif_positif(qt-cond,
     :           'condiso_liq_ice_vectiso 56: cond>qt')     
          call iso_verif_positif(tcond-Tmin_verif,
     :           'condiso_liq_ice_vectiso 70')        
          call iso_verif_positif(300.0-tcond,
     :           'condiso_liq_ice_vectiso 70')     
#endif
          zcond=max(0.0,min(cond,qt))
          if (essai_convergence) then
          else  
                cond=min(cond,qt)
          endif
            
        ! maintenant, qt et cond ne sont pas nuls:
            
        do ixt=1,niso
          call fractcalk(ixt,tcond,zxtalphal(ixt),zxtalphai(ixt))
        enddo
#ifdef ISOVERIF
        do ixt=1,niso
            call iso_verif_noNAN(zxtalphal(ixt),
     :            'condiso_liq_ice_vectiso 65')
            call iso_verif_noNAN(zxtalphai(ixt),
     :           'condiso_liq_ice_vectiso 66')
        enddo
        if (use_iso_eau.eq.1) then
            call iso_verif_egalite_choix(zxtalphal(iso_eau),1.0,
     :           'condiso 21',errmax,errmaxrel)
            call iso_verif_egalite_choix(zxtalphai(iso_eau),1.0,
     :           'condiso 21',errmax,errmaxrel)
        endif !if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
        if (use_iso_HDO.eq.1) then
            if (qt.gt.ridicule) then
               if (iso_verif_aberrant_nostop(xt(iso_HDO)
     :            /qt*zxtalphai(iso_HDO)/faccond,
     :            'condiso_liq_ice_vectiso 64').eq.1) then
!                write(*,*) 'deltaDt=',(xt/qt/tnat(iso_HDO)-1)*1000
!                write(*,*) 'tcond,fcond,zxtalphai=',
!     :                   tcond,cond/qt,zxtalphai
!                stop
              endif !if (iso_verif_aberrant_nostop(xt/qt*zxtalphai/faccond,
            endif !if (qt.gt.ridicule) then
          endif !if (use_iso_HDO.eq.1) then
#endif
        
        do ixt=1,niso
          zxtliq(ixt)=zxtalphal(ixt)*xt(ixt)*zcond
     :          /(qt+zcond*(zxtalphal(ixt)-1))
        enddo
        if (zcond/qt.lt.1e-5) then
           ! cas particulier pour viter FI quand cond/qt->0  
           do ixt=1,niso
             zxtice(ixt)=xt(ixt)/qt*zcond*zxtalphai(ixt)
           enddo

        else if (1.0-zcond/qt.lt.ridicule) then
           ! condensation totale
           ! on ajoute ce cas particulier le 9 avril 2012 car sur vargas
           ! en batch, 0**alpha est NaN
           do ixt=1,niso
             zxtice(ixt)=xt(ixt)  
           enddo !do ixt=1,niso

         else            ! cas gnral
           do ixt=1,niso
             zxtice(ixt)=xt(ixt)*(1.0-(1.0-(zcond/qt))**zxtalphai(ixt))
           enddo
        endif !if (zcond/qt.lt.1e-5) then
        

        ! verif
        ! verif egalit pour ixt=4 et eau normale:
#ifdef ISOVERIF
          if (zfice.lt.1) then  
            do ixt=1,niso  
              call iso_verif_noNAN(zxtliq(ixt),
     :           'condiso_liq_ice_vectiso 91')
            enddo
            if (use_iso_eau.eq.1) then   
              call iso_verif_egalite_choix(zxtliq(iso_eau),cond,
     :           'condiso_liq_ice_vectiso 30',errmax,errmaxrel)
            endif ! if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then  
            if (use_iso_HDO.eq.1) then 
                if (cond.gt.ridicule) then
                    call iso_verif_aberrant(zxtliq(iso_HDO)/cond,
     :                    'condiso_liq_ice_vectiso 32')
                endif !if (cond.gt.ridicule) then 
            endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then      
          endif !if (zfice.lt.1) then
          if (zfice.gt.0) then 
            do ixt=1,niso    
            call iso_verif_noNAN(zxtice,'condiso_liq_ice_vectiso 149')
            enddo
            if (use_iso_eau.eq.1) then      
              call iso_verif_egalite_choix(zxtice(iso_eau),cond,
     :                   'condiso_liq_ice_vectiso 31',errmax,errmaxrel)
            endif ! if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then  
            if (use_iso_HDO.eq.1) then 
              if (cond.gt.ridicule) then
                if (iso_verif_aberrant_nostop(zxtice(iso_HDO)/cond
     :             /faccond,'condiso_liq_ice_vectiso 33').eq.1) then
                  write(*,*) 'debug condiso 88: zfice=',zfice 
                  write(*,*) 'cond/qt=',cond/qt
                  write(*,*) 'xt(iso_HDO)/qt=',xt(iso_HDO)/qt
                  write(*,*) 'deltaD(xt(iso_HDO)/qt)=',
     :                           deltaD(xt(iso_HDO)/qt)
                  write(*,*) 'zxtalphai(iso_HDO)=',zxtalphai(iso_HDO)
                  write(*,*) 'Rice/Rv0=',qt/cond*
     :              (1-(1-cond/qt)**zxtalphai(iso_HDO))/(1-(1-cond/qt))
                  write(*,*) 'tcond=',tcond-t_coup,'C' 
                  if (tcond-t_coup.gt.-40.0) then
                      ! au dessus de -40, il y a de quoi s'inquiter
                      ! en dessous, on ne sait pas ce que valent les alphas
                     stop
                  endif !if (tcond(i).gt.100.0) then
                  endif
                endif !if (cond.gt.ridicule) then 
            endif !if (use_iso_HDO.eq.1) then
          endif !if (zfice.gt.0) then       
        ! verif que deltaD n'est pas abberant:
          
#endif
        ! end verif

        do ixt=1,ntraciso
          zxtliq(ixt)=(1-zfice)*zxtliq(ixt)
          zxtice(ixt)=zfice*zxtice(ixt)
        enddo
        
        ! cam verif
#ifdef ISOVERIF
        do ixt=1,niso
          call iso_verif_noNAN(zxtliq(ixt),
     :           'condiso_liq_ice_vectiso 132')
          call iso_verif_noNAN(zxtice(ixt),
     :           'condiso_liq_ice_vectiso 193')
        enddo
          if (use_iso_eau.eq.1) then
            call iso_verif_egalite_choix(
     :           zxtice(iso_eau)+zxtliq(iso_eau),cond,
     :           'condiso_liq_ice_vectiso 79',errmax,errmaxrel)
          endif ! if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
#endif

        if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
            ! assurer convergence
            if (zfice.eq.1.0) then
                zxtice(iso_eau)=cond
            endif !if (zfice.eq.1.0) then
       endif !if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
        
        do ixt=1,ntraciso
          zxtice(ixt)=max(0.0,zxtice(ixt))
          zxtliq(ixt)=max(0.0,zxtliq(ixt))
        enddo
        ! end verif
        
        ! *********** fin des calculs *********
        
        return
        end




        subroutine condiso_liq_ice_vectall(xt,qt,cond,
     :           tcond,zfice,zxtice,zxtliq,n)

        implicit none

        ! version vectorise de condiso_liq_ice
        ! on fait d'un coup tous les lieux i de 1  n
        ! et tous les iso de 1  niso
        
        ! dclarations
#include "wateriso2.h"
        ! **inputs
        integer n
        real xt(ntraciso,n),qt(n),cond(n),tcond(n),zfice(n) ! tcond en K        
        ! **outputs
        real zxtice(ntraciso,n),zxtliq(ntraciso,n)
        ! Rq: on met ntraciso au cas o on passe direct en argument les
        ! tableaux comportant les traceurs. Mais on ne fait que des
        ! isotopes normaux ici.
        ! **locals
        real zxtalphal(niso,n),zxtalphai(niso,n)
        real t_coup        
        parameter (t_coup=273.15)
        real zcond(n)
        integer ixt, i ! compteurs
#include "iso_verif.h"
#ifdef ISOVERIFIDRIS
        integer iso_verif_aberrant_nostop ! debugage
        integer iso_verif_aberrant_choix_nostop
        integer iso_verif_noNaN_nostop
        integer iso_verif_positif_nostop
        real deltaD
        real xtv(niso,n),qv(n)
#endif 

        ! verif xt et qt
#ifdef ISOVERIFIDRIS
       do i=1,n
        call iso_verif_noNaN(qt(i),'condiso_liq_ice_vectall 270')
        do ixt=1,niso
         call iso_verif_noNaN(xt(ixt,i),'condiso_liq_ice_vectall 271')
        enddo
       enddo !do i=1,n
#endif
#ifdef ISOVERIF   
!          write(*,*) 'condiso 253: entre dans condiso'     
          if (use_iso_eau.eq.1) then
            do i=1,n
              call iso_verif_egalite_choix
     :          (qt(i),xt(iso_eau,i),
     :          'condiso_liq_ice_vectall 251',errmax,errmaxrel)
              enddo !do i=1,no
          endif  !if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then  
          if (use_iso_hdo.eq.1) then
            do i=1,n
!             if (qt(i).gt.ridicule) then
#ifdef ISOTRAC            
              call iso_verif_aberrant_choix(xt(iso_hdo,i),qt(i),
     :            ridicule_trac,deltalimtrac,'condiso_liq_ice 256')
#else
              call iso_verif_aberrant_choix(xt(iso_hdo,i),qt(i),
     :            ridicule,deltalim,'condiso_liq_ice 256b') 
#endif              
              ! on met deltalim*2 car les traceurs sont plus capricieux
!             endif
            enddo !do i=1,n
          endif
          
          do i=1,n
!            write(*,*) 'condiso_liq_ice_vect 292: i,qt(i),cond(i)=',
!     :           i,qt(i),cond(i)
#ifdef VERIFNEGATIF
            call iso_verif_positif(qt(i),
     :           'condiso_liq_ice_vectall 268: qt<0')
#endif
            if ((iso_verif_positif_nostop(qt(i)-cond(i),
     :        'condiso_liq_ice_vectall 269: cond>qt').eq.1).or.
     :        (iso_verif_positif_nostop(tcond(i)-Tmin_verif,
     :        'condiso_liq_ice_vectall 284').eq.1).or.        
     :        (iso_verif_positif_nostop(370.0-tcond(i),
     :        'condiso_liq_ice_vectall 286').eq.1).or. 
     :        ((qt(i).eq.0).and.(cond(i).gt.ridicule))) then
              ! c'est impossible de condenser qi pas d'eau au dpart
                write(*,*) 'condiso_liq_ice_vectall 35'
                write(*,*) 'i=',i
                write(*,*) 'qt(i)=',qt(i)
                write(*,*) 'cond(i)=',cond(i)
                write(*,*) 'tcond=',tcond(i)
                stop
            endif
          enddo !do i=1,n
#endif
          do i=1,n
             zcond(i)=max(0.0,min(cond(i),qt(i)))
          enddo
          ! paragraphe enlev le 29 avril 2012 car redondant.
          !if (essai_convergence) then
          !else  
          !    do i=1,n
          !      cond(i)=min(cond(i),qt(i))
          !    enddo
          !endif
            
        ! calculs des coefs de fracs

        call fractcalk_vectall(tcond(1),zxtalphal(1,1),zxtalphai(1,1),n)

#ifdef ISOVERIF
       do i=1,n  
        do ixt=1,niso
            call iso_verif_noNAN(zxtalphal(ixt,i),
     :           'condiso_liq_ice_vectall 65')
            call iso_verif_noNAN(zxtalphai(ixt,i),
     :           'condiso_liq_ice_vectall 66')
        enddo
        if (use_iso_eau.eq.1) then
            call iso_verif_egalite_choix(zxtalphal(iso_eau,i),1.0,
     :           'condiso 21',errmax,errmaxrel)
            call iso_verif_egalite_choix(zxtalphai(iso_eau,i),1.0,
     :           'condiso 21',errmax,errmaxrel)
        endif !if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
        if (use_iso_HDO.eq.1) then
            if (qt(i).gt.ridicule) then
               if (iso_verif_aberrant_nostop(xt(iso_HDO,i)
     :            /qt(i)*zxtalphai(iso_HDO,i)/faccond,
     :            'condiso_liq_ice_vectall 64').eq.1) then
!                write(*,*) 'deltaDt=',(xt/qt/tnat(iso_HDO)-1)*1000
!                write(*,*) 'tcond,fcond,zxtalphai=',
!     :                   tcond,cond/qt,zxtalphai
!                stop
              endif !if (iso_verif_aberrant_nostop(xt/qt*zxtalphai/faccond,
            endif !if (qt.gt.ridicule) then
          endif !if (use_iso_HDO.eq.1) then
         enddo !do i=1,n  
!         write(*,*) 'condiso 320: aprs calculs alpha' 
#endif
        
        ! calculs du condensat

       do i=1,n
       ! on change les seuils
        if ((zcond(i).le.1e-15).or.
     :           ((qt(i).le.1e-15).and.(zcond(i).lt.ridicule))) then
          do ixt=1,niso
            zxtliq(ixt,i)=0.0
            zxtice(ixt,i)=0.0
          enddo
        else !if ((cond(i).le.0.0).or.
                        
         do ixt=1,niso
          zxtliq(ixt,i)=zxtalphal(ixt,i)
     :           *xt(ixt,i)*zcond(i)
     :          /(qt(i)+zcond(i)*(zxtalphal(ixt,i)-1.0))
         enddo

         if (zcond(i)/qt(i).lt.1e-5) then
           ! cas particulier pour viter FI quand cond/qt->0  
           do ixt=1,niso
             zxtice(ixt,i)=xt(ixt,i)/
     :           qt(i)*zcond(i)*zxtalphai(ixt,i)
           enddo !do ixt=1,niso

        else if (1.0-zcond(i)/qt(i).lt.ridicule) then
           ! condensation totale
           ! on ajoute ce cas particulier le 9 avril 2012 car sur vargas
           ! en batch, 0**alpha est NaN
           do ixt=1,niso
             zxtice(ixt,i)=xt(ixt,i)  
           enddo !do ixt=1,niso

         else  !if (cond(i)/qt(i).lt.1e-5) then
           ! cas gnral
           do ixt=1,niso
             zxtice(ixt,i)=xt(ixt,i)
     :          *(1.0-(1.0-zcond(i)/qt(i))**zxtalphai(ixt,i))
           enddo !do ixt=1,niso
        endif !if (cond(i)/qt(i).lt.1e-5) then

        endif  !if ((cond(i).le.0.0).or.
       enddo !do i=1,n
        

        ! verif
        ! verif egalit pour ixt=4 et eau normale:
#ifdef ISOVERIFIDRIS
        do i=1,n
            do ixt=1,niso  
              if ((iso_verif_noNaN_nostop(zxtliq(ixt,i),
     :           'condiso_liq_ice_vectall 91').eq.1).or.
     :           (iso_verif_noNaN_nostop(zxtice(ixt,i),
     :           'condiso_liq_ice_vectall 92').eq.1)) then
                 write(*,*) 'zxtalphal(ixt,i)=',zxtalphal(ixt,i)
                 write(*,*) 'xt(ixt,i)=',xt(ixt,i)
                 write(*,*) 'zcond(i)=',zcond(i)
                 write(*,*) 'qt(i)=',qt(i)
                 stop
              endif
            enddo !do ixt=1,niso  
       enddo !do i=1,n
#endif
#ifdef ISOVERIF
        do i=1,n
          if (zfice(i).lt.1) then  
            do ixt=1,niso  
              call iso_verif_noNaN(zxtliq(ixt,i),
     :           'condiso_liq_ice_vectall 91')
            enddo
            if (use_iso_eau.eq.1) then   
              call iso_verif_egalite_choix(zxtliq(iso_eau,i),cond(i),
     :           'condiso_liq_ice_vectall 30',errmax,errmaxrel)
            endif ! if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then  
            if (use_iso_HDO.eq.1) then 
#ifdef ISOTRAC
                  call iso_verif_aberrant_choix(
     :                zxtliq(iso_HDO,i),cond(i),
     :                ridicule_trac,deltalimtrac,
     :                'condiso_liq_ice_vectall 32')
#else
                  if (iso_verif_aberrant_choix_nostop(
     :                zxtliq(iso_HDO,i),cond(i),
     :                ridicule,deltalim,
     :                'condiso_liq_ice_vectall 32b').eq.1) then
                    write(*,*) 'deltaDvap=',deltaD(xt(iso_hdo,i)/qt(i))
                    write(*,*) 'T,alphal=',
     :                   tcond(i)-t_coup,zxtalphal(iso_hdo,i)
                    write(*,*) 'qt(i)=',qt(i)
                    stop
                  endif !if (iso_verif_aberrant_nostop(
#endif                                     

            endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then 

        endif !if (zfice.lt.1) then

          if (zfice(i).gt.0) then 
            do ixt=1,niso    
              if (iso_verif_noNAN_nostop(zxtice(ixt,i),
     :           'condiso_liq_ice_vectall 417').eq.1) then
                write(*,*) 'ixt,i=',ixt,i
                write(*,*) 'xt(ixt,i)=',xt(ixt,i)
                write(*,*) 'qt(i)=',qt(i)
                write(*,*) 'zcond(i),zcond/qt=',zcond(i),zcond(i)/qt(i)
                write(*,*) 'zxtalphai(ixt,i)=',zxtalphai(ixt,i)
                stop
              endif
            enddo !do ixt=1,niso    
            if (use_iso_eau.eq.1) then      
              call iso_verif_egalite_choix(zxtice(iso_eau,i),cond(i),
     :                   'condiso_liq_ice_vectall 31',errmax,errmaxrel)
            endif ! if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then  
            if (use_iso_HDO.eq.1) then 
              if (cond(i).gt.ridicule) then
                if (iso_verif_aberrant_nostop(
     :               zxtice(iso_HDO,i)/cond(i)/faccond,
     :               'condiso_liq_ice_vectall 414').eq.1) then
                  write(*,*) 'debug condiso_liq_ice_vect 364: i,zfice=',
     :                   i,zfice (i)
                  write(*,*) 'cond,qt,cond/qt=',cond(i)/qt(i),
     :                   cond(i),qt(i)
                  write(*,*) 'xt(iso_HDO)/qt=',
     :                   xt(iso_HDO,i)/qt(i)
                  write(*,*) 'deltaD(xt(iso_HDO)/qt)=',
     :               deltaD(xt(iso_HDO,i)/qt(i))
                  write(*,*) 'zxtalphai(iso_HDO)=',
     :                   zxtalphai(iso_HDO,i)
                  write(*,*) 'Rice/Rv0=',qt(i)/cond(i)*
     :                   (1.0-(1.0-cond(i)/qt(i))**zxtalphai(iso_HDO,i))
                  write(*,*) 'deltaD(zxtice/cond)=',
     :                   deltaD(zxtice(iso_HDO,i)/cond(i))
                  write(*,*) 'tcond(i)=',tcond(i)-t_coup,'C'

                  if (tcond(i)-t_coup.gt.-40.0) then 
                     ! sinon, c'est pas grave, il y aura juste une
                     ! abrrance dans les zones trs froides. 
#ifdef ISOTRAC                     
                     ! on est plus indulgent
                     call iso_verif_aberrant_choix(
     :                zxtice(iso_HDO,i),cond(i),
     :                ridicule_trac,deltalimtrac,
     :                'condiso_liq_ice_vectall 441')
#else
                    stop 
#endif 
                  endif
                  endif
                endif !if (cond.gt.ridicule) then

                if ((zcond(i)/max(qt(i),1e-15).gt.0.95).and.
     :                (zfice(i).eq.1).and.(qt(i).gt.5e-4)) then
                   ! verif que la vapeur est trs pauvre
                   do ixt=1,niso
                     xtv(ixt,i)=xt(ixt,i)-zxtice(ixt,i)        
                   enddo
#ifdef ISOVERIF
                   call iso_verif_noNaN(qt(i),
     :                'condiso_liq_ice_vect 467b')
                   call iso_verif_noNaN(zcond(i),
     :                'condiso_liq_ice_vect 467c')
                   do ixt=1,niso
                     call iso_verif_noNaN(xtv(ixt,i),
     :                'condiso_liq_ice_vect 475a')    
                     call iso_verif_noNaN(xt(ixt,i),
     :                'condiso_liq_ice_vect 475b')   
                     call iso_verif_noNaN(zxtice(ixt,i),
     :                'condiso_liq_ice_vect 475c')   
                   enddo !do ixt=1,niso
#endif                   
                   qv(i)=qt(i)-zcond(i)
                   if (qv(i).gt.ridicule) then
                   if (deltaD(xtv(iso_HDO,i)/qv(i)).gt.-200.0) then
                        write(*,*) 'condiso 454: deltaDv trop fort'
                        write(*,*) 'tcond(i)-t_coup=',tcond(i)-t_coup
                        write(*,*) 'xt(:,i)=',xt(:,i)
                        write(*,*) 'zxtice(:,i)=',zxtice(:,i)
                        write(*,*) 'xtv(:,i)=',xtv(:,i)
                        write(*,*) 'zxtalphai(:,i)=',zxtalphai(:,i)
                        write(*,*) 'qt(i),zcond(i)=',qt(i),zcond(i)
                        stop
                   endif  !if (deltaD((xt(ixt,i)-zxtice(ixt,i))/
                   endif !if (qv(i).gt.ridicule) then
                endif !if (zcond(i)/qt(i).gt.0.95) then
            endif !if (use_iso_HDO.eq.1) then
          endif !if (zfice.gt.0) then             
          enddo ! do i=1,n    
        
#endif
        ! #ifdef ISOVERIF
#ifdef ISOVERIF       
        ! ajout temporaire le 28 oct:
        if (use_iso_HDO.eq.1) then
         do i=1,n
          if (zfice(i).gt.0.9) then
              if (iso_verif_aberrant_choix_nostop(
     :           zxtice(iso_HDO,i),cond(i),ridicule,deltalim_snow,
     :           'condiso_liq_ice_vect 412').eq.1) then
                write(*,*) 'debug condiso_liq_ice_vect 449: i,zfice=',
     :                   i,zfice (i)
                  write(*,*) 'cond/qt=',cond(i)/qt(i)
                  write(*,*) 'deltaD(xt(iso_HDO)/qt)=',
     :               deltaD(xt(iso_HDO,i)/qt(i))
                  write(*,*) 'zxtalphai(iso_HDO)=',
     :                   zxtalphai(iso_HDO,i)
                  write(*,*) 'Rice/Rv0=',qt(i)/cond(i)*
     :                   (1.0-(1.0-cond(i)/qt(i))**zxtalphai(iso_HDO,i))
                  write(*,*) 'deltaD(zxtice/cond)=',
     :                   deltaD(zxtice(iso_HDO,i)/cond(i))   
                  write(*,*) 'tcond(i)=',tcond(i)-t_coup,'C'
                  if (tcond(i)-t_coup.gt.-40.0) then 
                     ! sinon, c'est pas grave, il y aura juste une
                     ! abrrance dans les zones trs froides. 
#ifdef ISOTRAC                     
                     ! on est plus indulgent
                     call iso_verif_aberrant_choix(
     :                zxtice(iso_HDO,i),cond(i),
     :                ridicule_trac,deltalimtrac,
     :                'condiso_liq_ice_vectall 480')
#else
                    stop 
#endif    
                  endif
              endif
          endif
         enddo
        endif !if (use_iso_HDO.eq.1) then 
#endif 
        ! end verif
        do i=1,n
         do ixt=1,niso
          zxtliq(ixt,i)=(1-zfice(i))*zxtliq(ixt,i)
          zxtice(ixt,i)=zfice(i)*zxtice(ixt,i)
         enddo
        enddo
        
        ! cam verif
#ifdef ISOVERIF
      do i=1,n  
        do ixt=1,niso
          call iso_verif_noNAN(zxtliq(ixt,i),
     :           'condiso_liq_ice_vectall 132')
          call iso_verif_noNAN(zxtice(ixt,i),
     :           'condiso_liq_ice_vectall 537')
        enddo !do ixt=1,niso
      enddo !do i=1,n  
          if (use_iso_eau.eq.1) then
            do i=1,n    
            call iso_verif_egalite_choix(zxtice(iso_eau,i)
     :           +zxtliq(iso_eau,i),cond(i),
     :           'condiso_liq_ice_vectall 79',errmax,errmaxrel)
            enddo !do i=1,n  
          endif ! if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
!          write(*,*) 'condiso 477: fin de condiso' 
#endif

      if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
            ! assurer convergence
           do i=1,n
            if (zfice(i).eq.1.0) then
                zxtice(iso_eau,i)=cond(i)
            endif !if (zfice.eq.1.0) then
           enddo
       endif !if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
        
        do i=1,n
         do ixt=1,niso        
          zxtice(ixt,i)=max(0.0,zxtice(ixt,i))
          zxtliq(ixt,i)=max(0.0,zxtliq(ixt,i))
         enddo
        enddo
        ! end verif
        
        ! *********** fin des calculs *********
        
        return
        end
#endif


