#ifdef ISOTRAC

        subroutine condiso_liq_ice_vectiso_trac(xt,qt,cond,
     :           tcond,zfice,zxtice,zxtliq)

        implicit none

        ! version vectorise de condiso_liq_ice
        ! on fait d'un coup tous les iso de 1  niso
        !d'un point de grille donne
        
        ! dclarations
#include "wateriso2.h"
        ! **inputs
        real xt(ntraciso),qt,cond,tcond,zfice ! tcond en K        
        ! **outputs
        real zxtice(ntraciso),zxtliq(ntraciso)
        ! **locals
        integer ixt
        real zcond
        integer ieau,izone,iiso
        real zcondtrac,qttrac
        real xttrac(ntraciso),zxtliqtrac(ntraciso),
     :           zxticetrac(ntraciso)
        ! normallement, niso en dimension suffirait, mais serait pas
        ! cohrent avec les dimensions dans condiso_liq_ice
#include "iso_verif.h"
#ifdef ISOVERIF    
        integer iso_verif_aberrant_nostop ! debugage
        integer iso_verif_aberrant_choix_nostop
        real deltaD
#endif    

        ! verif que qt n'est pas nul
        if (qt.eq.0) then
            if (cond.lt.ridicule) then
              do ixt=1,ntraciso  
                zxtliq(ixt)=0
                zxtice(ixt)=0
              enddo
              return
            else
                ! c'est impossible de condenser qi pas d'eau au dpart
                write(*,*) 'condiso_liq_ice_vectiso_trac 35'
                write(*,*) 'qt=',qt
                write(*,*) 'cond=',cond
                stop
            endif
        endif !if (qt.eq.0) then
        zcond=max(0.0,min(cond,qt))

#ifdef ISOVERIF
       do izone=1,ntraceurs_zone
          ieau=index_trac(izone,iso_eau) 
          call iso_verif_positif((qt-xt(ieau))*1e-4,'condisotrac 54')
       enddo
       call iso_verif_traceur(xt(1),'condisotrac 56')
#endif        
        
        do izone=1,ntraceurs_zone
          ieau=index_trac(izone,iso_eau)
          qttrac=xt(ieau)
          zcondtrac=(zcond/qt)*xt(ieau)
          zcondtrac=min(zcondtrac,qttrac)
          do iiso=1,niso          
            xttrac(iiso)=xt(index_trac(izone,iiso))
          enddo
          call condiso_liq_ice_vectiso(xttrac,qttrac,zcondtrac,
     :           tcond,zfice,zxticetrac,zxtliqtrac)
!          write(*,*) 'zxticetrac=',zxticetrac
          do iiso=1,niso          
            zxtice(index_trac(izone,iiso))=zxticetrac(iiso)
            zxtliq(index_trac(izone,iiso))=zxtliqtrac(iiso)
          enddo
#ifdef ISOVERIF  
        if (use_iso_HDO.eq.1) then 
              if (zcondtrac.gt.ridicule) then
                  if (iso_verif_aberrant_nostop(zxtice(iso_HDO)/cond
     :             /faccond,'condiso_trac 79').eq.1) then
                  write(*,*) 'izone=',izone
                  write(*,*) 'zcondtrac/qttrac=',cond/qt
                  write(*,*) 'deltaD(xt(iso_HDO)/qt)=',
     :                           deltaD(xttrac(iso_HDO)/qttrac)
                  write(*,*) 'tcond=',tcond-273,'C' 
                  if (tcond-273.gt.-40.0) then
                      ! au dessus de -40, il y a de quoi s'inquiter
                      ! en dessous, on ne sait pas ce que valent les alphas
                     stop
                  endif !if (tcond(i).gt.100.0) then
                  endif
                endif !if (cond.gt.ridicule) then 
            endif !if (use_iso_HDO.eq.1) then
#endif          
        enddo ! do izone=1,ntraceurs_zone 

#ifdef ISOVERIF      
!        write(*,*) 'zxtice=',zxtice  
!        write(*,*) 'zcond=',zcond
!        write(*,*) 'xt=',xt
!        write(*,*) 'qt=',qt
        call iso_verif_traceur(zxtliq(1),
     :          'condiso_liq_ice_vectiso_trac 194')
        call iso_verif_traceur_justmass(zxtice(1),
     :          'condiso_liq_ice_vectiso_trac 196')
        ! on ne peut pas faire pour xt
#endif

        if (option_traceurs.eq.17) then
           ! colorier le condensat en un tag spcifique
           do ixt=1,ntraciso
             if (index_zone(ixt).eq.izone_cond) then
                zxtliq(ixt)=zxtliq(index_iso(ixt))
                zxtice(ixt)=zxtice(index_iso(ixt))
             else !if (index_zone(ixt).eq.izone_cond) then
                zxtliq(ixt)=0.0
                zxtice(ixt)=0.0
             endif !if (index_zone(ixt).eq.izone_cond) then
           enddo !do ixt=1,ntraciso      
        endif !if (option_traceurs.eq.17) then
#ifdef ISOVERIF
        call iso_verif_traceur(zxtliq(1),
     :          'condiso_liq_ice_vectiso_trac 122')
        call iso_verif_traceur_justmass(zxtice(1),
     :          'condiso_liq_ice_vectiso_trac 124')
#endif

        return
        end  


        subroutine condiso_liq_ice_vectall_trac(xt,qt,cond,
     :           tcond,zfice,zxtice,zxtliq,n)

        implicit none

        ! version vectorise de condiso_liq_ice
        ! on fait d'un coup tous les lieux i de 1  n
        ! et tous les iso de 1  niso
        
        ! dclarations
#include "wateriso2.h"
        ! **inputs
        integer n
        real xt(ntraciso,n),qt(n),cond(n),tcond(n),zfice(n) ! tcond en K        
        ! **outputs
        real zxtice(ntraciso,n),zxtliq(ntraciso,n)
        ! **locals
        integer ixt, i ! compteurs
        real zcond(n)
#include "iso_verif.h"
!#ifdef ISOVERIF
!        integer iso_verif_aberrant_nostop ! debugage
!        integer iso_verif_aberrant_choix_nostop
!        real deltaD
!#endif 
        integer izone,ieau,iiso
        real zcondtrac(n),qttrac(n)
        real xttrac(ntraciso,n),zxtliqtrac(ntraciso,n),
     :           zxticetrac(ntraciso,n)
        ! normallement, niso en dimension suffirait, mais serait pas
        ! cohrent avec les dimensions dans condiso_liq_ice

!#ifdef ISOVERIF
!        write(*,*) 'condisotrac 112: entre, n=',n
!#endif

!        ! verif qt pas nul
!        do i=1,n
!          if (qt(i).eq.0) then
!            if (cond(i).lt.ridicule) then
!              do ixt=1,ntraciso  
!                zxtliq(ixt,i)=0
!                zxtice(ixt,i)=0
!              enddo
!              return
!            else
!                ! c'est impossible de condenser qi pas d'eau au dpart
!                write(*,*) 'condiso_liq_ice_vectall_trac 119'
!                write(*,*) 'qt=',qt(i)
!                write(*,*) 'cond=',cond(i)
!                stop
!            endif
!          endif !if (qt(i).eq.0) then
!        enddo !do i=1,n

        do i=1,n
             zcond(i)=max(0.0,min(cond(i),qt(i)))
        enddo

#ifdef ISOVERIF  
        do i=1,n
          call iso_verif_traceur(xt(1,i),
     :          'condiso_liq_ice_vectall_trac 132')
        enddo !do i=1,n
#endif

!        write(*,*) 'condisotrac tmp 128: xt(1:ntraciso,2)=',
!     :           xt(1:ntraciso,2)
!        write(*,*) 'zcond(2)=',zcond(2)
        do izone=1,ntraceurs_zone    
#ifdef ISOVERIF        
!        write(*,*) 'condisotrac 183: izone=',izone
#endif        
          ieau=index_trac(izone,iso_eau)
          do i=1,n
            qttrac(i)=xt(ieau,i)
            if (qt(i).gt.0.0) then
               zcondtrac(i)=(zcond(i)/qt(i))*xt(ieau,i)
            else !if (qt(i).eq.0) then
#ifdef ISOVERIF              
                call iso_verif_egalite(cond(i),0.0,'condisotrac 195')
#endif
                zcondtrac(i)=0.0
            endif !if (qt(i).eq.0) then
            zcondtrac(i)=min(zcondtrac(i),qttrac(i))
            do iiso=1,niso          
              xttrac(iiso,i)=xt(index_trac(izone,iiso),i)
            enddo
#ifdef ISOVERIF
            if (use_iso_eau.eq.1) then
              call iso_verif_egalite_choix(qttrac(i),
     :           xttrac(iso_eau,i),'condisotrac 148',
     :           errmax,errmaxrel)
            endif
            if (use_iso_HDO.eq.1) then
!              if (qttrac(i).gt.ridicule_trac) then
                call iso_verif_aberrant_choix(xttrac(iso_HDO,i),
     :           qttrac(i),ridicule_trac,deltalimtrac,
     :           'condisotrac 205')
!              endif
            endif
            call iso_verif_positif(qt(i)-cond(i),
     :           'condisotrac 163: cond>qt')
            call iso_verif_positif(qttrac(i)-zcondtrac(i),
     :           'condisotrac 165: cond>qt')
#endif            
          enddo !do i=1,n
!#ifdef ISOVERIF          
!          write(*,*) 'condisotrac 164: avant condiso'
!#endif           
          call condiso_liq_ice_vectall(xttrac,qttrac,zcondtrac,
     :           tcond,zfice,zxticetrac,zxtliqtrac,n)
!#ifdef ISOVERIF          
!          write(*,*) 'condisotrac 167: aprs condiso'
!#endif           
          do i=1,n
          do iiso=1,niso          
            zxtice(index_trac(izone,iiso),i)=zxticetrac(iiso,i)
            zxtliq(index_trac(izone,iiso),i)=zxtliqtrac(iiso,i)
          enddo
          enddo !do i=1,n
        enddo !do izone=1,ntraceurs_zone
!        write(*,*) 'zxtice(1:ntraciso,2)=',
!     :           zxtice(1:ntraciso,2)
!        write(*,*) 'zxtliq(1:ntraciso,2)=',
!     :           zxtliq(1:ntraciso,2)

#ifdef ISOVERIF  
        do i=1,n          
          call iso_verif_traceur(zxtliq(1,i),
     :          'condiso_liq_ice_vectall_trac 144')
          call iso_verif_traceur(zxtice(1,i),
     :          'condiso_liq_ice_vectall_trac 146')
        enddo !do i=1,n
#endif

        return
        end


#endif


