        subroutine integrale_Rieman_precision(binf,bsup,I,e,ntot
     :          ,qp0,A,m0,beta,gama,f0,g0) 
        implicit none
#define OPTIMFUNC        

        ! calcul d'intgral par mthode de monte carlo.
        ! ***declarations: 
        
        ! **inputs:
        double precision binf,bsup ! bornes
        integer ntot ! nbre de bins
        double precision qp0
        double precision A,m0,beta,gama,f0,g0 
                ! arguments de la fonction  intgrer
        
        ! ** output
        double precision I ! integrale
        double precision e ! erreur
        
        ! **locals
        integer j
        double precision dxj, xj
        double precision Imin, Imax
#ifdef OPTIMFUNC
        double precision func_precision
#endif        

         ! verifs
#include "iso_verif.h"
        
        ! *** verifs
        
        if (bsup.lt.binf) then
            write(*,*) 'integrale_rieman 25'
            write(*,*) 'binf=',binf,' bsup=',bsup
            stop
        endif

!        write(*,*) 'binf=',binf,' bsup=',bsup
!        write(*,*) 'A=',A
!        write(*,*) 'm0=',m0
!        write(*,*) 'beta=',beta
!        write(*,*) 'gama=',gama
!        write(*,*) 'qp0=',qp0
        
        !*** calculs
        
        I=0
        dxj=(bsup-binf)/ntot
#ifdef ISOVERIF        
        if (abs(gama-1).lt.errmax) then
        write(*,*) 'rieman 50: ntot,binf,bsup,dxj=', ntot,binf,bsup,dxj
        write(*,*) 'qp0,A,m0,m,g0,beta,gama,f0,bsup=',
     :           qp0,A,m0,binf,g0,beta,gama,f0,bsup
         endif
#endif         
!        write(*,*) 'bsup-binf=',bsup-binf
!        write(*,*) 'ntot=',ntot
        do j=2,ntot
          xj=binf+(j-1)*dxj
!          write(*,*) 'xj=',xj
#ifdef OPTIMFUNC
           ! in-lining:
           I=I+dxj*((((qp0-A*(xj-m0))/qp0)/g0)**(beta*gama-1))
     :            *(((xj/m0)/f0)**(-beta-1))  
!#ifdef ISOVERIF        
!        if (abs(gama-1).lt.errmax) then           
!           write(*,*) 'rieman tmp 60: func=',
!     :           ((((qp0-A*(xj-m0))/qp0)/g0)**(beta*gama-1))
!     :            *(((xj/m0)/f0)**(-beta-1))
!        endif
!#endif                 
#else
          ! appel de function, plus propre, mais casse la vectorisation    
           I=I+dxj*func_precision(xj,qp0,A,m0,beta,gama,f0,g0)
#endif
!          
       enddo
!       write(*,*) 'fin boucle'
       ! integrale avec valeur au dbut de l'intervalle
       xj=binf
#ifdef OPTIMFUNC      
           Imin=I+dxj*((((qp0-A*(xj-m0))/qp0)/g0)**(beta*gama-1))
     :            *(((xj/m0)/f0)**(-beta-1))
!#ifdef ISOVERIF        
!        if (abs(gama-1).lt.errmax) then           
!           write(*,*) 'rieman tmp 60: func,Imin=',
!     :           ((((qp0-A*(xj-m0))/qp0)/g0)**(beta*gama-1))
!     :            *(((xj/m0)/f0)**(-beta-1)),Imin
!           endif
!#endif
#else
           Imin=I+dxj*func_precision(xj,qp0,A,m0,beta,gama,f0,g0)
#endif
       ! integrale avec valeur en fin d'intervalle
       xj=bsup
#ifdef OPTIMFUNC      
           Imax=I+dxj*((((qp0-A*(xj-m0))/qp0)/g0)**(beta*gama-1))
     :            *(((xj/m0)/f0)**(-beta-1))
!#ifdef ISOVERIF        
!        if (abs(gama-1).lt.errmax) then           
!           write(*,*) 'rieman tmp 76: func,Imax=',
!     :           ((((qp0-A*(xj-m0))/qp0)/g0)**(beta*gama-1))
!     :            *(((xj/m0)/f0)**(-beta-1)),Imax
!           endif
!#endif
#else
           Imax=I+dxj*func_precision(xj,qp0,A,m0,beta,gama,f0,g0)
#endif

       e=abs(Imax-Imin)
       I=(Imin+Imax)/2
!       write(*,*) 'rieman tmp 86: I=',I
       

       ! verif
       if ((I.gt.-ridicule).and.(I.lt.borne)) then
       else
           write(*,*) 'I=',I,' e=',e
           write(*,*) 'Imin=',Imin,' Imax=',Imax
           write(*,*) 'qp0=',qp0,' A=',A,' m0=',m0
           write(*,*) 'beta=',beta,' gama=',gama
           write(*,*) 'binf=',binf,' bsup=',bsup
       endif
       ! end verif
            
!       write(*,*) 'I=',I
!       write(*,*) 'Imax=',Imax,'Imin=',Imin
!       write(*,*) 'e=',e

       return
       end
           
        
        
