#ifdef ISO
      subroutine integrale_Rieman_vectall(ncas,m,I,e,
     :          qp0,A,m0,beta,gama,f0,g0,ntot_loc) 
        implicit none

        ! calcul d'intgral par mthode de rieman
        ! ***declarations: 
#include "wateriso2.h"   

        ! **inputs:
        integer ncas
        ! arguments de la fonction  intgrer:
        double precision qp0(ncas)
        double precision A(ncas),m(ncas),m0(ncas),beta(niso,ncas),
     :           gama(niso,ncas),f0(ncas),g0(ncas) 
        integer ntot_loc(ncas)                
        
        ! ** output
        double precision I(niso,ncas) ! integrale
        double precision e(niso,ncas) ! erreur
        
        ! **locals
        ! ! nombre max d'itration dans integrale rieman
        integer j
        integer il,ixt
        double precision dxj(ncas)
        double precision Imin(niso,ncas), Imax(niso,ncas)

         ! verifs
#ifdef ISOVERIF         
        include "iso_verif.h"
        real double_to_real
#endif        
        
        ! *** verifs
        
#ifdef ISOVERIF     
      do il=1,ncas   
        if (m0(il).lt.m(il)) then
            write(*,*) 'integrale_rieman 25'
            write(*,*) 'binf=',m(il),' bsup=',m0(il)
            stop
        endif
      enddo
#endif        

!        write(*,*) 'binf=',binf,' bsup=',bsup
        
        !*** calculs
        
        do il=1,ncas
          dxj(il)=(m0(il)-m(il))/float(ntot_loc(il))
          do ixt=1,niso
            I(ixt,il)=0.0
          enddo
        enddo !do il=1,ncas   
        
!        write(*,*) 'rieman vect temp 52: il,dxj=',il,dxj(il)
!        write(*,*) 'qp0,A,m0,m,g0,beta,gama,f0=',
!     :           qp0(il),A(il),m0(il),m(il),g0(il),f0(il)
!        write(*,*) 'bsup-binf=',bsup-binf
!        write(*,*) 'ntot_loc=',ntot_loc
        do il=1,ncas        
          do j=2,ntot_loc(il)
            do ixt=1,niso
!          write(*,*) 'xj=',xj
           I(ixt,il)=I(ixt,il)+dxj(il)*((((qp0(il)-A(il)
     :       *(m(il)+(j-1)*dxj(il)-m0(il)))/qp0(il))/g0(il))
     :           **(beta(ixt,il)*gama(ixt,il)-1))
     :       *((((m(il)+(j-1)*dxj(il))/m(il)))
     :           **(-beta(ixt,il)-1))  
!          
            enddo  !do ixt=1,niso
          enddo !do j=2,ntot_loc(il)
        enddo
        
       ! integrale avec valeur au dbut de l'intervalle (en m)
       do il=1,ncas
        do ixt=1,niso
         Imin(ixt,il)=I(ixt,il)+dxj(il)
       ! integrale avec valeur en fin d'intervalle (en m0)
         Imax(ixt,il)=I(ixt,il)+dxj(il)
     :       *(g0(il))**(1-beta(ixt,il)*gama(ixt,il))
     :       *(f0(il))**(beta(ixt,il)+1)

         e(ixt,il)=abs(Imax(ixt,il)-Imin(ixt,il))
!       I=(1.1*Imin+0.9*Imax)/2.0
         I(ixt,il)=(Imin(ixt,il)+Imax(ixt,il))/2.0
         enddo !do ixt=1,niso
       enddo !do il=1,ncas 

       ! verif
#ifdef ISOVERIF  
       do il=1,ncas 
       do ixt=1,niso     
       call iso_verif_noNaN(double_to_real(I(ixt,il)),'integrale 68')
       enddo
       enddo
#endif       
       ! end verif
            
!       write(*,*) 'I=',I
!       write(*,*) 'Imax=',Imax,'Imin=',Imin
!       write(*,*) 'e=',e

       return
       end
           
#endif        
        
