#ifdef ISO
      subroutine integrale_gauss_vectall(ncas,m,I,
!     :          qp0,A,m0,beta,gama,g0,ntot) 
     :          qp0,A,m0,beta,gama,g0)  
        implicit none

        ! version vectorise en ncas. La vesrion _bak23fev2008 tait
        ! vectorise en ntot

        ! calcul d'intgral par mthode de gauss
        ! on vectorise sur toutes les intgrales  calculer
        ! ***declarations: 
#include "wateriso2.h"   

        ! **inputs:
        integer ncas
        ! arguments de la fonction  intgrer:
        double precision qp0(ncas)
        double precision A(ncas),m(ncas),m0(ncas),beta(niso,ncas),
     :           gama(niso,ncas),f0(ncas),g0(ncas) 
!        integer ntot(ncas) 
!        integer ntot
!        parameter (ntot=40)        
        
        ! ** output
        double precision I(niso,ncas) ! integrale
        
        ! **locals
        ! ! nombre max d'itration dans integrale rieman
        integer j
        integer il,ixt,k
        double precision dxj(ncas)
        integer ndeg ! degrs du polynome de Legendre 
        parameter (ndeg=5)   
        double precision w(ndeg),z(ndeg)
        real fj
            
!        double precision xj        

         ! verifs
#ifdef ISOVERIF         
        include "iso_verif.h"
        real double_to_real
#endif        
        
        ! *** verifs
!        write(*,*) 'ntot=',ntot
        
#ifdef ISOVERIF     
      do il=1,ncas   
        if (m0(il).lt.m(il)) then
            write(*,*) 'integrale_rieman 25'
            write(*,*) 'binf=',m(il),' bsup=',m0(il)
            stop
        endif
      enddo
#endif        

!        write(*,*) 'binf=',binf,' bsup=',bsup
        
        !*** calculs

        if (ndeg.eq.1) then
           z(1)=0.0
           w(1)=2.0
         else if (ndeg.eq.2) then
           z(1)=-0.577350269189
           z(2)=0.577350269189
           w(1)=1.0
           w(2)=1.0
        else if (ndeg.eq.3) then
           z(1)=-0.774596669241
           z(2)=0.0
           z(3)=0.774596669241
           w(1)=0.5555555555555
           w(2)=0.8888888888888
           w(3)=0.5555555555555
        else if (ndeg.eq.4) then
           z(1)=-0.861136311594
           z(2)=-0.3399810435848
           z(3)=0.3399810435848
           z(4)=0.861136311594
           w(1)=0.34785484513745
           w(2)=0.6521451548625 
           w(3)=0.6521451548625
           w(4)=0.34785484513745 
        else if (ndeg.eq.5) then
           z(1)=-0.90617984593866399280
           z(2)=-0.53846931010568309104
           z(3)=0.0
           z(4)=0.53846931010568309104
           z(5)=0.90617984593866399280
           w(1)=0.23692688505618908751
           w(2)=0.47862867049936646804 
           w(3)=0.568888888888888888889
           w(4)=0.47862867049936646804
           w(5)=0.23692688505618908751
        else
            write(*,*) 'integrale gauss: non prvu: ndeg=',ndeg
            stop
        endif  
        
        do il=1,ncas
!          dxj(il)=(m0(il)-m(il))/float(ntot(il))
          dxj(il)=(m0(il)-m(il))/float(ntot)
          do ixt=1,niso
            I(ixt,il)=0.0
          enddo
        enddo !do il=1,ncas   
        
        do j=1,ntot
          fj=float(j)
          do il=1,ncas      
            do ixt=1,niso
!                I(ixt,il)=I(ixt,il)
!     :            +w(k)*(
!     :                   ((((qp0(il)-A(il)
!     :           *((m(il)+0.5*(z(k)+2*float(j)-1.0)*dxj(il))-m0(il)))
!     :           /qp0(il))/g0(il))
!     :           **(beta(ixt,il)*gama(ixt,il)-1))
!     :           *((((m(il)+0.5*(z(k)+2*float(j)-1.0)*dxj(il))/m(il)))
!     :           **(-beta(ixt,il)-1))  ) 
              I(ixt,il)=I(ixt,il)+w(1)*(
     :                   ((((qp0(il)-A(il)
     :           *((m(il)+0.5*(z(1)+2*fj-1.0)*dxj(il))-m0(il)))
     :           /qp0(il))/g0(il))
     :           **(beta(ixt,il)*gama(ixt,il)-1))
     :           *((((m(il)+0.5*(z(1)+2*fj-1.0)*dxj(il))/m(il)))
     :           **(-beta(ixt,il)-1))  )
     :         +w(2)*(
     :                   ((((qp0(il)-A(il)
     :           *((m(il)+0.5*(z(2)+2*fj-1.0)*dxj(il))-m0(il)))
     :           /qp0(il))/g0(il))
     :           **(beta(ixt,il)*gama(ixt,il)-1))
     :           *((((m(il)+0.5*(z(2)+2*fj-1.0)*dxj(il))/m(il)))
     :           **(-beta(ixt,il)-1))  )
     :         +w(3)*(
     :                   ((((qp0(il)-A(il)
     :           *((m(il)+0.5*(z(3)+2*fj-1.0)*dxj(il))-m0(il)))
     :           /qp0(il))/g0(il))
     :           **(beta(ixt,il)*gama(ixt,il)-1))
     :           *((((m(il)+0.5*(z(3)+2*fj-1.0)*dxj(il))/m(il)))
     :           **(-beta(ixt,il)-1))  )
     :         +w(4)*(
     :                   ((((qp0(il)-A(il)
     :           *((m(il)+0.5*(z(4)+2*fj-1.0)*dxj(il))-m0(il)))
     :           /qp0(il))/g0(il))
     :           **(beta(ixt,il)*gama(ixt,il)-1))
     :           *((((m(il)+0.5*(z(4)+2*fj-1.0)*dxj(il))/m(il)))
     :           **(-beta(ixt,il)-1))  )
     :         +w(5)*(
     :                   ((((qp0(il)-A(il)
     :           *((m(il)+0.5*(z(5)+2*fj-1.0)*dxj(il))-m0(il)))
     :           /qp0(il))/g0(il))
     :           **(beta(ixt,il)*gama(ixt,il)-1))
     :           *((((m(il)+0.5*(z(5)+2*fj-1.0)*dxj(il))/m(il)))
     :           **(-beta(ixt,il)-1))  )
            enddo  !do ixt=1,niso
!           enddo !do k=1,ndeg   
          enddo !do j=2,ntot(il)
        enddo
        
       ! integrale avec valeur au dbut de l'intervalle (en m)
       do il=1,ncas
        do ixt=1,niso
           I(ixt,il)=I(ixt,il)*0.5*dxj(il)
         enddo !do ixt=1,niso
       enddo !do il=1,ncas 

       ! verif
#ifdef ISOVERIF  
       do il=1,ncas 
       do ixt=1,niso     
       call iso_verif_noNaN(double_to_real(I(ixt,il)),'integrale 68')
       enddo
       enddo
#endif       
       ! end verif
            
!       write(*,*) 'I=',I
!       write(*,*) 'Imax=',Imax,'Imin=',Imin
!       write(*,*) 'e=',e

       return
       end
           
#endif        
        
