! subroutine gnrique  ne jamais modifier
#ifdef ISO

      subroutine fractcalk_vectall(ptin, pxtfra, pfraice,n)
      implicit none

C-------------------------------------------------------------------------
C Calculation of the fractionation coefficient of water isotopes.
C
C March 2003
C Sandrine Bony (LMD/CNRS), after MPI code from Georg Hoffmann (LSCE)
C-------------------------------------------------------------------------
      ! camille risi: vectorisation sur les points de grilles

#include "wateriso2.h"
#include "iso_verif.h"

c -- inputs:
      integer n ! nombre de mailles  traiter
      real ptin(n)       ! temperature (K)

c -- outputs:
      real pxtfra(niso,n)   ! fractionation factor for vapor/liquid condensation
      real pfraice(niso,n)  ! fractionation factor for vapor/ice condensation

c -- local variables:
      real ZCELS, ZSATVAL(n)
      parameter (ZCELS=273.15)
      real pt(n) ! la temprature max(ptin,pxtmin)
      integer i ! compteur: indice des mailles
      integer ixt ! compteur: indice de l'isotope

#ifdef ISOVERIF
      integer iso_verif_noNAN_nostop ! pour debugage
#endif      

      real alpha_max
      parameter (alpha_max=10.0)


c-----------------------------------------------------------
C FRACTIONATION OVER WATER:
c-----------------------------------------------------------

      do i=1,n
       pt(i)=max(ptin(i),pxtmin)
      enddo

      do ixt=1,niso ! *******************************

       if ((use_iso_O17.eq.1).and.(ixt.eq.iso_O17)) then
         do i=1,n
         pxtfra(ixt,i)=(EXP(talph1(ixt)/(pt(i)**2)
     :           +talph2(ixt)/pt(i)+talph3(ixt)))
     :           **fac_coeff_eq17_liq
         enddo
       else
         do i=1,n
           pxtfra(ixt,i)=EXP(talph1(ixt)/(pt(i)**2)
     :           +talph2(ixt)/pt(i)+talph3(ixt))
         enddo
       endif

#ifdef ISOVERIF
       do i=1,n
        if (pt(i).gt.pxtice) then
           if (iso_verif_noNAN_nostop(pxtfra(ixt,i),
     :           'iso_fractcal 33').eq.1) then
           endif
        endif !if (pt(i).gt.pxtice) then
       enddo
#endif     
      do i=1,n  
       pxtfra(ixt,i)=max(min(
     :           pxtfra(ixt,i),alpha_max),0.0)
      enddo !do i=1,n

c-----------------------------------------------------------
C FRACTIONATION OVER ICE
c-----------------------------------------------------------

       if ((use_iso_HTO.eq.1).and.(ixt.eq.iso_HTO)) then
         do i=1,n 
          pfraice(ixt,i)=EXP(talps1(ixt)/(pt(i)**2)
     :            +talps2(ixt)/pt(i))
         enddo !do i=1,n       
       elseif ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then
         do i=1,n
          pfraice(ixt,i)=EXP(talps1(ixt)/(pt(i)**2)
     :           +talps2(ixt))
         enddo !do i=1,n       
       elseif ((use_iso_O18.eq.1).and.(ixt.eq.iso_O18)) then
         do i=1,n
          pfraice(ixt,i)=EXP(talps1(ixt)/pt(i)+talps2(ixt))
         enddo !do i=1,n 
       elseif ((use_iso_O17.eq.1).and.(ixt.eq.iso_O17)) then
         do i=1,n
          pfraice(ixt,i)=(EXP(talps1(ixt)/pt(i)
     :           +talps2(ixt)))**fac_coeff_eq17_ice
         enddo !do i=1,n 
       elseif ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
         do i=1,n
          pfraice(ixt,i)=1.
         enddo !do i=1,n 
       else
           write(*,*) 'iso_fractcal 47: non prvu: ixt=',ixt
       endif

#ifdef ISOVERIF  
       do i=1,n     
         if (pt(i).lt.pxtmelt) then
           if (iso_verif_noNAN_nostop(pfraice(ixt,i),
     :           'iso_fractcal 55').eq.1) then
           endif
         endif !if (pt(i).lt.pxtmelt) then
       enddo !do i=1,n
#endif   
      do i=1,n    
       pfraice(ixt,i)=max(min(
     :            pfraice(ixt,i),alpha_max),0.0)
      enddo

c-----------------------------------------------------------
C EFFECTIVE FRACTIONATION OVER ICE if NECESSARY
c-----------------------------------------------------------

       if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
       else  !if ((use_iso_eau).and.(ixt.eq.iso_eau)) then
         do i=1,n   
          if (pt(i).lt.pxtmelt) then
           ZSATVAL(i)=musi-lambda_sursat*(pt(i)-ZCELS)
           pfraice(ixt,i)=pfraice(ixt,i)
     :        *(ZSATVAL(i)/(1.+pfraice(ixt,i)*(ZSATVAL(i)-1.)
     :        *tdifrel(ixt)))
          endif !if (pt(i).lt.pxtmelt) then
         enddo ! do i=1,n 
       endif !if ((ixt.ne.iso_eau).or.(use_iso_eau.ne.1)) then

#ifdef ISOVERIF
       do i=1,n
         if (iso_verif_noNAN_nostop(pfraice(ixt,i),
     :          'iso_fractcal 73').eq.1) then 
!            write(*,*) 'ixt,pt(i)=',ixt,pt(i)
!            write(*,*) 'ZSATVAL,tdifrel(ixt)=',ZSATVAL,tdifrel(ixt)
         endif
       enddo
         if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then  
            do i=1,n 
             call iso_verif_egalite(pfraice(ixt,i),1.0,
     :                  'iso_fractcal 63')
             call iso_verif_egalite(pxtfra(ixt,i),1.0,
     :           'iso_fractcal 67')
            enddo ! do i=1,n 
         endif !if ((use_iso_eau).and.(ixt.eq.iso_eau)) then  
#endif
       do i=1,n
         pfraice(ixt,i)=max(min(
     :           pfraice(ixt,i),alpha_max),0.0)
       enddo

       enddo ! do ixt=1,niso ****************************

      return
      end
#endif

