#ifdef ISO
      SUBROUTINE iso_init()
      use IOIPSL ! getin
      implicit none

C--------------------------------------------------------------------------
C Purpose:
C sets default values for several variables used by water isotope tourines.
C
C March 2003:
C Sandrine Bony (LMD/CNRS), after INITRIT from G. Hoffmann (LSCE)
C--------------------------------------------------------------------------

c1506 #include "dimiso.h"    
#include "wateriso2.h"
#include "iso_verif.h"
!#include "iso_def.h"


!      integer niso

c -- local variables:

      integer ixt
      ! rÈfÈrence O18
      real fac_enrichoce18
      real alpha_liq_sol_O18,
     :     talph1_O18,talph2_O18,talph3_O18,
     :     talps1_O18,talps2_O18,
     :     tkcin0_O18,tkcin1_O18,tkcin2_O18,
     :     tdifrel_O18        
      ! cas de l'O17
      real fac_kcin
      real pente_MWL
      integer ierr

      logical ok_nocinsat, ok_nocinsfc !sensi test
      parameter (ok_nocinsfc=.FALSE.)  ! if T: no kinetic effect in sfc evap
      parameter (ok_nocinsat=.FALSE.)  ! if T: no sursaturation effect for ice
      logical Rdefault_smow
      parameter (Rdefault_smow=.FALSE.) ! si T: Rdefault=smow; si F: nul
      ! pour le tritium
      integer iessai


c--------------------------------------------------------------
c General:
c--------------------------------------------------------------

c -- verif du nombre d'isotopes:
      write(*,*) 'iso_init 64: niso=',niso
              
c -- Type of water isotopes:
      

      iso_eau=max(use_iso_eau,1)
      iso_HDO=max(use_iso_eau+use_iso_HDO,1)
      iso_O18=max(use_iso_eau+use_iso_HDO+use_iso_O18,1)
      iso_O17=max(use_iso_eau+use_iso_HDO+use_iso_O18
     :           +use_iso_O17,1)
      iso_HTO=max(use_iso_eau+use_iso_HDO+use_iso_O18
     :           +use_iso_O17+use_iso_HTO,1)

      write(*,*) 'iso_eau=',iso_eau
      write(*,*) 'iso_HDO=',iso_HDO
      write(*,*) 'iso_O18=',iso_O18
      write(*,*) 'iso_O17=',iso_O17
      write(*,*) 'iso_HTO=',iso_HTO

      ! ouverture fichier de paramËtres, iso.def.
      ! on fait comme l'ouverture de physiq.F: on utilise les getin

      ! initialisation
        lambda_sursat=0.004
        thumxt1=0.75*1.2
        ntot=20
        h_land_ice=20. ! ‡ comparer aux 3000mm de snow_max
        P_veg=1.0
        bidouille_anti_divergence=.false.
        essai_convergence=.false.
        initialisation_iso=0
        initialisation_isotrac=0
        modif_sst=0
        modif_sic=0
        deltaTtest=0.0
        deltasic=0.1
        deltaTtestpoles=0.0
        sstlatcrit=30.0
        deltaO18_oce=0.0
        albedo_prescrit=0
        lon_min_albedo=-200
        lon_max_albedo=200
        lat_min_albedo=-100
        lat_max_albedo=100
        deltaP_BL=10.0
        ruissellement_pluie=0
        alphak_stewart=1
        tdifexp_sol=0.67
        calendrier_guide=0
        cste_surf_cond=0
        mixlen=35.0
        deltalim=300.0
        deltalim_snow=500.0
        deltaDmin=-900.0
#ifdef ISOTRAC         
        deltalimtrac=2000.0
#endif 
        evap_cont_cste=0.0
        deltaO18_evap_cont=0.0
        d_evap_cont=0.0
        O17_verif=.false.
        o17excess_bas=-200.0
        o17excess_haut=120.0
        nlevmaxO17=50
        lev_histiso=1
        lev_histiso_diag=1
        no_pce=0
        A_satlim=1.0
        ok_restrict_A_satlim=0
!        slope_limiterxy=2.0
!        slope_limiterz=2.0
        modif_ratqs=0
        Pcrit_ratqs=500.0
        ratqsbasnew=0.05

        fac_modif_evaoce=1.0
        ok_bidouille_wake=0
        cond_temp_env=.false.
        ! si oui, la temperature de cond est celle de l'environnement,
        ! pour eviter bugs quand temperature dans ascendances convs est
        ! mal calculee
        ok_prod_nucl_tritium=.true. ! si oui, production nucleaire de tritium

      ! lecture des paramËtres isotopiques:
      call getin('lambda',lambda_sursat)
      call getin('thumxt1',thumxt1)
      call getin('ntot',ntot)
      call getin('h_land_ice',h_land_ice)
      call getin('P_veg',P_veg)
      call getin('bidouille_anti_divergence',bidouille_anti_divergence)
      call getin('essai_convergence',essai_convergence)
      call getin('initialisation_iso',initialisation_iso)
#ifdef ISOTRAC      
      if (initialisation_iso.eq.0) then
          call getin('initialisation_isotrac',initialisation_isotrac)
      endif !if (initialisation_iso.eq.0) then
#endif      
      call getin('modif_sst',modif_sst)
      if (modif_sst.ge.1) then
        call getin('deltaTtest',deltaTtest)
        if (modif_sst.ge.2) then
          call getin('deltaTtestpoles',deltaTtestpoles)
          call getin('sstlatcrit',sstlatcrit)
#ifdef ISOVERIF
              call iso_verif_positif(sstlatcrit,'iso_init 107')
#endif              
          if (modif_sst.ge.3) then  
              call getin('dsstlatcrit',dsstlatcrit)
#ifdef ISOVERIF
              call iso_verif_positif(dsstlatcrit,'iso_init 110')
#endif              
          endif
        endif
      endif     
      call getin('modif_sic',modif_sic)
      if (modif_sic.ge.1) then
        call getin('deltasic',deltasic)
      endif
      call getin('albedo_prescrit',albedo_prescrit)
      call getin('lon_min_albedo',lon_min_albedo)
      call getin('lon_max_albedo',lon_max_albedo)
      call getin('lat_min_albedo',lat_min_albedo)
      call getin('lat_max_albedo',lat_max_albedo)
      call getin('deltaO18_oce',deltaO18_oce)
      call getin('deltaP_BL',deltaP_BL)
      call getin('ruissellement_pluie',ruissellement_pluie)
      call getin('alphak_stewart',alphak_stewart)
      call getin('tdifexp_sol',tdifexp_sol)
      call getin('calendrier_guide',calendrier_guide)
      call getin('cste_surf_cond',cste_surf_cond)
      call getin('mixlen',mixlen)
      call getin('deltalim',deltalim)
      deltalim_snow=deltalim+200.0
      call getin('deltaDmin',deltaDmin)
#ifdef ISOTRAC      
      call getin('deltalimtrac',deltalimtrac)
#endif      
      call getin('evap_cont_cste',evap_cont_cste)
      call getin('deltaO18_evap_cont',deltaO18_evap_cont)
      call getin('d_evap_cont',d_evap_cont)  
      call getin('lev_histiso',lev_histiso) 
      call getin('lev_histiso_diag',lev_histiso_diag)
#ifdef ISOVERIF
      if ((use_iso_O17.eq.1).and.(use_iso_O18.eq.1)) then
          call getin('O17_verif',O17_verif)  
          call getin('o17excess_bas',o17excess_bas)  
          call getin('o17excess_haut',o17excess_haut)  
          call getin('nlevmaxO17',nlevmaxO17)  
      endif
#endif      
      call getin('no_pce',no_pce)
      call getin('A_satlim',A_satlim)
      call getin('ok_restrict_A_satlim',ok_restrict_A_satlim)
#ifdef ISOVERIF      
      call iso_verif_positif(1.0-A_satlim,'iso_init 158')
#endif          
!      call getin('slope_limiterxy',slope_limiterxy) 
!      call getin('slope_limiterz',slope_limiterz) 
      call getin('modif_ratqs',modif_ratqs)
      call getin('Pcrit_ratqs',Pcrit_ratqs)
      call getin('ratqsbasnew',ratqsbasnew)
      call getin('fac_modif_evaoce',fac_modif_evaoce)
      call getin('ok_bidouille_wake',ok_bidouille_wake)
      call getin('cond_temp_env',cond_temp_env)
      call getin('ok_prod_nucl_tritium',ok_prod_nucl_tritium)

      write(*,*) 'lambda,thumxt1=',lambda_sursat,thumxt1
      write(*,*) 'bidouille_anti_divergence=',bidouille_anti_divergence
      write(*,*) 'essai_convergence=',essai_convergence
      write(*,*) 'initialisation_iso=',initialisation_iso
      write(*,*) 'modif_sst,deltaTtest=',modif_sst,deltaTtest
      write(*,*) 'modif_sic,deltasic=',modif_sic,deltasic
      write(*,*) 'deltaTtestpoles,sstlatcrit,dsstlatcrit=',
     :           deltaTtestpoles,sstlatcrit,dsstlatcrit
      write(*,*) 'deltaO18_oce=',deltaO18_oce
      write(*,*) 'albedo_prescrit=',albedo_prescrit
      if (albedo_prescrit.eq.1) then
         write(*,*) 'lon_min_albedo,lon_max_albedo=',
     :           lon_min_albedo,lon_max_albedo
         write(*,*) 'lat_min_albedo,lat_max_albedo=',
     :           lat_min_albedo,lat_max_albedo
      endif !if (albedo_prescrit.eq.1) then
      write(*,*) 'deltaP_BL,ruissellement_pluie,alphak_stewart=',
     :       deltaP_BL,ruissellement_pluie,alphak_stewart
      write(*,*) 'cste_surf_cond=',cste_surf_cond
      write(*,*) 'mixlen=',mixlen
      write(*,*) 'tdifexp_sol=',tdifexp_sol
      write(*,*) 'calendrier_guide=',calendrier_guide
      write(*,*) 'deltalim=',deltalim
      write(*,*) 'deltaDmin=',deltaDmin
#ifdef ISOTRAC      
      write(*,*) 'deltalimtrac=',deltalimtrac
#endif      
      write(*,*) 'evap_cont_cste=',evap_cont_cste
      write(*,*) 'deltaO18_evap_cont,d_evap_cont=',
     :           deltaO18_evap_cont,d_evap_cont
      write(*,*) 'O17_verif=',O17_verif
      write(*,*) 'o17excess_bas=',o17excess_bas
      write(*,*) 'o17excess_haut=',o17excess_haut
      write(*,*) 'nlevmaxO17=',nlevmaxO17
      write(*,*) 'no_pce=',no_pce
      write(*,*) 'A_satlim=',A_satlim
      write(*,*) 'ok_restrict_A_satlim=',ok_restrict_A_satlim
!      write(*,*) 'slope_limiterxy=',slope_limiterxy
!      write(*,*) 'slope_limiterz=',slope_limiterz
      write(*,*) 'modif_ratqs=',modif_ratqs
      write(*,*) 'Pcrit_ratqs=',Pcrit_ratqs
      write(*,*) 'ratqsbasnew=',ratqsbasnew
      write(*,*) 'fac_modif_evaoce=',fac_modif_evaoce
      write(*,*) 'ok_bidouille_wake=',ok_bidouille_wake
      write(*,*) 'cond_temp_env=',cond_temp_env
      write(*,*) 'ok_prod_nucl_tritium=',ok_prod_nucl_tritium
                  

c--------------------------------------------------------------
c Parameters that do not depend on the nature of water isotopes:
c--------------------------------------------------------------

c -- temperature at which ice condensate starts to form (valeur ECHAM?):
      pxtmelt=273.15
c      pxtmelt=273.15-10.0 ! test PHASE

c -- temperature at which all condensate is ice:
      pxtice=273.15-10.0
c      pxtice=273.15-30.0 ! test PHASE

c -- minimum temperature to calculate fractionation coeff
      pxtmin=273.15-120.0 ! On ne calcule qu'au dessus de -120∞C
      pxtmax=273.15+60.0 ! On ne calcule qu'au dessus de +60∞C
      ! remarque: les coeffs ont ÈtÈ mesurÈs seulement jusq'‡ -40!

c -- a constant for alpha_eff for equilibrium below cloud base:
      tdifexp=0.58
      tv0cin=7.0

       ! facteurs lambda et mu dans Si=musi-lambda*T
      musi=1.0
      if (ok_nocinsat) then
        lambda_sursat = 0.0 ! no sursaturation effect
      endif            


      ! diffusion dans le sol
      Kd=2.5e-9 ! m2/s   

      ! cas o˘ cste_surf_cond: on met rhs ou/et Ts cste pour voir
      rh_cste_surf_cond=0.6
      T_cste_surf_cond=288.0

c--------------------------------------------------------------
c Parameters that depend on the nature of water isotopes:
c--------------------------------------------------------------
      ! ** constantes locales
      fac_enrichoce18=0.0005
      ! on a alors tcor018=1+fac_enrichoce18
      ! tcorD=1+fac_enrichoce18*8
      ! tcorO17=1+fac_enrichoce18*0.528
      alpha_liq_sol_O18=1.00291 ! valeur de Lehmann & Siegenthaler, 1991, 
          ! Journal of Glaciology, vol 37, p 23
      talph1_O18=1137.
      talph2_O18=-0.4156
      talph3_O18=-2.0667E-3
      talps1_O18=11.839
      talps2_O18=-0.028244
      tkcin0_O18 = 0.006
      tkcin1_O18 = 0.000285
      tkcin2_O18 = 0.00082
      tdifrel_O18= 1./0.9723

      ! rapport des ln(alphaeq) entre O18 et O17
      fac_coeff_eq17_liq=0.529 ! donnÈ par Amaelle
!      fac_coeff_eq17_ice=0.528 ! slope MWL 
      fac_coeff_eq17_ice=0.529
        

      do 999 ixt = 1, niso
        write(*,*) 'iso_init 80: ixt=',ixt


c -- kinetic factor for surface evaporation:
c (cf: kcin = tkcin0                  if |V|<tv0cin
c      kcin = tkcin1*|Vsurf| + tkcin2 if |V|>tv0cin )
c (Rq: formula discontinuous for |V|=tv0cin... )        

c -- main:
      if ((use_iso_HTO.eq.1).and.(ixt.eq.iso_HTO)) then ! Tritium
          tkcin0(ixt) = 0.01056
          tkcin1(ixt) = 0.0005016
          tkcin2(ixt) = 0.0014432
          !tkcin0(ixt) = 0. ! pas de fractionnement cinetique
          !tkcin1(ixt) = 0. ! pas de fractionnement cinetique
          !tkcin2(ixt) = 0. ! pas de fractionnement cinetique
          tnat(ixt)=0.
          !toce(ixt)=1.0E-18 ! rapport 3H/1H ocean
          toce(ixt)=4.0E-19 ! rapport T/H = 0.2 TU Dreisigacker and Roether 1978
          tcorr(ixt)=1.
          tdifrel(ixt)=1./0.968
          !tdifrel(ixt)=1. ! pas de rapport de diffusivite
          talph1(ixt)=46480.
          talph2(ixt)=-103.87
          talph3(ixt)=0.
          talps1(ixt)=46480.
          talps2(ixt)=-103.87
          !talph1(ixt)=0. ! pas de fractionnement equilibre
          !talph2(ixt)=-0. ! pas de fractionnement equilibre
          !talph3(ixt)=0. ! pas de fractionnement equilibre
          !talps1(ixt)=0. ! pas de fractionnement equilibre
          !talps2(ixt)=-0. ! pas de fractionnement equilibre
          alpha_liq_sol(ixt)=1. 
          Rdefault(ixt)=0.0
          CALL table_tritium_nucl(nessai,
     :                            day_nucl,month_nucl,year_nucl,
     :                            lat_nucl,lon_nucl,
     :                            zmin_nucl,zmax_nucl,
     :                            HTO_nucl)
!#ifdef ISOVERIFIDRIS
!      write(*,*) 'controle subroutine table_tritium_nucl'
!      write(*,*) 'nessai', nessai
!      write(*,*) 'ok_prod_nucl_tritium=', ok_prod_nucl_tritium
!      do iessai=1,nessai
!         write(*,*) 'iessai', iessai
!         write(*,*) 'day_nucl(iessai)', day_nucl(iessai)
!         write(*,*) 'month_nucl(iessai)', month_nucl(iessai)
!         write(*,*) 'year_nucl(iessai)', year_nucl(iessai)
!         write(*,*) 'lat_nucl(iessai)', lat_nucl(iessai)
!         write(*,*) 'lon_nucl(iessai)', lon_nucl(iessai)
!         write(*,*) 'zmin_nucl(iessai)', zmin_nucl(iessai)
!         write(*,*) 'zmax_nucl(iessai)', zmax_nucl(iessai)
!         write(*,*) 'HTO_nucl(iessai)', HTO_nucl(iessai)
!      enddo
!#endif
       endif
            
       if ((use_iso_O17.eq.1).and.(ixt.eq.iso_O17)) then ! oxygène-17
          pente_MWL=0.528
!          tdifrel(ixt)=1./0.985452 ! donnÈ par Amaelle 
          tdifrel(ixt)=1./0.98555 ! valeur utilisÈe en 1D et dans modËle de LdG
!          fac_kcin=0.5145 ! donnÈ par Amaelle
          fac_kcin= (tdifrel(ixt)-1.0)/(tdifrel_O18-1.0)
          tkcin0(ixt) = tkcin0_O18*fac_kcin
          tkcin1(ixt) = tkcin1_O18*fac_kcin
          tkcin2(ixt) = tkcin2_O18*fac_kcin
          tnat(ixt)=0.004/100. ! O17 reprÈsente 0.004% de l'oxygËne
          toce(ixt)=tnat(ixt)*(1.0+deltaO18_oce/1000.0)**pente_MWL
          tcorr(ixt)=1.0+fac_enrichoce18*pente_MWL ! donnÈ par Amaelle            
          talph1(ixt)=talph1_O18
          talph2(ixt)=talph2_O18
          talph3(ixt)=talph3_O18
          talps1(ixt)=talps1_O18
          talps2(ixt)=talps2_O18     
          alpha_liq_sol(ixt)=(alpha_liq_sol_O18)**fac_coeff_eq17_liq 
          if (Rdefault_smow) then    
                Rdefault(ixt)=tnat(ixt)*(-3.15/1000.0+1.0)
          else
                Rdefault(ixt)=0.0
          endif
       endif
 
       if ((use_iso_O18.eq.1).and.(ixt.eq.iso_O18)) then ! Oxygene18
          tkcin0(ixt) = tkcin0_O18
          tkcin1(ixt) = tkcin1_O18
          tkcin2(ixt) = tkcin2_O18
          tnat(ixt)=2005.2E-6
          toce(ixt)=tnat(ixt)*(1.0+deltaO18_oce/1000.0)
          tcorr(ixt)=1.0+fac_enrichoce18
          tdifrel(ixt)=tdifrel_O18
          talph1(ixt)=talph1_O18
          talph2(ixt)=talph2_O18
          talph3(ixt)=talph3_O18
          talps1(ixt)=talps1_O18
          talps2(ixt)=talps2_O18
          alpha_liq_sol(ixt)=alpha_liq_sol_O18   
          if (Rdefault_smow) then    
                Rdefault(ixt)=tnat(ixt)*(-6.0/1000.0+1.0)
          else
                Rdefault(ixt)=0.0
          endif
       endif
!       write(*,*) 'iso_init 163: ZXalpha_liq_sol=',ZXalpha_liq_sol
       if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then ! Deuterium
          pente_MWL=8.0
!          fac_kcin=0.88
          tdifrel(ixt)=1./0.9755
          fac_kcin= (tdifrel(ixt)-1)/(tdifrel_O18-1)
          tkcin0(ixt) = tkcin0_O18*fac_kcin
          tkcin1(ixt) = tkcin1_O18*fac_kcin
          tkcin2(ixt) = tkcin2_O18*fac_kcin
          tnat(ixt)=155.76E-6
          toce(ixt)=tnat(ixt)*(1.0+pente_MWL*deltaO18_oce/1000.0)
          tcorr(ixt)=1.0+fac_enrichoce18*pente_MWL          
          talph1(ixt)=24844.
          talph2(ixt)=-76.248
          talph3(ixt)=52.612E-3
          talps1(ixt)=16288.
          talps2(ixt)=-0.0934
          !ZXalpha_liq_sol=1.0192 ! Weston, Ralph, 1955
          alpha_liq_sol(ixt)=1.0212 
          ! valeur de Lehmann & Siegenthaler, 1991, Journal of
          ! Glaciology, vol 37, p 23
          if (Rdefault_smow) then    
            Rdefault(ixt)=tnat(ixt)*((-6.0*pente_MWL+10.0)/1000.0+1.0)
          else
            Rdefault(ixt)=0.0
          endif
       endif
!       write(*,*) 'iso_init 163: ZXalpha_liq_sol=',ZXalpha_liq_sol
       if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then ! Oxygene16
          tkcin0(ixt) = 0.0
          tkcin1(ixt) = 0.0
          tkcin2(ixt) = 0.0
          tnat(ixt)=1.
          toce(ixt)=tnat(ixt)
          tcorr(ixt)=1.0
          tdifrel(ixt)=1.
          talph1(ixt)=0.
          talph2(ixt)=0.
          talph3(ixt)=0.
          talps1(ixt)=0.
          talph3(ixt)=0.
          alpha_liq_sol(ixt)=1.
          if (Rdefault_smow) then
                Rdefault(ixt)=tnat(ixt)*1.0
          else
                Rdefault(ixt)=1.0
          endif
       endif

999   continue
       
! test de sensibilitÈ: 
        if (ok_nocinsfc) then ! no kinetic effect in sfc evaporation
         do ixt=1,niso
          tkcin0(ixt) = 0.0 
          tkcin1(ixt) = 0.0 
          tkcin2(ixt) = 0.0
         enddo 
        endif

        ! fermeture fichier de paramËtres
        close(unit=32)

        ! nom des isotopes
        
        if (use_iso_HTO.eq.1) then
          striso(iso_HTO)='HTO'
        endif
        if (use_iso_O17.eq.1) then
        striso(iso_O17)='O17'
        endif
        if (use_iso_O18.eq.1) then
        striso(iso_O18)='O18'
        endif
        if (use_iso_HDO.eq.1) then
        striso(iso_HDO)='HDO'
        endif
        if (use_iso_eau.eq.1) then
        striso(iso_eau)='eau'
        endif
        
        ! verif
        write(*,*) 'iso_init 285: verif initialisation:'
        
        do ixt=1,niso
          write(*,*) '* striso(',ixt,')=<'//striso(ixt)//'>'
          write(*,*) 'tnat(',ixt,')=',tnat(ixt)
!          write(*,*) 'alpha_liq_sol(',ixt,')=',alpha_liq_sol(ixt)
!          write(*,*) 'tkcin0(',ixt,')=',tkcin0(ixt)
!          write(*,*) 'tdifrel(',ixt,')=',tdifrel(ixt)
        enddo
        write(*,*) 'iso_init 69: lambda=',lambda_sursat
        write(*,*) 'iso_init 69: thumxt1=',thumxt1
        write(*,*) 'iso_init 69: h_land_ice=',h_land_ice
        write(*,*) 'iso_init 69: P_veg=',P_veg

#ifdef ISOTRAC
       call traceurs_init()
       write(*,*) 'gcm 265: ntraciso=',ntraciso
#endif                 

      return
      end
#endif
