#ifdef ISO
       subroutine iso_revap_fisrtilp(klon,klev,k,
     :            zrfl_ancien,zrfl,zrfln,zt,zxt_ancien,
     :            zxtrfl,zxtrfl_ancien,zxtrfln,zxt,
     :            paprs,dtime,
     :            zqs,zq_ancien,zqev_diag,zq)
       implicit none

#include "wateriso2.h"
#include "iso_verif.h"  
#include "YOMCST.h"       

       ! inputs
       integer klon,klev,k
       real zrfl_ancien(klon)
       real zrfl(klon) ! pas necessaire, juste pour vrif
       real zxt_ancien(ntraciso,klon) ! equivalent local de xt       
       real zqev_diag(klon)
       real zxtrfl_ancien(ntraciso,klon)
       REAL zrfln(klon)
       REAL dtime ! intervalle du temps (s)
       REAL paprs(klon,klev+1) ! pression a inter-couche
       REAL zt(klon)
       REAL zqs(klon)
       real zq_ancien(klon)
       real zq(klon) ! pas necessaire, juste pour vrifs
       
       ! outputs       
       real zxtrfln(ntraciso,klon)  
       real zxtrfl(ntraciso,klon) ! identique  zxtrfln
       real zxt(ntraciso,klon) 

       ! locals
       double precision zqevfl(klon)
       double precision fac_fluxtomixratio(klon)
       double precision zrfl_cas(klon)       
       real zqev_diag_cas(klon)
       double precision zxtrfl_cas(niso,klon)
       double precision zxtrfln_cas(niso,klon)
       double precision zrfln_cas(klon)
       double precision zxt_cas(niso,klon) ! zxt compress en input
       double precision zxtnew_cas(niso,klon) ! zxt compresse en output       
       real qeff(klon)
       real zqs_cas(klon),zt_cas(klon)
       double precision zq_cas(klon)
       real delP(klon),delP_s_dt(klon)
       double precision Exi(niso,klon)
       real ztglace_kelvin
       parameter (ztglace_kelvin=273) 
       integer frac_sublim
       parameter (frac_sublim=0)
       ! pour le parsage
      integer icas_evap_tot,ncas_evap_tot
      integer icas_evap_liq,ncas_evap_liq
      integer icas_evap_glace,ncas_evap_glace
!      integer cas_evap_tot(klon)
      integer cas_evap_liq(klon)
      integer cas_evap_glace(klon)
      integer i,ixt

#ifdef ISOVERIF 
      integer iso_verif_aberrant_nostop
      integer iso_verif_egalite_choix_nostop
      integer iso_verif_positif_nostop
      integer iso_verif_positif_choix_nostop
      integer trace_cas(klon)
      real double_to_real
      integer iso_verif_egalite_nostop
      integer iso_verif_aberrant_choix_nostop
#endif
#ifdef ISOTRAC  
      integer iiso,ieau,izone
      real xtrevap_tag(ntraciso,klon)
      double precision ptrac(klon)
      real hdiag(klon)
#endif

        ! ** parsage des cas pour isotopes
      icas_evap_tot=0
      icas_evap_liq=0
      icas_evap_glace=0
#ifdef ISOVERIF
      ! initialisation de l'outil de tracage de cas:
      do i=1,klon
          trace_cas(i)=0
          if (use_iso_eau.eq.1) then
                   call iso_verif_egalite_choix(zxt_ancien(iso_eau,i),
     :                  zq_ancien(i),'iso_revap_ilp 94',
     :                  errmax,errmaxrel)
                   call iso_verif_egalite_choix(
     :                  zxtrfl_ancien(iso_eau,i),
     :                  zrfl_ancien(i),'iso_revap_ilp 99',
     :                  errmax,errmaxrel)
          endif      
      enddo !do il=1,ncum
#endif  
      do i=1,klon
        IF (zrfl_ancien(i) .GT.0.) THEN
          if (zrfln(i).gt.ridicule*1e-2) then          
             if (zt(i).ge.ztglace_kelvin) then
               icas_evap_liq=icas_evap_liq+1    
               cas_evap_liq(icas_evap_liq)=i
#ifdef ISOVERIF
               trace_cas(i)=2               
#endif  
             else !if (zt(i).ge.ztglace_kelvin) then
               icas_evap_glace=icas_evap_glace+1    
               cas_evap_glace(icas_evap_glace)=i
#ifdef ISOVERIF
               trace_cas(i)=3
#endif       
             endif !if (zt(i).ge.ztglace_kelvin) then
            else !if (zrfln(i).gt.ridicule*1e-2) then  
               icas_evap_tot=icas_evap_tot+1    
!               cas_evap_tot(icas_evap_tot)=i
                ! traitement  la vole
              do ixt=1,ntraciso
               zxtrfln(ixt,i)=0.0               
               zxt(ixt,i)=zxt_ancien(ixt,i)
     :          +zxtrfl_ancien(ixt,i)*RG*dtime/(paprs(i,k)-paprs(i,k+1))
               zxt(ixt,i)=max(0.0,zxt(ixt,i))
               zxtrfl(ixt,i)=0.0
              enddo !do ixt=1,niso

#ifdef ISOVERIF
               trace_cas(i)=1
               if (use_iso_eau.eq.1) then
                   call iso_verif_egalite_choix(zxt(iso_eau,i),
     :                  zq(i),'iso_revap_ilp 116',errmax,errmaxrel)
               endif
               do ixt=1,ntraciso
                call iso_verif_positif_choix(zxt(ixt,i),0.0,
     :                   'revap_ilp 131')
               enddo
#endif
            endif !if (zrfln(i).gt.ridicule*1e-2) then  
        else !IF (zrfl_ancien(i) .GT.0.) THEN
            ! pas de precip, rien  signaler
            do ixt=1,ntraciso
               zxtrfln(ixt,i)=0.0               
               zxt(ixt,i)=zxt_ancien(ixt,i)
               zxt(ixt,i)=max(0.0,zxt(ixt,i))
               zxtrfl(ixt,i)=0.0
            enddo !do ixt=1,niso
#ifdef ISOVERIF
             trace_cas(i)=4
             call iso_verif_egalite_choix(zqev_diag(i),
     :                  0.0,'iso_revap_ilp 148',ridicule,errmaxrel)
             call iso_verif_egalite_choix(zrfl(i),
     :                  0.0,'iso_revap_ilp 148b',ridicule,errmaxrel)
             call iso_verif_egalite_choix(zrfln(i),
     :                  0.0,'iso_revap_ilp 148c',ridicule,errmaxrel)
             if (use_iso_eau.eq.1) then
                   call iso_verif_egalite_choix(zxt(iso_eau,i),
     :                  zq(i),'iso_revap_ilp 149',errmax,errmaxrel)
                   call iso_verif_egalite_choix(zxtrfln(iso_eau,i),
     :                  zrfln(i),'iso_revap_ilp 151',errmax,errmaxrel)
                   call iso_verif_egalite_choix(zxtrfl(iso_eau,i),
     :                  zrfl(i),'iso_revap_ilp 151b',errmax,errmaxrel)
             endif
#endif               
        endif !IF (zrfl_ancien(i) .GT.0.) THEN
      enddo !do i=1,klon   
      ncas_evap_liq=icas_evap_liq
      ncas_evap_glace=icas_evap_glace
      ncas_evap_tot=icas_evap_tot

!      write(*,*) 'zrfln 773,k,klev,klon=',k,klev,klon
!      write(*,*) 'ncas_evap_liq=',ncas_evap_liq
!      write(*,*) 'ncas_evap_glace=',ncas_evap_glace
!      write(*,*) 'ncas_evap_tot=',ncas_evap_tot


      ! ** cas evap_liq=2
      if (ncas_evap_liq.gt.0) then

          call compress_ilp_evap_liq(
     :       ncas_evap_liq,cas_evap_liq(1),
     :       zq_cas(1),zq_ancien(1),
     :       zqs_cas(1),zqs(1),
     :       zxt_cas(1,1),zxt_ancien(1,1),             
     :       zxtrfl_cas(1,1),zxtrfl_ancien(1,1),
     :       zrfln_cas(1),zrfln(1),  
     :       zrfl_cas(1),zrfl_ancien(1),                    
     :       zqev_diag_cas(1),zqev_diag(1),
     :       zt_cas(1),zt(1),        
     :       delP(1),paprs,k,klon,klev)
          do i=1,ncas_evap_liq
             fac_fluxtomixratio(i)=RG*dtime/delP(i)
             delP_s_dt(i)=delP(i)/dtime 
             qeff(i)=(1-thumxt1)*zq_cas(i)+thumxt1*zqs_cas(i)
          enddo   
          do i=1,ncas_evap_liq
             zqevfl(i)=zqev_diag_cas(i)/fac_fluxtomixratio(i)
          enddo  
#ifdef ISOVERIF
         do i=1,ncas_evap_liq
          
          call iso_verif_egalite_choix(double_to_real(zrfln_cas(i)),
     :           zrfln(cas_evap_liq(i)),
     :          'iso_revap_fisrtilp 690; ap compress_evap_liq',
     :           errmax,errmaxrel)
          call iso_verif_egalite_choix(double_to_real(zrfl_cas(i)),
     :           zrfl_ancien(cas_evap_liq(i)),
     :           'iso_revap_fisrtilp 695; ap compress_evap_liq',
     :           errmax,errmaxrel)
          if (use_iso_eau.eq.1) then
            call iso_verif_egalite_choix(double_to_real(
     :           zxtrfl_cas(iso_eau,i)),double_to_real(zrfl_cas(i)),
     :           'iso_revap_fisrtilp 639; ap compress_evap_liq',
     :           errmax,errmaxrel)
          endif ! if (use_iso_eau.eq.1) then
          call iso_verif_egalite_choix(zqev_diag_cas(i),
     :           zqev_diag(cas_evap_liq(i)),
     :           'iso_revap_fisrtilp 692; ap compress_evap_liq',
     :           errmax,errmaxrel)
          call iso_verif_egalite_choix(zrfl_ancien(cas_evap_liq(i))
     :           -zqev_diag(cas_evap_liq(i))
     :           *(paprs(cas_evap_liq(i),k)-paprs(cas_evap_liq(i),k+1))
     .                    /RG/dtime-zrfln(cas_evap_liq(i)),0.0,
     :           'iso_revap_fisrtilp 693; ap compress_evap_liq',
     :           errmax,errmaxrel)
          call iso_verif_egalite(double_to_real(
     :           zrfl_cas(i)-zqevfl(i)-zrfln_cas(i)),0.0,
     :          'iso_revap_fisrtilp 691, aprs compress_evap_liq')
         enddo !do i=1,ncas_evap_liq
!         write(*,*) 'iso_revap_fisrtilp temp 715: qeff(1),zqs_cas(1)=',
!     :           qeff(1),zqs_cas(1)
#endif       
         if (no_pce.eq.1) then
             call stewart_sublim_nofrac_vectall(
     :        ncas_evap_liq,zq_cas(1),
     :        zxt_cas(1,1),zrfl_cas(1),
     :        zxtrfl_cas(1,1),zqevfl(1),zrfln_cas(1),
     :        zxtrfln_cas(1,1),zxtnew_cas(1,1),Exi(1,1),
     :        fac_fluxtomixratio(1))
         else !if (no_pce.eq.1) then
             
          call stewart_explicite_vectall(ncas_evap_liq,
     :           zq_cas(1),zxt_cas(1,1),
     :           zrfl_cas(1),zxtrfl_cas(1,1),zqevfl(1),
     :           zrfln_cas(1),qeff(1),
     :           zxtrfln_cas(1,1),zxtnew_cas(1,1),Exi(1,1),
     :           fac_fluxtomixratio(1),
     :           zqs_cas(1),zt_cas(1),
     :           delP_s_dt(1),
     :           delP(1)
#ifdef ISOVERIF
     :          ,0,1
#endif
     :   )
        endif !if (no_pce.eq.1) then

#ifdef ISOVERIF
          do i=1,ncas_evap_liq
           do ixt=1,niso
            call iso_verif_noNaN(double_to_real(zxtrfln_cas(ixt,i)),
     :           'iso_revap_fisrtilp 8283')
            call iso_verif_noNaN(double_to_real(zxtnew_cas(ixt,i)),
     :           'iso_revap_fisrtilp 8293')
            call iso_verif_positif_choix(double_to_real(
     :           zxtnew_cas(ixt,i)),0.0,'revap_ilp 225')
           enddo
          enddo
          if (use_iso_eau.eq.1) then
             do i=1,ncas_evap_liq
               call iso_verif_egalite_choix(
     :                  double_to_real(zxtrfln_cas(iso_eau,i)),
     :                  double_to_real(zrfln_cas(i)),'il pleut 4552',
     :                  errmax,errmaxrel)               
               call iso_verif_egalite_choix(
     :                  double_to_real(zxtnew_cas(iso_eau,i)),
     :                  zq(cas_evap_liq(i)),
     :                  'il pleut 4102',errmax,errmaxrel)
              enddo !do i=1,ncas_evap_liq
           endif !if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
           if (use_iso_HDO.eq.1) then
              do i=1,ncas_evap_liq
                 if (zrfln_cas(i).gt.ridicule_rain) then
                        call iso_verif_aberrant(
     :                  double_to_real(zxtrfln_cas(iso_HDO,i)
     :                 /zrfln_cas(i)), 'iso_revap_fisrtilp 4562')
                 endif
               enddo
           endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then
#endif
          if ((bidouille_anti_divergence).and.
     :           (use_iso_eau.eq.1)) then
            do i=1,ncas_evap_liq
              zxtrfln_cas(iso_eau,i)=zrfln_cas(i)
              zxtnew_cas(iso_eau,i)=zq(cas_evap_liq(i))    
            enddo !do i=1,ncas_evap_liq
          endif
          
          call uncompress_ilp(
     :       ncas_evap_liq,cas_evap_liq(1),
     :       zxtrfln_cas(1,1),zxtnew_cas(1,1),
     :       zxtrfl(1,1),zxtrfln(1,1),zxt(1,1),klon)

#ifdef ISOTRAC
          do izone=1,ntraceurs_zone

          ! on compresse, mais en plus on slctionne que la preciip
          ! correspondant  la zone izone. Par contre, la vapeur reste
          ! la vapeur totale
          
#ifdef ISOVERIF          
          write(*,*) 'iso_revap_ilp 245 tmp: izone=',izone
          write(*,*) 'avant call compress_ilp_evap_liq_zone'
!          if (ncas_evap_liq.ge.9) then
!          i=9
!          write(*,*) 'i,cas_evap_liq(i),zrfln,zrfl_ancien,zqev_diag=',
!     :              i,cas_evap_liq(i),zrfln(cas_evap_liq(i)),
!     :              zrfl_ancien(cas_evap_liq(i)),
!     :              zqev_diag(cas_evap_liq(i))
!          write(*,*) 'zxtrfl_ancien(1:ntraciso:2,i)=',
!     :           zxtrfl_ancien(1:ntraciso:2,cas_evap_liq(i))
!          write(*,*) 'ieau,zxtrfl_ancien(ieau,cas_evap_liq(i)=',
!     :           index_trac(izone,iso_eau),zxtrfl_ancien        
!     :           (index_trac(izone,iso_eau),cas_evap_liq(i))
!          endif
#endif          

          call compress_ilp_evap_liq_zone(
     :       ncas_evap_liq,cas_evap_liq(1),
     :       zxt_cas(1,1),zxt_ancien(1,1),             
     :       zxtrfl_cas(1,1),zxtrfl_ancien(1,1),
     :       zrfln_cas(1),zrfln(1),  
     :       zrfl_cas(1),zrfl_ancien(1),                    
     :       zqev_diag_cas(1),zqev_diag(1),
     :       klon,izone,ptrac(1))
          do i=1,ncas_evap_liq
             zqevfl(i)=zqev_diag_cas(i)/fac_fluxtomixratio(i)
          enddo 

#ifdef ISOVERIF
          do i=1,ncas_evap_liq
            call iso_verif_egalite(double_to_real(
     :           zrfl_cas(i)-zqevfl(i)-zrfln_cas(i)),0.0,
     :          'iso_revap_fisrtilp 286')
          enddo !do i=1,ncas_evap_liq
#endif           

          ! renormaliser les flux de precip pour que la proportion masse
          ! de liq/masse de vap soit la mme pour toutes les zones
          ! on pourrait faire les choses plus proprement  l'avenir...
          do i=1,ncas_evap_liq
            ! 1er juin 2009: on remplace ridicule par ridicule*1e3
            if (ptrac(i).gt.ridicule*1e3) then
              zrfl_cas(i)=zrfl_cas(i)/ptrac(i)
              zqevfl(i)=zqevfl(i)/ptrac(i)
              zrfln_cas(i)=zrfln_cas(i)/ptrac(i)  
              do ixt=1,niso
               zxtrfl_cas(ixt,i)=zxtrfl_cas(ixt,i)/ptrac(i)
              enddo               
            else
#ifdef ISOVERIF                
             call iso_verif_egalite(double_to_real(zrfl_cas(i)),
     :           0.0,'revap_ilp 294')  
             call iso_verif_egalite(double_to_real(zqevfl(i)),
     :           0.0,'revap_ilp 296')
             call iso_verif_egalite(double_to_real(zrfln_cas(i)),
     :           0.0,'revap_ilp 298')
#endif             
             zrfl_cas(i)=0.0
             zqevfl(i)=0.0
             zrfln_cas(i)=0.0
             do ixt=1,niso
               zxtrfl_cas(ixt,i)=0.0
             enddo
            endif
          enddo !do i=1,ncas_evap_liq

#ifdef ISOVERIF
          do i=1,ncas_evap_liq
            if (iso_verif_egalite_nostop(double_to_real(
     :           zrfl_cas(i)-zqevfl(i)-zrfln_cas(i)),0.0,
     :          'iso_revap_fisrtilp 314').eq.1) then
               write(*,*) 'i,zrfl_cas(i),zqevfl(i),zrfln_cas(i)=',
     :           i,zrfl_cas(i),zqevfl(i),zrfln_cas(i)
               write(*,*) 'ptrac(i),zrfl_ancien=',
     :           ptrac(i),zrfl_ancien(cas_evap_liq(i))
               stop
            endif
            if (iso_verif_aberrant_choix_nostop(
     :         double_to_real(zxtrfl_cas(iso_HDO,i)),
     :         double_to_real(zrfl_cas(i)),
     :         ridicule_rain,deltalimtrac,
     :         'iso_revap_ilp 342').eq.1) then
               write(*,*) 'i,ptrac(i),zrfl_cas(i)=',
     :           i,ptrac(i),zrfl_cas(i)
               stop
             endif
          enddo !do i=1,ncas_evap_liq
#endif          
          
         if (no_pce.eq.1) then
             call stewart_sublim_nofrac_vectall(
     :        ncas_evap_liq,zq_cas(1),
     :        zxt_cas(1,1),zrfl_cas(1),
     :        zxtrfl_cas(1,1),zqevfl(1),zrfln_cas(1),
     :        zxtrfln_cas(1,1),zxtnew_cas(1,1),Exi(1,1),
     :        fac_fluxtomixratio(1))
         else !if (no_pce.eq.1) then 
          call stewart_explicite_vectall(ncas_evap_liq,
     :           zq_cas(1),zxt_cas(1,1),
     :           zrfl_cas(1),zxtrfl_cas(1,1),zqevfl(1),
     :           zrfln_cas(1),qeff(1),
     :           zxtrfln_cas(1,1),zxtnew_cas(1,1),Exi(1,1),
     :           fac_fluxtomixratio(1),
     :           zqs_cas(1),zt_cas(1),
     :           delP_s_dt(1),
     :           delP(1)
#ifdef ISOVERIF
     :          ,1,9
#endif
     :   )
          endif !if (no_pce.eq.1) then

          ! renormaliser les flux de precip pour que la proportion masse
          ! de liq/masse de vap soit la mme pour toutes les zones
          ! on pourrait faire les choses plus proprement  l'avenir...
          do i=1,ncas_evap_liq
             zrfl_cas(i)=zrfl_cas(i)*ptrac(i)
             zqevfl(i)=zqevfl(i)*ptrac(i)
             zrfln_cas(i)=zrfln_cas(i)*ptrac(i)
             do ixt=1,niso
               zxtrfl_cas(ixt,i)=zxtrfl_cas(ixt,i)*ptrac(i)
               Exi(ixt,i)=Exi(ixt,i)*ptrac(i)
               zxtrfln_cas(ixt,i)=zxtrfln_cas(ixt,i)*ptrac(i)
               zxtnew_cas(ixt,i)=zxt_cas(ixt,i)
     :           +(zxtnew_cas(ixt,i)-zxt_cas(ixt,i))*ptrac(i)
             enddo
             hdiag(i)=qeff(i)/zqs_cas(i)
          enddo !do i=1,ncas_evap_liq

#ifdef ISOVERIF
        do i=1,ncas_evap_liq
          do iiso=1,niso
          call iso_verif_positif_choix(double_to_real(
     :           zxtnew_cas(iiso,i)),0.0,'revap_ilp 394')
          ixt=index_trac(izone,iiso)
          call iso_verif_positif_choix(
     :           zxt(ixt,cas_evap_liq(i)),0.0,'revap_ilp 397')
          if (iso_verif_positif_choix_nostop(
     :           zxt(ixt,cas_evap_liq(i))+double_to_real(
     :           fac_fluxtomixratio(i)*Exi(iiso,i)),
     :           0.0,'revap_ilp 401').eq.1) then
             write(*,*) 'i,iiso,iso_eau=',i,iiso,iso_eau
             write(*,*) 'zxt=',zxt(ixt,cas_evap_liq(i))
             write(*,*) 'Exi=',Exi(iiso,i)
             write(*,*) 'zxt_eau=',zxt(
     :           index_trac(izone,iso_eau),cas_evap_liq(i))
             write(*,*) 'Exi_eau=',Exi(iso_eau,i)
             write(*,*) 'fac_ftmr=',fac_fluxtomixratio(i)
             write(*,*) 'ptrac=',ptrac(i)
!             stop
          endif
          enddo
        enddo !do i=1,ncas_evap_liq
#endif          
          
          call uncompress_ilp_zone(
     :       ncas_evap_liq,cas_evap_liq(1),
     :       zxtrfln_cas(1,1),zxtnew_cas(1,1),
     :       zxtrfl(1,1),zxtrfln(1,1),zxt(1,1),klon,
     :       izone,zqevfl(1),Exi(1,1),fac_fluxtomixratio(1),
     :       xtrevap_tag(1,1),1,hdiag(1))

          enddo !do izone=1,ntraceurs_zone
#ifdef ISOVERIF
       do i=1,ncas_evap_liq
        do ixt=1,ntraciso
            call iso_verif_positif_choix(zxt(ixt,cas_evap_liq(i)),
     :              0.0,'revap_ilp 414')
        enddo
       enddo !do i=1,ncas
#endif            

          ! si on taggue la rvap, alors les vaporations des
          ! diffrentes zones ont t stockes dans xtrevap_tag
          ! on les somme toute dans la vap au tag revap
          if (option_revap.eq.1) then
            call ajoute_revap(ncas_evap_liq,cas_evap_liq(1),
     :          klon,izone,zxt(1,1),xtrevap_tag(1,1))            
          endif !if (option_revap.eq.1) then
#ifdef ISOVERIF
          do i=1,ncas_evap_liq
             call iso_verif_traceur(zxt(1,cas_evap_liq(i)),
     :           'iso_revap_fisrtilp 282')
             call iso_verif_traceur(zxtrfln(1,cas_evap_liq(i)),
     :           'iso_revap_fisrtilp 804')
             do ixt=1,ntraciso
                call iso_verif_positif_choix(zxt(ixt,cas_evap_liq(i)),
     :                   0.0,'revap_ilp 424')
             enddo
          enddo
#endif          
#endif
! #endif ISOTRAC

      endif !if (ncas_evap_liq.gt.0) then  

      ! ** cas evap_glace=3
      if (ncas_evap_glace.gt.0) then

#ifdef ISOVERIF
!      write(*,*) ''
!      write(*,*) 'iso_revap tmp 469: traitement cas evap glace'
!      write(*,*) 'cas_evap_glace(1),zqev_diag=',
!     :           cas_evap_glace(1),zqev_diag(cas_evap_glace(1))

          if (use_iso_eau.eq.1) then
            do i=1,ncas_evap_glace
              call iso_verif_egalite_choix(
     :           zrfl_ancien(cas_evap_glace(i)),
     :           zxtrfl_ancien(iso_eau,cas_evap_glace(i)),
     :           'iso_revap_fisrtilp 742: zrfl_ancien=zxtrfl?',
     :           errmax,errmaxrel)
            enddo !do i=1,ncas_evap_glace
          endif !if (use_iso_eau.eq.1) then
#endif          
          call compress_ilp_evap_glace(
     :       ncas_evap_glace,cas_evap_glace(1),
     :       zq_cas(1),zq_ancien(1),
     :       zxt_cas(1,1),zxt_ancien(1,1),             
     :       zxtrfl_cas(1,1),zxtrfl_ancien(1,1),
     :       zrfln_cas(1),zrfln(1),  
     :       zrfl_cas(1),zrfl_ancien(1),        
     :       zqev_diag_cas(1),zqev_diag(1),
     :       zt_cas(1),zt(1),  
     :       delP(1),paprs,k,klon,klev,frac_sublim)
#ifdef ISOVERIF
          if (use_iso_eau.eq.1) then
            do i=1,ncas_evap_glace
              
              call iso_verif_egalite_choix(double_to_real(zrfl_cas(i)),
     :           double_to_real(zxtrfl_cas(iso_eau,i)),
     :           'iso_revap_fisrtilp 731: apres compress evap_glace',
     :           errmax,errmaxrel)
              call iso_verif_egalite_choix(double_to_real(zq_cas(i)),
     :           double_to_real(zxt_cas(iso_eau,i)),
     :           'iso_revap_fisrtilp 755: apres compress evap_glace',
     :           errmax,errmaxrel)
              call iso_verif_egalite_choix(zqev_diag_cas(i),
     :           zqev_diag(cas_evap_glace(i)),
     :           'iso_revap_fisrtilp 755: apres compress evap_glace',
     :           errmax,errmaxrel)
             call iso_verif_egalite_choix(delP(i),
     :          paprs(cas_evap_glace(i),k)-paprs(cas_evap_glace(i),k+1),
     :          'iso_revap_fisrtilp 769: apres compress evap_glace',
     :           errmax,errmaxrel) 
            enddo   !do i=1,ncas_evap_glace
          endif ! if (use_iso_eau.eq.1) then 
#endif          
          do i=1,ncas_evap_glace
             fac_fluxtomixratio(i)=RG*dtime/delP(i)
             zqevfl(i)=zqev_diag_cas(i)/fac_fluxtomixratio(i)
          enddo !do i=1,ncas_evap_glace
!          write(*,*) 'zqev_diag,fac_fluxtomixratio=',
!     :           zqev_diag(cas_evap_glace(1)),
!     :           fac_fluxtomixratio(1)
#ifdef ISOVERIF
          do i=1,ncas_evap_glace
            call iso_verif_noNaN(double_to_real(fac_fluxtomixratio(i)),
     :            'iso_revap_fisrtilp 763')
!            write(*,*) 'i,cas_evap_glace(i)=',i,cas_evap_glace(i)
!            write(*,*) 'zqevfl(i),zrfl_cas(i),zrfln_cas(i)=',
!     :           zqevfl(i),zrfl_cas(i),zrfln_cas(i)
!            write(*,*) 'zqev_diag_cas(i),fac_fluxtomixratio(i)=',
!     :         zqev_diag_cas(i),fac_fluxtomixratio(i)  
            if (iso_verif_positif_nostop(double_to_real
     :           (zrfl_cas(i)-zqevfl(i)),'iso_revap_fisrtilp 776')
     :           .eq.1) then
              if (zrfl_cas(i)-zqevfl(i).lt.-ridicule*1e3) then
                  stop
              endif
            endif !if (iso_verif_positif_nostop
          enddo !do i=1,ncas_evap_glace
#endif     
          if (frac_sublim.eq.1) then
              call stewart_glace_vectall(ncas_evap_glace
     :                ,zq_cas(1),zxt_cas(1,1)
     :                ,zrfl_cas(1),zxtrfl_cas(1,1)
     :                ,zqevfl(1),zrfln_cas(1)
     :                ,zxtrfln_cas(1,1),zxtnew_cas(1,1),Exi(1,1)
     :                ,fac_fluxtomixratio(1),zt(1))
          else !if (frac_sublim.eq.1) then
              call stewart_sublim_nofrac_vectall(ncas_evap_glace
     :              ,zq_cas(1),zxt_cas(1,1),zrfl_cas(1),zxtrfl_cas(1,1)
     :              ,zqevfl(1),zrfln_cas(1)
     :              ,zxtrfln_cas(1,1),zxtnew_cas(1,1),Exi(1,1)
     :              ,fac_fluxtomixratio(1))
          endif  !if (frac_sublim.eq.1) then 

#ifdef ISOVERIF
          do i=1,ncas_evap_glace
           do ixt=1,niso
            call iso_verif_noNaN(double_to_real(zxtrfln_cas(ixt,i)),
     :           'iso_revap_fisrtilp 8883')
            call iso_verif_noNaN(double_to_real(zxtnew_cas(ixt,i)),
     :           'iso_revap_fisrtilp 8893')
            call iso_verif_positif_choix(double_to_real(
     :           zxtnew_cas(ixt,i)),0.0,'revap_ilp 534')
           enddo
          enddo !do i=1,ncas_evap_glace
          if (use_iso_eau.eq.1) then
             do i=1,ncas_evap_glace
               call iso_verif_egalite_choix(
     :                  double_to_real(zxtrfln_cas(iso_eau,i)),
     :                  double_to_real(zrfln_cas(i)),
     :                  'iso_revap_fisrtilp 4553',
     :                  errmax,errmaxrel)
               if (iso_verif_egalite_choix_nostop(
     :              double_to_real(zxtnew_cas(iso_eau,i)),
     :              zq(cas_evap_glace(i)),
     :              'iso_revap_fisrtilp 4103',errmax,errmaxrel)
     :              .eq.1) then
                  write(*,*) 'i,cas_evap_glace(i)=',i,cas_evap_glace(i)
                  write(*,*) 'zq(cas_evap_glace(i))=',
     :                   zq(cas_evap_glace(i))
                  write(*,*) 'zq_cas(i)=',zq_cas(i)
                  stop
               endif !if (iso_verif_egalite_choix_nostop
              enddo !do i=1,ncas_evap_glace
           endif !if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
           if (use_iso_HDO.eq.1) then
              do i=1,ncas_evap_glace
                 if (zrfln_cas(i).gt.ridicule_rain) then
                        call iso_verif_aberrant(
     :                  double_to_real(zxtrfln_cas(iso_HDO,i)
     :                 /zrfln_cas(i)), 'iso_revap_fisrtilp 4563')
                 endif
               enddo !do i=1,ncas_evap_glace
           endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then
#endif

          if ((bidouille_anti_divergence).and.
     :           (use_iso_eau.eq.1)) then
            do i=1,ncas_evap_glace
              zxtrfln_cas(iso_eau,i)=zrfln_cas(i)
              zxtnew_cas(iso_eau,i)=zq(cas_evap_glace(i))    
            enddo !do i=1,ncas_evap_liq
          endif ! if ((bidouille_anti_divergence).and.

#ifdef ISOVERIF
          if (use_iso_eau.eq.1) then
            do i=1,ncas_evap_glace
            call iso_verif_egalite_choix(
     :            double_to_real(zxtrfln_cas(iso_eau,i)),
     :            zrfln(cas_evap_glace(i)),'iso_revap_fisrtilp 810',
     :           errmax,errmaxrel)
            enddo !do i=1,ncas_evap_glace
          endif !if (use_iso_eau.eq.1) then
#endif          
          
          call uncompress_ilp(
     :       ncas_evap_glace,cas_evap_glace(1),
     :       zxtrfln_cas(1,1),zxtnew_cas(1,1),
     :       zxtrfl(1,1),zxtrfln(1,1),zxt(1,1),klon)      

!      write(*,*) 'iso_revap tmp 448: traitement cas evap glace traceurs'
!      write(*,*) 'zqev_diag,fac_fluxtomixratio=',
!     :           zqev_diag(cas_evap_glace(1)),
!     :           fac_fluxtomixratio(1)

#ifdef ISOTRAC
          do izone=1,ntraceurs_zone
!          write(*,*) 'iso_revap_ilp 509 tmp: izone=',izone     
          ! on compresse, mais en plus on slctionne que la preciip
          ! correspondant  la zone izone. Par contre, la vapeur reste
          ! la vapeur totale
          call compress_ilp_evap_glace_zone(
     :       ncas_evap_glace,cas_evap_glace(1),
     :       zxt_cas(1,1),zxt_ancien(1,1),             
     :       zxtrfl_cas(1,1),zxtrfl_ancien(1,1),
     :       zrfln_cas(1),zrfln(1),  
     :       zrfl_cas(1),zrfl_ancien(1),                    
     :       zqev_diag_cas(1),zqev_diag(1),
     :       klon,izone)
          do i=1,ncas_evap_glace
             zqevfl(i)=zqev_diag_cas(i)/fac_fluxtomixratio(i)
          enddo  

          if (frac_sublim.eq.1) then
              call stewart_glace_vectall(ncas_evap_glace
     :                ,zq_cas(1),zxt_cas(1,1)
     :                ,zrfl_cas(1),zxtrfl_cas(1,1)
     :                ,zqevfl(1),zrfln_cas(1)
     :                ,zxtrfln_cas(1,1),zxtnew_cas(1,1),Exi(1,1)
     :                ,fac_fluxtomixratio(1),zt(1))
          else
              call stewart_sublim_nofrac_vectall(ncas_evap_glace
     :              ,zq_cas(1),zxt_cas(1,1),zrfl_cas(1),zxtrfl_cas(1,1)
     :              ,zqevfl(1),zrfln_cas(1)
     :              ,zxtrfln_cas(1,1),zxtnew_cas(1,1),Exi(1,1)
     :              ,fac_fluxtomixratio(1))
          endif  
          
!          write(*,*) 'iso_revap_ilp 509 tmp: Exi,zqev_diag_cas=',
!     :           Exi(iso_eau,1),zqev_diag_cas(1)
          call uncompress_ilp_zone(
     :       ncas_evap_glace,cas_evap_glace(1),
     :       zxtrfln_cas(1,1),zxtnew_cas(1,1),
     :       zxtrfl(1,1),zxtrfln(1,1),zxt(1,1),klon,
     :       izone,zqevfl(1),Exi(1,1),fac_fluxtomixratio(1),
     :       xtrevap_tag(1,1),0,hdiag(1)) ! hdiag not used         

          enddo !do izone=1,ntraceurs_zone        

          ! si on taggue la rvap, alors les vaporations des
          ! diffrentes zones ont t stockes dans xtrevap_tag
          ! on les somme toute dans la vap au tag revap
          if (option_revap.eq.1) then
            call ajoute_revap(ncas_evap_glace,cas_evap_glace(1),
     :          klon,izone,zxt(1,1),xtrevap_tag(1,1))            
          endif !if (option_revap.eq.1) then
#ifdef ISOVERIF
          do i=1,ncas_evap_glace
!             write(*,*) 'iso_revap_ilp 520 tmp: i=',i
!             write(*,*) 'zxt=',zxt(iso_eau:ntraciso:3,cas_evap_glace(i))
!             write(*,*) 'zxt_ancien=',zxt_ancien
!     :           (iso_eau:ntraciso:3,cas_evap_glace(i))
             call iso_verif_traceur(zxt(1,cas_evap_glace(i)),
     :           'iso_revap_fisrtilp 1033')
             call iso_verif_traceur(zxtrfln(1,cas_evap_glace(i)),
     :           'iso_revap_fisrtilp 1035')
          enddo
#endif          
#endif
!#ifdef ISOTRAC

        endif !if (ncas_evap_glace.gt.0) then 

#ifdef ISOVERIF          
          ! dernires vrifs pour l'vap
      if (use_iso_eau.eq.1) then
       do i=1,klon
       if (zrfl_ancien(i).gt.0.0) then
        call iso_verif_egalite_choix(
     :           zxtrfln(iso_eau,i),
     :           zrfln(i),'iso_revap_fisrtilp 801',
     :           errmax,errmaxrel)
        if (iso_verif_egalite_choix_nostop(
     :         zxtrfl(iso_eau,i),
     :         zrfl(i),'iso_revap_fisrtilp 802',
     :         errmax,errmaxrel).eq.1) then
              write(*,*) 'i,k,trace_cas(i)=',i,k,trace_cas(i)
              write(*,*) 'zxtrfln(iso_eau,i),zrfln(i)=',
     :           zxtrfln(iso_eau,i),zrfln(i)
              stop  
        endif ! if (iso_verif_egalite_choix_nostop(
        if (iso_verif_egalite_choix_nostop(
     :         zxt(iso_eau,i),zq(i),
     :         'iso_revap_fisrtilp 807',errmax,errmaxrel).eq.1) then
          write(*,*) 'i,k,trace_cas(i)=',i,k,trace_cas(i)
          stop
        endif !if (iso_verif_egalite_choix_nostop(
        endif !if (zrfl_ancien(i).gt.0.0) then
       enddo !do i=1,klon
      endif !if (use_iso_eau.eq.1) then
#ifdef ISOTRAC      
      ! grande vrif finale
      do i=1,klon          
            call iso_verif_traceur(zxt(1,i),'iso_revap_fisrtilp 532')
            call iso_verif_traceur(zxtrfln(1,i),
     :           'iso_revap_fisrtilp 533') 
            do ixt=1,ntraciso
                call iso_verif_positif_choix(zxt(ixt,i),0.0,
     :                   'revap_ilp 701')
            enddo
       enddo !do i=1,klon
#endif       
#endif          

          return
          end

#endif
