#ifdef ISO
! subroutines traitant l'vaporation en surface

      subroutine calcul_kcin(Vsurf,KCIN)
        implicit none
      ! calcul de kcin en fonction de Vsurf

#include "wateriso2.h"
      ! input:
      real Vsurf ! vent de surface
      ! output:
      real kcin(niso) ! coef cin
      ! locals      
      integer ixt ! numro d'isotope

      
      IF ( VSURF .LT. tv0cin ) THEN
          do ixt=1,niso
              KCIN(IXT) = tkcin0(IXT)
          enddo    
      ELSE
          do ixt=1,niso
              KCIN(IXT) = tkcin1(IXT)*VSURF + tkcin2(IXT)
          enddo    
      ENDIF
      

      return
      end

      !*****************

!      subroutine iso_evap_sol(qsol0,qevap,Pveg,Rsol0,R1,h,T,alphak,
!     :    Rsol,Revap)
!      implicit none
!
!      ! calcul de Rsol et Revap lors de l'vaporation de l'eau du sol
!      ! par un mlange de transpitration et d'vap nue.

!      ! cette subroutine n'est plus utilise, ou prfre
!      ! iso_evap_sol_nu.
!
!#include "wateriso2.h"
!#include "iso_verif.h"
!      ! inputs:
!      real qsol0 ! eau du sol
!      real qevap  ! eau perdue par le sol
!      real Pveg ! fraction de l'vap sans fractionnement: soit par transpiration, soit par sublimation
!      real Rsol0(niso) ! rapport iso initial dans sol
!      real R1(niso) ! rapport iso dans couche 1, suppos constant
!      real h ! humidit rel dans couche 1, suppose cosntante
!      real T ! temprature
!      real alphak(niso) ! coef cintique
!
!      ! outputs!
!      real Rsol(niso) ! rapport iso dans sol aprs l'vap
!      real Revap(niso) ! rapport iso dans flux d'vap
!      
!      ! locals
!      real f ! fraction d'eau rsiduelle dans le sol   
!      real interm(niso)        
!      real betaprime(niso) ! beta*(1-Pveg) avec beta le beta de stewart75
!      real gama(niso) ! le gama de Stewart75
!      real zxtalphal(niso), zxtalphai(niso) ! coeffs frac
!      integer ixt
!      
!      ! ca ne marche que si dj de l'eau dans le sol au dpart
!      if (qsol0.lt.ridicule_qsol) then
!          do ixt=1,niso
!             Rsol(ixt)=Rsol0(ixt)
!             Revap(ixt)=Rsol0(ixt)
!          enddo
!#ifdef ISOVERIF
!            if (use_iso_HDO.eq.1) then
!!                write(*,*) 'iso_surf 66: deltaDsol(iso_HDO)=',         
!!     :           (Rsol(iso_HDO)/tnat(iso_HDO)-1)*1000
!!                write(*,*) 'deltaDevap(iso_HDO)=',(Revap(iso_HDO)/
!!     :           tnat(iso_HDO)-1)*1000
!            endif !if (use_iso_HDO.eq.1) then
!#endif
!          return
!      endif !if (qsol0.lt.ridicule_qsol) then
!
!      ! vrif des rapports isotopiques en entre
!#ifdef ISOVERIF
!        if (use_iso_eau.eq.1) then
!          call iso_verif_egalite_choix(Rsol0(iso_eau),1.0,
!     :           'iso_surf 83',errmax,errmaxrel)
!          call iso_verif_egalite_choix(R1(iso_eau),1.0,
!     :           'iso_surf 56',errmax,errmaxrel)
!        endif !if (use_iso_eau.eq.1) then
!        if (use_iso_HDO.eq.1) then     
!          call iso_verif_aberrant(Rsol0(iso_HDO),'iso_surf 58')
!          if (h.gt.0.01) then
!             call iso_verif_aberrant(R1(iso_HDO),'iso_surf 59')
!          endif !if (h.gt.0.01) then
!        endif  !if (use_iso_HDO.eq.1) then  
!#endif
!
!      
!      f=(qsol0-qevap)/qsol0
!
!      ! premier cas simple: tout est transpir
!      if (Pveg.gt.0.99) then
!          ! on suppose que tout est transpire
!          do ixt=1,niso
!           Rsol(ixt)=Rsol0(ixt)
!           Revap(ixt)=Rsol0(ixt)
!          enddo !do ixt=1,niso
!
!#ifdef ISOVERIF
!            if (use_iso_eau.eq.1) then          
!               call iso_verif_egalite_choix(Rsol(iso_eau),1.0,         
!     :                   'iso_surf 85',errmaxrel,errmaxrel)
!               call iso_verif_egalite_choix(Revap(iso_eau),1.0,
!     :                   'iso_surf 86',errmaxrel,errmaxrel)
!            endif !if (use_iso_eau.eq.1) then
!            if (use_iso_HDO.eq.1) then  
!!              write(*,*) 'iso_surf 108: deltaDsol(iso_HDO)=',
!!     :                   (Rsol(iso_HDO)/tnat(iso_HDO)-1)*1000
!!              write(*,*) 'deltaDevap(iso_HDO)=',
!!     :                   (Revap(iso_HDO)/tnat(iso_HDO)-1)*1000
!              call iso_verif_aberrant(Rsol(iso_HDO),'iso_surf 88')
!              if (qevap.gt.ridicule_qsol) then
!                 call iso_verif_aberrant(Revap(iso_HDO),'iso_surf 89')
!              endif !if (qevap.gt.ridicule_qsol) then
!            endif  !if (use_iso_HDO.eq.1) then  
!#endif
!          return
!      endif
!
!      if (T.lt.273.0) then
!          write(*,*) 'iso_surf 86: impossible: T,Pveg=',T,Pveg
!          write(*,*) 'si T<0, faire rvaporer sans frac -> Pveg=1'
!          stop
!      endif
!
!      ! 2 e cas simple: h=1
!      if (h.gt.0.99) then
!#ifdef ISOVERIF
!          write(*,*) 'iso_surf 102: h=',h
!#endif          
!          do ixt=1,niso
!            call fractcalk(ixt,T,zxtalphal(ixt),zxtalphai(ixt))
!            Rsol(ixt)=Pveg*Rsol0(ixt)+zxtalphal(ixt)*R1(ixt)*(1-Pveg)
!          enddo !do ixt=1,niso
!          
!          if (f.gt.0.99) then
!#ifdef ISOVERIF              
!              write(*,*) 'iso_surf 108: f=',f
!#endif              
!              ! l'vap n'est pas dfinie
!              do ixt=1,niso
!                Revap(ixt)=R1(ixt) ! non dfini,
!                        ! donc on fait en sorte que ne modifie pas la couche 1            
!              enddo
!
!#ifdef ISOVERIF
!                if (use_iso_eau.eq.1) then
!                  call iso_verif_egalite_choix(Rsol(iso_eau),1.0,
!     :                  'iso_surf 110',errmaxrel,errmaxrel)
!                  call iso_verif_egalite_choix(Revap(iso_eau),1.0,
!     :                   'iso_surf 111',errmaxrel,errmaxrel)
!                endif !if (use_iso_eau.eq.1) then
!                if (use_iso_HDO.eq.1) then 
!!                  write(*,*) 'iso_surf 151: deltaDsol(iso_HDO)=',
!!     :                   (Rsol(iso_HDO)/tnat(iso_HDO)-1)*1000  
!!                  write(*,*) 'deltaDevap(iso_HDO)=',
!!     :                   (Revap(iso_HDO)/tnat(iso_HDO)-1)*1000
!                  call iso_verif_aberrant(Rsol(iso_HDO),'iso_surf 112')
!                  if (qevap.gt.ridicule_evap*1800) then
!                     call iso_verif_aberrant(Revap(iso_HDO),
!     :                   'iso_surf 113')
!                  endif !if (qevap.gt.ridicule_evap*1800) then
!                endif  !if (use_iso_HDO.eq.1) then  
!#endif
!
!              return
!
!          else !if (f.gt.1-errmaxrel) then
!#ifdef ISOVERIF              
!              write(*,*) 'iso_surf 121: f=',f
!#endif              
!              do ixt=1,niso
!                Revap(ixt)=(Rsol0(ixt)-f*(Pveg*Rsol0(ixt)
!     :            +(1.-Pveg)*zxtalphal(ixt)*R1(ixt)))        
!     :            /(1.-f) 
!              enddo ! do ixt=1,niso
!
!#ifdef ISOVERIF
!                write(*,*) 'Pveg=',Pveg   
!                if (use_iso_eau.eq.1) then                               
!!              write(*,*) 'zxtalphal(2)=',zxtalphal(2)
!!              write(*,*) 'deltaD1(2)=',(R1(2)/tnat(2)-1)*1000
!!              write(*,*) 'Rsol0(2)=',Rsol0(2)
!!              write(*,*) 'Revap(2)=',Revap(2)
!!              write(*,*) 'numrateur=',Rsol0(ixt)-f*(Pveg*Rsol0(ixt)
!!     :          +(1.-Pveg)*zxtalphal(ixt)*R1(ixt))
!!              write(*,*) 'denom=',1.-f
!!              write(*,*) 't2=',Pveg*Rsol0(ixt)
!!     :          +(1.-Pveg)*zxtalphal(ixt)*R1(ixt)
!                 call iso_verif_egalite_choix(Rsol(iso_eau),1.0,        
!     :                   'iso_surf 125',errmaxrel,errmaxrel)
!                 call iso_verif_egalite_choix(Revap(iso_eau),1.0,
!     :                  'iso_surf 126',errmaxrel,errmaxrel)
!               endif !if (use_iso_eau.eq.1) then
!               if (use_iso_HDO.eq.1) then
!!                 write(*,*) 'iso_surf 191: deltaDevap(iso_HDO)=',
!!     :                   (Revap(iso_HDO)/tnat(iso_HDO)-1)*1000
!!                 write(*,*) 'deltaDsol0(iso_HDO)=',(Rsol0(iso_HDO)
!!     :                   /tnat(iso_HDO)-1)*1000
!                 call iso_verif_aberrant(Rsol(iso_HDO),'iso_surf 127')
!                 if (qevap.gt.ridicule_evap*1800) then
!                    call iso_verif_aberrant(Revap(iso_HDO),
!     :                   'iso_surf 128')
!                 endif !if (qevap.gt.ridicule_evap*1800) then
!               endif  !if (use_iso_HDO.eq.1) then  
!#endif
!
!              return
!          endif !if (f.gt.1-errmaxrel) then
!      endif !if (h.gt.0.99) then
!
!      ! 3 e cas limite : f=1
!      if (f.gt.0.90) then
!#ifdef ISOVERIF          
!          write(*,*) 'iso_surf 139: f=',f
!#endif          
!          do ixt=1,niso
!            call fractcalk(ixt,T,zxtalphal(ixt),zxtalphai(ixt))
!            interm(ixt)=zxtalphal(ixt)*alphak(ixt)*(1-h)          
!            betaprime(ixt)=(1-Pveg)*((1.0-interm(ixt))/interm(ixt))   
!            gama(ixt)=zxtalphal(ixt)*h/(1.0-interm(ixt))
!            Rsol(ixt)=(Rsol0(ixt)-gama(ixt)*R1(ixt))
!     :           *f**(betaprime(ixt))+gama(ixt)*R1(ixt)
!!          Revap(ixt)=(1+betaprime(ixt))*Rsol0(ixt)
!!     :           -betaprime(ixt)*gama(ixt)*R1(ixt) ! 1er ordre
!!!     :          +(1-f)*(-Rsol0(ixt)*(1+betaprime(ixt))*0.5 ! 2e ordre
!!!     :             +betaprime(ixt)*(0.5+gama(ixt)*R1(ixt))) ! 2e ordre 
!          ! 2e ordre conserve mal la masse -> ne pas utiliser
!           Revap(ixt)= (1-Pveg)*((Rsol0(ixt)/zxtalphal(ixt)-h*R1(ixt) )
!     :       /alphak(ixt)/(1-h))+Pveg*Rsol0(ixt) ! =Revap0 <=>1er ordre               
!          enddo !do ixt=1,niso
!
!#ifdef ISOVERIF
!            if (use_iso_eau.eq.1) then
!              call iso_verif_egalite_choix(Rsol(iso_eau),1.0,
!     :           'iso_surf 151',errmaxrel,errmaxrel)
!              call iso_verif_egalite_choix(Revap(iso_eau),1.0,
!     :           'iso_surf 152',errmaxrel,errmaxrel)
!            endif !if (use_iso_eau.eq.1) then
!            if (use_iso_HDO.eq.1) then    
!!                write(*,*) 'iso_surf 235: deltaDsol(iso_HDO)=',
!!     :                   (Rsol(iso_HDO)/tnat(iso_HDO)-1)*1000
!!                write(*,*) 'deltaDevap(iso_HDO)=',(Revap(iso_HDO)
!!     :                   /tnat(iso_HDO)-1)*1000
!                call iso_verif_aberrant(Rsol(iso_HDO),'iso_surf 153')
!                if (qevap.gt.ridicule_evap*1800) then
!                  call iso_verif_aberrant(Revap(iso_HDO),'iso_surf 154')
!                endif !if (qevap.gt.ridicule_evap*1800) then
!            endif  !if (use_iso_HDO.eq.1) then  
!#endif
!          return
!      endif
!
!      ! 4e cas simple: si h=0
!      if (h.lt.0.01) then
!#ifdef ISOVERIF          
!        write(*,*) 'iso_surf 165: h=',h
!#endif        
!        do ixt=1,niso
!          call fractcalk(ixt,T,zxtalphal(ixt),zxtalphai(ixt))
!        enddo  
!        do ixt=1,niso
!          betaprime(ixt)=(1-Pveg)*(1.0/alphak(ixt)/zxtalphal(ixt)-1)
!          Rsol(ixt)=Rsol0(ixt)*f**(betaprime(ixt))
!          Revap(ixt)=Rsol0(ixt)*(1-f**(1+betaprime(ixt)))/(1-f)        
!        enddo !do ixt=1,niso
!        
!#ifdef ISOVERIF
!          if (use_iso_eau.eq.1) then
!             call iso_verif_egalite_choix(Rsol(iso_eau),1.0,
!     :           'iso_surf 168',errmaxrel,errmaxrel)
!             call iso_verif_egalite_choix(Revap(iso_eau),1.0,
!     ;         'iso_surf 169',errmaxrel,errmaxrel)
!          endif !if (use_iso_eau.eq.1) then
!          if (use_iso_HDO.eq.1) then   
!!            write(*,*) 'iso_surf 266: alphak(iso_HDO)=',alphak(iso_HDO)
!!            write(*,*) 'zxtalphal(iso_HDO)=',zxtalphal(iso_HDO)
!!            write(*,*) 'betaprime(iso_HDO)=',betaprime(iso_HDO)
!!            write(*,*) 'f**betaprime(iso_HDO)=',f**betaprime(iso_HDO)
!!            write(*,*) 'Rsol(iso_HDO)=',Rsol(iso_HDO)
!!            write(*,*) 'deltaDsol(iso_HDO)=',(Rsol(iso_HDO)
!!     :                   /tnat(iso_HDO)-1)*1000
!!            write(*,*) 'deltaDevap(iso_HDO)=',(Revap(iso_HDO)
!!     :                   /tnat(iso_HDO)-1)*1000
!            call iso_verif_aberrant(Rsol(iso_HDO),'iso_surf 170')
!            if (qevap.gt.ridicule_qsol) then
!              call iso_verif_aberrant(Revap(iso_HDO),'iso_surf 171')
!            endif !if (qevap.gt.ridicule_qsol) then
!          endif  !if (use_iso_HDO.eq.1) then  
!#endif
!
!        return
!      endif        
!
!      ! cas gnral
!#ifdef ISOVERIF      
!      write(*,*) 'iso_surf 182: cas gnral'
!#endif      
!      do ixt=1,niso
!        call fractcalk(ixt,T,zxtalphal(ixt),zxtalphai(ixt))
!        interm(ixt)=zxtalphal(ixt)*alphak(ixt)*(1.0-h)
!        betaprime(ixt)=(1-Pveg)*((1.0-interm(ixt))/interm(ixt))      
!        gama(ixt)=zxtalphal(ixt)*h/(1.0-interm(ixt))
!        Rsol(ixt)=(Rsol0(ixt)-gama(ixt)*R1(ixt))
!     :           *f**(betaprime(ixt))+gama(ixt)*R1(ixt)
!        Revap(ixt)=(Rsol0(ixt)*(1.0-f**(1.0+betaprime(ixt)))
!     :           -f*gama(ixt)*R1(ixt)*(1.0-f**betaprime(ixt)))/(1.0-f)
!      enddo !do ixt=1,niso
!      
!#ifdef ISOVERIF
!        if (use_iso_eau.eq.1) then
!          call iso_verif_egalite_choix(Rsol(iso_eau),1.0,      
!     :           'iso_surf 185',errmaxrel,errmaxrel)
!          call iso_verif_egalite_choix(Revap(iso_eau),1.0,
!     :           'iso_surf 186',errmaxrel,errmaxrel)
!        endif !if (use_iso_eau.eq.1) then
!        if (use_iso_HDO.eq.1) then  
!!           write(*,*) 'iso_surf 307: betaprime(iso_HDO)=',
!!     :           betaprime(iso_HDO)
!!           write(*,*) 'gama(iso_HDO)=',gama(iso_HDO)
!!           write(*,*) 'deltaDsol(iso_HDO)=',(Rsol(iso_HDO)
!!     :           /tnat(iso_HDO)-1)*1000
!!           write(*,*) 'deltaDevap(iso_HDO)=',(Revap(iso_HDO)
!!     :           /tnat(iso_HDO)-1)*1000
!           call iso_verif_aberrant(Rsol(iso_HDO),'iso_surf 188')
!           if (qevap.gt.ridicule_evap*1800) then
!              call iso_verif_aberrant(Revap(iso_HDO),'iso_surf 189')
!           endif
!         endif  !if (use_iso_HDO.eq.1) then  
!#endif
!
!
!      return
!      end

!
       !*****************


      subroutine calcul_Rsol(qsol,evap,xtsol,xt1lay,q1lay,t1lay,
     :            i,Rsol,klon) 
      implicit none

      ! calcul de Rsol
#include "iso_verif.h"
#include "wateriso2.h"   
      
      ! inputs
      integer klon
      integer i
      double precision qsol(klon)
      real evap(klon)
      double precision xtsol(niso,klon)
      real xt1lay(ntraciso,klon)
      real q1lay(klon)
      real t1lay(klon)
      ! outputs
      real Rsol(niso)
      ! locals
      integer ixt
      real zxtalphal(niso),zxtalphai(niso)
#ifdef ISOVERIF      
      integer iso_verif_egalite_choix_nostop
      real double_to_real
#endif      
     

      ! verif
#ifdef ISOVERIF
        if (use_iso_eau.eq.1) then      
          call iso_verif_egalite_choix(double_to_real(qsol(i)),
     :           double_to_real(xtsol(iso_eau,i)),
     :           'iso_surf>calcul_Rsol 303',errmax,errmaxrel)
          call iso_verif_egalite_choix(q1lay(i),xt1lay(iso_eau,i),
     :           'iso_surf>calcul_Rsol 387',errmax,errmaxrel)
!      write(*,*) 'qsol(i)=',qsol(i)
!      write(*,*) 'xtsol(4,i)=',xtsol(4,i)
        endif !if (use_iso_eau.eq.1) then
        if (use_iso_HDO.eq.1) then
          if (qsol(i).gt.ridicule_qsol*1e2) then
             call iso_verif_aberrant(double_to_real(
     :           xtsol(iso_HDO,i)/qsol(i))/faccond,
     :           'iso_surf>calcul_Rsol 301')
         endif ! if (qsol(i).gt.ridicule_qsol) then
        endif  !if (use_iso_HDO.eq.1) then 
        if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
            if (qsol(i).gt.ridicule_qsol) then
              call iso_verif_aberrant_o17(
     :           double_to_real(xtsol(iso_O17,i)
     :           /qsol(i)),double_to_real(xtsol(iso_O18,i)
     :           /qsol(i)),'iso_surf 401')
            endif !if ((qsol(i).gt.ridicule).and.(xtsol(iso_O18,i)
        endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then 
#endif
      ! end verif 

      if (qsol(i).gt.ridicule_qsol) then
        do ixt=1,niso
            Rsol(ixt)=xtsol(ixt,i)/qsol(i)             
        enddo !do ixt=1,niso

        ! verif
#ifdef ISOVERIF
          do ixt=1,niso  
            call iso_verif_noNAN(Rsol(ixt),'iso_surf>calcul_Rsol 3191')
          enddo !do ixt=1,niso
          if (use_iso_eau.eq.1) then
           if (iso_verif_egalite_choix_nostop(Rsol(iso_eau),1.0,
     :           'iso_surf>calcul_Rsol 312',errmax,errmaxrel*10)
     :           .eq.1) then
              write(*,*) 'xtsol(ixt,i),qsol(i),ridicule_qsol=',
     :           xtsol(ixt,i),qsol(i),ridicule_qsol
              stop
           endif !if (iso_verif_egalite_choix_nostop(Rsol(iso_eau),1.0,   
          endif !if (use_iso_eau.eq.1) then
          if (use_iso_HDO.eq.1) then   
            if (qsol(i).gt.ridicule_qsol*1e2) then
              call iso_verif_aberrant(Rsol(iso_HDO)/faccond,
     :                  'iso_surf>calcul_Rsol 3201')
            endif !if (qsol(i).gt.ridicule_qsol) then
          endif  !if (use_iso_HDO.eq.1) then 
         if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
            if (qsol(i).gt.ridicule_qsol) then
              call iso_verif_aberrant_o17(Rsol(iso_O17),
     :           Rsol(iso_O18),'iso_surf 437')
            endif !if ((qsol(i).gt.ridicule).and.(xtsol(iso_O18,i)
         endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then 
#endif
        ! end verif 

      else !if (qsol(i).gt.ridicule_rain) then
#ifdef ISOVERIF
         if (evap(i)*1800.0.gt.qsol(i)) then  
         write(*,*) 'iso_surf>calcul_Rsol 2989'
         write(*,*) 'qsol(i)=',qsol(i),' mais evap(i)=',evap(i)
         endif
#endif         
         if (q1lay(i).gt.ridicule) then
               ! on suppose que
               ! deltaDsol=deltaDprecip~deltaDcond(INB)~deltaDNK
             do ixt=1,niso
              call fractcalk(ixt,t1lay(i),zxtalphal(ixt),zxtalphai(ixt))
             enddo
             if (t1lay(i).ge.0.0) then   
                 do ixt=1,niso              
                    Rsol(ixt)=zxtalphal(ixt)*xt1lay(ixt,i)/q1lay(i) 
                 enddo !do ixt=1,niso

                 ! verif
#ifdef ISOVERIF
                   do ixt=1,niso        
                        call iso_verif_noNAN(Rsol(ixt),
     :                   'iso_surf>calcul_Rsol 3202')
                   enddo !do ixt=1,niso
                   if (use_iso_eau.eq.1) then 
                     call iso_verif_egalite_choix(Rsol(iso_eau),1.0,
     :                  'iso_surf>calcul_Rsol 467',errmax,errmaxrel)
                   endif !if (use_iso_eau.eq.1) then
                   if (use_iso_HDO.eq.1) then    
                      if (qsol(i).gt.ridicule_qsol) then
                         call iso_verif_aberrant(Rsol(iso_HDO)/faccond,
     :                   'iso_surf>calcul_Rsol 338')
                       endif !if (qsol(i).gt.ridicule_qsol) then
                   endif  !if (use_iso_HDO.eq.1) then 
                   if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
                     if (qsol(i).gt.ridicule_qsol) then
                       call iso_verif_aberrant_o17(Rsol(iso_O17)
     :                   ,Rsol(iso_O18),'iso_surf 480')
                     endif !if ((qsol(i).gt.ridicule).and.(xtsol(iso_O18,i)
                   endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then  
#endif
                  ! end verif
                  !
             else !if (t1lay(i).ge.0.0) then   
                  do ixt=1,niso
                    Rsol(ixt)=zxtalphai(ixt)*xt1lay(ixt,i)/q1lay(i)  
                  enddo !do ixt=1,niso

                  ! verif
#ifdef ISOVERIF
                    do ixt=1,niso  
                        call iso_verif_noNAN(Rsol(ixt),
     :                   'iso_surf>calcul_Rsol 3207')
                    enddo !do ixt=1,niso    
                    if (use_iso_eau.eq.1) then
                        call iso_verif_egalite_choix(Rsol(iso_eau),1.0,
     :                   'iso_surf>calcul_Rsol 335',errmax,errmaxrel)
                    endif !if (use_iso_eau.eq.1) then
                    if (use_iso_HDO.eq.1) then          
                      if (qsol(i).gt.ridicule_qsol) then
                        call iso_verif_aberrant(Rsol(iso_HDO)/faccond,
     :                   'iso_surf>calcul_Rsol 338')
                      endif !if (qsol(i).gt.ridicule_qsol) then
                    endif  !if (use_iso_HDO.eq.1) then 
                    if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
                      if (qsol(i).gt.ridicule_qsol) then
                        call iso_verif_aberrant_o17(Rsol(iso_O17)
     :                    ,Rsol(iso_O18),'iso_surf 513')
                      endif !if ((qsol(i).gt.ridicule).and.(xtsol(iso_O18,i)
                    endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then  
#endif
                      ! end verif
             endif !if (t1lay(i).ge.0.0) then   

         else !if (q1lay(i).gt.ridicule) then
                write(*,*) 'warning: iso_surf>calcul_Rsol 3209'
                write(*,*) 'qsol(i)=',qsol(i),' mais evap(i)=',evap(i)
                write(*,*) 'q1lay(i)=',q1lay(i)
                stop
         endif !if (q1lay(i).gt.ridicule) then
       endif !if (qsol(i).gt.ridicule_rain) then

       ! verif
#ifdef ISOVERIF
         do ixt=1,niso
           call iso_verif_noNAN(Rsol(ixt),
     :             'iso_surf>calcul_Rsol 3217, sur terre')
         enddo !do ixt=1,niso
       
         if (use_iso_eau.eq.1) then
                 call iso_verif_egalite_choix(Rsol(iso_eau),1.0,
     :          'iso_surf>calcul_Rsol 371',errmax,errmaxrel*10)
         endif !if (use_iso_eau.eq.1) then
         if (use_iso_HDO.eq.1) then        
            if (qsol(i).gt.ridicule_qsol*1e2) then
                call iso_verif_aberrant(Rsol(iso_HDO)/faccond,
     :          'iso_surf>calcul_Rsol 374')
            endif !if (qsol(i).gt.ridicule_qsol) then
         endif  !if (use_iso_HDO.eq.1) then 
         if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
            if (qsol(i).gt.ridicule_qsol) then
              call iso_verif_aberrant_o17(Rsol(iso_O17),
     :           Rsol(iso_O18),'iso_surf 548')
            endif !if ((qsol(i).gt.ridicule).and.(xtsol(iso_O18,i)
         endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then  
#endif
                  ! end verif

         return
         end

         !***************

         subroutine iso_rosee_givre(xt1lay,q1lay,Tsurf_new,t_coup,evap,
     :          i,xtevap,klon)      
         implicit none
#include "iso_verif.h"
#include "wateriso2.h"       
      ! inputs
      integer i
      integer klon
      real evap(klon) ! en kg d'eau/s
      real xt1lay(ntraciso,klon) ! en kg d'iso/kg d'air
      real q1lay(klon) ! en kg d'eau/kg d'air
      real Tsurf_new(klon)
      real t_coup
!      real dtime ! en s: typiquement: 1800s
!      real Mair ! en kg d'air

      ! outputs
      real xtevap(ntraciso,klon) ! en kg d'iso/s

      ! locals
      integer ixt
      real zxtalphal(niso),zxtalphai(niso)
      real zxtliq,zxtice ! en kg d'eau /kg d'air
!      real qevap ! en kg d'eau /kg d'air
      real deltaD ! juste pour vrif
      real R1eff
#ifdef ISOVERIF
      integer iso_verif_aberrant_o17_nostop
      real deltaO,o17excess
#endif

!      write(*,*) 'iso_surf>rose 527: entre dans rose'
      if (evap(i).eq.0.0) then
#ifdef ISOVERIF          
        write(*,*) 'iso_surf>rose 528: evap(i)=',evap(i)
#endif        
        do ixt=1,niso
          xtevap(ixt,i)=0.0
        enddo
        return
      endif

      if (q1lay(i).gt.ridicule) then
             ! verif de R1
#ifdef ISOVERIF
                 if (use_iso_HDO.eq.1) then
                     call iso_verif_aberrant(xt1lay(iso_HDO,i)/q1lay(i),
     :                  'iso_surf>rose 530')
                 endif   !if (use_iso_HDO.eq.1) then
#endif
             ! end verif R1   

!             qevap=-evap(i)*dtime/Mair ! en kg d'eau par kg d'air
!             write(*,*) 'iso_surf>ros 554: qevap=',qevap
!             write(*,*) 'evap(i),dtime,Mair,q1lay(i)=',
!     :                   evap(i),dtime,Mair,q1lay(i)            
          if (Tsurf_new(i).ge.t_coup) then
            !write(*,*) 'iso_surf>iso_rosee_givre 3181: Tsurf_new(i)=',Tsurf_new(i)
            do ixt=1,niso
               ! methode 1: condensation  l'quilibre, approx 1er ordre
               R1eff= xt1lay(ixt,i)/q1lay(i)  
               call fractcalk_liq(ixt,Tsurf_new(i),zxtalphal(ixt)) 
               xtevap(ixt,i)=evap(i)*zxtalphal(ixt)*R1eff 
               ! methode 2: condensation, approche sans approximation
!                call condiso_liq_ice(ixt,xt1lay(ixt,i),q1lay(i),
!     :           qevap,Tsurf_new(i),0.0,zxtice,zxtliq)    
!               xtevap(ixt,i)=-zxtliq/dtime*Mair       
!                write(*,*) 'iso_surf>rose 545: qevap=', qevap
!                write(*,*) 'q1lay(i)=',q1lay(i)
!                write(*,*) 'zxtice=',zxtice
!                write(*,*) 'zxtliq=',zxtliq               
                
            enddo !do ixt=1,niso

#ifdef ISOTRAC
           do ixt=niso+1,ntraciso
                R1eff= xt1lay(ixt,i)/q1lay(i) 
                xtevap(ixt,i)=evap(i)*R1eff*zxtalphal(index_iso(ixt))
           enddo
#endif            

#ifdef ISOVERIF
              do ixt=1,ntraciso
                call iso_verif_noNAN(xtevap(ixt,i),'iso_surf>rose 557')
              enddo !do ixt=1,niso  
              if (use_iso_HDO.eq.1) then            
!                write(*,*) 'iso_surf>rose 554: deltaD1=',
!     :                   deltaD(xt1lay(iso_HDO,i)/q1lay(i))
!                write(*,*) 'deltaDcond=',
!     :                   deltaD(xtevap(iso_HDO,i)/evap(i))
              endif ! if (use_iso_HDO.eq.1)) then 
#ifdef ISOTRAC
              call iso_verif_tracnps(xtevap(1,i),
     :          'iso_surf_rose 643')
#endif              
#endif
              
          else !if (Tsurf_new(i).ge.t_coup) then
            !write(*,*) 'iso_surf>iso_rosee_givre 3186: Tsurf_new(i)=',Tsurf_new(i)
            do ixt=1,niso
            ! methode 1: condensation  l'quilibre, approx 1er ordre
               R1eff= xt1lay(ixt,i)/q1lay(i)
               call fractcalk_glace(ixt,Tsurf_new(i),zxtalphai(ixt))
               xtevap(ixt,i)=evap(i)*zxtalphai(ixt)*R1eff
             ! methode 2: condensation, approche sans approximation
!                call condiso_liq_ice(ixt,xt1lay(ixt,i),q1lay(i),
!     :           qevap,Tsurf_new(i),1.0,zxtice,zxtliq)           
!                xtevap(ixt,i)=-zxtice/dtime*Mair
!                write(*,*) 'iso_surf>rose 558: qevap=',qevap
!                write(*,*) 'q1lay(i)=',q1lay(i)
!                write(*,*) 'zxtice=',zxtice
!                write(*,*) 'zxtliq=',zxtliq

            enddo !do ixt=1,niso  

#ifdef ISOTRAC
           do ixt=niso+1,ntraciso
                R1eff= xt1lay(ixt,i)/q1lay(i) 
                xtevap(ixt,i)=evap(i)*R1eff*zxtalphai(index_iso(ixt))
           enddo
#endif  

#ifdef ISOVERIF            
            if (use_iso_HDO.eq.1) then
!             write(*,*) 'iso_surf>rose 571: deltaD1=',
!     :                   deltaD(xt1lay(iso_HDO,i)/q1lay(i))
!             write(*,*) 'deltaDcond=',
!     :                   deltaD(xtevap(iso_HDO,i)/evap(i))    
            endif  !if (use_iso_HDO.eq.1) then
            if (use_iso_eau.eq.1) then
              call iso_verif_egalite_choix(xt1lay(iso_eau,i),q1lay(i),
     :           'iso_surf>iso_rosee_givre 621',errmax,errmaxrel)
              call iso_verif_egalite_choix(xtevap(iso_eau,i),evap(i),
     :           'iso_surf>iso_rosee_givre 622',errmax,errmaxrel)
            endif !if (use_iso_eau.eq.1) then
#ifdef ISOTRAC
              call iso_verif_tracnps(xtevap(1,i),
     :          'iso_surf_rose 687')
#endif              
#endif            
          endif !if (Tsurf_new(i).ge.0.0) then 

          
          ! verif   
#ifdef ISOVERIFIDRIS
            do ixt=1,niso
              call iso_verif_noNAN(xtevap(ixt,i),
     :            'iso_surf>iso_rosee_givre 3199')
            enddo !do ixt=1,niso
#endif
#ifdef ISOVERIF
            if (use_iso_eau.eq.1) then
              call iso_verif_egalite_choix(xtevap(iso_eau,i),evap(i),
     :           'iso_surf>iso_rosee_givre 3192',errmax,errmaxrel)
            endif !if (use_iso_eau.eq.1) then
            if (abs(evap(i)).gt.ridicule_rain) then
              if (use_iso_HDO.eq.1) then                  
                 call iso_verif_aberrant(xtevap(iso_HDO,i)/evap(i),
     :           'iso_surf>iso_rosee_givre 3193')               
              endif  !if (use_iso_HDO.eq.1) then  
              if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
                if (iso_verif_aberrant_o17_nostop(xtevap(iso_O17,i)
     :            /evap(i),xtevap(iso_O18,i)
     :            /evap(i),'iso_surf>iso_rosee_givre 713').eq.1) then
                  write(*,*) 'Tsurf_new(i)-t_coup=',Tsurf_new(i)-t_coup
                  write(*,*) 'deltaO18, O17excess, 1lay',
     :                  deltaO(xt1lay(iso_O18,i)/q1lay(i)),o17excess(
     :                  xt1lay(iso_O17,i)/q1lay(i),
     :                  xt1lay(iso_O18,i)/q1lay(i)) 
                  write(*,*) 'zxtalphai(:)=',zxtalphai(:)
                  stop
                endif
              endif !if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
            endif !if (evap(i).gt.ridicule_rain) then
#endif
          ! end verif

        else !if (q1lay(i).gt.0) then
            write(*,*) 'iso_surf>iso_rosee_givre 3189: evap=',evap
            write(*,*) 'q1lay(i)=',q1lay(i)
            stop
        endif !if (q1lay(i).gt.0) then

        return
        end
#endif        
