#ifdef ISOTRAC
      subroutine traceurs_init()
      use IOIPSL ! getin
        implicit none

#include "wateriso2.h"

        ! dfinition de quelles zones et quelles isotopes reprsentent
        ! les traceurs

        ! inputs, outputs
        ! ! c'est les variables dans traceurs.h qui sont modifies

        ! locals
        integer itrac,izone,ixt,k
        integer izone_pres,izone_lat
        character*2 strz,strz_preslat
        character*1 strz_pres,strz_lat

        ! vrifier que on a bien l'eau comme traceurs
        if (use_iso_eau.eq.0) then
            write(*,*) 'traceurs_init 18: isotrac ne marche que si ',
     :            'on met l''eau comme isotope'
            stop
        endif
        write(*,*) 'option_traceurs=',option_traceurs

        ! cas gnral: pas de traceurs dans ORCHIDEE
        ntracisoOR=niso

        ! partie  diter ! pour dfinir les diffrentes zones
        if (option_traceurs.eq.1) then
          ! on trace continents/ocean  

          izone_cont=1
          izone_oce=2          
          izone_poubelle=2 ! zone o on met les flux non physiques, de
                ! rajustement
          izone_init=2 ! zone d'initialisation par dfaut          
          option_revap=0
          option_tmin=0
          izone_revap=0
          option_cond=0

          strtrac(izone_cont)='con'
          strtrac(izone_oce)='oce'

        elseif (option_traceurs.eq.2) then
          ! on trace continent/ ocean/reevap des gouttes

          izone_cont=1
          izone_oce=2
          izone_poubelle=2 ! zone o on met les flux non physiques, de
                ! rajustement
          izone_init=2 ! zone d'initialisation par dfaut
          option_revap=1
          option_tmin=0
          izone_revap=3
          option_cond=0

          strtrac(izone_cont)='con'
          strtrac(izone_oce)='oce'
          strtrac(izone_revap)='rev'
          

        else if (option_traceurs.eq.3) then
            ! on trace des bassins ocaniques + un rsidu. On ne trace
            ! pas l'vap des gouttes  part
            ! le rsidu est la dernre dimension
            
          izone_cont=ntraceurs_zone
          izone_oce=0 ! pas de sens car spare en bassins          
          izone_poubelle=ntraceurs_zone-1 ! zone o on met les flux non physiques, de
                ! rajustement
          izone_init=ntraceurs_zone-1 ! zone d'initialisation par dfaut
          option_revap=0 ! on ne trace pas les gouttes 
          option_tmin=0
          izone_revap=0 ! pas de sens car on taggue pas les gouttes sparemment  
          option_cond=0

          ! si on a use_bassin_indian, on n'a pas le dcoupage dtaill
          ! de l'indian:
#ifdef ISOVERIFIDRIS
          if (use_bassin_indian.eq.1) then
              call iso_verif_egalite(float(use_bassin_merarabie),
     :            0.0,'iso_traceurs_init 73: revoir def des bassins')
              call iso_verif_egalite(float(use_bassin_golfebengale),
     :            0.0,'iso_traceurs_init 73: revoir def des bassins')
              call iso_verif_egalite(float(use_bassin_indiansud),
     :            0.0,'iso_traceurs_init 73: revoir def des bassins')
          endif
#endif    

          write(*,*) 'use_bassin_atlantic=' ,use_bassin_atlantic  
          write(*,*) 'use_bassin_medit=' ,use_bassin_medit
          write(*,*) 'use_bassin_indian=' ,use_bassin_indian
          write(*,*) 'use_bassin_austral=' ,use_bassin_austral
          write(*,*) 'use_bassin_merarabie=' ,use_bassin_merarabie
          write(*,*) 'use_bassin_golfebengale=' ,use_bassin_golfebengale
          write(*,*) 'use_bassin_indiansud=' ,use_bassin_indiansud
          write(*,*) 'use_bassin_tropics=' ,use_bassin_tropics
          write(*,*) 'use_bassin_midlats=' ,use_bassin_midlats
          write(*,*) 'use_bassin_hauteslats=' ,use_bassin_hauteslats
          
          bassin_atlantic= max(use_bassin_atlantic,1)
          bassin_medit=max(use_bassin_atlantic
     :           +use_bassin_medit,1)
          bassin_indian=max(use_bassin_atlantic
     :           +use_bassin_medit
     :           +use_bassin_indian,1)
          bassin_austral=max(use_bassin_atlantic
     :           +use_bassin_medit
     :           +use_bassin_indian
     :           +use_bassin_austral,1)
          bassin_pacific=max(use_bassin_atlantic
     :           +use_bassin_medit
     :           +use_bassin_indian
     :           +use_bassin_austral
     :           +use_bassin_pacific,1)
          bassin_merarabie=max(use_bassin_atlantic
     :           +use_bassin_medit
     :           +use_bassin_indian
     :           +use_bassin_austral
     :           +use_bassin_pacific
     :           +use_bassin_merarabie,1)
          bassin_golfebengale=max(use_bassin_atlantic
     :           +use_bassin_medit
     :           +use_bassin_indian
     :           +use_bassin_austral
     :           +use_bassin_pacific
     :           +use_bassin_merarabie
     :           +use_bassin_golfebengale,1)
          bassin_indiansud=max(use_bassin_atlantic
     :           +use_bassin_medit
     :           +use_bassin_indian
     :           +use_bassin_austral
     :           +use_bassin_pacific
     :           +use_bassin_merarabie
     :           +use_bassin_golfebengale
     :           +use_bassin_indiansud,1) 
          bassin_tropics=max(use_bassin_atlantic
     :           +use_bassin_medit
     :           +use_bassin_indian
     :           +use_bassin_austral
     :           +use_bassin_pacific
     :           +use_bassin_merarabie
     :           +use_bassin_golfebengale
     :           +use_bassin_indiansud,
     :           +use_bassin_tropics,1) 
          bassin_midlats=max(use_bassin_atlantic
     :           +use_bassin_medit
     :           +use_bassin_indian
     :           +use_bassin_austral
     :           +use_bassin_pacific
     :           +use_bassin_merarabie
     :           +use_bassin_golfebengale
     :           +use_bassin_indiansud
     :           +use_bassin_tropics
     :           +use_bassin_midlats,1) 
          bassin_hauteslats=max(use_bassin_atlantic
     :           +use_bassin_medit
     :           +use_bassin_indian
     :           +use_bassin_austral
     :           +use_bassin_pacific
     :           +use_bassin_merarabie
     :           +use_bassin_golfebengale
     :           +use_bassin_indiansud
     :           +use_bassin_tropics
     :           +use_bassin_midlats
     :           +use_bassin_hauteslats,1) 

          write(*,*) 'bassin_atlantic=' ,bassin_atlantic  
          write(*,*) 'bassin_medit=' ,bassin_medit
          write(*,*) 'bassin_indian=' ,bassin_indian
          write(*,*) 'bassin_austral=' ,bassin_austral
          write(*,*) 'bassin_merarabie=' ,bassin_merarabie
          write(*,*) 'bassin_golfebengale=' ,bassin_golfebengale
          write(*,*) 'bassin_indiansud=' ,bassin_indiansud
          write(*,*) 'bassin_tropics=' ,bassin_tropics
          write(*,*) 'bassin_midlats=' ,bassin_midlats
          write(*,*) 'bassin_hauteslats=' ,bassin_hauteslats

          if (use_bassin_atlantic.eq.1) then
            strtrac(bassin_atlantic)='atl'
          endif
          if (use_bassin_medit.eq.1) then
            strtrac(bassin_medit)='med'
          endif
          if (use_bassin_indian.eq.1) then
            strtrac(bassin_indian)='ind'
          endif
          if (use_bassin_austral.eq.1) then
            strtrac(bassin_austral)='aus'
          endif
          if (use_bassin_pacific.eq.1) then
            strtrac(bassin_pacific)='pac'
          endif
          if (use_bassin_merarabie.eq.1) then
            strtrac(bassin_merarabie)='ara'
          endif
          if (use_bassin_golfebengale.eq.1) then
            strtrac(bassin_golfebengale)='ben'
          endif
          if (use_bassin_indiansud.eq.1) then
            strtrac(bassin_indiansud)='ins'
          endif
          if (use_bassin_tropics.eq.1) then
            strtrac(bassin_tropics)='tro'
          endif
          if (use_bassin_midlats.eq.1) then
            strtrac(bassin_midlats)='mid'
          endif
          if (use_bassin_hauteslats.eq.1) then
            strtrac(bassin_hauteslats)='hau'
          endif
          strtrac(ntraceurs_zone-1)='res'
          strtrac(ntraceurs_zone)='con'

        else if (option_traceurs.eq.4) then
          ! on trace les temprature minimales vcues
          ! comme dans article sur LdG sauf pas de revap
            
          izone_cont=ntraceurs_zone
          izone_oce=ntraceurs_zone  
          izone_poubelle=ntraceurs_zone
          izone_init=ntraceurs_zone ! zone d'initialisation par dfaut
          option_revap=0 
          option_tmin=0  
          izone_revap=0
          option_cond=0
          do izone=1,nzone_temp
            write(strz,'(i2.2)') izone
            strtrac(izone)='t'//strz
            write(*,*) 'izone,strz,strtrac=',izone,strz,strtrac(izone)
          enddo
          strtrac(izone_poubelle)='pou'

          ! initialisation des zones de temparture
          do izone=1,nzone_temp-1
            zone_temp(izone)=zone_temp1+float(izone-1)
     :          *(zone_tempa*float(izone-nzone_temp+1)
     :          +(zone_tempf-zone_temp1)/float(nzone_temp-2))
          enddo
          write(*,*) 'iso_trac_init 183: zone_temp=',zone_temp          

        elseif (option_traceurs.eq.5) then
          ! on trace AEJ/flux de mousson/Harmattan
!          write(*,*) 'iso_traceurs_init 129'

          izone_cont=1
          izone_oce=1
          izone_poubelle=1 ! zone o on met les flux non physiques, de
                ! rajustement
          izone_init=1 ! zone d'initialisation par dfaut
          option_revap=0
          option_tmin=0
          izone_revap=0
          izone_aej=2
          izone_mousson=3
          izone_harmattan=4 
          option_cond=0

          strtrac(izone_poubelle)='res'
          strtrac(izone_aej)='aej'
          strtrac(izone_mousson)='mou'
          strtrac(izone_harmattan)='sah'

        elseif (option_traceurs.eq.6) then
          ! on trace les ddfts

          izone_cont=1
          izone_oce=1
          izone_poubelle=1 ! zone o on met les flux non physiques, de
                ! rajustement
          izone_init=1 ! zone d'initialisation par dfaut
          option_revap=0
          option_tmin=0
          izone_revap=0
          izone_ddft=2
          option_cond=0

          strtrac(izone_poubelle)='res'
          strtrac(izone_ddft)='dft'

        elseif (option_traceurs.eq.9) then
          ! on trace le condensat

          izone_cont=1
          izone_oce=1
          izone_poubelle=1 ! zone o on met les flux non physiques, de
                ! rajustement
          izone_init=1 ! zone d'initialisation par dfaut
          option_revap=1
          option_tmin=0
          izone_revap=2
          izone_cond=3
          option_cond=1

          ! 1 par dfaut pour colorier  la fois condensat LS et
          ! condensat convectif. Mais on peut mettre 2 si on ne veut que
          ! collorier que le condensat convectif.
          call getin('option_cond',option_cond)
          write(*,*) 'option_cond=',option_cond

          strtrac(izone_poubelle)='res'
          strtrac(izone_cond)='con'
          strtrac(izone_revap)='rev'

        elseif (option_traceurs.eq.10) then
          ! on trace l'vap venant de ocean/continent no frac/continent frac
          !  utilse seulement si coupl avec ORCHIDEE
#ifdef CPP_VEGET
#else
          write(*,*) 'iso_traceurs_init 219: option_traceurs=10 ',
     :          'inutile si on ne couple pas avec ORCHIDEE'
          stop
#endif          

          izone_cont=1 ! sous-entendu non fractionnant
          izone_oce=2
          izone_poubelle=2 ! zone o on met les flux non physiques, de
                ! rajustement
          izone_init=2 ! zone d'initialisation par dfaut
          option_revap=0
          option_tmin=0
          izone_revap=0
          izone_contfrac=3
          izone_contcanop=3
          izone_irrig=0
          option_cond=0

          strtrac(izone_oce)='oce'
          strtrac(izone_cont)='con'  
          strtrac(izone_contfrac)='enu'  ! evap sol nu

        elseif (option_traceurs.eq.11) then
          ! on trace reevap des gouttes et le reste

          izone_cont=1
          izone_oce=1
          izone_poubelle=1 ! zone o on met les flux non physiques, de
                ! rajustement
          izone_init=1 ! zone d'initialisation par dfaut
          option_revap=1
          option_tmin=0
          izone_revap=2
          izone_irrig=0
          option_cond=0

          strtrac(izone_poubelle)='res'
          strtrac(izone_revap)='rev'

        elseif (option_traceurs.eq.12) then
          ! on trace evap du sol nu, evap de la canope, reste de l'evap cont et
          ! evap oce
#ifdef CPP_VEGET
#else
          write(*,*) 'iso_traceurs_init 257: option_traceurs=10 ',
     :          'inutile si on ne couple pas avec ORCHIDEE'
          stop
#endif           

          izone_cont=1
          izone_oce=2
          izone_poubelle=2 ! zone o on met les flux non physiques, de
                ! rajustement
          izone_init=2 ! zone d'initialisation par dfaut
          option_revap=0
          option_tmin=0
          izone_revap=0
          izone_contfrac=3
          izone_contcanop=4
          izone_irrig=0   
          option_cond=0

          strtrac(izone_oce)='oce'
          strtrac(izone_cont)='con'
          strtrac(izone_contfrac)='enu'  ! evap sol nu
          strtrac(izone_contcanop)='eca'  ! evap canop

       else if (option_traceurs.eq.13) then
          ! on trace les temprature minimales vcues + la revap
          ! comme dans article sur LdG
            
          izone_cont=1
          izone_oce=1  
          izone_poubelle=1
          izone_init=1 ! zone d'initialisation par dfaut
          option_revap=1   
          option_tmin=0
          izone_revap=ntraceurs_zone
          izone_irrig=0
          option_cond=0
          do izone=1,nzone_temp
            write(strz,'(i2.2)') izone
            strtrac(izone)='t'//strz
            write(*,*) 'izone,strz,strtrac=',izone,strz,strtrac(izone)
          enddo
          strtrac(izone_revap)='rev'

          ! initialisation des zones de temparture
          do izone=1,nzone_temp-1
            zone_temp(izone)=zone_temp1+float(izone-1)
     :          *(zone_tempa*float(izone-nzone_temp+1)
     :          +(zone_tempf-zone_temp1)/float(nzone_temp-2))
          enddo
          write(*,*) 'zone_temp=',zone_temp

       else if (option_traceurs.eq.14) then
          ! on trace les pres et lat de dernire saturation dfinies
          ! comme rh>90%
            
          izone_cont=ntraceurs_zone
          izone_oce=ntraceurs_zone
          izone_poubelle=ntraceurs_zone
          izone_init=ntraceurs_zone ! zone d'initialisation par dfaut
          option_revap=0  
          option_tmin=0 
          izone_revap=0
          izone_irrig=0
          option_cond=0
          do izone_pres=1,nzone_pres
           do izone_lat=1,nzone_lat
            write(strz_pres,'(i1.1)') izone_pres
            write(strz_lat,'(i1.1)') izone_lat
            strz_preslat=strz_pres//strz_lat
            izone=izone_lat+(izone_pres-1)*nzone_lat
            strtrac(izone)='t'//strz_preslat
            write(*,*) 'izone_pres,izone_lat,strtrac=',
     :            izone_pres,izone_lat,izone,strtrac(izone)
           enddo !do izone_lat=1,nzone_lat
          enddo !do izone_pres=1,nzone_pres
          strtrac(ntraceurs_zone)='sfc'

          ! initialisation des zones de temparture
          do izone=1,nzone_pres-1
            zone_pres(izone)=zone_pres1+float(izone-1)
     :          *(zone_presa*float(izone-nzone_pres+1)
     :          +(zone_presf-zone_pres1)/float(nzone_pres-2))
          enddo !do izone=1,nzone_pres-1
          write(*,*) 'traceurs_init 332: zone_pres=',zone_pres
!          stop
!
       elseif (option_traceurs.eq.15) then
          ! on trace l'irrigation dans ORCHIDEE
#ifdef CPP_VEGET
#else
          write(*,*) 'iso_traceurs_init 257: option_traceurs=15 ',
     :          'inutile si on ne couple pas avec ORCHIDEE'
          stop
#endif

          izone_cont=1
          izone_oce=1
          izone_poubelle=1 ! zone o on met les flux non physiques, de
                ! rajustement
          izone_init=1 ! zone d'initialisation par dfaut
          option_revap=0
          option_tmin=0
          izone_revap=0
          izone_contfrac=0
          izone_contcanop=0 
          izone_irrig=2 
          option_cond=0
          
          strtrac(izone_poubelle)='res'
          strtrac(izone_irrig)='irrig'

          ! dans ce cas particulier, il y a des traceurs dans ORCHIDEE
          ntracisoOR=ntraciso

        else if ((option_traceurs.eq.17).or.
     :           (option_traceurs.eq.18)) then
          ! on trace les temprature minimales vcues
          ! comme dans article sur LdG sauf pas de revap
            
          izone_cont=nzone_temp+1
          izone_oce=nzone_temp+1 
          izone_poubelle=nzone_temp+1
          izone_init=nzone_temp+1 ! zone d'initialisation par dfaut
          option_revap=1  
          option_tmin=1 
          option_cond=1

          izone_revap=nzone_temp+3
          izone_cond=nzone_temp+2
          do izone=1,nzone_temp
            write(strz,'(i2.2)') izone
            strtrac(izone)='t'//strz
            write(*,*) 'izone,strz,strtrac=',izone,strz,strtrac(izone)
          enddo !do izone=1,nzone_temp
          strtrac(izone_poubelle)='sfc'
          strtrac(izone_cond)='con'
          strtrac(izone_revap)='rev'

          ! initialisation des zones de temparture
          do izone=1,nzone_temp-1
            zone_temp(izone)=zone_temp1+float(izone-1)
     :          *(zone_tempa*float(izone-nzone_temp+1)
     :          +(zone_tempf-zone_temp1)/float(nzone_temp-2))
          enddo
         write(*,*) 'zone_temp1,zone_tempf,zone_tempa=',
     :           zone_temp1,zone_tempf,zone_tempa
          write(*,*) 'zone_temp=',zone_temp
!          stop          

        else if (option_traceurs.eq.19) then
          izone_cont=nzone_temp+1
          izone_oce=nzone_temp+1 
          izone_poubelle=nzone_temp+1
          if (option_seuil_tag_tmin.eq.1) then
            izone_init=nzone_temp+1 ! zone d'initialisation par dfaut
          else
            izone_init=nzone_temp
          endif
          option_revap=1   
          izone_revap=nzone_temp+3
          izone_cond=nzone_temp+2
          izone_ddft=nzone_temp+4
          option_tmin=1          
          option_cond=1
          do izone=1,nzone_temp
            write(strz,'(i2.2)') izone
            strtrac(izone)='t'//strz
            write(*,*) 'izone,strz,strtrac=',izone,strz,strtrac(izone)
          enddo !do izone=1,nzone_temp
          strtrac(izone_poubelle)='sfc'
          strtrac(izone_cond)='con'
          strtrac(izone_revap)='rev'
          strtrac(izone_ddft)='dft'

        elseif (option_traceurs.eq.20) then
          ! on vapeur tropical/extractropicale/recyclage extractropical
          ! pour comprendre controles humidit et isotopes subtropicaux.

          izone_cont=1
          izone_oce=1
          izone_poubelle=2 ! zone o on met les flux non physiques, de
                ! rajustement
          izone_init=2 ! zone d'initialisation par dfaut
          option_revap=0
          option_tmin=0
          izone_revap=0
          izone_trop=2
          izone_extra=3

          strtrac(izone_trop)='tro' ! vapeur tropicale
          strtrac(izone_extra)='ext' ! vapeur extractropicale evapore 
                ! dans les tropiques
          strtrac(izone_cont)='rec' ! recyclage

        elseif (option_traceurs.eq.21) then
          ! on trace 2 boites 3D: UT tropicale et extratropiques 
          ! fonctionnement similaire  option 5 pour taggage des zones
          ! AMMA
!          write(*,*) 'iso_traceurs_init 129'

          izone_cont=1
          izone_oce=1
          izone_poubelle=1 ! zone o on met les flux non physiques, de
                ! rajustement
          izone_init=1 ! zone d'initialisation par dfaut
          option_revap=0
          option_tmin=0
          izone_revap=0
          izone_trop=2
          izone_extra=3
          option_cond=0

          strtrac(izone_poubelle)='res'
          strtrac(izone_trop)='tro'
          strtrac(izone_extra)='ext'

        elseif (option_traceurs.eq.22) then
          ! on trace la vapeur qui a t processe dans zones de
          ! convections  3 niveaux: BT, MT et UT

          izone_cont=1
          izone_oce=1
          izone_poubelle=1 ! zone o on met les flux non physiques, de
                ! rajustement
          izone_init=1 ! zone d'initialisation par dfaut
          option_revap=0
          option_tmin=0
          izone_revap=0
          izone_conv_BT=2
          izone_conv_UT=3
          option_cond=0

          strtrac(izone_poubelle)='res'
          strtrac(izone_conv_BT)='cbt'
          strtrac(izone_conv_UT)='cut'

        else
            write(*,*) 'traceurs_init 36: option pas encore prvue'
            stop
        endif

        ! partie non ditable, automatique
        
        ! seuil sur le taux de condensation
        if (option_tmin.eq.1) then
          seuil_tag_tmin=0.01
          call getin('seuil_tag_tmin',seuil_tag_tmin)
          write(*,*) 'seuil_tag_tmin=',seuil_tag_tmin

          seuil_tag_tmin_ls=seuil_tag_tmin
          call getin('seuil_tag_tmin_ls',seuil_tag_tmin_ls)
          write(*,*) 'seuil_tag_tmin_ls=',seuil_tag_tmin_ls

          option_seuil_tag_tmin=1
          call getin('option_seuil_tag_tmin',option_seuil_tag_tmin)
          write(*,*) 'option_seuil_tag_tmin=',option_seuil_tag_tmin
        endif

        if (option_traceurs.eq.20) then
          lim_tag20=35.0
          call getin('lim_tag20',lim_tag20)
          write(*,*) 'lim_tag20=',lim_tag20
        endif 

        if (option_traceurs.eq.22) then
          lim_precip_tag22=20.0
          call getin('lim_precip_tag22',lim_precip_tag22)
          write(*,*) 'lim_precip_tag22=',lim_precip_tag22
        endif        

        do ixt=1,niso
           index_zone(ixt)=0
           index_iso(ixt)=ixt
        enddo
        itrac=niso        
        do izone=1,ntraceurs_zone
          do ixt=1,niso
            itrac=itrac+1
            index_zone(itrac)=izone
            index_iso(itrac)=ixt
            index_trac(izone,ixt)=itrac
          enddo
        enddo
#ifdef ISOVERIFIDRIS
        call iso_verif_egalite(float(itrac),float(ntraciso),
     :           'traceurs_init 50')
     
        write(*,*) 'traceurs_init 65: bilan de l''init:'
        write(*,*) 'index_zone=',index_zone(1:ntraciso)
        write(*,*) 'index_iso=',index_iso(1:ntraciso)
        write(*,*) 'index_trac=',index_trac(1:ntraceurs_zone,1:niso)
        do izone=1,ntraceurs_zone
          write(*,*) 'strtrac(',izone,')=',strtrac(izone)
        enddo !do izone=1,ntraceurs_zone
        write(*,*) 'ntracisoOR=',ntracisoOR
#endif  

        return
        end
#endif
        
