#ifdef ISOTRAC

      subroutine ajoute_revap(ncas,cas,
     :    klon,izone,zxt,xtrevap_tag)
      implicit none

      ! ajoute xtrevap_tag (evaps des diffrents traceurs d'isotopes)
      ! dans la vapeur qui est tagge par la rvap des gouttes.

#include "wateriso2.h"
#include "iso_verif.h"
      ! input
      integer ncas
      integer cas(ncas)
      integer klon
      integer izone      
      real xtrevap_tag(ntraciso,ncas)

      ! inout
      real zxt(ntraciso,klon)

      ! local
      integer i,ixt,iiso,ixt_revap
#ifdef ISOVERIF      
      integer iso_verif_positif_choix_nostop
#endif          

#ifdef ISOVERIF
      do i=1,ncas
        do ixt=1,ntraciso
            call iso_verif_positif_choix(zxt(ixt,cas(i)),0.0,
     :                   'ajoute_revap 29')
        enddo
      enddo !do i=1,ncas
#endif    

      do i=1,ncas
         do iiso=1,niso
            ixt_revap=index_trac(izone_revap,iiso)
            do izone=1,ntraceurs_zone
               ixt=index_trac(izone,iiso)
               zxt(ixt_revap,cas(i))=zxt(ixt_revap,cas(i))
     :             +xtrevap_tag(ixt,i)
#ifdef ISOVERIF
               if (iso_verif_positif_choix_nostop(zxt(ixt_revap,cas(i)),
     :                   0.0,'ajoute_revap 46').eq.1) then
                  write(*,*) 'i,iiso,izone,ixt=',i,iiso,izone,ixt
                  write(*,*) 'xtrevap_tag(ixt,i)=',xtrevap_tag(ixt,i)
!                  stop
               endif
#endif               
               zxt(ixt_revap,cas(i))=max(0.0,zxt(ixt_revap,cas(i)))
            enddo !do izone=1,ntraceurs_zone
         enddo !do iiso=1,niso
      enddo !do i=1,ncas_evap_liq

#ifdef ISOVERIF
      do i=1,ncas
        do ixt=1,ntraciso
            call iso_verif_positif_choix(zxt(ixt,cas(i)),0.0,
     :                   'ajoute_revap 40')
        enddo
      enddo !do i=1,ncas
#endif      

      return
      end

      function is_in_bassin(lat,lon,bassin)
      implicit none
#include "wateriso2.h"
      ! rpond true si lat,lon se trouve dans le bassin numrot bassin

      ! input
      integer bassin
      real lat,lon

      ! outut
      logical is_in_bassin

      ! locals
      logical is_in_rectangle
      logical is_in_triangle
      
      is_in_bassin=.false.
#ifdef ISOVERIF      
      write(*,*) 'is_in_basin 84: entree,bassin=',bassin
#endif
      if ((use_bassin_atlantic.eq.1).and.
     :           (bassin.eq.bassin_atlantic)) then
#ifdef ISOVERIF           
          write(*,*) 'bassin Atlantique?'
#endif          
          if (is_in_rectangle(lon,lat,-67.0,28.0,20.0,-45.0)) then
            ! boite sud
            is_in_bassin=.true.
            return
          endif
          if (is_in_rectangle(lon,lat,-100.0,40.0,-5.3,28.0)) then
            ! ouest gibraltar    
            is_in_bassin=.true.
            return
          endif
          if (is_in_rectangle(lon,lat,-100.0,48.0,0.0,40.0)) then
            ! Ouest France
            is_in_bassin=.true.
            return
          endif 
          if (is_in_rectangle(lon,lat,-90.0,80.0,10.0,46.0)) then
            ! Atlantic Nord
            is_in_bassin=.true.
            return
          endif
          if (is_in_triangle(lon,lat,
     :           -62.0,0.0,-62.0,30.0,-112.0,30.0)) then
            ! golfe du Mexique
            is_in_bassin=.true.
            return
          endif

      else if ((use_bassin_medit.eq.1).and.
     :           (bassin.eq.bassin_medit)) then
#ifdef ISOVERIF           
          write(*,*) 'bassin Medit?'
#endif          
          if (is_in_rectangle(lon,lat,0.0,48.0,45.0,29.0)) then
            is_in_bassin=.true.
            return
          endif
          if (is_in_rectangle(lon,lat,-5.3,42.0,45.0,29.0)) then
            is_in_bassin=.true.
            return
          endif

      else if ((use_bassin_indian.eq.1).and.
     :           (bassin.eq.bassin_indian)) then
#ifdef ISOVERIF           
          write(*,*) 'bassin indian?'
#endif           
          if (is_in_rectangle(lon,lat,20.0,30.0,110.0,-45.0)) then
            is_in_bassin=.true.
            return
          endif
          if (is_in_triangle(lon,lat,
     :           90.0,30.0,90.0,-45.0,150.0,-45.0)) then
            ! Ouest Australie
            is_in_bassin=.true.
            return
          endif   

      else if ((use_bassin_indiansud.eq.1).and.
     :           (bassin.eq.bassin_indiansud)) then
#ifdef ISOVERIF           
          write(*,*) 'bassin indian hemisphere Sud?'
#endif           
          if (is_in_rectangle(lon,lat,20.0,0.0,120.0,-45.0)) then
            is_in_bassin=.true.
            return
          endif
          
      else if ((use_bassin_merarabie.eq.1).and.
     :           (bassin.eq.bassin_merarabie)) then
#ifdef ISOVERIF           
          write(*,*) 'bassin Mer d''Arabie?'
#endif           
          if (is_in_rectangle(lon,lat,20.0,30.0,76.0,0.0)) then
            is_in_bassin=.true.
            return
          endif 

      else if ((use_bassin_golfebengale.eq.1).and.
     :           (bassin.eq.bassin_golfebengale)) then
#ifdef ISOVERIF           
          write(*,*) 'bassin Golfe du Bengale?'
#endif           
          if (is_in_rectangle(lon,lat,76.0,30.0,110.0,0.0)) then
            is_in_bassin=.true.
            return
          endif         

      else if ((use_bassin_pacific.eq.1).and.
     :           (bassin.eq.bassin_pacific)) then
#ifdef ISOVERIF           
          write(*,*) 'bassin Pacific?'
#endif          
         if (is_in_rectangle(lon,lat,-180.0,80.0,-100.0,-45.0)) then
             ! pacifique Est
            is_in_bassin=.true.
            return
          endif
          if (is_in_rectangle(lon,lat,110.0,80.0,180.0,28.0)) then
            ! Pacifique Nord Ouest
            is_in_bassin=.true.
            return
          endif 
          if (is_in_rectangle(lon,lat,120.0,80.0,180.0,-45.0)) then
            ! Pacifique central Sud
            is_in_bassin=.true.
            return
          endif
          if (is_in_triangle(lon,lat,
     :            90.0,28.0,150.0,-45.0,150.0,28.0)) then
            ! Pacifque Sud Ouest
            is_in_bassin=.true.
            return
          endif
          if (is_in_triangle(lon,lat,
     :            -62.0,0.0,-112.0,30.0,-112.0,0.0)) then
            ! Ouest Amrique centrale
            is_in_bassin=.true.
            return
          endif
          if (is_in_rectangle(lon,lat,-180.0,0.0,-67.0,-45.0)) then
            ! Ouest Chili
            is_in_bassin=.true.
            return
          endif

      else if ((use_bassin_austral.eq.1).and.
     :           (bassin.eq.bassin_austral)) then  
#ifdef ISOVERIF           
          write(*,*) 'bassin austral?'
#endif           
          if (lat.lt.-45.0+0.2) then
                is_in_bassin=.true.
                return    
          endif  

      else if ((use_bassin_hauteslats.eq.1).and.
     :           (bassin.eq.bassin_hauteslats)) then  
#ifdef ISOVERIF           
          write(*,*) 'bassin hautes lats?'
#endif           
          if (abs(lat).gt.35.0) then
                is_in_bassin=.true.
                return    
          endif

      else if ((use_bassin_tropics.eq.1).and.
     :           (bassin.eq.bassin_tropics)) then  
#ifdef ISOVERIF           
          write(*,*) 'bassin tropics?'
#endif           
          if (abs(lat).lt.15.0) then
                is_in_bassin=.true.
                return    
          endif

       else if ((use_bassin_midlats.eq.1).and.
     :           (bassin.eq.bassin_midlats)) then  
#ifdef ISOVERIF           
          write(*,*) 'bassin mid lats?'
#endif           
          if ((abs(lat).ge.15.0).and.
     :           (abs(lat).le.35.0)) then
                is_in_bassin=.true.
                return    
          endif    

      else
          write(*,*) 'iso_traceurs_routines 59: bassin inconnu'
          write(*,*) 'bassin_atlantic=' ,bassin_atlantic  
          write(*,*) 'bassin_medit=' ,bassin_medit
          write(*,*) 'bassin_indian=' ,bassin_indian
          write(*,*) 'bassin_austral=' ,bassin_austral
          write(*,*) 'bassin_merarabie=' ,bassin_merarabie
          write(*,*) 'bassin_golfebengale=' ,bassin_golfebengale
          write(*,*) 'bassin_indiansud=' ,bassin_indiansud
          write(*,*) 'use_bassin_atlantic=' ,use_bassin_atlantic  
          write(*,*) 'use_bassin_medit=' ,use_bassin_medit
          write(*,*) 'use_bassin_indian=' ,use_bassin_indian
          write(*,*) 'use_bassin_austral=' ,use_bassin_austral
          write(*,*) 'use_bassin_merarabie=' ,use_bassin_merarabie
          write(*,*) 'use_bassin_golfebengale=' ,use_bassin_golfebengale
          write(*,*) 'use_bassin_indiansud=' ,use_bassin_indiansud
          stop
      endif
      
      return
      end

      subroutine find_bassin(lat,lon,bassin)
      implicit none

      ! inputs
      real lat,lon
      ! output
      integer bassin
      !locals
#include "wateriso2.h"
      logical continu
      logical is_in_bassin

      continu=.true.
      bassin=1
     
#ifdef ISOVERIF       
      write(*,*) ''
      write(*,*) 'find bassin lat,lon=',lat,lon
#endif       
      do while (continu)
!#ifdef ISOVERIF       
!!      write(*,*) 'find_bassin 169: lat,lon,bassin=',lat,lon,bassin
!#endif       
         if (is_in_bassin(lat,lon,bassin)) then
                continu=.false.
#ifdef ISOVERIF                 
                write(*,*) 'find_bassin 173: trouve: bassin=',bassin
#endif                 
         else
!#ifdef ISOVERIF              
!             write(*,*) 'find_bassin 175: pas trouve: bassin=',bassin
!#endif              
             bassin=bassin+1
         endif
         if (bassin.eq.izone_poubelle) then
                continu=.false.
                bassin=izone_poubelle
!#ifdef ISOVERIF                 
!                write(*,*) 'find_bassin 179: poubelle: bassin=',bassin
!#endif  
         endif
       enddo

       ! normalement, le bassin est soit un bassin oce, soit un rsidu
       ! donc bassin<=ntraceurs_zone-1
#ifdef ISOVERIF
       call iso_verif_positif(float(ntraceurs_zone-1-bassin),
     :           'find_bassin 195')
#endif

        return
        end

        subroutine bassin_map_init(lat,lon,bassin_map)
        USE dimphy
        implicit none

        INCLUDE "dimensions.h"   
        INCLUDE "paramet.h"        
        ! inputs
        real lat(klon),lon(klon)
        ! output
        integer bassin_map(klon)
        ! locals
        integer i
#ifdef ISOVERIF     
        logical write_gdat
        parameter (write_gdat=.false.)
        integer indiso,j 
        REAL chp2d(iip1,jjp1),bassin_real(klon)
#endif        

        do i=1,klon
             call find_bassin(lat(i),lon(i),bassin_map(i))
#ifdef ISOVERIF              
             write(*,*) 'init 233: i,lat,lon,bassin=',i,lat(i),lon(i),
     :            bassin_map(i)
#endif             
        enddo

#ifdef ISOVERIF  
        if (write_gdat) then
#include "debug_iso_bassin_map.h"
        write(*,*) 'bassin_map_init 215: stop temporaire'
        stop
        endif           
#endif        

        return
        end

        function is_in_rectangle(x,y,x1,y1,x2,y2)
        implicit none
        ! inputs 
        real x,y
        ! point en haut  gauche         
        real x1,y1
        ! point en bas  droite
        real x2,y2
        ! output
        logical is_in_rectangle

!#ifdef ISOVERIF        
!        write(*,*) 'is_in_rectange 237: x,y=',x,y
!        write(*,*) 'x1,y1,x2,y2=',x1,y1,x2,y2
!#endif        
        if ((x-x2.lt.0.1).and.(x-x1.gt.-0.1).and.
     :            (y-y1.lt.0.1).and.(y-y2.gt.-0.1)) then
          is_in_rectangle=.true.
        else
          is_in_rectangle=.false.
        endif
!#ifdef ISOVERIF        
!        write(*,*) 'is_in_rectangle=',is_in_rectangle
!#endif        
        return
        end

        function is_in_triangle(x,y,x1,y1,x2,y2,x3,y3)
        implicit none
        ! inputs
        real x,y
        ! points dans le sens trigo
        !  gauche
        real x1,y1
        ! en bas
        real x2,y2
        !  droite
        real x3,y3
        ! output
        logical is_in_triangle
        ! locals
        real det1
        real det2
        real det3
!#ifdef ISOVERIF
!        write(*,*) 'is_in_triange 271: x,y=',x,y
!        write(*,*) 'x1,y1,x2,y2,x3,y3=',x1,y1,x2,y2,x3,y3
!#endif        
        det1=(x1-x)*(y2-y)-(y1-y)*(x2-x)
        det2=(x2-x)*(y3-y)-(y2-y)*(x3-x)
        det3=(x3-x)*(y1-y)-(y3-y)*(x1-x)
        is_in_triangle=.false.
        if ((det1*det2.gt.0.0).and.(det2*det3.gt.0.0)) then
          is_in_triangle=.true.
        else
          is_in_triangle=.false.      
        endif
!#ifdef ISOVERIF        
!        write(*,*) 'det1,det2,det3,is_in_triangle',
!     :         det1,det2,det3,is_in_triangle
!#endif
        return
        end


        subroutine isotrac_recolorise_tmin(xt,t)
        USE dimphy
        implicit none

        INCLUDE "dimensions.h"  
        INCLUDE "paramet.h"    
#include "wateriso2.h"  

        ! inout
        real xt(ntraciso,klon,klev)
        ! input
        real t(klon,klev)
        ! locals
        integer izone_temp 
        integer ixt,ixt_recoit
        integer k,i,izone,iiso
        integer find_index
#ifdef ISOVERIF   
        logical write_gdat
        parameter (write_gdat=.true.)
        integer indiso,j 
        REAL chp3d(iip1,jjp1,klev)
        real xtstd(klon,klev)
        real xttrac(klon,klev,ntraceurs_zone)
#endif        

        do k=1,klev
          do i=1,klon
!#ifdef ISOVERIF
!            if (i.eq.1) then
!                write(*,*) 'recolorise 396: i,k,t=',i,k,t(i,k)
!                write(*,*) 'zone_temp=',zone_temp     
!            endif
!#endif           
            ! trouver la zone de cette temprature
            izone_temp=find_index(t(i,k),nzone_temp,zone_temp)

!#ifdef ISOVERIF
!            if (i.eq.1) then
!                write(*,*) 'recolorise 414: izone_temp=',izone_temp    
!            endif
!#endif            
            do izone=1,nzone_temp-1
               ! tous les tags de zone < nzone_temp se trouvant  des
               ! tempratures plus basses sont convertis
!#ifdef ISOVERIF
!            if (i.eq.1) then
!                write(*,*) 'recolorise 405: izone,xt_eau=',
!     :               izone,xt(index_trac(izone,iso_eau),i,k)  
!            endif
!#endif                 
               if (izone.lt.izone_temp) then                   
                  do iiso=1,niso
                   ixt=index_trac(izone,iiso) ! emmetteur
                   ixt_recoit=index_trac(izone_temp,iiso) ! recepteur
                   xt(ixt_recoit,i,k)=xt(ixt_recoit,i,k)+xt(ixt,i,k)
                   xt(ixt,i,k)=0.0 
                  enddo !do iiso=1,niso
               endif  !if (izone.lt.izone_temp) then
!#ifdef ISOVERIF
!            if (i.eq.1) then
!                write(*,*) 'recolorise 419: xt_eau,xt_recoit=',
!     :               xt(index_trac(izone,iso_eau),i,k),
!     :               xt(index_trac(izone_temp,iso_eau),i,k)
!            endif
!#endif                
            enddo !do izone=1,zone_pot(k)-1

            ! conversion de l'vap en surf et de la revap des gouttes
            do izone=nzone_temp+1,ntraceurs_zone 
              do iiso=1,niso 
                   ixt=index_trac(izone,iiso) ! emmetteur
                   ixt_recoit=index_trac(izone_temp,iiso) ! recepteur
                   xt(ixt_recoit,i,k)=xt(ixt_recoit,i,k)+xt(ixt,i,k)
                   xt(ixt,i,k)=0.0           
              enddo !do iiso=1,niso 
            enddo !do izone=nzone_temp+1,ntraceurs_zone 
          enddo !do i=1,klon
        enddo !do k=1,klev

#ifdef ISOVERIF
        do k=1,klev
          do i=1,klon
            call iso_verif_traceur(xt(1,i,k),'recolorise 403')
          enddo !do i=1,klon
        enddo !do k=1,klev
        if (write_gdat) then
#include "debug_iso_recolorise_temperature_min.h" 
!        write(*,*) 'recolorise 428: stop temporaire'
!        stop           
        endif !if (write_gdat) then    
#endif

        return
        end

        subroutine isotrac_recolorise_tmin_sfrev(xt,t)
        USE dimphy
        implicit none

        ! recolorise selon la temprature minimum, mais les tags de
        ! revap sont laisss en revap

        INCLUDE "dimensions.h"  
        INCLUDE "paramet.h"    
#include "wateriso2.h"  

        ! inout
        real xt(ntraciso,klon,klev)
        ! input
        real t(klon,klev)
        ! locals
        integer izone_temp 
        integer ixt,ixt_recoit
        integer k,i,izone,iiso
        integer find_index
#ifdef ISOVERIF   
        logical write_gdat
        parameter (write_gdat=.false.)
        integer indiso,j
        REAL chp3d(iip1,jjp1,klev)
        real xtstd(klon,klev)
        real xttrac(klon,klev,ntraceurs_zone)
#endif        

        do k=1,klev
          do i=1,klon
            ! trouver la zone de cette temprature
            izone_temp=find_index(t(i,k),nzone_temp,zone_temp)

            do izone=1,nzone_temp-1
               ! tous les tags de zone < nzone_temp se trouvant  des
               ! tempratures plus basses sont convertis
               ! sauf la revap
               ! le tag de la revap est nzone_temp+1=ntraceurs_zone
               if (izone.lt.izone_temp) then                   
                  do iiso=1,niso
                   ixt=index_trac(izone,iiso) ! emmetteur
                   ixt_recoit=index_trac(izone_temp,iiso) ! recepteur
                   xt(ixt_recoit,i,k)=xt(ixt_recoit,i,k)+xt(ixt,i,k)
                   xt(ixt,i,k)=0.0 
                  enddo !do iiso=1,niso
               endif  !if (izone.lt.izone_temp) then
            enddo !do izone=1,zone_pot(k)-1

          enddo !do i=1,klon
        enddo !do k=1,klev

#ifdef ISOVERIF
        do k=1,klev
          do i=1,klon
            call iso_verif_traceur(xt(1,i,k),'recolorise 594')
          enddo !do i=1,klon
        enddo !do k=1,klev
        if (write_gdat) then
#include "debug_iso_recolorise_temperature_min.h"  
        write(*,*) 'recolorise 428: stop temporaire'
        stop          
        endif

#endif

        return
        end


        subroutine isotrac_recolorise_saturation(xt,rh,lat,pres)
        USE dimphy
        implicit none

        ! recolorise selon la temprature minimum, mais les tags de
        ! revap sont laisss en revap

        INCLUDE "dimensions.h"  
        INCLUDE "paramet.h"    
#include "wateriso2.h" 

        ! inout
        real xt(ntraciso,klon,klev)
        ! input
        real rh(klon,klev)
        real lat(klon)
        real pres(klev)
        ! locals
        integer izone_recoit
        integer ixt,ixt_recoit
        integer k,i,izone,iiso
        logical continu
        real rh_seuil
        parameter (rh_seuil=0.90)
        integer index_zone_latpres
#ifdef ISOVERIF      
        logical write_gdat
        parameter (write_gdat=.true.)
        integer indiso,j 
        REAL chp3d(iip1,jjp1,klev)
        real xtstd(klon,klev)
        real xttrac(klon,klev,ntraceurs_zone)
#endif       

#ifdef ISOVERIF
        do k=1,klev
          do i=1,klon
            call iso_verif_traceur(xt(1,i,k),'recolorise 612')
          enddo !do i=1,klon
        enddo !do k=1,klev        
#endif

        ! on ne sature pas les 2 premires couches: on les laisse se
        ! recharger en evap de surface
        do k=3,klev
          do i=1,klon
            if (rh(i,k).gt.rh_seuil) then
                izone_recoit=index_zone_latpres(lat(i),pres(k))
                do izone=1,ntraceurs_zone
                 if (izone.ne.izone_recoit) then
                  do iiso=1,niso
                   ixt=index_trac(izone,iiso) ! emmetteur
                   ixt_recoit=index_trac(izone_recoit,iiso) ! recepteur
                   xt(ixt_recoit,i,k)=xt(ixt_recoit,i,k)+xt(ixt,i,k)
                   xt(ixt,i,k)=0.0 
                  enddo !do iiso=1,niso
                 endif
                enddo !do izone=1,ntraceurs_zone
            endif !if (rh(i,k).gt.rh_seuil) then
          enddo !do i=1,klon
        enddo !do k=1,klev

#ifdef ISOVERIF
        do k=1,klev
          do i=1,klon
            call iso_verif_traceur(xt(1,i,k),'recolorise 637')
          enddo !do i=1,klon
        enddo !do k=1,klev
        if (write_gdat) then
#include "debug_iso_recolorise_saturation.h" 
        write(*,*) 'recolorise 667: stop temporaire'
        stop
        endif
        
#endif

        return
        end

        subroutine isotrac_recolorise_boite(xt,boite_map)
        USE dimphy
        implicit none

        ! subroutine crite  la base pour tagguer 3 boites AMMA.
        ! Mais a peut tre gnrique, selon comment est initialise boite_map

        INCLUDE "dimensions.h"  
        INCLUDE "paramet.h"    
#include "wateriso2.h"  

        ! inout
        real xt(ntraciso,klon,klev)
        ! input
        integer boite_map(klon,klev)
        ! locals
        integer i,k
        integer izone_recoit,izone,iiso
        integer ixt,ixt_recoit
        
        do k=1,klev
          do i=1,klon
            izone_recoit=boite_map(i,k)
            if (izone_recoit.gt.0) then
                ! on est dans une boite connue
                ! toutes les molcules sont converties en cete couleur
               do izone=1,ntraceurs_zone
                  if (izone.ne.izone_recoit) then
                      ! on met les traceurs izone dans izone_recoit
                      do iiso=1,niso
                        ixt=index_trac(izone,iiso)
                        ixt_recoit=index_trac(izone_recoit,iiso)
                        xt(ixt_recoit,i,k)=xt(ixt_recoit,i,k)
     :                         +xt(ixt,i,k)
                        xt(ixt,i,k)=0.0
                      enddo
                  endif !if (izone.ne.izone_recoit) then
               enddo !do izone=2,ntraceurs_zone
            endif !if (izone_recoit.gt.0) then
          enddo !do i=1,klon
        enddo !do k=1,klev

#ifdef ISOVERIF
        do k=1,klev
          do i=1,klon
            call iso_verif_traceur(xt(1,i,k),'recolorise 514')
          enddo !do i=1,klon
        enddo !do k=1,klev
#endif

        return
        end

        subroutine isotrac_recolorise_extra(xt,rlat)
        USE dimphy
        implicit none

        ! subroutine crite pour l'option de taggage 20
        ! permet de retagguer la vapeur tropicale en vapeur
        ! extratropicale ds qu'elle atteint 35 de latitude

        INCLUDE "dimensions.h"  
        INCLUDE "paramet.h"    
#include "wateriso2.h"   

        ! inout
        real xt(ntraciso,klon,klev)
        ! input
        real rlat(klon)
        ! locals
        integer i,k
        integer iiso,ixt,ixt_recoit
       
!        write(*,*) 'iso_traceurs_routines 723: lim_tag20=',lim_tag20
        do k=1,klev
          do i=1,klon
            if (abs(rlat(i)).gt.lim_tag20) then
                ! on met les traceurs izone_trop dans izone_extra
                do iiso=1,niso
                    ixt=index_trac(izone_trop,iiso)
                    ixt_recoit=index_trac(izone_extra,iiso)
                        xt(ixt_recoit,i,k)=xt(ixt_recoit,i,k)
     :                         +xt(ixt,i,k)
                        xt(ixt,i,k)=0.0
                 enddo                  
            endif ! if (abs(rlat(i)).lt.35.0) then
          enddo !do i=1,klon
        enddo !do k=1,klev

#ifdef ISOVERIF
        do k=1,klev
          do i=1,klon
            call iso_verif_traceur(xt(1,i,k),'recolorise 741')
          enddo !do i=1,klon
        enddo !do k=1,klev
#endif

        return
        end

        subroutine isotrac_recolorise_conv(xt,rlat,presnivs,rain_con)
        USE dimphy
        implicit none

        ! subroutine crite pour l'option de taggage 20
        ! permet de retagguer la vapeur tropicale en vapeur
        ! extratropicale ds qu'elle atteint 35 de latitude

        INCLUDE "dimensions.h"  
        INCLUDE "paramet.h"    
#include "wateriso2.h"  

        ! inout
        real xt(ntraciso,klon,klev)
        ! input
        real rlat(klon)
        real presnivs(klev)
        real rain_con(klon)
        ! locals
        integer i,k
        integer iiso,ixt,ixt_recoit,izone
       
!        write(*,*) 'iso_traceurs_routines 723: lim_tag20=',lim_tag20
!        write(*,*) 'presnivs=',presnivs
!        stop
        do k=1,klev
          do i=1,klon
#ifdef ISOVERIF
          if ((abs(rlat(i)).lt.30.0).and.(k.eq.1)) then
!            write(*,*) 'i,rain_con*86400,lim_precip_tag22=',
!     :            i,rain_con(i)*86400,lim_precip_tag22
          endif
#endif          
            if ((abs(rlat(i)).lt.30.0).and.
     :            (rain_con(i)*86400.gt.lim_precip_tag22)) then
            
                ! on met les traceurs izone_trop dans izone_conv fn z                
                do iiso=1,niso
                  if (presnivs(k).gt.650.0*100.0) then
                    ixt_recoit=index_trac(izone_conv_BT,iiso) 
                  else
                    ixt_recoit=index_trac(izone_conv_UT,iiso) 
                  endif
                  do izone=1,ntraceurs_zone
                    ixt=index_trac(izone,iiso)
                    if (ixt.ne.ixt_recoit) then                    
                        xt(ixt_recoit,i,k)=xt(ixt_recoit,i,k)
     :                         +xt(ixt,i,k)
                        xt(ixt,i,k)=0.0
                    endif !if (ixt.ne.ixt_recoit) then
                  enddo !do izone=1,ntraceurs_zone
                enddo !do iiso=1,niso
!                write(*,*) 'k,presnivs,ixt,ixt_recoit=',k,presnivs(k),
!     :                   ixt,ixt_recoit
!                write(*,*) 'xt(:,i,k)=',xt(:,i,k)
            endif ! if (abs(rlat(i)).lt.35.0) then
          enddo !do i=1,klon
        enddo !do k=1,klev

#ifdef ISOVERIF
        do k=1,klev
          do i=1,klon
            call iso_verif_traceur(xt(1,i,k),'recolorise 741')
          enddo !do i=1,klon
        enddo !do k=1,klev
#endif

        return
        end


        subroutine boite_AMMA_init(lat,lon,presnivs,boite_map)
        USE dimphy
        implicit none

        INCLUDE "dimensions.h"  
        INCLUDE "paramet.h"    
#include "wateriso2.h"          
        real lat(klon),lon(klon)
        real presnivs(klev)
        ! output
        integer boite_map(klon,klev)
        ! locals
        integer i,k
#ifdef ISOVERIF          
        logical write_gdat
        parameter (write_gdat=.false.)
        integer indiso,j 
        REAL chp3d(iip1,jjp1,klev),boite_real(klon,klev)
#endif         

!        write(*,*) 'izone_aej,izone_mousson,izone_harmattan=',
!     :       izone_aej,izone_mousson,izone_harmattan    
        do k=1,klev
          do i=1,klon
                boite_map(i,k)=0.0
!                write(*,*) 'i,k,lat,lon,pres=',
!     :                   i,k,lat(i),lon(i),presnivs(k)
                if ((presnivs(k).le.700.0*100.0).and.
     :              (presnivs(k).gt.400.0*100.0).and.
     :              (lat(i).gt.8.0).and.
     :              (lat(i).lt.20.0).and.
     :              (lon(i).gt.10.0).and.
     :              (lon(i).lt.30.0)) then
                   boite_map(i,k)=izone_aej
!                   write(*,*) '   -> zone AEJ'
                else if (
     :              (presnivs(k).ge.850.0*100.0).and.
     :              (lat(i).gt.-5.0).and.
     :              (lat(i).le.8.0).and.
     :              (lon(i).gt.-40.0).and.
     :              (lon(i).lt.15.0)) then
                   boite_map(i,k)=izone_mousson
!                   write(*,*) '   -> zone flux de mousson'
                else if (
     :              (presnivs(k).gt.700.0*100.0).and.
     :              (lat(i).ge.20.0).and.
     :              (lat(i).lt.30.0).and.
     :              (lon(i).gt.-10.0).and.
     :              (lon(i).lt.40.0)) then
                   boite_map(i,k)=izone_harmattan
!                   write(*,*) '   -> zone Harmattan'
                endif
!                write(*,*) '   ** boite_map=',boite_map(i,k)
          enddo
        enddo

#ifdef ISOVERIF  
        if (write_gdat) then
#include "debug_iso_boite_map.h"   
        write(*,*) 'boite_map_init 569: stop temporaire'
        stop         
        endif                   
#endif   
        return
        end

        
        subroutine boite_UT_extra_init(lat,lon,presnivs,boite_map)
        USE dimphy
        implicit none

        INCLUDE "dimensions.h"  
        INCLUDE "paramet.h"    
#include "wateriso2.h"           
        real lat(klon),lon(klon)
        real presnivs(klev)
        ! output
        integer boite_map(klon,klev)
        ! locals
        integer i,k
#ifdef ISOVERIF          
        logical write_gdat
        parameter (write_gdat=.false.)
        integer indiso,j 
        REAL chp3d(iip1,jjp1,klev),boite_real(klon,klev)
#endif         

!        write(*,*) 'izone_trop,izone_extra=',
!     :       izone_trop,izone_extra    
        do k=1,klev
          do i=1,klon
                boite_map(i,k)=0.0
!                write(*,*) 'i,k,lat,lon,pres=',
!     :                   i,k,lat(i),lon(i),presnivs(k)
                if ((presnivs(k).le.500.0*100.0)
     :              .and.(abs(lat(i)).lt.15.0)) then
                   boite_map(i,k)=izone_trop
!                   write(*,*) '   -> zone trop'
                else if (abs(lat(i)).gt.35.0) then
                   boite_map(i,k)=izone_extra
!                   write(*,*) '   -> zone extratropiques'
                endif
!                write(*,*) '   ** boite_map=',boite_map(i,k)
          enddo
        enddo

#ifdef ISOVERIF  
        if (write_gdat) then
#include "debug_iso_boite_map.h"   
        write(*,*) 'boite_map_init 906: stop temporaire'
        stop         
        endif                   
#endif   
        return
        end


        function index_zone_lat(lat)
        implicit none
#include "wateriso2.h"          

        ! inputs
        real lat,pres
        ! output 
        integer index_zone_lat

        if (lat.lt.lattag_min) then
                index_zone_lat=1
        else
                index_zone_lat=int((lat-lattag_min)/dlattag)+2
                index_zone_lat=min(index_zone_lat,nzone_lat)
        endif

        return
        end


        function index_zone_pres(pres)
        implicit none
#include "wateriso2.h"          

        ! inputs
        real lat,pres
        ! output 
        integer index_zone_pres
        integer find_index

        
        index_zone_pres=find_index(pres,nzone_pres,zone_pres) 
        write(*,*) 'iso_traceurs_routines 802: pres,index_zone_pres=',
     :           pres,index_zone_pres
        write(*,*) 'zone_pres=',zone_pres(1:nzone_pres-1)

        return
        end

        function find_index(pres,nzone_pres,zone_pres)
        implicit none

        ! inputs
        real pres
        integer nzone_pres
        real zone_pres(nzone_pres)
        ! output 
        integer find_index
        logical continu

        if (nzone_pres.gt.1) then
          if (pres.ge.zone_pres(1)) then
                find_index=1
          else if (pres.lt.zone_pres(nzone_pres-1)) then
                find_index=nzone_pres
          else !if (t(i,k).ge.zone_temp1) then
                continu=.true.
                find_index=2
                do while (continu)
                  if (pres.ge.zone_pres(find_index)) then
                     continu=.false. 
                     ! c'est izone_temp, zone trouve
                  else   
                     find_index=find_index+1
                  endif     
                enddo !do while (continu)
           endif !if (t(i,k).ge.zone_temp1) then

        else !if (nzone_pres.gt.1) then
            find_index=1
        endif !if (nzone_pres.gt.1) then

        return
        end

        function index_zone_latpres(lat,pres)
        implicit none
#include "wateriso2.h"          

        ! inputs
        real lat,pres
        ! output 
        integer index_zone_latpres
        ! locals
        integer index_lat
        integer index_pres
        integer index_zone_lat
        integer index_zone_pres

        index_lat=index_zone_lat(lat)
        index_pres=index_zone_pres(pres)
        index_zone_latpres=index_lat+(index_pres-1)*nzone_lat

        return
        end

        subroutine iso_recolorise_condensation(qt,cond,
     :           xt,zxtcond,tcond,ep,xtres,
     :           seuil_in)
        USE dimphy
        implicit none

        ! on recolorise la vapeur rsiduelle selon la temprature de condensation
        ! on supose qu'une vapeur xt,q condense en cond,zxtcond,  une
        ! temprature tcond. A ce stade, la vapeur initiale n'est pas
        ! retranche de son condensat. On calcule les tags dans la vepru
        ! rsiduelle xtres qu'on aurait si on retranchait un fraction ep du
        ! condensat

        INCLUDE "dimensions.h"  
        INCLUDE "paramet.h"    
#include "wateriso2.h"   

        ! inputs
        real qt
        real cond
        real tcond
        real ep
        real xt(ntraciso)
        real zxtcond(ntraciso)
        real seuil_in
        ! outputs
        real xtres(ntraciso)
        ! locals
        integer izone_temp,izone 
        integer ixt,ixt_recoit
        integer iiso
        integer find_index
        real fcond, qmicro
#ifdef ISOVERIFIDRIS
        integer iso_verif_traceur_jm_nostop
        integer iso_verif_tag17_q_deltaD_chns
#endif
!        real f

        if ((cond.gt.0.0).and.(qt.gt.0.0)) then        

            izone_temp=find_index(tcond,nzone_temp,zone_temp)
!            WRITE(*,*) 'pgm 901 tmp: izone_temp=',izone_temp    
#ifdef ISOVERIF
           do ixt=1,ntraciso
              call iso_verif_positif(xt(ixt)-zxtcond(ixt),
     :           'iso_trac 898')
           enddo  !do ixt=1,ntraciso  
           call iso_verif_traceur_justmass(xt,
     :          'iso_trac_routines 906')                
           call iso_verif_traceur_justmass(zxtcond,
     :          'iso_trac_routines 908')
#endif           
          ! bidouille
          if (bidouille_anti_divergence) then
              call iso_verif_traceur_jbidouille(xt)
              call iso_verif_traceur_jbidouille(zxtcond)  
          endif 

          do ixt=1,niso
            xtres(ixt)=xt(ixt)-ep*zxtcond(ixt)
          enddo
          do ixt=1+niso,ntraciso
            xtres(ixt)=0.0
          enddo
!          write(*,*) 'iso_trac_routines tmp 916: xtres=',xtres

#ifdef ISOVERIF 
        do ixt=1,ntraciso
          call iso_verif_positif(xtres(ixt),
     :              'iso_trac_routines 921')
        enddo
#endif          

             ! cas de izone sfc et izone precip et izone cond et izone< izone_temp

!             write(*,*) 'iso_trac 940: cond/qt,seuil_in,izone_temp=',
!     :                   cond/qt,seuil_in,izone_temp

             if (option_seuil_tag_tmin.eq.2) then
                 qmicro=0.0
                 do izone=nzone_temp+1,ntraceurs_zone 
                   ixt= index_trac(izone,iso_eau)  
                   qmicro=qmicro+xt(ixt)
                 enddo !do izone=nzone_temp+1,ntraceurs_zone
                 if (qt-qmicro.gt.0.0) then 
                     fcond=(cond-qmicro)/(qt-qmicro)
                 else
                     fcond=0.0   
                 endif
             else
                 fcond=cond/qt
             endif
       
             if (fcond.gt.seuil_in) then

             ! on les transfert  izone_temp
             do izone=1,ntraceurs_zone
               if ((izone.gt.nzone_temp).or.(izone.lt.izone_temp)) then
!                 ieau=index_trac(izone,iso_eau)
                 do iiso=1,niso  
                   ixt= index_trac(izone,iiso)    
                   ixt_recoit=index_trac(izone_temp,iiso) ! recepteur                 
                   xtres(ixt_recoit)=xtres(ixt_recoit)
     :                   +(xt(ixt)-zxtcond(ixt))
                   xtres(ixt)=0.0   
!                   write(*,*) 'iso_trac 920: izone,ixt,',
!     :                 'ixt_recoit=',
!     :                 izone,ixt,ixt_recoit     
!                   write(*,*) 'isotrac 924: xt=',xt
!                   write(*,*) 'isotrac 925: zxtcond=',zxtcond
                 enddo !do iiso=1,niso
!                 write(*,*) 'iso_trac tmp 944: izone,xtres=',izone,xtres
                endif !if (izone.ne.izone_cond) then  
              enddo !do izone=nzones_temp+1,ntraceurs_zone

             else !if (cond/qt.gt.seuil_in) then
                
                ! on les laisse sur place
               do izone=1,ntraceurs_zone
                if ((izone.gt.nzone_temp).or.(izone.lt.izone_temp)) then
                 do iiso=1,niso  
                   ixt= index_trac(izone,iiso)    
                   xtres(ixt)=(xt(ixt)-zxtcond(ixt))
                 enddo !do iiso=1,niso
                endif !if (izone.ne.izone_cond) then  
               enddo !do izone=nzones_temp+1,ntraceurs_zone

             endif !if (cond/qt.gt.seuil_in) then

              ! izone_temp est conserv, on lui enlve juste son
              ! condesat
              do iiso=1,niso  
                   ixt_recoit=index_trac(izone_temp,iiso) ! recepteur                 
                   xtres(ixt_recoit)=xtres(ixt_recoit)
     :                   +(xt(ixt_recoit)-zxtcond(ixt_recoit))
              enddo !do iiso=1,niso  

#ifdef ISOVERIF 
        do ixt=1,ntraciso
          call iso_verif_positif(xtres(ixt),
     :              'iso_trac_routines 940')
        enddo
#endif

             ! cas des zones > izone temp
             ! on conserve le condensat rsiduel
             do izone=izone_temp+1,nzone_temp   
               do iiso=1,niso
                   ixt= index_trac(izone,iiso)
                   xtres(ixt)=xt(ixt)-zxtcond(ixt)
!                   write(*,*) 'iso_trac 931: izone,ixt,ixt_recoit=',
!     :                 izone,ixt,ixt_recoit       
!                   write(*,*) 'isotrac 934: xt=',xt
!                   write(*,*) 'isotrac 935: zxtice=',zxtice
               enddo !do iiso=1,niso  
!               write(*,*) 'iso_trac tmp 965: izone,xtres=',izone,xtres
             enddo !do izone=izone_temp+1,nzones_temp

             ! on rajoute le condensat qui ne precipite pas
             if (ep.lt.1.0) then
               do iiso=1,niso    
                   ixt= index_trac(izone_cond,iiso) 
                   xtres(ixt)=xtres(ixt)+(1.0-ep)*zxtcond(iiso)
!                   write(*,*) 'iso_trac 940: izone,ixt,ixt_recoit=',
!     :                 izone,ixt,ixt_recoit     
!                   write(*,*) 'isotrac 1014: xt=',xt
!                   write(*,*) 'isotrac 945: zxtice=',zxtice
                enddo  !do iiso=1,niso      
            endif !if (ep.lt.0.0) then

        else
            ! si cond=0 ou qt=0, tot reste pareil
           do ixt=1,ntraciso
                xtres(ixt)=xt(ixt)
           enddo  !do ixt=1,ntraciso     

        endif ! if (qt.gt.0.0) then    

#ifdef ISOVERIFIDRIS
        if (iso_verif_traceur_jm_nostop(xtres,
     :          'iso_trac_routines 166').eq.1) then
          write(*,*) 'isotrac 1024: xt=',xt
          write(*,*) 'zxtcond=',zxtcond
          write(*,*) 'xtres=',xtres
          write(*,*) 'ep=',ep
          stop
        endif 
#endif          
#ifdef ISOVERIF              
        do ixt=1,ntraciso
          call iso_verif_positif(xtres(ixt),
     :              'iso_trac_routines 953')
        enddo
        if (nzone_temp.ge.5) then
        if (iso_verif_tag17_q_deltaD_chns(xtres,
     :           'iso_trac_routines 1025').eq.1) then
            write(*,*) 'xt=',xt
            write(*,*) 'zxtcond=',zxtcond
            write(*,*) 'xtres=',xtres
            write(*,*) 'ep=',ep
            write(*,*) 'tcond=',tcond
            write(*,*) 'izone_temp=',izone_temp
            stop
        endif
        endif
!       write(*,*) 'isotrac 1048: sortie de iso_recolorise_condensation'
#endif

            return
            end

        subroutine bassin_map_init_opt20(lat,bassin_map)
        USE dimphy
        implicit none

        INCLUDE "dimensions.h"  
        INCLUDE "paramet.h"    
#include "wateriso2.h"
        ! inputs
        real lat(klon)
        ! output
        integer bassin_map(klon)
        ! locals
        integer i
#ifdef ISOVERIF            
        logical write_gdat
        parameter (write_gdat=.false.)
        integer indiso,j 
        REAL chp2d(iip1,jjp1),bassin_real(klon)
#endif        

        write(*,*) 'iso_traceurs_routines 1142: lim_tag20=',lim_tag20
        do i=1,klon
         if (abs(lat(i)).gt.lim_tag20) then   
             bassin_map(i)=izone_cont
         else  
             bassin_map(i)=izone_trop
         endif
        enddo !do i=1,klon
        
#ifdef ISOVERIF  
        write(*,*) 'bassin_map_init 1151: bassin_map(1:klon:10)=',
     :            bassin_map(1:klon:10)
        if (write_gdat) then
#include "debug_iso_bassin_map.h"
        write(*,*) 'bassin_map_init 1154: stop temporaire'
        stop
        endif           
#endif        

        return
        end

#endif
! # endif isotrac

