! subroutines gnriques  ne pas modifier sauf si changement
! architecture traceurs

#ifdef ISO
#ifdef ISOTRAC

      function iso_verif_traceur_choix_nostop(x,err_msg,
     :       errmax,errmaxrel,ridicule_trac,deltalimtrac)
        implicit none
        ! vrifier des choses sur les traceurs
        ! * toutes les zones donne t l'istope total
        ! * pas de deltaD aberrant
       
#include "wateriso2.h"
!#include "iso_verif.h"  ! dj en argument     
       ! inputs
       real x(ntraciso)
       character*(*) err_msg ! message d''erreur  afficher
       real errmax,errmaxrel,ridicule_trac,deltalimtrac

       ! output
       integer iso_verif_traceur_choix_nostop

       ! locals
       integer iso_verif_traceur_noNaN_nostop 
       integer iso_verif_tracm_choix_nostop
       integer iso_verif_tracdD_choix_nostop
       integer iso_verif_tracpos_choix_nostop

        iso_verif_traceur_choix_nostop=0  

        ! verif noNaN
        if (iso_verif_traceur_noNaN_nostop(x,err_msg).eq.1) then
             iso_verif_traceur_choix_nostop=1
        endif 
        
        ! verif masse
        if (iso_verif_tracm_choix_nostop(x,err_msg,
     :           errmax,errmaxrel).eq.1) then
             iso_verif_traceur_choix_nostop=1
        endif              

        ! verif deltaD
        if (use_iso_HDO.eq.1) then
        if (iso_verif_tracdD_choix_nostop(x,err_msg,
     :           ridicule_trac,deltalimtrac).eq.1) then
             iso_verif_traceur_choix_nostop=1
        endif  
        endif !if (use_iso_HDO.eq.1) then  

        ! verif pas aberramment negatif
        if (iso_verif_tracpos_choix_nostop(x,err_msg,
     :           1e-5).eq.1) then
             iso_verif_traceur_choix_nostop=1
        endif 

        return
        end

        function iso_verif_tracnps_choix_nostop(x,err_msg,
     :       errmax,errmaxrel,ridicule_trac,deltalimtrac)
        implicit none
        ! vrifier des choses sur les traceurs
        ! * toutes les zones donne t l'istope total
        ! * pas de deltaD aberrant
        ! on ne vrfie pas la positivit
       
#include "wateriso2.h"
!#include "iso_verif.h"  ! dj en argument     
       ! inputs
       real x(ntraciso)
       character*(*) err_msg ! message d''erreur  afficher
       real errmax,errmaxrel,ridicule_trac,deltalimtrac

       ! output
       integer iso_verif_tracnps_choix_nostop

       ! locals
       integer iso_verif_traceur_noNaN_nostop 
       integer iso_verif_tracm_choix_nostop
       integer iso_verif_tracdD_choix_nostop

        iso_verif_tracnps_choix_nostop=0  

        ! verif noNaN
        if (iso_verif_traceur_noNaN_nostop(x,err_msg).eq.1) then
             iso_verif_tracnps_choix_nostop=1
        endif 
        
        ! verif masse
        if (iso_verif_tracm_choix_nostop(x,err_msg,
     :           errmax,errmaxrel).eq.1) then
             iso_verif_tracnps_choix_nostop=1
        endif              

        ! verif deltaD
        if (use_iso_HDO.eq.1) then
        if (iso_verif_tracdD_choix_nostop(x,err_msg,
     :           ridicule_trac,deltalimtrac).eq.1) then
             iso_verif_tracnps_choix_nostop=1
        endif   
        endif ! if (use_iso_HDO.eq.1) then  

        return
        end

        function iso_verif_tracpos_choix_nostop(x,err_msg,seuil)
        implicit none
#include "wateriso2.h"
        ! inputs
       real x(ntraciso)
       character*(*) err_msg ! message d''erreur  afficher
       real seuil

       ! output
       integer iso_verif_tracpos_choix_nostop

       ! locals
       integer lnblnk
       integer iiso,ixt
       integer iso_verif_positif_choix_nostop

       iso_verif_tracpos_choix_nostop=0

       do ixt=niso+1,ntraciso
          iiso=index_iso(ixt)
          if (iso_verif_positif_choix_nostop(x(ixt),seuil,err_msg//
     :           ', verif positif, iso'//striso(iiso)
     :           //strtrac(index_zone(ixt))).eq.1) then
            iso_verif_tracpos_choix_nostop=1
          endif
        enddo

        return
        end


        function iso_verif_traceur_noNaN_nostop(x,err_msg)
        implicit none

        ! on vrifie juste que pas NaN
#include "wateriso2.h"
        ! inputs
       real x(ntraciso)
       character*(*) err_msg ! message d''erreur  afficher

       ! output
       integer iso_verif_traceur_noNaN_nostop

       ! locals
       integer lnblnk
       integer iiso,ixt
       integer iso_verif_nonaN_nostop

       iso_verif_traceur_noNaN_nostop=0

        do ixt=niso+1,ntraciso
          iiso=index_iso(ixt)
!          write(*,*) 'iso_verif_traceurs 154: iiso,ixt=',iiso,ixt
          if (iso_verif_noNaN_nostop(x(ixt),err_msg//
     :           ', verif trac no NaN, iso'//striso(iiso))
     :           .eq.1) then
            iso_verif_traceur_noNaN_nostop=1
          endif
        enddo

        return
        end

        function iso_verif_tracm_choix_nostop(x,err_msg,
     :           errmaxin,errmaxrelin)

        ! on vrifie juste bilan de masse
        implicit none
#include "wateriso2.h"
        ! inputs
        real x(ntraciso)
        character*(*) err_msg ! message d''erreur  afficher
        real errmaxin,errmaxrelin

        ! output
        integer iso_verif_tracm_choix_nostop

       ! locals
       integer iso_verif_egalite_choix_nostop
       integer iiso,izone,ixt
       real xtractot
#include "iso_verif.h"

       iso_verif_tracm_choix_nostop=0

        do iiso=1,niso

          xtractot=0.0
          do izone=1,ntraceurs_zone  
            ixt=index_trac(izone,iiso) 
            xtractot=xtractot+x(ixt)
          enddo !do izone=1,ntraceurs_zone

          if (iso_verif_egalite_choix_nostop(xtractot,x(iiso),
     :        err_msg//', verif trac egalite, iso '//striso(iiso),
     :        errmaxin,errmaxrelin).eq.1) then
            write(*,*) 'iso_verif_traceur 202: x=',x
!            write(*,*) 'xtractot=',xtractot
            iso_verif_tracm_choix_nostop=1
          endif

          ! verif ajoute le 19 fev 2011
          if ((abs(xtractot).lt.ridicule**2).and.
     :           (abs(x(iiso)).gt.ridicule)) then
            write(*,*) err_msg,', verif masse traceurs, iso ',
     :          striso(iiso)
            write(*,*) 'iso_verif_traceur 209: x=',x
!            iso_verif_tracm_choix_nostop=1
          endif

        enddo !do iiso=1,ntraceurs_iso  

        return
        end

        function iso_verif_tracdD_choix_nostop(x,err_msg,
     :           ridicule_trac,deltalimtrac)

        ! on vrifie juste deltaD
        implicit none
#include "wateriso2.h"
        ! inputs
        real x(ntraciso)
        character*(*) err_msg ! message d''erreur  afficher
        real ridicule_trac,deltalimtrac

        ! output
        integer iso_verif_tracdD_choix_nostop        

       ! locals
       integer izone,ieau,ixt
       integer iso_verif_aberrant_choix_nostop

        iso_verif_tracdD_choix_nostop=0

        if ((use_iso_eau.eq.1).and.(use_iso_HDO.eq.1)) then
        do izone=1,ntraceurs_zone
             ieau=index_trac(izone,iso_eau)
             ixt=index_trac(izone,iso_HDO)

             if (iso_verif_aberrant_choix_nostop(x(ixt),x(ieau),
     :           ridicule_trac,deltalimtrac,err_msg//
     :           ', verif trac no aberrant zone '//strtrac(izone))
     :           .eq.1) then
               iso_verif_tracdD_choix_nostop=1
             endif
!             if (x(ieau).gt.ridicule) then
!              call iso_verif_aberrant(x(ixt)/x(ieau),
!     :           err_msg//', verif trac no aberrant zone '
!     :           //strtrac(izone))
!             endif
        enddo !do izone=1,ntraceurs_zone
       endif ! if ((use_iso_eau.eq.1).and.(use_iso_HDO.eq.1)) then

       return
       end

       subroutine iso_verif_trac17_q_deltaD(x,err_msg)
       implicit none

#include "wateriso2.h"
#include "iso_verif.h"      

        ! inputs
        real x(ntraciso)
        character*(*) err_msg
        ! local 
        integer iso_verif_tag17_q_deltaD_chns

       if ((option_traceurs.eq.17).or.
     :           (option_traceurs.eq.18)) then
       if (nzone_temp.ge.5) then
          if (iso_verif_tag17_q_deltaD_chns(x,err_msg).eq.1) then
                stop
          endif
        endif
        endif !if (option_traceurs.eq.17) then

        return
        end

      subroutine iso_verif_traceur(x,err_msg)
        implicit none
        ! vrifier des choses sur les traceurs
        ! * toutes les zones donne t l'istope total
        ! * pas de deltaD aberrant

        ! on prend les valeurs pas dfaut pour 
        ! errmax,errmaxrel,ridicule_trac,deltalimtrac
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       real x(ntraciso)
       character*(*) err_msg ! message d''erreur  afficher

       ! locals
       integer iso_verif_traceur_choix_nostop  

        if (iso_verif_traceur_choix_nostop(x,err_msg,
     :       errmax,errmaxrel,ridicule_trac,deltalimtrac)
     :       .eq.1) then
                stop
        endif

        return
        end

        
      subroutine iso_verif_traceur_retourne3D(x,n1,n2,n3,
     :           i1,i2,i3,err_msg)
        implicit none
        ! vrifier des choses sur les traceurs
        ! * toutes les zones donne t l'istope total
        ! * pas de deltaD aberrant

        ! on prend les valeurs pas dfaut pour 
        ! errmax,errmaxrel,ridicule_trac,deltalimtrac
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       integer n1,n2,n3
       real x(n1,n2,n3,ntraciso)
       character*(*) err_msg ! message d''erreur  afficher
       integer i1,i2,i3

       ! locals
       integer iso_verif_traceur_choix_nostop  
       real xiso(ntraciso)

        call select_dim4_from4D(n1,n2,n3,ntraciso,
     :      x,xiso,i1,i2,i3)
        if (iso_verif_traceur_choix_nostop(xiso,err_msg,
     :       errmax,errmaxrel,ridicule_trac,deltalimtrac)
     :       .eq.1) then
                stop
        endif

        return
        end

        subroutine iso_verif_traceur_retourne4D(x,n1,n2,n3,n4,
     :           i1,i2,i3,i4,err_msg)
        implicit none
        ! vrifier des choses sur les traceurs
        ! * toutes les zones donne t l'istope total
        ! * pas de deltaD aberrant

        ! on prend les valeurs pas dfaut pour 
        ! errmax,errmaxrel,ridicule_trac,deltalimtrac
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       integer n1,n2,n3,n4
       real x(n1,n2,n3,n4,ntraciso)
       character*(*) err_msg ! message d''erreur  afficher
       integer i1,i2,i3,i4

       ! locals
       integer iso_verif_traceur_choix_nostop  
       real xiso(ntraciso)

        call select_dim5_from5D(n1,n2,n3,n4,ntraciso,
     :      x,xiso,i1,i2,i3,i4)
        if (iso_verif_traceur_choix_nostop(xiso,err_msg,
     :       errmax,errmaxrel,ridicule_trac,deltalimtrac)
     :       .eq.1) then
                stop
        endif

        return
        end

        
      subroutine iso_verif_traceur_retourne2D(x,n1,n2,
     :           i1,i2,err_msg)
        implicit none
        ! vrifier des choses sur les traceurs
        ! * toutes les zones donne t l'istope total
        ! * pas de deltaD aberrant

        ! on prend les valeurs pas dfaut pour 
        ! errmax,errmaxrel,ridicule_trac,deltalimtrac
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       integer n1,n2
       real x(n1,n2,ntraciso)
       character*(*) err_msg ! message d''erreur  afficher
       integer i1,i2

       ! locals
       integer iso_verif_traceur_choix_nostop  
       real xiso(ntraciso)

        call select_dim3_from3D(n1,n2,ntraciso,
     :      x,xiso,i1,i2)
        if (iso_verif_traceur_choix_nostop(xiso,err_msg,
     :       errmax,errmaxrel,ridicule_trac,deltalimtrac)
     :       .eq.1) then
                stop
        endif

        return
        end

        subroutine iso_verif_traceur_vect(x,n,m,err_msg)
        implicit none
        ! vrifier des choses sur les traceurs
        ! * toutes les zones donne t l'istope total
        ! * pas de deltaD aberrant

        ! on prend les valeurs pas dfaut pour 
        ! errmax,errmaxrel,ridicule_trac,deltalimtrac
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       integer n,m
       real x(ntraciso,n,m)
       character*(*) err_msg ! message d''erreur  afficher

       ! locals
       logical iso_verif_traceur_nostop
       integer i,j,ixt,iiso,izone,ieau
       integer ifaux,jfaux,ixtfaux
       
       call iso_verif_traceur_noNaN_vect(x,n,m,err_msg)        

        ! verif masse: iso_verif_tracm_choix_nostop
        call iso_verif_trac_masse_vect(x,n,m,err_msg,errmax,errmaxrel)

        ! verif deltaD: iso_verif_tracdD_choix_nostop    
        if (use_iso_HDO.eq.1) then  
        call iso_verif_tracdd_vect(x,n,m,err_msg)      
        endif !if (use_iso_HDO.eq.1) then        

        ! verif pas aberramment negatif: iso_verif_tracpos_choix_nostop
        call iso_verif_tracpos_vect(x,n,m,err_msg,1e-5)  
        
        return
        end

        subroutine iso_verif_tracnps_vect(x,n,m,err_msg)
        implicit none
        ! vrifier des choses sur les traceurs
        ! * toutes les zones donne t l'istope total
        ! * pas de deltaD aberrant

        ! on prend les valeurs pas dfaut pour 
        ! errmax,errmaxrel,ridicule_trac,deltalimtrac
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       integer n,m
       real x(ntraciso,n,m)
       character*(*) err_msg ! message d''erreur  afficher

       ! locals
       logical iso_verif_traceur_nostop
       integer i,j,ixt,iiso,izone,ieau
       integer ifaux,jfaux,ixtfaux
       
       call iso_verif_traceur_noNaN_vect(x,n,m,err_msg)        

        ! verif masse: iso_verif_tracm_choix_nostop
        call iso_verif_trac_masse_vect(x,n,m,err_msg,errmax,errmaxrel)

        ! verif deltaD: iso_verif_tracdD_choix_nostop    
        if (use_iso_HDO.eq.1) then  
        call iso_verif_tracdd_vect(x,n,m,err_msg)      
        endif !if (use_iso_HDO.eq.1) then        

        
        return
        end


        subroutine iso_verif_traceur_noNaN_vect(x,n,m,err_msg)
        implicit none
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       integer n,m
       real x(ntraciso,n,m)
       character*(*) err_msg ! message d''erreur  afficher

       ! locals
       logical iso_verif_traceur_nostop
       integer i,j,ixt,iiso
       integer ifaux,jfaux,ixtfaux


       iso_verif_traceur_nostop=.false.
        ! verif noNaN: iso_verif_traceur_noNaN_nostop        
        do j=1,m
        do i=1,n
        do ixt=niso+1,ntraciso
          if ((x(ixt,i,j).gt.-borne).and.(x(ixt,i,j).lt.borne)) then
          else !if ((x.gt.-borne).and.(x.lt.borne)) then
              iso_verif_traceur_nostop=.true.
              ifaux=i
              jfaux=i
          endif !if ((x.gt.-borne).and.(x.lt.borne)) then
        enddo !do ixt=niso+1,ntraciso
        enddo ! do i=1,n
        enddo ! do j=1,m
        

        if (iso_verif_traceur_nostop) then
            write(*,*) 'erreur detecte par iso_verif_nonNAN ',
     :           'dans iso_verif_traceur_vect'
            write(*,*) ''
            write(*,*) err_msg
            write(*,*) 'x=',x(:,ifaux,jfaux)
            stop
        endif

        return
        end

        
        subroutine iso_verif_trac_masse_vect(x,n,m,err_msg,
     :            errmax,errmaxrel)
        implicit none
#include "wateriso2.h"
       ! inputs
       integer n,m
       real x(ntraciso,n,m)
       character*(*) err_msg ! message d''erreur  afficher
       real errmax,errmaxrel

       ! locals
       logical iso_verif_traceur_nostop
       integer i,j,ixt,iiso,izone
       integer ifaux,jfaux,ixtfaux
       real xtractot(n,m)
       real xiiso(n,m)

        do iiso=1,niso        
        do j=1,m 
         do i=1,n       
          xtractot(i,j)=0.0
          xiiso(i,j)=x(iiso,i,j)
          do izone=1,ntraceurs_zone  
            ixt=index_trac(izone,iiso) 
            xtractot(i,j)=xtractot(i,j)+x(ixt,i,j)            
          enddo !do izone=1,ntraceurs_zone
         enddo !do i=1,n
        enddo !do j=1,m
        

        call iso_verif_egalite_std_vect(
     :           xtractot,xiiso,
     :           err_msg//', verif trac egalite, iso '//striso(iiso),
     :           n,m,errmax,errmaxrel)
        enddo !do iiso=1,niso

        return
        end

        subroutine iso_verif_tracdd_vect(x,n,m,err_msg) 
        implicit none
#include "wateriso2.h"
#include "iso_verif.h"
       ! inputs
       integer n,m
       real x(ntraciso,n,m)
       character*(*) err_msg ! message d''erreur  afficher

       ! locals
       integer i,j,iiso,izone,ieau,ixt
       real xiiso(niso,n,m)
       real xeau(n,m)
       integer lnblnk

       if (use_iso_HDO.eq.1) then
        do izone=1,ntraceurs_zone
          ieau=index_trac(izone,iso_eau)
          do iiso=1,niso
           ixt=index_trac(izone,iiso)
           do j=1,m
            do i=1,n
             xiiso(iiso,i,j)=x(ixt,i,j)
            enddo !do i=1,n
           enddo !do j=1,m
          enddo !do iiso=1,niso
           
          do j=1,m
           do i=1,n
            xeau(i,j)=x(ieau,i,j)
           enddo !do i=1,n
          enddo !do j=1,m
          
          call iso_verif_aberrant_vect2Dch(
     :           xiiso,xeau,err_msg//strtrac(izone),niso,n,m,
     :           deltalimtrac)
         enddo !do izone=1,ntraceurs_zone
        endif !if (use_iso_HDO.eq.1) then

        return
        end

        subroutine iso_verif_tracpos_vect(x,n,m,err_msg,seuil) 
        implicit none
#include "wateriso2.h"
       ! inputs
       integer n,m
       real x(ntraciso,n,m)
       character*(*) err_msg ! message d''erreur  afficher
       real seuil

       ! locals
       integer i,j,ixt
       logical iso_verif_traceur_nostop
       integer ifaux,jfaux,ixtfaux

        iso_verif_traceur_nostop=.false.        
        do j=1,m
        do i=1,n
        do ixt=niso+1,ntraciso
          if (x(ixt,i,j).lt.-seuil) then
              ifaux=i
              jfaux=j
              ixtfaux=ixt
              iso_verif_traceur_nostop=.true.
          endif
        enddo !do ixt=niso+1,ntraciso 
        enddo !do i=1,n
        enddo !do j=1,m        

        if (iso_verif_traceur_nostop) then
            write(*,*) 'erreur detecte par verif positif ',
     :           'dans iso_verif_traceur_vect'
            write(*,*) ''
            write(*,*) err_msg
            write(*,*) 'x=',x(:,ifaux,jfaux)
            stop
        endif

        return
        end



        subroutine iso_verif_tracnps(x,err_msg)
        implicit none
        ! vrifier des choses sur les traceurs
        ! * toutes les zones donne t l'istope total
        ! * pas de deltaD aberrant

        ! on prend les valeurs pas dfaut pour 
        ! errmax,errmaxrel,ridicule_trac,deltalimtrac
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       real x(ntraciso)
       character*(*) err_msg ! message d''erreur  afficher

       ! locals
       integer iso_verif_tracnps_choix_nostop  

        if (iso_verif_tracnps_choix_nostop(x,err_msg,
     :       errmax,errmaxrel,ridicule_trac,deltalimtrac)
     :       .eq.1) then
                stop
        endif

        return
        end

        subroutine iso_verif_tracpos_choix(x,err_msg,seuil)
        implicit none
        ! vrifier des choses sur les traceurs
        ! * toutes les zones donne t l'istope total
        ! * pas de deltaD aberrant

        ! on prend les valeurs pas dfaut pour 
        ! errmax,errmaxrel,ridicule_trac,deltalimtrac
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       real x(ntraciso)
       character*(*) err_msg ! message d''erreur  afficher
       real seuil

       ! locals
       integer iso_verif_tracpos_choix_nostop  

        if (iso_verif_tracpos_choix_nostop(x,err_msg,seuil)
     :       .eq.1) then
                stop
        endif

        return
        end

        subroutine iso_verif_traceur_choix(x,err_msg,
     :       errmax,errmaxrel,ridicule_trac,deltalimtrac)
        implicit none
        ! vrifier des choses sur les traceurs
        ! * toutes les zones donne t l'istope total
        ! * pas de deltaD aberrant
       
#include "wateriso2.h"
!#include "iso_verif.h"   ! dj en input    
       ! inputs
       real x(ntraciso)
       character*(*) err_msg ! message d''erreur  afficher
       real errmax,errmaxrel,ridicule_trac,deltalimtrac

       ! locals
       integer iso_verif_traceur_choix_nostop  

        if (iso_verif_traceur_choix_nostop(x,err_msg,
     :       errmax,errmaxrel,ridicule_trac,deltalimtrac)
     :       .eq.1) then
                stop
        endif

        return
        end

        function iso_verif_traceur_nostop(x,err_msg)
        implicit none
        ! vrifier des choses sur les traceurs
        ! * toutes les zones donne t l'istope total
        ! * pas de deltaD aberrant

        ! on prend les valeurs pas dfaut pour 
        ! errmax,errmaxrel,ridicule_trac,deltalimtrac
       
#include "wateriso2.h"
#include "iso_verif.h"   
       ! inputs
       real x(ntraciso)
       character*(*) err_msg ! message d''erreur  afficher

       ! output
       integer iso_verif_traceur_nostop

       ! locals
       integer iso_verif_traceur_choix_nostop  

        iso_verif_traceur_nostop=
     :       iso_verif_traceur_choix_nostop(x,err_msg,
     :       errmax,errmaxrel,ridicule_trac,deltalimtrac)

        return
        end


      subroutine iso_verif_traceur_justmass(x,err_msg)
        implicit none
        ! on vrifie que noNaN et masse

        ! on prend les valeurs pas dfaut pour 
        ! errmax,errmaxrel,ridicule_trac,deltalimtrac
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       real x(ntraciso)
       character*(*) err_msg ! message d''erreur  afficher

       ! locals
       integer iso_verif_traceur_noNaN_nostop
       integer iso_verif_tracm_choix_nostop

        ! verif noNaN
        if (iso_verif_traceur_noNaN_nostop(x,err_msg).eq.1) then
             stop
        endif 
        
        ! verif masse
        if (iso_verif_tracm_choix_nostop(x,err_msg,
     :           errmax,errmaxrel).eq.1) then
             stop
        endif    
        
        return
        end

        function iso_verif_traceur_jm_nostop(x,err_msg)
        implicit none
        ! on vrifie que noNaN et masse

        ! on prend les valeurs pas dfaut pour 
        ! errmax,errmaxrel,ridicule_trac,deltalimtrac
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       real x(ntraciso)
       character*(*) err_msg ! message d''erreur  afficher

       ! output
       integer iso_verif_traceur_jm_nostop

       ! locals
!       integer iso_verif_traceur_noNaN_nostop
       integer iso_verif_tracm_choix_nostop

        iso_verif_traceur_jm_nostop=0
!        ! verif noNaN
!        if (iso_verif_traceur_noNaN_nostop(x,err_msg).eq.1) then
!             iso_verif_traceur_jm_nostop=1
!        endif 
        
        ! verif masse
        if (iso_verif_tracm_choix_nostop(x,err_msg,
     :           errmax,errmaxrel).eq.1) then
             iso_verif_traceur_jm_nostop=1
        endif   
        
        return
        end

        subroutine iso_verif_traceur_pbidouille(x,err_msg)
        implicit none
        ! vrifier des choses sur les traceurs
        ! * toutes les zones donne t l'istope total
        ! * pas de deltaD aberrant
        ! on rajuste aussi les valeurs des traceurs pour la
        ! conservation de la masse, dans le cas bidouille

        ! on prend les valeurs pas dfaut pour 
        ! errmax,errmaxrel,ridicule_trac,deltalimtrac
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       real x(ntraciso)
       character*(*) err_msg ! message d''erreur  afficher

       ! local
       integer iso_verif_traceur_pbid_ns

        if (iso_verif_traceur_pbid_ns(x,err_msg).eq.1) then
            stop
        endif

        return
        end

        function iso_verif_traceur_pbid_ns(x,err_msg)
        implicit none
        ! vrifier des choses sur les traceurs
        ! * toutes les zones donne t l'istope total
        ! * pas de deltaD aberrant
        ! on rajuste aussi les valeurs des traceurs pour la
        ! conservation de la masse, dans le cas bidouille

        ! on prend les valeurs pas dfaut pour 
        ! errmax,errmaxrel,ridicule_trac,deltalimtrac
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       real x(ntraciso)
       character*(*) err_msg ! message d''erreur  afficher

       ! output
       integer iso_verif_traceur_pbid_ns

       ! locals
       integer iso_verif_traceur_noNaN_nostop
       integer iso_verif_tracm_choix_nostop  
       integer iso_verif_tracdD_choix_nostop  
       integer iiso,izone,ixt
       real xtractot
        
        ! verif noNaN
        iso_verif_traceur_pbid_ns=0

        if (iso_verif_traceur_noNaN_nostop(x,err_msg).eq.1) then
!             stop
            iso_verif_traceur_pbid_ns=1
        endif

        ! verif masse
        if (iso_verif_tracm_choix_nostop(x,err_msg,
     :           errmax*10,errmaxrel*50).eq.1) then
             ! on est plus laxiste car a vient en gnral aprs une
             ! bidouille pour iso_eau normal
!             stop
             iso_verif_traceur_pbid_ns=1   
        endif  

        if (bidouille_anti_divergence) then
            ! on rajuste pour que les traceurs fasses bien la somme
            ! des traceurs
            call iso_verif_traceur_jbidouille(x)
        endif !if (bidouille_anti_divergence) then    

       ! verif deltaD
       if (use_iso_HDO.eq.1) then
        if (iso_verif_tracdD_choix_nostop(x,err_msg,
     :           ridicule_trac,deltalimtrac).eq.1) then
!             stop
              iso_verif_traceur_pbid_ns=1
        endif  
       endif !if (use_iso_HDO.eq.1) then

        return
        end

        subroutine iso_verif_traceur_pbid_vect(x,n,m,err_msg)
        implicit none
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       integer n,m
       real x(ntraciso,n,m)
       character*(*) err_msg ! message d''erreur  afficher       

       ! locals
       integer iiso,izone,ixt
       real xtractot
        
        write(*,*) 'iso_verif_traceur tmp 822: xt(:,66,1)=',x(:,66,1)
        ! verif noNaN
        call iso_verif_traceur_noNaN_vect(x,n,m,err_msg)

        ! verif masse
        call iso_verif_trac_masse_vect(x,n,m,err_msg,errmax*10,
     :           errmaxrel*50)

        if (bidouille_anti_divergence) then
            ! on rajuste pour que les traceurs fasses bien la somme
            ! des traceurs
            call iso_verif_traceur_jbid_vect(x,n,m)
        endif !if (bidouille_anti_divergence) then    

       ! verif deltaD
       if (use_iso_HDO.eq.1) then
        call iso_verif_tracdd_vect(x,n,m,err_msg)  
       endif

        return
        end

        subroutine iso_verif_traceur_jbidouille(x)
        implicit none
        
        ! on rajuste aussi les valeurs des traceurs pour la
        ! conservation de la masse, dans le cas bidouille
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       real x(ntraciso)

       ! locals
       integer iiso,izone,ixt
       real xtractot
        
        if (bidouille_anti_divergence) then

        do iiso=1,niso

          xtractot=0.0
          do izone=1,ntraceurs_zone  
            ixt=index_trac(izone,iiso) 
            xtractot=xtractot+x(ixt)
          enddo !do izone=1,ntraceurs_zone
         
              ! on rajuste pour que les traceurs fasses bien la somme
              ! des traceurs
              if (abs(xtractot).gt.ridicule*10) then
                do izone=1,ntraceurs_zone
                  ixt=index_trac(izone,iiso) 
                  x(ixt)=x(ixt)/xtractot*x(iiso)
                enddo !do izone=1,ntraceurs_zone                
              endif         

        enddo !do iiso=1,ntraceurs_iso   
        endif !if (bidouille_anti_divergence) then     

        return
        end


        subroutine iso_verif_traceur_jbid_pos(x)
        implicit none
        
        ! on rajuste les valeurs des traceurs pour qu'il n'y ai pas de
        ! valeurs ngatives. Si valeurs ngatives -> on pompe les autres
        ! traceurs
        ! attention: fait la mme chose pour tous les isos -> peut
        ! induire des fractionnements.
        ! Pour ne pas induire des fractionnements, prendre 
        ! iso_verif_traceur_jbid_pos2
        ! avantage de cette subroutine: conserve la masse en isotopes
        ! lgers, ce qui nest pas le cas de pos2
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       real x(ntraciso)

       ! locals
       integer iiso,izone,ixt
       real xtractot,xtractotprec
        
        if (bidouille_anti_divergence) then

!            write(*,*) 'pgm 532 tmp: x=',x
        do iiso=1,niso

          xtractot=0.0
          xtractotprec=0.0
          do izone=1,ntraceurs_zone  
            ixt=index_trac(izone,iiso) 
            xtractotprec=xtractotprec+x(ixt)
            x(ixt)=max(x(ixt),0.0) 
            xtractot=xtractot+x(ixt)
          enddo !do izone=1,ntraceurs_zone
!          write(*,*) 'iiso,xtractotprec,xtractot=',
!     :          iiso,xtractotprec,xtractot
         
          if (xtractot.gt.xtractotprec) then
              ! on rajuste pour que les traceurs fasses bien la somme
              ! des traceurs
              if (abs(xtractot).gt.ridicule) then
                do izone=1,ntraceurs_zone
                  ixt=index_trac(izone,iiso) 
                  x(ixt)=x(ixt)*xtractotprec/xtractot
                enddo !do izone=1,ntraceurs_zone  
                ! on modifie aussi l'isotope de base si lui aussi tait
                ! ngatif   
!                x(iiso)=xtractot
              else  !if (abs(xtractot).gt.ridicule) then
                ! normallement, valeurs restantes trs faibles
                ! on ne fait rien. 
                ! on met juste un max
                x(iiso)=max(x(iiso),0.0)
                do izone=1,ntraceurs_zone
                  ixt=index_trac(izone,iiso) 
                  x(ixt)=max(x(ixt),0.0)
                enddo !do izone=1,ntraceurs_zone
              endif !if (abs(xtractot).gt.ridicule) then
          endif !if (xtractot.gt.xtractotprec) then      

        enddo !do iiso=1,ntraceurs_iso
#ifdef ISOVERIF        
        call iso_verif_traceur_pbidouille(x,'iso_verif_trac 558') 
#else
        call iso_verif_traceur_jbidouille(x) 
#endif
        endif !if (bidouille_anti_divergence) then     

        return
        end

        subroutine iso_verif_traceur_jbid_pos_vect(n,m,x)
        implicit none
               
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       integer n,m
       real x(ntraciso,n,m)

       ! locals
       integer iiso,izone,ixt
       real xtractot(n,m),xtractotprec(n,m)
       integer i,j
        
        if (bidouille_anti_divergence) then

!            write(*,*) 'pgm 532 tmp: x=',x
               
        do iiso=1,niso          
          do j=1,m 
          do i=1,n
          xtractot(i,j)=0.0
          xtractotprec(i,j)=0.0
          enddo !do j=1,m 
          enddo !do i=1,n
          do izone=1,ntraceurs_zone 
            ixt=index_trac(izone,iiso)  

            do j=1,m 
            do i=1,n
            xtractotprec(i,j)=xtractotprec(i,j)+x(ixt,i,j)
            x(ixt,i,j)=max(x(ixt,i,j),0.0) 
            xtractot(i,j)=xtractot(i,j)+x(ixt,i,j)
            enddo !do i=1,n
            enddo !do j=1,m 
            
          enddo !do izone=1,ntraceurs_zone
!          write(*,*) 'iiso,xtractotprec,xtractot=',
!     :          iiso,xtractotprec,xtractot
                  
         do j=1,m 
         do i=1,n
          if (xtractot(i,j).gt.xtractotprec(i,j)) then
              ! on rajuste pour que les traceurs fasses bien la somme
              ! des traceurs
              if (abs(xtractot(i,j)).gt.ridicule) then
                do izone=1,ntraceurs_zone
                  ixt=index_trac(izone,iiso) 
                  x(ixt,i,j)=x(ixt,i,j)*xtractotprec(i,j)/xtractot(i,j)
                enddo !do izone=1,ntraceurs_zone  
                ! on modifie aussi l'isotope de base si lui aussi tait
                ! ngatif   
!                x(iiso)=xtractot
              else  !if (abs(xtractot).gt.ridicule) then
                ! normallement, valeurs restantes trs faibles
                ! on ne fait rien. 
                ! on met juste un max
                x(iiso,i,j)=max(x(iiso,i,j),0.0)
                do izone=1,ntraceurs_zone
                  ixt=index_trac(izone,iiso) 
                  x(ixt,i,j)=max(x(ixt,i,j),0.0)
                enddo !do izone=1,ntraceurs_zone
              endif !if (abs(xtractot).gt.ridicule) then
          endif !if (xtractot.gt.xtractotprec) then
         enddo !do i=1,n      
         enddo !do j=1,m 
         

        enddo !do iiso=1,ntraceurs_iso
#ifdef ISOVERIF        
        call iso_verif_traceur_pbid_vect(x,n,m,'iso_verif_trac 558') 
#else
        call iso_verif_traceur_jbid_vect(x,n,m) 
#endif
        endif !if (bidouille_anti_divergence) then     

        return
        end

        subroutine iso_verif_traceur_jbid_pos2(x,q)
        implicit none
        
        ! mme but que iso_verif_traceur_jbid_pos, mais n'induit
        ! pas de fractionnement.
        ! on regarde si xteau est positif. S'il ne l'est pas, on pompe
        ! dans les autres tags pour le mettre  0. On conserve la compo
        ! iso.
        ! Pb: ne conserve pas la masse d'isotopes lgers.
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       real x(ntraciso),q

       ! locals
       integer iiso,izone,ixt,ieau
       real dqtmp,factmp
        
        if (bidouille_anti_divergence) then
!        write(*,*) 'iso_verif_trac 578 tmp: q,xt=',
!     :                q,x(1:ntraciso)
        if (q.gt.0.0) then
              dqtmp=0.0
              do izone=1,ntraceurs_zone
                ieau=index_trac(izone,iso_eau)
                if (x(ieau).lt.0.0) then
!                    write(*,*) 'local_x<0 pour izone=',izone
                    dqtmp=dqtmp-x(ieau)
                    do iiso=1,niso    
                      ixt=index_trac(izone,iiso)
                      x(ixt) =0.0
                    enddo !do iiso=1,niso  
                endif  !if (local_xt(ieau,i,k).lt.0.0) then                
              enddo !do izone=1,ntraceurs_zone
!              write(*,*) 'dqtmp=',dqtmp
              if (dqtmp.gt.0.0) then  
!                  write(*,*) 'iso_verif_trac 593 warning: q,dqtmp,xt=',
!     :                q,dqtmp,x(1:ntraciso)
                    ! on redistribue la ngativit des traceurs dans les
                    ! traceurs positifs
!                    factmp=(1.0-dqtmp/(local_q(i,k)+dqtmp))
                    ! correction janv 2010
                    factmp=(q/(q+dqtmp))
!                    write(*,*) 'factmp=',factmp
                     do izone=1,ntraceurs_zone
                       ieau=index_trac(izone,iso_eau)
                       if (x(ieau).gt.0.0) then
                          do iiso=1,niso    
                             ixt=index_trac(izone,iiso)
                             x(ixt)=x(ixt)*factmp
                          enddo !do iiso=1,niso
                       endif !if (local_xt(ieau,i,k).gt.0.0) then
                     enddo ! do izone=1,ntraceurs_zone
!                     write(*,*) 'apres bidouille: xt=',x(1:ntraciso)
              endif !if (dqtmp.gt.0.0) then   
              call iso_verif_traceur(x,'iso_verif_traceurs 612') 
          endif !if (local_q(i,k).lt.0.0) then

        call iso_verif_traceur_pbidouille(x,'iso_verif_trac 625')    
        endif ! if (bidouille_anti_divergence) then  

        return
        end

        subroutine iso_verif_traceur_jbid_vect1D(x,n)
        implicit none
        
        ! version vectrise de iso_verif_traceur_jbidouille
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       integer n
       real x(ntraciso,n)

       ! locals
       integer iiso,izone,ixt,i
       real xtractot
        
        if (bidouille_anti_divergence) then

        do i=1,n
        do iiso=1,niso

          xtractot=0.0
          do izone=1,ntraceurs_zone  
            ixt=index_trac(izone,iiso) 
            xtractot=xtractot+x(ixt,i)
          enddo !do izone=1,ntraceurs_zone
         
              ! on rajuste pour que les traceurs fasses bien la somme
              ! des traceurs
              if (abs(xtractot).gt.ridicule*10) then
                do izone=1,ntraceurs_zone
                  ixt=index_trac(izone,iiso) 
                  x(ixt,i)=x(ixt,i)/xtractot*x(iiso,i)
                enddo !do izone=1,ntraceurs_zone                
              endif         

        enddo !do iiso=1,ntraceurs_iso  
        enddo  !do i=1,n
        endif !if (bidouille_anti_divergence) then             

        return
        end


        subroutine iso_verif_traceur_jbid_vect(x,n,m)
        implicit none
        
        ! version vectrise de iso_verif_traceur_jbidouille
       
#include "wateriso2.h"
#include "iso_verif.h"       
       ! inputs
       integer n,m
       real x(ntraciso,n,m)

       ! locals
       integer iiso,izone,ixt,i,j
       real xtractot(n,m)
                
        if (bidouille_anti_divergence) then        
        do iiso=1,niso

          do j=1,m
           do i=1,n          
            xtractot(i,j)=0.0
           enddo !do j=1,m
          enddo !do j=1,m

          do izone=1,ntraceurs_zone  
            ixt=index_trac(izone,iiso) 
            do j=1,m
             do i=1,n
              xtractot(i,j)=xtractot(i,j)+x(ixt,i,j)
             enddo !do j=1,m
            enddo !do j=1,m
           enddo !do izone=1,ntraceurs_zone
         
              ! on rajuste pour que les traceurs fasses bien la somme
              ! des traceurs
           do izone=1,ntraceurs_zone
            ixt=index_trac(izone,iiso)
            do j=1,m
             do i=1,n
!              if (abs(xtractot(i,j)).gt.ridicule*10) then 
               if (abs(xtractot(i,j)).gt.ridicule) then 
                   ! modif le 19 fev 2011
                  x(ixt,i,j)=x(ixt,i,j)/xtractot(i,j)*x(iiso,i,j) 
              endif !if (abs(xtractot(i,j)).gt.ridicule*10) then
             enddo !do i=1,n
            enddo !do j=1,m   
           enddo !do izone=1,ntraceurs_zone 
 
!           ! ajout le 19 fev 2011
!           ! on rend plutot les vrifs plus strictes
!           ixt=index_trac(izone_poubelle,iiso)
!           do j=1,m
!             do i=1,n
!              if ((abs(xtractot(i,j)).lt.1e-18).and.
!     :           (x(iiso,i,j).gt.ridicule)) then
!                  x(ixt,i,j)=x(iiso,i,j)
!              endif !if (abs(xtractot(i,j)).gt.ridicule*10) then
!             enddo ! do i=1,n
!           enddo !do j=1,m

        enddo !do iiso=1,ntraceurs_iso  
        endif !if (bidouille_anti_divergence) then             

        return
        end

        function iso_verif_tag17_q_deltaD_chns(x,err_msg)
        implicit none

#include "wateriso2.h"
#include "iso_verif.h"      

        ! inputs
        real x(ntraciso)
        character*(*) err_msg
        ! output 
        integer iso_verif_tag17_q_deltaD_chns
        ! locals
        integer iso_verif_positif_nostop
        real deltaD
        integer ieau,ixt,ieau1

        iso_verif_tag17_q_deltaD_chns=0

        if ((option_traceurs.eq.17).or.
     :           (option_traceurs.eq.18)) then
        ! verifier que deltaD du tag de la couche la plus haute <
        ! 200 permil, et vrifier que son q est infrieur  
        ieau=index_trac(nzone_temp,iso_eau)
        ixt=index_trac(nzone_temp,iso_HDO)

        if (x(ieau).gt.ridicule) then
          if (iso_verif_positif_nostop(-200.0-deltaD(x(ixt)/x(ieau)),
     :           err_msg//': deltaDt05 trop fort').eq.1) then
                write(*,*) 'x=',x
                iso_verif_tag17_q_deltaD_chns=1
          endif !if (iso_verif_positif_nostop(-200.0-deltaD(x(ixt),x(ieau)),
        endif !if (x(ieau).gt.ridicule) then

        if (iso_verif_positif_nostop(2.0e-3-x(ieau),
     :           err_msg//': qt05 trop fort').eq.1) then
                write(*,*) 'x=',x
                iso_verif_tag17_q_deltaD_chns=1
        endif !if (iso_verif_positif_nostop(1.0e-3-x(ieau),

        ! on vrifie que si q est petit, alors qt01 fait moins de 10%
        if (x(iso_eau).lt.2.0e-3) then
           ieau1= index_trac(1,iso_eau)
           if (iso_verif_positif_nostop(0.1-(x(ieau1)/x(iso_eau)),
     :            err_msg//': qt01 trop abondant').eq.1) then
             write(*,*) 'x=',x
                iso_verif_tag17_q_deltaD_chns=1
           endif ! if (iso_verif_positif(0.1-(x(ixt)/x(ieau)),
        endif !if (x(ieau).lt.2.0e-3) then

        endif !if (option_traceurs.eq.17) then

        return
        end

        subroutine iso_verif_tag17_q_deltaD_vect(x,n,m,err_msg)
        implicit none

#include "wateriso2.h"
#include "iso_verif.h"    

        ! inputs
        integer n,m
        real x(ntraciso,n,m)
        character*(*) err_msg

        ! locals
        integer iso_verif_positif_nostop
        real deltaD
        integer ieau,ixt,ieau1
        integer i,k

        if ((option_traceurs.eq.17).or.
     :           (option_traceurs.eq.18)) then
        ! verifier que deltaD du tag de la couche la plus haute <
        ! 200 permil, et vrifier que son q est infrieur  
        ieau=index_trac(nzone_temp,iso_eau)
        ixt=index_trac(nzone_temp,iso_HDO)
        ieau1=index_trac(1,iso_eau)
        do i=1,n
         do k=1,m
           if (x(ieau,i,k).gt.ridicule) then
             if ((x(ixt,i,k)/x(ieau,i,k)/tnat(iso_HDO)-1)*1000
     :            .gt.-200.0) then
                write(*,*) err_msg,', vect:deltaDt05 trop fort'
                write(*,*) 'i,k=',i,k
                write(*,*) 'x(:,i,k)=',x(:,i,k)
                stop
             endif !if (iso_verif_positif_nostop(-200.0-deltaD(x(ixt),x(ieau)),
           endif !if (x(ieau).gt.ridicule) then
           if (x(ieau,i,k).gt.2.0e-3) then
                write(*,*) err_msg,', vect:qt05 trop fort'
                write(*,*) 'i,k=',i,k
                write(*,*) 'x(:,i,k)=',x(:,i,k)
                stop
           endif !if (iso_verif_positif_nostop(1.0e-3-x(ieau),
           if (x(iso_eau,i,k).lt.2.0e-3) then
                if (x(ieau1,i,k)/x(iso_eau,i,k).gt.0.1) then
                   write(*,*) err_msg,', vect: qt01 trop abondant'
                   write(*,*) 'i,k=',i,k
                   write(*,*) 'ieau1,iso_eau,x(ieau1,i,k),',
     :                 'x(iso_eau,i,k)=',ieau1,iso_eau,
     :                  x(ieau1,i,k),x(iso_eau,i,k)  
                   write(*,*) 'x(:,i,k)=',x(:,i,k)
                   stop
                endif !if (x(ieau1,i,k)/x(iso_eau,i,k).gt.0.1) then
            endif
          enddo !do k=1,m
        enddo !do i=1,n

        endif !if (option_traceurs.eq.17) then

        return
        end


        subroutine iso_verif_tag17_q_deltaD_vect_ret3D(x,n,m,nq,err_msg)
        implicit none

#include "wateriso2.h"
#include "iso_verif.h"    

        ! inputs
        integer n,m,nq
        real x(n,m,nq,ntraciso)
        character*(*) err_msg

        ! locals
        integer iso_verif_positif_nostop
        real deltaD
        integer ieau,ixt,ieau1
        integer i,k,iq

        if ((option_traceurs.eq.17).or.
     :           (option_traceurs.eq.18)) then
        ! verifier que deltaD du tag de la couche la plus haute <
        ! 200 permil, et vrifier que son q est infrieur  
        ieau=index_trac(nzone_temp,iso_eau)
        ixt=index_trac(nzone_temp,iso_HDO)
        ieau1=index_trac(1,iso_eau)
        do iq=1,nq
        do i=1,n
         do k=1,m
           if (x(i,k,iq,ieau).gt.ridicule) then
             if ((x(i,k,iq,ixt)/x(i,k,iq,ieau)/tnat(iso_HDO)-1)*1000
     :            .gt.-200.0) then
                write(*,*) err_msg,', vect:deltaDt05 trop fort'
                write(*,*) 'i,k=',i,k
                write(*,*) 'x(i,k,iq,:)=',x(i,k,iq,:)
                stop
             endif !if (iso_verif_positif_nostop(-200.0-deltaD(x(ixt),x(ieau)),
           endif !if (x(ieau).gt.ridicule) then
           if (x(i,k,iq,ieau).gt.2.0e-3) then
                write(*,*) err_msg,', vect:qt05 trop fort'
                write(*,*) 'i,k=',i,k
                write(*,*) 'x(i,k,iq,:)=',x(i,k,iq,:)
                stop
           endif !if (iso_verif_positif_nostop(1.0e-3-x(ieau),
           if (x(i,k,iq,iso_eau).lt.2.0e-3) then
                if (x(i,k,iq,ieau1)/x(i,k,iq,iso_eau).gt.0.1) then
                   write(*,*) err_msg,', vect: qt01 trop abondant'
                   write(*,*) 'i,k=',i,k
                   write(*,*) 'ieau1,iso_eau,x(i,k,iq,ieau1),',
     :                 'x(i,k,iq,ieau)=',ieau1,iso_eau,
     :                  x(i,k,iq,ieau1),x(i,k,iq,iso_eau)  
                   write(*,*) 'x(i,k,iq,:)=',x(i,k,iq,:)
                   stop
                endif !if (x(ieau1,i,k)/x(iso_eau,i,k).gt.0.1) then
            endif
          enddo !do k=1,m
        enddo !do i=1,n
        enddo ! do iq=1,nq

        endif !if (option_traceurs.eq.17) then

        return
        end


#endif
#endif


