#ifdef ISO
      SUBROUTINE phyiso_etat0_dur (
     :          xtsol,xtsnow, xtevap
     :         ,xtrun_off_lic_0, Rland_ice
     :         ,qsol,snow,evap,run_off_lic_0) 

      USE dimphy
      USE mod_grid_phy_lmdz
      USE mod_phys_lmdz_para
      USE iophy
      USE phys_state_var_mod
      USE iostart
      USE write_field_phy
      USE infotrac
        implicit none


#include "wateriso2.h"
#include "indicesol.h"
#include "dimsoil.h"
#include "clesphys.h"
#include "temps.h"
#include "thermcell.h"
#include "compbl.h"
#include "iso_verif.h"
#ifdef ISOVERIFIDRIS
#endif          
        ! arguments  
      !integer niso 
      real xtsol(niso,klon) 
      real xtsnow(niso,klon,nbsrf)  
      real xtevap(ntraciso,klon,nbsrf) 
      real xtrun_off_lic_0(niso,klon)
      real Rland_ice(niso,klon)

      REAL qsol(klon)
      REAL snow(klon,nbsrf)
      REAL evap(klon,nbsrf)
      REAL run_off_lic_0(klon)
      !locals
      integer ixt, k, i, nsrf   
      real deltaD_rain_fall(niso)
      real deltaD_snow_fall(niso)
      real deltaD_snow(niso)
      real deltaD_land_ice(niso)
      real deltaD_sol(niso)
      real deltaD_run_off_lic_0(niso)
      real deltaD_evap(niso)

      ! constes
        real deltaD_snow_fall_O18,deltaD_rain_fall_O18
        real alpha(niso),kcin(niso)
!      character*50 text
      
        
      ! initialisation des isotopes
     
      ! 1. initialisation de la neige qui tombe
      ! 2. initialisation de la pluie
        deltaD_snow_fall_O18=-20.
        deltaD_rain_fall_O18=-5.
        if (use_iso_HTO.eq.1) then
        deltaD_snow_fall(iso_HTO)=-1000.  
        deltaD_rain_fall(iso_HTO)=-1000.   
        endif   
        if (use_iso_O18.eq.1) then
        deltaD_snow_fall(iso_O18)=deltaD_snow_fall_O18
        deltaD_rain_fall(iso_O18)=deltaD_rain_fall_O18
        endif
        if (use_iso_O17.eq.1) then
        deltaD_snow_fall(iso_O17)=(exp(25.0/1e6)
     :           *(deltaD_snow_fall_O18/1000.0+1.0)**0.528
     :           -1.0)*1000.0
        deltaD_rain_fall(iso_O17)=(exp(25.0/1e6)
     :           *(deltaD_rain_fall_O18/1000.0+1.0)**0.528
     :           -1.0)*1000.0
        endif
        if (use_iso_HDO.eq.1) then
          deltaD_snow_fall(iso_HDO)=deltaD_snow_fall_O18*8.0+10.0
          deltaD_rain_fall(iso_HDO)=deltaD_rain_fall_O18*8.0+10.
        endif
        if (use_iso_eau.eq.1) then
          deltaD_snow_fall(iso_eau)=0.
          deltaD_rain_fall(iso_eau)=0.
        endif
        do ixt=1,niso
          deltaD_snow(ixt)=deltaD_snow_fall(ixt)
          deltaD_sol(ixt)=deltaD_rain_fall(ixt)
          deltaD_evap(ixt)=deltaD_sol(ixt)
          deltaD_run_off_lic_0(ixt)=deltaD_sol(ixt)
          deltaD_land_ice(ixt)=deltaD_snow(ixt)
          call fractcalk_liq(ixt, 283.0, alpha(ixt))            
        enddo !do ixt=1,niso
        call calcul_kcin(2.0,kcin) 

       do i=1,klon
        do ixt=1,niso
           xtsnow_fall(ixt,i)=snow_fall(i)
     :           *tnat(ixt)*(deltaD_snow_fall(ixt)/1000.0+1.0)
        enddo
        do ixt=1,niso
           xtrain_fall(ixt,i)=rain_fall(i)
     :           *tnat(ixt)*(deltaD_rain_fall(ixt)/1000.0+1.0)
        enddo
       enddo !do i=1,klon
#ifdef ISOTRAC
       do i=1,klon
        do ixt=niso+1,ntraciso
         if (index_zone(ixt).eq.izone_init) then 
           xtrain_fall(ixt,i)=rain_fall(i)
     :           *tnat(index_iso(ixt))
     :           *(deltaD_rain_fall(index_iso(ixt))/1000.0+1.0)
           xtsnow_fall(ixt,i)=snow_fall(i)
     :           *tnat(index_iso(ixt))
     :           *(deltaD_snow_fall(index_iso(ixt))/1000.0+1.0)
         else
             xtsnow_fall(ixt,i)=0.0
             xtrain_fall(ixt,i)=0.0
         endif
        enddo !do ixt=niso+1,ntraciso
       enddo !do i=1,klon
#endif        

        ! 3. initialisation de la neige au sol
       do i=1,klon
        do nsrf=1,nbsrf
          do ixt=1,niso           
           xtsnow(ixt,i,nsrf)=snow(i,nsrf)
     :           *tnat(ixt)*(deltaD_snow(ixt)/1000+1)
          enddo
        enddo !do nsrf=1,nbsrf
       enddo !do i=1,klon

        ! 4. initialisation du sol
        do i=1,klon
          do ixt=1,niso
       
           xtsol(ixt,i)=qsol(i)
     :           *tnat(ixt)*(deltaD_sol(ixt)/1000+1)                   
          enddo
        enddo !do i=1,klon

          ! verif   
#ifdef ISOVERIF
        do i=1,klon  
             if (use_iso_eau.eq.1)  then
                 call iso_verif_egalite(xtsol(iso_eau,i),qsol(i),
     :           'phyiso_etat0_dur 74')
             endif  
        enddo !do i=1,klon      
#endif

          ! end verif
      ! 5. initialisation de l'vaporation
      do i=1,klon
        do nsrf=1,nbsrf
          do ixt=1,niso
           xtevap(ixt,i,nsrf)=evap(i,nsrf)
     :           *tnat(ixt)*(deltaD_evap(ixt)/1000+1)
          enddo
#ifdef ISOTRAC
          do ixt=niso+1,ntraciso
           if (index_zone(ixt).eq.izone_init) then 
             xtevap(ixt,i,nsrf)=evap(i,nsrf)
     :           *tnat(index_iso(ixt))
     :           *(deltaD_evap(index_iso(ixt))/1000.0+1.0)
           else
             xtevap(ixt,i,nsrf)=0.0
           endif
          enddo !do ixt=niso+1,ntraciso
#endif            
        enddo !do nsrf=1,nbsrf
      enddo !do i=1,klon 

      ! 6. initialisation de xtrun_off_lic0
      do i=1,klon
          do ixt=1,niso
           xtrun_off_lic_0(ixt,i)=run_off_lic_0(i)
     :         *tnat(ixt)*(deltaD_run_off_lic_0(ixt)/1000.0+1.0)
          enddo
       enddo !do i=1,klon   

      ! 7. initialisation de xt_ancien et wake_deltaxt
      do i=1,klon
        do k=1,klev
          do ixt=1,niso
           xt_ancien(ixt,i,k)=q_ancien(i,k)*
     :                  toce(ixt)/alpha(ixt)
     :                  *(1.0-kcin(ixt))/(1-kcin(ixt)*0.7)
     :                  *(q_ancien(i,k)/20.0e-3)
     :                  **(alpha(ixt)-1.0)
          enddo !do ixt=1,niso
#ifdef ISOTRAC
        do ixt=niso+1,ntraciso
          if (index_zone(ixt).eq.izone_init) then
            xt_ancien(ixt,i,k)=xt_ancien(index_iso(ixt),i,k) 
          else
            xt_ancien(ixt,i,k)=0.0
          endif
        enddo !do ixt=niso+1,ntraciso
#endif             
        enddo !do k=1,klev
       enddo ! do i=1,klon

       ! 7bis: wake_deltaxt       
       do i=1,klon
        do k=1,klev
         if (q_ancien(i,k).gt.ridicule) then
          do ixt=1,niso
           wake_deltaxt(ixt,i,k)=xt_ancien(ixt,i,k)/q_ancien(i,k)
     :           *wake_deltaq(i,k)
          enddo !do ixt=1,niso
        else !if (q_ancien(i,k).gt.ridicule) then
          do ixt=1,niso
           wake_deltaxt(ixt,i,k)=Rdefault(ixt)*wake_deltaq(i,k)
          enddo !do ixt=1,niso
        endif !if (q_ancien(i,k).gt.ridicule) then
#ifdef ISOTRAC
        do ixt=niso+1,ntraciso
          if (index_zone(ixt).eq.izone_init) then
            wake_deltaxt(ixt,i,k)=wake_deltaxt(index_iso(ixt),i,k) 
          else
            wake_deltaxt(ixt,i,k)=0.0
          endif
        enddo !do ixt=niso+1,ntraciso
#endif             
#ifdef ISOVERIF 
        do ixt=1,ntraciso      
             call iso_verif_noNaN(wake_deltaxt(ixt,i,k),
     :           'phyiso_etat0_dur 288a')
        enddo !do ixt=1,niso
#endif
        enddo !do k=1,klev
       enddo ! do i=1,klon

        ! 8. initialisation de la composition des glaciers
       do i=1,klon 
        do ixt=1,niso
           Rland_ice(ixt,i)=
     :           tnat(ixt)*(deltaD_snow(ixt)/1000+1)
          enddo
      enddo !do i=1,klon

#ifdef ISOVERIF
      do i=1,klon
         do ixt=1,niso
         call iso_verif_noNAN(xtsol(ixt,i),'phyiso_etat0_dur 753')
         call iso_verif_noNAN(xtrain_fall(ixt,i),'phyiso_etat0_dur 754')
         call iso_verif_noNAN(xtsnow_fall(ixt,i),'phyiso_etat0_dur 755')
         call iso_verif_noNAN(xtrun_off_lic_0(ixt,i),
     :           'phyiso_etat0_dur 756')
         enddo !do ixt=1,niso
         if (use_iso_eau.eq.1) then
         call iso_verif_egalite(xtsol(iso_eau,i),qsol(i),
     :           'phyiso_etat0_dur 759')
         call iso_verif_egalite(xtrain_fall(iso_eau,i),rain_fall(i),
     :            'phyiso_etat0_dur 760')
         call iso_verif_egalite(xtsnow_fall(iso_eau,i),snow_fall(i),
     :           'phyiso_etat0_dur 761')
         call iso_verif_egalite(xtrun_off_lic_0(iso_eau,i),
     :           run_off_lic_0(i), 'phyiso_etat0_dur 762')
         endif !if (use_iso_eau.eq.1) then
         do k=1,klev
           do ixt=1,niso
!              write(*,*) 'ixt,i,k=',ixt,i,k
              call iso_verif_noNAN(xt_ancien(ixt,i,k),
     :           'phyiso_etat0_dur 771')     
              call iso_verif_noNAN(wake_deltaxt(ixt,i,k),
     :           'phyiso_etat0_dur 240')        
           enddo !do ixt=1,niso
           if (use_iso_eau.eq.1) then
             call iso_verif_egalite(xt_ancien(iso_eau,i,k),
     :           q_ancien(i,k),'phyiso_etat0_dur 775')        
           endif !if (use_iso_eau.eq.1) then
         enddo !do k=1,klev
         do nsrf=1,nbsrf
            do ixt=1,niso
               call iso_verif_noNAN(xtsnow(ixt,i,nsrf),
     :           'phyiso_etat0_dur 781')
               call iso_verif_noNAN(xtevap(ixt,i,nsrf),
     :           'phyiso_etat0_dur 783')
             enddo !do ixt=1,niso
             if (use_iso_eau.eq.1) then
             call iso_verif_egalite(xtsnow(iso_eau,i,nsrf),snow(i,nsrf),
     :                'phyiso_etat0_dur 787')        
             call iso_verif_egalite(xtevap(iso_eau,i,nsrf),evap(i,nsrf),
     :                 'phyiso_etat0_dur 789')           
             endif !if (use_iso_eau.eq.1) then 
         enddo !do nsrf=1,nbsrf
         if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
             if ((qsol(i).gt.ridicule_qsol).and.(xtsol(iso_O18,i)
     :           .gt.ridicule_qsol*tnat(iso_o18))) then
                call iso_verif_aberrant_o17(xtsol(iso_O17,i)
     :           /qsol(i),xtsol(iso_O18,i)
     :           /qsol(i),'phyisoeta0 193')
             endif
         endif
#ifdef ISOTRAC
         do nsrf=1,nbsrf
           call iso_verif_traceur_justmass(xtevap(1,i,nsrf),
     :                   'phyiso_etat0_dur 231')
         enddo !do nsrf=1,nbsrf
         do k=1,klev
                call iso_verif_traceur(xt_ancien(1,i,k),
     :                   'phyiso_etat0_dur 236')
         enddo !do k=1,klev
         call iso_verif_traceur(xtrain_fall(1,i),
     :                   'phyiso_etat0_dur 238')
         call iso_verif_traceur(xtsnow_fall(1,i),
     :                   'phyiso_etat0_dur 241')
#endif         
      enddo !do i=1,klon  
#endif

      return
      end

#endif

