#ifdef ISO
      subroutine phyiso_etat0_fichier(
     :           qsol,snow,evap,run_off_lic_0,
     :           xtsol,xtsnow,xtevap,xtrun_off_lic_0,
     :           Rland_ice)
      USE dimphy
      USE mod_grid_phy_lmdz
      USE mod_phys_lmdz_para
      USE iophy
      USE phys_state_var_mod
      USE iostart
      USE write_field_phy
      USE infotrac
        implicit none

#include "dimensions.h"
#include "netcdf.inc"
#include "indicesol.h"
#include "dimsoil.h"
#include "clesphys.h"
#include "temps.h"
#include "thermcell.h"
#include "compbl.h"    
#include "wateriso2.h"
#ifdef ISOVERIF
#include "iso_verif.h"   
#endif             

        ! inputs 
        REAL qsol(klon)
        REAL snow(klon,nbsrf)
        REAL evap(klon,nbsrf)
        REAL run_off_lic_0(klon)
        ! outputs   
        REAL xtsol(niso,klon)
        REAL xtsnow(niso,klon,nbsrf) 
        REAL xtevap(ntraciso,klon,nbsrf)     
        REAL xtrun_off_lic_0(niso,klon)
        REAL Rland_ice(niso,klon)

        ! locals
        real iso_tmp(klon)
        real iso_tmp_lonlev(klon,klev)
        real iso_tmp_lonsrf(klon,nbsrf)
        INTEGER ierr
        integer i,ixt,k,nsrf
        INTEGER nid, nvarid
        CHARACTER*2 str2
        CHARACTER*5 str5
        real xmin,xmax    
        CHARACTER*50 striso_sortie  
        integer lnblnk
      LOGICAL :: found

#ifdef ISOVERIF
      integer iso_verif_egalite_nostop
#endif
#ifdef ISOVERIFIDRIS
        real deltaD
#endif
#ifdef ISOVERIFNAN
        integer iso_verif_noNaN_nostop
#endif
#ifdef ISOTRAC
        integer iiso,izone
#endif


        write(*,*) 'phyiso_etat0_fichier 3'
        write(*,*) 'niso,striso(1)=',niso,striso(1)

        do ixt=1,niso
         write(*,*) 'ixt,striso(ixt)=',ixt,striso(ixt)
         if (ixt.gt.niso) then
            write(*,*) 'phyiso_etat0_fichier 49: ixt=',ixt
            stop
         endif !if (ixt.gt.niso) then

!        WRITE(str2,'(i2.2)') ixt
!        write(*,*) 'phyiso_etat0_fichier: str2='//str2

      striso_sortie='XTSOL'//striso(ixt)         
      write(*,*) 'striso_sortie=<',striso_sortie
     :   (1:lnblnk(striso_sortie)),'>'
      CALL get_field(striso_sortie(1:lnblnk(striso_sortie)),
     :  iso_tmp,found)
      IF (.NOT. found) THEN
         PRINT*, "phyetat0: Le champ <XTSOL> est absent"
         PRINT*, "Depart legerement fausse. Mais je continue"
         iso_tmp = 0.
      ENDIF !IF (.NOT. found) THEN
      xmin = 1.0E+20
      xmax = -1.0E+20
      xmin = MINval(iso_tmp)
      xmax = MAXval(iso_tmp)
      PRINT*,'(ecart-type) xtsol:', xmin, xmax
      do i=1,klon
          xtsol(ixt,i)=iso_tmp(i)
#ifdef ISOVERIFNAN
!          if (ixt.eq.1) then
!          write(*,*) 'i,klon,xtsol(ixt,i)=',i,klon,xtsol(ixt,i)
!          endif
          if (iso_verif_noNaN_nostop(xtsol(ixt,i),
     :          'phyiso_etat0_fichier 95').eq.1) then
            write(*,*) 'ixt,i=',ixt,i
            stop
          endif
#endif            
      enddo !do i=1,klon


      striso_sortie='XTSNOW'//striso(ixt)     
      write(*,*) 'striso_sortie=<',striso_sortie
     :   (1:lnblnk(striso_sortie)),'>'
      CALL get_field(striso_sortie(1:lnblnk(striso_sortie)),
     :           iso_tmp,found)
      IF (.NOT. found) THEN
         PRINT*, 'phyisoetat0_fichier: Le champ <XTSNOW> est absent'
         PRINT*, '          Mais je vais essayer de lire XTSNOW**'
         DO nsrf = 1, nbsrf
           IF (nsrf.GT.99) THEN
             PRINT*, "Trop de sous-mailles"
             CALL abort
           ENDIF
           WRITE(str2,'(i2.2)') nsrf
           striso_sortie="XTSNOW"//str2
           striso_sortie=striso_sortie(1:lnblnk(striso_sortie))
     :           //striso(ixt)
           
           write(*,*) 'striso_sortie=<',striso_sortie
     :       (1:lnblnk(striso_sortie)),'>'
           CALL get_field(striso_sortie(1:lnblnk(striso_sortie)),
     :           iso_tmp)
           xmin = 1.0E+20
           xmax = -1.0E+20
           DO i = 1, klon
              xmin = MIN(iso_tmp(i),xmin)
              xmax = MAX(iso_tmp(i),xmax)
           ENDDO
           PRINT*,'snow XTSNOW**:', nsrf, xmin, xmax
           do i=1,klon
              xtsnow(ixt,i,nsrf)=iso_tmp(i)
           enddo !do i=1,klon
         ENDDO !DO nsrf = 1, nbsrf
      ELSE !IF (.NOT. found) THEN
         PRINT*, 'phyisoetat0_fichier: Le champ <XTSNOW> est present'
         PRINT*, '          J ignore donc les autres SNOW**'
         xmin = 1.0E+20
         xmax = -1.0E+20
         DO i = 1, klon
            xmin = MIN(iso_tmp(i),xmin)
            xmax = MAX(iso_tmp(i),xmax)
         ENDDO
         PRINT*,'snow <XTSNOW>', xmin, xmax
         DO nsrf = 2, nbsrf
         DO i = 1, klon
            xtsnow(ixt,i,nsrf) = iso_tmp(i)
         ENDDO
         ENDDO !DO nsrf = 2, nbsrf
      ENDIF !IF (.NOT. found) THEN

      
      write(*,*) 'striso_sortie=<',striso_sortie
     :   (1:lnblnk(striso_sortie)),'>'
      striso_sortie="XTEVAP"//striso(ixt)
      CALL get_field(striso_sortie(1:lnblnk(striso_sortie)),
     :           iso_tmp,found)
      IF (.NOT. found) THEN
         PRINT*, 'phyisoetat0_fichier: Le champ <XTEVAP> est absent'
         PRINT*, '          Mais je vais essayer de lire XTEVAP**'
         DO nsrf = 1, nbsrf
           IF (nsrf.GT.99) THEN
             PRINT*, "Trop de sous-mailles"
             CALL abort
           ENDIF
           WRITE(str2,'(i2.2)') nsrf
           striso_sortie="XTEVAP"//str2
           striso_sortie=striso_sortie
     :           (1:lnblnk(striso_sortie))//striso(ixt)
           CALL get_field(striso_sortie
     :           (1:lnblnk(striso_sortie)), iso_tmp)
           xmin = 1.0E+20
           xmax = -1.0E+20
           DO i = 1, klon
              xmin = MIN(iso_tmp(i),xmin)
              xmax = MAX(iso_tmp(i),xmax)
           ENDDO
           PRINT*,'evap du sol EVAP**:', nsrf, xmin, xmax
           do i=1,klon
              xtevap(ixt,i,nsrf)=iso_tmp(i)
           enddo !do i=1,klon
         ENDDO !DO nsrf = 1, nbsrf
      ELSE !IF (.NOT. found) THEN
         PRINT*, 'phyetat0: Le champ <XTEVAP> est present'
         PRINT*, '          J ignore donc les autres XTEVAP**'
         xmin = 1.0E+20
         xmax = -1.0E+20
         DO i = 1, klon
            xmin = MIN(iso_tmp(i),xmin)
            xmax = MAX(iso_tmp(i),xmax)
         ENDDO
         PRINT*,'Evap du sol <XTEVAP>', xmin, xmax
         DO nsrf = 2, nbsrf
         DO i = 1, klon
            xtevap(ixt,i,nsrf) = iso_tmp(i)
         ENDDO
         ENDDO !DO nsrf = 2, nbsrf
      ENDIF !IF (.NOT. found) THEN

      striso_sortie="xtrain_f"//striso(ixt)
      CALL get_field(striso_sortie(1:lnblnk(striso_sortie)),
     :  iso_tmp,found)
      IF (.NOT. found) THEN
         PRINT*, "phyisoetat0_fichier: Le champ <xtrain_f> est absent"
         PRINT*, "Depart legerement fausse. Mais je continue"
         iso_tmp = 0.
      ENDIF !IF (.NOT. found) THEN
      xmin = 1.0E+20
      xmax = -1.0E+20
      xmin = MINval(iso_tmp)
      xmax = MAXval(iso_tmp)
      PRINT*,'(ecart-type) xtrain_f:', xmin, xmax
      do i=1,klon
            xtrain_fall(ixt,i)=iso_tmp(i)
      enddo !do i=1,klon

      striso_sortie="xtsnow_f"//striso(ixt)
      CALL get_field(striso_sortie(1:lnblnk(striso_sortie)),
     :  iso_tmp,found)
      IF (.NOT. found) THEN
         PRINT*, "phyisoetat0_fichier: Le champ <xtsnow_f> est absent"
         PRINT*, "Depart legerement fausse. Mais je continue"
         iso_tmp = 0.
      ENDIF !IF (.NOT. found) THEN
      xmin = 1.0E+20
      xmax = -1.0E+20
      xmin = MINval(iso_tmp)
      xmax = MAXval(iso_tmp)
      PRINT*,'(ecart-type) xtsnow_f:', xmin, xmax
      do i=1,klon
            xtsnow_fall(ixt,i)=iso_tmp(i)
      enddo !do i=1,klon

#ifdef ISO
#ifdef ISOVERIF 
      if (use_iso_eau.eq.1) then
        do i=1,klon
         call iso_verif_egalite(xtsnow_fall(iso_eau,i),snow_fall(i),
     :           'phyisoetat0_fichier 231')
        enddo !do i=1,klon
      endif !if (use_iso_eau.eq.1) then
#endif    
#endif  

      striso_sortie="Rland_ice"//striso(ixt)
      CALL get_field(striso_sortie(1:lnblnk(striso_sortie)),
     :  iso_tmp,found)
      IF (.NOT. found) THEN
         PRINT*, "phyisoetat0_fichier: Le champ <Rland_ice> est absent"
         PRINT*, "Depart legerement fausse. Mais je continue"
         iso_tmp = 0.
      ENDIF !IF (.NOT. found) THEN
      xmin = 1.0E+20
      xmax = -1.0E+20
      xmin = MINval(iso_tmp)
      xmax = MAXval(iso_tmp)
      PRINT*,'(ecart-type) xtsnow_f:', xmin, xmax
      do i=1,klon
            Rland_ice(ixt,i)=iso_tmp(i)
      enddo !do i=1,klon

        if (ixt.gt.niso) then
               write(*,*) 'phyiso_etat0_fichier 217: ixt=',ixt
               stop
        endif !if (ixt.gt.niso) then

       striso_sortie="XTANCIEN"//striso(ixt)
       write(*,*) 'striso_sortie=<',striso_sortie
     :       (1:lnblnk(striso_sortie)),'>'
       CALL get_field(striso_sortie(1:lnblnk(striso_sortie)),
     :  iso_tmp_lonlev,found)
      IF (.NOT. found) THEN
         PRINT*, "phyetat0: Le champ <XTANCIEN> est absent"
         PRINT*, "Depart legerement fausse. Mais je continue"
      ENDIF !IF (.NOT. found) THEN
      do k=1,klev
      do i=1,klon
            xt_ancien(ixt,i,k)=iso_tmp_lonlev(i,k)
      enddo !do i=1,klon
      enddo !do k=1,klev

#ifdef ISOVERIF            
            if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then
              do k=1,klev
               do i=1,klon
                if (q_ancien(i,k).gt.2e-3) then
                call iso_verif_positif(deltaD(xt_ancien(iso_hdo,i,k)
     :           /q_ancien(i,k))+400.0,'phyisoetat0_fichier 312')
                endif !if (q_ancien(i,k).gt.2e-3) then
               enddo !do i=1,klon
              enddo !do k=1,klev
!              write(*,*) 'xt_ancien(iso_hdo,149,3)=',
!     :           xt_ancien(iso_hdo,149,3)
!              write(*,*) 'q_ancien(149,3)=',
!     :           q_ancien(149,3)
            endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then
#endif

            
      write(*,*) 'phyiso_etat0_fichier tmp 308:'
      write(*,*) 'run_off_lic_0(60)=',run_off_lic_0(60)
      write(*,*) 'run_off_lic_0(418)=',run_off_lic_0(418)
      write(*,*) 'run_off_lic_0(6)=',run_off_lic_0(6)

      striso_sortie="XTRUNOFFLIC0"//striso(ixt)
      write(*,*) 'phyiso_etat0_fichier 305: striso_sortie=<',
     :   striso_sortie(1:lnblnk(striso_sortie)),'>'
      CALL get_field(striso_sortie(1:lnblnk(striso_sortie)),
     :  iso_tmp,found)
      IF (.NOT. found) THEN
         PRINT*, "phyetat0: Le champ <XTRUNOFFLIC0> est absent"
         PRINT*, "Depart legerement fausse. Mais je continue"
         iso_tmp = 0.
      ENDIF !IF (.NOT. found) THEN
      xmin = 1.0E+20
      xmax = -1.0E+20
      xmin = MINval(iso_tmp)
      xmax = MAXval(iso_tmp)
      PRINT*,'(ecart-type) xtrun_off_lic_0:', xmin, xmax
      do i=1,klon
            xtrun_off_lic_0(ixt,i)=iso_tmp(i)
      enddo !do i=1,klon
#ifdef ISOVERIF   
      if (use_iso_eau.eq.1) then   
        do i=1,klon
          if (iso_verif_egalite_nostop(run_off_lic_0(i),
     :           xtrun_off_lic_0(iso_eau,i),
     :          'phyiso_etat0_fichier 326').eq.1) then
            write(*,*) 'i=',i
            stop
          endif !if (iso_verif_egalite_nostop(run_off_lic_0(i),
        enddo !do i=1,klon
      endif !if (use_iso_eau.eq.1) then 
#endif

      striso_sortie="WAKE_DELTAXT"//striso(ixt)
      write(*,*) 'striso_sortie=<',striso_sortie
     :   (1:lnblnk(striso_sortie)),'>'
      CALL get_field(striso_sortie(1:lnblnk(striso_sortie)),
     :  iso_tmp_lonlev,found)
      IF (.NOT. found) THEN
        PRINT*, "phyetat0: Le champ <WAKE_DELTAXT> est absent"
        PRINT*, "Depart legerement fausse. Mais je continue"
        iso_tmp_lonlev=0.
      ELSE !IF (.NOT. found) THEN
        xmin = 1.0E+20
        xmax = -1.0E+20
        DO k = 1, klev
          DO i = 1, klon
            xmin = MIN(iso_tmp_lonlev(i,k),xmin)
            xmax = MAX(iso_tmp_lonlev(i,k),xmax)
          ENDDO !DO i = 1, klon
        ENDDO !DO k = 1, klev
        PRINT*,'wake_deltaxt:', xmin, xmax
      ENDIF !IF (.NOT. found) THEN
      do k=1,klev
      do i=1,klon
            wake_deltaxt(ixt,i,k)=iso_tmp_lonlev(i,k)
      enddo !do i=1,klon
      enddo !do k=1,klev


      enddo !do ixt=1,niso

#ifdef ISOTRAC

        if (initialisation_isotrac.eq.0) then

        do ixt=niso+1,ntraciso
        iiso=index_iso(ixt)
        izone=index_zone(ixt)

       striso_sortie='_iso'// striso(iiso)
       striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//'_'
       striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//
     :           strtrac(izone)
        write(*,*) 'striso_sortie=',
     :           striso_sortie(1:lnblnk(striso_sortie))
      CALL get_field("XTEVAP"//striso_sortie
     :           (1:lnblnk(striso_sortie)),iso_tmp,found)
      IF (.NOT. found) THEN
         PRINT*, 'phyetat0: Le champ <XTEVAP> est absent'
         PRINT*, '          Mais je vais essayer de lire XTEVAP**'
         DO nsrf = 1, nbsrf
           IF (nsrf.GT.99) THEN
             PRINT*, "Trop de sous-mailles"
             CALL abort
           ENDIF
           WRITE(str2,'(i2.2)') nsrf
           striso_sortie=str2//striso_sortie
     :           (1:lnblnk(striso_sortie))
           CALL get_field("XTEVAP"//striso_sortie
     :           (1:lnblnk(striso_sortie)), iso_tmp)
           xmin = 1.0E+20
           xmax = -1.0E+20
           DO i = 1, klon
              xmin = MIN(iso_tmp(i),xmin)
              xmax = MAX(iso_tmp(i),xmax)
           ENDDO
           PRINT*,'evap du sol EVAP**:', nsrf, xmin, xmax
           do i=1,klon
              xtevap(ixt,i,nsrf)=iso_tmp(i)
           enddo !do i=1,klon
         ENDDO !DO nsrf = 1, nbsrf
      ELSE !IF (.NOT. found) THEN
         PRINT*, 'phyetat0: Le champ <XTEVAP> est present'
         PRINT*, '          J ignore donc les autres XTEVAP**'
         xmin = 1.0E+20
         xmax = -1.0E+20
         DO i = 1, klon
            xmin = MIN(iso_tmp(i),xmin)
            xmax = MAX(iso_tmp(i),xmax)
         ENDDO
         PRINT*,'Evap du sol <XTEVAP>', xmin, xmax
         DO nsrf = 2, nbsrf
         DO i = 1, klon
            xtevap(ixt,i,nsrf) = iso_tmp(i)
         ENDDO
         ENDDO !DO nsrf = 2, nbsrf
      ENDIF !IF (.NOT. found) THEN
      
      CALL get_field("xtrain_f"//striso_sortie
     :            (1:lnblnk(striso_sortie)),iso_tmp,found)
      IF (.NOT. found) THEN
         PRINT*, "phyetat0: Le champ <xtrain_f> est absent"
         PRINT*, "Depart legerement fausse. Mais je continue"
         iso_tmp = 0.
      ENDIF
      xmin = 1.0E+20
      xmax = -1.0E+20
      xmin = MINval(iso_tmp)
      xmax = MAXval(iso_tmp)
      PRINT*,'(ecart-type) xtrain_f:', xmin, xmax
      do i=1,klon
            xtrain_fall(ixt,i)=iso_tmp(i)
      enddo !do i=1,klon

      CALL get_field("xtsnow_f"//striso_sortie
     :            (1:lnblnk(striso_sortie)),iso_tmp,found)
      IF (.NOT. found) THEN
         PRINT*, "phyetat0: Le champ <xtsnow_f> est absent"
         PRINT*, "Depart legerement fausse. Mais je continue"
         iso_tmp = 0.
      ENDIF
      xmin = 1.0E+20
      xmax = -1.0E+20
      xmin = MINval(iso_tmp)
      xmax = MAXval(iso_tmp)
      PRINT*,'(ecart-type) xtsnow_f:', xmin, xmax
      do i=1,klon
            xtsnow_fall(ixt,i)=iso_tmp(i)
      enddo !do i=1,klon

      CALL get_field("XTANCIEN"//striso_sortie
     :            (1:lnblnk(striso_sortie)),iso_tmp_lonlev,found)
      IF (.NOT. found) THEN
         PRINT*, "phyetat0: Le champ <XTANCIEN> est absent"
         PRINT*, "Depart legerement fausse. Mais je continue"
         ancien_ok = .FALSE.
      ENDIF
      do k=1,klev
      do i=1,klon
            xt_ancien(ixt,i,k)=iso_tmp_lonlev(i,k)
      enddo !do i=1,klon
      enddo  !do k=1,klev     


        enddo !do ixt=niso+1,ntraciso

        else !if (initialisation_isotrac.eq.0) then
          ! l'eau normale est mise dans la zone izone_init
           do ixt=niso+1,ntraciso
             if (index_zone(ixt).eq.izone_init) then
                do i=1,klon
                 do nsrf = 1, nbsrf
                  xtevap(ixt,i,nsrf)=xtevap(index_iso(ixt),i,nsrf)
                 enddo !do nsrf = 1, nbsrf
                 xtsnow_fall(ixt,i)=xtsnow_fall(index_iso(ixt),i)
                 xtrain_fall(ixt,i)=xtrain_fall(index_iso(ixt),i)
                 do k=1,klev
                   xt_ancien(ixt,i,k)=xt_ancien(index_iso(ixt),i,k)
                 enddo
                enddo !do i=1,klon
             else !if (index_zone(ixt).eq.izone_init) then
                do i=1,klon
                 do nsrf = 1, nbsrf
                  xtevap(ixt,i,nsrf)=0.0
                 enddo !do nsrf = 1, nbsrf
                 xtsnow_fall(ixt,i)=0.0
                 xtrain_fall(ixt,i)=0.0
                 do k=1,klev
                   xt_ancien(ixt,i,k)=0.0
                 enddo
                enddo !do i=1,klon
             endif !if (index_zone(ixt).eq.izone_init) then
           enddo  !do ixt=1,niso

      endif !if (initialisation_isotrac.eq.0) then


#ifdef ISOVERIF
        DO nsrf = 1, nbsrf
         do i=1,klon
               call iso_verif_traceur(xtevap(1,i,nsrf),
     :                   'phyiso_etat0_fichier 426')
         enddo !do i=1,klon 
        enddo !DO nsrf = 1, nbsrf
        do i=1,klon
           call iso_verif_traceur(xtrain_fall(1,i),
     :                   'phyiso_etat0_fichier 466')
           call iso_verif_traceur(xtsnow_fall(1,i),
     :                   'phyiso_etat0_fichier 468')
        enddo !do i=1,klon 
        do k=1,klev
          do i=1,klon
               call iso_verif_traceur(xt_ancien(1,i,k),
     :                   'phyiso_etat0_fichier 591')
          enddo !do i=1,klon
        enddo !do k=1,klev             
#endif 
        ! endif ISOVERIF       
#endif  
        ! endif ISOTRAC      

c on ferme le fichier
      CALL close_startphy



        return
        end
#endif

