#ifdef ISO
      SUBROUTINE phyisoetat0 (qsol,snow,evap,run_off_lic_0,
     :           xtsol,xtsnow,xtevap,xtrun_off_lic_0,
     :           Rland_ice) 
      USE dimphy
      USE mod_grid_phy_lmdz
      USE mod_phys_lmdz_para
      USE iophy
      USE phys_state_var_mod
      USE iostart
      USE write_field_phy
      USE infotrac
       implicit none   

      ! equivalent de phyetat0 pour les isotopes  

#include "dimensions.h"
#include "netcdf.inc"
#include "indicesol.h"
#include "dimsoil.h"
#include "clesphys.h"
#include "temps.h"
#include "thermcell.h"
#include "compbl.h"      
#include "wateriso2.h"

#ifdef ISOVERIF
#include "iso_verif.h"
      real deltaD
#endif        
      ! arguments  
      real xtsol(niso,klon) 
      real xtsnow(niso,klon,nbsrf)  
      real xtevap(ntraciso,klon,nbsrf)  
      real xtrun_off_lic_0(niso,klon)
      real Rland_ice(niso,klon)

      REAL qsol(klon)
      REAL snow(klon,nbsrf)
      REAL evap(klon,nbsrf)
      REAL run_off_lic_0(klon)

      ! locals
      integer ixt,i,k,nsrf

!      character*50 text

!      write(*,*) 'phyisoetat0 20: fichnom=',fichnom
      write(*,*) 'initialisation_iso=',initialisation_iso

      write(*,*) 'phyisoetat0 tmp 51:'
      write(*,*) 'run_off_lic_0(60)=',run_off_lic_0(60)
      write(*,*) 'run_off_lic_0(418)=',run_off_lic_0(418)
      write(*,*) 'run_off_lic_0(6)=',run_off_lic_0(6)

      if (initialisation_iso.eq.0) then
          call phyiso_etat0_fichier(
     :           qsol,snow,evap,run_off_lic_0,
     :           xtsol,xtsnow,xtevap,xtrun_off_lic_0,
     :           Rland_ice)
      else
        write(*,*) 'phyisoetat0 57:'
        write(*,*) 'initialisation_iso=',initialisation_iso
!          stop
          call phyiso_etat0_dur(
     :         xtsol,xtsnow, xtevap
     :         ,xtrun_off_lic_0, Rland_ice
     :         ,qsol,snow,evap,run_off_lic_0)
      endif


      ! verif
!      text="phyisoetat0 67"
!      write(*,*) 'snow(8,1)=',snow(8,1)
!      write(*,*) 'xtsnow(4,8,1)=',xtsnow(4,8,1)
#ifdef ISOVERIFIDRIS
      do i=1,klon
         do ixt=1,niso
         call iso_verif_noNaN(xtsol(ixt,i),'phyisoetat0 753')
         call iso_verif_noNaN(xtrain_fall(ixt,i),'phyisoetat0 754')
         call iso_verif_noNaN(xtsnow_fall(ixt,i),'phyisoetat0 755')
         call iso_verif_noNaN(xtrun_off_lic_0(ixt,i),'phyisoetat0 756')
         enddo !do ixt=1,niso
      enddo !do i=1,klon
#endif      
#ifdef ISOVERIF
      do i=1,klon
         if (use_iso_eau.eq.1) then
         call iso_verif_egalite(xtsol(iso_eau,i),qsol(i),
     :           'phyisoetat0 759')
         call iso_verif_egalite(xtrain_fall(iso_eau,i),rain_fall(i),
     :            'phyisoetat0 760')
         call iso_verif_egalite(xtsnow_fall(iso_eau,i),snow_fall(i),
     :           'phyisoetat0 761')
         call iso_verif_egalite(xtrun_off_lic_0(iso_eau,i),
     :           run_off_lic_0(i), 'phyisoetat0 762')
         endif !if (use_iso_eau.eq.1) then
         do k=1,klev
           do ixt=1,niso
              call iso_verif_noNAN(xt_ancien(ixt,i,k),
     :           'phyisoetat0 771')        
           enddo !do ixt=1,niso
           if (use_iso_eau.eq.1) then
             call iso_verif_egalite(xt_ancien(iso_eau,i,k),
     :           q_ancien(i,k),'phyisoetat0 775')        
           endif !if (use_iso_eau.eq.1) then
           if (use_iso_hdo.eq.1) then
            if (q_ancien(i,k).gt.2e-3) then
!                write(*,*) 'i,k=',i,k
             call iso_verif_positif(deltaD(xt_ancien(iso_hdo,i,k)
     :           /q_ancien(i,k))+400.0,'phyisoetat0 103')
            endif
           endif !if (use_iso_hdo.eq.1) then
#ifdef ISOTRAC      
           call iso_verif_traceur(xt_ancien(1,i,k),
     :           'phyisoetat0 111')
#endif           
         enddo !do k=1,klev
        do nsrf=1,nbsrf
          do ixt=1,niso
               call iso_verif_noNAN(xtsnow(ixt,i,nsrf),
     :           'phyisoetat0 781')
               call iso_verif_noNAN(xtevap(ixt,i,nsrf),
     :           'phyisoetat0 783')
          enddo !do ixt=1,niso
#ifdef ISOTRAC      
           call iso_verif_traceur_justmass(xtevap(1,i,nsrf),
     :           'phyisoetat0 123')
#endif 
          if (use_iso_eau.eq.1) then
            call iso_verif_egalite(xtsnow(iso_eau,i,nsrf),snow(i,nsrf),
     :                'phyisoetat0 787')
            call iso_verif_egalite(xtevap(iso_eau,i,nsrf),evap(i,nsrf),
     :                   'phyisoetat0 75')
          endif !if (use_iso_eau) then
          if (use_iso_hdo.eq.1) then
            if (snow(i,nsrf).gt.ridicule_snow) then
            call iso_verif_aberrant(xtsnow(iso_hdo,i,nsrf)/snow(i,nsrf),
     :                'phyisoetat0 117')
            endif
          endif !if (use_iso_eau) then
        enddo !do nsrf=1,nbsrf
      enddo !do i=1,klon
      do i=1,klon
        if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1)) then
             if ((qsol(i).gt.ridicule_qsol).and.(xtsol(iso_O18,i)
     :           .gt.ridicule_qsol*tnat(iso_o18))) then
                call iso_verif_aberrant_o17(xtsol(iso_O17,i)
     :           /qsol(i),xtsol(iso_O18,i)
     :           /qsol(i),'phyisoetat0 123')
             endif
         endif 
       enddo !do i=1,klon

#endif
      !end verif


      RETURN
      END      
      

#endif      


