#ifdef ISO
      SUBROUTINE phyisoredem (
     :          xtsol,xtsnow,xtevap,
     :          xtrun_off_lic_0,Rland_ice,
     :          run_off_lic_0) 
      USE dimphy
      USE mod_grid_phy_lmdz
      USE mod_phys_lmdz_para
      USE phys_state_var_mod
      USE iostart
      USE infotrac
      USE control_mod

        implicit none

        ! equivalent isotopique de phyredem


#include "netcdf.inc"
#include "indicesol.h"
#include "dimsoil.h"
#include "clesphys.h"
#include "temps.h"
#include "thermcell.h"
#include "compbl.h"      
#include  "wateriso2.h"
#ifdef ISOVERIF        
#include  "iso_verif.h" 
#endif             
      ! inputs
      REAL xtsol(niso,klon)
      REAL xtsnow(niso,klon,nbsrf) 
      REAL xtevap(ntraciso,klon,nbsrf)     
      REAL xtrun_off_lic_0(niso,klon)
      REAL Rland_ice(niso,klon)
      real run_off_lic_0(klon)

      ! locals
      real iso_tmp(klon)
      real iso_tmp_lonlev(klon,klev)
      real iso_tmp_lonsrf(klon,nbsrf)
      integer i,ixt,k,nsrf
      INTEGER nid, nvarid
      INTEGER ierr
      CHARACTER*7 str7
      CHARACTER*2 str2
      CHARACTER*50 striso_sortie
      integer lnblnk
#ifdef ISOTRAC
      integer iiso,izone
#endif      
#ifdef ISOVERIF      
      integer iso_verif_egalite_nostop
#endif             

      write(*,*) 'phyisoredem 41: entre'
#ifdef ISOVERIF
      do k=1,klev
        do i=1,klon
          if (use_iso_eau.eq.1) then
           call iso_verif_egalite(xt_ancien(iso_eau,i,k),q_ancien(i,k),
     :           'phyisoredem 50')
          endif ! if (use_iso_eau.eq.1) then 
#ifdef ISOTRAC          
          call iso_verif_traceur(xt_ancien(1,i,k),
     :                   'phyisoredem 60')  
#endif          
        enddo !do i=1,klon
      enddo !do k=1,klev
#endif
#ifdef ISOVERIFNAN
      do i=1,klon
       do ixt=1,niso
        call iso_verif_noNaN(xtsol(ixt,i),'phyisoredem 72')
       enddo !do ixt=1,niso
      enddo !do i=1,klon
#endif

      do ixt=1,niso

      do i=1,klon
           iso_tmp(i)=xtsol(ixt,i)
      enddo !do i=1,klon
      CALL put_field("XTSOL"//striso(ixt),
     :   "Eau dans le sol (mm)",iso_tmp)
      
      DO nsrf = 1, nbsrf
        IF (nsrf.LE.99) THEN
          do i=1,klon
           iso_tmp(i)=xtevap(ixt,i,nsrf)
          enddo !do i=1,klon
          WRITE(str2,'(i2.2)') nsrf
          striso_sortie="XTEVAP"//str2
          striso_sortie=striso_sortie(1:lnblnk(striso_sortie))
     :           //striso(ixt)
          CALL put_field(striso_sortie(1:lnblnk(striso_sortie)),
     :           "Evaporation de surface No."//str2
     .                   ,iso_tmp)
        ELSE
          PRINT*, "Trop de sous-mailles"
          CALL abort
        ENDIF
      ENDDO ! DO nsrf = 1, nbsrf

      DO nsrf = 1, nbsrf
        IF (nsrf.LE.99) THEN
          do i=1,klon
           iso_tmp(i)=xtsnow(ixt,i,nsrf)
          enddo !do i=1,klon
          WRITE(str2,'(i2.2)') nsrf
          striso_sortie="XTSNOW"//str2
          striso_sortie=striso_sortie(1:lnblnk(striso_sortie))
     :           //striso(ixt)
          CALL put_field(striso_sortie(1:lnblnk(striso_sortie)),
     :           "Neige de surface No."//str2
     .                   ,iso_tmp)
        ELSE
          PRINT*, "Trop de sous-mailles"
          CALL abort
        ENDIF
      ENDDO ! DO nsrf = 1, nbsrf

      do i=1,klon
           iso_tmp(i)=xtrain_fall(ixt,i)
      enddo !do i=1,klon
      CALL put_field("xtrain_f"//striso(ixt),
     :   "precipitation liquide",iso_tmp)

      do i=1,klon
           iso_tmp(i)=xtsnow_fall(ixt,i)
      enddo !do i=1,klon
      CALL put_field("xtsnow_f"//striso(ixt),
     :   "precipitation solide",iso_tmp)

      do k=1,klev
       do i=1,klon
           iso_tmp_lonlev(i,k)=xt_ancien(ixt,i,k)
       enddo !do i=1,klon
      enddo
      CALL put_field("XTANCIEN"//striso(ixt),
     :   "XTANCIEN",iso_tmp_lonlev)


#ifdef ISOVERIF   
      if (use_iso_eau.eq.1) then   
        do i=1,klon
          if (iso_verif_egalite_nostop(run_off_lic_0(i),
     :         xtrun_off_lic_0(iso_eau,i),'phyisoredem 137')
     :         .eq.1) then
              write(*,*) 'i=',i
              stop
          endif
        enddo !do i=1,klon
      endif !if (use_iso_eau.eq.1) then 
#endif
      do i=1,klon
           iso_tmp(i)=xtrun_off_lic_0(ixt,i)
      enddo !do i=1,klon
      CALL put_field("XTRUNOFFLIC0"//striso(ixt),
     :   "Runofflic0",iso_tmp)

      do k=1,klev
       do i=1,klon
           iso_tmp_lonlev(i,k)=wake_deltaxt(ixt,i,k)
       enddo !do i=1,klon
      enddo
      CALL put_field("WAKE_DELTAXT"//striso(ixt),
     :   "WAKE_DELTAXT"//striso(ixt),
     :             iso_tmp_lonlev)

      do i=1,klon
           iso_tmp(i)=Rland_ice(ixt,i)
      enddo !do i=1,klon
      CALL put_field("Rland_ice"//striso(ixt),
     :   "ratio land ice",iso_tmp)

      enddo !do ixt=1,niso

#ifdef ISOTRAC
      do ixt=niso+1,ntraciso
      iiso=index_iso(ixt)
      izone=index_zone(ixt)
     
      DO nsrf = 1, nbsrf
        IF (nsrf.LE.99) THEN
          do i=1,klon
           iso_tmp(i)=xtevap(ixt,i,nsrf)
          enddo !do i=1,klon
          WRITE(str2,'(i2.2)') nsrf
          striso_sortie="XTEVAP"//str2
          striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//'_iso'
          striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//
     :           striso(iiso)
          striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//'_'
          striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//
     :           strtrac(izone)
          CALL put_field(striso_sortie(1:lnblnk(striso_sortie)),
     :           "Evaporation de surface No."//str2
     .                   ,iso_tmp)
        ELSE
          PRINT*, "Trop de sous-mailles"
          CALL abort
        ENDIF
      ENDDO ! DO nsrf = 1, nbsrf

      do i=1,klon
           iso_tmp(i)=xtrain_fall(ixt,i)
      enddo !do i=1,klon
      striso_sortie="xtrain_f"
      striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//'_iso'
      striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//
     :           striso(iiso)
       striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//'_'
       striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//
     :           strtrac(izone)
      CALL put_field(striso_sortie(1:lnblnk(striso_sortie)),
     :   "precipitation liquide",iso_tmp)

      do i=1,klon
           iso_tmp(i)=xtsnow_fall(ixt,i)
      enddo !do i=1,klon
      striso_sortie="xtsnow_f"
      striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//'_iso'
      striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//
     :           striso(iiso)
       striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//'_'
       striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//
     :           strtrac(izone)
      CALL put_field(striso_sortie(1:lnblnk(striso_sortie)),
     :   "precipitation solide",iso_tmp)

      do k=1,klev
       do i=1,klon
           iso_tmp_lonlev(i,k)=xt_ancien(ixt,i,k)
       enddo !do i=1,klon
      enddo
      striso_sortie="XTANCIEN"
      striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//'_iso'
      striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//
     :           striso(iiso)
       striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//'_'
       striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//
     :           strtrac(izone)
      CALL put_field(striso_sortie(1:lnblnk(striso_sortie)),
     :           "XTANCIEN",iso_tmp_lonlev)

      do k=1,klev
       do i=1,klon
           iso_tmp_lonlev(i,k)=wake_deltaxt(ixt,i,k)
       enddo !do i=1,klon
      enddo
      striso_sortie="WAKE_DELTAXT"
      striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//'_iso'
      striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//
     :           striso(iiso)
       striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//'_'
       striso_sortie=striso_sortie(1:lnblnk(striso_sortie))//
     :           strtrac(izone)
      CALL put_field(striso_sortie(1:lnblnk(striso_sortie)),
     :             "WAKE_DELTAXT",iso_tmp_lonlev)

      enddo !do ixt=niso+1,ntraciso
#endif      
c
      write(*,*) 'phyisoredem 261: sortie'
      RETURN
      END

#endif
