! subroutine gnrique de traitement de l'vaporation des gouttes
!  ne pas modifier sauf si vous tes surs de ce que vous faites.      

#ifdef ISO
      subroutine stewart_explicite_vectall(ncas,
     :           qp0,xtp0,Pqisup
     :           ,Pxtisup,Eqi,Pqiinf,qeff,
     :           Pxtiinf,xtnew,Exi,fac_ftmr,
     :           qs,Tevap,wt,deltaP
#ifdef ISOVERIF
     :          ,debug,il_debug
#endif
     :   )

        implicit none

        ! version vctorise: sur les isotopes et sur les points de
        ! grille
        ! on s'interresse  l'isotope ixt
        ! on a un air de proprit (q,xt) 
        ! on lui apporte une goutte de flux (Pqisup,Pxtisup)
        ! cette goutte s'vapore avec un flux Eqi
        ! on cherche le flux de sortie Pxtiinf et la nouvelle
        ! composition de l'air xtnew, sachant que qnew=q+Eqi*fac_ftmr
        
        ! declaration des variables      
#include "wateriso2.h"          
        ! **inputs
        integer ncas
        double precision qp0(ncas),xtp0(niso,ncas)
        double precision Pxtisup(niso,ncas)
        double precision Pqisup(ncas),Eqi(ncas),Pqiinf(ncas)
        real qs(ncas),qeff(ncas)
        double precision fac_ftmr(ncas)
        
        real Tevap(ncas)
        real deltaP(ncas),wt(ncas)
        
        ! **outputs
        double precision Pxtiinf(niso,ncas)
        double precision xtnew(niso,ncas)
        double precision Exi(niso,ncas)
        integer ixt
        
        ! **locals
        ! verifs
#include "iso_verif.h"
#ifdef ISOVERIF
        real deltaD,deltaO,O17excess
        double precision Rlfin(niso),Rbfin(niso)
        integer debug ! si 1: on sort  l'cran ce qui se passe en il_debug
        integer il_debug
#endif        

        ! intermediaires
        real h(ncas)
        double precision gama(niso,ncas), beta(niso,ncas), 
     :           interm(niso,ncas)
        real alphap(niso,ncas)
        double precision Rl0(niso,ncas), Rb0(niso,ncas), Rl(niso,ncas), 
     :           Rb(niso,ncas)
        double precision m(ncas), m0(ncas), A(ncas), qp(ncas)
        double precision J(niso,ncas),e(niso,ncas)
        double precision r_l0qp0(ncas), r_jqp0(niso,ncas), 
     :           r_jl0(niso,ncas)
        double precision f(ncas),g(ncas)
        double precision Revap(niso,ncas)
        double precision Revap0(niso,ncas)
        double precision Revapfin(niso,ncas)
        real fv(ncas)

        real double_to_real ! debugage
        double precision real_to_double        
        integer il
#ifdef ISOVERIFIDRIS
        integer iso_verif_aberrant_nostop
        integer iso_verif_egalite_choix_nostop
        integer iso_verif_egalite_nostop
        double precision Jtmp,etmp
#endif      
        integer iso_verif_noNaN_nostop
! calcul d'intgrale: mtode?
        ! si rieman:
!#define rieman 
        ! sinon: gauss.
        

        ! parsage
        integer trace(ncas)
        integer icas_Jsimple,ncas_Jsimple
        integer icas_rieman,ncas_rieman
        integer cas_Jsimple(ncas)
        integer cas_rieman(ncas)
        
        double precision m_cas(ncas), m0_cas(ncas),
     :     qp0_cas(ncas),A_cas(ncas),
     :     beta_cas(niso,ncas),gama_cas(niso,ncas),f_cas(ncas),
     :     g_cas(ncas),
     :     Rb0_cas(niso,ncas),Rl0_cas(niso,ncas),r_l0qp0_cas(ncas),
     :     Exi_cas(niso,ncas),Pxtiinf_cas(niso,ncas),
     :     Pxtisup_cas(niso,ncas),
     :     xtnew_cas(niso,ncas),Pqiinf_cas(ncas),
     :     Eqi_cas(ncas),xtp0_cas(niso,ncas)
        double precision fac_ftmr_cas(ncas)
!        integer ntot_cas(ncas)

!        include "dimiso.h"
        

        ! quelques verifs de bilan d'eau
#ifdef ISOVERIF      
        do il=1,ncas
          do ixt=1,niso
            call iso_verif_noNaN(double_to_real(Pxtisup(ixt,il)),
     :         'stewart_explicite_vectall 113') 
            call iso_verif_noNaN(double_to_real(xtp0(ixt,il)),
     :         'stewart_explicite_vectall 115') 
          enddo
        enddo !do il=1,ncas
#endif     
#ifdef ISOVERIF
!        write(*,*) 'stewart_explicite 50: entre'
        do il=1,ncas
        if (iso_verif_egalite_nostop(double_to_real(
     :           Pqisup(il)-Eqi(il)-Pqiinf(il)),0.0,
     :          'stewart_explicite 37' ).eq.1) then
          write(*,*) 'il,Pqisup(il),Eqi(il),Pqiinf(il)=',
     :          il,Pqisup(il),Eqi(il),Pqiinf(il) 
          stop
        endif !if (iso_verif_egalite
        enddo !do il=1,ncas 
        if (use_iso_eau.eq.1) then
           do il=1,ncas   
           call iso_verif_egalite_choix(double_to_real(Pqisup(il)),
     :           double_to_real(Pxtisup(iso_eau,il)),
     :          'stewart_explicite 38',errmax,errmaxrel) 
           call iso_verif_egalite_choix(double_to_real(
     :           xtp0(iso_eau,il)),
     :           double_to_real(qp0(il)),
     :          'stewart_explicite 58',errmax,errmaxrel)
           enddo !do il=1,ncas 
         endif !if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
#endif
         
!          write(*,*) 'stewart_explicite 88: Pqisup=',Pqisup
         do il=1,ncas 
          Pqisup(il)=max(Pqisup(il),0.0)
          do ixt=1,niso
           Pxtisup(ixt,il)=max(Pxtisup(ixt,il),0.0)           
          enddo !do ixt=1,niso
         enddo !do il=1,ncas   

        
        ! ***************** dbut des calculs **********
        
        icas_Jsimple=0
        icas_rieman=0
        do il=1,ncas ! ******************************

!        write(*,*) 'stewart_explicite 78: il=',il
!        write(*,*) 'stewart_explicite 112: Pqisup=',Pqisup
        !****** traitement rapide du cas sans pluie:
        if (Pqisup(il).lt.ridicule**2) then
!            write(*,*) 'stewart_explicit 96: cas pas de goutte'
            ! pas de pluie, pas de Pqiinf, pas de changement de vap
            ! cam verif
            ! le 21 dec 2012: on change le.0 en lt.ridicule**2 pour
            ! viter des Pqisup pathologiquement petits
#ifdef ISOVERIF
            if ((abs(Pqiinf(il)).gt.ridicule)
     :            .or.(abs(Eqi(il)).gt.ridicule)) then
                write(*,*) 'stewart_explicite 39'
                write(*,*) 'Pqisup=',Pqisup(il)
                write(*,*) 'Eqi=',Eqi(il)
                write(*,*) 'Eqi*fac_ftmr=',Eqi(il)*fac_ftmr(il)
                write(*,*) 'Pqiinf=',Pqiinf(il)
                stop
            endif     !if ((abs(Pqiinf).gt.ridicule)  
#endif 
            ! end cam verif
            do ixt=1,niso
              Pxtiinf(ixt,il)=0.0
            enddo
            if (abs(Eqi(il)*fac_ftmr(il)).gt.ridicule) then
                ! attention: pour des raisons obscures, il y a parfois
                ! de le rvaporation significative alors qu'il n'y a
                ! aucune goutte  rvaporer.
                ! Dans ce cas, on admet cette rvaporation obscure et
                ! on suppose qu'elle ne change pas la composition
                ! isotopique de la vapeur. 
                if (qp0(il).gt.ridicule) then
                   do ixt=1,niso
                   Rb0(ixt,il)=xtp0(ixt,il)/qp0(il)  
                   enddo
                else !if (qp0.gt.ridicule) then
                   ! il n'y a pas encore de vapeur dans le ddft. On est
                   ! trs embtt, mais on se dit que le ddft sera
                   ! bientot recharg par de la vapeur plus lgitime
                   do ixt=1,niso
                   Rb0(ixt,il)=0.0     
                   enddo ! do ixt=1,niso
                   if (use_iso_eau.eq.1) then
                        Rb0(iso_eau,il)=1.0
                   endif
                endif   !if (qp0.gt.ridicule) then
                do ixt=1,niso
                 Exi(ixt,il)=Rb0(ixt,il)*Eqi(il)
                 xtnew(ixt,il)=xtp0(ixt,il)+Exi(ixt,il)*fac_ftmr(il)
                enddo ! do ixt=1,niso
            else !if (abs(Eqi*fac_ftmr).gt.ridicule) then
                ! a va, tout est logique, tous les flux d'eau sont nuls
                do ixt=1,niso
                  xtnew(ixt,il)=xtp0(ixt,il)
                  Exi(ixt,il)=0.0
                enddo !do ixt=1,niso
            endif !if (abs(Eqi*fac_ftmr).gt.ridicule) then
#ifdef ISOVERIFNAN
            do ixt=1,niso
             call iso_verif_noNaN(double_to_real(Exi(ixt,il)),
     :             'stewart_explicite_vectall 206')
             call iso_verif_noNaN(double_to_real(xtnew(ixt,il)),
     :             'stewart_explicite_vectall 220')
            enddo
#endif
#ifdef ISOVERIF
              if (use_iso_eau.eq.1) then
                call iso_verif_egalite_choix(
     :              double_to_real(Exi(iso_eau,il)*fac_ftmr(il)),
     :              double_to_real(Eqi(il)*fac_ftmr(il)),
     :              'stewart_expilicit 125',errmax*10,errmaxrel*10)
                call iso_verif_egalite_choix(
     :                   double_to_real(Pxtiinf(iso_eau,il)),
     :                   double_to_real(Pqiinf(il)),
     :                  'stewart_explicite 143',errmax,errmaxrel)
                call iso_verif_egalite_choix(
     :                double_to_real(xtnew(iso_eau,il)),
     :                double_to_real(qp0(il)+Eqi(il)*fac_ftmr(il)),
     :                'stewart_explicite 218',errmax*10,errmaxrel*50) 
               endif !if (use_iso_eau.eq.1) then
               if ((use_iso_HDO.eq.1).and.
     :           (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule)) then
                 call iso_verif_aberrant(double_to_real(
     :                   xtnew(iso_HDO,il)/(qp0(il)+Eqi(il)
     :                   *fac_ftmr(il))),'stewart_explicite 214')
               endif !if ((use_iso_HDO.eq.1).and.
               if ((debug.eq.1).and.(il.eq.il_debug)) then
                   write(*,*) 'stewart_explicit 224: cas Pqisup<=0'
                   write(*,*) 'Eqi(il),deltaD=',Eqi(il),
     :                   deltaD(double_to_real(Exi(iso_HDO,il)/Eqi(il)))
               endif
#endif              
        else !if (Pqisup.eq.0) then

        h(il)=qeff(il)/qs(il)       
        h(il)= MAX(MIN(h(il),1.0),0.0)
#ifdef ISOVERIF        
        call iso_verif_positif(h(il)-thumxt1,'stewart_explicit 209') 
#endif        
        
        ! ******** cas avec eau: Pqisup>0
        ! cas ou pas d'vaporation -> tout reste pareil si pas de diff.
        ! en fait, tout reste pareil si h<1, car diff devient alors
        ! difficile
        if ((Eqi(il)*fac_ftmr(il).lt.ridicule).and.(h(il).lt.0.99)) then
!            write(*,*) 'stewart_explicite 137: cas pas d''vap'

            do ixt=1,niso
              Pxtiinf(ixt,il)=Pqiinf(il)*(Pxtisup(ixt,il)/Pqisup(il))
              Exi(ixt,il)=0.0
              xtnew(ixt,il)=xtp0(ixt,il)
            enddo !do ixt=1,niso

            ! verif
#ifdef ISOVERIFNAN
            do ixt=1,niso
              call iso_verif_noNAN(double_to_real(Pxtiinf(ixt,il)),
     :           'stewart_explicite 152') 
              call iso_verif_noNAN(double_to_real(xtnew(ixt,il)),
     :           'stewart_explicite 152b') 
            enddo
#endif
#ifdef ISOVERIF
            if (use_iso_eau.eq.1) then
              call iso_verif_egalite_choix(
     :                   double_to_real(Pxtiinf(iso_eau,il)),
     :                   double_to_real(Pqiinf(il)),
     :                  'stewart_explicite 143',errmax,errmaxrel)
              if (iso_verif_egalite_choix_nostop(
     :              double_to_real(Exi(iso_eau,il)*fac_ftmr(il)),
     :              double_to_real(Eqi(il)*fac_ftmr(il)),
     :              'stewart_explicit 283',errmax*10,errmaxrel*10)
     :              .eq.1) then
                write(*,*) 'il=',il
                write(*,*) 'Eqi(il)=',Eqi(il)
                write(*,*) 'fac_ftmr(il)=',fac_ftmr(il)
                stop
              endif
              if (Pqiinf(il).gt.ridicule) then
                  call iso_verif_egalite_choix
     :               (double_to_real(Pxtiinf(iso_eau,il)/Pqiinf(il)),
     :               1.,'stewart_explicite 143',errmax,errmaxrel)
              endif !if (Pqiinf.gt.ridicule) then
            endif !if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
            if (use_iso_HDO.eq.1) then
              if (Pqiinf(il).gt.ridicule_rain) then
                    call iso_verif_aberrant(
     :                double_to_real(Pxtiinf(iso_HDO,il)/Pqiinf(il)),
     :                'stewart_explicie 132')   
              endif   !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO).and.
              if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
                 call iso_verif_aberrant(double_to_real(
     :                   xtnew(iso_HDO,il)/(qp0(il)+Eqi(il)
     :                   *fac_ftmr(il))),'stewart_explicite 268')
              endif !if ((use_iso_HDO.eq.1).and.
            endif !if (use_iso_HDO.eq.1) then
            if ((debug.eq.1).and.(il.eq.il_debug)) then
                   write(*,*) 'stewart_explicit 302: cas evap~0'
                   write(*,*) 'deltaDv est inchang:',deltaD(
     :               double_to_real(xtnew(iso_HDO,il)/(qp0(il)
     :               +Eqi(il)*fac_ftmr(il))))
            endif
#endif                           
             ! end verif

         else !if ((Eqi(il)*fac_ftmr(il).lt.ridicule).and.(h(il).lt.0.99)) then     

        A(il)=wt(il)/deltaP(il)*fac_ftmr(il)
        m0(il)=max(Pqisup(il)*deltaP(il)/wt(il),0.0)
        m(il)=max(Pqiinf(il)*deltaP(il)/wt(il),0.0)      
        if (qp0(il).gt.ridicule*1e-3)  then
          do ixt=1,niso
           Rb0(ixt,il)=xtp0(ixt,il)/qp0(il)
          enddo
        else
          do ixt=1,niso  
           Rb0(ixt,il)=0.0 
          enddo !do ixt=1,niso
          if (use_iso_eau.eq.1) then
              Rb0(iso_eau,il)=1.0
          endif
        endif
        if (Pqisup(il).gt.ridicule*1e-3) then
          do ixt=1,niso  
           Rl0(ixt,il)=Pxtisup(ixt,il)/Pqisup(il)
          enddo !do ixt=1,niso 
        else ! if (Pqisup(il).gt.ridicule*1e-3) then
          do ixt=1,niso  
           Rl0(ixt,il)=0.0
          enddo !do ixt=1,niso 
          if (use_iso_eau.eq.1) then
              Rl0(iso_eau,il)=1.0
          endif
        endif ! if (Pqisup(il).gt.ridicule*1e-3) then
        f(il)=m(il)/m0(il)    
        ! verifs
#ifdef ISOVERIF        
        call iso_verif_positif(double_to_real(m(il)),
     :           'stewart_explicite 173')
        call iso_verif_positif(double_to_real(qp0(il)),
     :           'stewart_explicite 174')
          call iso_verif_positif(1.0-double_to_real(f(il)),
     :        'stewart_explicite 373')        
!          write(*,*) 'il,m0(il),m(il)=', il,m0(il),m(il)   
          call iso_verif_positif(double_to_real(m0(il))-
     :           double_to_real(m(il)),'stewart explicite 123') 
#endif
        qp0(il)=max(0.0,qp0(il))
        m(il)=min(m(il),m0(il))
        f(il)=min(f(il),1.0)
        f(il)=max(f(il),0.0)


#ifdef ISOVERIFNAN
        do ixt=1,niso
          if ((iso_verif_noNaN_nostop(double_to_real(Rl0(ixt,il)),
     :          'stewart_explicit 357').eq.1).or. 
     :          (iso_verif_noNaN_nostop(double_to_real(Rb0(ixt,il)),
     :          'stewart_explicit 359').eq.1)) then
            write(*,*) 'Pxtisup(ixt,il)=',Pxtisup(ixt,il)
            write(*,*) 'Pqisup(il)',Pqisup(il)
            write(*,*) 'xtp0(ixt,il)=',xtp0(ixt,il)
            write(*,*) 'qp0(il)=',qp0(il)
            stop
          endif !if ((iso_verif_noNaN_nostop
        enddo !do ixt=1,niso
#endif              
#ifdef ISOVERIF
          if (use_iso_eau.eq.1) then
            call iso_verif_egalite_choix(
     :           double_to_real(xtp0(iso_eau,il)),
     :           double_to_real(qp0(il)),'stewart_explicit 199',
     :           errmax,errmaxrel)  
            if (iso_verif_egalite_choix_nostop(
     :           double_to_real(Rb0(iso_eau,il)),1.0,
     :           'stewart_explicit 136',
     :           errmax*10,errmaxrel*10).eq.1) then
               write(*,*) 'xtp0,qp0,Rb0=',
     :           xtp0(iso_eau,il),qp0(il),Rb0(iso_eau,il)
               stop
            endif !if (iso_verif_egalite_choix_nostop(
            call iso_verif_egalite_choix(double_to_real(
     :           Pxtisup(iso_eau,il)),double_to_real(Pqisup(il)),
     :           'stewart_explicit 208',errmax,errmaxrel)
            if (iso_verif_egalite_choix_nostop(
     :           double_to_real(Rl0(iso_eau,il)),1.0,
     :        'stewart_explicit 209',errmax,errmaxrel).eq.1) then
              write(*,*) 'Pxtisup(iso_eau,il),Pqisup=',
     :                   Pxtisup(iso_eau,il),Pqisup(il)
              stop
            endif !if (iso_verif_egalite_choix_nostop(
            ! rajout verif 4 sept 2009
            if (use_iso_HDO.eq.1) then
             if (Pqisup(il).gt.ridicule) then
                call iso_verif_aberrant(double_to_real(Rl0(iso_HDO,il)),
     :                   'stewart_explicite 368')
             endif
            endif
          endif !(use_iso_eau.eq.1)
#endif
        ! end verif

                
        ! **** cas o m=0 <-> f=0
        if ((f(il).lt.1e-9).or.(Pqiinf(il).lt.ridicule/10.)) then
            !write(*,*) 'stewart_explicit 137: cas f=0: il=',il
          do ixt=1,niso 
            Pxtiinf(ixt,il)=0.0 ! plus rien ne ressors           
!            Exi(ixt,il)=Eqi(il)*(Pxtisup(ixt,il)/Pqisup(il)) ! tout se rvapore en totalit
            Exi(ixt,il)=Eqi(il)*  Rl0(ixt,il)  ! modif le 21 dec 2012
            !Exi=max(Exi,0) 
            !xtnew=(xtp0+Rl0*m0*A) 
            xtnew(ixt,il)=xtp0(ixt,il)+Exi(ixt,il)*fac_ftmr(il)
            xtnew(ixt,il)=max(xtnew(ixt,il),0.0)
          enddo !do ixt=1,niso      
                ! cam verifs
#ifdef ISOVERIFNAN
          do ixt=1,niso      
                call iso_verif_noNAN(double_to_real(Pxtiinf(ixt,il)),
     :                   'stewart_explicite 259')
                call iso_verif_noNAN(double_to_real(Exi(ixt,il)),
     :                   'stewart_explicite 260')
                call iso_verif_noNAN(double_to_real(xtnew(ixt,il)),
     :                   'stewart_explicite 271')
           enddo !do ixt=1,niso   
#endif
#ifdef ISOVERIF  
           if (use_iso_eau.eq.1) then
              call iso_verif_egalite_choix(
     :                   double_to_real(Pxtiinf(iso_eau,il)),
     :                   double_to_real(Pqiinf(il)),
     :                  'stewart_explicite 168',errmax,errmaxrel)
              call iso_verif_egalite_choix(
     :                  double_to_real(Exi(iso_eau,il)),
     :                  double_to_real(Eqi(il)),'stewart_explicite 169',
     :                  errmax,errmaxrel)
              call iso_verif_egalite_choix(
     :                  double_to_real(Exi(iso_eau,il)*fac_ftmr(il)),
     :                  double_to_real(Eqi(il)*fac_ftmr(il)),
     :                  'stewart_expilicit 229',errmax*10,errmaxrel*10)
              if (Pqiinf(il).gt.ridicule) then
                      call iso_verif_egalite_choix
     :                 (double_to_real(Pxtiinf(iso_eau,il)/Pqiinf(il)),
     :                 1.,'stewart_explicite 143',errmax,errmaxrel)
              endif !if (Pqiinf.gt.ridicule) then

              if (iso_verif_egalite_choix_nostop(
     :                   double_to_real(xtnew(iso_eau,il)),
     :                   double_to_real(qp0(il)+Eqi(il)*fac_ftmr(il)),
     :                   'stewart_explicite 218',errmax*10,errmaxrel*50)
     :                           .eq.1) then
                        write(*,*) 'xtnew=',xtnew(iso_eau,il)
                        write(*,*) 'qp=',qp0(il)+Eqi(il)*fac_ftmr(il)
                        write(*,*) 'Exi=',Exi(iso_eau,il)
                        write(*,*) 'Eqi(il)=',Eqi(il)
                        write(*,*) 'xtp0=',xtp0(iso_eau,il),
     :                     'qp0=',qp0(il)
                        write(*,*) 'Pxtisup=',Pxtisup(iso_eau,il),
     :                   ' Pqisup=',pqisup(il)
                        write(*,*) 'Pxtiinf=',Pxtiinf(iso_eau,il),
     :                   ' Pqiinf=',pqiinf(il)
                        stop
               endif !if (iso_verif_egalite_choix_nostop(
                     ! pour meilleure conv
                     !Pxtiinf=Pqiinf
                     !Exi=Eqi
                     !xtnew=qp0+Eqi*fac_ftmr
             endif    !if (use_iso_eau.eq.1).and.(ixt.eq.iso_eau) 
             if (use_iso_HDO.eq.1) then
               if (Pqiinf(il).gt.ridicule_rain) then
                    call iso_verif_aberrant(
     :                  double_to_real(Pxtiinf(iso_HDO,il)/Pqiinf(il)),
     :                   'stewart_explicie 224')   
               endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO).and.
               if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
                 call iso_verif_aberrant(double_to_real(
     :                   xtnew(iso_HDO,il)/(qp0(il)+Eqi(il)
     :                   *fac_ftmr(il))),'stewart_explicite 420')
               endif !if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
             endif !if (use_iso_HDO.eq.1)
             if ((debug.eq.1).and.(il.eq.il_debug)) then
                 write(*,*) 'stewart_explicit 442: tout se rvapore'
                 write(*,*) 'Eqi(il),deltaD=',Eqi(il),
     :                   deltaD(double_to_real(Exi(iso_HDO,il)/Eqi(il)))
             endif
#endif
                ! end verifs                
          else !if ((f.lt.errmaxrel).or.(Pqiinf.lt.errmax)) then
                    
                    
        do ixt=1,niso            
        CALL FRACTCALK_liq(IXT, TEVAP(il), alphap(ixt,il))
        enddo !do ixt=1,niso 

        ! **** cas o h=1 -> equilibre
        ! on rajoute ce cas le 8 dec 2011 pour viter overflow errors
        ! dans le cas 1er ordre pour la vapeur
        ! on remplace aussi le alpha en gama pour tre plus prcis
        if ((h(il).gt.0.99).or.
     :           (h(il).gt.0.98).and.(f(il).lt.1e-3)) then
#ifdef ISOVERIF          
!            write(*,*) 'stewart_explicit 191: cas h=1: il=',il
#endif            
            do ixt=1,niso
            interm(ixt,il)=alphap(ixt,il)*(1.0-h(il))
     :           *tdifrel(IXT)**(tdifexp)
            gama(ixt,il)=alphap(ixt,il)*h(il)/(1.0-interm(ixt,il))
            Rb(ixt,il)=(Rb0(ixt,il)*qp0(il)+Rl0(ixt,il)*m0(il)*A(il))/
     :        (qp0(il)+A(il)*m0(il)*(1-f(il))+A(il)*f(il)*m0(il)
     :           *gama(ixt,il))
            Rl(ixt,il)=gama(ixt,il)*Rb(ixt,il)
            Pxtiinf(ixt,il)=Pqiinf(il)*Rl(ixt,il)            
            Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)   
            !xtnew=xtp0+Exi*fac_ftmr
            xtnew(ixt,il)=Rb(ixt,il)*(qp0(il)+Eqi(il)*fac_ftmr(il))    
            xtnew(ixt,il)=max(xtnew(ixt,il),0.0)
          enddo !do ixt=1,niso 
          if (fac_ftmr(il).gt.0.0) then
             do ixt=1,niso  
               Exi(ixt,il)=(xtnew(ixt,il)-xtp0(ixt,il))/fac_ftmr(il)
             enddo !do ixt=1,niso   
          else
            do ixt=1,niso   
               Exi(ixt,il)=Pxtisup(ixt,il)-Pxtiinf(ixt,il)
            enddo !do ixt=1,niso    
          endif
            !Exi=max(Exi,0)

            ! verif
#ifdef ISOVERIFNAN
            do ixt=1,niso 
              call iso_verif_noNAN(double_to_real(Pxtiinf(ixt,il)),
     :           'stewart_explicite 209')   
              call iso_verif_noNAN(double_to_real(Exi(ixt,il)),
     :           'stewart_explicite 259')
              call iso_verif_noNAN(double_to_real(xtnew(ixt,il)),
     :           'stewart_explicite 261')
            enddo !do ixt=1,niso
#endif           
#ifdef ISOVERIF
            if (use_iso_eau.eq.1) then
                call iso_verif_egalite_choix(
     :            double_to_real(Rb(iso_eau,il)),
     :            1.0,'stewart_explicite 232',errmax,errmaxrel)
                call iso_verif_egalite_choix(
     :              double_to_real(Pxtiinf(iso_eau,il)),
     :              double_to_real(Pqiinf(il)),'stewart_explicite 232',
     :              errmax,errmaxrel)
                call iso_verif_egalite_choix(
     :            double_to_real(Exi(iso_eau,il)),
     :             double_to_real(Eqi(il)),'stewart_explicite 233',
     :             errmax,errmaxrel)
                call iso_verif_egalite_choix(
     :                  double_to_real(Exi(iso_eau,il)*fac_ftmr(il)),
     :                  double_to_real(Eqi(il)*fac_ftmr(il)),
     :                  'stewart_expilicit 291',errmax*10,errmaxrel*10)
                if (Pqiinf(il).gt.ridicule) then
                    call iso_verif_egalite_choix
     :                 (double_to_real(Pxtiinf(iso_eau,il)/Pqiinf(il)),
     :                 1.,'stewart_explicite 312',errmax,errmaxrel)
                 endif !if (Pqiinf.gt.ridicule) then
             endif    !if (use_iso_eau.eq.1).and.(ixt.eq.iso_eau)  
              
             if (use_iso_HDO.eq.1) then 
               if (Pqiinf(il).gt.ridicule_rain) then
                   if (iso_verif_aberrant_nostop(
     :                  double_to_real(Pxtiinf(iso_HDO,il)/Pqiinf(il)),
     :                   'stewart_explicie 248').eq.1) then
                     write(*,*) 'cas reeq totale, il=',il
                     write(*,*) 'deltaDl0=',deltaD(
     :                   double_to_real(Rl0(iso_hdo,il)))
                     write(*,*) 'deltaDb0=',deltaD(
     :                   double_to_real(Rb0(iso_hdo,il)))
                     write(*,*) 'deltaDb=',deltaD(
     :                   double_to_real(Rb(iso_hdo,il)))
                     stop
                   endif 
               endif  !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO).and.
               if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
                 call iso_verif_aberrant(double_to_real(
     :                   xtnew(iso_HDO,il)/(qp0(il)+Eqi(il)
     :                   *fac_ftmr(il))),'stewart_explicite 499')
               endif !if ((use_iso_HDO.eq.1).and.
             endif  !if (use_iso_HDO.eq.1) then
            if ((debug.eq.1).and.(il.eq.il_debug)) then
                 write(*,*) 'stewart_explicit 526: cas h~1: rq'
                 write(*,*) 'Eqi(il),deltaD=',Eqi(il),
     :                   deltaD(double_to_real(Exi(iso_HDO,il)/Eqi(il)))
                 write(*,*) 'deltaDv0,l0=',deltaD(
     :                   double_to_real(Rb0(iso_hdo,il))),deltaD(
     :                   double_to_real(Rl0(iso_hdo,il)))
            endif 
#endif
            ! end verifs

        else if ((f(il).gt.0.998).and.
     :           (Eqi(il)*fac_ftmr(il).lt.1e-2*qp0(il))) then

        !*** cas particulier pour viter imprcisions numriques:
            ! dans ce cas, on fait l'hypoythse que Rl et Rb varient peu
            ! -> approx au premier ordre: Revap intgr = Revap initial
            ! f>0.998 veut dire que la goutte varie peu, tandis que
            ! Eqi<<qp0/fac_ftmr veut dire que la vapeur varie peu
           do ixt=1,niso
            Revap0(ixt,il)=tdifrel(IXT)**(tdifexp)
     :          *(Rl0(ixt,il)/alphap(ixt,il)
     :           -h(il)*Rb0(ixt,il))/(1-h(il))
            Exi(ixt,il)=Eqi(il)*Revap0(ixt,il)
            Pxtiinf(ixt,il)=Pxtisup(ixt,il)-Exi(ixt,il)          
            xtnew(ixt,il)=xtp0(ixt,il)+Exi(ixt,il)*fac_ftmr(il)
#ifdef ISOVERIF
            Rlfin(ixt)=Pxtiinf(ixt,il)/Pqiinf(il)
            Rbfin(ixt)=xtnew(ixt,il)/(qp0(il)+Eqi(il)*fac_ftmr(il))
#endif            

!            ! modif du 4 sept 2007: on simplifie
!            Revap(ixt,il)=Revap0(ixt,il)
            ! modif abandonne
            Revapfin(ixt,il)=tdifrel(IXT)**(tdifexp)
     :         *(Pxtiinf(ixt,il)/Pqiinf(il)/alphap(ixt,il)
     :         -h(il)*xtnew(ixt,il)/(qp0(il)+Eqi(il)*fac_ftmr(il)))
     :           /(1-h(il)) 
            Revap(ixt,il)=0.5*(Revap0(ixt,il)+Revapfin(ixt,il))

            Exi(ixt,il)=Eqi(il)*Revap(ixt,il)
            Exi(ixt,il)=max(min(Exi(ixt,il),Pxtisup(ixt,il)),
     :           -xtp0(ixt,il)/fac_ftmr(il))
            Pxtiinf(ixt,il)=Pxtisup(ixt,il)-Exi(ixt,il)            
            xtnew(ixt,il)=xtp0(ixt,il)+Exi(ixt,il)*fac_ftmr(il)
           enddo !do ixt=1,niso        
            ! verifs
#ifdef ISOVERIFNAN
           do ixt=1,niso 
            call iso_verif_noNAN(double_to_real(Pxtiinf(ixt,il)),
     :           'stewart_explicite 395')
            call iso_verif_noNAN(double_to_real(Exi(ixt,il)),
     :           'stewart_explicite 396')
            call iso_verif_noNAN(double_to_real(xtnew(ixt,il)),
     :           'stewart_explicite 397')
           enddo !do ixt=1,niso 
#endif
#ifdef ISOVERIF
           if (use_iso_eau.eq.1) then
                call iso_verif_egalite_choix(
     :              double_to_real(Pxtiinf(iso_eau,il)),
     :              double_to_real(Pqiinf(il)),'stewart_explicite 418',
     :              errmax,errmaxrel)
                call iso_verif_egalite_choix(
     :              double_to_real(Exi(iso_eau,il)),
     :              double_to_real(Eqi(il)),'stewart_explicite 419',
     :              errmax,errmaxrel)
                if (iso_verif_egalite_choix_nostop(
     :                double_to_real(Exi(iso_eau,il)*fac_ftmr(il)),
     :                double_to_real(Eqi(il)*fac_ftmr(il)),
     :                'stewart_expilicit 344',
     :                errmax*10,errmaxrel*10).eq.1) then
                  write(*,*) 'Rl0,Rb0=',Rl0(iso_eau,il),Rb0(iso_eau,il)
                  write(*,*) 'Revap0=',Revap0(iso_eau,il)
                  write(*,*) 'Eqi,Pqisup,Pxtisup,Pqiinf=',
     :                 Eqi(il),Pqisup(il),Pxtisup(iso_eau,il),Pqiinf(il)
                  write(*,*) 'fac_ftmr,qp0,xtp0=',
     :                   fac_ftmr(il),qp0(il),xtp0(iso_eau,il)
                  write(*,*) 'Revapfin=',Revapfin(iso_eau,il)
                  stop
                endif
                if (Pqiinf(il).gt.ridicule) then
                      call iso_verif_egalite_choix
     :                 (double_to_real(Pxtiinf(iso_eau,il)/Pqiinf(il)),
     :                 1.,'stewart_explicite 143',
     :                   errmax,errmaxrel)
                endif !if (Pqiinf.gt.ridicule) then

                if (iso_verif_egalite_choix_nostop(
     :                   double_to_real(xtnew(iso_eau,il)),
     :                   double_to_real(qp0(il)+Eqi(il)*fac_ftmr(il)),
     :                   'stewart_explicite 380',errmax*10,errmaxrel*50)
     :                           .eq.1) then
                        write(*,*) 'xtnew=',xtnew(iso_eau,il)
                        write(*,*) 'qp=',qp0(il)+Eqi(il)*fac_ftmr(il)
                        write(*,*) 'Exi=',Exi(iso_eau,il)
                        write(*,*) 'Eqi=',Eqi(il)
                        write(*,*) 'xtp0=',xtp0(iso_eau,il),
     :                   'qp0=',qp0(il)
                        write(*,*) 'Pxtisup=',Pxtisup(iso_eau,il),
     :                   ' Pqisup=',pqisup(il)
                        write(*,*) 'Pxtiinf=',Pxtiinf(iso_eau,il),
     :                   ' Pqiinf=',pqiinf(il)
                        stop
                endif !if (iso_verif_egalite_choix_nostop(
             endif    !if (use_iso_eau.eq.1).and.(ixt.eq.iso_eau)
             if (use_iso_HDO.eq.1) then
               if (Pqiinf(il).gt.ridicule_rain) then
                 call iso_verif_aberrant(
     :              double_to_real(Pxtiinf(iso_HDO,il)/Pqiinf(il)),
     :             'stewart_explicie 384')   
               endif !(use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)
               if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
                 if (iso_verif_aberrant_nostop(double_to_real(
     :               xtnew(iso_HDO,il)/(qp0(il)+Eqi(il)*fac_ftmr(il))),
     :              'stewart_explicite 603').eq.1) then
                   write(*,*) 'qp0(il),Eqi(il),fac_ftmr(il)=',
     :                   qp0(il),Eqi(il),fac_ftmr(il)
                   write(*,*) 'Pqisup(il)=',Pqisup(il)
                   write(*,*) 'Rl0(iso_HDO,il),Rb0(iso_HDO,il)=',       
     :                  Rl0(iso_HDO,il),Rb0(iso_HDO,il) 
                   write(*,*)'Revap0(iso_HDO,il),Revapfin(iso_HDO,il)=',
     :                 Revap0(iso_HDO,il),Revapfin(iso_HDO,il)  
                   write(*,*) 'Revap(iso_HDO,il)=',Revap(iso_HDO,il)
                   write(*,*) 'Rlfin,Rbfin=',
     :                   Rlfin(iso_HDO),Rbfin(iso_HDO)
                   write(*,*) 'h(il),alphap(iso_HDO,il),(D/D'')^n=',
     :              h(il),alphap(iso_HDO,il),tdifrel(iso_HDO)**(tdifexp)
                   write(*,*) 'deltaDl0,deltaDb0=',
     :               deltaD(double_to_real(Rl0(iso_HDO,il))),
     :                   deltaD(double_to_real(Rb0(iso_HDO,il)))
                   write(*,*) 'deltaDe0,deltaDefin,deltaDe=',
     :               deltaD(double_to_real(Revap0(iso_HDO,il))),
     :               deltaD(double_to_real(Revapfin(iso_HDO,il))),
     :               deltaD(double_to_real(Revap(iso_HDO,il)))
                   write(*,*) 'deltaDlfin,deltaDbfin=',
     :                   deltaD(double_to_real(Rlfin(iso_HDO))),
     :                   deltaD(double_to_real(Rbfin(iso_HDO)))       
                   stop
                 endif !if (iso_verif_aberrant_nostop(double_to_real(
               endif !if ((use_iso_HDO.eq.1).and.
             endif !!if ((use_iso_HDO.eq.1)
             if ((debug.eq.1).and.(il.eq.il_debug)) then
                 write(*,*) 'stewart_explicit 663: cas o rvap faible'
                 write(*,*) 'ordre 1 pour la vapeur et le liquide'
                 write(*,*) 'Eqi(il),deltaD=',Eqi(il),
     :                   deltaD(double_to_real(Exi(iso_HDO,il)/Eqi(il)))
             endif
#endif
            ! end verif

        else ! f.gt.0.99
        

          ! *** cas o pas d'air
          if ((h(il).lt.1e-3).or.(qp0(il).lt.1e-8)) then
!              write(*,*) 'stewart_explicit 349: cas pas d''air'
              !**** calcul de Rl
!                Rl=Rl0*f**beta ! on fait autrement pour viter
!                underflow exception si f trop petit et beta >1
              do ixt=1,niso
               interm(ixt,il)=alphap(ixt,il)*tdifrel(IXT)**(tdifexp)
               beta(ixt,il)=(1.0-interm(ixt,il))/(interm(ixt,il))
!                Rl(ixt,il)=Rl0(ixt,il)*puissance_double(f,beta(ixt,il))
                 ! on inline:
                Rl(ixt,il)=Rl0(ixt,il)
     :             *10.0**(min(max(beta(ixt,il)*log(f(il)),
     :             -expb_max),expb_max))
              enddo 
#ifdef ISOVERIF
              call iso_verif_egalite_choix(double_to_real(
     :           Rl(iso_eau,il)),1.0,
     :          'stewart_explicit 722',errmax,errmaxrel)
#endif              
              ! **** calcul de Rb  
!                Rb=Rl0*(1-f**(beta+1))/(1-f) ! on fait autrement pour
!                viter underflow exception:
                
                do ixt=1,niso
                  Rb(ixt,il)=(A(il)*m0(il)*Rl0(ixt,il)*(1.0-exp
     :             (min(max((beta(ixt,il)+1.0)*log(f(il)),
     :             -expb_max),expb_max)))+qp0(il)*Rb0(ixt,il))
     :                   /(qp0(il)+A(il)*m0(il)*(1.0-f(il)))
                  ! correction bug 19 mars 2010: dnom tait faux
                  Pxtiinf(ixt,il)=Pqiinf(il)*Rl(ixt,il)
                  Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)
                  xtnew(ixt,il)=Rb(ixt,il)
     :                   *(qp0(il)+Eqi(il)*fac_ftmr(il))
                enddo
                if (fac_ftmr(il).gt.0.0) then
                    do ixt=1,niso
                        Exi(ixt,il)=(xtnew(ixt,il)-xtp0(ixt,il))
     :                   /fac_ftmr(il)
                    enddo    
                else !if (fac_ftmr.gt.0.0) then
                    do ixt=1,niso
                        Exi(ixt,il)=Pxtisup(ixt,il)-Pxtiinf(ixt,il)
                    enddo ! do ixt=1,niso    
                endif !if (fac_ftmr.gt.0.0) then
                !Exi=max(Exi,0) 

                ! cam verifs
#ifdef ISOVERIFNAN
                do ixt=1,niso     
                  call iso_verif_noNAN(double_to_real(Pxtiinf(ixt,il)),
     :                   'stewart_explicite 282b')
                  call iso_verif_noNAN(double_to_real(Exi(ixt,il)),
     :                   'stewart_explicite 283b')
                  call iso_verif_noNAN(double_to_real(xtnew(ixt,il)),
     :                   'stewart_explicite 284b')
                enddo !do ixt=1,niso       
#endif
#ifdef ISOVERIF
                  if (use_iso_eau.eq.1) then
                    call iso_verif_egalite_choix(
     :                   double_to_real(Pxtiinf(iso_eau,il)),
     :                   double_to_real(Pqiinf(il)),
     :                  'stewart_explicite 305',errmax,errmaxrel)
                    call iso_verif_egalite_choix(
     :                   double_to_real(Exi(iso_eau,il)),
     :                  double_to_real(Eqi(il)),'stewart_explicite 306',
     :                   errmax,errmaxrel)
                    call iso_verif_egalite_choix(
     :                  double_to_real(Exi(iso_eau,il)*fac_ftmr(il)),
     :                  double_to_real(Eqi(il)*fac_ftmr(il)),
     :                  'stewart_expilicit 419',errmax*10,errmaxrel*10)
                    if (Pqiinf(il).gt.ridicule) then
                      call iso_verif_egalite_choix
     :                 (double_to_real(Pxtiinf(iso_eau,il)/Pqiinf(il)),
     :                 1.,'stewart_explicite 143',errmax,errmaxrel)
                    endif !if (Pqiinf.gt.ridicule) then  
                  endif !(use_iso_eau.eq.1).and.(ixt.eq.iso_eau)
                  if (use_iso_HDO.eq.1) then
                    if (Pqiinf(il).gt.ridicule_rain) then
                      call iso_verif_aberrant(
     :                  double_to_real(Pxtiinf(iso_HDO,il)/Pqiinf(il)),
     :                   'stewart_explicie 484')   
                    endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO).and.
                    if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
                      call iso_verif_aberrant(double_to_real(
     :                   xtnew(iso_HDO,il)/(qp0(il)+Eqi(il)
     :                   *fac_ftmr(il))),'stewart_explicite 214')
                     endif !if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
                  endif !if ((use_iso_HDO.eq.1)
             if ((debug.eq.1).and.(il.eq.il_debug)) then
                 write(*,*) 'stewart_explicit 767: cas de rvap sche'
                 write(*,*) 'distill de Rayleigh'
                 write(*,*) 'Eqi(il),deltaD=',Eqi(il),
     :                   deltaD(double_to_real(Exi(iso_HDO,il)/Eqi(il)))
             endif
#endif
                ! end verifs

            !else if (fac_ftmr(il).gt.1e18) then
            else if (fac_ftmr(il).gt.1e24) then

                ! *** cas o flux de masse nul
                do ixt=1,niso
                interm(ixt,il)=alphap(ixt,il)*(1.0-h(il))
     :           *tdifrel(IXT)**(tdifexp)
                beta(ixt,il)=(1.0-interm(ixt,il))/(interm(ixt,il))
                enddo
#ifdef ISOVERIFNAN
                do ixt=1,niso
                call iso_verif_noNaN(double_to_real(beta(ixt,il)),
     :            'stewart_explicit 269')
                enddo !do ixt=1,niso 
#endif


!                write(*,*) 'stewart_explicit 349: cas Mp=0'
              do ixt=1,niso 
                Rl(ixt,il)=Rl0(ixt,il)*f(il)**beta(ixt,il)
                Pxtiinf(ixt,il)=Pqiinf(il)*Rl(ixt,il)
                Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)
                Exi(ixt,il)=Pxtisup(ixt,il)-Pxtiinf(ixt,il)
                !Exi=max(Exi,0) 
                xtnew(ixt,il)=xtp0(ixt,il)
              enddo ! do ixt=1,niso   

                ! cam verifs
#ifdef ISOVERIFNAN
            do ixt=1,niso     
              call iso_verif_noNAN(double_to_real(Pxtiinf(ixt,il)),
     :                   'stewart_explicite 463')
              call iso_verif_noNAN(double_to_real(Exi(ixt,il)),
     :                   'stewart_explicite 465')
              call iso_verif_noNAN(double_to_real(xtnew(ixt,il)),
     :                   'stewart_explicite 467')
            enddo !do ixt=1,niso    
#endif          
#ifdef ISOVERIF  
                  if (use_iso_eau.eq.1) then
                    call iso_verif_egalite_choix(
     :                  double_to_real(Pxtiinf(iso_eau,il)),
     :                   double_to_real(Pqiinf(il)),
     :                   'stewart_explicite 471',errmax,errmaxrel)
                    call iso_verif_egalite_choix(
     :                   double_to_real(Exi(iso_eau,il)),
     :                  double_to_real(Eqi(il)),'stewart_explicite 472',
     :                   errmax,errmaxrel)
                    if (iso_verif_egalite_choix_nostop(
     :                  double_to_real(Exi(iso_eau,il)*fac_ftmr(il)),
     :                  double_to_real(Eqi(il)*fac_ftmr(il)),
     :                  'stewart_expilicit 472b',errmax*10,errmaxrel*10)
     :                  .eq.1) then
                        write(*,*) 'il=',il
                        write(*,*) 'f,h=',f(il),h(il)
                        write(*,*) 'fac_ftmr,Eqi=',fac_ftmr(il),Eqi(il)
                        write(*,*) 'Pqisup,Pqiinf=',
     :                           Pqisup(il),Pqiinf(il)
                        write(*,*) 'Pxtisup,Pxtiinf',
     :                     Pxtisup(iso_eau,il),Pxtiinf(iso_eau,il)
                        stop
                    endif !if (iso_verif_egalite_choix_nostop(
                    if (Pqiinf(il).gt.ridicule) then
                      call iso_verif_egalite_choix
     :                  (double_to_real(Pxtiinf(iso_eau,il)/Pqiinf(il)),
     :                  1.,'stewart_explicite 143',errmax,errmaxrel)
                    endif !if (Pqiinf.gt.ridicule) then 
                  endif !(use_iso_eau.eq.1).and.(ixt.eq.iso_eau)
                  if (use_iso_HDO.eq.1) then
                    if (Pqiinf(il).gt.ridicule_rain) then
                    call iso_verif_aberrant(
     :                  double_to_real(Pxtiinf(iso_HDO,il)/Pqiinf(il)),
     :                   'stewart_explicie 484')   
                    endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO).and.
                    if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
                     call iso_verif_aberrant(double_to_real(
     :                   xtnew(iso_HDO,il)/(qp0(il)+Eqi(il)
     :                   *fac_ftmr(il))),'stewart_explicite 759')
                    endif !if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
                  endif !if (use_iso_HDO.eq.1)
              if ((debug.eq.1).and.(il.eq.il_debug)) then
                 write(*,*) 'stewart_explicit 831: flux de masse vap~0'
                 write(*,*) 'Eqi(il),deltaD=',Eqi(il),
     :                   deltaD(double_to_real(Exi(iso_HDO,il)/Eqi(il)))
              endif
#endif
                ! end verifs

            else ! else if (fac_ftmr(il).gt.1e18) then


            !**** cas gnral

!            write(*,*) 'stewart_explicit 403: cas gnral'
            do ixt=1,niso
              interm(ixt,il)=alphap(ixt,il)*(1.0-h(il))
     :           *tdifrel(IXT)**(tdifexp)
              beta(ixt,il)=(1.0-interm(ixt,il))/(interm(ixt,il))
              gama(ixt,il)=alphap(ixt,il)*h(il)/(1-interm(ixt,il))
            enddo

            ! modif le 13 juin 2012: seuil 1e-2 -> 5e-2
            ! le 15 juin: on revient  1e-2 car sinon, vapeur varie trop
            if (Eqi(il)*fac_ftmr(il)/qp0(il).lt.1e-2) then
                        ! premier ordre pour la vapeur
                        ! cas ajout le 7 dec 2011 car le cas gnral
                        ! compliqu donne des choses aberrantes pour
                        ! l'O17excess
                    ! distinction ajoutee le 8 dec 2011 pour eviter les
                    ! underflow exceptions quand f**beta fait dans les
                    ! 1e-300.    
               if (-h(il)/(1-h(il))*log(f(il)).gt.30.0) then
                do ixt=1,niso
                   Rl(ixt,il) = Rl0(ixt,il)*f(il)**beta(ixt,il)
     :              +gama(ixt,il)*Rb0(ixt,il)*(1.0-f(il)**beta(ixt,il))
                enddo
               else !if (-h(il)/(1-h(il))*log(f(il)).gt.30.0) then
                do ixt=1,niso
                   Rl(ixt,il) = gama(ixt,il)*Rb0(ixt,il)
                enddo   
               endif !if (-h(il)/(1-h(il))*log(f(il)).gt.30.0) then
                do ixt=1,niso
                Rb(ixt,il)=((Rl0(ixt,il)-Rl(ixt,il)*f(il))
     :                  *Pqisup(il)*fac_ftmr(il)
     :                   +Rb0(ixt,il)*qp0(il))
     :                   /(qp0(il)+Eqi(il)*fac_ftmr(il))
                Pxtiinf(ixt,il)=Pqiinf(il)*Rl(ixt,il)
                Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)  
                xtnew(ixt,il)=Rb(ixt,il)*(qp0(il)+Eqi(il)*fac_ftmr(il)) 
                xtnew(ixt,il)=max(xtnew(ixt,il),0.0)              
                if (fac_ftmr(il).gt.0.0) then
                 Exi(ixt,il)=(xtnew(ixt,il)-xtp0(ixt,il))/fac_ftmr(il)
                else
                 Exi(ixt,il)=Pxtisup(ixt,il)-Pxtiinf(ixt,il)
                endif
                !Exi=max(Exi,0) 
                Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)
               enddo !do ixt=1,niso

#ifdef ISOVERIFNAN
                do ixt=1,niso     
                  call iso_verif_noNaN(double_to_real(Pxtiinf(ixt,il)),
     :                   'stewart_explicite 913')
                  call iso_verif_noNaN(double_to_real(Exi(ixt,il)),
     :                   'stewart_explicite 915')
                  call iso_verif_noNaN(double_to_real(xtnew(ixt,il)),
     :                   'stewart_explicite 917')
                enddo !do ixt=1,niso    
#endif
#ifdef ISOVERIF   
                  if (use_iso_eau.eq.1) then
                    call iso_verif_egalite_choix(
     :                   double_to_real(Pxtiinf(iso_eau,il)),
     :                   double_to_real(Pqiinf(il)),
     :                  'stewart_explicite 923',errmax,errmaxrel)
                    call iso_verif_egalite_choix(
     :                   double_to_real(Exi(iso_eau,il)),
     :                  double_to_real(Eqi(il)),'stewart_explicite 926',
     :                   errmax,errmaxrel)
                    call iso_verif_egalite_choix(
     :                  double_to_real(Exi(iso_eau,il)*fac_ftmr(il)),
     :                  double_to_real(Eqi(il)*fac_ftmr(il)),
     :                  'stewart_expilicit 931',errmax*10,errmaxrel*10)
                    if (Pqiinf(il).gt.ridicule) then
                      call iso_verif_egalite_choix
     :                 (double_to_real(Pxtiinf(iso_eau,il)/Pqiinf(il)),
     :                 1.,'stewart_explicite 935',errmax,errmaxrel)
                    endif !if (Pqiinf.gt.ridicule) then  
                  endif !(use_iso_eau.eq.1).and.(ixt.eq.iso_eau)
                  if (use_iso_HDO.eq.1) then
                    if (Pqiinf(il).gt.ridicule_rain) then
                      call iso_verif_aberrant(
     :                  double_to_real(Pxtiinf(iso_HDO,il)/Pqiinf(il)),
     :                   'stewart_explicie 484')   
                    endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO).and.
                    if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
                        if (iso_verif_aberrant_nostop(double_to_real(
     :                   xtnew(iso_HDO,il)/(qp0(il)+Eqi(il)
     :                   *fac_ftmr(il))),'stewart_explicite 947')
     :                   .eq.1) then
                           write(*,*) 'Eqi(il)*fac_ftmr(il)/qp0(il)=',
     :                          Eqi(il)*fac_ftmr(il)/qp0(il) 
                           write(*,*) 'f,h=',f(il),h(il)
                           write(*,*) 'Eqi(il)= ',Eqi(il)
                           write(*,*) 'Pqisup(il)= ',Pqisup(il)
                           write(*,*) 'fac_ftmr(il)= ',fac_ftmr(il)
                           write(*,*) 'qp0(il)= ',qp0(il)
                           write(*,*) 'beta(iso_HDO,il)= ',
     :                        beta(iso_HDO,il)
                           write(*,*) 'gama(iso_HDO,il)= ',
     :                        gama(iso_HDO,il)
                           write(*,*) 'deltaDl0,b0=',deltaD(
     :                        double_to_real(Rl0(iso_HDO,il))),deltaD(
     :                        double_to_real(Rb0(iso_HDO,il)))
                           write(*,*) 'deltaDl,b=',deltaD(
     :                        double_to_real(Rl(iso_HDO,il))),deltaD(
     :                        double_to_real(Rb(iso_HDO,il)))
                           write(*,*) 'deltaDe=',deltaD(
     :                        double_to_real(Exi(iso_HDO,il)/Eqi(il)))
                           write(*,*) 'deltaDgamaRb0=',deltaD(
     :                        double_to_real(gama(iso_HDO,il)
     :                        *Rb0(iso_HDO,il))) 
                           write(*,*) 'deltaDalphaRb0=',deltaD(
     :                        double_to_real(alphap(iso_HDO,il)
     :                        *Rb0(iso_HDO,il)))
                           stop
                        endif
                     endif !if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
                  endif !if ((use_iso_HDO.eq.1)
                  if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1).and.
     :               (O17_verif)) then
                     if (Pqiinf(il).gt.ridicule_rain) then
                      call iso_verif_aberrant_o17(
     :                  double_to_real(Pxtiinf(iso_O17,il)/Pqiinf(il)),
     :                  double_to_real(Pxtiinf(iso_O18,il)/Pqiinf(il)),
     :                  'stewart_explicie 955')   
                    endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO).and.
                  endif  ! if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1).and.
             if ((debug.eq.1).and.(il.eq.il_debug)) then
                write(*,*) 'stewart_explicit 951: 1er ordre pour la vap'
             endif !if ((debug.eq.1).and.(il.eq.il_debug)) then
#endif              

            else if ((A(il)*m0(il)/qp0(il).gt.10.0).and.
     :                (1.0-f(il).lt.1e-5)) then
                ! beaucoup de liquide se rvaporant trs peu dans un
                ! tout petit peu de vapeur. Ca peut donner des cas
                ! pathologiques avec des vapeurs abrrantes -> on fait
                ! une approx de compo constante du liquide et on se
                ! concentre sur l'volution de la compo de la vapeur.

                fv(il)=1.0+Eqi(il)*fac_ftmr(il)/qp0(il)
                do ixt=1,niso
                  Rb(ixt,il)=(1+beta(ixt,il))/(1+beta(ixt,il)
     :                 *gama(ixt,il))*Rl0(ixt,il)
     :                 *(1-fv(il)**(-(1+beta(ixt,il)*gama(ixt,il))))
     :                 +Rb0(ixt,il)*fv(il)
     :                 **(-(1+beta(ixt,il)*gama(ixt,il)))
                  Rl(ixt,il)=(Rl0(ixt,il)*A(il)*m0(il)
     :                 +Rb0(ixt,il)*qp0(il)
     :                 -fv(il)*qp0(il)*Rb(ixt,il))
     :                 /(A(il)*m0(il)+qp0(il)*(1-fv(il)))
                  Pxtiinf(ixt,il)=Pqiinf(il)*Rl(ixt,il)
                  xtnew(ixt,il)=Rb(ixt,il)*
     :                 (qp0(il)+Eqi(il)*fac_ftmr(il)) 
                  Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)
                  xtnew(ixt,il)=max(xtnew(ixt,il),0.0)          
                  if (fac_ftmr(il).gt.0.0) then
                     Exi(ixt,il)=(xtnew(ixt,il)
     :                 -xtp0(ixt,il))/fac_ftmr(il)
                  else
                     Exi(ixt,il)=Pxtisup(ixt,il)-Pxtiinf(ixt,il)
                  endif
                enddo !do ixt=1,niso

                ! vrifs
#ifdef ISOVERIFNAN
                do ixt=1,niso     
                  call iso_verif_noNaN(double_to_real(Pxtiinf(ixt,il)),
     :                   'stewart_explicite 1092')
                  call iso_verif_noNaN(double_to_real(Exi(ixt,il)),
     :                   'stewart_explicite 1095')
                  call iso_verif_noNaN(double_to_real(xtnew(ixt,il)),
     :                   'stewart_explicite 1097')
                enddo !do ixt=1,niso 
#endif
#ifdef ISOVERIF      
                  if (use_iso_eau.eq.1) then
                    call iso_verif_egalite_choix(
     :                   double_to_real(Pxtiinf(iso_eau,il)),
     :                   double_to_real(Pqiinf(il)),
     :                  'stewart_explicite 1103',errmax,errmaxrel)
                    call iso_verif_egalite_choix(
     :                   double_to_real(Exi(iso_eau,il)),
     :                  double_to_real(Eqi(il)),'stewart_explicite 926',
     :                   errmax,errmaxrel)
                    call iso_verif_egalite_choix(
     :                  double_to_real(Exi(iso_eau,il)*fac_ftmr(il)),
     :                  double_to_real(Eqi(il)*fac_ftmr(il)),
     :                  'stewart_expilicit 1111',errmax*10,errmaxrel*10)
                    if (Pqiinf(il).gt.ridicule) then
                      call iso_verif_egalite_choix
     :                 (double_to_real(Pxtiinf(iso_eau,il)/Pqiinf(il)),
     :                 1.,'stewart_explicite 1115',errmax,errmaxrel)
                    endif !if (Pqiinf.gt.ridicule) then  
                  endif !(use_iso_eau.eq.1).and.(ixt.eq.iso_eau)
                  if (use_iso_HDO.eq.1) then
                    if (Pqiinf(il).gt.ridicule_rain) then
                      call iso_verif_aberrant(
     :                  double_to_real(Pxtiinf(iso_HDO,il)/Pqiinf(il)),
     :                   'stewart_explicie 1122')   
                    endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO).and.
                    if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
                        if (iso_verif_aberrant_nostop(double_to_real(
     :                   xtnew(iso_HDO,il)/(qp0(il)+Eqi(il)
     :                   *fac_ftmr(il))),'stewart_explicite 1127')
     :                   .eq.1) then
                           write(*,*) 'Eqi(il)*fac_ftmr(il)/qp0(il)=',
     :                          Eqi(il)*fac_ftmr(il)/qp0(il) 
                           write(*,*) 'f,h=',f(il),h(il)
                           write(*,*) 'deltaDl0,b0=',deltaD(
     :                        double_to_real(Rl0(iso_HDO,il))),deltaD(
     :                        double_to_real(Rb0(iso_HDO,il)))
                           write(*,*) 'deltaDl,b=',deltaD(
     :                        double_to_real(Rl(iso_HDO,il))),deltaD(
     :                        double_to_real(Rb(iso_HDO,il)))
                           write(*,*) 'deltaDe=',deltaD(
     :                        double_to_real(Exi(iso_HDO,il)/Eqi(il)))
                           write(*,*) 'deltaDgamaRb0=',deltaD(
     :                        double_to_real(gama(iso_HDO,il)
     :                        *Rb0(iso_HDO,il))) 
                           write(*,*) 'deltaDalphaRb0=',deltaD(
     :                        double_to_real(alphap(iso_HDO,il)
     :                        *Rb0(iso_HDO,il)))
                           stop
                        endif
                     endif !if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
                  endif !if ((use_iso_HDO.eq.1)
                  if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1).and.
     :               (O17_verif)) then
                     if (Pqiinf(il).gt.ridicule_rain) then
                      call iso_verif_aberrant_o17(
     :                  double_to_real(Pxtiinf(iso_O17,il)/Pqiinf(il)),
     :                  double_to_real(Pxtiinf(iso_O18,il)/Pqiinf(il)),
     :                  'stewart_explicie 1156')   
                    endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO).and.
                  endif  ! if ((use_iso_o17.eq.1).and.(use_iso_o18.eq.1).and.
             if ((debug.eq.1).and.(il.eq.il_debug)) then
              write(*,*) 'stewart_explicit 1160: 1er ordre pour le liq'
             endif !if ((debug.eq.1).and.(il.eq.il_debug)) then
#endif              

            else !if (Eqi(il)*fac_ftmr(il)/qp0(il).lt.5e-2) then

            !**** cas gnral
#ifdef ISOVERIFNAN
!        write(*,*) 'stewart_explicit 1170: cas gnral: il=',il
        do ixt=1,niso
          call iso_verif_noNaN(double_to_real(beta(ixt,il)),
     :            'stewart_explicit 269')
        enddo !do ixt=1,niso 
#endif            

!            if ((allow_ordre1v).and.
!     :           (Eqi(il)*fac_ftmr(il).lt.1e-2*qp0(il)).and.
!     :            (h.lt.0.97)) then
!               ! peu d'apport d'vap dans la vapeur, et peu diffusf ->
!               ! peu de modif de la vapeur -> on utilse l'ordre 1 pour
!               ! la vapeur
!            endif

            g(il)=(qp0(il)-A(il)*(m(il)-m0(il)))/qp0(il)

            ! encore un cas particulier!
            ! quand f trs petit et surtout f**beta trs petit, on
            ! traite  part.
            r_l0qp0(il)=A(il)*m0(il)/qp0(il)            
!            if (  ((f.lt.0.005).and.(h.gt.0.5)) ! orig: beta.gt.7
!     :           .or.((f.lt.0.01).and.(h.gt.0.85)) ! orig: beta.gt.8
!     :           .or.((f.lt.0.1).and.(h.gt.0.9))
!     :           .or.((f.lt.0.15).and.(h.gt.0.95))            
!     :           .or.((f.lt.0.2).and.(h.gt.0.98))) then 
            if ((h(il).gt.0.5).and.(f(il).lt.0.2).and.
     :           (f(il).lt.0.005+3*(h(il)-0.5)**4)) then
                ! la fonction flimite(h(il))=0.005+3*(h(il)-0.5)**4 est
                ! une courbe qui colle aux points de repres utiliss
                ! prcdemment. Elle est teste das GCMiso/tests_offline/integrale/gnuplot_cas_f_petit.plot

            do ixt=1,niso
               Rl(ixt,il) = gama(ixt,il)
     :           * (Rl0(ixt,il)*r_l0qp0(il)+Rb0(ixt,il)) 
     :             / (1+r_l0qp0(il))
     :              * (1-f(il)*r_l0qp0(il))
     :           /(1-f(il)*r_l0qp0(il)*gama(ixt,il))          
               Rb(ixt,il)= (Rl0(ixt,il)*r_l0qp0(il)+Rb0(ixt,il))
     :           / (1+r_l0qp0(il))

               Pxtiinf(ixt,il)=Pqiinf(il)*Rl(ixt,il) 
               Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)  
               xtnew(ixt,il)=Rb(ixt,il)*(qp0(il)+Eqi(il)*fac_ftmr(il)) 
               xtnew(ixt,il)=max(xtnew(ixt,il),0.0)
              
               if (fac_ftmr(il).gt.0.0) then
                 Exi(ixt,il)=(xtnew(ixt,il)-xtp0(ixt,il))/fac_ftmr(il)
               else
                 Exi(ixt,il)=Pxtisup(ixt,il)-Pxtiinf(ixt,il)
               endif
               !Exi=max(Exi,0) 
               Pxtiinf(ixt,il)=max(Pxtiinf(ixt,il),0.0)
               xtnew(ixt,il)=max(xtnew(ixt,il),0.0) 
               
             enddo !do ixt=1,niso

              ! cam verifs
#ifdef ISOVERIFNAN
            do ixt=1,niso  
               call iso_verif_noNAN(double_to_real(Pxtiinf(ixt,il)),
     :                   'stewart_explicite 518')
                call iso_verif_noNAN(double_to_real(Exi(ixt,il)),
     :                   'stewart_explicite 520')
                call iso_verif_noNAN(double_to_real(xtnew(ixt,il)),
     :                   'stewart_explicite 522')
            enddo  !do ixt=1,niso    
#endif
#ifdef ISOVERIF
              if (use_iso_eau.eq.1) then
                 call iso_verif_egalite_choix(
     :            double_to_real(Rl(iso_eau,il)),
     :            1.0,'stewart_explicite 591',
     :            errmax*50,errmaxrel*10) 
                 call iso_verif_egalite_choix(
     :            double_to_real(Rb(iso_eau,il)),
     :            1.0,'stewart_explicite 592',
     :            errmax*50,errmaxrel*10)
                 call iso_verif_egalite_choix(
     :            double_to_real(Pxtiinf(iso_eau,il)),
     :            double_to_real(Pqiinf(il)),'stewart_explicite 593',
     :            errmax*50,errmaxrel*10)
                 call iso_verif_egalite_choix(
     :            double_to_real(xtnew(iso_eau,il)),
     :            double_to_real(qp0(il)+Eqi(il)*fac_ftmr(il)),
     :            'stewart_explicite 594',
     :            errmax*50,errmaxrel*10)
                 if (iso_verif_egalite_choix_nostop(
     :            double_to_real(Exi(iso_eau,il)),
     :            double_to_real(Eqi(il)),'stewart_explicite 595',
     :            errmax*50,errmaxrel*10).eq.1) then
                   write(*,*) 'il,fac_ftmr(il)=',il,fac_ftmr(il)
                   write(*,*) 'xtnew(iso_eau,il),qp(il)=',
     :                 xtnew(iso_eau,il),qp0(il)+Eqi(il)*fac_ftmr(il)
                   write(*,*) 'xtp0(iso_eau,il),qp0(il)=',
     :                   xtp0(iso_eau,il),qp0(il)
                   write(*,*) 'il=',il
                   write(*,*) 'xtp0(iso_eau,7),qp0(7)=',
     :                   xtp0(iso_eau,7),qp0(7)
                   stop
                 endif
                 if (iso_verif_egalite_choix_nostop(
     :            double_to_real(Exi(iso_eau,il)*fac_ftmr(il)),
     :            double_to_real(Eqi(il)*fac_ftmr(il)),
     :            'stewart_expilicit 521',errmax*10,errmaxrel*10)
     :            .eq.1) then
                   write(*,*) 'il=',il
                   stop
                 endif !if (iso_verif_egalite_choix_nostop
                 if (Pqiinf(il).gt.ridicule) then
                   call iso_verif_egalite_choix
     :                (double_to_real(Pxtiinf(iso_eau,il)/Pqiinf(il)),
     :                1.,'stewart_explicite 143',errmax,errmaxrel)
                 endif !if (Pqiinf.gt.ridicule) then 
                ! pour meilleure convergence numrique
                !Pxtiinf=Pqiinf
                !Exi=Eqi
                if (iso_verif_egalite_choix_nostop(
     :                   double_to_real(xtnew(iso_eau,il)),
     :                   double_to_real(qp0(il)+Eqi(il)*fac_ftmr(il)),
     :                   'stewart_explicite 605',errmax*10,errmaxrel*50)
     :                           .eq.1) then
                        write(*,*) 'xtnew=',xtnew(iso_eau,il)
                        write(*,*) 'qp=',qp0(il)+Eqi(il)*fac_ftmr(il)
                        write(*,*) 'errrel=',
     :                   (xtnew(iso_eau,il)-
     :                    (qp0(il)+Eqi(il)*fac_ftmr(il)))
     :                     /(qp0(il)+Eqi(il)*fac_ftmr(il))
                        write(*,*) 'Rb=',Rb(iso_eau,il)
                        write(*,*) 'Rl=',Rl(iso_eau,il)
                        stop
               endif !if (iso_verif_egalite_choix_nostop(
               ! pour meilleure convergence numrique:
               !xtnew=qp0+Eqi*fac_ftmr
           endif   ! if (use_iso_eau.eq.1).and.(ixt.eq.iso_eau)    

           if (use_iso_HDO.eq.1) then
             if (Pqiinf(il).gt.ridicule_rain) then
                if (iso_verif_aberrant_nostop(
     :                  double_to_real(Pxtiinf(iso_HDO,il)/Pqiinf(il)),
     :                   'stewart_explicie 675').eq.1) then
                  write(*,*) 'cas gnral f petit: il=',il
                  write(*,*) 'Rl,deltaDRl=',Rl(iso_HDO,il),
     :                   deltaD(double_to_real(Rl(iso_HDO,il)))
                  write(*,*) 'gama,h=',gama(iso_HDO,il),h(il)
                  write(*,*) 'Rl0,Rb0,deltaDRl0,RbO=',Rl0(iso_HDO,il),
     :                   Rb0(iso_HDO,il),
     :                   deltaD(double_to_real(Rl0(iso_HDO,il))),
     :                   deltaD(double_to_real(Rb0(iso_HDO,il)))
                  write(*,*) 'r_l0qp0/(1+r_l0qp0),1/(1+r_l0qp0)=',
     :               r_l0qp0(il)/(1.0+r_l0qp0(il)),1.0/(1.0+r_l0qp0(il))
                  write(*,*) 'f,r_l0qp0=',f(il),r_l0qp0(il)
                  write(*,*) 'fac=',(1-f(il)*r_l0qp0(il))
     :                  /(1-f(il)*r_l0qp0(il)*gama(iso_HDO,il)) 
                  write(*,*) 'Rl=gama*(RlO*r_l0qp0+rb0)/(1+r_l0qp0)*fac'
                  stop
                endif   !if iso_verif_aberrant_nostop(
               endif !if (Pqiinf(il).gt.ridicule_rain) then
               if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
                     call iso_verif_aberrant(double_to_real(
     :                   xtnew(iso_HDO,il)/(qp0(il)+Eqi(il)
     :                   *fac_ftmr(il))),'stewart_explicite 912')
                endif !if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
              endif !if (use_iso_HDO.eq.1)
              if ((debug.eq.1).and.(il.eq.il_debug)) then
                 write(*,*) 'stewart_explicit 991: fcas gnral'
                 write(*,*) 'mais avec formule simplifie'
                 write(*,*) 'il,Eqi(il),deltaD=',il,Eqi(il),
     :                   deltaD(double_to_real(Exi(iso_HDO,il)/Eqi(il)))
              endif
#endif     
          ! end verifs  
            
        else if (abs((g(il)**((1-2*h(il))/(1-h(il))))-1.0).lt.1e-2) then
                ! dans ce cas, le premier facteur de func (la fonction a
                ! intgrer) est environ constant et gal  1. on a alors
                ! func=(x/m)**(-beta-1), intgrable analytiquement:
!                write(*,*) 'stewart_explicite 684:calcul analytique'
                icas_Jsimple=icas_Jsimple+1
                cas_Jsimple(icas_Jsimple)=il
#ifdef ISOVERIF
!               write(*,*) 'stewart_expl 894 tmp: '//
!     :             'icas_jsimple,il=',icas_jsimple,il
               trace(il)=2532
#endif                
                        
        else !if ((g**(1-beta*gama))-1.0.lt.errmaxrel*10) then
                ! dans ce cas, la fonction est trop compliqu  intgrer
                ! analytiquement. On intgre donc numriquement.
!                write(*,*) 'stewart_explicite 684:calcul numrique'
                ! on traitera ce cas en vectoriel:
                icas_rieman=icas_rieman+1
                cas_rieman(icas_rieman)=il
#ifdef ISOVERIF
!                write(*,*) 'stewart_expl 895 tmp: '//
!     :             'icas_rieman,il=',icas_rieman,il
                trace(il)=2533
#endif                
          endif !if ((g**(1-beta*gama))-1.0.lt.errmaxrel*10) then

            
          ! end verifs
        endif !if (Eqi(il)*fac_ftmr(il)/qp0(il).lt.5e-2) then
      endif !if ((h.lt.1e-3).or.(qp0.lt.1e-8)) then   
      endif !if (h(il).gt.0.99) then
      endif !if ((f(il).lt.1e-9).or.(Pqiinf(il).lt.ridicule/10.)) then
      endif !!if ((Eqi(il)*fac_ftmr(il).lt.ridicule).and.(h(il).lt.0.99)) then 
      endif ! Pqisup.le.0
      enddo ! do il=1,ncas


      ncas_rieman=icas_rieman
      ncas_Jsimple=icas_Jsimple
!#ifdef ISOVERIF
!      write(*,*) 'stewart_explicite_vectall 812: ncas=',ncas
!      write(*,*) 'ncas_rieman=',ncas_rieman
!      write(*,*) 'ncas_Jsimple=',ncas_Jsimple      
!#endif      

      !******** traitement vectoriel des cas Rieman et Jsimple:
      ! compression
      if (ncas_Jsimple+ncas_rieman.gt.0) then
!#ifdef ISOVERIF          
!        write(*,*) 'stewart_explicite_vectall 873:compression_calculJ' 
!#endif        
        call compress_calculJ(ncas,ncas_Rieman,ncas_Jsimple, 
     :           cas_rieman,cas_Jsimple,
     :           m_cas,m, m0_cas,m0, 
     :           qp0_cas,qp0, A_cas,A,
     :           xtp0_cas,xtp0,   
     :           beta_cas,beta,gama_cas,gama,
!     :           f_cas,f, g_cas,g,ntot_cas,h,
     :           f_cas,f, g_cas,g,h,
     :           Rb0_cas,Rb0,
     :           Rl0_cas,Rl0,
     :           r_l0qp0_cas,r_l0qp0,   
     :           Eqi_cas,Eqi,
     :           fac_ftmr_cas,fac_ftmr,
     :           Pxtisup_cas,Pxtisup,
     :           Pqiinf_cas,Pqiinf)

#ifdef ISOVERIF
        ! vrif de la compression:
        do icas_Jsimple=1,ncas_Jsimple
          call iso_verif_egalite_choix(
     :           double_to_real(Pqiinf_cas(icas_Jsimple)),
     :           double_to_real(Pqiinf(cas_Jsimple(icas_Jsimple))),
     :           'stewart_explicit 912',errmax,errmaxrel)
          call iso_verif_egalite_choix(
     :           double_to_real(qp0_cas(icas_Jsimple)),
     :           double_to_real(qp0(cas_Jsimple(icas_Jsimple))),
     :           'stewart_explicit 913',errmax,errmaxrel)
          call iso_verif_egalite_choix(
     :           double_to_real(Eqi_cas(icas_Jsimple)),
     :           double_to_real(Eqi(cas_Jsimple(icas_Jsimple))),
     :           'stewart_explicit 913',errmax,errmaxrel) 
          call iso_verif_egalite_choix(
     :           double_to_real(fac_ftmr_cas(icas_Jsimple)),
     :           double_to_real(fac_ftmr(cas_Jsimple(icas_Jsimple))),
     :           'stewart_explicit 913',errmax,errmaxrel) 
          call iso_verif_egalite_choix
     :           (double_to_real(f_cas(icas_Jsimple)),
     :        double_to_real(m_cas(icas_Jsimple)/m0_cas(icas_Jsimple)),
     :       'stewart_explicite_vectall 953 apres compression',
     :        errmax,errmaxrel)
        enddo !do icas_Jsimple=1,ncas_Jsimple
        do icas_Jsimple=1,ncas_rieman
          call iso_verif_egalite_choix(
     :           double_to_real(Pqiinf_cas(icas_Jsimple+ncas_Jsimple)),
     :           double_to_real(Pqiinf(cas_rieman(icas_Jsimple))),
     :           'stewart_explicit 918',errmax,errmaxrel)
          if (iso_verif_egalite_choix_nostop(
     :        double_to_real(f_cas(icas_Jsimple+ncas_Jsimple)),
     :        double_to_real(m_cas(icas_Jsimple+ncas_Jsimple)
     :        /m0_cas(icas_Jsimple+ncas_Jsimple)),
     :       'stewart_explicite_vectall 953b apres compression',
     :        errmax,errmaxrel).eq.1) then
              write(*,*) 'icas_Jsimple,cas_rieman(icas_Jsimple)=',
     :           icas_Jsimple,cas_rieman(icas_Jsimple)
              stop
          endif
        enddo !do icas_Jsimple=1,ncas_Jsimple
#endif        

      ! ************ traitement vectoriel du cas J simplifi
      if (ncas_Jsimple.gt.0) then
!#ifdef ISOVERIF
!          write(*,*) 'traitement vectoriel J simple: x',ncas_Jsimple
!#endif          
        do il=1,ncas_Jsimple
          do ixt=1,niso
            J(ixt,il)=m_cas(il)*(1.0-10.0
     :           **(min(max(beta_cas(ixt,il)*log(f_cas(il))/log(10.0),
     :             -expb_max),expb_max)))/beta_cas(ixt,il)            
            e(ixt,il)=0.0
#ifdef ISOVERIFNAN
            call iso_verif_noNAN(double_to_real(J(ixt,il)),
     :                   'stewart_explicit 691') 
            call iso_verif_egalite_choix(double_to_real(J(ixt,il)),
     :       double_to_real(m_cas(il)/beta_cas(ixt,il)
     :           *(1.0-f_cas(il)**(beta_cas(ixt,il)))),
     :       'stewart_explicite 998: vrif de fonction puissance',
     :       errmax,errmaxrel)      
#endif                                      
          enddo  !do ixt=1,niso  
        enddo !do il=1,ncas_Jsimple
       endif !if (ncas_Jsimple.gt.0) then
              

            ! ******* traitement vectoriel du cas Rieman (=2533)
       if (ncas_rieman.gt.0) then
!#ifdef ISOVERIF
!!          write(*,*) 'traitement vectoriel rieman: x',ncas_rieman
!          do icas_rieman=1+ncas_Jsimple,ncas_rieman+ncas_Jsimple
!!            write(*,*) 'ntot_cas(icas_rieman)=',ntot_cas(icas_rieman)
!          call iso_verif_positif(float(ntot_cas(icas_rieman))-1.0,
!     :           'stewart_expl 984: ntot faux') 
!          enddo   !do icas_rieman=1,ncas_rieman       
!#endif            
           icas_rieman=1+ncas_Jsimple
!           write(*,*) 'stewart_expl 988 tmp: icas_rieman=',icas_rieman
!           write(*,*) 'qp0_cas(1)=',qp0_cas(1)
!           write(*,*) 'A_cas(1)=',A_cas(1)
!           write(*,*) 'm0_cas(1)=',m0_cas(1)
!           write(*,*) 'm_cas(1)=',m_cas(1)
!           if (use_iso_eau.eq.1) then
!           write(*,*) 'beta_cas(iso_eau,1)=',beta_cas(iso_eau,1)
!           write(*,*) 'gama_cas(iso_eau,1)=',gama_cas(iso_eau,1)
!           endif
!           write(*,*) 'f_cas(1)=',f_cas(1)
!           write(*,*) 'g_cas(1)=',g_cas(1)
!#ifdef rieman           
!           call integrale_rieman_vectall
!     :       (ncas_rieman,m_cas(icas_rieman),
!     :       J(1,icas_rieman),e(1,icas_rieman),
!     :       qp0_cas(icas_rieman),A_cas(icas_rieman),
!     :       m0_cas(icas_rieman),beta_cas(1,icas_rieman),
!     :       gama_cas(1,icas_rieman),f_cas(icas_rieman),
!     :       g_cas(icas_rieman),ntot_cas(icas_rieman))
!#else
           call integrale_gauss_vectall
     :       (ncas_rieman,m_cas(icas_rieman),
     :       J(1,icas_rieman),
     :       qp0_cas(icas_rieman),A_cas(icas_rieman),
     :       m0_cas(icas_rieman),beta_cas(1,icas_rieman),
     :       gama_cas(1,icas_rieman),
!     :       g_cas(icas_rieman),ntot_cas(icas_rieman))
     :       g_cas(icas_rieman))      
!#endif
!#ifdef ISOVERIF
!           do il=1+ncas_Jsimple,ncas_rieman+ncas_Jsimple
!             do ixt=1,niso
!               call integrale_Rieman_precision(m_cas(il),m0_cas(il),
!     :          Jtmp,etmp,ntot_cas(il)*1e2,
!     :           qp0_cas(il),A_cas(il),m0_cas(il),
!     :          beta_cas(ixt,il),gama_cas(ixt,il),f_cas(il),g_cas(il))
!               call iso_verif_egalite_choix(double_to_real(Jtmp),
!     :           double_to_real(J(ixt,il)),
!     :           'stewart_exp 999: test rieman',errmax,errmaxrel)
!               if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
!                 write(*,*) 'stew exp tmp 1005: il,J(iso_eau,il),Jtmp=',
!     :           il,J(iso_eau,il),Jtmp
!               endif
!             enddo             
!           enddo
!#endif           

          endif !if (ncas_rieman.gt.0) then


        ! ******* traitement vectoriel commun du cas Rieman et Jsimple           
#ifdef ISOVERIF
!          write(*,*) 'traitement vectoriel commun rieman/Jsimple'
#endif          
           do il=1,ncas_Jsimple+ncas_rieman          
            do ixt=1,niso 
            r_jqp0(ixt,il)=A_cas(il)*J(ixt,il)/qp0_cas(il)
            r_jl0(ixt,il)=J(ixt,il)/m0_cas(il)                
            Rl(ixt,il)=Rl0_cas(ixt,il)*((f_cas(il)**beta_cas(ixt,il))
     :          *(g_cas(il)**(-beta_cas(ixt,il)*gama_cas(ixt,il)))
     :          +beta_cas(ixt,il)*gama_cas(ixt,il)*r_jqp0(ixt,il)
     :                   /f_cas(il)/g_cas(il))
     :          +Rb0_cas(ixt,il)*gama_cas(ixt,il)*beta_cas(ixt,il)
     :                   *r_jl0(ixt,il)/f_cas(il)/g_cas(il)
            Rb(ixt,il)=Rb0_cas(ixt,il)*(1/g_cas(il) 
     :           - 1/g_cas(il)/g_cas(il) 
     :          * gama_cas(ixt,il)*beta_cas(ixt,il)*r_jqp0(ixt,il))
     :          +Rl0_cas(ixt,il)*r_l0qp0_cas(il)* (1.0/g_cas(il)
     :          -(f_cas(il)**(beta_cas(ixt,il)+1.0))
     :          *(g_cas(il)**(-beta_cas(ixt,il)*gama_cas(ixt,il)-1.0)) 
     :          -beta_cas(ixt,il)*gama_cas(ixt,il)*r_jqp0(ixt,il)
     :                   /g_cas(il)/g_cas(il))
!#ifdef ISOVERIF            
!            if ((use_iso_eau.eq.1).and.(iso_eau.eq.ixt)) then
!              write(*,*) 'stewart_explicite tmp 1071: il=',il
!              if (il.le.ncas_Jsimple) then
!                write(*,*) 'cas_Jsimple(il)=',cas_Jsimple(il)
!              else !if (il.le.ncas_Jsimple) then
!                write(*,*) 'cas_rieman(il)=',cas_rieman(il)
!              endif !if (il.le.ncas_Jsimple) then
!              write(*,*) 'f_cas(il),beta_cas(ixt,il),gama_cas(ixt,il)=',
!     :                   f_cas(il),beta_cas(ixt,il),gama_cas(ixt,il)
!              write(*,*) 'g_cas(il),r_jqp0(ixt,il),r_jl0(ixt,il)=',
!     ;          g_cas(il),r_jqp0(ixt,il),r_jl0(ixt,il)
!              write(*,*) 'A_cas(il)=',A_cas(il)
!              write(*,*) 'pond Rl0=',(f_cas(il)**beta_cas(ixt,il))
!     :          *(g_cas(il)**(-beta_cas(ixt,il)*gama_cas(ixt,il)))
!     :          +beta(ixt,il)*gama_cas(ixt,il)*r_jqp0(ixt,il)
!     :                   /f_cas(il)/g_cas(il)
!              write(*,*) 'pond Rb0=',gama_cas(ixt,il)*beta_cas(ixt,il)
!     :                   *r_jl0(ixt,il)/f_cas(il)/g_cas(il)
!              write(*,*) 'pondRl0=fac1*fac2+t3'
!              write(*,*) 'fac1=',
!     :           f_cas(il)**beta_cas(ixt,il)
!              write(*,*) 'fac2=',
!     :             g_cas(il)**(-beta_cas(ixt,il)*gama_cas(ixt,il)) 
!              write(*,*) 't3=',
!     :           beta_cas(ixt,il)*gama_cas(ixt,il)*r_jqp0(ixt,il)
!     :                   /f_cas(il)/g_cas(il)     
!            endif
!#endif

            Pxtiinf_cas(ixt,il)=Pqiinf_cas(il)*Rl(ixt,il) 
            Pxtiinf_cas(ixt,il)=max(Pxtiinf_cas(ixt,il),0.0)   

            xtnew_cas(ixt,il)=Rb(ixt,il)*(qp0_cas(il)+Eqi_cas(il)
     :           *fac_ftmr_cas(il))    
            xtnew_cas(ixt,il)=max(xtnew_cas(ixt,il),0.0)
            
            if ((fac_ftmr_cas(il).gt.0.0).and.
     :           (Pqiinf_cas(il).gt.(Eqi_cas(il)+qp0_cas(il)
     :                   /fac_ftmr_cas(il)))) then 
                ! mthode (1)
!                write(*,*) 'stewart_explicite 739: methode 1'
                Exi_cas(ixt,il)=(xtnew_cas(ixt,il)-xtp0_cas(ixt,il))
     :                   /fac_ftmr_cas(il)
            else
               ! mthode (2): 
!               write(*,*) 'stewart_explicite 743: methode 2'
               Exi_cas(ixt,il)=Pxtisup_cas(ixt,il)-Pxtiinf_cas(ixt,il)
            endif
            enddo !do ixt=1,niso 
#ifdef ISOVERIFNAN
            do ixt=1,niso
              if ((iso_verif_noNaN_nostop(Exi_cas(ixt,il),
     :           'stewart_explicite 1345').eq.1).or.
     :           (iso_verif_noNaN_nostop(Pxtiinf_cas(ixt,il),
     :           'stewart_explicite 1348').eq.1).or.
     :           (iso_verif_noNaN_nostop(xtnew_cas(ixt,il),
     :           'stewart_explicite 1348b').eq.1)) then
               write(*,*) 'ixt,ncas_Jsimple,il=',ixt,ncas_Jsimple,il
               write(*,*) 'Exi_cas(ixt,il)=',Exi_cas(ixt,il)
               write(*,*) 'Pxtiinf_cas(ixt,il)=',Pxtiinf_cas(ixt,il)
               write(*,*) 'xtnew_cas(ixt,il)=',xtnew_cas(ixt,il)
               write(*,*) 'xtp0_cas(ixt,il)=',xtp0_cas(ixt,il)
               write(*,*) 'Pxtisup_cas(ixt,il)=',Pxtisup_cas(ixt,il)
               write(*,*) 'fac_ftmr_cas(il)=',fac_ftmr_cas(il)
               write(*,*) 'Eqi_cas(il)=',Eqi_cas(il)
               write(*,*) 'Pqiinf_cas(il)=',Pqiinf_cas(il)
               write(*,*) 'qp0_cas(il)=',qp0_cas(il)
               write(*,*) 'm0_cas(il)=',m0_cas(il)
               write(*,*) 'Rb(ixt,il)=',Rb(ixt,il)
               write(*,*) 'Rl(ixt,il)=',Rl(ixt,il)
               write(*,*) 'r_jqp0(ixt,il)=',r_jqp0(ixt,il)
               write(*,*) 'r_jl0(ixt,il)=',r_jl0(ixt,il)
               write(*,*) 'J(ixt,il)=',J(ixt,il)
               write(*,*) 'A_cas(il)=',A_cas(il)
               write(*,*) 'f_cas(il)=',f_cas(il)
               write(*,*) 'g_cas(il)=',g_cas(il)
               write(*,*) 'beta_cas(ixt,il)=',beta_cas(ixt,il)
               write(*,*) 'gama_cas(ixt,il)=',gama_cas(ixt,il)
               write(*,*) 'f**beta=',f_cas(il)**beta_cas(ixt,il)
               write(*,*) 'f**(beta+1)=',f_cas(il)**(beta_cas(ixt,il)+1)
               write(*,*) 'g*(-beta*gama)=',g_cas(il)**
     :          (-beta_cas(ixt,il)*gama_cas(ixt,il))
               write(*,*) 'g*(-beta*gama-1)=',g_cas(il)**
     :          (-beta_cas(ixt,il)*gama_cas(ixt,il)-1.0)
               stop
              endif
            enddo
#endif
#ifdef ISOVERIF            
            if (use_iso_eau.eq.1) then
              if (iso_verif_egalite_choix_nostop(
     :           double_to_real(Pxtiinf_cas(iso_eau,il)),
     :           double_to_real(Pqiinf_cas(il)),'stewart_explicite 451',
     :           errmax*50,errmaxrel*50).eq.1) then 
                 write(*,*) 'il=',il
                 if (il.le.ncas_Jsimple) then
                    write(*,*) 'cas_Jsimple(il)=',cas_Jsimple(il)
                 else !if (il.le.ncas_Jsimple) then
                    write(*,*) 'cas_rieman(il)=',cas_rieman(il)
                 endif !if (il.le.ncas_Jsimple) then
                 write(*,*) 'Rl=',Rl(iso_eau,il),' Rb=',Rb(iso_eau,il)
                 write(*,*) 'g**(1-beta*gama)=',g_cas(il)**
     :                 (1-beta_cas(iso_eau,il)*gama_cas(iso_eau,il))
                 write(*,*) 'j=',j(iso_eau,il)
!#ifdef rieman                 
!                 write(*,*) 'e=',e(iso_eau,il)
!#endif                 
!                 write(*,*) 'ntot_cas(il)=',ntot_cas(il)
                 write(*,*) 'gama=',gama_cas(iso_eau,il),
     :                   ' beta=',beta_cas(iso_eau,il)
                 if (il.le.ncas_Jsimple) then
                   write(*,*) 'h=',h(cas_Jsimple(il)),
     :                   ' Tevap=',Tevap(cas_Jsimple(il))
                 else !if (il.le.ncas_Jsimple) then
                     write(*,*) 'h=',h(cas_rieman(il)),
     :                   ' Tevap=',Tevap(cas_rieman(il))
                 endif !if (il.le.ncas_Jsimple) then
                 write(*,*) 'f=',f_cas(il),' g=',g_cas(il)
                 write(*,*) 'r_jl0=',r_jl0(iso_eau,il),
     :                   ' r_jqp0=',r_jqp0(iso_eau,il)
                 write(*,*) 'r_l0qp0=',r_l0qp0_cas(il)
                 write(*,*) 'm0=',m0_cas(il),' m=',m_cas(il),
     :                           ' m0-m=',m0_cas(il)-m_cas(il)
                 write(*,*) 'A=',A_cas(il),' qp0=',qp0_cas(il)
                 write(*,*) 'Rl0=',Rl0_cas(iso_eau,il),
     :           ' Rb0=',Rb0_cas(iso_eau,il)
                 write(*,*) 'pond Rl0=',(f_cas(il)
     :               **beta_cas(iso_eau,il))
     ;                   *(g_cas(il)**(-beta_cas(iso_eau,il)
     :                   *gama_cas(iso_eau,il)))
     :                 +beta_cas(iso_eau,il)*gama_cas(iso_eau,il)
     :              *r_jqp0(iso_eau,il)/f_cas(il)/g_cas(il)
                 write(*,*) 'pond Rb0=',
     :              gama_cas(iso_eau,il)*beta_cas(iso_eau,il)
     :              *r_jl0(iso_eau,il)/f_cas(il)/g_cas(il)
                 write(*,*) 'fac1=',
     :                  f_cas(il)**beta_cas(iso_eau,il)
                 write(*,*) 'fac2=',g_cas(il)
     :             **(-beta_cas(iso_eau,il)*gama_cas(iso_eau,il)) 
                 write(*,*) 't3=',beta_cas(iso_eau,il)
     :               *gama_cas(iso_eau,il)*r_jqp0(iso_eau,il)
     :           /f_cas(il)/g_cas(il)    
                 stop   
               endif !if (iso_verif_egalite_choix_nostop(
               if (iso_verif_egalite_choix_nostop(
     :           double_to_real(xtnew_cas(iso_eau,il)),
     :           double_to_real(qp0_cas(il)+Eqi_cas(il)
     :           *fac_ftmr_cas(il)),'stewart_explicite 1026',
     :           errmax*50,errmaxrel*50).eq.1) then 
                 write(*,*) 'il=',il                 
                 if (il.le.ncas_Jsimple) then
                    write(*,*) 'cas_Jsimple(il)=',cas_Jsimple(il)
                 else !if (il.le.ncas_Jsimple) then
                    write(*,*) 'cas_rieman(il)=',cas_rieman(il)
                 endif !if (il.le.ncas_Jsimple) then
                 write(*,*) 'Rl=',Rl(iso_eau,il),' Rb=',Rb(iso_eau,il)
                 write(*,*) 'g**(1-beta*gama)=',g_cas(il)**
     :                 (1-beta_cas(iso_eau,il)*gama_cas(iso_eau,il))
                 write(*,*) 'J=',J(iso_eau,il)
!#ifdef rieman                 
!                 write(*,*) 'e=',e(iso_eau,il)
!#endif                   
!                 write(*,*) 'ntot_cas(il)=',ntot_cas(il)
                 write(*,*) 'gama=',gama_cas(iso_eau,il),
     :                   ' beta=',beta_cas(iso_eau,il)
                 if (il.le.ncas_Jsimple) then
                   write(*,*) 'h=',h(cas_Jsimple(il)),
     :                   ' Tevap=',Tevap(cas_Jsimple(il))
                 else !if (il.le.ncas_Jsimple) then
                     write(*,*) 'h=',h(cas_rieman(il)),
     :                   ' Tevap=',Tevap(cas_rieman(il))
                 endif !if (il.le.ncas_Jsimple) then
                 write(*,*) 'f=',f_cas(il),' g=',g_cas(il)
                 write(*,*) 'r_jl0=',r_jl0(iso_eau,il),
     :                   ' r_jqp0=',r_jqp0(iso_eau,il)
                 write(*,*) 'r_l0qp0=',r_l0qp0_cas(il)
                 write(*,*) 'm0=',m0_cas(il),' m=',m_cas(il)
                 write(*,*) 'A=',A_cas(il),' qp0=',qp0_cas(il)
                 write(*,*) 'Rl0=',Rl0_cas(iso_eau,il),
     :           ' Rb0=',Rb0_cas(iso_eau,il)
                 write(*,*) 'pond Rl0=',r_l0qp0_cas(il)* (1/g_cas(il)
     :              -(f_cas(il)**(beta_cas(iso_eau,il)+1))
     :              *(g_cas(il)**(-beta_cas(iso_eau,il)
     :                   *gama_cas(iso_eau,il)-1)) 
     :              -beta_cas(iso_eau,il)*gama_cas(iso_eau,il)
     :                   *r_jqp0(iso_eau,il)
     :                   /g_cas(il)/g_cas(il))
                 write(*,*) 'pond Rb0=',(1/g_cas(il) 
     :              - 1/g_cas(il)/g_cas(il) * gama_cas(iso_eau,il)
     :             *beta_cas(iso_eau,il)*r_jqp0(iso_eau,il))
                 stop   
               endif !if (iso_verif_egalite_choix_nostop(
               if ((iso_verif_egalite_choix_nostop(
     :            double_to_real(Exi_cas(iso_eau,il)),
     :            double_to_real(Eqi_cas(il)),'stewart_explicite 777',
     :            errmax*800,errmaxrel*800).eq.1).or.
     :            (iso_verif_egalite_choix_nostop(
     :            double_to_real(Exi_cas(iso_eau,il)*fac_ftmr_cas(il)),
     :            double_to_real(Eqi_cas(il)*fac_ftmr_cas(il)),
     :           'stewart_explicite 586',
     :            errmax*3000,errmaxrel*800).eq.1)) then  
                  write(*,*) 'il=',il                 
                 if (il.le.ncas_Jsimple) then
                    write(*,*) 'cas_Jsimple(il)=',cas_Jsimple(il)
                 else !if (il.le.ncas_Jsimple) then
                    write(*,*) 'cas_rieman(il)=',cas_rieman(il)
                 endif !if (il.le.ncas_Jsimple) then
                  write(*,*) 'g**(1-beta*gama)=',g_cas(il)
     :                **(1-beta_cas(iso_eau,il)*gama_cas(iso_eau,il))
                  write(*,*) 'Eqi,Exi,fac_ftmr,Pqiinf=',Eqi_cas(il),
     :             Exi_cas(iso_eau,il),fac_ftmr_cas(il),Pqiinf_cas(il)
                  write(*,*) 'xtnew(iso_eau,il),xtp0(iso_eau,il)=',
     :              xtnew_cas(iso_eau,il),xtp0_cas(iso_eau,il)     
                  stop
             endif
            endif  !if (use_iso_eau.eq.1) then
            if (use_iso_HDO.eq.1) then
               if (qp0_cas(il)+Eqi_cas(il)*fac_ftmr_cas(il)
     :                   .gt.ridicule) then
                 if (iso_verif_aberrant_nostop(double_to_real(
     :                xtnew_cas(iso_HDO,il)/(qp0_cas(il)+Eqi_cas(il)
     :                *fac_ftmr_cas(il))),
     :                'stewart_explicite 1316').eq.1) then
                   write(*,*) 'il,fac_ftmr_cas(il)=',il,fac_ftmr_cas(il)
                   write(*,*) 'h(il)=',h(il)
                   write(*,*) 'alphap(iso_HDO,il)=',alphap(iso_HDO,il)
                   write(*,*) 'Di/D)^n=',tdifrel(iso_HDO)**(tdifexp)
                   write(*,*) 'qp0_cas(il)=',qp0_cas(il)   
                   write(*,*) 'Eqi_cas(il)=',Eqi_cas(il)   
                   write(*,*) 'Pqiinf_cas(il)=',Pqiinf_cas(il) 
                   write(*,*) 'm0_cas(il)=',m0_cas(il)
                   write(*,*) 'deltaD(Rb0(iso_HDO,il))=',
     :               deltaD(Rb0(iso_HDO,il))
                   write(*,*) 'deltaD(Rl0(iso_HDO,il))=',
     :               deltaD(Rl0(iso_HDO,il))
                   write(*,*) 'deltaD(Rb(iso_HDO,il))=',
     :               deltaD(Rb(iso_HDO,il))
                   write(*,*) 'deltaD(Rl(iso_HDO,il))=',
     :               deltaD(Rl(iso_HDO,il))
                   write(*,*) 'r_jqp0(iso_HDO,il)=',r_jqp0(iso_HDO,il)
                   write(*,*) 'r_jl0(iso_HDO,il)=',r_jl0(iso_HDO,il)
                   write(*,*) 'J(iso_HDO,il)=',J(iso_HDO,il)
                   write(*,*) 'A_cas(il)=',A_cas(il)
                   write(*,*) 'f_cas(il)=',f_cas(il)
                   write(*,*) 'g_cas(il)=',g_cas(il)
                   write(*,*) 'beta_cas(iso_HDO,il)=',
     :               beta_cas(iso_HDO,il)
                   write(*,*) 'gama_cas(iso_HDO,il)=',
     :               gama_cas(iso_HDO,il)
                   stop
                 endif
                endif !if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
              endif !if (use_iso_HDO.eq.1)
#endif            
          enddo !do il=1,ncas_Jsimple+ncas_rieman 

          call uncompress_calculJ(ncas,ncas_rieman,ncas_Jsimple,
     :          cas_rieman,cas_Jsimple,Exi_cas,Exi,
     :           xtnew_cas,xtnew,Pxtiinf_cas,Pxtiinf)


#ifdef ISOVERIF
        ! vrif de la dcompression:        
        do icas_Jsimple=1,ncas_Jsimple
         do ixt=1,niso
          call iso_verif_egalite_choix(
     :           double_to_real(xtnew_cas(ixt,icas_Jsimple)),
     :           double_to_real(xtnew(ixt,cas_Jsimple(icas_Jsimple))),
     :           'stewart_explicit 1046',errmax,errmaxrel)
          call iso_verif_egalite_choix(
     :           double_to_real(Exi_cas(ixt,icas_Jsimple)),
     :           double_to_real(Exi(ixt,cas_Jsimple(icas_Jsimple))),
     :           'stewart_explicit 1047',errmax,errmaxrel)
         enddo !do ixt=1,niso
        enddo !do icas_Jsimple=1,ncas_Jsimple
        do icas_Jsimple=1,ncas_rieman
         do ixt=1,niso
          call iso_verif_egalite_choix(
     :        double_to_real(xtnew_cas(ixt,icas_Jsimple+ncas_Jsimple)),
     :        double_to_real(xtnew(ixt,cas_rieman(icas_Jsimple))),
     :        'stewart_explicit 1054',errmax,errmaxrel)
          call iso_verif_egalite_choix(
     :        double_to_real(Exi_cas(ixt,icas_Jsimple+ncas_Jsimple)),
     :        double_to_real(Exi(ixt,cas_rieman(icas_Jsimple))),
     :        'stewart_explicit 1055',errmax,errmaxrel)
         enddo !do ixt=1,niso 
        enddo !do icas_Jsimple=1,ncas_Jsimple
#endif   
        

            ! cam verifs
#ifdef ISOVERIFNAN
         do icas_Jsimple=1,ncas_Jsimple+ncas_rieman    
           if (icas_Jsimple.le.ncas_Jsimple) then
             il=cas_Jsimple(icas_Jsimple)
           else
             il=cas_rieman(icas_Jsimple-ncas_Jsimple)
           endif
           do ixt=1,niso
            if ((iso_verif_noNaN_nostop(double_to_real(Pxtiinf(ixt,il)),
     :         'stewart_explicite 618').eq.1).or.
     :         (iso_verif_noNaN_nostop(double_to_real(Exi(ixt,il)),
     :         'stewart_explicite 620').eq.1).or.
     :         (iso_verif_noNaN_nostop(double_to_real(xtnew(ixt,il)),
     :         'stewart_explicite 622').eq.1)) then
               write(*,*) 'ixt,il=',ixt,il
               write(*,*) 'icas_Jsimple,ncas_Jsimple=',
     :                  icas_Jsimple,ncas_Jsimple
               stop
             endif !if ((iso_verif_noNaN_nostop
           enddo  !do ixt=1,niso  
         enddo !do icas_Jsimple=1,ncas_Jsimple+ncas_rieman  
#endif           
#ifdef ISOVERIF
         do icas_Jsimple=1,ncas_Jsimple+ncas_rieman    
           if (icas_Jsimple.le.ncas_Jsimple) then
             il=cas_Jsimple(icas_Jsimple)
           else
             il=cas_rieman(icas_Jsimple-ncas_Jsimple)
           endif           
           if (use_iso_eau.eq.1) then
               if (iso_verif_egalite_choix_nostop(
     :           double_to_real(Pxtiinf(iso_eau,il)),
     :           double_to_real(Pqiinf(il)),'stewart_explicite 1105',
     :           errmax*50,errmaxrel*50).eq.1) then 
                  write(*,*) 'icas_Jsimple,il,trace(il)=',
     :                    icas_Jsimple,il,trace(il) 
                  write(*,*) 'Pqiinf_cas(icas_Jsimple)=',
     :                   Pqiinf_cas(icas_Jsimple)
                  write(*,*) 'Pxtiinf_cas(iso_eau,icas_Jsimple)=',
     :                   Pxtiinf_cas(iso_eau,icas_Jsimple)
                  stop
             endif
             !Pxtiinf=Pqiinf
             if ((iso_verif_egalite_choix_nostop(
     :            double_to_real(Exi(iso_eau,il)),
     :            double_to_real(Eqi(il)),'stewart_explicite 778',
     :            errmax*800,errmaxrel*800).eq.1).or.
     :            (iso_verif_egalite_choix_nostop(
     :            double_to_real(Exi(iso_eau,il)*fac_ftmr(il)),
     :            double_to_real(Eqi(il)*fac_ftmr(il)),
     :           'stewart_explicite 587',
     :            errmax*3000,errmaxrel*800).eq.1)) then  
                  write(*,*) 'il,icas_Jsimple=',il,icas_Jsimple
                  write(*,*) 'g**(1-beta*gama)=',
     :                   g(il)**(1-beta(iso_eau,il)*gama(iso_eau,il))
                  write(*,*) 'Eqi,Exi,fac_ftmr=',
     :                   Eqi(il),Exi(iso_eau,il),fac_ftmr(il)
                  stop
             endif

             ! le 6 dec 2011: on relache ridicule en ridicule*2
             if (Pqiinf(il).gt.ridicule*2) then
               if (iso_verif_egalite_choix_nostop
     :           (double_to_real(Pxtiinf(iso_eau,il)/Pqiinf(il)),1.,
     :           'stewart_explicite 716',
     :            errmax*10,errmaxrel*50).eq.1) then
                 write(*,*) 'il=',il
                 write(*,*) 'Pqiinf,Pxtiinf=',
     :                 Pqiinf(il),Pxtiinf(iso_eau,il)
                 write(*,*) 'fac_ftmr_cas(il)=',fac_ftmr_cas(il)
                 write(*,*) 'f,h(il)=',f(il),h(il)
                 write(*,*) 'Eqi(il)*fac_ftmr(il)/qp0(il)=',
     :                  Eqi(il)*fac_ftmr(il)/qp0(il)        
                 write(*,*) 'g(il)=',g(il)           
                 stop
               endif !if (iso_verif_egalite_choix_nostop
             endif !if (Pqiinf.gt.ridicule) then
             
             if (iso_verif_egalite_choix_nostop(
     :                   double_to_real(xtnew(iso_eau,il)),
     :                   double_to_real(qp0(il)+Eqi(il)*fac_ftmr(il)),
     :                   'stewart_explicite 732',errmax*10,errmaxrel*50)
     :                           .eq.1) then
                        write(*,*) 'icas_Jsimple,il,trace(il)=',
     :                    icas_Jsimple,il,trace(il) 
                        write(*,*) 'xtnew_cas(iso_eau,icas_Jsimple)=',
     :                   xtnew_cas(iso_eau,icas_Jsimple)
                        write(*,*) 'xtnew(iso_eau,il)=',
     :                           xtnew(iso_eau,il)
                        write(*,*) 'qp0(il)=',qp0(il)
                        write(*,*) 'qp0_cas(icas_Jsimple)=',
     :                           qp0(icas_Jsimple)
                        write(*,*) 'Eqi(il)=',Eqi(il)
                        write(*,*) 'Eqi_cas(icas_Jsimple)=',
     :                           Eqi(icas_Jsimple)
                        write(*,*) 'fac_ftmr(il)=',fac_ftmr(il)
                        write(*,*) 'fac_ftmr_cas(icas_Jsimple)=',
     :                           fac_ftmr_cas(icas_Jsimple)
                        stop
             endif
             ! pour meilleure convergence numrique:
             if (bidouille_anti_divergence) then
                 Exi(iso_eau,il)=Eqi(il)
                 xtnew(iso_eau,il)=qp0(il)+Eqi(il)*fac_ftmr(il)
                 Pxtiinf(iso_eau,il)=Pqiinf(il)
             endif   

           endif   ! if if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) the       

           if (use_iso_HDO.eq.1) then
            if (Pqiinf(il).gt.ridicule_rain) then
              if (iso_verif_aberrant_nostop(
     :                  double_to_real(Pxtiinf(iso_HDO,il)/Pqiinf(il)),
     :                   'stewart_explicie 871').eq.1)  then
              write(*,*) 'deltaDl0=',deltaD(
     :           double_to_real(Rl0(iso_HDO,il)))
                write(*,*) 'deltaDb0=',deltaD(
     :           double_to_real(Rb0(iso_HDO,il)))
                stop
              endif  !if (iso_verif_aberrant_nostop(
             endif !if (Pqiinf(il).gt.ridicule_rain) then
             if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
                 call iso_verif_aberrant(double_to_real(
     :               xtnew(iso_HDO,il)/(qp0(il)+Eqi(il)
     :               *fac_ftmr(il))),'stewart_explicite 1461')
             endif !if (qp0(il)+Eqi(il)*fac_ftmr(il).gt.ridicule) then
            endif !if (use_iso_HDO.eq.1)

            if ((debug.eq.1).and.(il.eq.il_debug)) then
                  write(*,*) 'stewart_explicit 1558: cas avec calcul J'
                  write(*,*) 'Eqi(il),deltaD=',Eqi(il),
     :                   deltaD(double_to_real(Exi(iso_HDO,il)/Eqi(il)))
                  if (icas_Jsimple.le.ncas_Jsimple) then
                       write(*,*) 'calcul J par simple'
                  else
                       write(*,*) 'calcul J par Rieman'
                  endif
                  write(*,*) 'stewart_explict 1051: h(il)=',h(il)
                  write(*,*) 'f(il)=',f(il)
                  write(*,*) 'Eqi(il)*fac_ftmr(il)/qp0(il)=',
     :              Eqi(il)*fac_ftmr(il)/qp0(il)
                  write(*,*) 'Pqisup,deltaD=',Pqisup(il),deltaD(
     :             double_to_real(Pxtisup(iso_HDO,il)/Pqisup(il)))
                  write(*,*) 'qp0,deltaD=',qp0(il),deltaD(
     :             double_to_real(xtp0(iso_HDO,il)/qp0(il)))
                  write(*,*) 'f_cas(icas)=',f_cas(icas_Jsimple)
                  write(*,*) 'g_cas(icas)=',g_cas(icas_Jsimple)
                  write(*,*) 'beta_cas(icas)=',
     :                   beta_cas(iso_HDO,icas_Jsimple)
                  write(*,*) 'gama_cas(icas)=',
     :                   gama_cas(iso_HDO,icas_Jsimple)
                  write(*,*) 'r_jqp0(icas)=',
     :                   r_jqp0(iso_HDO,icas_Jsimple)
                  write(*,*) 'r_jl0(icas)=',r_jl0(iso_HDO,icas_Jsimple)
                  write(*,*) 'r_l0qp0(icas)=',
     :                   r_l0qp0_cas(icas_Jsimple)
                  write(*,*) 'J(icas)=',J(iso_HDO,icas_Jsimple)
                  write(*,*) 'deltaDl0(icas)=',deltaD
     ;                 (double_to_real(Rl0_cas(iso_HDO,icas_Jsimple)))
                  write(*,*) 'deltaDb0(icas)=',deltaD
     ;                 (double_to_real(Rb0_cas(iso_HDO,icas_Jsimple)))
                  write(*,*) 'deltaDl(icas)=',deltaD
     ;                 (double_to_real(Rl(iso_HDO,icas_Jsimple)))
                  write(*,*) 'deltaDb(icas)=',deltaD
     ;                 (double_to_real(Rb(iso_HDO,icas_Jsimple)))
                  write(*,*) 'Pqiinf_cas(icas)=',
     :                   Pqiinf_cas(icas_Jsimple)
                  write(*,*) 'Eqi_cas(icas)=',Eqi_cas(icas_Jsimple)
                  write(*,*) 'qp0_cas(icas)=',qp0_cas(icas_Jsimple)
                  write(*,*) 'fac_ftmr_cas(icas)=',
     :                   fac_ftmr_cas(icas_Jsimple)
            endif !if ((debug.eq.1).and.(il.eq.il_debug)) then

            enddo !do il=1,ncas_Jsimple+ncas_rieman    
#endif  
        endif !if (ncas_rieman+ncas_Jsimple.gt.0) then 

#ifdef ISOVERIF
!          write(*,*) 'stewart_explicite vectall 1179: fin'
#endif         
        
        return
                
        end
#endif           
