        subroutine stewart_glace_vectall(ncas,q,xt,Pqisup
     :           ,Pxtisup,Eqi,Pqiinf
     :          ,Pxtiinf,xtnew,Exi,fac_ftmr,
     :           Tevap)

        implicit none

        ! idem que stewart_loop, mais pour la rrvap de la glace.
        ! On n'applique donc pas la formule de stewart, on applique
        ! juste le bilan de masse et une rvap sans effets cintaiques

          ! declaration des variables      
#include "wateriso2.h"          
        ! **inputs
        integer ncas
        double precision q(ncas),xt(niso,ncas)
        double precision Pxtisup(niso,ncas)
        double precision Pqisup(ncas)
        double precision Eqi(ncas),Pqiinf(ncas)
        double precision fac_ftmr(ncas)       
        real Tevap(ncas)    

               ! **outputs
        double precision xtnew(niso,ncas)
        double precision Pxtiinf(niso,ncas)
        double precision Exi(niso,ncas)
        
        ! **locals
        real zxtalphai(niso,ncas)
        real f(ncas) , double_to_real
        integer ixt,il        
#include "iso_verif.h"        
        
!        write(*,*) 'sttewart_glace 39: entre'
        
        
        ! quelques verifs de bilan d'eau
#ifdef ISOVERIF
        do il=1,ncas
          call iso_verif_egalite(
     :           double_to_real(Pqisup(il)-Eqi(il)-Pqiinf(il)),0.0,
     :           'stewart_glace 37')
          if (use_iso_eau.eq.1) then
              call iso_verif_egalite(double_to_real(Pqisup(il)),
     :           double_to_real(Pxtisup(iso_eau,il)),'stewart_loop 52')
              call iso_verif_egalite(double_to_real(xt(iso_eau,il)),
     :           double_to_real(q),'stewart_loop 58')
          endif !if  ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
        enddo !do il=1,ncas
#endif
        ! fin des verifs
        
        ! ***************** dbut des calculs **********
        do il=1,ncas
        ! traitement rapide de quelques cas particuliers:
        if (Pqisup(il).eq.0) then
            ! pas de pluie, pas de Pqiinf, pas de changement de vap
            ! cam verif
#ifdef ISOVERIF
            if ((abs(Pqiinf(il)).gt.ridicule)
     :            .or.(abs(Eqi(il)).gt.ridicule)) then
                write(*,*) 'stewart_loop 39'
                write(*,*) 'Pqisup=',Pqisup(il)
                write(*,*) 'Eqi=',Eqi(il)
                write(*,*) 'Pqiinf=',Pqiinf(il)
                stop
            endif  
#endif    
            ! end cam verif
            do ixt=1,niso
              xtnew(ixt,il)=xt(ixt,il)
              Pxtiinf(ixt,il)=0.0
              Exi(ixt,il)=0.0
            enddo !do ixt=1,niso
        else !if (Pqisup(il).eq.0) then

        ! calcul du coeff de fractionnement
        do ixt=1,niso
          call fractcalk_glace(ixt,Tevap,zxtalphai(ixt,il))
        enddo
        
        ! calcul de f=la fraction rsiduelle
        f(il)=Pqiinf(il)/(Pqisup(il))

        ! calcul de Pxtiinf et Exi
        ! sparation en 2 cas pour une meilleure convergence numrique        
        if (f(il).lt.0.9) then
         do ixt=1,niso   
            Pxtiinf(ixt,il)=Pxtisup(ixt,il)*Pqiinf(il)*zxtalphai(ixt,il)
     :           /(Eqi(il)+Pqiinf(il)*zxtalphai(ixt,il))
            Exi(ixt,il)=Pxtisup(ixt,il)-Pxtiinf(ixt,il)
         enddo !do ixt=1,niso  
        else
         do ixt=1,niso     
            Exi(ixt,il)=Eqi(il)*Pxtisup(ixt,il)
     :           /(Eqi(il)+Pqiinf(il)*zxtalphai(ixt,il))
            Pxtiinf(ixt,il)=Pxtisup(ixt,il)-Exi(ixt,il)
         enddo !do ixt=1,niso
        endif !if (f.lt.0.9) then

        ! verif
#ifdef ISOVERIF
        do ixt=1,niso
            call iso_verif_noNAN(double_to_real(Exi(ixt,il)),
     :           'stewart_glace 102')
            call iso_verif_noNAN(double_to_real(Pxtiinf(ixt,il)),
     :           'stewart_glace 111')
         enddo !do ixt=1,niso   
         if (use_iso_eau.eq.1) then
           call iso_verif_egalite(double_to_real(Exi(iso_eau,il)),
     :                   double_to_real(Eqi(il)),'stewart_glace 101')
           call iso_verif_egalite(double_to_real(Pxtiinf(iso_eau,il)),
     :           double_to_real(Pqiinf(il)),'stewart_glace 110')
         endif !if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
#endif
        if ((bidouille_anti_divergence).and.
     :            (use_iso_eau.eq.1)) then
          ! assurer la convergence numrique pour ixt=4:
          Exi(iso_eau,il)=Eqi(il)
          Pxtiinf(iso_eau,il)=Pqiinf(il)
         endif !if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)
          
        
        ! calcul de xtnew
        do ixt=1,niso
          xtnew(ixt,il)=xt(ixt,il)+Exi(ixt,il)*fac_ftmr(il)
          xtnew(ixt,il)=max(0.0,xtnew(ixt,il))
        enddo

        ! verif
#ifdef ISOVERIF
        do ixt=1,niso
          call iso_verif_noNAN(double_to_real(xtnew),
     :           'stewart_glace 140')
        enddo !do ixt=1,niso  
          if ((use_iso_HDO.eq.1).and.
     :            (Pqisup(il).gt.ridicule_rain)) then
            call iso_verif_aberrant(double_to_real(
     :           Pxtiinf(iso_HDO,il)/Pqiinf(il)),'stewart_glace 175')  
          endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then
#endif
        ! end verif
        endif !if (Pqisup(il).eq.0) then
        enddo !do il=1,ncas
        
        ! ************ fin des calculs ***************

!        write(*,*) 'sttewart_glace 155: sortie'
        return
        end
