        subroutine stewart_glace_vectiso(q,xt,Pqisup
     :           ,Pxtisup,Eqi,Pqiinf
     :          ,Pxtiinf,xtnew,Exi,fac_ftmr,
     :           qs,Tevap)

        implicit none

        ! idem que stewart_loop, mais pour la rrvap de la glace.
        ! On n'applique donc pas la formule de stewart, on applique
        ! juste le bilan de masse et une rvap sans effets cintaiques

          ! declaration des variables      
#include "wateriso2.h"          
        ! **inputs
        double precision q,xt(niso)
        double precision Pxtisup(niso)
        double precision Pqisup
        double precision Eqi,Pqiinf
        real qs
        double precision fac_ftmr        
        real Tevap     

               ! **outputs
        double precision xtnew(niso)
        double precision Pxtiinf(niso)
        double precision Exi(niso)
        
        ! **locals
        real zxtalphai(niso), alphap(niso)
        real f , double_to_real
        integer ixt        
#include "iso_verif.h"        
        
!        write(*,*) 'sttewart_glace 39: entre'
        
        ! quelques verifs de bilan d'eau
#ifdef ISOVERIF
          call iso_verif_egalite(double_to_real(Pqisup-Eqi-Pqiinf),0.0,          
     :           'stewart_glace 37')
          if (use_iso_eau.eq.1) then
              call iso_verif_egalite(double_to_real(Pqisup),
     :           double_to_real(Pxtisup(iso_eau)),'stewart_loop 52')
              call iso_verif_egalite(double_to_real(xt(iso_eau)),
     :           double_to_real(q),'stewart_loop 58')
          endif !if  ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
#endif
        ! fin des verifs
        
        ! ***************** dbut des calculs **********
        
        ! traitement rapide de quelques cas particuliers:
        if (Pqisup.eq.0) then
            ! pas de pluie, pas de Pqiinf, pas de changement de vap
            ! cam verif
#ifdef ISOVERIF
            if ((abs(Pqiinf).gt.ridicule)
     :            .or.(abs(Eqi).gt.ridicule)) then
                write(*,*) 'stewart_loop 39'
                write(*,*) 'Pqisup=',Pqisup
                write(*,*) 'Eqi=',Eqi
                write(*,*) 'Pqiinf=',Pqiinf
                stop
            endif  
#endif    
            ! end cam verif
            do ixt=1,niso
            xtnew(ixt)=xt(ixt)
            Pxtiinf(ixt)=0.0
            Exi(ixt)=0.0
            enddo !do ixt=1,niso
            return
        endif

        ! calcul du coeff de fractionnement
        do ixt=1,niso
          CALL FRACTCALK(IXT, TEVAP, alphap(ixt), zxtalphai(ixt))
        enddo
        
        ! calcul de f=la fraction rsiduelle
        f=Pqiinf/(Pqisup)

        ! calcul de Pxtiinf et Exi
        ! sparation en 2 cas pour une meilleure convergence numrique        
        if (f.lt.0.9) then
         do ixt=1,niso   
            Pxtiinf=Pxtisup(ixt)*Pqiinf*zxtalphai(ixt)
     :           /(Eqi+Pqiinf*zxtalphai(ixt))
            Exi(ixt)=Pxtisup(ixt)-Pxtiinf(ixt)
         enddo !do ixt=1,niso  
        else
         do ixt=1,niso     
            Exi(ixt)=Eqi*Pxtisup(ixt)/(Eqi+Pqiinf*zxtalphai(ixt))
            Pxtiinf(ixt)=Pxtisup(ixt)-Exi(ixt)
         enddo !do ixt=1,niso
        endif !if (f.lt.0.9) then

        ! verif
#ifdef ISOVERIF
        do ixt=1,niso
            call iso_verif_noNAN(double_to_real(Exi),
     :           'stewart_glace 102')
            call iso_verif_noNAN(double_to_real(Pxtiinf),
     :           'stewart_glace 111')
         enddo !do ixt=1,niso   
         if (use_iso_eau.eq.1) then
                call iso_verif_egalite(double_to_real(Exi(iso_eau)),
     :                   double_to_real(Eqi),'stewart_glace 101')
                call iso_verif_egalite(double_to_real(Pxtiinf),
     :           double_to_real(Pqiinf),'stewart_glace 110')
         endif !if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
#endif
        if ((bidouille_anti_divergence).and.
     :            (use_iso_eau.eq.1)) then
          ! assurer la convergence numrique pour ixt=4:
          Exi(iso_eau)=Eqi
          Pxtiinf(iso_eau)=Pqiinf
         endif !if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)
          
        
        ! calcul de xtnew

        do ixt=1,niso
        xtnew=xt+Exi*fac_ftmr
        xtnew=max(0.0,xtnew)
        enddo

        ! verif
#ifdef ISOVERIF
        do ixt=1,niso
          call iso_verif_noNAN(double_to_real(xtnew),
     :           'stewart_glace 140')
        enddo !do ixt=1,niso  
          if ((use_iso_HDO.eq.1).and.
     :            (Pqisup.gt.ridicule_rain)) then
            call iso_verif_aberrant(double_to_real(
     :           Pxtiinf(iso_HDo)/Pqiinf),'stewart_glace 175')  
          endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO)) then
#endif
        ! end verif

        
        ! ************ fin des calculs ***************

!        write(*,*) 'sttewart_glace 155: sortie'
        return
        end
