        subroutine stewart_sublim_nofrac_vectall(ncas,q
     :           ,xt,Pqisup,Pxtisup
     :           ,Eqi,Pqiinf
     :           ,Pxtiinf,xtnew,Exi
     :           ,fac_ftmr)

        implicit none

        ! rrvap de la glace.
        ! on suppose que pas de ractionnement lors de la sublimation de
        ! la glace

          ! declaration des variables      
#include "wateriso2.h"          
        ! **inputs
        integer ncas
        double precision q(ncas),xt(niso,ncas)
        double precision Pxtisup(niso,ncas)
        double precision Pqisup(ncas)
        double precision Eqi(ncas),Pqiinf(ncas)
        double precision fac_ftmr(ncas)      

               ! **outputs
        double precision xtnew(niso,ncas)
        double precision Pxtiinf(niso,ncas)
        double precision Exi(niso,ncas)
        
        ! **locals
        integer il
#include "iso_verif.h"
        real double_to_real ! debuggage
        double precision Rb0(niso,ncas)
        double precision real_to_double
        integer ixt
#ifdef ISOVERIF
        integer iso_verif_egalite_nostop
        integer iso_verif_egalite_choix_nostop
#endif        
        
!        write(*,*) 'sttewart_glace 39: entre'
        
        ! quelques verifs de bilan d'eau
#ifdef ISOVERIF
        do il=1,ncas
        if (iso_verif_egalite_nostop(double_to_real(
     :           Pqisup(il)-Eqi(il)-Pqiinf(il)),0.0,
     :           'stewart_sublim_nofrac 37').eq.1) then
          write(*,*) 'il,Pqisup(il),Eqi(il),Pqiinf(il)=',
     :          il,Pqisup(il),Eqi(il),Pqiinf(il)         
          stop
        endif
        if (use_iso_eau.eq.1) then
           call iso_verif_egalite(double_to_real(Pqisup(il)),
     :           double_to_real(Pxtisup(iso_eau,il)),
     :           'stewart_sublim_nofrac 38') 
           call iso_verif_egalite(double_to_real(xt(iso_eau,il)),
     :           double_to_real(q(il)),
     :           'stewart_sublim_nofrac 39')              
        endif !if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
        if ((use_iso_HDO.eq.1).and.
     :           (Pqisup(il).gt.ridicule_rain)) then
            call iso_verif_aberrant(
     :           double_to_real(Pxtisup(iso_HDO,il)/Pqisup(il)),
     :           'stewart_sublim_nofrac 40')     
        endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO).and.
        enddo !do il=1,ncas
#endif
        ! fin des verifs
        
        ! ***************** dbut des calculs **********
        
        do il=1,ncas
        ! traitement rapide de quelques cas particuliers:
        if (Pqisup(il).le.0) then
            ! pas de pluie, pas de Pqiinf, pas de changement de vap
            ! cam verif
#ifdef ISOVERIF
             if ((abs(Pqiinf(il)).gt.ridicule)
     :            .or.(abs(Eqi(il)).gt.ridicule)) then
                write(*,*) 'stewart_sublim 57'
                write(*,*) 'Pqisup=',Pqisup(il)
                write(*,*) 'Eqi=',Eqi(il)
                write(*,*) 'Pqiinf=',Pqiinf(il)
                stop
             endif   
#endif     
            ! end cam verif 
            do ixt=1,niso               
              Pxtiinf(ixt,il)=0.0
            enddo
            if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)) then
                Pxtiinf(iso_eau,il)=Pqiinf(il)
            endif
            if (abs(Eqi(il)*fac_ftmr(il)).gt.ridicule) then
                ! attention: pour des raisons obscures, il y a parfois
                ! de le rvaporation significative alors qu'il n'y a
                ! aucun cristal  rvaporer.
                ! Dans ce cas, on admet cette rvaporation obscure et
                ! on suppose qu'elle ne change pas la composition
                ! isotopique de la vapeur. 
                if (q(il).gt.ridicule) then
                   do ixt=1,niso
                     Rb0(ixt,il)=xt(ixt,il)/q(il)
                   enddo
                else !if (qp0.gt.ridicule) then
                   ! il n'y a pas encore de vapeur dans le ddft. On est
                   ! trs embtt, mais on se dit que le ddft sera
                   ! bientot recharg par de la vapeur plus lgitime
                   do ixt=1,niso
                     Rb0(ixt,il)=0.0                        
                   enddo !do ixt=1,niso  
                   if (use_iso_eau.eq.1) then
                        Rb0(iso_eau,il)=1.0 
                   endif      
                endif   !if (qp0.gt.ridicule) then
                do ixt=1,niso
                  Exi(ixt,il)=Rb0(ixt,il)*Eqi(il)
                  xtnew(ixt,il)=xt(ixt,il)+Exi(ixt,il)*fac_ftmr(il)
                enddo !do ixt=1,niso
            else !if (abs(Eqi*fac_ftmr).gt.ridicule) then
                ! a va, tout est logique, tous les flux d'eau sont nuls
                do ixt=1,niso
                  xtnew(ixt,il)=xt(ixt,il)
                  Exi(ixt,il)=0.0
                enddo !do ixt=1,niso
            endif !if (abs(Eqi*fac_ftmr).gt.ridicule) then
#ifdef ISOVERIF
              if (use_iso_eau.eq.1) then
                call iso_verif_egalite_choix(
     :             double_to_real(Exi(iso_eau,il)*fac_ftmr(il)),
     :             double_to_real(Eqi(il)*fac_ftmr(il)),
     :             'stewart_sublim_nofrac 125',errmax*10,errmaxrel*10)
                call iso_verif_egalite_choix(
     :           double_to_real(Pxtiinf(iso_eau,il)),
     :               double_to_real(Pqiinf(il)),
     :              'stewart_sublim_nofrac 143',errmax,errmaxrel)
                call iso_verif_egalite_choix(
     :              double_to_real(xtnew(iso_eau,il)),
     :              double_to_real(q(il)+Eqi(il)*fac_ftmr(il)),
     :              'stewart_sublim_nofrac 218',errmax*10,errmaxrel*50)
               endif
#endif
        else !if (Pqisup(il).le.0) then

        ! dornavant, Pqisup est diffrenent de 0
        

        ! calcul de Pxtiinf et Exi; pas de fractionnement
        do ixt=1,niso
            Pxtiinf(ixt,il)=Pxtisup(ixt,il)/Pqisup(il)*Pqiinf(il)
            Exi(ixt,il)=Pxtisup(ixt,il)/Pqisup(il)*Eqi(il)
        enddo ! do ixt=1,niso    

        ! verif
#ifdef ISOVERIF
        do ixt=1,niso
          call iso_verif_noNAN(double_to_real(Exi(ixt,il)),
     :           'stewart_sublim 102')
          call iso_verif_noNAN(double_to_real(Pxtiinf(ixt,il)),
     :           'stewart_sublim 102')
        enddo !do ixt=1,niso
          if (use_iso_eau.eq.1) then
           call iso_verif_egalite_choix(double_to_real(Exi(iso_eau,il)),
     :                   double_to_real(Eqi(il)),
     :           'stewart_sublim 101',errmax*1e-2,errmaxrel*1e-2) 
           call iso_verif_egalite(double_to_real(Pxtiinf(iso_eau,il)),
     :           double_to_real(Pqiinf(il)),'stewart_sublim 110')
          endif !if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
#endif

         if ((bidouille_anti_divergence).and.
     :           (use_iso_eau.eq.1)) then
          ! assurer la convergence numrique pour ixt=4:
          Exi(iso_eau,il)=Eqi(il)          
          Pxtiinf(iso_eau,il)=Pqiinf(il)
        endif !if  if ((bidouille_anti_divergence).and.(use_iso_eau.eq.1)
        
        ! calcul de xtnew

        do ixt=1,niso
          xtnew(ixt,il)=xt(ixt,il)+Exi(ixt,il)*fac_ftmr(il)
          xtnew(ixt,il)=max(0.0,xtnew(ixt,il))
        enddo !do ixt=1,niso

        ! verif
#ifdef ISOVERIF
        do ixt=1,niso
          call iso_verif_noNAN(
     :           double_to_real(xtnew(ixt,il)),'stewart_sublim 140')
        enddo ! do ixt=1,niso
        ! verif que deltaD(Pqiinf) raisonable
        if ((use_iso_HDO.eq.1).and.
     :           (Pqiinf(il).gt.ridicule_rain)) then
            call iso_verif_aberrant(
     :           double_to_real(Pxtiinf(iso_HDO,il)/Pqiinf(il)),
     :           'stewart_sublim 175')
        endif !if ((use_iso_HDO.eq.1).and.(ixt.eq.iso_HDO).and.
        if (use_iso_eau.eq.1) then
            if (q(il)+Eqi(il)*fac_ftmr(il).ge.0.0) then
            if (iso_verif_egalite_choix_nostop(
     :                  double_to_real(xtnew(iso_eau,il)),
     :                  double_to_real(q(il)+Eqi(il)*fac_ftmr(il)),
     :                  'stewart_sublim 108',
     :                  errmax,errmaxrel).eq.1) then
              write(*,*) 'q(il)=',q(il)
              write(*,*) 'Eqi(il)=',Eqi(il)
              write(*,*) 'fac_ftmr(il)=',fac_ftmr(il)
              stop
            endif !if (iso_verif_egalite_choix_nostop
            endif !if (q(il)+Eqi(il)*fac_ftmr(il).ge.0.0) then
            if (iso_verif_egalite_choix_nostop(
     :                  double_to_real(Pxtiinf(iso_eau,il)),
     :                  double_to_real(Pqiinf(il)),'stewart_sublim 204',
     :                  errmax,errmaxrel).eq.1) then
              write(*,*) 'Pqisup(il)=',Pqisup(il)
              stop
            endif !if (iso_verif_egalite_choix_nostop
        endif !if ((use_iso_eau.eq.1).and.(ixt.eq.iso_eau)) then
#endif
        ! end verif
        endif ! if pqisup.gt.0
        enddo ! do il=1,ncas

        ! en verif
        
        ! ************ fin des calculs ***************

!        write(*,*) 'sttewart_sublim 155: sortie'
        return
        end
