! $Id: physiq.F 1565 2011-08-31 12:53:29Z jghattas $
c#define IO_DEBUG

      SUBROUTINE physiq (nlon,nlev,
     .            debut,lafin,jD_cur, jH_cur,pdtphys,
     .            paprs,pplay,pphi,pphis,presnivs,clesphy0,
     .            u,v,t,qx,
     .            flxmass_w,
     .            d_u, d_v, d_t, d_qx, d_ps
     .            , dudyn
     .            , PVteta

     :          ,xtx
     :          ,d_xtx
     :          ,rlat_out   





     .            )

      USE ioipsl, only: histbeg, histvert, histdef, histend, histsync,
     $     histwrite, ju2ymds, ymds2ju, ioget_year_len
      USE comgeomphy
      USE phys_cal_mod
      USE write_field_phy
      USE dimphy
      USE infotrac
      USE mod_grid_phy_lmdz
      USE mod_phys_lmdz_para
      USE iophy
      USE misc_mod, mydebug=>debug
      USE vampir
      USE pbl_surface_mod, ONLY : pbl_surface
      USE change_srf_frac_mod
      USE surface_data,     ONLY : type_ocean, ok_veget
      USE phys_local_var_mod ! Variables internes non sauvegardees de la physique
      USE phys_state_var_mod ! Variables sauvegardees de la physique
      USE phys_output_var_mod ! Variables pour les ecritures des sorties
      USE fonte_neige_mod, ONLY  : fonte_neige_get_vars
      USE phys_output_mod
      use open_climoz_m, only: open_climoz ! ozone climatology from a file
      use regr_pr_av_m, only: regr_pr_av
      use netcdf95, only: nf95_close
cIM for NMC files
      use netcdf, only: nf90_fill_real
      use mod_phys_lmdz_mpi_data, only: is_mpi_root
      USE aero_mod
      use ozonecm_m, only: ozonecm ! ozone of J.-F. Royer
      use conf_phys_m, only: conf_phys
      use radlwsw_m, only: radlwsw
      USE control_mod





!IM stations CFMIP
      USE CFMIP_point_locations
      IMPLICIT none
c======================================================================
c
c Auteur(s) Z.X. Li (LMD/CNRS) date: 19930818
c
c Objet: Moniteur general de la physique du modele
cAA      Modifications quant aux traceurs :
cAA                  -  uniformisation des parametrisations ds phytrac
cAA                  -  stockage des moyennes des champs necessaires
cAA                     en mode traceur off-line 
c======================================================================
c   CLEFS CPP POUR LES IO
c   =====================

c#define histISCCP
c======================================================================
c    modif   ( P. Le Van ,  12/10/98 )
c
c  Arguments:
c
c nlon----input-I-nombre de points horizontaux
c nlev----input-I-nombre de couches verticales, doit etre egale a klev
c debut---input-L-variable logique indiquant le premier passage
c lafin---input-L-variable logique indiquant le dernier passage
c jD_cur       -R-jour courant a l'appel de la physique (jour julien)
c jH_cur       -R-heure courante a l'appel de la physique (jour julien)
c pdtphys-input-R-pas d'integration pour la physique (seconde)
c paprs---input-R-pression pour chaque inter-couche (en Pa)
c pplay---input-R-pression pour le mileu de chaque couche (en Pa)
c pphi----input-R-geopotentiel de chaque couche (g z) (reference sol)
c pphis---input-R-geopotentiel du sol
c presnivs-input_R_pressions approximat. des milieux couches ( en PA)
c u-------input-R-vitesse dans la direction X (de O a E) en m/s
c v-------input-R-vitesse Y (de S a N) en m/s
c t-------input-R-temperature (K)
c qx------input-R-humidite specifique (kg/kg) et d'autres traceurs
c d_t_dyn-input-R-tendance dynamique pour "t" (K/s)
c d_q_dyn-input-R-tendance dynamique pour "q" (kg/kg/s)
c flxmass_w -input-R- flux de masse verticale
c d_u-----output-R-tendance physique de "u" (m/s/s)
c d_v-----output-R-tendance physique de "v" (m/s/s)
c d_t-----output-R-tendance physique de "t" (K/s)
c d_qx----output-R-tendance physique de "qx" (kg/kg/s)
c d_ps----output-R-tendance physique de la pression au sol
cIM
c PVteta--output-R-vorticite potentielle a des thetas constantes
c======================================================================
!-----------------------------------------------------------------------
!   INCLUDE 'dimensions.h'
!
!   dimensions.h contient les dimensions du modele
!   ndm est tel que iim=2**ndm
!-----------------------------------------------------------------------

      INTEGER iim,jjm,llm,ndm

      PARAMETER (iim= 96,jjm=71,llm=39,ndm=1)

!-----------------------------------------------------------------------
      integer jjmp1
      parameter (jjmp1=jjm+1-1/jjm)
      integer iip1
      parameter (iip1=iim+1)
      integer jjp1
      parameter (jjp1=jjm+1)

!
! $Header$
!
      INTEGER i1_deb, i1_fin
      INTEGER i2_deb, i2_fin
ccc      PARAMETER (i1_deb=21, i1_fin=40)
ccc      PARAMETER (i2_deb=41, i2_fin=44)
cccc      PARAMETER (i1_deb=47, i1_fin=77)
cccc      PARAMETER (i2_deb=78, i2_fin=79)
      PARAMETER (i1_deb=16, i1_fin=30)
      PARAMETER (i2_deb=31, i2_fin=33)
c
      INTEGER j_deb, j_fin
ccc      PARAMETER (j_deb=29, j_fin=61)
cccc      PARAMETER (j_deb=21, j_fin=51)
      PARAMETER (j_deb=18, j_fin=39)
!
! $Header$
!
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation
!                 (les placer en colonne 6 et en colonne 73)
!
!
      INTEGER nbsrf
      PARAMETER (nbsrf=4) ! nombre de sous-fractions pour une maille
!
      INTEGER is_oce
      PARAMETER (is_oce=3) ! ocean
      INTEGER is_sic
      PARAMETER (is_sic=4) ! glace de mer
      INTEGER is_ter
      PARAMETER (is_ter=1) ! terre
      INTEGER is_lic
      PARAMETER (is_lic=2) ! glacier continental
!
      REAL epsfra
      PARAMETER (epsfra=1.0E-05)
!
      CHARACTER(len=3) clnsurf(nbsrf)
      DATA clnsurf/'ter', 'lic', 'oce', 'sic'/
      SAVE clnsurf
!$OMP THREADPRIVATE(clnsurf)
!
! $Header$
!
      INTEGER nsoilmx
      PARAMETER (nsoilmx=11)

!
! $Id: clesphys.h 1750 2013-04-25 15:27:27Z fairhead $
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation 
!                 (les placer en colonne 6 et en colonne 73)
!
!..include cles_phys.h
!
       LOGICAL cycle_diurne,soil_model,new_oliq,ok_orodr,ok_orolf 
       LOGICAL ok_limitvrai
       INTEGER nbapp_rad, iflag_con
       REAL co2_ppm, co2_ppm0, solaire
       REAL(kind=8) RCO2, RCH4, RN2O, RCFC11, RCFC12  
       REAL(kind=8) RCO2_act, RCH4_act, RN2O_act, RCFC11_act, RCFC12_act  
       REAL(kind=8) CH4_ppb, N2O_ppb, CFC11_ppt, CFC12_ppt
!IM ajout CFMIP2/CMIP5
       REAL co2_ppm_per
       LOGICAL ok_4xCO2atm
       REAL(kind=8) RCO2_per,RCH4_per,RN2O_per,RCFC11_per,RCFC12_per
       REAL(kind=8) CH4_ppb_per,N2O_ppb_per,CFC11_ppt_per,CFC12_ppt_per

!OM ---> correction du bilan d'eau global
!OM Correction sur precip KE
       REAL cvl_corr
!OM Fonte calotte dans bilan eau
       LOGICAL ok_lic_melt

!IM simulateur ISCCP 
       INTEGER top_height, overlap
!IM seuils cdrm, cdrh
       REAL cdmmax, cdhmax
!IM param. stabilite s/ terres et en dehors
       REAL ksta, ksta_ter
!IM ok_kzmin : clef calcul Kzmin dans la CL de surface cf FH
       LOGICAL ok_kzmin
!IM, MAFo fmagic, pmagic : parametres - additionnel et multiplicatif - 
!                          pour regler l albedo sur ocean
       REAL fmagic, pmagic
! Hauteur (imposee) du contenu en eau du sol
           REAL qsol0
! Frottement au sol (Cdrag)
       Real f_cdrag_ter,f_cdrag_oce
! Rugoro
       Real f_rugoro

!IM lev_histhf  : niveau sorties 6h
!IM lev_histday : niveau sorties journalieres
!IM lev_histmth : niveau sorties mensuelles
!IM lev_histdayNMC : on peut sortir soit sur 8 (comme AR5) ou bien 
!                    sur 17 niveaux de pression
       INTEGER lev_histhf, lev_histday, lev_histmth
       INTEGER lev_histdayNMC
       Integer lev_histins, lev_histLES  
!IM ok_histNMC  : sortie fichiers niveaux de pression (histmthNMC, histdayNMC, histhfNMC)
!IM freq_outNMC : frequences de sortie fichiers niveaux de pression (histmthNMC, histdayNMC, histhfNMC)
!IM freq_calNMC : frequences de calcul fis. hist*NMC.nc
!IM pasphys : pas de temps de physique (secondes)
       REAL pasphys
       LOGICAL ok_histNMC(3)
       REAL freq_outNMC(3) , freq_calNMC(3)
       CHARACTER(len=4) type_run
! aer_type: pour utiliser un fichier constant dans readaerosol 
       CHARACTER*8 :: aer_type 
       LOGICAL ok_isccp, ok_regdyn
       REAL lonmin_ins, lonmax_ins, latmin_ins, latmax_ins
       REAL ecrit_ins, ecrit_hf, ecrit_day
       REAL ecrit_mth, ecrit_tra, ecrit_reg 
       REAL ecrit_LES
       REAL freq_ISCCP, ecrit_ISCCP
       REAL freq_COSP
       LOGICAL :: ok_cosp,ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP
       INTEGER :: ip_ebil_phy, iflag_rrtm
       LOGICAL :: ok_strato
       LOGICAL :: ok_hines
       LOGICAL :: ok_qch4

       COMMON/clesphys/cycle_diurne, soil_model, new_oliq,              &
     &     ok_orodr, ok_orolf, ok_limitvrai, nbapp_rad, iflag_con       &
     &     , co2_ppm, solaire                                           &
     &     , RCO2, RCH4, RN2O, RCFC11, RCFC12                           &
     &     , RCO2_act, RCH4_act, RN2O_act, RCFC11_act, RCFC12_act       &
     &     , ok_4xCO2atm                                                & 
     &     , RCO2_per, RCH4_per, RN2O_per, RCFC11_per, RCFC12_per       &
     &     , CH4_ppb, N2O_ppb, CFC11_ppt, CFC12_ppt                     &
     &     , CH4_ppb_per, N2O_ppb_per, CFC11_ppt_per, CFC12_ppt_per     &
     &     , top_height, overlap, cdmmax, cdhmax, ksta, ksta_ter        &
     &     , ok_kzmin, fmagic, pmagic                                   &
     &     , f_cdrag_ter,f_cdrag_oce,f_rugoro                           &
     &     , lev_histhf, lev_histday, lev_histmth                       &
     &     , lev_histins, lev_histLES, lev_histdayNMC                   &
     &     , pasphys, ok_histNMC, freq_outNMC, freq_calNMC              &
     &     , type_run, ok_isccp, ok_regdyn, ok_cosp                     &
     &     , ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP                     &
     &     , lonmin_ins, lonmax_ins, latmin_ins, latmax_ins             &
     &     , ecrit_ins, ecrit_hf, ecrit_day                             &
     &     , ecrit_mth, ecrit_tra, ecrit_reg                            &
     &     , freq_ISCCP, ecrit_ISCCP, freq_COSP, ip_ebil_phy            &
     &     , ok_lic_melt, cvl_corr, aer_type                            &
     &     , qsol0, iflag_rrtm, ok_strato,ok_hines,ecrit_LES            &
     &     , co2_ppm0, ok_qch4
     
       save /clesphys/
!$OMP THREADPRIVATE(/clesphys/)
 
!
! $Id: temps.h 1665 2012-10-09 13:35:26Z fairhead $
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation
!                 (les placer en colonne 6 et en colonne 73)
!
!
! jD_ref = jour julien de la date de reference (lancement de l'experience)
! hD_ref = "heure" julienne de la date de reference
!-----------------------------------------------------------------------
! INCLUDE 'temps.h'

      COMMON/temps/itaufin, dt, day_ini, day_end, annee_ref, day_ref,   &
     &             itau_dyn, itau_phy, jD_ref, jH_ref, calend,          &
     &             start_time


      INTEGER   itaufin
      INTEGER itau_dyn, itau_phy
      INTEGER day_ini, day_end, annee_ref, day_ref
      REAL      dt, jD_ref, jH_ref, start_time
      CHARACTER (len=10) :: calend

!$OMP THREADPRIVATE(/temps/)
!-----------------------------------------------------------------------
!
! $Header$
!
!
! gestion des impressions de sorties et de dbogage
! lunout:    unit du fichier dans lequel se font les sorties 
!                           (par defaut 6, la sortie standard)
! prt_level: niveau d'impression souhait (0 = minimum)
!
      INTEGER lunout, prt_level
      COMMON /comprint/ lunout, prt_level
      integer            :: iflag_thermals,nsplit_thermals

!!! nrlmd le 10/04/2012
      integer            :: iflag_trig_bl,iflag_clos_bl
      integer            :: tau_trig_shallow,tau_trig_deep
      real               :: s_trig
!!! fin nrlmd le 10/04/2012

      real,parameter     :: r_aspect_thermals=2.,l_mix_thermals=30.
      real               :: alp_bl_k
      real               :: tau_thermals
      integer,parameter  :: w2di_thermals=0
      integer            :: isplit

      integer            :: iflag_coupl,iflag_clos,iflag_wake
      integer            :: iflag_thermals_ed,iflag_thermals_optflux

      common/ctherm1/iflag_thermals,nsplit_thermals
      common/ctherm2/tau_thermals,alp_bl_k
      common/ctherm4/iflag_coupl,iflag_clos,iflag_wake
      common/ctherm5/iflag_thermals_ed,iflag_thermals_optflux

!!! nrlmd le 10/04/2012
      common/ctherm6/iflag_trig_bl,iflag_clos_bl
      common/ctherm7/tau_trig_shallow,tau_trig_deep
      common/ctherm8/s_trig
!!! fin nrlmd le 10/04/2012

!$OMP THREADPRIVATE(/ctherm1/,/ctherm2/,/ctherm4/,/ctherm5/)
!$OMP THREADPRIVATE(/ctherm6/,/ctherm7/,/ctherm8/)
c======================================================================
      LOGICAL ok_cvl  ! pour activer le nouveau driver pour convection KE
      PARAMETER (ok_cvl=.TRUE.)
      LOGICAL ok_gust ! pour activer l'effet des gust sur flux surface
      PARAMETER (ok_gust=.FALSE.)
      integer iflag_radia     ! active ou non le rayonnement (MPL)
      save iflag_radia
c$OMP THREADPRIVATE(iflag_radia)
c======================================================================
      LOGICAL check ! Verifier la conservation du modele en eau
      PARAMETER (check=.FALSE.)
      LOGICAL ok_stratus ! Ajouter artificiellement les stratus
      PARAMETER (ok_stratus=.FALSE.)
c======================================================================
      REAL amn, amx
      INTEGER igout
c======================================================================
c Clef controlant l'activation du cycle diurne:
ccc      LOGICAL cycle_diurne
ccc      PARAMETER (cycle_diurne=.FALSE.)
c======================================================================
c Modele thermique du sol, a activer pour le cycle diurne:
ccc      LOGICAL soil_model
ccc      PARAMETER (soil_model=.FALSE.)
c======================================================================
c Dans les versions precedentes, l'eau liquide nuageuse utilisee dans
c le calcul du rayonnement est celle apres la precipitation des nuages.
c Si cette cle new_oliq est activee, ce sera une valeur moyenne entre
c la condensation et la precipitation. Cette cle augmente les impacts
c radiatifs des nuages.
ccc      LOGICAL new_oliq
ccc      PARAMETER (new_oliq=.FALSE.)
c======================================================================
c Clefs controlant deux parametrisations de l'orographie:
cc      LOGICAL ok_orodr
ccc      PARAMETER (ok_orodr=.FALSE.)
ccc      LOGICAL ok_orolf
ccc      PARAMETER (ok_orolf=.FALSE.)
c======================================================================
      LOGICAL ok_journe ! sortir le fichier journalier
      save ok_journe
c$OMP THREADPRIVATE(ok_journe)
c
      LOGICAL ok_mensuel ! sortir le fichier mensuel
      save ok_mensuel
c$OMP THREADPRIVATE(ok_mensuel)
c
      LOGICAL ok_instan ! sortir le fichier instantane
      save ok_instan
c$OMP THREADPRIVATE(ok_instan)
c
      LOGICAL ok_LES ! sortir le fichier LES 
      save ok_LES                            
c$OMP THREADPRIVATE(ok_LES)                  
c
      LOGICAL callstats ! sortir le fichier stats 
      save callstats                            
c$OMP THREADPRIVATE(callstats)                  
c
      LOGICAL ok_region ! sortir le fichier regional
      PARAMETER (ok_region=.FALSE.)
c======================================================================
      real weak_inversion(klon),dthmin(klon)
      real seuil_inversion
      save seuil_inversion
c$OMP THREADPRIVATE(seuil_inversion)
      integer iflag_ratqs
      save iflag_ratqs
c$OMP THREADPRIVATE(iflag_ratqs)
      real facteur

      REAL zz,znum,zden
      REAL wmax_th(klon)
      REAL zmax_th(klon)
      REAL tau_overturning_th(klon)

      integer lmax_th(klon)
      integer limbas(klon)
      real ratqscth(klon,klev)
      real ratqsdiff(klon,klev)
      real zqsatth(klon,klev)

      ! sursat marine
      real zpdf_beta(klon)
      real flag_ss(klon,klev)
      real flagb_ss(klon,klev)
      real rneb_ss(klon,klev)
      real clsk_ss(klon,klev)

c======================================================================
c
      INTEGER ivap          ! indice de traceurs pour vapeur d'eau
      PARAMETER (ivap=1)
      INTEGER iliq          ! indice de traceurs pour eau liquide
      PARAMETER (iliq=2)

c
c
c Variables argument:
c
      INTEGER nlon
      INTEGER nlev
      !INTEGER nlat
      REAL, intent(in):: jD_cur, jH_cur

      REAL pdtphys
      LOGICAL debut, lafin
      REAL paprs(klon,klev+1)
      REAL pplay(klon,klev)
      REAL pphi(klon,klev)
      REAL pphis(klon)
      REAL presnivs(klev)
      REAL znivsig(klev)
      real pir

      REAL u(klon,klev)
      REAL v(klon,klev)
      REAL t(klon,klev),theta(klon,klev)
      REAL qx(klon,klev,nqtot)
      REAL flxmass_w(klon,klev)
      REAL omega(klon,klev) ! vitesse verticale en Pa/s
      REAL d_u(klon,klev)
      REAL d_v(klon,klev)
      REAL d_t(klon,klev)
      REAL d_qx(klon,klev,nqtot)
      REAL d_ps(klon)
! Variables pour le transport convectif
      real da(klon,klev),phi(klon,klev,klev),mp(klon,klev)
! Variables pour le lessivage convectif
! RomP >>> 
      real phi2(klon,klev,klev)
      real d1a(klon,klev),dam(klon,klev)
      real ev(klon,klev),ep(klon,klev)
      real clw(klon,klev),elij(klon,klev,klev)
      real epmlmMm(klon,klev,klev),eplaMm(klon,klev)
      real wdtrainA(klon,klev),wdtrainM(klon,klev)
! RomP <<<

!C----------------------------------------------------------------------------------
!C COMMON "wateriso.h" including all parameters + some fields of water isotopes:
!C filled by iso_init.f
!C
!C Sandrine Bony (LMD/CNRS), March 2003
!C----------------------------------------------------------------------------------

!c -- general:

!#include "dimisodyn.h"
        ! c'est ici que l'on choisi quels isotopes on veut simuler
        integer use_iso_eau ! eau normale H2O18
        integer use_iso_HDO ! HDO (Deuterium)
        integer use_iso_O18 ! H2018
        integer use_iso_O17 ! H2O17
        integer use_iso_HTO ! HTO (Tritium)        

        ! mettre la valeur 1 si on veut utiliser, 0 sinon
        parameter (use_iso_eau=0)
        parameter (use_iso_HDO=1)
        parameter (use_iso_O18=1)
        parameter (use_iso_O17=0)
        parameter (use_iso_HTO=0)
    
        

!c -- parameters that do not depend on the type of water isotope:

       real pxtmelt,pxtice,pxtmin,pxtmax
       real tdifexp, tv0cin, thumxt1
       integer ntot
       real h_land_ice
       real P_veg
       real musi,lambda_sursat
       real Kd
       real rh_cste_surf_cond,T_cste_surf_cond

!c type de simulation
	logical bidouille_anti_divergence
                ! si true, rappel rgulier de xteau vers q, pour viter drives lentes
	logical essai_convergence 
                ! si false, on fait rigoureusement comme dans LMDZ sans isotopes, 
		! meme si c'est gnant pour les isotopes
        integer initialisation_iso
                ! 0: dans fichier
                ! 1: R=0
                ! 2: R selon distill rayleigh
                ! 3: R=Rsmow
        integer initialisation_isotrac
                ! 1 pour idalis
                ! 0 pour lecture dans fichier
        integer modif_SST ! 0 par defaut, 1 si on veut modifier la sst
                ! 2 et 3: profils de SST
        real deltaTtest ! modif de la SST, uniforme.
	integer modif_sic ! on met des trous dans glace de mer
	real deltasic ! fraction de trous minimale
	real deltaTtestpoles
	real sstlatcrit
	real dsstlatcrit
	real deltaO18_oce
	integer albedo_prescrit ! 0 par defaut
				 ! 1 si on veut garder albedo constant
	real lon_min_albedo,lon_max_albedo
	real lat_min_albedo,lat_max_albedo
	real deltaP_BL,tdifexp_sol
        integer ruissellement_pluie,alphak_stewart
        integer calendrier_guide
        integer cste_surf_cond
	real mixlen
        integer evap_cont_cste
	real deltaO18_evap_cont,d_evap_cont
	integer lev_histiso,lev_histiso_diag
	integer no_pce
!	real slope_limiterxy,slope_limiterz
	real A_satlim
	integer ok_restrict_A_satlim,modif_ratqs
	real Pcrit_ratqs,ratqsbasnew
	real fac_modif_evaoce
	integer ok_bidouille_wake
	logical cond_temp_env ! si oui, la temperature de cond est celle de l'environnement: permet d'eviter temperature de cond aberrantes
        logical ok_prod_nucl_tritium ! si oui, production de tritium par essais nucleaires
        integer nessai
        parameter (nessai=486)
        integer day_nucl(nessai)
        integer month_nucl(nessai)
        integer year_nucl(nessai)
        real lat_nucl(nessai)
        real lon_nucl(nessai)
        real zmin_nucl(nessai)
        real zmax_nucl(nessai)
        real HTO_nucl(nessai)

!c -- parameters to define the indexation of isotopes
        integer iso_eau ! eau normale H2O18
        integer iso_HDO ! HDO (Deuterium)
        integer iso_O18 ! H2018
        integer iso_O17 ! H2O17
        integer iso_HTO ! HTO (Tritium)

        integer niso ! nombre d'isotopes utiliss
        parameter (niso=use_iso_eau+use_iso_HDO+use_iso_O18
     &           +use_iso_O17+use_iso_HTO)

        character*3 striso(niso)
      
        integer ntraciso
        parameter (ntraciso=niso)
    	integer ntracisoOR
        parameter (ntracisoOR=niso)

!c -- parameters that depend on the type of water isotope:
        real fac_coeff_eq17_liq,fac_coeff_eq17_ice

       real tsatfac(niso)
     &    , tnat(niso), toce(niso), tcorr(niso)
     &    , tdifrel(niso)
     &    , talph1(niso), talph2(niso), talph3(niso)
     &    , talps1(niso), talps2(niso)
     &    , tkcin0(niso)
     &    , tkcin1(niso),tkcin2(niso)
     &    , alpha_liq_sol(niso) 
     &    , Rdefault(niso)

! Rdefault est la valeur de r quand on ne sait pas quoi mettre. 
! Normallement, trs peu utilis.

!c -- everything is there:

       COMMON /wateriso/ h_land_ice, P_veg
     &    , pxtmelt, pxtice, pxtmin, pxtmax
     &    , bidouille_anti_divergence,essai_convergence
     &    , initialisation_iso, initialisation_isotrac
     &    , modif_sst,deltaTtest
     &    , modif_sic,deltasic
     &    , deltaTtestpoles,sstlatcrit,albedo_prescrit
     &    , lon_min_albedo,lon_max_albedo,lat_min_albedo,lat_max_albedo
     &    , tdifexp,tv0cin,fac_coeff_eq17_liq,fac_coeff_eq17_ice 
     &    , thumxt1, musi,lambda_sursat, Kd, deltaO18_oce, ntot
     &    , rh_cste_surf_cond, T_cste_surf_cond
     &    , deltaP_BL, tdifexp_sol, ruissellement_pluie
     &    , alphak_stewart, cste_surf_cond
     &    , mixlen
     &    , tnat, toce, tcorr
     &    , tdifrel
     &    , calendrier_guide
     &    , talph1, talph2, talph3
     &    , talps1, talps2
     &    , tkcin0, tkcin1, tkcin2
     &    , alpha_liq_sol, Rdefault
     &    , striso
     &    , iso_eau,iso_HDO,iso_O18,iso_O17,iso_HTO
     &    , evap_cont_cste,deltaO18_evap_cont,d_evap_cont
     &    , lev_histiso,lev_histiso_diag,no_pce,A_satlim
     &    , ok_restrict_A_satlim,modif_ratqs,fac_modif_evaoce
     &    , ratqsbasnew,Pcrit_ratqs
     &    , ok_bidouille_wake,cond_temp_env
     &    , ok_prod_nucl_tritium

       COMMON /tritium/ day_nucl, month_nucl
     &    , year_nucl, lat_nucl, lon_nucl
     &    , zmin_nucl, zmax_nucl, HTO_nucl
      real xtx(ntraciso,klon,klev,2) ! <-> qx(klon,klev,nqmax)
      real d_xtx(ntraciso,klon,klev,2) ! <-> d_qx(klon,klev,nqmax)  
      
!IM definition dynamique o_trac dans phys_output_open
!      type(ctrl_out) :: o_trac(nqtot)
c
cIM Amip2 PV a theta constante 
c
      INTEGER nbteta
      PARAMETER(nbteta=3)
      CHARACTER*3 ctetaSTD(nbteta)
      DATA ctetaSTD/'350','380','405'/
      SAVE ctetaSTD
c$OMP THREADPRIVATE(ctetaSTD)
      REAL rtetaSTD(nbteta)
      DATA rtetaSTD/350., 380., 405./
      SAVE rtetaSTD
c$OMP THREADPRIVATE(rtetaSTD)     
c
      REAL PVteta(klon,nbteta)
      REAL zx_tmp_3dte(iim,jjmp1,nbteta)
c
cMI Amip2 PV a theta constante

cym      INTEGER klevp1, klevm1
cym      PARAMETER(klevp1=klev+1,klevm1=klev-1)
cym#include "raddim.h"
c
c
cIM Amip2
c variables a une pression donnee
c
cIM for NMC files
      real twriteSTD(klon,nlevSTD,nfiles)
      real qwriteSTD(klon,nlevSTD,nfiles)
      real rhwriteSTD(klon,nlevSTD,nfiles)
      real phiwriteSTD(klon,nlevSTD,nfiles)
      real uwriteSTD(klon,nlevSTD,nfiles)
      real vwriteSTD(klon,nlevSTD,nfiles)
      real wwriteSTD(klon,nlevSTD,nfiles)

      real twriteSTD3(klon,nlevSTD3)
      real qwriteSTD3(klon,nlevSTD3)
      real rhwriteSTD3(klon,nlevSTD3)
      real phiwriteSTD3(klon,nlevSTD3)
      real uwriteSTD3(klon,nlevSTD3)
      real vwriteSTD3(klon,nlevSTD3)
      real wwriteSTD3(klon,nlevSTD3)

      real tnondefSTD8(klon,nlevSTD8)
      real twriteSTD8(klon,nlevSTD8)
      real qwriteSTD8(klon,nlevSTD8)
      real rhwriteSTD8(klon,nlevSTD8)
      real phiwriteSTD8(klon,nlevSTD8)
      real uwriteSTD8(klon,nlevSTD8)
      real vwriteSTD8(klon,nlevSTD8)
      real wwriteSTD8(klon,nlevSTD8)

      real, save :: rlevSTD(nlevSTD)
      DATA rlevSTD/100000., 92500., 85000., 70000.,
     .60000., 50000., 40000., 30000., 25000., 20000.,
     .15000., 10000., 7000., 5000., 3000., 2000., 1000./
c$OMP THREADPRIVATE(rlevstd)

      CHARACTER*4, SAVE :: clevSTD(nlevSTD)
      DATA clevSTD/'1000','925 ','850 ','700 ','600 ',
     .'500 ','400 ','300 ','250 ','200 ','150 ','100 ',
     .'70  ','50  ','30  ','20  ','10  '/
c$OMP THREADPRIVATE(clevSTD)

      real, save :: rlevSTD3(nlevSTD3)
      DATA rlevSTD3/85000., 50000., 25000./
c$OMP THREADPRIVATE(rlevSTD3)

      real, save :: rlevSTD8(nlevSTD8)
      DATA rlevSTD8/100000., 85000., 70000., 50000., 25000., 10000.,
     $     5000., 1000./
c$OMP THREADPRIVATE(rlevSTD8) 
c
      REAL geo500(klon)

c nout : niveau de output des variables a une pression donnee
      logical oknondef(klon,nlevSTD,nout)
c
c les produits uvSTD, vqSTD, .., T2STD sont calcules
c a partir des valeurs instantannees toutes les 6 h
c qui sont moyennees sur le mois

      REAL zx_tmp_fiNC(klon,nlevSTD)

      REAL missing_val
      REAL, SAVE :: freq_moyNMC(nout)
c$OMP THREADPRIVATE(freq_moyNMC)
c
      CHARACTER*4 bb2
      CHARACTER*2 bb3
c
!
! $Header$
!
      LOGICAL LEVOIGT
      PARAMETER (LEVOIGT=.FALSE.)
      INTEGER NOVLP
      PARAMETER (NOVLP=1)
      INTEGER KAER
      PARAMETER (KAER=0)
c
c
c prw: precipitable water
      real prw(klon)
      real xtprw(ntraciso,klon)

      REAL convliq(klon,klev)  ! eau liquide nuageuse convective
      REAL convfra(klon,klev)  ! fraction nuageuse convective

      REAL cldl_c(klon),cldm_c(klon),cldh_c(klon) !nuages bas, moyen et haut
      REAL cldt_c(klon),cldq_c(klon) !nuage total, eau liquide integree
      REAL cldl_s(klon),cldm_s(klon),cldh_s(klon) !nuages bas, moyen et haut
      REAL cldt_s(klon),cldq_s(klon) !nuage total, eau liquide integree

      INTEGER linv, kp1
c flwp, fiwp = Liquid Water Path & Ice Water Path (kg/m2)
c flwc, fiwc = Liquid Water Content & Ice Water Content (kg/kg)
      REAL flwp(klon), fiwp(klon)
      REAL flwc(klon,klev), fiwc(klon,klev)
      REAL flwp_c(klon), fiwp_c(klon)
      REAL flwc_c(klon,klev), fiwc_c(klon,klev)
      REAL flwp_s(klon), fiwp_s(klon)
      REAL flwc_s(klon,klev), fiwc_s(klon,klev)

      REAL evap_pot(klon,nbsrf)

cIM ISCCP simulator v3.4
c dans clesphys.h top_height, overlap
cv3.4
      INTEGER debug, debugcol
cym      INTEGER npoints
cym      PARAMETER(npoints=klon) 
c
      INTEGER sunlit(klon) !sunlit=1 if day; sunlit=0 if night
      INTEGER nregISCtot
      PARAMETER(nregISCtot=1) 
c
c imin_debut, nbpti, jmin_debut, nbptj : parametres pour sorties sur 1 region rectangulaire
c y compris pour 1 point
c imin_debut : indice minimum de i; nbpti : nombre de points en direction i (longitude)
c jmin_debut : indice minimum de j; nbptj : nombre de points en direction j (latitude)
      INTEGER imin_debut, nbpti
      INTEGER jmin_debut, nbptj 
cIM parametres ISCCP BEG
      INTEGER nbapp_isccp
!     INTEGER nbapp_isccp,isccppas
!     PARAMETER(isccppas=6) !appel du simulateurs tous les 6pas de temps de la physique
!                           !i.e. toutes les 3 heures 
      INTEGER n
      INTEGER ifreq_isccp(napisccp), freqin_pdt(napisccp)
      DATA ifreq_isccp/3/
      SAVE ifreq_isccp
c$OMP THREADPRIVATE(ifreq_isccp)
      CHARACTER*5 typinout(napisccp)
      DATA typinout/'i3od'/
      SAVE typinout
c$OMP THREADPRIVATE(typinout)
cIM verif boxptop BEG
      CHARACTER*1 verticaxe(napisccp)
      DATA verticaxe/'1'/ 
      SAVE verticaxe
c$OMP THREADPRIVATE(verticaxe)
cIM verif boxptop END
      INTEGER nvlev(napisccp)
c     INTEGER nvlev
      REAL t1, aa
      REAL seed_re(klon,napisccp)
cym !!!! A voir plus tard 
cym      INTEGER iphy(iim,jjmp1)
cIM parametres ISCCP END
c
c ncol = nb. de sous-colonnes pour chaque maille du GCM 
c ncolmx = No. max. de sous-colonnes pour chaque maille du GCM 
c      INTEGER ncol(napisccp), ncolmx, seed(klon,napisccp)
      INTEGER,SAVE :: ncol(napisccp)
c$OMP THREADPRIVATE(ncol)
      INTEGER ncolmx, seed(klon,napisccp)
      REAL nbsunlit(nregISCtot,klon,napisccp)  !nbsunlit : moyenne de sunlit
c     PARAMETER(ncolmx=1500)
      PARAMETER(ncolmx=300)
c
cIM verif boxptop BEG
      REAL vertlev(ncolmx,napisccp)
cIM verif boxptop END
c
      REAL,SAVE :: tautab_omp(0:255),tautab(0:255)
      INTEGER,SAVE :: invtau_omp(-20:45000),invtau(-20:45000)
c$OMP THREADPRIVATE(tautab,invtau)
      REAL emsfc_lw
      PARAMETER(emsfc_lw=0.99)
c     REAL    ran0                      ! type for random number fuction
c
      REAL cldtot(klon,klev)
c variables de haut en bas pour le simulateur ISCCP
      REAL dtau_s(klon,klev) !tau nuages startiformes
      REAL dtau_c(klon,klev) !tau nuages convectifs
      REAL dem_s(klon,klev)  !emissivite nuages startiformes 
      REAL dem_c(klon,klev)  !emissivite nuages convectifs
c
c variables de haut en bas pour le simulateur ISCCP
      REAL pfull(klon,klev)
      REAL phalf(klon,klev+1)
      REAL qv(klon,klev)
      REAL cc(klon,klev)
      REAL conv(klon,klev)
      REAL dtau_sH2B(klon,klev)
      REAL dtau_cH2B(klon,klev)
      REAL at(klon,klev)
      REAL dem_sH2B(klon,klev)
      REAL dem_cH2B(klon,klev)
c
      INTEGER kmax, lmax, lmax3
      PARAMETER(kmax=8, lmax=8, lmax3=3)
      INTEGER kmaxm1, lmaxm1
      PARAMETER(kmaxm1=kmax-1, lmaxm1=lmax-1)
      INTEGER iimx7, jjmx7, jjmp1x7
      PARAMETER(iimx7=iim*kmaxm1, jjmx7=jjm*lmaxm1, 
     .jjmp1x7=jjmp1*lmaxm1)
c
c output from ISCCP simulator
      REAL fq_isccp(klon,kmaxm1,lmaxm1,napisccp)
      REAL fq_is_true(klon,kmaxm1,lmaxm1,napisccp)
      REAL totalcldarea(klon,napisccp) 
      REAL meanptop(klon,napisccp)
      REAL meantaucld(klon,napisccp)
      REAL boxtau(klon,ncolmx,napisccp)
      REAL boxptop(klon,ncolmx,napisccp) 
      REAL zx_tmp_fi3d_bx(klon,ncolmx)
      REAL zx_tmp_3d_bx(iim,jjmp1,ncolmx)
c
      REAL cld_fi3d(klon,lmax3)
      REAL cld_3d(iim,jjmp1,lmax3)
c
      INTEGER iw, iwmax
      REAL wmin, pas_w
c     PARAMETER(wmin=-100.,pas_w=10.,iwmax=30)
cIM 051005     PARAMETER(wmin=-200.,pas_w=10.,iwmax=40)
      PARAMETER(wmin=-100.,pas_w=10.,iwmax=20)
      REAL o500(klon)
c

c sorties ISCCP

      integer nid_isccp
      save nid_isccp        
c$OMP THREADPRIVATE(nid_isccp)

      REAL zx_tau(kmaxm1), zx_pc(lmaxm1), zx_o500(iwmax)
      DATA zx_tau/0.0, 0.3, 1.3, 3.6, 9.4, 23., 60./
      SAVE zx_tau
      DATA zx_pc/180., 310., 440., 560., 680., 800., 1000./
      SAVE zx_pc
c$OMP THREADPRIVATE(zx_tau,zx_pc)
c cldtopres pression au sommet des nuages
      REAL cldtopres(lmaxm1), cldtopres3(lmax3)
      DATA cldtopres/180., 310., 440., 560., 680., 800., 1000./
      DATA cldtopres3/440., 680., 1000./
      SAVE cldtopres,cldtopres3
c$OMP THREADPRIVATE(cldtopres,cldtopres3)
cIM 051005 BEG
      INTEGER komega, nhoriRD 

c taulev: numero du niveau de tau dans les sorties ISCCP
      CHARACTER *4 taulev(kmaxm1)
c     DATA taulev/'tau1','tau2','tau3','tau4','tau5','tau6','tau7'/
      DATA taulev/'tau0','tau1','tau2','tau3','tau4','tau5','tau6'/
      CHARACTER *3 pclev(lmaxm1)
      DATA pclev/'pc1','pc2','pc3','pc4','pc5','pc6','pc7'/
      SAVE taulev,pclev
c$OMP THREADPRIVATE(taulev,pclev)
c
c cnameisccp
      CHARACTER *29 cnameisccp(lmaxm1,kmaxm1)
cIM bad 151205     DATA cnameisccp/'pc< 50hPa, tau< 0.3', 
      DATA cnameisccp/'pc= 50-180hPa, tau< 0.3',
     .                'pc= 180-310hPa, tau< 0.3',
     .                'pc= 310-440hPa, tau< 0.3',
     .                'pc= 440-560hPa, tau< 0.3',
     .                'pc= 560-680hPa, tau< 0.3',
     .                'pc= 680-800hPa, tau< 0.3',
     .                'pc= 800-1000hPa, tau< 0.3',
     .                'pc= 50-180hPa, tau= 0.3-1.3',
     .                'pc= 180-310hPa, tau= 0.3-1.3',
     .                'pc= 310-440hPa, tau= 0.3-1.3',
     .                'pc= 440-560hPa, tau= 0.3-1.3',
     .                'pc= 560-680hPa, tau= 0.3-1.3',
     .                'pc= 680-800hPa, tau= 0.3-1.3',
     .                'pc= 800-1000hPa, tau= 0.3-1.3',
     .                'pc= 50-180hPa, tau= 1.3-3.6',
     .                'pc= 180-310hPa, tau= 1.3-3.6',
     .                'pc= 310-440hPa, tau= 1.3-3.6',
     .                'pc= 440-560hPa, tau= 1.3-3.6',
     .                'pc= 560-680hPa, tau= 1.3-3.6',
     .                'pc= 680-800hPa, tau= 1.3-3.6',
     .                'pc= 800-1000hPa, tau= 1.3-3.6',
     .                'pc= 50-180hPa, tau= 3.6-9.4',
     .                'pc= 180-310hPa, tau= 3.6-9.4',
     .                'pc= 310-440hPa, tau= 3.6-9.4',
     .                'pc= 440-560hPa, tau= 3.6-9.4',
     .                'pc= 560-680hPa, tau= 3.6-9.4',
     .                'pc= 680-800hPa, tau= 3.6-9.4',
     .                'pc= 800-1000hPa, tau= 3.6-9.4',
     .                'pc= 50-180hPa, tau= 9.4-23',
     .                'pc= 180-310hPa, tau= 9.4-23',
     .                'pc= 310-440hPa, tau= 9.4-23',
     .                'pc= 440-560hPa, tau= 9.4-23',
     .                'pc= 560-680hPa, tau= 9.4-23',
     .                'pc= 680-800hPa, tau= 9.4-23',
     .                'pc= 800-1000hPa, tau= 9.4-23',
     .                'pc= 50-180hPa, tau= 23-60',
     .                'pc= 180-310hPa, tau= 23-60',
     .                'pc= 310-440hPa, tau= 23-60',
     .                'pc= 440-560hPa, tau= 23-60',
     .                'pc= 560-680hPa, tau= 23-60',
     .                'pc= 680-800hPa, tau= 23-60',
     .                'pc= 800-1000hPa, tau= 23-60',
     .                'pc= 50-180hPa, tau> 60.',
     .                'pc= 180-310hPa, tau> 60.',
     .                'pc= 310-440hPa, tau> 60.',
     .                'pc= 440-560hPa, tau> 60.',
     .                'pc= 560-680hPa, tau> 60.',
     .                'pc= 680-800hPa, tau> 60.',
     .                'pc= 800-1000hPa, tau> 60.'/
       SAVE cnameisccp
c$OMP THREADPRIVATE(cnameisccp)
c
c     REAL zx_lonx7(iimx7), zx_latx7(jjmp1x7)
c     INTEGER nhorix7
cIM: region='3d' <==> sorties en global
      CHARACTER*3 region
      PARAMETER(region='3d')
c
cIM ISCCP simulator v3.4
c
      logical ok_hf
c
      integer nid_hf, nid_hf3d
      save ok_hf, nid_hf, nid_hf3d
c$OMP THREADPRIVATE(ok_hf, nid_hf, nid_hf3d)
c  QUESTION : noms de variables ?

      INTEGER        longcles
      PARAMETER    ( longcles = 20 )
      REAL clesphy0( longcles      )
c
c Variables propres a la physique
      INTEGER itap
      SAVE itap                   ! compteur pour la physique
c$OMP THREADPRIVATE(itap)
c
      real slp(klon) ! sea level pressure
c
      REAL fevap(klon,nbsrf)
      REAL fluxlat(klon,nbsrf)
c
      REAL qsol(klon)
      REAL fxtevap(ntraciso,klon,nbsrf)
      REAL xtsol(niso,klon)  
      REAL,save ::  solarlong0
c$OMP THREADPRIVATE(solarlong0)

c
c  Parametres de l'Orographie a l'Echelle Sous-Maille (OESM):
c
cIM 141004     REAL zulow(klon),zvlow(klon),zustr(klon), zvstr(klon)
      REAL zulow(klon),zvlow(klon)
c
      INTEGER igwd,idx(klon),itest(klon)
c
      REAL agesno(klon,nbsrf)
c
c      REAL,allocatable,save :: run_off_lic_0(:)
cc$OMP THREADPRIVATE(run_off_lic_0)
cym      SAVE run_off_lic_0
cKE43
c Variables liees a la convection de K. Emanuel (sb):
c
      REAL bas, top             ! cloud base and top levels
      SAVE bas
      SAVE top
c$OMP THREADPRIVATE(bas, top)

      REAL wdn(klon), tdn(klon), qdn(klon)
c
c=================================================================================================
cCR04.12.07: on ajoute les nouvelles variables du nouveau schema de convection avec poches froides
c Variables li\'ees \`a la poche froide (jyg)

      REAL mip(klon,klev)  ! mass flux shed by the adiab ascent at each level
      REAL Vprecip(klon,klev+1)   ! precipitation vertical profile
      REAL xtVprecip(ntraciso,klon,klev+1)   ! precipitation vertical profile
c
      REAL wape_prescr, fip_prescr
      INTEGER it_wape_prescr
      SAVE wape_prescr, fip_prescr, it_wape_prescr
c$OMP THREADPRIVATE(wape_prescr, fip_prescr, it_wape_prescr)
c
c variables supplementaires de concvl
      REAL Tconv(klon,klev)
      REAL ment(klon,klev,klev),sij(klon,klev,klev)
      REAL dd_t(klon,klev),dd_q(klon,klev)

      real, save :: alp_bl_prescr=0.
      real, save :: ale_bl_prescr=0.

      real, save :: ale_max=1000.
      real, save :: alp_max=2.

      real, save :: wake_s_min_lsp=0.1

c$OMP THREADPRIVATE(alp_bl_prescr,ale_bl_prescr)
c$OMP THREADPRIVATE(ale_max,alp_max)
c$OMP THREADPRIVATE(wake_s_min_lsp)

      real ale_wake(klon)
      real alp_wake(klon)

      real ok_wk_lsp(klon)

cRC
c Variables li\'ees \`a la poche froide (jyg et rr)
c Version diagnostique pour l'instant : pas de r\'etroaction sur la convection

      REAL t_wake(klon,klev),q_wake(klon,klev) ! wake pour la convection

      REAL wake_dth(klon,klev)        ! wake : temp pot difference

      REAL wake_d_deltat_gw(klon,klev)! wake : delta T tendency due to Gravity Wave (/s)
      REAL wake_omgbdth(klon,klev)    ! Wake : flux of Delta_Theta transported by LS omega
      REAL wake_dp_omgb(klon,klev)    ! Wake : vertical gradient of large scale omega
      REAL wake_dtKE(klon,klev)       ! Wake : differential heating (wake - unpertubed) CONV
      REAL wake_dqKE(klon,klev)       ! Wake : differential moistening (wake - unpertubed) CONV
      REAL wake_dtPBL(klon,klev)      ! Wake : differential heating (wake - unpertubed) PBL
      REAL wake_dqPBL(klon,klev)      ! Wake : differential moistening (wake - unpertubed) PBL
      REAL wake_omg(klon,klev)        ! Wake : velocity difference (wake - unpertubed)
      REAL wake_ddeltat(klon,klev),wake_ddeltaq(klon,klev)
      REAL wake_dp_deltomg(klon,klev) ! Wake : gradient vertical de wake_omg
      REAL wake_spread(klon,klev)     ! spreading term in wake_delt

      real xt_wake(ntraciso,klon,klev) 
      REAL wake_dxtKE(ntraciso,klon,klev)       ! Wake : differential moistening (wake - unpertubed) CONV
      REAL wake_dxtPBL(ntraciso,klon,klev)      ! Wake : differential moistening (wake - unpertubed) PBL
      REAL wake_ddeltaxt(ntraciso,klon,klev)
c
cpourquoi y'a pas de save??
      REAL wake_h(klon)               ! Wake : hauteur de la poche froide
c
      INTEGER wake_k(klon)            ! Wake sommet
c
      REAL t_undi(klon,klev)               ! temperature moyenne dans la zone non perturbee
      REAL q_undi(klon,klev)               ! humidite moyenne dans la zone non perturbee

      real xt_undi(ntraciso,klon,klev)
      real seuil_q_undi
      parameter (seuil_q_undi=0.0)
      real wake_deltaq_prec(klon,klev)
c
cjyg
ccc      REAL wake_pe(klon)              ! Wake potential energy - WAPE 

      REAL wake_gfl(klon)             ! Gust Front Length
      REAL wake_dens(klon)
c
c
      REAL dt_dwn(klon,klev)
      REAL dq_dwn(klon,klev)
      REAL wdt_PBL(klon,klev)
      REAL udt_PBL(klon,klev)
      REAL wdq_PBL(klon,klev)
      REAL udq_PBL(klon,klev)
      REAL M_dwn(klon,klev)
      REAL M_up(klon,klev)
      REAL dt_a(klon,klev)
      REAL dq_a(klon,klev)
      REAL dxt_dwn(ntraciso,klon,klev)
      REAL wdxt_PBL(ntraciso,klon,klev)
      REAL udxt_PBL(ntraciso,klon,klev)
      REAL dxt_a(ntraciso,klon,klev)

      REAL, SAVE :: alp_offset
c$OMP THREADPRIVATE(alp_offset)

c
cRR:fin declarations poches froides
c=======================================================================================================

      REAL zw2(klon,klev+1)
      REAL fraca(klon,klev+1)        
      REAL ztv(klon,klev) 
      REAL zpspsk(klon,klev)
      REAL ztla(klon,klev) 
      REAL zthl(klon,klev)

ccc nrlmd le 10/04/2012

c--------Stochastic Boundary Layer Triggering: ALE_BL--------
c---Propri\'et\'es du thermiques au LCL 
      real zlcl_th(klon)                                     ! Altitude du LCL calcul\'e continument (pcon dans thermcell_main.F90)
      real fraca0(klon)                                      ! Fraction des thermiques au LCL
      real w0(klon)                                          ! Vitesse des thermiques au LCL
      real w_conv(klon)                                      ! Vitesse verticale de grande \'echelle au LCL
      real therm_tke_max0(klon)                              ! TKE dans les thermiques au LCL 
      real env_tke_max0(klon)                                ! TKE dans l'environnement au LCL 

c---Spectre de thermiques de type 2 au LCL
      real n2(klon),s2(klon)
      real ale_bl_stat(klon)

c---D\'eclenchement stochastique
      integer :: tau_trig(klon)
      real proba_notrig(klon)
      real random_notrig(klon)

c--------Statistical Boundary Layer Closure: ALP_BL--------
c---Profils de TKE dans et hors du thermique
      real pbl_tke_input(klon,klev+1,nbsrf)
      real therm_tke_max(klon,klev)                          ! Profil de TKE dans les thermiques
      real env_tke_max(klon,klev)                            ! Profil de TKE dans l'environnement

c---Fermeture statistique
      real alp_bl_det(klon)                                     ! ALP d\'terministe du thermique unique
      real alp_bl_fluct_m(klon)                                 ! ALP li\'ee aux fluctuations de flux de masse sous-nuageux
      real alp_bl_fluct_tke(klon)                               ! ALP li\'ee aux fluctuations d'\'energie cin\'etique sous-nuageuse 
      real alp_bl_conv(klon)                                    ! ALP li\'ee \`a grande \'echelle
      real alp_bl_stat(klon)                                    ! ALP totale

ccc fin nrlmd le 10/04/2012

c Variables locales pour la couche limite (al1):
c
cAl1      REAL pblh(klon)           ! Hauteur de couche limite
cAl1      SAVE pblh
c34EK
c
c Variables locales:
c
      REAL cdragh(klon) ! drag coefficient pour T and Q
      REAL cdragm(klon) ! drag coefficient pour vent
cAA
cAA  Pour phytrac 
cAA
      REAL coefh(klon,klev)     ! coef d'echange pour phytrac, valable pour 2<=k<=klev
      REAL coefm(klon,klev)     ! coef d'echange pour U, V
      REAL u1(klon)             ! vents dans la premiere couche U
      REAL v1(klon)             ! vents dans la premiere couche V

      REAL zxffonte(klon), zxfqcalving(klon),zxfqfonte(klon)

      REAL zxfxtcalving(niso,klon),zxfxtfonte(niso,klon)

c@$$      LOGICAL offline           ! Controle du stockage ds "physique"
c@$$      PARAMETER (offline=.false.)
c@$$      INTEGER physid
      REAL frac_impa(klon,klev) ! fractions d'aerosols lessivees (impaction)
      REAL frac_nucl(klon,klev) ! idem (nucleation)
! RomP >>> 
      REAL beta_prec_fisrt(klon,klev) ! taux de conv de l'eau cond (fisrt)
      REAL beta_prec(klon,klev)       ! taux de conv de l'eau cond (utilise)
! RomP <<<
      INTEGER       :: iii
      REAL          :: calday

cIM cf FH pour Tiedtke 080604
      REAL rain_tiedtke(klon),snow_tiedtke(klon)
c
cIM 050204 END
      REAL evap(klon), devap(klon) ! evaporation et sa derivee
      REAL sens(klon), dsens(klon) ! chaleur sensible et sa derivee
      REAL xtevap(ntraciso,klon), dxtevap(ntraciso,klon) ! evaporation et sa derivee

      REAL bils(klon) ! bilan de chaleur au sol
      REAL wfbilo(klon,nbsrf) ! bilan d'eau, pour chaque
C                             ! type de sous-surface et pondere par la fraction
      REAL wfbils(klon,nbsrf) ! bilan de chaleur au sol, pour chaque
C                             ! type de sous-surface et pondere par la fraction
      REAL slab_wfbils(klon)  ! bilan de chaleur au sol pour le cas de slab, sur les points d'ocean

      REAL fder(klon)         
      REAL ve(klon) ! integr. verticale du transport meri. de l'energie
      REAL vq(klon) ! integr. verticale du transport meri. de l'eau
      REAL ue(klon) ! integr. verticale du transport zonal de l'energie
      REAL uq(klon) ! integr. verticale du transport zonal de l'eau
c
      REAL frugs(klon,nbsrf)
      REAL zxrugs(klon) ! longueur de rugosite
c
c Conditions aux limites
c
!
      REAL :: day_since_equinox
! Date de l'equinoxe de printemps
      INTEGER, parameter :: mth_eq=3, day_eq=21
      REAL :: jD_eq

      LOGICAL, parameter :: new_orbit = .true.

c
      INTEGER lmt_pas
      SAVE lmt_pas                ! frequence de mise a jour
c$OMP THREADPRIVATE(lmt_pas) 
      real zmasse(klon, llm) 
C     (column-density of mass of air in a cell, in kg m-2)
      real, parameter:: dobson_u = 2.1415e-05 ! Dobson unit, in kg m-2

cIM sorties
      REAL un_jour
      PARAMETER(un_jour=86400.)
c======================================================================
c
c Declaration des procedures appelees
c
      EXTERNAL angle     ! calculer angle zenithal du soleil
      EXTERNAL alboc     ! calculer l'albedo sur ocean
      EXTERNAL ajsec     ! ajustement sec
      EXTERNAL conlmd    ! convection (schema LMD)
cKE43
      EXTERNAL conema3  ! convect4.3
      EXTERNAL fisrtilp  ! schema de condensation a grande echelle (pluie)
cAA 
      EXTERNAL fisrtilp_tr ! schema de condensation a grande echelle (pluie)
c                          ! stockage des coefficients necessaires au
c                          ! lessivage OFF-LINE et ON-LINE
      EXTERNAL hgardfou  ! verifier les temperatures
      EXTERNAL nuage     ! calculer les proprietes radiatives
CC      EXTERNAL o3cm      ! initialiser l'ozone
      EXTERNAL orbite    ! calculer l'orbite terrestre
      EXTERNAL phyetat0  ! lire l'etat initial de la physique
      EXTERNAL phyredem  ! ecrire l'etat de redemarrage de la physique
      EXTERNAL suphel    ! initialiser certaines constantes
      EXTERNAL transp    ! transport total de l'eau et de l'energie
      EXTERNAL ecribina  ! ecrire le fichier binaire global
      EXTERNAL ecribins  ! ecrire le fichier binaire global
      EXTERNAL ecrirega  ! ecrire le fichier binaire regional
      EXTERNAL ecriregs  ! ecrire le fichier binaire regional
cIM
      EXTERNAL haut2bas  !variables de haut en bas
      EXTERNAL ini_undefSTD  !initialise a 0 une variable a 1 niveau de pression
      EXTERNAL undefSTD      !somme les valeurs definies d'1 var a 1 niveau de pression
c     EXTERNAL moy_undefSTD  !moyenne d'1 var a 1 niveau de pression
c     EXTERNAL moyglo_aire   !moyenne globale d'1 var ponderee par l'aire de la maille (moyglo_pondaire)
c                            !par la masse/airetot (moyglo_pondaima) et la vraie masse (moyglo_pondmass)
c
c Variables locales
c
      REAL rhcl(klon,klev)    ! humiditi relative ciel clair
      REAL dialiq(klon,klev)  ! eau liquide nuageuse
      REAL diafra(klon,klev)  ! fraction nuageuse
      REAL cldliq(klon,klev)  ! eau liquide nuageuse
      REAL cldfra(klon,klev)  ! fraction nuageuse
      REAL cldtau(klon,klev)  ! epaisseur optique
      REAL cldemi(klon,klev)  ! emissivite infrarouge
c
CXXX PB 
      REAL fluxq(klon,klev, nbsrf)   ! flux turbulent d'humidite
      REAL fluxt(klon,klev, nbsrf)   ! flux turbulent de chaleur
      REAL fluxu(klon,klev, nbsrf)   ! flux turbulent de vitesse u
      REAL fluxv(klon,klev, nbsrf)   ! flux turbulent de vitesse v
c
      REAL zxfluxt(klon, klev)
      REAL zxfluxq(klon, klev)
      REAL zxfluxu(klon, klev)
      REAL zxfluxv(klon, klev)

      real fluxxt(ntraciso,klon,klev, nbsrf)
      real zxfluxxt(ntraciso,klon,klev)
CXXX
c
      REAL fsollw(klon, nbsrf)   ! bilan flux IR pour chaque sous surface
      REAL fsolsw(klon, nbsrf)   ! flux solaire absorb. pour chaque sous surface
c Le rayonnement n'est pas calcule tous les pas, il faut donc
c                      sauvegarder les sorties du rayonnement
cym      SAVE  heat,cool,albpla,topsw,toplw,solsw,sollw,sollwdown
cym      SAVE  sollwdownclr, toplwdown, toplwdownclr
cym      SAVE  topsw0,toplw0,solsw0,sollw0, heat0, cool0
c
      INTEGER itaprad
      SAVE itaprad
c$OMP THREADPRIVATE(itaprad)
c
      REAL conv_q(klon,klev) ! convergence de l'humidite (kg/kg/s)
      REAL conv_t(klon,klev) ! convergence de la temperature(K/s)
c
      REAL cldl(klon),cldm(klon),cldh(klon) !nuages bas, moyen et haut
      REAL cldt(klon),cldq(klon) !nuage total, eau liquide integree
c
      REAL zxtsol(klon), zxqsurf(klon), zxsnow(klon), zxfluxlat(klon)
      REAL zxsnow_dummy(klon)
      real zxxtsnow(niso,klon)
      real Rland_ice(niso,klon)
c
      REAL dist, rmu0(klon), fract(klon)
      REAL zdtime, zlongi
c
      CHARACTER*2 str2
      CHARACTER*2 iqn
c
      REAL qcheck
      REAL z_avant(klon), z_apres(klon), z_factor(klon)
      LOGICAL zx_ajustq
c
      REAL za, zb
      REAL zx_t, zx_qs, zdelta, zcor, zfra, zlvdcp, zlsdcp
      real zqsat(klon,klev)
      INTEGER i, k, iq, ig, j, nsrf, ll, l, iiq, iff
      REAL t_coup
      PARAMETER (t_coup=234.0)

      real zxt_avant(ntraciso,klon) ! <-> z_avant(klon)
      real zxt_apres(ntraciso,klon) ! <-> z_apres(klon)
      real zxt_factor(ntraciso,klon) ! <-> z_factor(klon)
      real zbxt ! <-> zb
      REAL zxta(niso)
c
      REAL zphi(klon,klev)
cym A voir plus tard !!
cym      REAL zx_relief(iim,jjmp1)
cym      REAL zx_aire(iim,jjmp1)
c
c Grandeurs de sorties
      REAL s_pblh(klon), s_lcl(klon), s_capCL(klon)
      REAL s_oliqCL(klon), s_cteiCL(klon), s_pblt(klon)
      REAL s_therm(klon), s_trmb1(klon), s_trmb2(klon)
      REAL s_trmb3(klon)
cKE43
c Variables locales pour la convection de K. Emanuel (sb):
c
      REAL upwd(klon,klev)      ! saturated updraft mass flux
      REAL dnwd(klon,klev)      ! saturated downdraft mass flux
      REAL dnwd0(klon,klev)     ! unsaturated downdraft mass flux
      REAL tvp(klon,klev)       ! virtual temp of lifted parcel
      REAL plcl(klon)           ! Lifting Condensation Level
      REAL plfc(klon)           ! Level of Free Convection
      REAL wbeff(klon)          ! saturated updraft velocity at LFC
      CHARACTER*40 capemaxcels  !max(CAPE)

      REAL rflag(klon)          ! flag fonctionnement de convect
      INTEGER iflagctrl(klon)          ! flag fonctionnement de convect

c -- convect43:
      INTEGER ntra              ! nb traceurs pour convect4.3
      REAL pori_con(klon)    ! pressure at the origin level of lifted parcel
      REAL dtma_con(klon),dtlcl_con(klon)
      REAL dtvpdt1(klon,klev), dtvpdq1(klon,klev)
      REAL dplcldt(klon), dplcldr(klon)
c?     .     condm_con(klon,klev),conda_con(klon,klev),
c?     .     mr_con(klon,klev),ep_con(klon,klev)
c?     .    ,sadiab(klon,klev),wadiab(klon,klev)
c --
c34EK
c
c Variables du changement
c
c con: convection
c lsc: condensation a grande echelle (Large-Scale-Condensation)
c ajs: ajustement sec
c eva: evaporation de l'eau liquide nuageuse
c vdf: couche limite (Vertical DiFfusion)
      REAL rneb(klon,klev)

      ! dans la physique en gÈnÈral
      real rlat_out(klon)  
      INTEGER ixt
      real h1_diag(klon)
      real runoff_diag(klon)
      real xtrunoff_diag(niso,klon)
      character*50 striso_sortie ! nom des sorties
      character*50 varname_iso ! nom des sorties
      integer lnblnk


      real xt_iso(klon,klev)
      real xtl_iso(klon,klev)
      ! cam de bug
       logical sorties_gdat ! si true, sorties gdat intermdiaires internes aux subroutines
        parameter (sorties_gdat=.false.)      
!
!        logical essai_convergence ! si false, on peut rtroagir sur
!        l'eau normale, si true, on ne peut pas, et a permet de tester
!        la convergence avec la verison d'LMDZ sans isotopes.
!        Attention: si on  fait un essai de convergence, mieux vaut
!        enlever iso_debug, sinon, risuqes de plantage si non
!        conservation de l'eau. 
!        parameter (essai_convergence=.false.)
!        parameter (essai_convergence=.false.)


    ! essai convergence a t dplac dans wateriso2.h et est lue  l'execution

      real errmax ! erreur maximale en absolu.
      parameter (errmax=1e-8)
!      parameter (errmax=1e10)

      real errmax_sol ! erreur maximale en absolu.
      parameter (errmax_sol=5e-7)

      real errmaxrel ! erreur maximale en relatif autorise
!      parameter (errmaxrel=1e10)
      parameter (errmaxrel=1e-3)

      real borne ! valeur maximale que n'importe quelle variable peut
                 ! atteindre, en val abs; utile pour vrif que pas NAN
      parameter (borne=1e19)

      real ridicule ! valeur maximale pour qu'une variable de type
                    ! rapoport de mlange puisse tre considre comme ngligeable. Si
                    ! ngligeable, alors on ne verifie pas si sa compo iso esta brrante.
      parameter (ridicule=1e-12)      
!      parameter (ridicule=1)
!
      real ridicule_rain ! valeur limite de ridicule pour les flux de pluies (rain, zrfl...)
      parameter (ridicule_rain=1e-8) ! en kg/s <-> 1e-3mm/day

      real ridicule_evap ! valeur limite de ridicule pour les evap
      parameter (ridicule_evap=ridicule_rain*1e-2) ! en kg/s <-> 1e-3mm/day

      real ridicule_qsol ! valeur limite de ridicule pour les qsol
      parameter (ridicule_qsol=ridicule_rain) ! en kg <-> 1e-8kg

      real ridicule_snow ! valeur limite de ridicule pour les snow
      parameter (ridicule_snow=ridicule_qsol) ! en kg/s <-> 1e-8kg

      real ridicule_trac
      parameter (ridicule_trac=ridicule*1e4)
      
      real deltalim ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la vapeur, au-dela, en suppose que c'est abrrant.
                             ! dans le liquide, on autorise deltalim*faccond.
!      parameter (deltalim=1e10)
!      parameter (deltalim=300.0)
       ! maintenant dfini dans iso.def

       real deltalimtrac ! max de deltaD dans les traceurs, dfini dans iso.def

      real deltalim_snow ! deltalim est le maximum de deltaD qu'on
                             ! autorise dans la neige, au-dela, en suppose que c'est abrrant.
!      parameter (deltalim_snow=500.0) ! initalis dans iso_init

	real deltaDmin
!	parameter (deltaDmin=-900.0)
    ! maintentant, dfini dans iso.def

      real o17excess_bas,o17excess_haut ! bornes inf et sup de l'O17-excess
!      parameter(o17excess_bas=-200.0,o17excess_haut=120)
      integer nlevmaxO17

      logical O17_verif
!      parameter (O17_verif=.true.)

      real faccond  ! dans le liquide, on autorise R(deltalim)*faccond.
      parameter (faccond=1.1)
      
!      logical bidouille_anti_divergence ! si true, alors on fait un
!                                        ! rappel rgulier des xt4 vers les q pour 
!                                        !viter accumulation d'rreurs et  divergences
!      parameter (bidouille_anti_divergence=.true.)
!      parameter (bidouille_anti_divergence=.false.)
    ! bidouille_anti_divergence a t dplac dans wateriso2.h et est lue  l'execution

        real expb_max
        parameter (expb_max=30.0)

	real deltaDfaible ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible=-300)
        real deltaDfaible_lax ! deltaD en dessous duquel la vapeur est tellement faible 
        !que on peut accepter que la remise  l'quilibre du sol avec 
        ! cette vapeur donne des deltaDevap aberrants.
        parameter (deltaDfaible_lax=-180)

    	real faible_evap ! faible vaporation: on est plus laxiste 
        !pour les deltaD aberrant dans le cas de l'vap venant d'orchidee
        parameter (faible_evap=3.0)

    	real Tmin_verif
	parameter (Tmin_verif=5.0) ! en K
    	real Tmax_verif
	parameter (Tmax_verif=1000.0) ! en K

        COMMON /isoverif/ deltalim,deltalimtrac,deltalim_snow,deltaDmin
	COMMON /isoverifO17/ O17_verif,o17excess_bas,o17excess_haut
	COMMON /isoverifO17bis/ nlevmaxO17      
      

! tendance nulles
      REAL du0(klon,klev),dv0(klon,klev),dq0(klon,klev),dql0(klon,klev)

      REAL dxt0(ntraciso,klon,klev),dxtl0(ntraciso,klon,klev)
c
*********************************************************
*     declarations
      
*********************************************************
cIM 081204 END
c
      REAL pmfu(klon,klev), pmfd(klon,klev)
      REAL pen_u(klon,klev), pen_d(klon,klev)
      REAL pde_u(klon,klev), pde_d(klon,klev)
      INTEGER kcbot(klon), kctop(klon), kdtop(klon)
      REAL pmflxr(klon,klev+1), pmflxs(klon,klev+1)
      REAL prfl(klon,klev+1), psfl(klon,klev+1)
c
      REAL rain_lsc(klon)
      REAL snow_lsc(klon)

      real pxtrfl(ntraciso,klon,klev+1),pxtsfl(ntraciso,klon,klev+1)
      real xtrain_lsc(ntraciso,klon),xtsnow_lsc(ntraciso,klon)
c
      REAL ratqsc(klon,klev)
      real ratqsbas,ratqshaut,tau_ratqs
      save ratqsbas,ratqshaut,tau_ratqs
c$OMP THREADPRIVATE(ratqsbas,ratqshaut,tau_ratqs)
      real zpt_conv(klon,klev)

c Parametres lies au nouveau schema de nuages (SB, PDF)
      real fact_cldcon
      real facttemps
      logical ok_newmicro
      save ok_newmicro
      real ref_liq(klon,klev), ref_ice(klon,klev)
c$OMP THREADPRIVATE(ok_newmicro)
      save fact_cldcon,facttemps
c$OMP THREADPRIVATE(fact_cldcon,facttemps)

      integer iflag_cldcon
      save iflag_cldcon
c$OMP THREADPRIVATE(iflag_cldcon)
      logical ptconv(klon,klev)
cIM cf. AM 081204 BEG
      logical ptconvth(klon,klev)
cIM cf. AM 081204 END
c
c Variables liees a l'ecriture de la bande histoire physique
c
c======================================================================
c
cIM cf. AM 081204 BEG
c   declarations pour sortir sur une sous-region
      integer imin_ins,imax_ins,jmin_ins,jmax_ins
      save imin_ins,imax_ins,jmin_ins,jmax_ins
c$OMP THREADPRIVATE(imin_ins,imax_ins,jmin_ins,jmax_ins)
c      real lonmin_ins,lonmax_ins,latmin_ins
c     s  ,latmax_ins
c     data lonmin_ins,lonmax_ins,latmin_ins
c    s  ,latmax_ins/
c valeurs initiales     s   -5.,20.,41.,55./   
c    s   100.,130.,-20.,20./
c    s   -180.,180.,-90.,90./
c======================================================================
cIM cf. AM 081204 END

c
      integer itau_w   ! pas de temps ecriture = itap + itau_phy
c
c
c Variables locales pour effectuer les appels en serie
c
      REAL zx_rh(klon,klev)
cIM RH a 2m (la surface)
      REAL rh2m(klon), qsat2m(klon)
      REAL tpot(klon), tpote(klon)
      REAL Lheat

      INTEGER        length
      PARAMETER    ( length = 100 )
      REAL tabcntr0( length       )
c
      INTEGER ndex2d(iim*jjmp1),ndex3d(iim*jjmp1*klev)
cIM
      INTEGER ndex2d1(iwmax)
c
cIM AMIP2 BEG
      REAL moyglo, mountor
cIM 141004 BEG
      REAL zustrdr(klon), zvstrdr(klon)
      REAL zustrli(klon), zvstrli(klon)
      REAL zustrph(klon), zvstrph(klon)
      REAL zustrhi(klon), zvstrhi(klon)
      REAL aam, torsfc
cIM 141004 END
cIM 190504 BEG
      INTEGER ij, imp1jmp1
      PARAMETER(imp1jmp1=(iim+1)*jjmp1)
cym A voir plus tard
      REAL zx_tmp(imp1jmp1), airedyn(iim+1,jjmp1)
      REAL padyn(iim+1,jjmp1,klev+1)
      REAL dudyn(iim+1,jjmp1,klev)
      REAL rlatdyn(iim+1,jjmp1)
cIM 190504 END
      LOGICAL ok_msk
      REAL msk(klon)
cIM 
      REAL airetot, pi
cym A voir plus tard
cym      REAL zm_wo(jjmp1, klev)
cIM AMIP2 END
c
      REAL zx_tmp_fi2d(klon)      ! variable temporaire grille physique
      REAL zx_tmp_fi3d(klon,klev) ! variable temporaire pour champs 3D 
      REAL zx_tmp_fi3d1(klon,klev+1) !variable temporaire pour champs 3D (kelvp1)
      REAL(KIND=8) zx_tmp2_fi3d(klon,klev) ! variable temporaire pour champs 3D 
      REAL zx_tmp_2d(iim,jjmp1), zx_tmp_3d(iim,jjmp1,klev)
      REAL zx_lon(iim,jjmp1), zx_lat(iim,jjmp1)
c
      INTEGER nid_day, nid_mth, nid_ins, nid_mthnmc, nid_daynmc
      INTEGER nid_hfnmc, nid_day_seri, nid_ctesGCM
      integer nid_iso
      save nid_iso
      SAVE nid_day, nid_mth, nid_ins, nid_mthnmc, nid_daynmc
      SAVE nid_hfnmc, nid_day_seri, nid_ctesGCM
c$OMP THREADPRIVATE(nid_day, nid_mth, nid_ins)
c$OMP THREADPRIVATE(nid_mthnmc, nid_daynmc, nid_hfnmc)
c$OMP THREADPRIVATE(nid_day_seri,nid_ctesGCM)
c
cIM 280405 BEG
      INTEGER nid_bilKPins, nid_bilKPave
      SAVE nid_bilKPins, nid_bilKPave
c$OMP THREADPRIVATE(nid_bilKPins, nid_bilKPave)
c
      REAL ve_lay(klon,klev) ! transport meri. de l'energie a chaque niveau vert.
      REAL vq_lay(klon,klev) ! transport meri. de l'eau a chaque niveau vert.
      REAL ue_lay(klon,klev) ! transport zonal de l'energie a chaque niveau vert.
      REAL uq_lay(klon,klev) ! transport zonal de l'eau a chaque niveau vert.
      REAL wq_lay(klon,klev) ! transport vertical de l'eau a chaque niveau vert.
      REAL uxt_lay(niso,klon,klev) ! transport zonal de l'eau a chaque niveau vert.
      REAL vxt_lay(niso,klon,klev) ! transport meri. de l'eau a chaque niveau vert.
c
      INTEGER nhori, nvert, nvert1, nvert3
      REAL zsto, zsto1, zsto2
      REAL zstophy, zstorad, zstohf, zstoday, zstomth, zout
      REAL zcals(napisccp), zcalh(napisccp), zoutj(napisccp)
      REAL zout_isccp(napisccp)
      SAVE zcals, zcalh, zoutj, zout_isccp
c$OMP THREADPRIVATE(zcals, zcalh, zoutj, zout_isccp)

      real zjulian
      save zjulian
c$OMP THREADPRIVATE(zjulian)

      character*20 modname
      character*80 abort_message
      logical ok_sync
      real date0
      integer idayref

C essai writephys
      integer fid_day, fid_mth, fid_ins
      parameter (fid_ins = 1, fid_day = 2, fid_mth = 3) 
      integer prof2d_on, prof3d_on, prof2d_av, prof3d_av
      parameter (prof2d_on = 1, prof3d_on = 2,
     .           prof2d_av = 3, prof3d_av = 4)
      character*30 nom_fichier
      character*10 varname
      character*40 vartitle
      character*20 varunits
C     Variables liees au bilan d'energie et d'enthalpi
      REAL ztsol(klon)
      REAL      h_vcol_tot, h_dair_tot, h_qw_tot, h_ql_tot
     $        , h_qs_tot, qw_tot, ql_tot, qs_tot , ec_tot
      SAVE      h_vcol_tot, h_dair_tot, h_qw_tot, h_ql_tot
     $        , h_qs_tot, qw_tot, ql_tot, qs_tot , ec_tot
c$OMP THREADPRIVATE(h_vcol_tot, h_dair_tot, h_qw_tot, h_ql_tot,
c$OMP+              h_qs_tot, qw_tot, ql_tot, qs_tot , ec_tot)
      REAL      d_h_vcol, d_h_dair, d_qt, d_qw, d_ql, d_qs, d_ec
      real d_xtw(niso), d_xtl(niso)
      REAL      d_h_vcol_phy
      REAL      fs_bound, fq_bound
      SAVE      d_h_vcol_phy
c$OMP THREADPRIVATE(d_h_vcol_phy)
      REAL      zero_v(klon)
      CHARACTER*15 ztit
      INTEGER   ip_ebil  ! PRINT level for energy conserv. diag.
      SAVE      ip_ebil
      DATA      ip_ebil/0/
c$OMP THREADPRIVATE(ip_ebil)
      INTEGER   if_ebil ! level for energy conserv. dignostics
      SAVE      if_ebil
c$OMP THREADPRIVATE(if_ebil)
c+jld ec_conser
      REAL ZRCPD
c-jld ec_conser
      REAL t2m(klon,nbsrf)  ! temperature a 2m
      REAL q2m(klon,nbsrf)  ! humidite a 2m

cIM: t2m, q2m, ustar, u10m, v10m et t2mincels, t2maxcels
      REAL zt2m(klon), zq2m(klon)             !temp., hum. 2m moyenne s/ 1 maille
      REAL zustar(klon),zu10m(klon), zv10m(klon)  ! u* et vents a 10m moyennes s/1 maille
      CHARACTER*40 t2mincels, t2maxcels       !t2m min., t2m max
      CHARACTER*40 tinst, tave, typeval
      REAL cldtaupi(klon,klev)  ! Cloud optical thickness for pre-industrial (pi) aerosols

      REAL re(klon, klev)       ! Cloud droplet effective radius
      REAL fl(klon, klev)  ! denominator of re

      REAL re_top(klon), fl_top(klon) ! CDR at top of liquid water clouds

      ! Aerosol optical properties
      CHARACTER*4, DIMENSION(naero_grp) :: rfname 
      REAL, DIMENSION(klon)          :: aerindex     ! POLDER aerosol index
      REAL, DIMENSION(klon,klev)     :: mass_solu_aero    ! total mass concentration for all soluble aerosols[ug/m3]
      REAL, DIMENSION(klon,klev)     :: mass_solu_aero_pi ! - " - (pre-industrial value)
      INTEGER :: naero ! aerosol species 

      ! Parameters
      LOGICAL ok_ade, ok_aie    ! Apply aerosol (in)direct effects or not
      LOGICAL ok_cdnc          ! ok cloud droplet number concentration (O. Boucher 01-2013)
      REAL bl95_b0, bl95_b1   ! Parameter in Boucher and Lohmann (1995)
      SAVE ok_ade, ok_aie, ok_cdnc, bl95_b0, bl95_b1
c$OMP THREADPRIVATE(ok_ade, ok_aie, ok_cdnc, bl95_b0, bl95_b1)
      LOGICAL, SAVE :: aerosol_couple ! true  : calcul des aerosols dans INCA
                                      ! false : lecture des aerosol dans un fichier
c$OMP THREADPRIVATE(aerosol_couple)    
      INTEGER, SAVE :: flag_aerosol 
c$OMP THREADPRIVATE(flag_aerosol) 
      LOGICAL, SAVE :: new_aod
c$OMP THREADPRIVATE(new_aod) 
   
c
c Declaration des constantes et des fonctions thermodynamiques
c
      LOGICAL,SAVE :: first=.true.
c$OMP THREADPRIVATE(first)

      integer iunit

      integer, save::  read_climoz ! read ozone climatology
C     (let it keep the default OpenMP shared attribute)
C     Allowed values are 0, 1 and 2
C     0: do not read an ozone climatology
C     1: read a single ozone climatology that will be used day and night
C     2: read two ozone climatologies, the average day and night
C     climatology and the daylight climatology

      integer, save:: ncid_climoz ! NetCDF file containing ozone climatologies
C     (let it keep the default OpenMP shared attribute)

      real, pointer, save:: press_climoz(:)
C     (let it keep the default OpenMP shared attribute)
!     edges of pressure intervals for ozone climatologies, in Pa, in strictly
!     ascending order

      integer, save:: co3i = 0
!     time index in NetCDF file of current ozone fields
c$OMP THREADPRIVATE(co3i) 

      integer ro3i
!     required time index in NetCDF file for the ozone fields, between 1
!     and 360

      INTEGER ierr
!
! $Header$
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation
!                 (les placer en colonne 6 et en colonne 73)
!
!
! A1.0 Fundamental constants
      REAL RPI,RCLUM,RHPLA,RKBOL,RNAVO
! A1.1 Astronomical constants
      REAL RDAY,REA,REPSM,RSIYEA,RSIDAY,ROMEGA
! A1.1.bis Constantes concernant l'orbite de la Terre:
      REAL R_ecc, R_peri, R_incl
! A1.2 Geoide
      REAL RA,RG,R1SA
! A1.3 Radiation
!     REAL RSIGMA,RI0
      REAL RSIGMA
! A1.4 Thermodynamic gas phase
      REAL R,RMD,RMO3,RMV,RD,RV,RCPD,RCPV,RCVD,RCVV
      REAL RKAPPA,RETV
! A1.5,6 Thermodynamic liquid,solid phases
      REAL RCW,RCS
! A1.7 Thermodynamic transition of phase
      REAL RLVTT,RLSTT,RLMLT,RTT,RATM
! A1.8 Curve of saturation
      REAL RESTT,RALPW,RBETW,RGAMW,RALPS,RBETS,RGAMS
      REAL RALPD,RBETD,RGAMD
!
      COMMON/YOMCST/RPI   ,RCLUM ,RHPLA ,RKBOL ,RNAVO                   &
     &      ,RDAY  ,REA   ,REPSM ,RSIYEA,RSIDAY,ROMEGA                  &
     &      ,R_ecc, R_peri, R_incl                                      &
     &      ,RA    ,RG    ,R1SA                                         &
     &      ,RSIGMA                                                     &
     &      ,R     ,RMD   ,RMO3  ,RMV   ,RD    ,RV    ,RCPD             &
     &      ,RCPV  ,RCVD  ,RCVV  ,RKAPPA,RETV                           &
     &      ,RCW   ,RCS                                                 &
     &      ,RLVTT ,RLSTT ,RLMLT ,RTT   ,RATM                           &
     &      ,RESTT ,RALPW ,RBETW ,RGAMW ,RALPS ,RBETS ,RGAMS            &
     &      ,RALPD ,RBETD ,RGAMD
!    ------------------------------------------------------------------
!$OMP THREADPRIVATE(/YOMCST/)
!
! $Header$
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation
!                 (les placer en colonne 6 et en colonne 73)
!
!*    COMMON *YOETHF* DERIVED CONSTANTS SPECIFIC TO ECMWF THERMODYNAMICS
!
!     *R__ES*   *CONSTANTS USED FOR COMPUTATION OF SATURATION
!                MIXING RATIO OVER LIQUID WATER(*R_LES*) OR
!                ICE(*R_IES*).
!     *RVTMP2*  *RVTMP2=RCPV/RCPD-1.
!     *RHOH2O*  *DENSITY OF LIQUID WATER.   (RATM/100.)
!
      REAL R2ES, R3LES, R3IES, R4LES, R4IES, R5LES, R5IES
      REAL RVTMP2, RHOH2O
      COMMON /YOETHF/R2ES, R3LES, R3IES, R4LES, R4IES, R5LES, R5IES,    &
     &               RVTMP2, RHOH2O
!$OMP THREADPRIVATE(/YOETHF/)
!
! $Header$
!
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation
!                 (les placer en colonne 6 et en colonne 73)
!
!     ------------------------------------------------------------------
!     This COMDECK includes the Thermodynamical functions for the cy39
!       ECMWF Physics package.
!       Consistent with YOMCST Basic physics constants, assuming the
!       partial pressure of water vapour is given by a first order
!       Taylor expansion of Qs(T) w.r.t. to Temperature, using constants
!       in YOETHF
!     ------------------------------------------------------------------
      REAL PTARG, PDELARG, P5ARG, PQSARG, PCOARG
      REAL FOEEW, FOEDE, qsats, qsatl, dqsats, dqsatl
      LOGICAL thermcep
      PARAMETER (thermcep=.TRUE.)
!
      FOEEW ( PTARG,PDELARG ) = EXP (                                   &
     &          (R3LES*(1.-PDELARG)+R3IES*PDELARG) * (PTARG-RTT)        &
     & / (PTARG-(R4LES*(1.-PDELARG)+R4IES*PDELARG)) )
!
      FOEDE ( PTARG,PDELARG,P5ARG,PQSARG,PCOARG ) = PQSARG*PCOARG*P5ARG &
     & / (PTARG-(R4LES*(1.-PDELARG)+R4IES*PDELARG))**2
!
      qsats(ptarg) = 100.0 * 0.622 * 10.0                               &
     &           ** (2.07023 - 0.00320991 * ptarg                       &
     &           - 2484.896 / ptarg + 3.56654 * LOG10(ptarg))
      qsatl(ptarg) = 100.0 * 0.622 * 10.0                               &
     &           ** (23.8319 - 2948.964 / ptarg                         &
     &           - 5.028 * LOG10(ptarg)                                 &
     &           - 29810.16 * EXP( - 0.0699382 * ptarg)                 &
     &           + 25.21935 * EXP( - 2999.924 / ptarg))
!
      dqsats(ptarg,pqsarg) = RLVTT/RCPD*pqsarg * (3.56654/ptarg         &
     &                     +2484.896*LOG(10.)/ptarg**2                  &
     &                     -0.00320991*LOG(10.))
      dqsatl(ptarg,pqsarg) = RLVTT/RCPD*pqsarg*LOG(10.)*                &
     &                (2948.964/ptarg**2-5.028/LOG(10.)/ptarg           &
     &                +25.21935*2999.924/ptarg**2*EXP(-2999.924/ptarg)  &
     &                +29810.16*0.0699382*EXP(-0.0699382*ptarg))
cIM 100106 BEG : pouvoir sortir les ctes de la physique
!
! $Header$
!-- Modified by : Filiberti M-A 06/2005
!
      real epmax             ! 0.993
      logical ok_adj_ema      ! F
      integer iflag_clw      ! 0
	  integer iflag_cvl_sigd
      real sig1feed      ! 1.
      real sig2feed      ! 0.95

      common/comconema1/epmax,ok_adj_ema,iflag_clw,sig1feed,sig2feed
      common/comconema2/iflag_cvl_sigd

!      common/comconema/epmax,ok_adj_ema,iflag_clw
!$OMP THREADPRIVATE(/comconema1/)
!$OMP THREADPRIVATE(/comconema2/)
!
! $Header$
!
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation
!                 (les placer en colonne 6 et en colonne 73)
!
      REAL cld_lc_lsc,cld_lc_con
      REAL cld_tau_lsc,cld_tau_con
      REAL ffallv_lsc,ffallv_con
      REAL coef_eva
      LOGICAL reevap_ice
      INTEGER iflag_pdf
      INTEGER ok_sursat_marine

      common/comfisrtilp/                                               &
     &     cld_lc_lsc                                                   &
     &     ,cld_lc_con                                                  &
     &     ,cld_tau_lsc                                                 &
     &     ,cld_tau_con                                                 &
     &     ,ffallv_lsc                                                  &
     &     ,ffallv_con                                                  &
     &     ,coef_eva                                                    &
     &     ,reevap_ice                                                  &
     &     ,iflag_pdf                                                   &
     &     ,ok_sursat_marine        

!$OMP THREADPRIVATE(/comfisrtilp/)
!
! $Id: nuage.h 1525 2011-05-25 10:55:27Z idelkadi $
!
      REAL rad_froid, rad_chau1, rad_chau2, t_glace_max, t_glace_min
      REAL rei_min,rei_max

      common /nuagecom/ rad_froid,rad_chau1, rad_chau2,t_glace_max,     &
     &                  t_glace_min,rei_min,rei_max
!$OMP THREADPRIVATE(/nuagecom/)
      !
      ! $Header$
      !
      integer iflag_pbl
      common/compbl/iflag_pbl
!$OMP THREADPRIVATE(/compbl/)
cIM 100106 END : pouvoir sortir les ctes de la physique
c
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c Declarations pour Simulateur COSP
c============================================================
      real :: mr_ozone(klon,klev)

cIM sorties fichier 1D paramLMDZ_phy.nc
      REAL :: zx_tmp_0d(1,1)
      INTEGER, PARAMETER :: np=1
      REAL,dimension(klon_glo)        :: rlat_glo
      REAL,dimension(klon_glo)        :: rlon_glo
      REAL gbils(1), gevap(1), gevapt(1), glat(1), gnet0(1), gnet(1)
      REAL grain(1), gtsol(1), gt2m(1), gprw(1)

cIM stations CFMIP
      INTEGER, SAVE :: nCFMIP
c$OMP THREADPRIVATE(nCFMIP)
      INTEGER, PARAMETER :: npCFMIP=120
      INTEGER, ALLOCATABLE, SAVE :: tabCFMIP(:)
      REAL, ALLOCATABLE, SAVE :: lonCFMIP(:), latCFMIP(:)
c$OMP THREADPRIVATE(tabCFMIP, lonCFMIP, latCFMIP) 
      INTEGER, ALLOCATABLE, SAVE :: tabijGCM(:)
      REAL, ALLOCATABLE, SAVE :: lonGCM(:), latGCM(:)
c$OMP THREADPRIVATE(tabijGCM, lonGCM, latGCM)
      INTEGER, ALLOCATABLE, SAVE :: iGCM(:), jGCM(:)
c$OMP THREADPRIVATE(iGCM, jGCM)
      logical, dimension(nfiles)            :: phys_out_filestations
      logical, parameter :: lNMC=.FALSE.

cIM betaCRF
      REAL, SAVE :: pfree, beta_pbl, beta_free
c$OMP THREADPRIVATE(pfree, beta_pbl, beta_free)
      REAL, SAVE :: lon1_beta,  lon2_beta, lat1_beta, lat2_beta
c$OMP THREADPRIVATE(lon1_beta,  lon2_beta, lat1_beta, lat2_beta)
      LOGICAL, SAVE :: mskocean_beta
c$OMP THREADPRIVATE(mskocean_beta)
      REAL, dimension(klon, klev) :: beta         ! facteur sur cldtaurad et cldemirad pour evaluer les retros liees aux CRF
      REAL, dimension(klon, klev) :: cldtaurad    ! epaisseur optique pour radlwsw pour tester "CRF off"
      REAL, dimension(klon, klev) :: cldtaupirad  ! epaisseur optique pour radlwsw pour tester "CRF off"
      REAL, dimension(klon, klev) :: cldemirad    ! emissivite pour radlwsw pour tester "CRF off"
      REAL, dimension(klon, klev) :: cldfrarad    ! fraction nuageuse

      INTEGER :: nbtr_tmp ! Number of tracer inside concvl
      REAL, dimension(klon,klev) :: sh_in ! Specific humidity entering in phytrac
      integer iostat

c======================================================================
! Gestion calendrier : mise a jour du module phys_cal_mod
!
      CALL phys_cal_update(jD_cur,jH_cur)

c======================================================================
! Ecriture eventuelle d'un profil verticale en entree de la physique.
! Utilise notamment en 1D mais peut etre active egalement en 3D
! en imposant la valeur de igout.
c======================================================================

      if (prt_level.ge.1) then
          igout=klon/2+1/klon
         write(lunout,*) 'DEBUT DE PHYSIQ !!!!!!!!!!!!!!!!!!!!'
         write(lunout,*) 'iim=',iim
         write(lunout,*)
     s 'nlon,klev,nqtot,debut,lafin, jD_cur, jH_cur,pdtphys'
         write(lunout,*)
     s  nlon,klev,nqtot,debut,lafin, jD_cur, jH_cur,pdtphys 

         write(lunout,*) 'paprs, play, phi, u, v, t'
         do k=1,klev
            write(lunout,*) paprs(igout,k),pplay(igout,k),pphi(igout,k),
     s   u(igout,k),v(igout,k),t(igout,k)
         enddo
         write(lunout,*) 'ovap (g/kg),  oliq (g/kg)'
         do k=1,klev
            write(lunout,*) qx(igout,k,1)*1000,qx(igout,k,2)*1000.
         enddo
      endif

c======================================================================

cym => necessaire pour iflag_con != 2    
      pmfd(:,:) = 0.
      pen_u(:,:) = 0.
      pen_d(:,:) = 0.
      pde_d(:,:) = 0.
      pde_u(:,:) = 0.
      aam=0.

      torsfc=0.
      forall (k=1: llm) zmasse(:, k) = (paprs(:, k)-paprs(:, k+1)) / rg

      if (first) then 
      
cCR:nvelles variables convection/poches froides
      
      print*, '================================================='
      print*, 'Allocation des variables locales et sauvegardees'
      call phys_local_var_init
c
      pasphys=pdtphys
c     appel a la lecture du run.def physique
      call conf_phys(ok_journe, ok_mensuel,
     .     ok_instan, ok_hf,
     .     ok_LES,
     .     callstats,
     .     solarlong0,seuil_inversion,
     .     fact_cldcon, facttemps,ok_newmicro,iflag_radia,
     .     iflag_cldcon,iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs,
     .     ok_ade, ok_aie, ok_cdnc, aerosol_couple, 
     .     flag_aerosol, new_aod,
     .     bl95_b0, bl95_b1,
c     nv flags pour la convection et les poches froides
     .     read_climoz,
     &     alp_offset)
      call phys_state_var_init(read_climoz)
      call phys_output_var_init
      print*, '================================================='
c
          dnwd0=0.0
          ftd=0.0
          fqd=0.0
          fxtd=0.0
          cin=0.
cym Attention pbase pas initialise dans concvl !!!!
          pbase=0
cIM 180608
c         pmflxr=0.
c         pmflxs=0.

        itau_con=0
        first=.false.

      endif  ! first

       modname = 'physiq'
cIM
      IF (ip_ebil_phy.ge.1) THEN
        DO i=1,klon
          zero_v(i)=0.
        END DO 
      END IF 
      ok_sync=.TRUE.

      IF (debut) THEN
         CALL suphel ! initialiser constantes et parametres phys.
      ENDIF

      if(prt_level.ge.1) print*,'CONVERGENCE PHYSIQUE THERM 1 '


c======================================================================
! Gestion calendrier : mise a jour du module phys_cal_mod
!
c     CALL phys_cal_update(jD_cur,jH_cur)

c
c Si c'est le debut, il faut initialiser plusieurs choses
c          ********
c
       IF (debut) THEN
!rv
cCRinitialisation de wght_th et lalim_conv pour la definition de la couche alimentation 
cde la convection a partir des caracteristiques du thermique
         wght_th(:,:)=1.
         lalim_conv(:)=1 
cRC
         ustar(:,:)=0.
         u10m(:,:)=0.
         v10m(:,:)=0.
         rain_con(:)=0.
         snow_con(:)=0.
         topswai(:)=0.
         topswad(:)=0.
         solswai(:)=0.
         solswad(:)=0.

         wmax_th(:)=0.
         tau_overturning_th(:)=0.

         xtrain_con(:,:)=0.
         xtsnow_con(:,:)=0.

         IF (type_trac == 'inca') THEN
            ! jg : initialisation jusqu'au ces variables sont dans restart
            ccm(:,:,:) = 0.
            tau_aero(:,:,:,:) = 0.
            piz_aero(:,:,:,:) = 0.
            cg_aero(:,:,:,:) = 0.
         END IF

         rnebcon0(:,:) = 0.0
         clwcon0(:,:) = 0.0
         rnebcon(:,:) = 0.0
         clwcon(:,:) = 0.0

cIM      
         IF (ip_ebil_phy.ge.1) d_h_vcol_phy=0.
c
      print*,'iflag_coupl,iflag_clos,iflag_wake',
     .   iflag_coupl,iflag_clos,iflag_wake
      print*,'CYCLE_DIURNE', cycle_diurne
c
      IF (iflag_con.EQ.2.AND.iflag_cldcon.GT.-1) THEN
         abort_message = 'Tiedtke needs iflag_cldcon=-2 or -1'
         CALL abort_gcm (modname,abort_message,1)
      ENDIF
c
      IF(ok_isccp.AND.iflag_con.LE.2) THEN
         abort_message = 'ISCCP-like outputs may be available for KE
     .(iflag_con >= 3); for Tiedtke (iflag_con=-2) put ok_isccp=n'
         CALL abort_gcm (modname,abort_message,1)
      ENDIF
         write(*,*) 'physiq 1612'
c
c Initialiser les compteurs:
c
         itap    = 0
         itaprad = 0

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! Un petit travail \`a faire ici.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

         if (iflag_pbl>1) then
             PRINT*, "Using method MELLOR&YAMADA" 
         endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! FH 2008/05/02 changement lie a la lecture de nbapp_rad dans phylmd plutot que
! dyn3d
! Attention : la version precedente n'etait pas tres propre.
! Il se peut qu'il faille prendre une valeur differente de nbapp_rad
! pour obtenir le meme resultat.
         dtime=pdtphys
         radpas = NINT( 86400./dtime/nbapp_rad)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

         ! isotopes: on y met l‡-dedans l'init des isotopes
         CALL phyetat0 ("startphy.nc",clesphy0,tabcntr0)
cIM begin
          print*,'physiq: clwcon rnebcon ratqs',clwcon(1,1),rnebcon(1,1)
     $,ratqs(1,1)
cIM end





         ! phyisoetat0 est maintenant appelÈ depuis phyetat0

         ! verif




!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c
C on remet le calendrier a zero
c
         IF (raz_date .eq. 1) THEN
           itau_phy = 0
         ENDIF

cIM cf. AM 081204 BEG
         PRINT*,'cycle_diurne3 =',cycle_diurne
cIM cf. AM 081204 END
c
         CALL printflag( tabcntr0,radpas,ok_journe,
     ,                    ok_instan, ok_region )
c
         IF (ABS(dtime-pdtphys).GT.0.001) THEN
            WRITE(lunout,*) 'Pas physique n est pas correct',dtime,
     .                        pdtphys
            abort_message='Pas physique n est pas correct '
!           call abort_gcm(modname,abort_message,1)
            dtime=pdtphys
         ENDIF
         IF (nlon .NE. klon) THEN
            WRITE(lunout,*)'nlon et klon ne sont pas coherents', nlon, 
     .                      klon
            abort_message='nlon et klon ne sont pas coherents'
            call abort_gcm(modname,abort_message,1)
         ENDIF
         IF (nlev .NE. klev) THEN
            WRITE(lunout,*)'nlev et klev ne sont pas coherents', nlev,
     .                       klev
            abort_message='nlev et klev ne sont pas coherents'
            call abort_gcm(modname,abort_message,1)
         ENDIF
c
         IF (dtime*REAL(radpas).GT.21600..AND.cycle_diurne) THEN 
           WRITE(lunout,*)'Nbre d appels au rayonnement insuffisant'
           WRITE(lunout,*)"Au minimum 4 appels par jour si cycle diurne"
           abort_message='Nbre d appels au rayonnement insuffisant'
           call abort_gcm(modname,abort_message,1)
         ENDIF
         WRITE(lunout,*)"Clef pour la convection, iflag_con=", iflag_con
         WRITE(lunout,*)"Clef pour le driver de la convection, ok_cvl=",
     .                   ok_cvl
c
cKE43
c Initialisation pour la convection de K.E. (sb):
         IF (iflag_con.GE.3) THEN

         WRITE(lunout,*)"*** Convection de Kerry Emanuel 4.3  "
         WRITE(lunout,*)
     .      "On va utiliser le melange convectif des traceurs qui"
         WRITE(lunout,*)"est calcule dans convect4.3"
         WRITE(lunout,*)" !!! penser aux logical flags de phytrac"

          DO i = 1, klon
           ema_cbmf(i) = 0.
           ema_pcb(i)  = 0.
           ema_pct(i)  = 0.
c          ema_workcbmf(i) = 0.
          ENDDO
cIM15/11/02 rajout initialisation ibas_con,itop_con cf. SB =>BEG
          DO i = 1, klon
           ibas_con(i) = 1
           itop_con(i) = 1
          ENDDO
cIM15/11/02 rajout initialisation ibas_con,itop_con cf. SB =>END
c===============================================================================
cCR:04.12.07: initialisations poches froides
c Controle de ALE et ALP pour la fermeture convective (jyg)
          if (iflag_wake>=1) then
            CALL ini_wake(0.,0.,it_wape_prescr,wape_prescr,fip_prescr
     s                  ,alp_bl_prescr, ale_bl_prescr)
c 11/09/06 rajout initialisation ALE et ALP du wake et PBL(YU)
c        print*,'apres ini_wake iflag_cldcon=', iflag_cldcon
          endif

        do i = 1,klon
         Ale_bl(i)=0.
         Alp_bl(i)=0.
        enddo

c================================================================================
cIM stations CFMIP
      nCFMIP=npCFMIP
      OPEN(98,file='npCFMIP_param.data',status='old',
     $          form='formatted',iostat=iostat)
            if (iostat == 0) then
      READ(98,*,end=998) nCFMIP
998   CONTINUE
      CLOSE(98)
      CONTINUE
      IF(nCFMIP.GT.npCFMIP) THEN
       print*,'nCFMIP > npCFMIP : augmenter npCFMIP et recompiler'
       CALL abort
      else
       print*,'physiq npCFMIP=',npCFMIP,'nCFMIP=',nCFMIP
      ENDIF

        if (nCFMIP.gt.0) then ! ajout crlmd
c
      ALLOCATE(tabCFMIP(nCFMIP))
      ALLOCATE(lonCFMIP(nCFMIP), latCFMIP(nCFMIP))
      ALLOCATE(tabijGCM(nCFMIP))
      ALLOCATE(lonGCM(nCFMIP), latGCM(nCFMIP))
      ALLOCATE(iGCM(nCFMIP), jGCM(nCFMIP))
c
c lecture des nCFMIP stations CFMIP, de leur numero 
c et des coordonnees geographiques lonCFMIP, latCFMIP
c
         CALL read_CFMIP_point_locations(nCFMIP, tabCFMIP, 
     $lonCFMIP, latCFMIP)
c
c identification des
c 1) coordonnees lonGCM, latGCM des points CFMIP dans la grille de LMDZ
c 2) indices points tabijGCM de la grille physique 1d sur klon points
c 3) indices iGCM, jGCM de la grille physique 2d
c
         CALL LMDZ_CFMIP_point_locations(nCFMIP, lonCFMIP, latCFMIP,
     $tabijGCM, lonGCM, latGCM, iGCM, jGCM)
c
            else
               ALLOCATE(tabijGCM(0))
               ALLOCATE(lonGCM(0), latGCM(0))
               ALLOCATE(iGCM(0), jGCM(0))
            end if
         else
            ALLOCATE(tabijGCM(0))
            ALLOCATE(lonGCM(0), latGCM(0))
            ALLOCATE(iGCM(0), jGCM(0))
         ENDIF

        endif ! if (nCFMIP.gt.0) then ! ajout crlmd 

           DO i=1,klon
             rugoro(i) = f_rugoro * MAX(1.0e-05, zstd(i)*zsig(i)/2.0)
           ENDDO

c34EK
         IF (ok_orodr) THEN

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! FH sans doute a enlever de finitivement ou, si on le garde, l'activer
! justement quand ok_orodr = false.
! ce rugoro est utilise par la couche limite et fait double emploi
! avec les param\'etrisations sp\'ecifiques de Francois Lott.
!           DO i=1,klon
!             rugoro(i) = MAX(1.0e-05, zstd(i)*zsig(i)/2.0)
!           ENDDO
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
           IF (ok_strato) THEN
             CALL SUGWD_strato(klon,klev,paprs,pplay)
           ELSE
             CALL SUGWD(klon,klev,paprs,pplay)
           ENDIF
           
           DO i=1,klon
             zuthe(i)=0.
             zvthe(i)=0.
             if(zstd(i).gt.10.)then
               zuthe(i)=(1.-zgam(i))*cos(zthe(i))
               zvthe(i)=(1.-zgam(i))*sin(zthe(i))
             endif
           ENDDO
         ENDIF
c
c
         lmt_pas = NINT(86400./dtime * 1.0)   ! tous les jours
         WRITE(lunout,*)'La frequence de lecture surface est de ', 
     .                   lmt_pas
c
      capemaxcels = 't_max(X)'
      t2mincels = 't_min(X)'
      t2maxcels = 't_max(X)'
      tinst = 'inst(X)'
      tave = 'ave(X)'
cIM cf. AM 081204 BEG
      write(lunout,*)'AVANT HIST IFLAG_CON=',iflag_con
cIM cf. AM 081204 END
c
c=============================================================
c   Initialisation des sorties
c=============================================================


!      write(*,*) 'physiq 1919: call phys_output_open'
c$OMP MASTER
       call phys_output_open(rlon,rlat,nCFMIP,tabijGCM,
     &                       iGCM,jGCM,lonGCM,latGCM,
     &                       jjmp1,nlevSTD,clevSTD,
     &                       nbteta, ctetaSTD, dtime,ok_veget,
     &                       type_ocean,iflag_pbl,ok_mensuel,ok_journe,
     &                       ok_hf,ok_instan,ok_LES,ok_ade,ok_aie, 
     &                       read_climoz, phys_out_filestations,
     &                       new_aod, aerosol_couple
     &                        )
c$OMP END MASTER
c$OMP BARRIER


!
! $Header$
!
c$OMP MASTER
c
      IF (ok_histNMC(3)) THEN
c
       zstophy = dtime
       zstohf = ecrit_hf
       zstomth = ecrit_mth
c      zout = 6 * 3600.
       zout = freq_outNMC(3)
c
         idayref = day_ref
         CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)
c
cym         CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlon,zx_lon)
cym         DO i = 1, iim
cym            zx_lon(i,1) = rlon(i+1)
cym            zx_lon(i,jjmp1) = rlon(i+1)
cym         ENDDO
         DO ll=1,klev
            znivsig(ll)=float(ll)
         ENDDO
cym         CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlat,zx_lat)
cym         CALL histbeg("histNMC.nc", iim,zx_lon(:,1), jjmp1,zx_lat(1,:),
cym     .                 1,iim,1,jjmp1, itau_phy, zjulian, dtime, 
cym     .                 nhori, nid_hfnmc)

         CALL histbeg_phy("histhfNMC",itau_phy, zjulian, dtime, 
     .                 nhori, nid_hfnmc)
c
         CALL histvert(nid_hfnmc, "plev", "pressure", "Pa",
     .                 nlevSTD3, rlevSTD3, nvert,"down")
c
cIM Astuce MAF: remplacer inst par ave pour les variables NMC pour avoir
cIM             le time_counter et les bounds
c
ccc
ccc Champs 3D interpolles sur des niveaux de pression du NMC
ccc
c
c ATTENTION : pour AMIP2 on interpole t,u,v,wphi,q,rh
c             sur les niveaux du NMC et on somme & moyenne
c             toutes les freq_moyNMC secondes par des routines undefSTD et
c             moy_undefSTD pour eliminer les valeurs "undef"
c             de la moyenne mensuelle
c ======> le "inst(X)" ci-dessous est par consequence factice !
c
          CALL histdef(nid_hfnmc, "tnondef",
     .                 "Valeurs non-definies","-",
     .                iim,jj_nb,nhori, nlevSTD3,1,nlevSTD3, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_hfnmc, "ta",
     .                 "Air temperature","K",
     .                iim,jj_nb,nhori, nlevSTD3,1,nlevSTD3, nvert, 32,
     .                "ave(X)", zout,zout)
c
         CALL histdef(nid_hfnmc, "zg",
     .                "Geopotential height", "m",
     .                iim,jj_nb,nhori, nlevSTD3,1,nlevSTD3, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_hfnmc, "hus",
     .                 "Specific humidity","1",
     .                iim,jj_nb,nhori, nlevSTD3,1,nlevSTD3, nvert, 32,
     .                "ave(X)", zout,zout)
c
         CALL histdef(nid_hfnmc, "hur",
     .                 "Relative humidity", "%",
     .                iim,jj_nb,nhori, nlevSTD3,1,nlevSTD3, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_hfnmc, "ua",
     .                 "Eastward wind","m s-1",
     .                iim,jj_nb,nhori, nlevSTD3,1,nlevSTD3, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_hfnmc, "va",
     .                 "Northward wind","m s-1",
     .                iim,jj_nb,nhori, nlevSTD3,1,nlevSTD3, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_hfnmc, "wap",
     .                 "Lagrangian tendency of air pressure","Pa s-1",
     .                iim,jj_nb,nhori, nlevSTD3,1,nlevSTD3, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_hfnmc, "psbg",
     .         "Pressure sfce below ground","%",
     .         iim,jj_nb,nhori, nlevSTD3,1,nlevSTD3, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_hfnmc, "uv",
     .         "uv ",
     .         "m2/s2",iim,jj_nb,nhori, nlevSTD3,1,nlevSTD3, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_hfnmc, "vq",
     .         "vq ",
     .         "m/s * (kg/kg)",iim,jj_nb,nhori, 
     .          nlevSTD3,1,nlevSTD3, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_hfnmc, "vT",
     .         "vT ", 
     .         "mK/s",iim,jj_nb,nhori, 
     .          nlevSTD3,1,nlevSTD3, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_hfnmc, "wq",
     .         "wq ", 
     .         "(Pa/s)*(kg/kg)",iim,jj_nb,nhori,
     .          nlevSTD3,1,nlevSTD3, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_hfnmc, "vphi",
     .         "vphi ", 
     .         "m2/s",iim,jj_nb,nhori, 
     .          nlevSTD3,1,nlevSTD3, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_hfnmc, "wT",
     .         "wT ", 
     .         "K*Pa/s",iim,jj_nb,nhori,
     .          nlevSTD3,1,nlevSTD3, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_hfnmc, "uxu",
     .         "u2 ", 
     .         "m2/s2",iim,jj_nb,nhori,
     .          nlevSTD3,1,nlevSTD3, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_hfnmc, "vxv",
     .         "v2 ", 
     .         "m2/s2",iim,jj_nb,nhori,
     .          nlevSTD3,1,nlevSTD3, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_hfnmc, "TxT",
     .         "T2 ", 
     .         "K2",iim,jj_nb,nhori,
     .          nlevSTD3,1,nlevSTD3, nvert, 32,
     .         "ave(X)", zout,zout)
c
         CALL histend(nid_hfnmc)
c
      ENDIF !(ok_histNMC(2)) THEN
c
c$OMP END MASTER
!
! $Header$
!
c$OMP MASTER
      IF (ok_histNMC(2)) THEN
c
       zstophy = dtime
       zstohf = ecrit_hf
       zstomth = ecrit_mth
       zout = freq_outNMC(2)
c
         idayref = day_ref
         CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)
c
cym         CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlon,zx_lon)
cym         DO i = 1, iim
cym            zx_lon(i,1) = rlon(i+1)
cym            zx_lon(i,jjmp1) = rlon(i+1)
cym         ENDDO
         DO ll=1,klev
            znivsig(ll)=float(ll)
         ENDDO
cym         CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlat,zx_lat)
cym         CALL histbeg("histNMC.nc", iim,zx_lon(:,1), jjmp1,zx_lat(1,:),
cym     .                 1,iim,1,jjmp1, itau_phy, zjulian, dtime, 
cym     .                 nhori, nid_daynmc)

         CALL histbeg_phy("histdayNMC",itau_phy, zjulian, dtime, 
     .                 nhori, nid_daynmc)
c
        IF(lev_histdayNMC.EQ.nlevSTD) THEN 
         CALL histvert(nid_daynmc, "plev", "pressure", "Pa",
     .                 nlevSTD, rlevSTD, nvert,"down")
        ELSE IF(lev_histdayNMC.EQ.nlevSTD8) THEN 
         CALL histvert(nid_daynmc, "plev", "pressure", "Pa",
     .                 nlevSTD8, rlevSTD8, nvert,"down")
        ENDIF
c
cIM Astuce MAF: remplacer inst par ave pour les variables NMC pour avoir
cIM             le time_counter et les bounds
c
ccc Champs 3D interpolles sur des niveaux de pression du NMC
ccc
c
c ATTENTION : pour AMIP2 on interpole t,u,v,wphi,q,rh
c             sur les niveaux du NMC et on somme & moyenne
c             toutes les freq_moyNMC secondes par des routines undefSTD et
c             moy_undefSTD pour eliminer les valeurs "undef"
c             de la moyenne mensuelle
c ======> le "inst(X)" ci-dessous est par consequence factice !
c
        IF(lev_histdayNMC.EQ.nlevSTD) THEN 
          CALL histdef(nid_daynmc, "tnondef",
     .                 "Valeurs non-definies","-",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_daynmc, "ta",
     .                 "Air temperature","K",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
         CALL histdef(nid_daynmc, "zg",
     .                "Geopotential height", "m",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_daynmc, "hus",
     .                 "Specific humidity","1",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
         CALL histdef(nid_daynmc, "hur",
     .                 "Relative humidity", "%",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_daynmc, "ua",
     .                 "Eastward wind","m s-1",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_daynmc, "va",
     .                 "Northward wind","m s-1",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_daynmc, "wap",
     .                 "Lagrangian tendency of air pressure","Pa s-1",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
        ELSE IF(lev_histdayNMC.EQ.nlevSTD8) THEN 
c
          CALL histdef(nid_daynmc, "tnondef",
     .                 "Valeurs non-definies","-",
     .                iim,jj_nb,nhori, nlevSTD8,1,nlevSTD8, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_daynmc, "ta",
     .                 "Air temperature","K",
     .                iim,jj_nb,nhori, nlevSTD8,1,nlevSTD8, nvert, 32,
     .                "ave(X)", zout,zout)
c
         CALL histdef(nid_daynmc, "zg",
     .                "Geopotential height", "m",
     .                iim,jj_nb,nhori, nlevSTD8,1,nlevSTD8, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_daynmc, "hus",
     .                 "Specific humidity","1",
     .                iim,jj_nb,nhori, nlevSTD8,1,nlevSTD8, nvert, 32,
     .                "ave(X)", zout,zout)
c
         CALL histdef(nid_daynmc, "hur",
     .                 "Relative humidity", "%",
     .                iim,jj_nb,nhori, nlevSTD8,1,nlevSTD8, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_daynmc, "ua",
     .                 "Eastward wind","m s-1",
     .                iim,jj_nb,nhori, nlevSTD8,1,nlevSTD8, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_daynmc, "va",
     .                 "Northward wind","m s-1",
     .                iim,jj_nb,nhori, nlevSTD8,1,nlevSTD8, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_daynmc, "wap",
     .                 "Lagrangian tendency of air pressure","Pa s-1",
     .                iim,jj_nb,nhori, nlevSTD8,1,nlevSTD8, nvert, 32,
     .                "ave(X)", zout,zout)
c
        ENDIF
c
         CALL histend(nid_daynmc)
c
      ENDIF !(ok_histNMC(2)) THEN
c$OMP END MASTER
!
! $Id: ini_histmthNMC.h 1403 2010-07-01 09:02:53Z fairhead $
!
c$OMP MASTER
c
      IF (ok_histNMC(1)) THEN
c
       zout = freq_outNMC(1)
c
       idayref = day_ref
       CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)
c
cym         CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlon,zx_lon)
cym         DO i = 1, iim
cym            zx_lon(i,1) = rlon(i+1)
cym            zx_lon(i,jjmp1) = rlon(i+1)
cym         ENDDO
         DO ll=1,klev
            znivsig(ll)=REAL(ll)
         ENDDO
cym         CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlat,zx_lat)
cym         CALL histbeg("histNMC.nc", iim,zx_lon(:,1), jjmp1,zx_lat(1,:),
cym     .                 1,iim,1,jjmp1, itau_phy, zjulian, dtime, 
cym     .                 nhori, nid_mthnmc)

         CALL histbeg_phy("histmthNMC",itau_phy, zjulian, dtime, 
     .                 nhori, nid_mthnmc)
c
         CALL histvert(nid_mthnmc, "plev", "pressure", "Pa",
     .                 nlevSTD, rlevSTD, nvert,"down")
c
cIM Astuce MAF: remplacer inst par ave pour les variables NMC pour avoir
cIM             le time_counter et les bounds
cIM 
ccc Champs 3D interpolles sur des niveaux de pression du NMC
ccc
c
c ATTENTION : pour AMIP2 on interpole t,u,v,wphi,q,rh
c             sur les niveaux du NMC et on somme & moyenne
c             toutes les freq_moyNMC secondes par des routines undefSTD et
c             moy_undefSTD pour eliminer les valeurs "undef"
c             de la moyenne mensuelle
c ======> le "inst(X)" ci-dessous est par consequence factice !
c
c
          CALL histdef(nid_mthnmc, "tnondef",
     .                 "Valeurs non-definies","-",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "ta",
     .                 "Air temperature","K",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
         CALL histdef(nid_mthnmc, "zg",
     .                "Geopotential height", "m",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "hus",
     .                 "Specific humidity","1",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
         CALL histdef(nid_mthnmc, "hur",
     .                 "Relative humidity", "%",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "ua",
     .                 "Eastward wind","m s-1",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "va",
     .                 "Northward wind","m s-1",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "wap",
     .                 "Lagrangian tendency of air pressure","Pa s-1",
     .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .                "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "psbg",
     .         "Pressure sfce below ground","%",
     .         iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "uv",
     .         "uv ",
     .         "m2/s2",iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "vq",
     .         "vq ",
     .         "m/s * (kg/kg)",iim,jj_nb,nhori, 
     .          nlevSTD,1,nlevSTD, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "vT",
     .         "vT ", 
     .         "mK/s",iim,jj_nb,nhori, 
     .          nlevSTD,1,nlevSTD, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "wq",
     .         "wq ", 
     .         "(Pa/s)*(kg/kg)",iim,jj_nb,nhori,
     .          nlevSTD,1,nlevSTD, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "vphi",
     .         "vphi ", 
     .         "m2/s",iim,jj_nb,nhori, 
     .          nlevSTD,1,nlevSTD, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "wT",
     .         "wT ", 
     .         "K*Pa/s",iim,jj_nb,nhori,
     .          nlevSTD,1,nlevSTD, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "uxu",
     .         "u2 ", 
     .         "m2/s2",iim,jj_nb,nhori,
     .          nlevSTD,1,nlevSTD, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "vxv",
     .         "v2 ", 
     .         "m2/s2",iim,jj_nb,nhori,
     .          nlevSTD,1,nlevSTD, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "TxT",
     .         "T2 ", 
     .         "K2",iim,jj_nb,nhori,
     .          nlevSTD,1,nlevSTD, nvert, 32,
     .         "ave(X)", zout,zout)
c
          CALL histdef(nid_mthnmc, "tro3",
     .         "Ozone mole fraction",
     .         "1e-9",iim,jj_nb,nhori,
     .          nlevSTD,1,nlevSTD, nvert, 32,
     .         "ave(X)", zout,zout)
c
          if (read_climoz == 2) THEN
           CALL histdef(nid_mthnmc, "tro3_daylight",
     .         "Daylight ozone mole fraction",
     .         "1e-9",iim,jj_nb,nhori,
     .          nlevSTD,1,nlevSTD, nvert, 32,
     .         "ave(X)", zout,zout)
          endif
c
         CALL histend(nid_mthnmc)
c
      ENDIF !(ok_histNMC(1)) THEN
c
c$OMP END MASTER

c
c $Id: ini_histday_seri.h 1403 2010-07-01 09:02:53Z fairhead $
c
cym Ne fonctionnera pas en mode parallele
      IF (is_sequential) THEN
      
      IF (type_run.EQ."AMIP") THEN
c
       zstophy = dtime
       zout = ecrit_day
c
         idayref = day_ref
         CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)
c
         CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlon,zx_lon)
         DO i = 1, iim
            zx_lon(i,1) = rlon(i+1)
            zx_lon(i,jjmp1) = rlon(i+1)
         ENDDO
         DO ll=1,klev
            znivsig(ll)=REAL(ll)
         ENDDO
         CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlat,zx_lat)
c
         imin_debut=1 
         nbpti=1
         jmin_debut=1 
         nbptj=1
c
         CALL histbeg("histday_seri.nc", 
     .                 iim,zx_lon(:,1), jjmp1,zx_lat(1,:),
     .                 imin_debut,nbpti,jmin_debut,nbptj,
     .                 itau_phy, zjulian, dtime,
     .                 nhori, nid_day_seri)
c
         CALL histvert(nid_day_seri, "presnivs", 
     .                "Vertical levels","mb",
     .                 klev, presnivs/100., nvert)
c
         CALL histdef(nid_day_seri, "bilTOA", 
     .                "Net radiation at model top", "W/m2",
     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
     .                "ave(X)", zstophy,zout)
c
         CALL histdef(nid_day_seri, "bils", 
     .                "Net downward energy flux at surface","W/m2",
     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
     .                "ave(X)", zstophy,zout)
c
         CALL histdef(nid_day_seri, "ecin", 
     .                "Total kinetic energy (per unit area)","J/m2",
     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
     .                "ave(X)", zstophy,zout)
c
cIM 151004 BEG
         IF(1.EQ.0) THEN
c
         CALL histdef(nid_day_seri, "momang", 
     .               "Total relative angular momentum (per unit area)",
     .               "kg/s",
     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
     .                "ave(X)", zstophy,zout)
c
         CALL histdef(nid_day_seri, "frictor", 
     .               "Friction torque (per unit area)", "N/m",
     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
     .                "ave(X)", zstophy,zout)
c
         CALL histdef(nid_day_seri, "mountor", 
     .               "Mountain torque (per unit area)", "N/m",
     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
     .                "ave(X)", zstophy,zout)
c
         ENDIF !(1.EQ.0) THEN
c
         CALL histdef(nid_day_seri, "momang", 
     .               "Axial angular momentum (per unit area)",
     .               "kg/s",
     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
     .                "ave(X)", zstophy,zout)
c
         CALL histdef(nid_day_seri, "torsfc", 
     .        "Total surface torque (including mountain torque)", "N/m",
     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
     .                "ave(X)", zstophy,zout)
c
cIM 151004 END        
c
         CALL histdef(nid_day_seri, "tamv", 
     .                "Temperature (mass-weighted vert. ave)", "K",
     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
     .                "ave(X)", zstophy,zout)
c
         CALL histdef(nid_day_seri, "psol", 
     .                "Surface pressure", "Pa",
     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
     .                "ave(X)", zstophy,zout)
c
         CALL histdef(nid_day_seri, "evap", 
     .                "Evaporation and sublimation (per unit area)", 
     .                "kg/(m2*s)",
     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
     .                "ave(X)", zstophy,zout)
c
c          call histdef(nid_day_seri, 
c    .         "SnowFrac", 
c    .         "Snow-covered area ", "%",  
c    .         iim,jjmp1,nhori, 1,1,1, -99, 32,
c    .         "ave(X)", zstophy,zout)
c
c        CALL histdef(nid_day_seri, "snow_depth", 
cIM 080904  .                "Snow Depth (water equivalent)", "m",
cIM 191104  .                "Snow Depth (water equivalent)", "kg/m2",
c    .                "Snow Mass", "kg/m2",
c    .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
c    .               "ave(X)", zstophy,zout)
c
           call histdef(nid_day_seri, 
     .         "tsol_"//clnsurf(is_oce), 
     .         "SST over open (ice-free) ocean ", "K",  
     .         iim,jjmp1,nhori, 1,1,1, -99, 32,
     .         "ave(X)", zstophy,zout)
c
c=================================================================
c
         CALL histend(nid_day_seri)
c
c=================================================================
      ENDIF ! fin de test sur type_run.EQ.AMIP
      
      ENDIF ! is_sequential

cIM    Implemente en modes sequentiel et parallele

       CALL gather(rlat,rlat_glo)
       CALL bcast(rlat_glo)
       CALL gather(rlon,rlon_glo)
       CALL bcast(rlon_glo)

c$OMP MASTER
      if (is_mpi_root) then
c
       zstophy = dtime
       zout = mth_len*un_jour
c
       idayref = day_ref
       CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)
c
       CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlon_glo,zx_lon)
       if (iim.gt.1) then
       DO i = 1, iim
         zx_lon(i,1) = rlon_glo(i+1)
         zx_lon(i,jjmp1) = rlon_glo(i+1)
       ENDDO
       endif
       CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlat_glo,zx_lat)
c
       CALL histbeg("paramLMDZ_phy.nc", 
     .                 np,zx_lon(np:np,1), np,zx_lat(1,np:np),
     .                 1,1,1,1,
     .                 itau_phy, zjulian, dtime,
     .                 nhori, nid_ctesGCM)
c
       CALL histdef(nid_ctesGCM, "R_ecc", 
     .                "Excentricite","-",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "R_peri", 
     .                "Equinoxe","-",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "R_incl", 
     .                "Inclinaison","deg",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "solaire", 
     .                "Constante solaire","W/m2",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "co2_ppm", 
     .                "Concentration du CO2", "ppm",
     .                1,1,nhori, 1,1,1, -99, 32, 
     .                "ave(X)", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "CH4_ppb", 
     .                "Concentration du CH4", "ppb",
     .                1,1,nhori, 1,1,1, -99, 32, 
     .                "ave(X)", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "N2O_ppb",
     .                "Concentration du N2O", "ppb",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave(X)", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "CFC11_ppt",
     .                "Concentration du CFC11", "ppt",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave(X)", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "CFC12_ppt",
     .                "Concentration du CFC12", "ppt",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave(X)", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "bils",
     .                "Surface total heat flux", "W m-2",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "evap",
     .                "Evaporation", "kg m-2 s-1",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "evap_land",
     .                "Land evaporation", "kg m-2 s-1",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "flat",
     .                "Latent heat flux", "W m-2",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "nettop0",
     .                "Clear sky net downward radiatif flux at TOA", 
     .                "W m-2",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "nettop",
     .                "Net downward radiatif flux at TOA", "W m-2",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "precip",
     .                "Total precipitation (liq+sol)", "kg m-2 s-1",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "tsol",
     .                "Surface temperature", "K",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "t2m",
     .                "Temperature at 2m", "K",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave", zstophy,zout)
c
       CALL histdef(nid_ctesGCM, "prw",
     .                "Precipitable water", "kg m-2",
     .                1,1,nhori, 1,1,1, -99, 32,
     .                "ave", zstophy,zout) 
c=================================================================
c
       CALL histend(nid_ctesGCM)
       
       endif !(is_mpi_root)
c$OMP END MASTER
c=================================================================

         ecrit_reg = ecrit_reg * un_jour
         ecrit_tra = ecrit_tra * un_jour

cXXXPB Positionner date0 pour initialisation de ORCHIDEE
      date0 = jD_ref 
      WRITE(*,*) 'physiq date0 : ',date0
c
c
c
c Prescrire l'ozone dans l'atmosphere
c
c
cc         DO i = 1, klon
cc         DO k = 1, klev
cc            CALL o3cm (paprs(i,k)/100.,paprs(i,k+1)/100., wo(i,k),20)
cc         ENDDO
cc         ENDDO
c
      IF (type_trac == 'inca') THEN
      END IF
c
c
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Nouvelle initialisation pour le rayonnement RRTM
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      call iniradia(klon,klev,paprs(1,1:klev+1))

C$omp single
      if (read_climoz >= 1) then
         call open_climoz(ncid_climoz, press_climoz)
      END IF
C$omp end single
c
cIM betaCRF
      pfree=70000. !Pa
      beta_pbl=1.
      beta_free=1.
      lon1_beta=-180.
      lon2_beta=+180.
      lat1_beta=90.
      lat2_beta=-90.
      mskocean_beta=.FALSE.

      OPEN(99,file='beta_crf.data',status='old',
     $          form='formatted',err=9999)
      READ(99,*,end=9998) pfree
      READ(99,*,end=9998) beta_pbl
      READ(99,*,end=9998) beta_free
      READ(99,*,end=9998) lon1_beta
      READ(99,*,end=9998) lon2_beta
      READ(99,*,end=9998) lat1_beta
      READ(99,*,end=9998) lat2_beta
      READ(99,*,end=9998) mskocean_beta
9998  Continue
      CLOSE(99)
9999  Continue
      WRITE(*,*)'pfree=',pfree
      WRITE(*,*)'beta_pbl=',beta_pbl
      WRITE(*,*)'beta_free=',beta_free
      WRITE(*,*)'lon1_beta=',lon1_beta
      WRITE(*,*)'lon2_beta=',lon2_beta
      WRITE(*,*)'lat1_beta=',lat1_beta
      WRITE(*,*)'lat2_beta=',lat2_beta
      WRITE(*,*)'mskocean_beta=',mskocean_beta
      ENDIF
!
!   ****************     Fin  de   IF ( debut  )   ***************
!
!
! Incrementer le compteur de la physique
!
      itap   = itap + 1
c
!
! Update fraction of the sub-surfaces (pctsrf) and 
! initialize, where a new fraction has appeared, all variables depending 
! on the surface fraction.
!
      CALL change_srf_frac(itap, dtime, days_elapsed+1, 
     *     pctsrf, falb1, falb2, ftsol, ustar, u10m, v10m, pbl_tke)


! Update time and other variables in Reprobus
      IF (type_trac == 'repr') THEN
      END IF


! Tendances bidons pour les processus qui n'affectent pas certaines
! variables.
      du0(:,:)=0.
      dv0(:,:)=0.
      dq0(:,:)=0.
      dql0(:,:)=0.
      dxt0(:,:,:)=0.
      dxtl0(:,:,:)=0.
c
c Mettre a zero des variables de sortie (pour securite)
c
      DO i = 1, klon
         d_ps(i) = 0.0
      ENDDO
      DO k = 1, klev
      DO i = 1, klon
         d_t(i,k) = 0.0
         d_u(i,k) = 0.0
         d_v(i,k) = 0.0
      ENDDO
      ENDDO
      DO iq = 1, nqtot
      DO k = 1, klev
      DO i = 1, klon
         d_qx(i,k,iq) = 0.0
        if (iq.le.2) then
        do ixt=1,ntraciso
          d_xtx(ixt,i,k,iq)=0.0
        enddo
        endif !if (iq.le.2) then
      ENDDO
      ENDDO
      ENDDO
      da(:,:)=0.
      mp(:,:)=0.
      phi(:,:,:)=0.
! RomP >>>
      phi2(:,:,:)=0.
      beta_prec_fisrt(:,:)=0.
      beta_prec(:,:)=0.
      epmlmMm(:,:,:)=0.
      eplaMm(:,:)=0.
      d1a(:,:)=0.
      dam(:,:)=0.
! RomP <<<
      
c
c Ne pas affecter les valeurs entrees de u, v, h, et q
c
      DO k = 1, klev
      DO i = 1, klon
         t_seri(i,k)  = t(i,k)
         u_seri(i,k)  = u(i,k)
         v_seri(i,k)  = v(i,k)
         q_seri(i,k)  = qx(i,k,ivap)
         ql_seri(i,k) = qx(i,k,iliq)
         qs_seri(i,k) = 0.
      ENDDO ! klon
      ENDDO !klev
      DO k = 1, klev
      DO i = 1, klon
         do ixt=1,ntraciso
            xt_seri(ixt,i,k)= xtx(ixt,i,k,ivap)
            xtl_seri(ixt,i,k) = xtx(ixt,i,k,iliq)
         enddo ! niso
      ENDDO ! klon
      ENDDO !klev   
      
      IF (nqtot.GE.3) THEN
      DO iq = 3, nqtot
      DO  k = 1, klev
      DO  i = 1, klon
         tr_seri(i,k,iq-2) = qx(i,k,iq)
      ENDDO
      ENDDO
      ENDDO
      ELSE
      DO k = 1, klev
      DO i = 1, klon
         tr_seri(i,k,1) = 0.0
      ENDDO
      ENDDO
      ENDIF
C
      DO i = 1, klon
        ztsol(i) = 0.
      ENDDO
      DO nsrf = 1, nbsrf
        DO i = 1, klon
          ztsol(i) = ztsol(i) + ftsol(i,nsrf)*pctsrf(i,nsrf)
        ENDDO
      ENDDO
cIM
      IF (ip_ebil_phy.ge.1) THEN 
        ztit='after dynamic'
        CALL diagetpq(airephy,ztit,ip_ebil_phy,1,1,dtime
     e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
     s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec
     :       , xt_seri,xtl_seri,d_xtw, d_xtl      
     :           )

       
C     Comme les tendances de la physique sont ajoute dans la dynamique,
C     on devrait avoir que la variation d'entalpie par la dynamique
C     est egale a la variation de la physique au pas de temps precedent.
C     Donc la somme de ces 2 variations devrait etre nulle.
        call diagphy(airephy,ztit,ip_ebil_phy
     e      , zero_v, zero_v, zero_v, zero_v, zero_v
     e      , zero_v, zero_v, zero_v, ztsol
     e      , d_h_vcol+d_h_vcol_phy, d_qt, 0.
     s      , fs_bound, fq_bound )
      END IF 

c Diagnostiquer la tendance dynamique
c
      IF (ancien_ok) THEN
         DO k = 1, klev
         DO i = 1, klon
            d_u_dyn(i,k) = (u_seri(i,k)-u_ancien(i,k))/dtime
            d_v_dyn(i,k) = (v_seri(i,k)-v_ancien(i,k))/dtime
            d_t_dyn(i,k) = (t_seri(i,k)-t_ancien(i,k))/dtime
            d_q_dyn(i,k) = (q_seri(i,k)-q_ancien(i,k))/dtime
         ENDDO
         ENDDO
!!! RomP >>>   td dyn traceur
       IF (nqtot.GE.3) THEN
          DO iq = 3, nqtot
          DO k = 1, klev
          DO i = 1, klon
            d_tr_dyn(i,k,iq-2)=
     $       (tr_seri(i,k,iq-2)-tr_ancien(i,k,iq-2))/dtime
!         iiq=niadv(iq)
!         print*,i,k," d_tr_dyn",d_tr_dyn(i,k,iq-2),"tra:",iq,tname(iiq)
          ENDDO
          ENDDO
          ENDDO
       ENDIF
!!! RomP <<<

         DO k = 1, klev
         DO i = 1, klon
            do ixt=1,ntraciso
              d_xt_dyn(ixt,i,k) = 
     :           (xt_seri(ixt,i,k)-xt_ancien(ixt,i,k))/dtime
            enddo ! do ixt=1,niso
         ENDDO
         ENDDO   

      ELSE !IF (ancien_ok) THEN

         DO k = 1, klev
         DO i = 1, klon
            d_u_dyn(i,k) = 0.0
            d_v_dyn(i,k) = 0.0
            d_t_dyn(i,k) = 0.0
            d_q_dyn(i,k) = 0.0
         ENDDO
         ENDDO
         DO k = 1, klev
          DO i = 1, klon
           do ixt=1,ntraciso
            d_xt_dyn(ixt,i,k)= 0.0
           enddo
          enddo
         enddo
!!! RomP >>>   td dyn traceur
        IF (nqtot.GE.3) THEN
          DO iq = 3, nqtot
          DO k = 1, klev
          DO i = 1, klon
            d_tr_dyn(i,k,iq-2)= 0.0
          ENDDO
          ENDDO
          ENDDO
       ENDIF
!!! RomP <<<
         
         ancien_ok = .TRUE.
      ENDIF !IF (ancien_ok) THEN
c
c Ajouter le geopotentiel du sol:
c
      DO k = 1, klev
      DO i = 1, klon
         zphi(i,k) = pphi(i,k) + pphis(i)
!         write(*,*) 'i,k', i, k
!         write(*,*) 'pphi, pphis', pphi(i,k), pphis(i)
!         write(*,*) 'zphi', zphi(i,k)
      ENDDO
      ENDDO
c
c Verifier les temperatures
c
cIM BEG
      IF (check) THEN
       amn=MIN(ftsol(1,is_ter),1000.)
       amx=MAX(ftsol(1,is_ter),-1000.)
       DO i=2, klon
        amn=MIN(ftsol(i,is_ter),amn)
        amx=MAX(ftsol(i,is_ter),amx)
       ENDDO
c
       PRINT*,' debut avant hgardfou min max ftsol',itap,amn,amx
      ENDIF !(check) THEN
cIM END
c
      CALL hgardfou(t_seri,ftsol,'debutphy')
c
cIM BEG
      IF (check) THEN
       amn=MIN(ftsol(1,is_ter),1000.)
       amx=MAX(ftsol(1,is_ter),-1000.)
       DO i=2, klon
        amn=MIN(ftsol(i,is_ter),amn)
        amx=MAX(ftsol(i,is_ter),amx)
       ENDDO
c
       PRINT*,' debut apres hgardfou min max ftsol',itap,amn,amx
      ENDIF !(check) THEN
cIM END
!#ifdef 1
!        if (calendrier_guide.eq.1) then
!            ! calendrier de 365 jour ou 366 jours si annÈe bissextile
!            julien = MOD(NINT(xjour*360.0/365.0),360)
!            if (julien .eq. 0) julien = 360
!            write(*,*) 'physiq 2065: calendrier_guide: xjour,julien=',
!     :           xjour,julien
!        endif      
!#endif    
c
c Mettre en action les conditions aux limites (albedo, sst, etc.).
c Prescrire l'ozone et calculer l'albedo sur l'ocean.
c
!         write(*,*) 'physiq 2360: klon=',klon
      if (read_climoz >= 1) then
C        Ozone from a file
!        Update required ozone index:
         ro3i = int((days_elapsed + jh_cur - jh_1jan)
     $        / ioget_year_len(year_cur) * 360.) + 1
         if (ro3i == 361) ro3i = 360
C        (This should never occur, except perhaps because of roundup
C        error. See documentation.)
         if (ro3i /= co3i) then
C           Update ozone field:
            if (read_climoz == 1) then
               call regr_pr_av(ncid_climoz, (/"tro3"/), julien=ro3i,
     $              press_in_edg=press_climoz, paprs=paprs, v3=wo)
            else
C              read_climoz == 2
               call regr_pr_av(ncid_climoz,
     $              (/"tro3         ", "tro3_daylight"/),
     $              julien=ro3i, press_in_edg=press_climoz, paprs=paprs,
     $              v3=wo)
            end if
!           Convert from mole fraction of ozone to column density of ozone in a
!           cell, in kDU:
            forall (l = 1: read_climoz) wo(:, :, l) = wo(:, :, l)
     $           * rmo3 / rmd * zmasse / dobson_u / 1e3
C           (By regridding ozone values for LMDZ only once every 360th of
C           year, we have already neglected the variation of pressure in one
C           360th of year. So do not recompute "wo" at each time step even if
C           "zmasse" changes a little.)
            co3i = ro3i
         end if
      elseif (MOD(itap-1,lmt_pas) == 0) THEN
C        Once per day, update ozone from Royer:
         wo(:, :, 1) = ozonecm(rlat, paprs, rjour=real(days_elapsed+1))
      ENDIF
c
c Re-evaporer l'eau liquide nuageuse
!#ifdef ISOVERIF      
!      write(*,*) 'physiq 1989: reevaporer l''eau nuageuse'
!#endif
        DO i = 1, klon
          rlat_out(i)=rlat(i)
        enddo
c
      DO k = 1, klev  ! re-evaporation de l'eau liquide nuageuse
      DO i = 1, klon
         zlvdcp=RLVTT/RCPD/(1.0+RVTMP2*q_seri(i,k))
c        zlsdcp=RLSTT/RCPD/(1.0+RVTMP2*q_seri(i,k))
         zlsdcp=RLVTT/RCPD/(1.0+RVTMP2*q_seri(i,k))
         zdelta = MAX(0.,SIGN(1.,RTT-t_seri(i,k)))
         zb = MAX(0.0,ql_seri(i,k))
         za = - MAX(0.0,ql_seri(i,k))
     .                  * (zlvdcp*(1.-zdelta)+zlsdcp*zdelta)
         t_seri(i,k) = t_seri(i,k) + za
         q_seri(i,k) = q_seri(i,k) + zb
         ql_seri(i,k) = 0.0
         d_t_eva(i,k) = za
         d_q_eva(i,k) = zb
      ENDDO
      ENDDO
cIM
!         write(*,*) 'physiq 2425'
      DO k = 1, klev  ! re-evaporation de l'eau liquide nuageuse
      DO i = 1, klon
         do ixt=1,ntraciso
            zbxt = MAX(0.0,xtl_seri(ixt,i,k))
            xt_seri(ixt,i,k) = xt_seri(ixt,i,k) + zbxt
            xtl_seri(ixt,i,k) = 0.0
            d_xt_eva(ixt,i,k) = zbxt
         enddo ! do ixt=1,niso
      ENDDO
      ENDDO   



      IF (ip_ebil_phy.ge.2) THEN 
        ztit='after reevap'
        CALL diagetpq(airephy,ztit,ip_ebil_phy,2,1,dtime
     e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
     s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec
     :       , xt_seri,xtl_seri,d_xtw, d_xtl      
     :           )
         call diagphy(airephy,ztit,ip_ebil_phy
     e      , zero_v, zero_v, zero_v, zero_v, zero_v
     e      , zero_v, zero_v, zero_v, ztsol
     e      , d_h_vcol, d_qt, d_ec
     s      , fs_bound, fq_bound )
C
      END IF 

c
c=========================================================================
! Calculs de l'orbite.
! Necessaires pour le rayonnement et la surface (calcul de l'albedo).
! doit donc etre plac\'e avant radlwsw et pbl_surface

!!!   jyg 17 Sep 2010 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      call ymds2ju(year_cur, mth_eq, day_eq,0., jD_eq)
      day_since_equinox = (jD_cur + jH_cur) - jD_eq
!
!   choix entre calcul de la longitude solaire vraie ou valeur fixee a 
!   solarlong0
      if (solarlong0<-999.) then
       if (new_orbit) then
! calcul selon la routine utilisee pour les planetes
        call solarlong(day_since_equinox, zlongi, dist)
       else
! calcul selon la routine utilisee pour l'AR4
        CALL orbite(REAL(days_elapsed+1),zlongi,dist)
       endif
      else
           zlongi=solarlong0  ! longitude solaire vraie
           dist=1.            ! distance au soleil / moyenne 
      endif
      if(prt_level.ge.1)                                                &
     &    write(lunout,*)'Longitude solaire ',zlongi,solarlong0,dist


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Calcul de l'ensoleillement :
! ============================
! Pour une solarlong0=1000., on calcule un ensoleillement moyen sur
! l'annee a partir d'une formule analytique.
! Cet ensoleillement est sym\'etrique autour de l'\'equateur et
! non nul aux poles.
      IF (abs(solarlong0-1000.)<1.e-4) then
         call zenang_an(cycle_diurne,jH_cur,rlat,rlon,rmu0,fract)
      ELSE
!  Avec ou sans cycle diurne
         IF (cycle_diurne) THEN
           zdtime=dtime*REAL(radpas) ! pas de temps du rayonnement (s)
           CALL zenang(zlongi,jH_cur,zdtime,rlat,rlon,rmu0,fract)
         ELSE
           CALL angle(zlongi, rlat, fract, rmu0)
         ENDIF
      ENDIF

      if (mydebug) then
        call writefield_phy('u_seri',u_seri,llm)
        call writefield_phy('v_seri',v_seri,llm)
        call writefield_phy('t_seri',t_seri,llm)
        call writefield_phy('q_seri',q_seri,llm)
      endif

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Appel au pbl_surface : Planetary Boudary Layer et Surface
c Cela implique tous les interactions des sous-surfaces et la partie diffusion 
c turbulent du couche limit. 
c 
c Certains varibales de sorties de pbl_surface sont utiliser que pour 
c ecriture des fihiers hist_XXXX.nc, ces sont :
c   qsol,      zq2m,      s_pblh,  s_lcl,
c   s_capCL,   s_oliqCL,  s_cteiCL,s_pblT,
c   s_therm,   s_trmb1,   s_trmb2, s_trmb3,
c   zxrugs,    zu10m,     zv10m,   fder,
c   zxqsurf,   rh2m,      zxfluxu, zxfluxv,
c   frugs,     agesno,    fsollw,  fsolsw,
c   d_ts,      fevap,     fluxlat, t2m,
c   wfbils,    wfbilo,    fluxt,   fluxu, fluxv,
c
c Certains ne sont pas utiliser du tout : 
c   dsens, devap, zxsnow, zxfluxt, zxfluxq, q2m, fluxq
c

c Calcul de l'humidite de saturation au niveau du sol



      if (iflag_pbl/=0) then

!      write(*,*) 'physiq tmp 2564: appel pbl_surface'
      CALL pbl_surface( 
     e     dtime,     date0,     itap,    days_elapsed+1,
     e     debut,     lafin,
     e     rlon,      rlat,      rugoro,  rmu0,     
     e     rain_fall, snow_fall, solsw,   sollw,    
     e     t_seri,    q_seri,    u_seri,  v_seri,   
     e     pplay,     paprs,     pctsrf,            
     +     ftsol,     falb1,     falb2,   ustar, u10m,   v10m,
     s     sollwdown, cdragh,    cdragm,  u1,    v1,
     s     albsol1,   albsol2,   sens,    evap,  
     s     zxtsol,    zxfluxlat, zt2m,    qsat2m, 
     s     d_t_vdf,   d_q_vdf,   d_u_vdf, d_v_vdf,
     s     coefh,     coefm,     slab_wfbils,                
     d     qsol,      zq2m,      s_pblh,  s_lcl,
     d     s_capCL,   s_oliqCL,  s_cteiCL,s_pblT,
     d     s_therm,   s_trmb1,   s_trmb2, s_trmb3,
     d     zxrugs,    zustar, zu10m,     zv10m,   fder,
     d     zxqsurf,   rh2m,      zxfluxu, zxfluxv,
     d     frugs,     agesno,    fsollw,  fsolsw,
     d     d_ts,      fevap,     fluxlat, t2m,
     d     wfbils,    wfbilo,    fluxt,   fluxu,  fluxv,
     -     dsens,     devap,     zxsnow,
     -     zxfluxt,   zxfluxq,   q2m,     fluxq, pbl_tke 
     :   ,xtrain_fall, xtsnow_fall,xt_seri,xtevap,fxtevap,
     :   d_xt_vdf,xtsol,dxtevap,zxxtsnow,zxfluxxt,fluxxt,
     :   h1_diag,runoff_diag,xtrunoff_diag
     :   )


!#ifdef ISOVERIF 
!#ifdef 1    

!-----------------------------------------------------------------------------------------
! ajout des tendances de la diffusion turbulente
      CALL add_phys_tend(d_u_vdf,d_v_vdf,d_t_vdf,
     :    d_q_vdf,dql0,'vdf'
     :    ,d_xt_vdf,dxtl0
     :   )
!-----------------------------------------------------------------------------------------

      if (mydebug) then
        call writefield_phy('u_seri',u_seri,llm)
        call writefield_phy('v_seri',v_seri,llm)
        call writefield_phy('t_seri',t_seri,llm)
        call writefield_phy('q_seri',q_seri,llm)
      endif


      ! verif



         CALL evappot(klon,nbsrf,ftsol,pplay(:,1),cdragh,
     e      t_seri(:,1),q_seri(:,1),u_seri(:,1),v_seri(:,1),evap_pot)


      IF (ip_ebil_phy.ge.2) THEN 
        ztit='after surface_main'
        CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime
     e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
     s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec
     :       , xt_seri,xtl_seri,d_xtw, d_xtl      
     :           )
         call diagphy(airephy,ztit,ip_ebil_phy
     e      , zero_v, zero_v, zero_v, zero_v, sens
     e      , evap  , zero_v, zero_v, ztsol
     e      , d_h_vcol, d_qt, d_ec
     s      , fs_bound, fq_bound )
      END IF 

      ENDIF
c =================================================================== c
c   Calcul de Qsat

      DO k = 1, klev
      DO i = 1, klon
         zx_t = t_seri(i,k)
         IF (thermcep) THEN
            zdelta = MAX(0.,SIGN(1.,rtt-zx_t))
            zx_qs  = r2es * FOEEW(zx_t,zdelta)/pplay(i,k)
            zx_qs  = MIN(0.5,zx_qs)
            zcor   = 1./(1.-retv*zx_qs)
            zx_qs  = zx_qs*zcor
         ELSE
           IF (zx_t.LT.t_coup) THEN
              zx_qs = qsats(zx_t)/pplay(i,k)
           ELSE
              zx_qs = qsatl(zx_t)/pplay(i,k)
           ENDIF
         ENDIF
         zqsat(i,k)=zx_qs
      ENDDO
      ENDDO

      if (prt_level.ge.1) then
      write(lunout,*) 'L   qsat (g/kg) avant clouds_gno'
      write(lunout,'(i4,f15.4)') (k,1000.*zqsat(igout,k),k=1,klev)
      endif
c
c Appeler la convection (au choix)
c
      DO k = 1, klev
      DO i = 1, klon
         conv_q(i,k) = d_q_dyn(i,k) 
     .               + d_q_vdf(i,k)/dtime
         conv_t(i,k) = d_t_dyn(i,k) 
     .               + d_t_vdf(i,k)/dtime
         ! ceci n'esy utile que pour convflx, qui n'est pas appelÈ
         ! quand iflag_conv.ge.3
      ENDDO
      ENDDO
      IF (check) THEN
         za = qcheck(klon,klev,paprs,q_seri,ql_seri,airephy)
         WRITE(lunout,*) "avantcon=", za
         do ixt=1,niso
          DO k = 1, klev
           DO i = 1, klon
             xt_iso(i,k)=xt_seri(ixt,i,k)
             xtl_iso(i,k)=xtl_seri(ixt,i,k)
           enddo
          enddo
          zxta(ixt)= qcheck(klon,klev,paprs,xt_iso,xtl_iso,airephy) 
          WRITE(lunout,*)"avantcon: ixt: ",ixt, zxta(ixt)
        enddo
      ENDIF
      zx_ajustq = .FALSE.
      IF (iflag_con.EQ.2) zx_ajustq=.TRUE.
      IF (zx_ajustq) THEN
         DO i = 1, klon
            z_avant(i) = 0.0
         ENDDO
         DO i = 1, klon
            do ixt=1,ntraciso
                zxt_avant(ixt,i) = 0.0
            enddo ! do ixt=1,niso
         ENDDO   
         
         DO k = 1, klev
         DO i = 1, klon
            z_avant(i) = z_avant(i) + (q_seri(i,k)+ql_seri(i,k))
     .                        *(paprs(i,k)-paprs(i,k+1))/RG
         ENDDO
         ENDDO
         DO k = 1, klev
         DO i = 1, klon
            do ixt=1,ntraciso
                zxt_avant(ixt,i) = zxt_avant(ixt,i)
     :                  + (xt_seri(ixt,i,k)+xtl_seri(ixt,i,k))
     .                  *(paprs(i,k)-paprs(i,k+1))/RG
            enddo ! do ixt=1,niso
         ENDDO
         ENDDO   
      ENDIF

        
c Calcule de vitesse verticale a partir de flux de masse verticale
      DO k = 1, klev
         DO i = 1, klon
            omega(i,k) = RG*flxmass_w(i,k) / airephy(i)
         END DO
      END DO
      if (prt_level.ge.1) write(lunout,*) 'omega(igout, :) = ',
     $     omega(igout, :)

      IF (iflag_con.EQ.1) THEN
        abort_message ='reactiver le call conlmd dans physiq.F'
        CALL abort_gcm (modname,abort_message,1)
c     CALL conlmd (dtime, paprs, pplay, t_seri, q_seri, conv_q,
c    .             d_t_con, d_q_con,
c    .             rain_con, snow_con, ibas_con, itop_con)
      ELSE IF (iflag_con.EQ.2) THEN
      write(*,*) 'physiq 2733: isotopes pas prÈvus ici'
      stop
      CALL conflx(dtime, paprs, pplay, t_seri, q_seri,
     e            conv_t, conv_q, -evap, omega,
     s            d_t_con, d_q_con, rain_con, snow_con,
     s            pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
     s            kcbot, kctop, kdtop, pmflxr, pmflxs)
      d_u_con = 0.
      d_v_con = 0.

      WHERE (rain_con < 0.) rain_con = 0.
      WHERE (snow_con < 0.) snow_con = 0.
      DO i = 1, klon
         ibas_con(i) = klev+1 - kcbot(i)
         itop_con(i) = klev+1 - kctop(i)
      ENDDO
      ELSE IF (iflag_con.GE.3) THEN
c nb of tracers for the KE convection:
c MAF la partie traceurs est faite dans phytrac
c on met ntra=1 pour limiter les appels mais on peut
c supprimer les calculs / ftra.
              ntra = 1

c=====================================================================================
cajout pour la parametrisation des poches froides: 
ccalcul de t_wake et t_undi: si pas de poches froides, t_wake=t_undi=t_seri 

              

      do k=1,klev
            do i=1,klon
             if (iflag_wake>=1) then
             t_wake(i,k) = t_seri(i,k)
     .           +(1-wake_s(i))*wake_deltat(i,k)
             q_wake(i,k) = q_seri(i,k)
     .           +(1-wake_s(i))*wake_deltaq(i,k)
             t_undi(i,k) = t_seri(i,k)
     .           -wake_s(i)*wake_deltat(i,k)
             q_undi(i,k) = q_seri(i,k)
     .           -wake_s(i)*wake_deltaq(i,k)
             do ixt=1,ntraciso
               xt_wake(ixt,i,k) = xt_seri(ixt,i,k)
     .           +(1-wake_s(i))*wake_deltaxt(ixt,i,k)
               xt_undi(ixt,i,k) = xt_seri(ixt,i,k)
     .           -wake_s(i)*wake_deltaxt(ixt,i,k)
             enddo !do ixt=1,ntraciso
             else !if (iflag_wake>=1) then
             t_wake(i,k) = t_seri(i,k)
             q_wake(i,k) = q_seri(i,k)
             t_undi(i,k) = t_seri(i,k)
             q_undi(i,k) = q_seri(i,k)
             do ixt=1,ntraciso
               xt_wake(ixt,i,k) =xt_seri(ixt,i,k)
               xt_undi(ixt,i,k) =xt_seri(ixt,i,k)
             enddo !do ixt=1,ntraciso
             endif !if (iflag_wake>=1) then
            enddo
         enddo



      if (iflag_wake>=1) then
          if (ok_bidouille_wake.eq.1) then
!      if (essai_convergence) then
!      else !if (essai_convergence) then
          ! on Èvite les q_undi nÈgatifs
          DO k=1,klev
           DO i=1,klon
            if (q_undi(i,k).lt.seuil_q_undi) then
                wake_deltaq_prec(i,k)=wake_deltaq(i,k)
                wake_deltaq(i,k)=(q_seri(i,k)-seuil_q_undi)/wake_s(i)
                q_undi(i,k) = q_seri(i,k)
     .                  -wake_s(i)*wake_deltaq(i,k)    
                q_wake(i,k) = q_seri(i,k)
     .                  +(1-wake_s(i))*wake_deltaq(i,k)
             do ixt=1,ntraciso
               wake_deltaxt(ixt,i,k)=wake_deltaq(i,k)
     :                   *wake_deltaxt(ixt,i,k)/wake_deltaq_prec(i,k)
               xt_wake(ixt,i,k) = xt_seri(ixt,i,k)
     .                  +(1-wake_s(i))*wake_deltaxt(ixt,i,k)
               xt_undi(ixt,i,k) = xt_seri(ixt,i,k)
     .                  -wake_s(i)*wake_deltaxt(ixt,i,k)
             enddo !do ixt=1,ntraciso
            endif !if (wake_deltaq(i,l).gt.q(i,l)/sigmaw(i)) then
           enddo !DO i=1,klon
          enddo !DO l=1,klev
        endif !if (ok_bidouille_wake.eq.1) then
!      endif !if (essai_convergence) then
      endif !if (iflag_wake>=1) then

      
cc--   Calcul de l'energie disponible ALE (J/kg) et de la puissance disponible ALP (W/m2)
cc--    pour le soulevement des particules dans le modele convectif
c
      do i = 1,klon
        ALE(i) = 0.
        ALP(i) = 0.
      enddo
c
ccalcul de ale_wake et alp_wake
       if (iflag_wake>=1) then
         if (itap .le. it_wape_prescr) then
          do i = 1,klon
           ale_wake(i) = wape_prescr
           alp_wake(i) = fip_prescr
          enddo
         else
          do i = 1,klon
cjyg  ALE=WAPE au lieu de ALE = 1/2 Cstar**2
ccc           ale_wake(i) = 0.5*wake_cstar(i)**2
           ale_wake(i) = wake_pe(i)
           alp_wake(i) = wake_fip(i)
          enddo
         endif
       else
         do i = 1,klon
           ale_wake(i) = 0.
           alp_wake(i) = 0.
         enddo
       endif
ccombinaison avec ale et alp de couche limite: constantes si pas de couplage, valeurs calculees
cdans le thermique sinon
       if (iflag_coupl.eq.0) then
          if (debut.and.prt_level.gt.9)
     $                     WRITE(lunout,*)'ALE et ALP imposes'
          do i = 1,klon
con ne couple que ale
c           ALE(i) = max(ale_wake(i),Ale_bl(i))
            ALE(i) = max(ale_wake(i),ale_bl_prescr)
con ne couple que alp
c           ALP(i) = alp_wake(i) + Alp_bl(i)
            ALP(i) = alp_wake(i) + alp_bl_prescr
          enddo
       else
         IF(prt_level>9)WRITE(lunout,*)'ALE et ALP couples au thermique'
!         do i = 1,klon
!             ALE(i) = max(ale_wake(i),Ale_bl(i))
! avant        ALP(i) = alp_wake(i) + Alp_bl(i)
!             ALP(i) = alp_wake(i) + Alp_bl(i) + alp_offset ! modif sb
!         write(20,*)'ALE',ALE(i),Ale_bl(i),ale_wake(i)
!         write(21,*)'ALP',ALP(i),Alp_bl(i),alp_wake(i)
!         enddo

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Modif FH 2010/04/27. Sans doute temporaire.
! Deux options pour le alp_offset : constant si >?? 0 ou proportionnel ??a
! w si <0
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       do i = 1,klon
          ALE(i) = max(ale_wake(i),Ale_bl(i))
ccc nrlmd le 10/04/2012----------Stochastic triggering--------------
          if (iflag_trig_bl.ge.1) then
             ALE(i) = max(ale_wake(i),Ale_bl_trig(i))
          endif
ccc fin nrlmd le 10/04/2012
          if (alp_offset>=0.) then
            ALP(i) = alp_wake(i) + Alp_bl(i) + alp_offset ! modif sb
          else
            ALP(i)=alp_wake(i)+Alp_bl(i)+alp_offset*min(omega(i,6),0.)
            if (alp(i)<0.) then
               print*,'ALP ',alp(i),alp_wake(i)
     s         ,Alp_bl(i),alp_offset*min(omega(i,6),0.)
            endif
          endif
       enddo
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

       endif
       do i=1,klon
          if (alp(i)>alp_max) then
             IF(prt_level>9)WRITE(lunout,*)                             &
     &       'WARNING SUPER ALP (seuil=',alp_max,
     ,       '): i, alp, alp_wake,ale',i,alp(i),alp_wake(i),ale(i)
             alp(i)=alp_max
          endif
          if (ale(i)>ale_max) then
             IF(prt_level>9)WRITE(lunout,*)                             &
     &       'WARNING SUPER ALE (seuil=',ale_max,
     ,       '): i, alp, alp_wake,ale',i,ale(i),ale_wake(i),alp(i)
             ale(i)=ale_max
          endif
       enddo

cfin calcul ale et alp
c=================================================================================================


c sb, oct02:
c Schema de convection modularise et vectorise:
c (driver commun aux versions 3 et 4)
c
          IF (ok_cvl) THEN ! new driver for convectL
!ISOVERIF         
          if ((bidouille_anti_divergence).and. 
     &           (use_iso_eau.eq.1)) then
           do k=1,klev
            do i=1,klon  
             xt_seri(iso_eau,i,k)= q_seri(i,k)
             xt_undi(iso_eau,i,k)= q_undi(i,k)
            enddo !do i=1,klon
           enddo !do k=1,klev
          endif !if ((bidouille_anti_divergence).and. &       
!1

             IF (type_trac == 'repr') THEN
                nbtr_tmp=ntra
             ELSE
                nbtr_tmp=nbtr
             END IF
          CALL concvl (iflag_con,iflag_clos,
     .        dtime,paprs,pplay,t_undi,q_undi,
     .        t_wake,q_wake,wake_s,
     .        u_seri,v_seri,tr_seri,nbtr_tmp,
     .        ALE,ALP,
     .        ema_work1,ema_work2,
     .        d_t_con,d_q_con,d_u_con,d_v_con,d_tr,
     .        rain_con, snow_con, ibas_con, itop_con, sigd,
     .        ema_cbmf,plcl,plfc,wbeff,upwd,dnwd,dnwd0,
     .        Ma,mip,Vprecip,cape,cin,tvp,Tconv,iflagctrl,
     .        pbase,bbase,dtvpdt1,dtvpdq1,dplcldt,dplcldr,qcondc,wd,
! RomP >>>
!!     .        pmflxr,pmflxs,da,phi,mp,
!!     .        ftd,fqd,lalim_conv,wght_th)
     .        pmflxr,pmflxs,da,phi,mp,phi2,d1a,dam,sij,clw,elij,
     .        ftd,fqd,lalim_conv,wght_th,
     .        ev, ep,epmlmMm,eplaMm,
     .        wdtrainA,wdtrainM
! RomP <<<
     :       ,xt_undi,xt_wake,d_xt_con,xtrain_con,xtsnow_con,fxtd
     :       ,xtVprecip  
     :        )


cIM begin
c       print*,'physiq: cin pbase dnwd0 ftd fqd ',cin(1),pbase(1),
c    .dnwd0(1,1),ftd(1,1),fqd(1,1)
cIM end
cIM cf. FH
              clwcon0=qcondc
              pmfu(:,:)=upwd(:,:)+dnwd(:,:)

              do i = 1, klon
                if (iflagctrl(i).le.1) itau_con(i)=itau_con(i)+1
              enddo

          ELSE ! ok_cvl

c MAF conema3 ne contient pas les traceurs
c SB: ni les isotopes de l'eau
          CALL conema3 (dtime,
     .        paprs,pplay,t_seri,q_seri,
     .        u_seri,v_seri,tr_seri,ntra,
     .        ema_work1,ema_work2,
     .        d_t_con,d_q_con,d_u_con,d_v_con,d_tr,
     .        rain_con, snow_con, ibas_con, itop_con,
     .        upwd,dnwd,dnwd0,bas,top,
     .        Ma,cape,tvp,rflag,
     .        pbase
     .        ,bbase,dtvpdt1,dtvpdq1,dplcldt,dplcldr
     .        ,clwcon0)

          ENDIF ! ok_cvl

c
c Correction precip
          rain_con = rain_con * cvl_corr
          snow_con = snow_con * cvl_corr
          xtrain_con = xtrain_con * cvl_corr
          xtsnow_con = xtsnow_con * cvl_corr
c

           IF (.NOT. ok_gust) THEN
           do i = 1, klon
            wd(i)=0.0
           enddo
           ENDIF

c =================================================================== c
c Calcul des proprietes des nuages convectifs
c

c   calcul des proprietes des nuages convectifs
             clwcon0(:,:)=fact_cldcon*clwcon0(:,:)
             call clouds_gno
     s       (klon,klev,q_seri,zqsat,clwcon0,ptconv,ratqsc,rnebcon0)

c =================================================================== c

          DO i = 1, klon
           itop_con(i) = min(max(itop_con(i),1),klev)
           ibas_con(i) = min(max(ibas_con(i),1),itop_con(i))
          ENDDO

          DO i = 1, klon
          ! camille: pour Èviter pb de dÈpassement d'indice dans les cas
          ! o˘ i n'est pas un point convectif et donc ibas_con(i)=0
          ! c'est un pb indÈpendant des isotopes
          if (ibas_con(i).gt.0) then
              ema_pcb(i)  = paprs(i,ibas_con(i))
          else ! if (ibas_con(i).gt.0) then
              ema_pcb(i)  = 0.0
          endif ! if (ibas_con(i).gt.0) then
          ENDDO !DO i = 1, klon
          DO i = 1, klon
! L'idicage de itop_con peut cacher un pb potentiel
! FH sous la dictee de JYG, CR
            ema_pct(i)  = paprs(i,itop_con(i)+1)

            if (itop_con(i).gt.klev-3) then
              if(prt_level >= 9) then
                write(lunout,*)'La convection monte trop haut '
                write(lunout,*)'itop_con(,',i,',)=',itop_con(i)
              endif
            endif
          ENDDO     
      ELSE IF (iflag_con.eq.0) THEN
          write(lunout,*) 'On n appelle pas la convection'
          clwcon0=0.
          rnebcon0=0.
          d_t_con=0.
          d_q_con=0.
          d_u_con=0.
          d_v_con=0.
          rain_con=0.
          snow_con=0.
          bas=1
          top=1
          d_xt_con=0.
      ELSE
          WRITE(lunout,*) "iflag_con non-prevu", iflag_con
          CALL abort
      ENDIF

c     CALL homogene(paprs, q_seri, d_q_con, u_seri,v_seri,
c    .              d_u_con, d_v_con)

!-----------------------------------------------------------------------------------------
! ajout des tendances de la diffusion turbulente
      CALL add_phys_tend(d_u_con,d_v_con,d_t_con,d_q_con,dql0,'con'
     :  ,d_xt_con,dxtl0
     :  )
      
!-----------------------------------------------------------------------------------------

      if (mydebug) then
        call writefield_phy('u_seri',u_seri,llm)
        call writefield_phy('v_seri',v_seri,llm)
        call writefield_phy('t_seri',t_seri,llm)
        call writefield_phy('q_seri',q_seri,llm)
      endif


! isoverif  
! iso  

      if (essai_convergence) then
      else !if (essai_convergence) then        
         ! isotrac
        DO k = 1, klev
          DO i = 1, klon
            q_seri(i,k)=max(0.0,q_seri(i,k))
            do ixt=1,ntraciso
               xt_seri(ixt,i,k)=max(xt_seri(ixt,i,k),0.0)
            enddo
         ENDDO !DO i = 1, klon
        ENDDO   !DO k = 1, klev 
         
      endif  !if (essai_convergence) then
       ! endif isoverif
! iso       
      ! isoverifidris
! iso   
! endif ISOTRAC 
! endif isotopes          

cIM
      IF (ip_ebil_phy.ge.2) THEN 
        ztit='after convect'
        CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime
     e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
     s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec
     :       , xt_seri,xtl_seri,d_xtw, d_xtl      
     :           )
         call diagphy(airephy,ztit,ip_ebil_phy
     e      , zero_v, zero_v, zero_v, zero_v, zero_v
     e      , zero_v, rain_con, snow_con, ztsol
     e      , d_h_vcol, d_qt, d_ec
     s      , fs_bound, fq_bound )
      END IF 
C
      IF (check) THEN
          za = qcheck(klon,klev,paprs,q_seri,ql_seri,airephy)
          WRITE(lunout,*)"aprescon=", za
         do ixt=1,ntraciso
          DO k = 1, klev
           DO i = 1, klon
             xt_iso(i,k)=xt_seri(ixt,i,k)
             xtl_iso(i,k)=xtl_seri(ixt,i,k)
           enddo
          enddo
          zxta(ixt)= qcheck(klon,klev,paprs,xt_iso,xtl_iso,airephy)
          WRITE(lunout,*)"aprescon: ixt: ",ixt, zxta(ixt) 
         enddo
          zx_t = 0.0
          za = 0.0
          DO i = 1, klon
            za = za + airephy(i)/REAL(klon)
            zx_t = zx_t + (rain_con(i)+
     .                   snow_con(i))*airephy(i)/REAL(klon)
          ENDDO
          zx_t = zx_t/za*dtime
          WRITE(lunout,*)"Precip=", zx_t
      ENDIF !IF (check) THEN
      IF (zx_ajustq) THEN
          DO i = 1, klon
            z_apres(i) = 0.0
          ENDDO
          zxt_apres = 0.0
          DO k = 1, klev
            DO i = 1, klon
              z_apres(i) = z_apres(i) + (q_seri(i,k)+ql_seri(i,k))
     .            *(paprs(i,k)-paprs(i,k+1))/RG
            ENDDO
          ENDDO
          DO k = 1, klev
            DO i = 1, klon
              do ixt=1,ntraciso
                zxt_apres(ixt,i) = zxt_apres(ixt,i) 
     :            + (xt_seri(ixt,i,k)+xtl_seri(ixt,i,k))
     .            *(paprs(i,k)-paprs(i,k+1))/RG
              enddo ! do ixt=1,niso
            ENDDO
          ENDDO  

          DO i = 1, klon
            z_factor(i) = (z_avant(i)-(rain_con(i)+snow_con(i))*dtime)
     .          /z_apres(i)
          ENDDO
         DO i = 1, klon
            do ixt=1,ntraciso
              zxt_factor(ixt,i) = (zxt_avant(ixt,i)-(xtrain_con(ixt,i)
     .          +xtsnow_con(ixt,i))*dtime)/zxt_apres(ixt,i)
            enddo ! do ixt=1,niso
         ENDDO   
         
          DO k = 1, klev
            DO i = 1, klon
              IF (z_factor(i).GT.(1.0+1.0E-08) .OR.
     .            z_factor(i).LT.(1.0-1.0E-08)) THEN
                  q_seri(i,k) = q_seri(i,k) * z_factor(i)
                do ixt=1,ntraciso
                  xt_seri(ixt,i,k)=xt_seri(ixt,i,k)*zxt_factor(ixt,i)  
                enddo ! do ixt=1,niso
              ENDIF
            ENDDO
          ENDDO
      ENDIF !IF (zx_ajustq) THEN
      zx_ajustq=.FALSE.


c
c=============================================================================
cRR:Evolution de la poche froide: on ne fait pas de separation wake/env 
cpour la couche limite diffuse pour l instant
c

!#ifdef ISOVERIF
!      i=231
!      k=3      
!      write(*,*) 'physiq tmp 3660: i,k,klon=',i,k,klon
!      if (i.le.klon) then
!      write(*,*) 'fxtd(:,i,k)=',fxtd(:,i,k)
!      write(*,*) 'd_xt_con(:,i,k)=',d_xt_con(:,i,k)
!      write(*,*) 'fqd(i,k)=',fqd(i,k)
!      write(*,*) 'd_q_con(i,k)=',d_q_con(i,k)
!      endif !if (i.le.klon) then
!#endif  
      if (iflag_wake>=1) then
      DO k=1,klev
        DO i=1,klon
          dt_dwn(i,k)  = ftd(i,k) 
          wdt_PBL(i,k) = 0.
          dq_dwn(i,k)  = fqd(i,k) 
          wdq_PBL(i,k) = 0.
          M_dwn(i,k)   = dnwd0(i,k)
          M_up(i,k)    = upwd(i,k)
          dt_a(i,k)    = d_t_con(i,k)/dtime - ftd(i,k) 
          udt_PBL(i,k) = 0.
          dq_a(i,k)    = d_q_con(i,k)/dtime - fqd(i,k)
          udq_PBL(i,k) = 0.
          do ixt=1,ntraciso
            dxt_dwn(ixt,i,k)  = fxtd(ixt,i,k)  
            wdxt_PBL(ixt,i,k) = 0.
            dxt_a(ixt,i,k)    = d_xt_con(ixt,i,k)/dtime - fxtd(ixt,i,k)
            udxt_PBL(ixt,i,k) = 0.
          enddo !do ixt=1,ntraciso
        ENDDO
      ENDDO


      if (iflag_wake==2) then
        ok_wk_lsp(:)=max(sign(1.,wake_s(:)-wake_s_min_lsp),0.)
        DO k = 1,klev
         dt_dwn(:,k)= dt_dwn(:,k)+
     :            ok_wk_lsp(:)*(d_t_eva(:,k)+d_t_lsc(:,k))/dtime
         dq_dwn(:,k)= dq_dwn(:,k)+
     :            ok_wk_lsp(:)*(d_q_eva(:,k)+d_q_lsc(:,k))/dtime
         do ixt=1,ntraciso
            dxt_dwn(ixt,:,k)= dxt_dwn(ixt,:,k)+
     :            ok_wk_lsp(:)*(d_xt_eva(ixt,:,k)+d_xt_lsc(ixt,:,k))
     :            /dtime  
         enddo !do ixt=1,ntraciso
        ENDDO
      endif
c
ccalcul caracteristiques de la poche froide
      call calWAKE (paprs,pplay,dtime
     :               ,t_seri,q_seri,omega
     :               ,dt_dwn,dq_dwn,M_dwn,M_up
     :               ,dt_a,dq_a,sigd
     :               ,wdt_PBL,wdq_PBL
     :               ,udt_PBL,udq_PBL
     o               ,wake_deltat,wake_deltaq,wake_dth
     o               ,wake_h,wake_s,wake_dens
     o               ,wake_pe,wake_fip,wake_gfl
     o               ,dt_wake,dq_wake
     o               ,wake_k, t_undi,q_undi
     o               ,wake_omgbdth,wake_dp_omgb
     o               ,wake_dtKE,wake_dqKE
     o               ,wake_dtPBL,wake_dqPBL
     o               ,wake_omg,wake_dp_deltomg
     o               ,wake_spread,wake_Cstar,wake_d_deltat_gw
     o               ,wake_ddeltat,wake_ddeltaq
     :               ,xt_seri,dxt_dwn,dxt_a,wdxt_PBL,udxt_PBL
     :               ,wake_deltaxt,dxt_wake,xt_undi
     :               ,wake_dxtKE,wake_dxtPBL
     :   )

c
!-----------------------------------------------------------------------------------------
! ajout des tendances des poches froides
! Faire rapidement disparaitre l'ancien dt_wake pour garder un d_t_wake
! coherent avec les autres d_t_...
      d_t_wake(:,:)=dt_wake(:,:)*dtime
      d_q_wake(:,:)=dq_wake(:,:)*dtime
      d_xt_wake(:,:,:)=dxt_wake(:,:,:)*dtime
      CALL add_phys_tend(du0,dv0,d_t_wake,d_q_wake,dql0,'wake'
     :               ,d_xt_wake,dxtl0
     :   )

        
!-----------------------------------------------------------------------------------------

      endif !if (iflag_wake.eq.1) then
c
c===================================================================
cJYG
      IF (ip_ebil_phy.ge.2) THEN 
        ztit='after wake'
        CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime
     e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
     s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec
     :       , xt_seri,xtl_seri,d_xtw, d_xtl      
     :           )
        call diagphy(airephy,ztit,ip_ebil_phy
     e      , zero_v, zero_v, zero_v, zero_v, zero_v
     e      , zero_v, zero_v, zero_v, ztsol
     e      , d_h_vcol, d_qt, d_ec
     s      , fs_bound, fq_bound )
      END IF !IF (ip_ebil_phy.ge.2) THEN 

c      print*,'apres callwake iflag_cldcon=', iflag_cldcon
c
c===================================================================
c Convection seche (thermiques ou ajustement)
c===================================================================
c
       call stratocu_if(klon,klev,pctsrf,paprs, pplay,t_seri
     s ,seuil_inversion,weak_inversion,dthmin)


      d_t_ajsb(:,:)=0.
      d_q_ajsb(:,:)=0.
      d_t_ajs(:,:)=0.
      d_u_ajs(:,:)=0.
      d_v_ajs(:,:)=0.
      d_q_ajs(:,:)=0.
      clwcon0th(:,:)=0.
      d_xt_ajs(:,:,:)=0.0
      d_xt_ajsb(:,:,:)=0.0
c
c      fm_therm(:,:)=0.
c      entr_therm(:,:)=0.
c      detr_therm(:,:)=0.
c
      IF(prt_level>9)WRITE(lunout,*)
     .    'AVANT LA CONVECTION SECHE , iflag_thermals='
     s   ,iflag_thermals,'   nsplit_thermals=',nsplit_thermals
      if(iflag_thermals.lt.0) then
c  Rien
c  ====
         IF(prt_level>9)WRITE(lunout,*)'pas de convection'


!#ifdef ISOVERIF         
       if ((use_iso_eau.eq.1).and.(bidouille_anti_divergence)) then
        do k=1,klev   
        do i=1,klon
            xt_seri(iso_eau,i,k)=q_seri(i,k)
        enddo !do i=1,klon
        enddo !do k=1,klev  
      endif !if ((use_iso_eau.eq.1).and.(bidouille_anti_divergence)) then  
!#ifdef 1      

      else ! if(iflag_thermals.lt.0) then  

c  Thermiques
c  ==========
         IF(prt_level>9)WRITE(lunout,*)'JUSTE AVANT , iflag_thermals='
     s   ,iflag_thermals,'   nsplit_thermals=',nsplit_thermals


ccc nrlmd le 10/04/2012
         DO k=1,klev+1
           DO i=1,klon
           pbl_tke_input(i,k,is_oce)=pbl_tke(i,k,is_oce)
           pbl_tke_input(i,k,is_ter)=pbl_tke(i,k,is_ter)
           pbl_tke_input(i,k,is_lic)=pbl_tke(i,k,is_lic)
           pbl_tke_input(i,k,is_sic)=pbl_tke(i,k,is_sic)
           ENDDO
         ENDDO
ccc fin nrlmd le 10/04/2012

         if (iflag_thermals>=1) then
         call calltherm(pdtphys
     s      ,pplay,paprs,pphi,weak_inversion
     s      ,u_seri,v_seri,t_seri,q_seri,zqsat,debut
     s      ,d_u_ajs,d_v_ajs,d_t_ajs,d_q_ajs
     s      ,fm_therm,entr_therm,detr_therm
     s      ,zqasc,clwcon0th,lmax_th,ratqscth
     s      ,ratqsdiff,zqsatth
con rajoute ale et alp, et les caracteristiques de la couche alim
     s      ,Ale_bl,Alp_bl,lalim_conv,wght_th, zmax0, f0, zw2,fraca
     s      ,ztv,zpspsk,ztla,zthl
ccc nrlmd le 10/04/2012
     e      ,pbl_tke_input,pctsrf,omega,airephy
     s      ,zlcl_th,fraca0,w0,w_conv,therm_tke_max0,env_tke_max0
     s      ,n2,s2,ale_bl_stat
     s      ,therm_tke_max,env_tke_max
     s      ,alp_bl_det,alp_bl_fluct_m,alp_bl_fluct_tke
     s      ,alp_bl_conv,alp_bl_stat
ccc fin nrlmd le 10/04/2012
     :      ,xt_seri,d_xt_ajs
     :   )


ccc nrlmd le 10/04/2012
c-----------Stochastic triggering-----------
      if (iflag_trig_bl.ge.1) then
c
        IF (prt_level .GE. 10) THEN
         print *,'cin, ale_bl_stat, alp_bl_stat ',
     $            cin, ale_bl_stat, alp_bl_stat
        ENDIF

c----Initialisations
      do i=1,klon
      proba_notrig(i)=1.
      random_notrig(i)=1e6*ale_bl_stat(i)-int(1e6*ale_bl_stat(i))
        if ( ale_bl_trig(i) .lt. abs(cin(i))+1.e-10 ) then 
        tau_trig(i)=tau_trig_shallow
        else
        tau_trig(i)=tau_trig_deep
        endif
      enddo
c
        IF (prt_level .GE. 10) THEN
         print *,'random_notrig, tau_trig ',
     $            random_notrig, tau_trig
          print *,'s_trig,s2,n2 ',
     $             s_trig,s2,n2
        ENDIF

c----Tirage al\'eatoire et calcul de ale_bl_trig
      do i=1,klon
        if ( (ale_bl_stat(i) .gt. abs(cin(i))+1.e-10) )  then
        proba_notrig(i)=(1.-exp(-s_trig/s2(i)))**
     $                  (n2(i)*dtime/tau_trig(i))
c        print *, 'proba_notrig(i) ',proba_notrig(i)
          if (random_notrig(i) .ge. proba_notrig(i)) then 
          ale_bl_trig(i)=ale_bl_stat(i)
          else
          ale_bl_trig(i)=0.
          endif
        else
        proba_notrig(i)=1.
        random_notrig(i)=0.
        ale_bl_trig(i)=0.
        endif
      enddo
c
        IF (prt_level .GE. 10) THEN
         print *,'proba_notrig, ale_bl_trig ',
     $            proba_notrig, ale_bl_trig
        ENDIF

      endif !(iflag_trig_bl)

c-----------Statistical closure-----------
      if (iflag_clos_bl.ge.1) then 

        do i=1,klon
        alp_bl(i)=alp_bl_stat(i)
        enddo

      else

      alp_bl_stat(:)=0.

      endif !(iflag_clos_bl)

        IF (prt_level .GE. 10) THEN
         print *,'ale_bl_trig, alp_bl_stat ',ale_bl_trig, alp_bl_stat
        ENDIF

ccc fin nrlmd le 10/04/2012

! ----------------------------------------------------------------------
! Transport de la TKE par les panaches thermiques.
! FH : 2010/02/01
!     if (iflag_pbl.eq.10) then
!     call thermcell_dtke(klon,klev,nbsrf,pdtphys,fm_therm,entr_therm,
!    s           rg,paprs,pbl_tke)
!     endif
! ----------------------------------------------------------------------
!IM/FH: 2011/02/23 
! Couplage Thermiques/Emanuel seulement si T<0
      if (iflag_coupl==2) then
        print*,'Couplage Thermiques/Emanuel seulement si T<0'
        do i=1,klon
           if (t_seri(i,lmax_th(i))>273.) then
              Ale_bl(i)=0.
           endif
        enddo
      endif

      do i=1,klon
         zmax_th(i)=pphi(i,lmax_th(i))/rg
      enddo

         endif


c  Ajustement sec
c  ==============

! Dans le cas o\`u on active les thermiques, on fait partir l'ajustement
! a partir du sommet des thermiques.
! Dans le cas contraire, on demarre au niveau 1.

         if (iflag_thermals.ge.13.or.iflag_thermals.eq.0) then

         if(iflag_thermals.eq.0) then
            IF(prt_level>9)WRITE(lunout,*)'ajsec'
            limbas(:)=1
         else
            limbas(:)=lmax_th(:)
         endif
  
! Attention : le call ajsec_convV2 n'est maintenu que momentanneement
! pour des test de convergence numerique.
! Le nouveau ajsec est a priori mieux, meme pour le cas 
! iflag_thermals = 0 (l'ancienne version peut faire des tendances
! non nulles numeriquement pour des mailles non concernees.

        !#ifdef ISOVERIF
        !#ifdef 1



         if (iflag_thermals.eq.0) then
            CALL ajsec_convV2(paprs, pplay, t_seri,q_seri
     s      , d_t_ajsb, d_q_ajsb
     :      ,xt_seri,d_xt_ajsb      
     :   )
         else
            CALL ajsec(paprs, pplay, t_seri,q_seri,limbas
     s      , d_t_ajsb, d_q_ajsb
     :      ,xt_seri,d_xt_ajsb      
     :   )
         endif

!-----------------------------------------------------------------------------------------
! ajout des tendances de l'ajustement sec ou des thermiques
      CALL add_phys_tend(du0,dv0,d_t_ajsb,d_q_ajsb,dql0,'ajsb'
     :      ,d_xt_ajsb,dxtl0
     :           )
         d_t_ajs(:,:)=d_t_ajs(:,:)+d_t_ajsb(:,:)
         d_q_ajs(:,:)=d_q_ajs(:,:)+d_q_ajsb(:,:)
         d_xt_ajs(:,:,:)=d_xt_ajs(:,:,:)+d_xt_ajsb(:,:,:)

!-----------------------------------------------------------------------------------------

         endif

      endif
c
c===================================================================
cIM
      IF (ip_ebil_phy.ge.2) THEN 
        ztit='after dry_adjust'
        CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime
     e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
     s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec
     :       , xt_seri,xtl_seri,d_xtw, d_xtl      
     :           )
        call diagphy(airephy,ztit,ip_ebil_phy
     e      , zero_v, zero_v, zero_v, zero_v, zero_v
     e      , zero_v, zero_v, zero_v, ztsol
     e      , d_h_vcol, d_qt, d_ec
     s      , fs_bound, fq_bound )
      END IF 


c-------------------------------------------------------------------------
! Computation of ratqs, the width (normalized) of the subrid scale 
! water distribution
      CALL  calcratqs(klon,klev,prt_level,lunout,       
     s     iflag_ratqs,iflag_con,iflag_cldcon,pdtphys, 
     s     ratqsbas,ratqshaut,tau_ratqs,fact_cldcon,  
     s     ptconv,ptconvth,clwcon0th, rnebcon0th,    
     s     paprs,pplay,q_seri,zqsat,fm_therm,
     s     ratqs,ratqsc)


      ! expÈrience de sensi ciblÈe ‡ ratqs
      if (modif_ratqs.eq.1) then
          ! x3 seulement dans extratropiques
       do k=1,klev
         do i=1, klon
           if (abs(rlat(i)).gt.30.0) then
                ratqs(i,k)=3.0*ratqs(i,k)
           endif
         enddo
       enddo
      endif


c
c Appeler le processus de condensation a grande echelle
c et le processus de precipitation
c-------------------------------------------------------------------------
      IF (prt_level .GE.10) THEN
       print *,' ->fisrtilp '
      ENDIF
c-------------------------------------------------------------------------
!ISOVERIF
          if ((bidouille_anti_divergence).and. 
     &           (use_iso_eau.eq.1)) then
           do k=1,klev
            do i=1,klon  
             xt_seri(iso_eau,i,k)= q_seri(i,k)
            enddo !do i=1,klon
           enddo !do k=1,klev
          endif !if ((bidouille_anti_divergence).and. &   
!1

      CALL fisrtilp(dtime,paprs,pplay,
     .           t_seri, q_seri,ptconv,ratqs,
     .           d_t_lsc, d_q_lsc, d_ql_lsc, rneb, cldliq,
     .           rain_lsc, snow_lsc,
     .           pfrac_impa, pfrac_nucl, pfrac_1nucl,
     .           frac_impa, frac_nucl, beta_prec_fisrt,
     .           prfl, psfl, rhcl, 
     .           zqasc, fraca,ztv,zpspsk,ztla,zthl,iflag_cldcon ,
     .           flag_ss, flagb_ss, rneb_ss, clsk_ss ! sursat marine
     :          ,xt_seri,xtrain_lsc,xtsnow_lsc
     :           ,d_xt_lsc,d_xtl_lsc,pxtrfl,pxtsfl
     :   )

      if (essai_convergence) then
      else !if (essai_convergence) then
        do k=1,klev
          do i=1,klon
             q_seri(i,k)=max(0.0,q_seri(i,k))
             do ixt=1,ntraciso
               xt_seri(ixt,i,k)=max(0.0,xt_seri(ixt,i,k))
             enddo
          enddo
        enddo
      endif !if (essai_convergence) then

      WHERE (rain_lsc < 0) rain_lsc = 0.
      WHERE (snow_lsc < 0) snow_lsc = 0.
      WHERE (xtrain_lsc < 0) xtrain_lsc = 0.
      WHERE (xtsnow_lsc < 0) xtsnow_lsc = 0.
!-----------------------------------------------------------------------------------------
! ajout des tendances de la diffusion turbulente
      CALL add_phys_tend(du0,dv0,d_t_lsc,d_q_lsc,d_ql_lsc,'lsc'
     :      ,d_xt_lsc,d_xtl_lsc  
     :    )
!-----------------------------------------------------------------------------------------

      DO k = 1, klev
      DO i = 1, klon
         cldfra(i,k) = rneb(i,k)
         IF (.NOT.new_oliq) cldliq(i,k) = ql_seri(i,k)
      ENDDO
      ENDDO

!#ifdef ISOVERIF
!      write(*,*) 'physiq 4030: verif apres ajout lsc'
!#endif      
!#ifdef ISOVERIF
!#ifdef ISOTRAC      
!#ifdef 1       
     
      IF (check) THEN
         za = qcheck(klon,klev,paprs,q_seri,ql_seri,airephy)
         WRITE(lunout,*)"apresilp=", za
         do ixt=1,ntraciso
          DO k = 1, klev
           DO i = 1, klon
             xt_iso(i,k)=xt_seri(ixt,i,k)
             xtl_iso(i,k)=xtl_seri(ixt,i,k)
           enddo
          enddo
          zxta(ixt)= qcheck(klon,klev,paprs,xt_iso,xtl_iso,airephy) 
          WRITE(lunout,*)"apresilp: ixt: ",ixt, zxta(ixt)
        enddo !do ixt=1,ntraciso

         zx_t = 0.0
         za = 0.0
         DO i = 1, klon
            za = za + airephy(i)/REAL(klon)
            zx_t = zx_t + (rain_lsc(i)
     .                  + snow_lsc(i))*airephy(i)/REAL(klon)
        ENDDO
         zx_t = zx_t/za*dtime
         WRITE(lunout,*)"Precip=", zx_t
      ENDIF
cIM
      IF (ip_ebil_phy.ge.2) THEN 
        ztit='after fisrt'
        CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime
     e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
     s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec
     :       , xt_seri,xtl_seri,d_xtw, d_xtl      
     :           )
        call diagphy(airephy,ztit,ip_ebil_phy
     e      , zero_v, zero_v, zero_v, zero_v, zero_v
     e      , zero_v, rain_lsc, snow_lsc, ztsol
     e      , d_h_vcol, d_qt, d_ec
     s      , fs_bound, fq_bound )
      END IF 

      if (mydebug) then
        call writefield_phy('u_seri',u_seri,llm)
        call writefield_phy('v_seri',v_seri,llm)
        call writefield_phy('t_seri',t_seri,llm)
        call writefield_phy('q_seri',q_seri,llm)
      endif

c
c-------------------------------------------------------------------
c  PRESCRIPTION DES NUAGES POUR LE RAYONNEMENT
c-------------------------------------------------------------------

c 1. NUAGES CONVECTIFS
c
cIM cf FH
c     IF (iflag_cldcon.eq.-1) THEN ! seulement pour Tiedtke
      IF (iflag_cldcon.le.-1) THEN ! seulement pour Tiedtke
       snow_tiedtke=0.
c     print*,'avant calcul de la pseudo precip '
c     print*,'iflag_cldcon',iflag_cldcon
       if (iflag_cldcon.eq.-1) then
          rain_tiedtke=rain_con
       else
c       print*,'calcul de la pseudo precip '
          rain_tiedtke=0.
c         print*,'calcul de la pseudo precip 0'
          do k=1,klev
          do i=1,klon
             if (d_q_con(i,k).lt.0.) then
                rain_tiedtke(i)=rain_tiedtke(i)-d_q_con(i,k)/pdtphys
     s         *(paprs(i,k)-paprs(i,k+1))/rg
             endif
          enddo
          enddo
       endif
c
c     call dump2d(iim,jjm,rain_tiedtke(2:klon-1),'PSEUDO PRECIP ')
c

c Nuages diagnostiques pour Tiedtke
      CALL diagcld1(paprs,pplay,
cIM cf FH  .             rain_con,snow_con,ibas_con,itop_con,
     .             rain_tiedtke,snow_tiedtke,ibas_con,itop_con,
     .             diafra,dialiq)
      DO k = 1, klev
      DO i = 1, klon
      IF (diafra(i,k).GT.cldfra(i,k)) THEN
         cldliq(i,k) = dialiq(i,k)
         cldfra(i,k) = diafra(i,k)
      ENDIF
      ENDDO
      ENDDO

      ELSE IF (iflag_cldcon.ge.3) THEN
c  On prend pour les nuages convectifs le max du calcul de la
c  convection et du calcul du pas de temps precedent diminue d'un facteur
c  facttemps
      facteur = pdtphys *facttemps
      do k=1,klev
         do i=1,klon
            rnebcon(i,k)=rnebcon(i,k)*facteur
            if (rnebcon0(i,k)*clwcon0(i,k).gt.rnebcon(i,k)*clwcon(i,k))
     s      then
                rnebcon(i,k)=rnebcon0(i,k)
                clwcon(i,k)=clwcon0(i,k)
            endif
         enddo
      enddo

c
cjq - introduce the aerosol direct and first indirect radiative forcings
cjq - Johannes Quaas, 27/11/2003 (quaas@lmd.jussieu.fr)
      IF (flag_aerosol .gt. 0) THEN
         IF (.NOT. aerosol_couple)
     &        CALL readaerosol_optic(
     &        debut, new_aod, flag_aerosol, itap, jD_cur-jD_ref,
     &        pdtphys, pplay, paprs, t_seri, rhcl, presnivs, 
     &        mass_solu_aero, mass_solu_aero_pi, 
     &        tau_aero, piz_aero, cg_aero, 
     &        tausum_aero, tau3d_aero)
      ELSE
         tausum_aero(:,:,:) = 0.
         tau_aero(:,:,:,:) = 0.
         piz_aero(:,:,:,:) = 0.
         cg_aero(:,:,:,:)  = 0.
      ENDIF

cIM calcul nuages par le simulateur ISCCP
c

c   On prend la somme des fractions nuageuses et des contenus en eau

      if (iflag_cldcon>=5) then

        do k=1,klev
         ptconvth(:,k)=fm_therm(:,k+1)>0.
        enddo

       if (iflag_coupl==4) then

! Dans le cas iflag_coupl==4, on prend la somme des convertures
! convectives et lsc dans la partie des thermiques
! Le controle par iflag_coupl est peut etre provisoire.
         do k=1,klev
            do i=1,klon
               if (ptconv(i,k).and.ptconvth(i,k)) then
                   cldliq(i,k)=cldliq(i,k)+rnebcon(i,k)*clwcon(i,k)
                   cldfra(i,k)=min(cldfra(i,k)+rnebcon(i,k),1.)
               else if (ptconv(i,k)) then
                   cldfra(i,k)=rnebcon(i,k)
                   cldliq(i,k)=rnebcon(i,k)*clwcon(i,k)
               endif
            enddo
         enddo

         else if (iflag_coupl==5) then
         do k=1,klev
            do i=1,klon
               cldfra(i,k)=min(cldfra(i,k)+rnebcon(i,k),1.)
               cldliq(i,k)=cldliq(i,k)+rnebcon(i,k)*clwcon(i,k)
            enddo
         enddo

         else

! Si on est sur un point touche par la convection profonde et pas
! par les thermiques, on prend la couverture nuageuse et l'eau nuageuse
! de la convection profonde.

!IM/FH: 2011/02/23 
! definition des points sur lesquels ls thermiques sont actifs

         do k=1,klev
            do i=1,klon
               if (ptconv(i,k).and. .not. ptconvth(i,k)) then
                   cldfra(i,k)=rnebcon(i,k)
                   cldliq(i,k)=rnebcon(i,k)*clwcon(i,k)
               endif
            enddo
         enddo

        endif

      else

! Ancienne version
      cldfra(:,:)=min(max(cldfra(:,:),rnebcon(:,:)),1.)
      cldliq(:,:)=cldliq(:,:)+rnebcon(:,:)*clwcon(:,:)
      endif

      ENDIF

!     plulsc(:)=0.
!     do k=1,klev,-1
!        do i=1,klon
!              zzz=prfl(:,k)+psfl(:,k)
!           if (.not.ptconvth.zzz.gt.0.)
!        enddo prfl, psfl,
!     enddo
c
c 2. NUAGES STARTIFORMES
c
      IF (ok_stratus) THEN
      CALL diagcld2(paprs,pplay,t_seri,q_seri, diafra,dialiq)
      DO k = 1, klev
      DO i = 1, klon
      IF (diafra(i,k).GT.cldfra(i,k)) THEN
         cldliq(i,k) = dialiq(i,k)
         cldfra(i,k) = diafra(i,k)
      ENDIF
      ENDDO
      ENDDO
      ENDIF
c
c Precipitation totale
c
      DO i = 1, klon
         rain_fall(i) = rain_con(i) + rain_lsc(i)
         snow_fall(i) = snow_con(i) + snow_lsc(i)
      ENDDO


      DO i = 1, klon
         do ixt=1,ntraciso
           xtrain_fall(ixt,i)=xtrain_con(ixt,i) + xtrain_lsc(ixt,i)
           xtsnow_fall(ixt,i)=xtsnow_con(ixt,i) + xtsnow_lsc(ixt,i)
         enddo
      ENDDO !DO i = 1, klon






        if ((use_iso_eau.eq.1).and.(bidouille_anti_divergence)) then
        do i=1,klon
            xtrain_fall(iso_eau,i)=rain_fall(i)
        enddo !do i=1,klon
        endif

cIM
      IF (ip_ebil_phy.ge.2) THEN 
        ztit="after diagcld"
        CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime
     e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
     s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec

     :       , xt_seri,xtl_seri,d_xtw, d_xtl      

     :           )
        call diagphy(airephy,ztit,ip_ebil_phy
     e      , zero_v, zero_v, zero_v, zero_v, zero_v
     e      , zero_v, zero_v, zero_v, ztsol
     e      , d_h_vcol, d_qt, d_ec
     s      , fs_bound, fq_bound )
      END IF 
c
c Calculer l'humidite relative pour diagnostique
c
      DO k = 1, klev
      DO i = 1, klon
         zx_t = t_seri(i,k)
         IF (thermcep) THEN
            zdelta = MAX(0.,SIGN(1.,rtt-zx_t))
            zx_qs  = r2es * FOEEW(zx_t,zdelta)/pplay(i,k)
            zx_qs  = MIN(0.5,zx_qs)
            zcor   = 1./(1.-retv*zx_qs)
            zx_qs  = zx_qs*zcor
         ELSE
           IF (zx_t.LT.t_coup) THEN
              zx_qs = qsats(zx_t)/pplay(i,k)
           ELSE
              zx_qs = qsatl(zx_t)/pplay(i,k)
           ENDIF
         ENDIF
         zx_rh(i,k) = q_seri(i,k)/zx_qs
         zqsat(i,k)=zx_qs
      ENDDO
      ENDDO

cIM Calcul temp.potentielle a 2m (tpot) et temp. potentielle 
c   equivalente a 2m (tpote) pour diagnostique
c
      DO i = 1, klon
       tpot(i)=zt2m(i)*(100000./paprs(i,1))**RKAPPA
       IF (thermcep) THEN
        IF(zt2m(i).LT.RTT) then
         Lheat=RLSTT
        ELSE
         Lheat=RLVTT
        ENDIF
       ELSE
        IF (zt2m(i).LT.RTT) THEN
         Lheat=RLSTT
        ELSE
         Lheat=RLVTT
        ENDIF
       ENDIF
       tpote(i) = tpot(i)*     
     . EXP((Lheat *qsat2m(i))/(RCPD*zt2m(i)))
      ENDDO

      IF (type_trac == 'inca') THEN
      END IF !type_trac = inca
c     
c Calculer les parametres optiques des nuages et quelques
c parametres pour diagnostiques:
c

      IF (aerosol_couple) THEN 
         mass_solu_aero(:,:)    = ccm(:,:,1) 
         mass_solu_aero_pi(:,:) = ccm(:,:,2) 
      END IF

      if (ok_newmicro) then
      CALL newmicro (ok_cdnc, bl95_b0, bl95_b1,
     .              paprs, pplay, t_seri, cldliq, cldfra,
     .              cldtau, cldemi, cldh, cldl, cldm, cldt, cldq,
     e              flwp, fiwp, flwc, fiwc,
     e              mass_solu_aero, mass_solu_aero_pi,
     s              cldtaupi, re, fl, ref_liq, ref_ice) 
      else
      CALL nuage (paprs, pplay,
     .            t_seri, cldliq, cldfra, cldtau, cldemi,
     .            cldh, cldl, cldm, cldt, cldq,
     e            ok_aie,
     e            mass_solu_aero, mass_solu_aero_pi,
     e            bl95_b0, bl95_b1,
     s            cldtaupi, re, fl)      
      endif
c
cIM betaCRF
c
      cldtaurad   = cldtau
      cldtaupirad = cldtaupi
      cldemirad   = cldemi

c
      if(lon1_beta.EQ.-180..AND.lon2_beta.EQ.180..AND.
     $lat1_beta.EQ.90..AND.lat2_beta.EQ.-90.) THEN
c
c global
c
       DO k=1, klev
       DO i=1, klon
        if (pplay(i,k).GE.pfree) THEN
         beta(i,k) = beta_pbl
        else
         beta(i,k) = beta_free
        endif
        if (mskocean_beta) THEN
         beta(i,k) = beta(i,k) * pctsrf(i,is_oce)
        endif
        cldtaurad(i,k)   = cldtau(i,k) * beta(i,k)
        cldtaupirad(i,k) = cldtaupi(i,k) * beta(i,k)
        cldemirad(i,k)   = cldemi(i,k) * beta(i,k)
        cldfrarad(i,k)   = cldfra(i,k) * beta(i,k)
        if (cldtaurad(i,k).lt.0.0) then
          write(*,*) 'physiq 4988: i,k,cldtaurad=',i,k,cldtaurad(i,k)
          stop
        endif
       ENDDO
       ENDDO 
c
      else
c
c regional
c
       DO k=1, klev
       DO i=1,klon
c
        if (rlon(i).ge.lon1_beta.AND.rlon(i).le.lon2_beta.AND.
     $      rlat(i).le.lat1_beta.AND.rlat(i).ge.lat2_beta) THEN
         if (pplay(i,k).GE.pfree) THEN
          beta(i,k) = beta_pbl
         else
          beta(i,k) = beta_free
         endif
         if (mskocean_beta) THEN
          beta(i,k) = beta(i,k) * pctsrf(i,is_oce)
         endif
        cldtaurad(i,k)   = cldtau(i,k) * beta(i,k)
        cldtaupirad(i,k) = cldtaupi(i,k) * beta(i,k)
        cldemirad(i,k)   = cldemi(i,k) * beta(i,k)
        cldfrarad(i,k)   = cldfra(i,k) * beta(i,k)
        endif
c
       ENDDO
       ENDDO
c
      endif
c
c Appeler le rayonnement mais calculer tout d'abord l'albedo du sol.
c
      IF (MOD(itaprad,radpas).EQ.0) THEN

      DO i = 1, klon
         albsol1(i) = falb1(i,is_oce) * pctsrf(i,is_oce)
     .             + falb1(i,is_lic) * pctsrf(i,is_lic)
     .             + falb1(i,is_ter) * pctsrf(i,is_ter)
     .             + falb1(i,is_sic) * pctsrf(i,is_sic)
         albsol2(i) = falb2(i,is_oce) * pctsrf(i,is_oce)
     .               + falb2(i,is_lic) * pctsrf(i,is_lic)
     .               + falb2(i,is_ter) * pctsrf(i,is_ter)
     .               + falb2(i,is_sic) * pctsrf(i,is_sic)
      ENDDO

      if (mydebug) then
        call writefield_phy('u_seri',u_seri,llm)
        call writefield_phy('v_seri',v_seri,llm)
        call writefield_phy('t_seri',t_seri,llm)
       call writefield_phy('q_seri',q_seri,llm)
      endif
      
      IF (aerosol_couple) THEN 
      ELSE
c
cIM calcul radiatif pour le cas actuel
c
       RCO2 = RCO2_act
       RCH4 = RCH4_act
       RN2O = RN2O_act
       RCFC11 = RCFC11_act
       RCFC12 = RCFC12_act
c
      IF (prt_level .GE.10) THEN
       print *,' ->radlwsw, number 1 '
      ENDIF
c
         CALL radlwsw
     e        (dist, rmu0, fract, 
     e        paprs, pplay,zxtsol,albsol1, albsol2, 
     e        t_seri,q_seri,wo,
     e        cldfrarad, cldemirad, cldtaurad,
     e        ok_ade, ok_aie, flag_aerosol,
     e        tau_aero, piz_aero, cg_aero,
     e        cldtaupirad,new_aod,
     e        zqsat, flwc, fiwc,
     s        heat,heat0,cool,cool0,radsol,albpla,
     s        topsw,toplw,solsw,sollw,
     s        sollwdown,
     s        topsw0,toplw0,solsw0,sollw0,
     s        lwdn0, lwdn, lwup0, lwup, 
     s        swdn0, swdn, swup0, swup,
     s        topswad_aero, solswad_aero,
     s        topswai_aero, solswai_aero,
     o        topswad0_aero, solswad0_aero,
     o        topsw_aero, topsw0_aero,
     o        solsw_aero, solsw0_aero,
     o        topswcf_aero, solswcf_aero)
         
c
cIM 2eme calcul radiatif pour le cas perturbe ou au moins un
cIM des taux doit etre different du taux actuel
cIM Par defaut on a les taux perturbes egaux aux taux actuels
c
      if (ok_4xCO2atm) then
       if (RCO2_per.NE.RCO2_act.OR.RCH4_per.NE.RCH4_act.OR.
     $RN2O_per.NE.RN2O_act.OR.RCFC11_per.NE.RCFC11_act.OR.
     $RCFC12_per.NE.RCFC12_act) THEN
c
       RCO2 = RCO2_per
       RCH4 = RCH4_per
       RN2O = RN2O_per
       RCFC11 = RCFC11_per
       RCFC12 = RCFC12_per
c
      IF (prt_level .GE.10) THEN
       print *,' ->radlwsw, number 2 '
      ENDIF
c
         CALL radlwsw
     e        (dist, rmu0, fract, 
     e        paprs, pplay,zxtsol,albsol1, albsol2, 
     e        t_seri,q_seri,wo,
     e        cldfra, cldemi, cldtau,
     e        ok_ade, ok_aie, flag_aerosol,
     e        tau_aero, piz_aero, cg_aero,
     e        cldtaupi,new_aod,
     e        zqsat, flwc, fiwc,
     s        heatp,heat0p,coolp,cool0p,radsolp,albplap,
     s        topswp,toplwp,solswp,sollwp,
     s        sollwdownp,
     s        topsw0p,toplw0p,solsw0p,sollw0p,
     s        lwdn0p, lwdnp, lwup0p, lwupp, 
     s        swdn0p, swdnp, swup0p, swupp,
     s        topswad_aerop, solswad_aerop,
     s        topswai_aerop, solswai_aerop,
     o        topswad0_aerop, solswad0_aerop,
     o        topsw_aerop, topsw0_aerop,
     o        solsw_aerop, solsw0_aerop,
     o        topswcf_aerop, solswcf_aerop)
       endif
      endif
c
      ENDIF ! aerosol_couple
      itaprad = 0
      ENDIF ! MOD(itaprad,radpas)
      itaprad = itaprad + 1

      IF (iflag_radia.eq.0) THEN
         IF (prt_level.ge.9) THEN
            PRINT *,'--------------------------------------------------'
            PRINT *,'>>>> ATTENTION rayonnement desactive pour ce cas'
            PRINT *,'>>>>           heat et cool mis a zero '
            PRINT *,'--------------------------------------------------'
         END IF
         heat=0.
         cool=0.
         sollw=0.   ! MPL 01032011
         solsw=0.
         radsol=0.
      END IF

c
c Ajouter la tendance des rayonnements (tous les pas)
c
      DO k = 1, klev
      DO i = 1, klon
         t_seri(i,k) = t_seri(i,k)
     .               + (heat(i,k)-cool(i,k)) * dtime/RDAY
      ENDDO
      ENDDO
c
      if (mydebug) then
        call writefield_phy('u_seri',u_seri,llm)
        call writefield_phy('v_seri',v_seri,llm)
        call writefield_phy('t_seri',t_seri,llm)
        call writefield_phy('q_seri',q_seri,llm)
      endif
 
cIM
      IF (ip_ebil_phy.ge.2) THEN 
        ztit='after rad'
        CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime
     e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
     s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec
     :       , xt_seri,xtl_seri,d_xtw, d_xtl      
     :           )
        call diagphy(airephy,ztit,ip_ebil_phy
     e      , topsw, toplw, solsw, sollw, zero_v
     e      , zero_v, zero_v, zero_v, ztsol
     e      , d_h_vcol, d_qt, d_ec
     s      , fs_bound, fq_bound )
      END IF 
c
c
c Calculer l'hydrologie de la surface
c
c      CALL hydrol(dtime,pctsrf,rain_fall, snow_fall, zxevap,
c     .            agesno, ftsol,fqsurf,fsnow, ruis)
c

c
c Calculer le bilan du sol et la derive de temperature (couplage)
c
      DO i = 1, klon
c         bils(i) = radsol(i) - sens(i) - evap(i)*RLVTT
c a la demande de JLD
         bils(i) = radsol(i) - sens(i) + zxfluxlat(i)
      ENDDO
c
cmoddeblott(jan95)
c Appeler le programme de parametrisation de l'orographie
c a l'echelle sous-maille:
c
      IF (prt_level .GE.10) THEN
       print *,' call orography ? ', ok_orodr
      ENDIF
c
      IF (ok_orodr) THEN
c
c  selection des points pour lesquels le shema est actif:
        igwd=0
        DO i=1,klon
        itest(i)=0
c        IF ((zstd(i).gt.10.0)) THEN
        IF (((zpic(i)-zmea(i)).GT.100.).AND.(zstd(i).GT.10.0)) THEN
          itest(i)=1
          igwd=igwd+1
          idx(igwd)=i
        ENDIF
        ENDDO
c        igwdim=MAX(1,igwd)
c
        IF (ok_strato) THEN
        
          CALL drag_noro_strato(klon,klev,dtime,paprs,pplay,
     e                   zmea,zstd, zsig, zgam, zthe,zpic,zval,
     e                   igwd,idx,itest,
     e                   t_seri, u_seri, v_seri,
     s                   zulow, zvlow, zustrdr, zvstrdr,
     s                   d_t_oro, d_u_oro, d_v_oro)

       ELSE
        CALL drag_noro(klon,klev,dtime,paprs,pplay,
     e                   zmea,zstd, zsig, zgam, zthe,zpic,zval,
     e                   igwd,idx,itest,
     e                   t_seri, u_seri, v_seri,
     s                   zulow, zvlow, zustrdr, zvstrdr,
     s                   d_t_oro, d_u_oro, d_v_oro)
       ENDIF
c
c  ajout des tendances
!-----------------------------------------------------------------------------------------
! ajout des tendances de la trainee de l'orographie
      CALL add_phys_tend(d_u_oro,d_v_oro,d_t_oro,dq0,dql0,'oro'
     :           ,dxt0,dxtl0
     :    )
!-----------------------------------------------------------------------------------------
c
      ENDIF ! fin de test sur ok_orodr
c
      if (mydebug) then
        call writefield_phy('u_seri',u_seri,llm)
        call writefield_phy('v_seri',v_seri,llm)
        call writefield_phy('t_seri',t_seri,llm)
        call writefield_phy('q_seri',q_seri,llm)
      endif
      
      IF (ok_orolf) THEN
c
c  selection des points pour lesquels le shema est actif:
        igwd=0
        DO i=1,klon
        itest(i)=0
        IF ((zpic(i)-zmea(i)).GT.100.) THEN
          itest(i)=1
          igwd=igwd+1
          idx(igwd)=i
        ENDIF
        ENDDO
c        igwdim=MAX(1,igwd)
c
        IF (ok_strato) THEN

          CALL lift_noro_strato(klon,klev,dtime,paprs,pplay,
     e                   rlat,zmea,zstd,zpic,zgam,zthe,zpic,zval,
     e                   igwd,idx,itest,
     e                   t_seri, u_seri, v_seri,
     s                   zulow, zvlow, zustrli, zvstrli,
     s                   d_t_lif, d_u_lif, d_v_lif               )
        
        ELSE
          CALL lift_noro(klon,klev,dtime,paprs,pplay,
     e                   rlat,zmea,zstd,zpic,
     e                   itest,
     e                   t_seri, u_seri, v_seri,
     s                   zulow, zvlow, zustrli, zvstrli,
     s                   d_t_lif, d_u_lif, d_v_lif)
       ENDIF
c   
!-----------------------------------------------------------------------------------------
! ajout des tendances de la portance de l'orographie
      CALL add_phys_tend(d_u_lif,d_v_lif,d_t_lif,dq0,dql0,'lif'
     :           ,dxt0,dxtl0
     :    )
!-----------------------------------------------------------------------------------------
c
      ENDIF ! fin de test sur ok_orolf
C  HINES GWD PARAMETRIZATION

       IF (ok_hines) then

         CALL hines_gwd(klon,klev,dtime,paprs,pplay,
     i                  rlat,t_seri,u_seri,v_seri,
     o                  zustrhi,zvstrhi,
     o                  d_t_hin, d_u_hin, d_v_hin)
c
c  ajout des tendances
        CALL add_phys_tend(d_u_hin,d_v_hin,d_t_hin,dq0,dql0,'hin'
     :           ,dxt0,dxtl0
     :    )

      ENDIF
c

c
cIM cf. FLott BEG
C STRESS NECESSAIRES: TOUTE LA PHYSIQUE

      if (mydebug) then
        call writefield_phy('u_seri',u_seri,llm)
        call writefield_phy('v_seri',v_seri,llm)
        call writefield_phy('t_seri',t_seri,llm)
	call writefield_phy('q_seri',q_seri,llm)
      endif

      DO i = 1, klon
        zustrph(i)=0.
        zvstrph(i)=0.
      ENDDO
      DO k = 1, klev
      DO i = 1, klon
       zustrph(i)=zustrph(i)+(u_seri(i,k)-u(i,k))/dtime*
     c            (paprs(i,k)-paprs(i,k+1))/rg
       zvstrph(i)=zvstrph(i)+(v_seri(i,k)-v(i,k))/dtime*
     c            (paprs(i,k)-paprs(i,k+1))/rg
      ENDDO
      ENDDO
c
cIM calcul composantes axiales du moment angulaire et couple des montagnes
c
      IF (is_sequential .and. ok_orodr) THEN 
        CALL aaam_bud (27,klon,klev,jD_cur-jD_ref,jH_cur,
     C                 ra,rg,romega,
     C                 rlat,rlon,pphis,
     C                 zustrdr,zustrli,zustrph,
     C                 zvstrdr,zvstrli,zvstrph,
     C                 paprs,u,v,
     C                 aam, torsfc)
       ENDIF
cIM cf. FLott END
cIM
      IF (ip_ebil_phy.ge.2) THEN 
        ztit='after orography'
        CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime
     e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
     s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec
     :       , xt_seri,xtl_seri,d_xtw, d_xtl      
     :           )
         call diagphy(airephy,ztit,ip_ebil_phy
     e      , zero_v, zero_v, zero_v, zero_v, zero_v
     e      , zero_v, zero_v, zero_v, ztsol
     e      , d_h_vcol, d_qt, d_ec
     s      , fs_bound, fq_bound )
      END IF 
c
c
!====================================================================
! Interface Simulateur COSP (Calipso, ISCCP, MISR, ..)
!====================================================================
! Abderrahmane 24.08.09

!          write(*,*) 'physiq 5377: ok_cosp=',ok_cosp
      IF (ok_cosp) THEN
! adeclarer 
       ENDIF  !ok_cosp
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

c====================================================================
c   Ajout de la production de tritium (naturelle et essais nucléaires)
c====================================================================
C
        call iso_tritium(iim,jjm,
     :           klon,klev,
     :           rlat,rlon,rlatd,rlond,
     :           paprs,pplay,
     :           zphi,dtime,
     :           airephy,
     :           d_xt_prod_nucl,
     :           d_xt_cosmo,
     :           d_xt_decroiss,
     :           xt_seri)


!      write(*,*)'itap=',itap
!      write(*,*)'itau_phy=',itau_phy
!      write(*,*)'jD_cur=',jD_cur


cAA
cAA Installation de l'interface online-offline pour traceurs
cAA
c====================================================================
c   Calcul  des tendances traceurs
c====================================================================
C

       IF (type_trac=='repr') THEN
          sh_in(:,:) = q_seri(:,:)
       ELSE
          sh_in(:,:) = qx(:,:,ivap)
       END IF


      IF (offline) THEN

       IF (prt_level.ge.9)
     $    print*,'Attention on met a 0 les thermiques pour phystoke'
	 call phystokenc (
     I                   nlon,klev,pdtphys,rlon,rlat,
     I                   t,pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
     I                   fm_therm,entr_therm,
     I                   cdragh,coefh,u1,v1,ftsol,pctsrf,
     I                   frac_impa, frac_nucl,
     I                   pphis,airephy,dtime,itap,
     I                   qx(:,:,ivap),da,phi,mp,upwd,dnwd)


      ENDIF

c
c Calculer le transport de l'eau et de l'energie (diagnostique)
c
      CALL transp (paprs,zxtsol,
     e                   t_seri, q_seri, u_seri, v_seri, zphi,
     s                   ve, vq, ue, uq)
c
cIM global posePB BEG
      IF(1.EQ.0) THEN
c
      CALL transp_lay (paprs,zxtsol,flxmass_w,
     e                   t_seri, q_seri, u_seri, v_seri, zphi,
     s                   ve_lay, vq_lay, ue_lay, uq_lay, wq_lay)
c
      ENDIF !(1.EQ.0) THEN
cIM global posePB END
c Accumuler les variables a stocker dans les fichiers histoire:
c
c+jld ec_conser
      DO k = 1, klev
      DO i = 1, klon
        ZRCPD = RCPD*(1.0+RVTMP2*q_seri(i,k))
        d_t_ec(i,k)=0.5/ZRCPD
     $      *(u(i,k)**2+v(i,k)**2-u_seri(i,k)**2-v_seri(i,k)**2)
      ENDDO
      ENDDO

      DO k = 1, klev
      DO i = 1, klon
        t_seri(i,k)=t_seri(i,k)+d_t_ec(i,k)
        d_t_ec(i,k) = d_t_ec(i,k)/dtime
       END DO 
      END DO 
c-jld ec_conser
cIM
      IF (ip_ebil_phy.ge.1) THEN 
        ztit='after physic'
        CALL diagetpq(airephy,ztit,ip_ebil_phy,1,1,dtime
     e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
     s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec
     :       , xt_seri,xtl_seri,d_xtw, d_xtl      
     :           )
C     Comme les tendances de la physique sont ajoute dans la dynamique,
C     on devrait avoir que la variation d'entalpie par la dynamique
C     est egale a la variation de la physique au pas de temps precedent.
C     Donc la somme de ces 2 variations devrait etre nulle.

        call diagphy(airephy,ztit,ip_ebil_phy
     e      , topsw, toplw, solsw, sollw, sens
     e      , evap, rain_fall, snow_fall, ztsol
     e      , d_h_vcol, d_qt, d_ec
     s      , fs_bound, fq_bound )
C
      d_h_vcol_phy=d_h_vcol
C
      END IF 
C
c=======================================================================
c   SORTIES
c=======================================================================

cIM Interpolation sur les niveaux de pression du NMC
c   -------------------------------------------------
c
c
c $Header$
c
cIM on initialise les variables 
c
        missing_val=nf90_fill_real
c
cIM freq_moyNMC = frequences auxquelles on moyenne les champs accumules 
cIM               sur les niveaux de pression standard du NMC
      DO n=1, nout
       freq_moyNMC(n)=freq_outNMC(n)/freq_calNMC(n)
      ENDDO
c
        CALL ini_undefSTD(itap,freq_outNMC)
c
cIM on interpole les champs sur les niveaux STD de pression 
cIM a chaque pas de temps de la physique
c
c-------------------------------------------------------c
c positionnement de l'argument logique a .false.        c
c pour ne pas recalculer deux fois la meme chose !      c
c a cet effet un appel a plevel_new a ete deplace       c
c a la fin de la serie d'appels                         c
c la boucle 'DO k=1, nlevSTD' a ete internalisee        c
c dans plevel_new, d'ou la creation de cette routine... c
c-------------------------------------------------------c
c
        CALL plevel_new(klon,klev,nlevSTD,.true.,pplay,rlevSTD,
     &              t_seri,tlevSTD)
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             u_seri,ulevSTD)
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             v_seri,vlevSTD)
c

c
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             zphi/RG,philevSTD)
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             qx(:,:,ivap),qlevSTD)
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             zx_rh*100.,rhlevSTD)
c
        DO l=1, klev
         DO i=1, klon
          zx_tmp_fi3d(i,l)=u_seri(i,l)*v_seri(i,l)
         ENDDO !i
        ENDDO !l
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             zx_tmp_fi3d,uvSTD)
c
        DO l=1, klev
         DO i=1, klon
          zx_tmp_fi3d(i,l)=v_seri(i,l)*q_seri(i,l)
         ENDDO !i
        ENDDO !l
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             zx_tmp_fi3d,vqSTD)
c
        DO l=1, klev
         DO i=1, klon
          zx_tmp_fi3d(i,l)=v_seri(i,l)*t_seri(i,l)
         ENDDO !i
        ENDDO !l
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             zx_tmp_fi3d,vTSTD)
c
        DO l=1, klev
         DO i=1, klon
          zx_tmp_fi3d(i,l)=omega(i,l)*qx(i,l,ivap)
         ENDDO !i 
        ENDDO !l
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             zx_tmp_fi3d,wqSTD)
c
        DO l=1, klev
         DO i=1, klon
          zx_tmp_fi3d(i,l)=v_seri(i,l)*zphi(i,l)/RG
         ENDDO !i
        ENDDO !l
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             zx_tmp_fi3d,vphiSTD)
c
        DO l=1, klev
         DO i=1, klon
          zx_tmp_fi3d(i,l)=omega(i,l)*t_seri(i,l)
         ENDDO !i
        ENDDO !l
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             zx_tmp_fi3d,wTSTD)
c
        DO l=1, klev
         DO i=1, klon
          zx_tmp_fi3d(i,l)=u_seri(i,l)*u_seri(i,l)
         ENDDO !i
        ENDDO !l
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             zx_tmp_fi3d,u2STD)
c
        DO l=1, klev
         DO i=1, klon
          zx_tmp_fi3d(i,l)=v_seri(i,l)*v_seri(i,l)
         ENDDO !i
        ENDDO !l
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             zx_tmp_fi3d,v2STD)
c
        DO l=1, klev
         DO i=1, klon
          zx_tmp_fi3d(i,l)=t_seri(i,l)*t_seri(i,l)
         ENDDO !i
        ENDDO !l
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             zx_tmp_fi3d,T2STD)

c
      zx_tmp_fi3d(:,:)=wo(:,:,1) * dobson_u * 1e3 / zmasse / rmo3 * rmd
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             zx_tmp_fi3d,O3STD)
c
      if (read_climoz == 2) THEN
      zx_tmp_fi3d(:,:)=wo(:,:,2) * dobson_u * 1e3 / zmasse / rmo3 * rmd
        CALL plevel_new(klon,klev,nlevSTD,.false.,pplay,rlevSTD,
     &             zx_tmp_fi3d,O3daySTD)
      endif
c
        DO l=1, klev
        DO i=1, klon
         zx_tmp_fi3d(i,l)=paprs(i,l)
        ENDDO !i
        ENDDO !l
        CALL plevel_new(klon,klev,nlevSTD,.true.,zx_tmp_fi3d,rlevSTD,
     &             omega,wlevSTD)
c
cIM on somme les valeurs toutes les freq_calNMC secondes
c
       CALL undefSTD(itap,freq_calNMC, read_climoz)
c
cIM on moyenne a la fin du mois ou du jour (toutes les freq_outNMC secondes)
c
       CALL moy_undefSTD(itap,freq_outNMC,freq_moyNMC)
c
       CALL plevel(klon,klev,.true.,pplay,50000.,
     &              zphi/RG,geo500)

cIM on interpole a chaque pas de temps le SWup(clr) et SWdn(clr) a 200 hPa
c
      CALL plevel(klon,klevp1,.true.,paprs,20000.,
     $     swdn0,SWdn200clr)
      CALL plevel(klon,klevp1,.false.,paprs,20000.,
     $     swdn,SWdn200)
      CALL plevel(klon,klevp1,.false.,paprs,20000.,
     $     swup0,SWup200clr)
      CALL plevel(klon,klevp1,.false.,paprs,20000.,
     $     swup,SWup200)
c
      CALL plevel(klon,klevp1,.false.,paprs,20000.,
     $     lwdn0,LWdn200clr)
      CALL plevel(klon,klevp1,.false.,paprs,20000.,
     $     lwdn,LWdn200)
      CALL plevel(klon,klevp1,.false.,paprs,20000.,
     $     lwup0,LWup200clr)
      CALL plevel(klon,klevp1,.false.,paprs,20000.,
     $     lwup,LWup200)
c
      twriteSTD(:,:,1)=tsumSTD(:,:,1)
      qwriteSTD(:,:,1)=qsumSTD(:,:,1)
      rhwriteSTD(:,:,1)=rhsumSTD(:,:,1)
      phiwriteSTD(:,:,1)=phisumSTD(:,:,1)
      uwriteSTD(:,:,1)=usumSTD(:,:,1)
      vwriteSTD(:,:,1)=vsumSTD(:,:,1)
      wwriteSTD(:,:,1)=wsumSTD(:,:,1)

      twriteSTD(:,:,2)=tsumSTD(:,:,2)
      qwriteSTD(:,:,2)=qsumSTD(:,:,2)
      rhwriteSTD(:,:,2)=rhsumSTD(:,:,2)
      phiwriteSTD(:,:,2)=phisumSTD(:,:,2)
      uwriteSTD(:,:,2)=usumSTD(:,:,2)
      vwriteSTD(:,:,2)=vsumSTD(:,:,2)
      wwriteSTD(:,:,2)=wsumSTD(:,:,2)

      twriteSTD(:,:,3)=tlevSTD(:,:)
      qwriteSTD(:,:,3)=qlevSTD(:,:)
      rhwriteSTD(:,:,3)=rhlevSTD(:,:)
      phiwriteSTD(:,:,3)=philevSTD(:,:)
      uwriteSTD(:,:,3)=ulevSTD(:,:)
      vwriteSTD(:,:,3)=vlevSTD(:,:)
      wwriteSTD(:,:,3)=wlevSTD(:,:)

      twriteSTD(:,:,4)=tlevSTD(:,:)
      qwriteSTD(:,:,4)=qlevSTD(:,:)
      rhwriteSTD(:,:,4)=rhlevSTD(:,:)
      phiwriteSTD(:,:,4)=philevSTD(:,:)
      uwriteSTD(:,:,4)=ulevSTD(:,:)
      vwriteSTD(:,:,4)=vlevSTD(:,:)
      wwriteSTD(:,:,4)=wlevSTD(:,:)
c
cIM initialisation 5eme fichier de sortie 
      twriteSTD(:,:,5)=tlevSTD(:,:)
      qwriteSTD(:,:,5)=qlevSTD(:,:)
      rhwriteSTD(:,:,5)=rhlevSTD(:,:)
      phiwriteSTD(:,:,5)=philevSTD(:,:)
      uwriteSTD(:,:,5)=ulevSTD(:,:)
      vwriteSTD(:,:,5)=vlevSTD(:,:)
      wwriteSTD(:,:,5)=wlevSTD(:,:)
c
cIM initialisation 6eme fichier de sortie 
      twriteSTD(:,:,6)=tlevSTD(:,:)
      qwriteSTD(:,:,6)=qlevSTD(:,:)
      rhwriteSTD(:,:,6)=rhlevSTD(:,:)
      phiwriteSTD(:,:,6)=philevSTD(:,:)
      uwriteSTD(:,:,6)=ulevSTD(:,:)
      vwriteSTD(:,:,6)=vlevSTD(:,:)
      wwriteSTD(:,:,6)=wlevSTD(:,:)
cIM for NMC files
      DO n=1, nlevSTD3
       DO k=1, nlevSTD
        if(rlevSTD3(n).EQ.rlevSTD(k)) THEN
         twriteSTD3(:,n)=tlevSTD(:,k)
         qwriteSTD3(:,n)=qlevSTD(:,k)
         rhwriteSTD3(:,n)=rhlevSTD(:,k)
         phiwriteSTD3(:,n)=philevSTD(:,k)
         uwriteSTD3(:,n)=ulevSTD(:,k)
         vwriteSTD3(:,n)=vlevSTD(:,k)
         wwriteSTD3(:,n)=wlevSTD(:,k)
        endif !rlevSTD3(n).EQ.rlevSTD(k)
       ENDDO 
      ENDDO 
c
      DO n=1, nlevSTD8
       DO k=1, nlevSTD
        if(rlevSTD8(n).EQ.rlevSTD(k)) THEN
         tnondefSTD8(:,n)=tnondef(:,k,2)
         twriteSTD8(:,n)=tsumSTD(:,k,2)
         qwriteSTD8(:,n)=qsumSTD(:,k,2)
         rhwriteSTD8(:,n)=rhsumSTD(:,k,2)
         phiwriteSTD8(:,n)=phisumSTD(:,k,2)
         uwriteSTD8(:,n)=usumSTD(:,k,2)
         vwriteSTD8(:,n)=vsumSTD(:,k,2)
         wwriteSTD8(:,n)=wsumSTD(:,k,2)
        endif !rlevSTD8(n).EQ.rlevSTD(k)
       ENDDO 
      ENDDO 
c
c slp sea level pressure
      slp(:) = paprs(:,1)*exp(pphis(:)/(RD*t_seri(:,1)))
c
ccc prw = eau precipitable
      DO i = 1, klon
       prw(i) = 0.
       DO k = 1, klev
        prw(i) = prw(i) +
     .           q_seri(i,k)*(paprs(i,k)-paprs(i,k+1))/RG
       ENDDO
      ENDDO
!#ifdef ISOVERIF
!      write(*,*) 'physiq 4868: calcul prw'      
!#endif      
      
      DO i = 1, klon
      do ixt=1,ntraciso
       xtprw(ixt,i) = 0. 
       DO k = 1, klev
        xtprw(ixt,i) = xtprw(ixt,i) +
     .           xt_seri(ixt,i,k)*(paprs(i,k)-paprs(i,k+1))/RG
       ENDDO !DO k = 1, klev
      enddo !do ixt=1,ntraciso
      enddo !DO i = 1, klon
c
cIM initialisation + calculs divers diag AMIP2
c
c
c $Header$
c

c     Initialisations diverses au "debut" du mois
      IF(debut) THEN
         nday_rain(:)=0.

c        surface terre
         paire_ter(:)=0.
         DO i=1, klon
            IF(pctsrf(i,is_ter).GT.0.) THEN
               paire_ter(i)=airephy(i)*pctsrf(i,is_ter)
            ENDIF 
         ENDDO
      ENDIF

cIM   Calcul une fois par jour : total_rain, nday_rain
      IF(MOD(itap,INT(un_jour/dtime)).EQ.0) THEN
         DO i = 1, klon
            total_rain(i)=rain_fall(i)+snow_fall(i)  
            IF(total_rain(i).GT.0.) nday_rain(i)=nday_rain(i)+1.
         ENDDO
      ENDIF
c
      IF (type_trac == 'inca') THEN
      END IF

c=============================================================
c
c Convertir les incrementations en tendances
c
      IF (prt_level .GE.10) THEN
        print *,'Convertir les incrementations en tendances '
      ENDIF
c
      if (mydebug) then
        call writefield_phy('u_seri',u_seri,llm)
        call writefield_phy('v_seri',v_seri,llm)
        call writefield_phy('t_seri',t_seri,llm)
        call writefield_phy('q_seri',q_seri,llm)
      endif

      DO k = 1, klev
      DO i = 1, klon
         d_u(i,k) = ( u_seri(i,k) - u(i,k) ) / dtime
         d_v(i,k) = ( v_seri(i,k) - v(i,k) ) / dtime
         d_t(i,k) = ( t_seri(i,k)-t(i,k) ) / dtime
         d_qx(i,k,ivap) = ( q_seri(i,k) - qx(i,k,ivap) ) / dtime
         d_qx(i,k,iliq) = ( ql_seri(i,k) - qx(i,k,iliq) ) / dtime
      ENDDO
      ENDDO
!ISOVERIF      
      DO k = 1, klev
      DO i = 1, klon   
         do ixt=1,ntraciso
              d_xtx(ixt,i,k,ivap) = ( xt_seri(ixt,i,k) 
     :                  - xtx(ixt,i,k,ivap) ) / dtime
              d_xtx(ixt,i,k,iliq) = ( xtl_seri(ixt,i,k) 
     :                  - xtx(ixt,i,k,iliq) ) / dtime
         enddo ! do ixt=1,niso
      ENDDO !DO i = 1, klon
      ENDDO !DO k = 1, klev  
      !ISOVERIF
      !1
c
      IF (nqtot.GE.3) THEN
      DO iq = 3, nqtot
      DO  k = 1, klev
      DO  i = 1, klon
         d_qx(i,k,iq) = ( tr_seri(i,k,iq-2) - qx(i,k,iq) ) / dtime
      ENDDO
      ENDDO
      ENDDO
      ENDIF
c
cIM rajout diagnostiques bilan KP pour analyse MJO par Jun-Ichi Yano
cIM global posePB#include "write_bilKP_ins.h"
cIM global posePB#include "write_bilKP_ave.h"
c

c Sauvegarder les valeurs de t et q a la fin de la physique:
c
      DO k = 1, klev
      DO i = 1, klon
         u_ancien(i,k) = u_seri(i,k)
         v_ancien(i,k) = v_seri(i,k)
         t_ancien(i,k) = t_seri(i,k)
         q_ancien(i,k) = q_seri(i,k)
      ENDDO
      ENDDO
      DO k = 1, klev
      DO i = 1, klon
         do ixt=1,ntraciso
            xt_ancien(ixt,i,k)=xt_seri(ixt,i,k)
         enddo
      ENDDO
      ENDDO  
!#ifdef ISOVERIF
!      write(*,*) 'physiq 5170: save q_ancien'
!#endif                   

!!! RomP >>>
      IF (nqtot.GE.3) THEN
        DO iq = 3, nqtot
        DO k = 1, klev
        DO i = 1, klon
           tr_ancien(i,k,iq-2) = tr_seri(i,k,iq-2)
        ENDDO
        ENDDO
        ENDDO
      ENDIF
!!! RomP <<<
!==========================================================================
! Sorties des tendances pour un point particulier
! a utiliser en 1D, avec igout=1 ou en 3D sur un point particulier
! pour le debug
! La valeur de igout est attribuee plus haut dans le programme
!==========================================================================

      if (prt_level.ge.1) then
      write(lunout,*) 'FIN DE PHYSIQ !!!!!!!!!!!!!!!!!!!!'
      write(lunout,*)
     s 'nlon,klev,nqtot,debut,lafin,jD_cur, jH_cur, pdtphys pct tlos'
      write(lunout,*)
     s  nlon,klev,nqtot,debut,lafin, jD_cur, jH_cur ,pdtphys,
     s  pctsrf(igout,is_ter), pctsrf(igout,is_lic),pctsrf(igout,is_oce),
     s  pctsrf(igout,is_sic)
      write(lunout,*) 'd_t_dyn,d_t_con,d_t_lsc,d_t_ajsb,d_t_ajs,d_t_eva'
      do k=1,klev
         write(lunout,*) d_t_dyn(igout,k),d_t_con(igout,k),
     s   d_t_lsc(igout,k),d_t_ajsb(igout,k),d_t_ajs(igout,k),
     s   d_t_eva(igout,k)
      enddo
      write(lunout,*) 'cool,heat'
      do k=1,klev
         write(lunout,*) cool(igout,k),heat(igout,k)
      enddo

      write(lunout,*) 'd_t_oli,d_t_vdf,d_t_oro,d_t_lif,d_t_ec'
      do k=1,klev
         write(lunout,*) d_t_oli(igout,k),d_t_vdf(igout,k),
     s d_t_oro(igout,k),d_t_lif(igout,k),d_t_ec(igout,k)
      enddo

      write(lunout,*) 'd_ps ',d_ps(igout)
      write(lunout,*) 'd_u, d_v, d_t, d_qx1, d_qx2 '
      do k=1,klev
         write(lunout,*) d_u(igout,k),d_v(igout,k),d_t(igout,k),
     s  d_qx(igout,k,1),d_qx(igout,k,2)
      enddo
      endif

!==========================================================================

c============================================================
c   Calcul de la temperature potentielle
c============================================================
      DO k = 1, klev
      DO i = 1, klon
cJYG/IM theta en debut du pas de temps
cJYG/IM       theta(i,k)=t(i,k)*(100000./pplay(i,k))**(RD/RCPD)
cJYG/IM theta en fin de pas de temps de physique
        theta(i,k)=t_seri(i,k)*(100000./pplay(i,k))**(RD/RCPD)
      ENDDO
      ENDDO
c

c 22.03.04 BEG
c=============================================================
c   Ecriture des sorties
c=============================================================
 
c Recupere des varibles calcule dans differents modules
c pour ecriture dans histxxx.nc 

      ! Get some variables from module fonte_neige_mod
      CALL fonte_neige_get_vars(pctsrf, 
     .     zxfqcalving, zxfqfonte, zxffonte
     :  ,zxfxtcalving, zxfxtfonte
     :   )



c=============================================================
! Separation entre thermiques et non thermiques dans les sorties
! de fisrtilp
c=============================================================

      if (iflag_thermals>=1) then
      d_t_lscth=0.
      d_t_lscst=0.
      d_q_lscth=0.
      d_q_lscst=0.
      do k=1,klev
         do i=1,klon
            if (ptconvth(i,k)) then
                d_t_lscth(i,k)=d_t_eva(i,k)+d_t_lsc(i,k)
                d_q_lscth(i,k)=d_q_eva(i,k)+d_q_lsc(i,k)
            else
                d_t_lscst(i,k)=d_t_eva(i,k)+d_t_lsc(i,k)
                d_q_lscst(i,k)=d_q_eva(i,k)+d_q_lsc(i,k)
            endif
         enddo
      enddo

      do i=1,klon
      plul_st(i)=prfl(i,lmax_th(i)+1)+psfl(i,lmax_th(i)+1)
      plul_th(i)=prfl(i,1)+psfl(i,1)
      enddo
      endif
        !DIAGISO

 
      itau_w = itau_phy + itap + start_time * day_step / iphysiq

      DO iff=1,nfiles

       IF (clef_files(iff)) THEN
             ndex2d = 0
             ndex3d = 0

!!! Champs 1D !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       IF (o_phis%flag(iff)<=lev_files(iff)) THEN 
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                  o_phis%name,itau_w,pphis)
       ENDIF

       IF (.NOT.clef_stations(iff)) THEN
       IF (o_aire%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_aire%name,itau_w,airephy)
       ENDIF

       IF (o_contfracATM%flag(iff)<=lev_files(iff)) THEN
      DO i=1, klon
       zx_tmp_fi2d(i)=pctsrf(i,is_ter)+pctsrf(i,is_lic)
      ENDDO
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $             o_contfracATM%name,itau_w,zx_tmp_fi2d)
       ENDIF
       ENDIF

       IF (o_contfracOR%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                  o_contfracOR%name,itau_w,pctsrf(:,is_ter))
       ENDIF

       IF (o_aireTER%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                  o_aireTER%name,itau_w,paire_ter)
       ENDIF

!!! Champs 2D !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

       IF (o_flat%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                  o_flat%name,itau_w,zxfluxlat)
       ENDIF

       IF (o_slp%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                  o_slp%name,itau_w,slp)
       ENDIF

       IF (o_tsol%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                  o_tsol%name,itau_w,zxtsol)
       ENDIF

       IF (o_t2m%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                  o_t2m%name,itau_w,zt2m)
       ENDIF

      IF (.NOT.clef_stations(iff)) THEN
       IF (o_t2m_min%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_t2m_min%name,itau_w,zt2m)
       ENDIF

       IF (o_t2m_max%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_t2m_max%name,itau_w,zt2m)
       ENDIF
       ENDIF

       IF (o_wind10m%flag(iff)<=lev_files(iff)) THEN
      DO i=1, klon
       zx_tmp_fi2d(i)=SQRT(zu10m(i)*zu10m(i)+zv10m(i)*zv10m(i))
      ENDDO
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                  o_wind10m%name,itau_w,zx_tmp_fi2d)
       ENDIF

      IF (.NOT.clef_stations(iff)) THEN
       IF (o_wind10max%flag(iff)<=lev_files(iff)) THEN
      DO i=1, klon
       zx_tmp_fi2d(i)=SQRT(zu10m(i)*zu10m(i)+zv10m(i)*zv10m(i))
      ENDDO
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_wind10max%name,itau_w,zx_tmp_fi2d)
       ENDIF
      ENDIF

       IF (o_sicf%flag(iff)<=lev_files(iff)) THEN
      DO i = 1, klon
         zx_tmp_fi2d(i) = pctsrf(i,is_sic)
      ENDDO
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                   o_sicf%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_q2m%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_q2m%name,itau_w,zq2m)
       ENDIF

       IF (o_ustar%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ustar%name,itau_w,zustar)
       ENDIF

       IF (o_u10m%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_u10m%name,itau_w,zu10m)
       ENDIF

       IF (o_v10m%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_v10m%name,itau_w,zv10m)
       ENDIF

       IF (o_psol%flag(iff)<=lev_files(iff)) THEN
      DO i = 1, klon
         zx_tmp_fi2d(i) = paprs(i,1)
      ENDDO
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                   o_psol%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_mass%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                   o_mass%name,itau_w,zmasse)
        ENDIF


       IF (o_qsurf%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_qsurf%name,itau_w,zxqsurf)
       ENDIF

       if (.not. ok_veget) then
         IF (o_qsol%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_qsol%name,itau_w,qsol)
         ENDIF
       endif

      IF (o_precip%flag(iff)<=lev_files(iff)) THEN
       DO i = 1, klon
         zx_tmp_fi2d(i) = rain_fall(i) + snow_fall(i)
       ENDDO
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_precip%name,itau_w,zx_tmp_fi2d)
      ENDIF

       IF (o_ndayrain%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ndayrain%name,itau_w,nday_rain)
       ENDIF

      IF (o_plul%flag(iff)<=lev_files(iff)) THEN
       DO i = 1, klon
         zx_tmp_fi2d(i) = rain_lsc(i) + snow_lsc(i)
       ENDDO
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_plul%name,itau_w,zx_tmp_fi2d)
      ENDIF

      IF (o_pluc%flag(iff)<=lev_files(iff)) THEN
      DO i = 1, klon
         zx_tmp_fi2d(i) = rain_con(i) + snow_con(i)
      ENDDO
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_pluc%name,itau_w,zx_tmp_fi2d)
      ENDIF

       IF (o_snow%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_snow%name,itau_w,snow_fall)
       ENDIF

       IF (o_msnow%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_msnow%name,itau_w,snow_o)
       ENDIF

       IF (o_fsnow%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_fsnow%name,itau_w,zfra_o)
       ENDIF

       IF (o_evap%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_evap%name,itau_w,evap)
       ENDIF

       IF (o_tops%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_tops%name,itau_w,topsw)
       ENDIF

       IF (o_tops0%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_tops0%name,itau_w,topsw0)
       ENDIF

       IF (o_topl%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_topl%name,itau_w,toplw)
       ENDIF

       IF (o_topl0%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_topl0%name,itau_w,toplw0)
       ENDIF

       IF (o_SWupTOA%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = swup ( 1 : klon, klevp1 )
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_SWupTOA%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_SWupTOAclr%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = swup0 ( 1 : klon, klevp1 )
      CALL histwrite_phy(nid_files(iff),clef_stations(iff), 
     $                  o_SWupTOAclr%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_SWdnTOA%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = swdn ( 1 : klon, klevp1 )
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                  o_SWdnTOA%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_SWdnTOAclr%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = swdn0 ( 1 : klon, klevp1 )
      CALL histwrite_phy(nid_files(iff),clef_stations(iff), 
     $                  o_SWdnTOAclr%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_nettop%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(:) = topsw(:)-toplw(:)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                  o_nettop%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_SWup200%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_SWup200%name,itau_w,SWup200)
       ENDIF

       IF (o_SWup200clr%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                   o_SWup200clr%name,itau_w,SWup200clr)
       ENDIF

       IF (o_SWdn200%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_SWdn200%name,itau_w,SWdn200)
       ENDIF

       IF (o_SWdn200clr%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                o_SWdn200clr%name,itau_w,SWdn200clr)
       ENDIF

       IF (o_LWup200%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_LWup200%name,itau_w,LWup200)
       ENDIF

       IF (o_LWup200clr%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                   o_LWup200clr%name,itau_w,LWup200clr)
       ENDIF

       IF (o_LWdn200%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                   o_LWdn200%name,itau_w,LWdn200)
       ENDIF

       IF (o_LWdn200clr%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                  o_LWdn200clr%name,itau_w,LWdn200clr)
       ENDIF

       IF (o_sols%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_sols%name,itau_w,solsw)
       ENDIF

       IF (o_sols0%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_sols0%name,itau_w,solsw0)
       ENDIF

       IF (o_soll%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_soll%name,itau_w,sollw)
       ENDIF

       IF (o_radsol%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_radsol%name,itau_w,radsol)
       ENDIF

       IF (o_soll0%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_soll0%name,itau_w,sollw0)
       ENDIF

       IF (o_SWupSFC%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = swup ( 1 : klon, 1 )
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s               o_SWupSFC%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_SWupSFCclr%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = swup0 ( 1 : klon, 1 )
      CALL histwrite_phy(nid_files(iff),clef_stations(iff), 
     $                   o_SWupSFCclr%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_SWdnSFC%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = swdn ( 1 : klon, 1 )
      CALL histwrite_phy(nid_files(iff),clef_stations(iff), 
     $                   o_SWdnSFC%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_SWdnSFCclr%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = swdn0 ( 1 : klon, 1 )
      CALL histwrite_phy(nid_files(iff),clef_stations(iff), 
     $                  o_SWdnSFCclr%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_LWupSFC%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1:klon)=sollwdown(1:klon)-sollw(1:klon)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                    o_LWupSFC%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_LWdnSFC%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                   o_LWdnSFC%name,itau_w,sollwdown)
       ENDIF

       sollwdownclr(1:klon) = -1.*lwdn0(1:klon,1)
       IF (o_LWupSFCclr%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1:klon)=sollwdownclr(1:klon)-sollw0(1:klon)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                   o_LWupSFCclr%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_LWdnSFCclr%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                   o_LWdnSFCclr%name,itau_w,sollwdownclr)
       ENDIF

       IF (o_bils%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_bils%name,itau_w,bils)
       ENDIF

       IF (o_sens%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1:klon)=-1*sens(1:klon)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_sens%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_fder%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_fder%name,itau_w,fder)
       ENDIF

       IF (o_ffonte%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ffonte%name,itau_w,zxffonte)
       ENDIF

       IF (o_fqcalving%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                    o_fqcalving%name,itau_w,zxfqcalving)
       ENDIF

       IF (o_fqfonte%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                   o_fqfonte%name,itau_w,zxfqfonte)
       ENDIF

       IF (o_taux%flag(iff)<=lev_files(iff)) THEN
         zx_tmp_fi2d=0.
         do nsrf=1,nbsrf
          zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+pctsrf(:,nsrf)*fluxu(:,1,nsrf)
         enddo
         CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                   o_taux%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_tauy%flag(iff)<=lev_files(iff)) THEN
         zx_tmp_fi2d=0.
         do nsrf=1,nbsrf
          zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+pctsrf(:,nsrf)*fluxv(:,1,nsrf)
         enddo
         CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                   o_tauy%name,itau_w,zx_tmp_fi2d)
       ENDIF

         DO nsrf = 1, nbsrf
!           IF(nsrf.GE.2) THEN
            IF (o_pourc_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
            zx_tmp_fi2d(1 : klon) = pctsrf( 1 : klon, nsrf)*100.
            CALL histwrite_phy(nid_files(iff),
     $                     clef_stations(iff),
     $                     o_pourc_srf(nsrf)%name,itau_w,
     $                     zx_tmp_fi2d)
            ENDIF

          IF (o_fract_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
          zx_tmp_fi2d(1 : klon) = pctsrf( 1 : klon, nsrf)
          CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                  o_fract_srf(nsrf)%name,itau_w,
     $                  zx_tmp_fi2d)
          ENDIF
!         ENDIF !nsrf.GT.2

        IF (o_taux_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
        zx_tmp_fi2d(1 : klon) = fluxu( 1 : klon, 1, nsrf)
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                     o_taux_srf(nsrf)%name,itau_w,
     $                     zx_tmp_fi2d)
        ENDIF

        IF (o_tauy_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN           
        zx_tmp_fi2d(1 : klon) = fluxv( 1 : klon, 1, nsrf)
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                    o_tauy_srf(nsrf)%name,itau_w,
     $                    zx_tmp_fi2d)
        ENDIF

        IF (o_tsol_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
        zx_tmp_fi2d(1 : klon) = ftsol( 1 : klon, nsrf)
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                   o_tsol_srf(nsrf)%name,itau_w,
     $      zx_tmp_fi2d)
        ENDIF

        IF (o_evappot_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
        zx_tmp_fi2d(1 : klon) = evap_pot( 1 : klon, nsrf)
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                   o_evappot_srf(nsrf)%name,itau_w,
     $      zx_tmp_fi2d)
        ENDIF

      IF (o_ustar_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = ustar(1 : klon, nsrf)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ustar_srf(nsrf)%name,
     $                 itau_w,zx_tmp_fi2d)
      ENDIF

      IF (o_u10m_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = u10m(1 : klon, nsrf)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_u10m_srf(nsrf)%name,
     $                 itau_w,zx_tmp_fi2d)
      ENDIF

      IF (o_v10m_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = v10m(1 : klon, nsrf)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_v10m_srf(nsrf)%name,
     $              itau_w,zx_tmp_fi2d)
      ENDIF
 
      IF (o_t2m_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = t2m(1 : klon, nsrf)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_t2m_srf(nsrf)%name,
     $           itau_w,zx_tmp_fi2d)
      ENDIF

      IF (o_evap_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = fevap(1 : klon, nsrf)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_evap_srf(nsrf)%name,
     $           itau_w,zx_tmp_fi2d)
      ENDIF

       IF (o_sens_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1 : klon) = fluxt( 1 : klon, 1, nsrf)
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                    o_sens_srf(nsrf)%name,itau_w,
     $      zx_tmp_fi2d)
       ENDIF

        IF (o_lat_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
        zx_tmp_fi2d(1 : klon) = fluxlat( 1 : klon, nsrf)
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                 o_lat_srf(nsrf)%name,itau_w,
     $                                   zx_tmp_fi2d)
          ENDIF

        IF (o_flw_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
        zx_tmp_fi2d(1 : klon) = fsollw( 1 : klon, nsrf)
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                     o_flw_srf(nsrf)%name,itau_w,
     $      zx_tmp_fi2d)
        ENDIF

        IF (o_fsw_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
        zx_tmp_fi2d(1 : klon) = fsolsw( 1 : klon, nsrf)
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                   o_fsw_srf(nsrf)%name,itau_w,
     $      zx_tmp_fi2d)
        ENDIF

        IF (o_wbils_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
        zx_tmp_fi2d(1 : klon) = wfbils( 1 : klon, nsrf)
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                   o_wbils_srf(nsrf)%name,itau_w,
     $      zx_tmp_fi2d)
        ENDIF

        IF (o_wbilo_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
        zx_tmp_fi2d(1 : klon) = wfbilo( 1 : klon, nsrf)
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                    o_wbilo_srf(nsrf)%name,itau_w,
     $      zx_tmp_fi2d)
        ENDIF

       if (iflag_pbl>1 .and. lev_files(iff).gt.10 ) then
        IF (o_tke_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                   o_tke_srf(nsrf)%name,itau_w,
     $                    pbl_tke(:,1:klev,nsrf))
       ENDIF

      IF (.NOT.clef_stations(iff)) THEN
        IF (o_tke_max_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                    o_tke_max_srf(nsrf)%name,itau_w,
     $      pbl_tke(:,1:klev,nsrf))
        ENDIF
      ENDIF
       endif
      ENDDO ! DO nsrf = 1, nbsrf

        IF (o_cdrm%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_cdrm%name,itau_w,cdragm)
        ENDIF

        IF (o_cdrh%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_cdrh%name,itau_w,cdragh)
        ENDIF

        IF (o_cldl%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_cldl%name,itau_w,cldl)
        ENDIF

        IF (o_cldm%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_cldm%name,itau_w,cldm)
        ENDIF

        IF (o_cldh%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_cldh%name,itau_w,cldh)
        ENDIF

        IF (o_cldt%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_cldt%name, 
     &                   itau_w,cldt)
        ENDIF

        IF (o_cldq%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_cldq%name,itau_w,cldq)
        ENDIF

        IF (o_lwp%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1:klon) = flwp(1:klon)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                   o_lwp%name,itau_w,zx_tmp_fi2d)
        ENDIF

        IF (o_iwp%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1:klon) = fiwp(1:klon)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                    o_iwp%name,itau_w,zx_tmp_fi2d)
        ENDIF

        IF (o_ue%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ue%name,itau_w,ue)
        ENDIF

        IF (o_ve%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ve%name,itau_w,ve)
        ENDIF

        IF (o_uq%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_uq%name,itau_w,uq)
        ENDIF

        IF (o_vq%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_vq%name,itau_w,vq)
        ENDIF

        IF (o_wq%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_wq%name,itau_w,wq_lay)
        ENDIF

        IF (o_flxmass_w%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_flxmass_w%name,itau_w,flxmass_w)
        ENDIF

      IF(iflag_con.GE.3) THEN ! sb
        IF (o_cape%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_cape%name,itau_w,cape)
        ENDIF

        IF (o_pbase%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_pbase%name,itau_w,ema_pcb)
        ENDIF

        IF (o_ptop%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ptop%name,itau_w,ema_pct)
        ENDIF

        IF (o_fbase%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_fbase%name,itau_w,ema_cbmf)
        ENDIF

        if (iflag_con /= 30) then
           if (o_plcl%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $             o_plcl%name,itau_w,plcl)
           ENDIF

	   ! plfc n'est pas initialise si iflag_clos!=2
	   ! il est alors NaN sur vargas et ca plante
	   IF (iflag_clos .eq. 2) THEN
           IF (o_plfc%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $             o_plfc%name,itau_w,plfc)
           ENDIF

           IF (o_wbeff%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $             o_wbeff%name,itau_w,wbeff)
           ENDIF
	   endif !IF (iflag_clos .eq. 2) THEN

        end if

      IF (.NOT.clef_stations(iff)) THEN
      IF (o_cape_max%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_cape_max%name,itau_w,cape)
      ENDIF
      ENDIF

       IF (o_upwd%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_upwd%name,itau_w,upwd)
       ENDIF

       IF (o_Ma%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_Ma%name,itau_w,Ma)
       ENDIF

       IF (o_dnwd%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dnwd%name,itau_w,dnwd)
       ENDIF

       IF (o_dnwd0%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dnwd0%name,itau_w,dnwd0)
       ENDIF

       IF (o_ftime_con%flag(iff)<=lev_files(iff)) THEN
        zx_tmp_fi2d=float(itau_con)/float(itap)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ftime_con%name,
     s                   itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_mc%flag(iff)<=lev_files(iff)) THEN
        if(iflag_thermals>=1)then
         zx_tmp_fi3d=dnwd+dnwd0+upwd+fm_therm(:,1:klev)
        else
         zx_tmp_fi3d=dnwd+dnwd0+upwd
        endif 
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_mc%name,itau_w,zx_tmp_fi3d)

       ENDIF
      
      ENDIF !iflag_con .GE. 3

        IF (o_prw%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_prw%name,itau_w,prw)
        ENDIF

        IF (o_s_pblh%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_s_pblh%name,itau_w,s_pblh)
        ENDIF

        IF (o_s_pblt%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_s_pblt%name,itau_w,s_pblt)
        ENDIF

        IF (o_s_lcl%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_s_lcl%name,itau_w,s_lcl)
        ENDIF

        IF (o_s_therm%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_s_therm%name,itau_w,s_therm)
        ENDIF

!IM : Les champs suivants (s_capCL, s_oliqCL, s_cteiCL, s_trmb1, s_trmb2, s_trmb3) ne sont pas definis dans HBTM.F
!       IF (o_s_capCL%flag(iff)<=lev_files(iff)) THEN
!     CALL histwrite_phy(nid_files(iff),clef_stations(iff),
!    $o_s_capCL%name,itau_w,s_capCL)
!       ENDIF

!       IF (o_s_oliqCL%flag(iff)<=lev_files(iff)) THEN
!     CALL histwrite_phy(nid_files(iff),clef_stations(iff),
!    $o_s_oliqCL%name,itau_w,s_oliqCL)
!       ENDIF

!       IF (o_s_cteiCL%flag(iff)<=lev_files(iff)) THEN
!     CALL histwrite_phy(nid_files(iff),clef_stations(iff),
!    $o_s_cteiCL%name,itau_w,s_cteiCL)
!       ENDIF

!       IF (o_s_trmb1%flag(iff)<=lev_files(iff)) THEN
!     CALL histwrite_phy(nid_files(iff),clef_stations(iff),
!    $o_s_trmb1%name,itau_w,s_trmb1)
!       ENDIF

!       IF (o_s_trmb2%flag(iff)<=lev_files(iff)) THEN
!     CALL histwrite_phy(nid_files(iff),clef_stations(iff),
!    $o_s_trmb2%name,itau_w,s_trmb2)
!       ENDIF

!       IF (o_s_trmb3%flag(iff)<=lev_files(iff)) THEN
!     CALL histwrite_phy(nid_files(iff),clef_stations(iff),
!    $o_s_trmb3%name,itau_w,s_trmb3)
!       ENDIF

! Champs interpolles sur des niveaux de pression

        ll=0
        DO k=1, nlevSTD
         bb2=clevSTD(k) 
         IF(bb2.EQ."850".OR.bb2.EQ."700".OR.
     $      bb2.EQ."500".OR.bb2.EQ."200".OR.
     $      bb2.EQ."100".OR.
     $      bb2.EQ."50".OR.bb2.EQ."10") THEN

! a refaire correctement !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          ll=ll+1
       IF (o_uSTDlevs(ll)%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_uSTDlevs(ll)%name,
     &                    itau_w,uwriteSTD(:,k,iff))
       ENDIF

       IF (o_vSTDlevs(ll)%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_vSTDlevs(ll)%name,  
     &                   itau_w,vwriteSTD(:,k,iff))
       ENDIF

       IF (o_wSTDlevs(ll)%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_wSTDlevs(ll)%name,
     &                    itau_w,wwriteSTD(:,k,iff))
       ENDIF

       IF (o_zSTDlevs(ll)%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_zSTDlevs(ll)%name,
     &               itau_w,phiwriteSTD(:,k,iff))
       ENDIF

       IF (o_qSTDlevs(ll)%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_qSTDlevs(ll)%name,
     &                   itau_w, qwriteSTD(:,k,iff))
       ENDIF

       IF (o_tSTDlevs(ll)%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_tSTDlevs(ll)%name,
     &                   itau_w, twriteSTD(:,k,iff))
       ENDIF

       ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR.
       ENDDO

      IF (o_t_oce_sic%flag(iff)<=lev_files(iff)) THEN
      DO i=1, klon
       IF (pctsrf(i,is_oce).GT.epsfra.OR.
     $     pctsrf(i,is_sic).GT.epsfra) THEN
        zx_tmp_fi2d(i) = (ftsol(i, is_oce) * pctsrf(i,is_oce)+
     $                   ftsol(i, is_sic) * pctsrf(i,is_sic))/
     $                   (pctsrf(i,is_oce)+pctsrf(i,is_sic))
       ELSE
        zx_tmp_fi2d(i) = 273.15
       ENDIF
      ENDDO
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                   o_t_oce_sic%name,itau_w,zx_tmp_fi2d)
      ENDIF

! Couplage convection-couche limite
      IF (iflag_con.GE.3) THEN
      IF (iflag_coupl>=1) THEN
       IF (o_ale_bl%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ale_bl%name,itau_w,ale_bl)
       ENDIF
       IF (o_alp_bl%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_alp_bl%name,itau_w,alp_bl)
       ENDIF
      ENDIF !iflag_coupl>=1
      ENDIF !(iflag_con.GE.3)

! Wakes
!#ifdef ISOVERIFIDRIS
!	write(*,*) 'phys_output_write 838: iflag_con,iflag_wake=',
!     &		iflag_con,iflag_wake
!#endif
      IF (iflag_con.EQ.3) THEN
      IF (iflag_wake>=1) THEN
       IF (o_ale_wk%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ale_wk%name,itau_w,ale_wake)
       ENDIF
       IF (o_alp_wk%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_alp_wk%name,itau_w,alp_wake)
       ENDIF

       IF (o_ale%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ale%name,itau_w,ale)
       ENDIF
       IF (o_alp%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_alp%name,itau_w,alp)
       ENDIF

       IF (iflag_clos .eq. 2) THEN
       IF (o_cin%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_cin%name,itau_w,cin)
       ENDIF
       ENDIF ! IF (iflag_clos .eq. 2) THEN

       IF (o_wape%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_WAPE%name,itau_w,wake_pe)
       ENDIF
       IF (o_wake_h%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_wake_h%name,itau_w,wake_h)
       ENDIF

       IF (o_wake_s%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_wake_s%name,itau_w,wake_s)
       ENDIF

        IF (o_wake_deltat%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_wake_deltat%name,
     $                     itau_w,wake_deltat)
        ENDIF

        IF (o_wake_deltaq%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_wake_deltaq%name,
     $                    itau_w,wake_deltaq)
        ENDIF

        IF (o_wake_omg%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                    o_wake_omg%name,itau_w,wake_omg)
        ENDIF

         IF (o_dtwak%flag(iff)<=lev_files(iff)) THEN
           zx_tmp_fi3d(1:klon,1:klev)=d_t_wake(1:klon,1:klev)
     &                                        /pdtphys
           CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     &                       o_dtwak%name,itau_w,zx_tmp_fi3d)
         ENDIF

        IF (o_dqwak%flag(iff)<=lev_files(iff)) THEN
        zx_tmp_fi3d(1:klon,1:klev)=d_q_wake(1:klon,1:klev)/pdtphys
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     &                     o_dqwak%name,itau_w,zx_tmp_fi3d)
        ENDIF
!#ifdef ISOVERIFIDRIS
!	write(*,*) 'phys_outputs_write 916: d_q_wake ecrit'
!#endif	
      ENDIF ! iflag_wake>=1

        IF (o_Vprecip%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_Vprecip%name,itau_w,Vprecip)
        ENDIF

        IF (o_ftd%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ftd%name,itau_w,ftd)
        ENDIF

        IF (o_fqd%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_fqd%name,itau_w,fqd)
        ENDIF

      ELSEIF (iflag_con.EQ.30) THEN
! sortie RomP convection descente insaturee iflag_con=30
       IF (o_Vprecip%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_Vprecip%name,itau_w,Vprecip)
       ENDIF
      IF (o_wdtrainA%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_wdtrainA%name,itau_w,wdtrainA)
      ENDIF
      IF (o_wdtrainM%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_wdtrainM%name,itau_w,wdtrainM)
      ENDIF

      ENDIF !(iflag_con.EQ.3.or.iflag_con.EQ.30)
 
!!! nrlmd le 10/04/2012

        IF (iflag_trig_bl>=1) THEN
          IF (o_n2%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                     o_n2%name,itau_w,n2)
         ENDIF

         IF (o_s2%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                     o_s2%name,itau_w,s2)
         ENDIF

          IF (o_proba_notrig%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                     o_proba_notrig%name,itau_w,proba_notrig)
         ENDIF

         IF (o_random_notrig%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                     o_random_notrig%name,itau_w,random_notrig)
         ENDIF

         IF (o_ale_bl_stat%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                     o_ale_bl_stat%name,itau_w,ale_bl_stat)
         ENDIF

         IF (o_ale_bl_trig%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                     o_ale_bl_trig%name,itau_w,ale_bl_trig)
         ENDIF
       ENDIF  !(iflag_trig_bl>=1)

        IF (iflag_clos_bl>=1) THEN
         IF (o_alp_bl_det%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                     o_alp_bl_det%name,itau_w,alp_bl_det)
         ENDIF

         IF (o_alp_bl_fluct_m%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                     o_alp_bl_fluct_m%name,itau_w,alp_bl_fluct_m)
         ENDIF

         IF (o_alp_bl_fluct_tke%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                o_alp_bl_fluct_tke%name,itau_w,alp_bl_fluct_tke)
         ENDIF

         IF (o_alp_bl_conv%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                     o_alp_bl_conv%name,itau_w,alp_bl_conv)
         ENDIF

         IF (o_alp_bl_stat%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                     o_alp_bl_stat%name,itau_w,alp_bl_stat)
         ENDIF
       ENDIF  !(iflag_clos_bl>=1)

!!! fin nrlmd le 10/04/2012

      IF (type_ocean=='slab ') THEN
      IF ( o_slab_bils%flag(iff)<=lev_files(iff)) 
     $     CALL histwrite_phy(
     $     nid_files(iff),clef_stations(iff),
     $o_slab_bils%name,itau_w,slab_wfbils)

      ENDIF !type_ocean == force/slab

      IF (o_weakinv%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                  o_weakinv%name,itau_w,weak_inversion)
      ENDIF

      IF (o_dthmin%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dthmin%name,itau_w,dthmin)
      ENDIF

       IF (o_cldtau%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_cldtau%name,itau_w,cldtau)
       ENDIF

       IF (o_cldemi%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_cldemi%name,itau_w,cldemi)
       ENDIF

      IF (o_pr_con_l%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s         o_pr_con_l%name,itau_w,pmflxr(:,1:klev))
      ENDIF

      IF (o_pr_con_i%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s         o_pr_con_i%name,itau_w,pmflxs(:,1:klev))
      ENDIF

      IF (o_pr_lsc_l%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s        o_pr_lsc_l%name,itau_w,prfl(:,1:klev))
      ENDIF

      IF (o_pr_lsc_i%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s        o_pr_lsc_i%name,itau_w,psfl(:,1:klev))
      ENDIF

      IF (o_re%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_re%name,itau_w,re)
      ENDIF

      IF (o_fl%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_fl%name,itau_w,fl)
      ENDIF



      IF (o_rh2m%flag(iff)<=lev_files(iff)) THEN
      DO i=1, klon
       zx_tmp_fi2d(i)=MIN(100.,rh2m(i)*100.)
      ENDDO
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rh2m%name,itau_w,zx_tmp_fi2d)
      ENDIF

      IF (.NOT.clef_stations(iff)) THEN
      IF (o_rh2m_min%flag(iff)<=lev_files(iff)) THEN
      DO i=1, klon
       zx_tmp_fi2d(i)=MIN(100.,rh2m(i)*100.)
      ENDDO
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rh2m_min%name,
     s               itau_w,zx_tmp_fi2d)
      ENDIF

      IF (o_rh2m_max%flag(iff)<=lev_files(iff)) THEN
      DO i=1, klon
       zx_tmp_fi2d(i)=MIN(100.,rh2m(i)*100.)
      ENDDO
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rh2m_max%name,
     s              itau_w,zx_tmp_fi2d)
      ENDIF
      ENDIF


      IF (o_qsat2m%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_qsat2m%name,itau_w,qsat2m)
      ENDIF

      IF (o_tpot%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_tpot%name,itau_w,tpot)
      ENDIF

       IF (o_tpote%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_tpote%name,itau_w,tpote)
       ENDIF

      IF (o_SWnetOR%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = fsolsw( 1 : klon, is_ter)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                   o_SWnetOR%name,itau_w, zx_tmp_fi2d)
      ENDIF

      IF (o_SWdownOR%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1:klon) = solsw(1:klon)/(1.-albsol1(1:klon))
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                   o_SWdownOR%name,itau_w, zx_tmp_fi2d)
      ENDIF

      IF (o_LWdownOR%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                  o_LWdownOR%name,itau_w,sollwdown)
      ENDIF

      IF (o_snowl%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_snowl%name,itau_w,snow_lsc)
      ENDIF

      IF (o_solldown%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                   o_solldown%name,itau_w,sollwdown)
      ENDIF

      IF (o_dtsvdfo%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                 o_dtsvdfo%name,itau_w,d_ts(:,is_oce))
      ENDIF

      IF (o_dtsvdft%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                   o_dtsvdft%name,itau_w,d_ts(:,is_ter))
      ENDIF

       IF (o_dtsvdfg%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                   o_dtsvdfg%name,itau_w, d_ts(:,is_lic))
       ENDIF

       IF (o_dtsvdfi%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                   o_dtsvdfi%name,itau_w,d_ts(:,is_sic))
       ENDIF

       IF (o_rugs%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rugs%name,itau_w,zxrugs)
       ENDIF

! OD550 per species
      IF (new_aod .and. (.not. aerosol_couple)) THEN
          IF (ok_ade.OR.ok_aie) THEN

          IF (o_od550aer%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_od550aer%name,itau_w,
     $            od550aer)
          ENDIF
          IF (o_od865aer%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_od865aer%name,itau_w,
     $            od865aer)
          ENDIF
          IF (o_absvisaer%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_absvisaer%name,itau_w,
     $            absvisaer)
          ENDIF
          IF (o_od550lt1aer%flag(iff)<=lev_files(iff)) THEN
            CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_od550lt1aer%name,itau_w,
     $            od550lt1aer)
          ENDIF

          IF (o_sconcso4%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_sconcso4%name,itau_w,
     $            sconcso4)
          ENDIF
          IF (o_sconcoa%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_sconcoa%name,itau_w,
     $            sconcoa)
          ENDIF
          IF (o_sconcbc%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_sconcbc%name,itau_w,
     $            sconcbc)
          ENDIF
          IF (o_sconcss%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_sconcss%name,itau_w,
     $            sconcss)
          ENDIF
          IF (o_sconcdust%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_sconcdust%name,itau_w,
     $            sconcdust)
          ENDIF
          
          IF (o_concso4%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_concso4%name,itau_w,
     $            concso4)
          ENDIF
          IF (o_concoa%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_concoa%name,itau_w,
     $            concoa)
          ENDIF
          IF (o_concbc%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_concbc%name,itau_w,
     $            concbc)
          ENDIF
          IF (o_concss%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_concss%name,itau_w,
     $            concss)
          ENDIF
          IF (o_concdust%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_concdust%name,itau_w,
     $            concdust)
          ENDIF
          
          IF (o_loadso4%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_loadso4%name,itau_w,
     $            loadso4)
          ENDIF
          IF (o_loadoa%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_loadoa%name,itau_w,
     $            loadoa)
          ENDIF
          IF (o_loadbc%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_loadbc%name,itau_w,
     $            loadbc)
          ENDIF
          IF (o_loadss%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_loadss%name,itau_w,
     $            loadss)
          ENDIF
          IF (o_loaddust%flag(iff)<=lev_files(iff)) THEN
              CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_loaddust%name,itau_w,
     $            loaddust)
          ENDIF
          
          DO naero = 1, naero_spc
            IF (o_tausumaero(naero)%flag(iff)<=lev_files(iff)) THEN
                CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $              o_tausumaero(naero)%name,itau_w,
     $              tausum_aero(:,2,naero) )
            ENDIF
          END DO
          endif
      ENDIF
      
       IF (ok_ade) THEN
          IF (o_topswad%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_topswad%name,itau_w,
     $            topswad_aero)
          ENDIF
          IF (o_topswad0%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_topswad0%name,itau_w,
     $            topswad0_aero)
          ENDIF
          IF (o_solswad%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_solswad%name,itau_w,
     $            solswad_aero)
          ENDIF
          IF (o_solswad0%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_solswad0%name,itau_w,
     $            solswad0_aero)
          ENDIF

!====MS forcing diagnostics
        if (new_aod) then	       
        IF (o_swtoaas_nat%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_swtoaas_nat%name,itau_w,
     $      topsw_aero(:,1))
        ENDIF

        IF (o_swsrfas_nat%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_swsrfas_nat%name,itau_w,
     $      solsw_aero(:,1))
        ENDIF

        IF (o_swtoacs_nat%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_swtoacs_nat%name,itau_w,
     $      topsw0_aero(:,1))
        ENDIF

        IF (o_swsrfcs_nat%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_swsrfcs_nat%name,itau_w,
     $      solsw0_aero(:,1))
        ENDIF
  
!ant
        IF (o_swtoaas_ant%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_swtoaas_ant%name,itau_w,
     $      topsw_aero(:,2))
        ENDIF

        IF (o_swsrfas_ant%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_swsrfas_ant%name,itau_w,
     $      solsw_aero(:,2))
        ENDIF

        IF (o_swtoacs_ant%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_swtoacs_ant%name,itau_w,
     $      topsw0_aero(:,2))
        ENDIF

        IF (o_swsrfcs_ant%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_swsrfcs_ant%name,itau_w,
     $      solsw0_aero(:,2))
        ENDIF

!cf

        if (.not. aerosol_couple) then
        IF (o_swtoacf_nat%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_swtoacf_nat%name,itau_w,
     $      topswcf_aero(:,1))
        ENDIF

        IF (o_swsrfcf_nat%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_swsrfcf_nat%name,itau_w,
     $      solswcf_aero(:,1))
        ENDIF

        IF (o_swtoacf_ant%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_swtoacf_ant%name,itau_w,
     $      topswcf_aero(:,2))
        ENDIF

        IF (o_swsrfcf_ant%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_swsrfcf_ant%name,itau_w,
     $      solswcf_aero(:,2))
        ENDIF

        IF (o_swtoacf_zero%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_swtoacf_zero%name,itau_w,
     $      topswcf_aero(:,3))
        ENDIF

        IF (o_swsrfcf_zero%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_swsrfcf_zero%name,itau_w,
     $      solswcf_aero(:,3))
        ENDIF
        endif

	endif ! new_aod
!====MS forcing diagnostics

       ENDIF

       IF (ok_aie) THEN
          IF (o_topswai%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_topswai%name,itau_w,
     $            topswai_aero)
          ENDIF
          IF (o_solswai%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_solswai%name,itau_w,
     $            solswai_aero)
          ENDIF
          IF (o_scdnc%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_scdnc%name,itau_w,
     $            scdnc)
          ENDIF
          IF (o_cldncl%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_cldncl%name,itau_w,
     $            cldncl)
          ENDIF
         IF (o_reffclws%flag(iff)<=lev_files(iff)) THEN
            CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_reffclws%name,itau_w,
     $            reffclws)
         ENDIF
         IF (o_reffclwc%flag(iff)<=lev_files(iff)) THEN
            CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_reffclwc%name,itau_w,
     $            reffclwc)
         ENDIF
          IF (o_cldnvi%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_cldnvi%name,itau_w,
     $            cldnvi)
          ENDIF
       ENDIF !IF (ok_aie) THEN

! crlmd 27dec2012: on déplace ce paquet en dehors du ok_aie.        
          IF (o_lcc%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_lcc%name,itau_w,
     $            lcc)
          ENDIF
          IF (o_lcc3d%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_lcc3d%name,itau_w,
     $            lcc3d)
          ENDIF
          IF (o_lcc3dcon%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_lcc3dcon%name,itau_w,
     $            lcc3dcon)
          ENDIF
          IF (o_lcc3dstra%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_lcc3dstra%name,itau_w,
     $            lcc3dstra)
          ENDIF
          IF (o_reffclwtop%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_reffclwtop%name,itau_w,
     $            reffclwtop)
          ENDIF

! Champs 3D:
       IF (ok_ade .OR. ok_aie) then
          IF (o_ec550aer%flag(iff)<=lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff),
     $clef_stations(iff),
     $o_ec550aer%name,itau_w,
     &            ec550aer)
          ENDIF
       ENDIF

	! ajout marine
       IF (o_flag_ss%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $ o_flag_ss%name,itau_w,flag_ss)
      ENDIF

       IF (o_rneb_ss%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $ o_rneb_ss%name,itau_w,rneb_ss)
      ENDIF

      IF (o_clsk_ss%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $ o_clsk_ss%name,itau_w,clsk_ss)
      ENDIF

      IF (o_flagb_ss%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $ o_flagb_ss%name,itau_w,flagb_ss)
      ENDIF
	! fin ajout marine


       IF (o_lwcon%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_lwcon%name,itau_w,flwc)
       ENDIF

       IF (o_iwcon%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_iwcon%name,itau_w,fiwc)
       ENDIF

       IF (o_temp%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_temp%name,itau_w,t_seri)
       ENDIF

       IF (o_theta%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_theta%name,itau_w,theta)
       ENDIF

       IF (o_ovapinit%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ovapinit%name,itau_w,
     $ qx(:,:,ivap))
       ENDIF

       IF (o_ovap%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $                   o_ovap%name,itau_w,q_seri)
       ENDIF
                                                               
       IF (o_oliq%flag(iff)<=lev_files(iff)) THEN              
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),    
     $                   o_oliq%name,itau_w,ql_seri)            
       ENDIF

       IF (o_geop%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_geop%name,itau_w,zphi)
       ENDIF

       IF (o_vitu%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_vitu%name,itau_w,u_seri)
       ENDIF

       IF (o_vitv%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_vitv%name,itau_w,v_seri)
       ENDIF

       IF (o_vitw%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_vitw%name,itau_w,omega)
       ENDIF

        IF (o_pres%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_pres%name,itau_w,pplay)
        ENDIF

        IF (o_paprs%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_paprs%name,
     s                    itau_w,paprs(:,1:klev))
        ENDIF

        IF (o_zfull%flag(iff)<=lev_files(iff)) THEN
         DO i=1, klon
          zx_tmp_fi3d1(i,1)= pphis(i)/RG
!020611   zx_tmp_fi3d(i,1)= pphis(i)/RG
         ENDDO
         DO k=1, klev
!020611        DO k=1, klev-1
         DO i=1, klon
!020611         zx_tmp_fi3d(i,k+1)= zx_tmp_fi3d(i,k) - (t_seri(i,k) *RD * 
          zx_tmp_fi3d1(i,k+1)= zx_tmp_fi3d1(i,k) - (t_seri(i,k) *RD * 
     $    (paprs(i,k+1) - paprs(i,k))) / ( pplay(i,k) * RG ) 
         ENDDO
         ENDDO
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_zfull%name,itau_w,zx_tmp_fi3d1(:,2:klevp1))
!020611    $o_zfull%name,itau_w,zx_tmp_fi3d)
        ENDIF

        IF (o_zhalf%flag(iff)<=lev_files(iff)) THEN
         DO i=1, klon
          zx_tmp_fi3d(i,1)= pphis(i)/RG - (
     $    (t_seri(i,1)+zxtsol(i))/2. *RD *
     $    (pplay(i,1) - paprs(i,1)))/( (paprs(i,1)+pplay(i,1))/2. * RG)
         ENDDO
         DO k=1, klev-1
         DO i=1, klon
          zx_tmp_fi3d(i,k+1)= zx_tmp_fi3d(i,k) - (
     $    (t_seri(i,k)+t_seri(i,k+1))/2. *RD * 
     $    (pplay(i,k+1) - pplay(i,k))) / ( paprs(i,k) * RG ) 
         ENDDO
         ENDDO
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_zhalf%name,itau_w,zx_tmp_fi3d)
        ENDIF

       IF (o_rneb%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rneb%name,itau_w,cldfra)
       ENDIF

       IF (o_rnebcon%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rnebcon%name,itau_w,rnebcon)
       ENDIF

       IF (o_rnebls%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rnebls%name,itau_w,rneb)
       ENDIF

       IF (o_rhum%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rhum%name,itau_w,zx_rh)
       ENDIF

      IF (o_ozone%flag(iff)<=lev_files(iff)) THEN
         CALL histwrite_phy(nid_files(iff),clef_stations(iff), 
     $o_ozone%name, itau_w,
     $        wo(:, :, 1) * dobson_u * 1e3 / zmasse / rmo3 * rmd)
      ENDIF

      IF (o_ozone_light%flag(iff)<=lev_files(iff) .and.
     $     read_climoz == 2) THEN
         CALL histwrite_phy(nid_files(iff),clef_stations(iff), 
     $o_ozone_light%name, itau_w,
     $        wo(:, :, 2) * dobson_u * 1e3 / zmasse / rmo3 * rmd)
      ENDIF

       IF (o_dtphy%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtphy%name,itau_w,d_t)
       ENDIF

       IF (o_dqphy%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                  o_dqphy%name,itau_w, d_qx(:,:,ivap))
       ENDIF

        DO nsrf=1, nbsrf
        IF (o_albe_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN 
        zx_tmp_fi2d(1 : klon) = falb1( 1 : klon, nsrf)
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                    o_albe_srf(nsrf)%name,itau_w,
     $                     zx_tmp_fi2d)
        ENDIF

        IF (o_rugs_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN  
        zx_tmp_fi2d(1 : klon) = frugs( 1 : klon, nsrf)
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                     o_rugs_srf(nsrf)%name,itau_w,
     $      zx_tmp_fi2d)
        ENDIF

        IF (o_ages_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
        zx_tmp_fi2d(1 : klon) = agesno( 1 : klon, nsrf)
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                     o_ages_srf(nsrf)%name,itau_w
     $    ,zx_tmp_fi2d)
        ENDIF
        ENDDO !nsrf=1, nbsrf

       IF (o_alb1%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_alb1%name,itau_w,albsol1)
       ENDIF

       IF (o_alb2%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_alb2%name,itau_w,albsol2)
       ENDIF

!FH Sorties pour la couche limite
      if (iflag_pbl>1) then
      zx_tmp_fi3d=0.
      do nsrf=1,nbsrf
         do k=1,klev
          zx_tmp_fi3d(:,k)=zx_tmp_fi3d(:,k)
     $    +pctsrf(:,nsrf)*pbl_tke(:,k,nsrf)
         enddo
      enddo
       IF (o_tke%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_tke%name,itau_w,zx_tmp_fi3d)
       ENDIF

      IF (.NOT.clef_stations(iff)) THEN
       IF (o_tke_max%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                   o_tke_max%name,itau_w,zx_tmp_fi3d)
       ENDIF
      ENDIF
      endif

       IF (o_kz%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_kz%name,itau_w,coefh)
       ENDIF

      IF (.NOT.clef_stations(iff)) THEN
       IF (o_kz_max%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_kz_max%name,itau_w,coefh)
       ENDIF
      ENDIF

       IF (o_clwcon%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_clwcon%name,itau_w,clwcon0)
       ENDIF

       IF (o_dtdyn%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtdyn%name,itau_w,d_t_dyn)
       ENDIF

       IF (o_dqdyn%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dqdyn%name,itau_w,d_q_dyn)
       ENDIF

       IF (o_dudyn%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dudyn%name,itau_w,d_u_dyn)
       ENDIF                                                    

       IF (o_dvdyn%flag(iff)<=lev_files(iff)) THEN                 
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dvdyn%name,itau_w,d_v_dyn)  
       ENDIF                                                     

       IF (o_dtcon%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_t_con(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtcon%name,itau_w,zx_tmp_fi3d)
      ENDIF

      if(iflag_thermals.eq.1)then
      IF (o_tntc%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_t_con(1:klon,1:klev)/pdtphys +
     $                           d_t_ajsb(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_tntc%name,itau_w,zx_tmp_fi3d)
      ENDIF
      else if(iflag_thermals.gt.1.and.iflag_wake.EQ.1)then
      IF (o_tntc%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_t_con(1:klon,1:klev)/pdtphys +
     $                           d_t_ajs(1:klon,1:klev)/pdtphys +
     $                           d_t_wake(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_tntc%name,itau_w,zx_tmp_fi3d)
      ENDIF
      endif

       IF (o_ducon%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_u_con(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ducon%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dvcon%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_v_con(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dvcon%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dqcon%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_q_con(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dqcon%name,itau_w,zx_tmp_fi3d)
       ENDIF

      if(iflag_thermals.eq.1)then
       IF (o_tnhusc%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_q_con(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_tnhusc%name,itau_w,zx_tmp_fi3d)
       ENDIF
      else if(iflag_thermals.gt.1.and.iflag_wake.EQ.1)then
      IF (o_tnhusc%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_q_con(1:klon,1:klev)/pdtphys +
     $                           d_q_ajs(1:klon,1:klev)/pdtphys +
     $                           d_q_wake(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_tnhusc%name,itau_w,zx_tmp_fi3d)
      ENDIF
      endif

       IF (o_dtlsc%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_t_lsc(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtlsc%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dtlschr%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon, 1:klev)=(d_t_lsc(1:klon,1:klev)+
     $                           d_t_eva(1:klon,1:klev))/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                   o_dtlschr%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dqlsc%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_q_lsc(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dqlsc%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_beta_prec%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=beta_prec(1:klon,1:klev)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_beta_prec%name,itau_w,zx_tmp_fi3d)
       ENDIF

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Sorties specifiques a la separation thermiques/non thermiques
       if (iflag_thermals>=1) then

       IF (o_dtlscth%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_t_lscth(1:klon,1:klev)/pdtphys
      CALL 
     s histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtlscth%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dtlscst%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_t_lscst(1:klon,1:klev)/pdtphys
      CALL 
     s histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtlscst%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dqlscth%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_q_lscth(1:klon,1:klev)/pdtphys
      CALL 
     s histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dqlscth%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dqlscst%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_q_lscst(1:klon,1:klev)/pdtphys
      CALL 
     s histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dqlscst%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_plulth%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_plulth%name,itau_w,plul_th)
       ENDIF

       IF (o_plulst%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_plulst%name,itau_w,plul_st)
       ENDIF

      do k=1,klev
      do i=1,klon
          if (ptconvth(i,k)) then
           zx_tmp_fi3d(i,k)=1.
          else
           zx_tmp_fi3d(i,k)=0.
          endif
      enddo
      enddo
       IF (o_ptconvth%flag(iff)<=lev_files(iff)) THEN
      CALL 
     s  histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ptconvth%name,itau_w,zx_tmp_fi3d)
       ENDIF

      do i=1,klon
           zx_tmp_fi2d(1:klon)=lmax_th(:)
      enddo
       IF (o_ptconvth%flag(iff)<=lev_files(iff)) THEN
      CALL 
     s histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_lmaxth%name,itau_w,zx_tmp_fi2d)
       ENDIF

      endif ! iflag_thermals>=1

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

       IF (o_dtvdf%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_t_vdf(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtvdf%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dqvdf%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_q_vdf(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dqvdf%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dteva%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_t_eva(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dteva%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dqeva%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_q_eva(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dqeva%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_ptconv%flag(iff)<=lev_files(iff)) THEN
      zpt_conv = 0.
      where (ptconv) zpt_conv = 1.
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ptconv%name,itau_w,zpt_conv)
       ENDIF

       IF (o_ratqs%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ratqs%name,itau_w,ratqs)
       ENDIF

       IF (o_dtthe%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_t_ajs(1:klon,1:klev)/pdtphys -
     $                           d_t_ajsb(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtthe%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (iflag_thermals>=1) THEN
        IF (o_ftime_th%flag(iff)<=lev_files(iff)) THEN
! Pour l instant 0 a y reflichir pour les thermiques
         zx_tmp_fi2d=0. 
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ftime_th%name,
     s                     itau_w,zx_tmp_fi2d)
        ENDIF

        IF (o_f_th%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_f_th%name,itau_w,fm_therm)
        ENDIF

        IF (o_e_th%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_e_th%name,itau_w,entr_therm)
        ENDIF

        IF (o_w_th%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_w_th%name,itau_w,zw2)
        ENDIF

        IF (o_q_th%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_q_th%name,itau_w,zqasc)
        ENDIF


        IF (o_a_th%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_a_th%name,itau_w,fraca)
        ENDIF

       IF (o_d_th%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_d_th%name,itau_w,detr_therm)
       ENDIF

       IF (o_f0_th%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_f0_th%name,itau_w,f0)
       ENDIF

       IF (o_zmax_th%flag(iff)<=lev_files(iff)) THEN
       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_zmax_th%name,itau_w,zmax_th)
       ENDIF

       IF (o_dqthe%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_q_ajs(1:klon,1:klev)/pdtphys -
     $                           d_q_ajsb(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dqthe%name,itau_w,zx_tmp_fi3d)
       ENDIF

      ENDIF !iflag_thermals

       IF (o_dtajs%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_t_ajsb(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtajs%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dqajs%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_q_ajsb(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dqajs%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dtswr%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=heat(1:klon,1:klev)/RDAY
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtswr%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dtsw0%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=heat0(1:klon,1:klev)/RDAY
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtsw0%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dtlwr%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=-1.*cool(1:klon,1:klev)/RDAY
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtlwr%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dtlw0%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=-1.*cool0(1:klon,1:klev)/RDAY
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtlw0%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dtec%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_t_ec(1:klon,1:klev)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtec%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_duvdf%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_u_vdf(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_duvdf%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_dvvdf%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_v_vdf(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dvvdf%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (ok_orodr) THEN
      IF (o_duoro%flag(iff)<=lev_files(iff)) THEN 
      zx_tmp_fi3d(1:klon,1:klev)=d_u_oro(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_duoro%name,itau_w,zx_tmp_fi3d)
       ENDIF

      IF (o_dvoro%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_v_oro(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dvoro%name,itau_w,zx_tmp_fi3d)
      ENDIF

      IF (o_dtoro%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_t_oro(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtoro%name,itau_w,zx_tmp_fi3d)
      ENDIF
       ENDIF

        IF (ok_orolf) THEN
       IF (o_dulif%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_u_lif(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dulif%name,itau_w,zx_tmp_fi3d)
       ENDIF

        IF (o_dvlif%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_v_lif(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dvlif%name,itau_w,zx_tmp_fi3d)
       ENDIF

        IF (o_dtlif%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_t_lif(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dtlif%name,itau_w,zx_tmp_fi3d)
       ENDIF
        ENDIF

       IF (ok_hines) THEN
       IF (o_duhin%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_u_hin(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_duhin%name,itau_w,zx_tmp_fi3d)
       ENDIF


        IF (o_dvhin%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_v_hin(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dvhin%name,itau_w,zx_tmp_fi3d)
       ENDIF

        IF (o_dthin%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_t_hin(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_dthin%name,itau_w,zx_tmp_fi3d)
       ENDIF
        ENDIF

       IF (o_rsu%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rsu%name,itau_w,swup)
       ENDIF
       IF (o_rsd%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rsd%name,itau_w,swdn)
       ENDIF
       IF (o_rlu%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rlu%name,itau_w,lwup)
       ENDIF
       IF (o_rld%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rld%name,itau_w,lwdn)
       ENDIF

       IF (o_rsucs%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rsucs%name,itau_w,swup0)
       ENDIF
       IF (o_rsdcs%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rsdcs%name,itau_w,swdn0)
       ENDIF
       IF (o_rlucs%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rlucs%name,itau_w,lwup0)
       ENDIF
       IF (o_rldcs%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rldcs%name,itau_w,lwdn0)
       ENDIF

       IF (o_tnt%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_t(1:klon,1:klev)+
     $d_t_dyn(1:klon,1:klev)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_tnt%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_tntr%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=heat(1:klon,1:klev)/RDAY -
     $cool(1:klon,1:klev)/RDAY
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_tntr%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_tntscpbl%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)= (d_t_lsc(1:klon,1:klev)+
     $                             d_t_eva(1:klon,1:klev)+
     $                             d_t_vdf(1:klon,1:klev))/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_tntscpbl%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_tnhus%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_qx(1:klon,1:klev,ivap)+
     $d_q_dyn(1:klon,1:klev)
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_tnhus%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_tnhusscpbl%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=d_q_lsc(1:klon,1:klev)/pdtphys+
     $                           d_q_eva(1:klon,1:klev)/pdtphys
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_tnhusscpbl%name,itau_w,zx_tmp_fi3d)
       ENDIF

       IF (o_evu%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_evu%name,itau_w,coefm)
       ENDIF

       IF (o_h2o%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi3d(1:klon,1:klev)=q_seri(1:klon,1:klev)+
     $                           ql_seri(1:klon,1:klev) 
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_h2o%name,itau_w,zx_tmp_fi3d)
       ENDIF

       if (iflag_con >= 3) then
          IF (o_mcd%flag(iff)<=lev_files(iff)) THEN
             zx_tmp_fi3d(1:klon,1:klev)=-1 * (dnwd(1:klon,1:klev)+
     $            dnwd0(1:klon,1:klev)) 
             CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $            o_mcd%name,itau_w,zx_tmp_fi3d)
          ENDIF

          IF (o_dmc%flag(iff)<=lev_files(iff)) THEN
             zx_tmp_fi3d(1:klon,1:klev)=upwd(1:klon,1:klev) +
     $            dnwd(1:klon,1:klev)+ dnwd0(1:klon,1:klev) 
             CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $            o_dmc%name,itau_w,zx_tmp_fi3d)
          ENDIF
       else if (iflag_con == 2) then
          IF (o_mcd%flag(iff) <= lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff), clef_stations(iff),
     $            o_mcd%name, itau_w, pmfd)
          ENDIF

          IF (o_dmc%flag(iff) <= lev_files(iff)) THEN
             CALL histwrite_phy(nid_files(iff), clef_stations(iff),
     $            o_dmc%name, itau_w, pmfu + pmfd)
          ENDIF
       end if

       IF (o_ref_liq%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ref_liq%name,itau_w,ref_liq)
       ENDIF

       IF (o_ref_ice%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_ref_ice%name,itau_w,ref_ice)
       ENDIF

      if (RCO2_per.NE.RCO2_act.OR.RCH4_per.NE.RCH4_act.OR.
     $ RN2O_per.NE.RN2O_act.OR.RCFC11_per.NE.RCFC11_act.OR.
     $ RCFC12_per.NE.RCFC12_act) THEN

       IF (o_rsut4co2%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = swupp ( 1 : klon, klevp1 )
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rsut4co2%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_rlut4co2%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = lwupp ( 1 : klon, klevp1 )
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rlut4co2%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_rsutcs4co2%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = swup0p ( 1 : klon, klevp1 )
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rsutcs4co2%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_rlutcs4co2%flag(iff)<=lev_files(iff)) THEN
      zx_tmp_fi2d(1 : klon) = lwup0p ( 1 : klon, klevp1 )
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rlutcs4co2%name,itau_w,zx_tmp_fi2d)
       ENDIF

       IF (o_rsu4co2%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rsu4co2%name,itau_w,swupp)
       ENDIF

       IF (o_rlu4co2%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rlu4co2%name,itau_w,lwupp)
       ENDIF

       IF (o_rsucs4co2%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rsucs4co2%name,itau_w,swup0p)
       ENDIF

       IF (o_rlucs4co2%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rlucs4co2%name,itau_w,lwup0p)
       ENDIF

       IF (o_rsd4co2%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rsd4co2%name,itau_w,swdnp)
       ENDIF

       IF (o_rld4co2%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rld4co2%name,itau_w,lwdnp)
       ENDIF

       IF (o_rsdcs4co2%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rsdcs4co2%name,itau_w,swdn0p)
       ENDIF

       IF (o_rldcs4co2%flag(iff)<=lev_files(iff)) THEN
      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $o_rldcs4co2%name,itau_w,lwdn0p)
       ENDIF

      endif

        if (nqtot.GE.3) THEN
         DO iq=3,nqtot
       IF (o_trac(iq-2)%flag(iff)<=lev_files(iff)) THEN
         CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                  o_trac(iq-2)%name,itau_w,qx(:,:,iq))
       ENDIF
         ENDDO
         DO iq=3,nqtot
       IF (o_trac_cum(iq-2)%flag(iff)<=lev_files(iff)) THEN
         zx_tmp_fi2d=0.
         do k=1,klev
            zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*qx(:,k,iq)
         enddo
         CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s                  o_trac_cum(iq-2)%name,itau_w,zx_tmp_fi2d)

       ENDIF
         ENDDO
        endif

      if (ok_sync) then
c$OMP MASTER
      call histsync(nid_files(iff))
c$OMP END MASTER
      endif

!       write(*,*) 'histwrites pour isotopes'

       do ixt=1,niso
       
        IF (o_prw%flag(iff)<=lev_files(iff)) THEN
         DO i = 1, klon
          zx_tmp_fi2d(i) = xtprw(ixt,i)
         ENDDO
         varname_iso=o_prw%name
         varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
!	 write(*,*) 'varname_iso<=',
!     :           varname_iso(1:lnblnk(varname_iso)),'>'
         CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s        varname_iso(1:lnblnk(varname_iso)),
     s        itau_w,zx_tmp_fi2d)
        ENDIF !IF (o_prw%flag(iff)<=lev_files(iff)) THEN

        IF (o_precip%flag(iff)<=lev_files(iff)) THEN
         DO i = 1, klon
          zx_tmp_fi2d(i) = xtrain_fall(ixt,i) + xtsnow_fall(ixt,i)
         ENDDO
         varname_iso=o_precip%name
         varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
!	 write(*,*) 'varname_iso<=',
!     :           varname_iso(1:lnblnk(varname_iso)),'>'
         CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     s        varname_iso(1:lnblnk(varname_iso)),
     s        itau_w,zx_tmp_fi2d)
        ENDIF !IF (o_precip%flag(iff)<=lev_files(iff)) THEN

	  
         IF (o_pluc%flag(iff)<=lev_files(iff)) THEN
         DO i = 1, klon
           zx_tmp_fi2d(i) = xtrain_con(ixt,i) + xtsnow_con(ixt,i)
         ENDDO
         varname_iso=o_pluc%name
         varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
         CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     :       varname_iso(1:lnblnk(varname_iso)),
     s       itau_w,zx_tmp_fi2d)
         ENDIF !IF (o_pluc%flag(iff)<=lev_files(iff)) THEN

         IF (o_plul%flag(iff)<=lev_files(iff)) THEN
         DO i = 1, klon
           zx_tmp_fi2d(i) = xtrain_lsc(ixt,i) + xtsnow_lsc(ixt,i)
         ENDDO
         varname_iso=o_plul%name
         varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
         CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     :       varname_iso(1:lnblnk(varname_iso)),
     s       itau_w,zx_tmp_fi2d)
         ENDIF !IF (o_plul%flag(iff)<=lev_files(iff)) THEN

         IF (o_evap%flag(iff)<=lev_files(iff)) THEN
         DO i = 1, klon
           zx_tmp_fi2d(i) = xtevap(ixt,i)
         ENDDO
         varname_iso=o_evap%name
         varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
         CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     :       varname_iso(1:lnblnk(varname_iso)),
     s       itau_w,zx_tmp_fi2d)
         ENDIF !IF (o_evap%flag(iff)<=lev_files(iff)) THEN

	 DO nsrf = 1, nbsrf
	  IF (o_evap_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
            DO i = 1, klon
               zx_tmp_fi2d(i) = fxtevap(ixt,i,nsrf)
            ENDDO
            varname_iso=o_evap_srf(nsrf)%name
            varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
      	   CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $		varname_iso(1:lnblnk(varname_iso)),
     $          itau_w,zx_tmp_fi2d)
      	  ENDIF
	 enddo !DO nsrf = 1, nbsrf

       if (.not. ok_veget) then
         IF (o_qsol%flag(iff)<=lev_files(iff)) THEN
         DO i = 1, klon
           zx_tmp_fi2d(i) = xtrain_con(ixt,i) + xtsnow_con(ixt,i)
         ENDDO
         varname_iso=o_qsol%name
         varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
         CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     :       varname_iso(1:lnblnk(varname_iso)),
     s       itau_w,zx_tmp_fi2d)
         ENDIF !IF (o_qsol%flag(iff)<=lev_files(iff)) THEN
       endif

        IF (o_ovap%flag(iff)<=lev_files(iff)) THEN
          do k=1,klev  
           DO i = 1, klon
            zx_tmp_fi3d(i,k) = xt_seri(ixt,i,k)
           ENDDO
          enddo !do k=1,klev      
          varname_iso=o_ovap%name
          varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
          CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $         varname_iso(1:lnblnk(varname_iso)),
     $         itau_w,zx_tmp_fi3d)
!	  write(*,*) 'phys_output_write 1578'
!	  write(*,*) 'ecrit ',varname_iso(1:lnblnk(varname_iso))
        ENDIF  !IF (o_ovap%flag(iff)<=lev_files(iff)) THEN

        IF (o_dqdyn%flag(iff)<=lev_files(iff)) THEN
          do k=1,klev  
           DO i = 1, klon
            zx_tmp_fi3d(i,k) = d_xt_dyn(ixt,i,k)
           ENDDO
          enddo !do k=1,klev      
          varname_iso=o_dqdyn%name
          varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
          CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $         varname_iso(1:lnblnk(varname_iso)),
     $         itau_w,zx_tmp_fi3d)
        ENDIF  !IF (o_ovap%flag(iff)<=lev_files(iff)) THEN


        IF (o_dqcon%flag(iff)<=lev_files(iff)) THEN
          do k=1,klev  
           DO i = 1, klon
            zx_tmp_fi3d(i,k) = d_xt_con(ixt,i,k)/pdtphys
           ENDDO
          enddo !do k=1,klev      
          varname_iso=o_dqcon%name
          varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
          CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $         varname_iso(1:lnblnk(varname_iso)),
     $         itau_w,zx_tmp_fi3d)
        ENDIF  !IF (o_ovap%flag(iff)<=lev_files(iff)) THEN

        IF (o_dqlsc%flag(iff)<=lev_files(iff)) THEN
          do k=1,klev  
           DO i = 1, klon
            zx_tmp_fi3d(i,k) = d_xt_lsc(ixt,i,k)/pdtphys
           ENDDO
          enddo !do k=1,klev      
          varname_iso=o_dqlsc%name
          varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
          CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $         varname_iso(1:lnblnk(varname_iso)),
     $         itau_w,zx_tmp_fi3d)
        ENDIF  !IF (o_ovap%flag(iff)<=lev_files(iff)) THEN

        IF (o_dqvdf%flag(iff)<=lev_files(iff)) THEN
          do k=1,klev  
           DO i = 1, klon
            zx_tmp_fi3d(i,k) = d_xt_vdf(ixt,i,k)/pdtphys
           ENDDO
          enddo !do k=1,klev      
          varname_iso=o_dqvdf%name
          varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
          CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $         varname_iso(1:lnblnk(varname_iso)),
     $         itau_w,zx_tmp_fi3d)
        ENDIF  !IF (o_ovap%flag(iff)<=lev_files(iff)) THEN

        IF (o_dqcosmo%flag(iff)<=lev_files(iff)) THEN
          do k=1,klev
           DO i = 1, klon
            zx_tmp_fi3d(i,k) = d_xt_cosmo(ixt,i,k)
           ENDDO
          enddo !do k=1,klev
          varname_iso=o_dqcosmo%name
          varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
          CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $         varname_iso(1:lnblnk(varname_iso)),
     $         itau_w,zx_tmp_fi3d)
        ENDIF  !IF (o_ovap%flag(iff)<=lev_files(iff)) THEN

        IF (o_dqprodnucl%flag(iff)<=lev_files(iff)) THEN
          do k=1,klev
           DO i = 1, klon
            zx_tmp_fi3d(i,k) = d_xt_prod_nucl(ixt,i,k)
           ENDDO
          enddo !do k=1,klev
          varname_iso=o_dqprodnucl%name
          varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
          CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $         varname_iso(1:lnblnk(varname_iso)),
     $         itau_w,zx_tmp_fi3d)
        ENDIF  !IF (o_ovap%flag(iff)<=lev_files(iff)) THEN

        IF (o_dqdecroiss%flag(iff)<=lev_files(iff)) THEN
          do k=1,klev
           DO i = 1, klon
            zx_tmp_fi3d(i,k) = d_xt_decroiss(ixt,i,k)
           ENDDO
          enddo !do k=1,klev
          varname_iso=o_dqdecroiss%name
          varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
          CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $         varname_iso(1:lnblnk(varname_iso)),
     $         itau_w,zx_tmp_fi3d)
        ENDIF  !IF (o_ovap%flag(iff)<=lev_files(iff)) THEN

        IF (o_dqeva%flag(iff)<=lev_files(iff)) THEN
          do k=1,klev  
           DO i = 1, klon
            zx_tmp_fi3d(i,k) = d_xt_eva(ixt,i,k)/pdtphys
           ENDDO
          enddo !do k=1,klev      
          varname_iso=o_dqeva%name
          varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
          CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $         varname_iso(1:lnblnk(varname_iso)),
     $         itau_w,zx_tmp_fi3d)
        ENDIF  !IF (o_ovap%flag(iff)<=lev_files(iff)) THEN

        IF (iflag_thermals.gt.1) THEN
         IF (o_dqthe%flag(iff)<=lev_files(iff)) THEN
          do k=1,klev  
           DO i = 1, klon
            zx_tmp_fi3d(i,k) = d_xt_ajs(ixt,i,k)/pdtphys
           ENDDO
          enddo !do k=1,klev      
          varname_iso=o_dqthe%name
          varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
          CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $         varname_iso(1:lnblnk(varname_iso)),
     $         itau_w,zx_tmp_fi3d)
         ENDIF  !IF (o_ovap%flag(iff)<=lev_files(iff)) THEN
        endif

        IF (o_dqajs%flag(iff)<=lev_files(iff)) THEN
          do k=1,klev  
           DO i = 1, klon
            zx_tmp_fi3d(i,k) = d_xt_ajsb(ixt,i,k)/pdtphys
           ENDDO
          enddo !do k=1,klev      
          varname_iso=o_dqajs%name
          varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
          CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $         varname_iso(1:lnblnk(varname_iso)),
     $         itau_w,zx_tmp_fi3d)
        ENDIF  !IF (o_ovap%flag(iff)<=lev_files(iff)) THEN
    
!	write(*,*) 'phys_output_write 2320'	
	  
      IF (iflag_con.EQ.3) THEN
      IF (iflag_wake.EQ.1) THEN
        IF (o_wake_deltaq%flag(iff)<=lev_files(iff)) THEN
          do k=1,klev  
           DO i = 1, klon
            zx_tmp_fi3d(i,k) = wake_deltaxt(ixt,i,k)
           ENDDO
          enddo !do k=1,klev      
          varname_iso=o_wake_deltaq%name
          varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
          CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $         varname_iso(1:lnblnk(varname_iso)),
     $         itau_w,zx_tmp_fi3d)
        ENDIF

        IF (o_dqwak%flag(iff)<=lev_files(iff)) THEN
          do k=1,klev  
           DO i = 1, klon
            zx_tmp_fi3d(i,k) = d_xt_wake(ixt,i,k)/pdtphys
           ENDDO
          enddo !do k=1,klev      
          varname_iso=o_dqwak%name
          varname_iso=varname_iso(1:lnblnk(varname_iso))
     :           //striso(ixt)
          CALL histwrite_phy(nid_files(iff),clef_stations(iff),
     $         varname_iso(1:lnblnk(varname_iso)),
     $         itau_w,zx_tmp_fi3d)
        ENDIF
	endif
	endif

       enddo !do ixt=1,niso

! endif ISOTRAC
! endif 1

       ENDIF ! clef_files

      ENDDO ! iff=1,nfiles


!
! $Header$
!
      IF (ok_histNMC(3)) THEN
c
       ndex3d = 0
       itau_w = itau_phy + itap + start_time * day_step / iphysiq
ccc
c  Champs interpolles sur des niveaux de pression du NMC
c
c     PARAMETER(nout=3) 
c nout=1 : in=pdtphys,    out=mth
c nout=2 : in=pdtphys,    out=day
c nout=3 : in=pdtphys,    out=hf
ccc
      CALL histwrite_phy(nid_hfnmc,lNMC,"tnondef",itau_w,
     $tnondef(:,:,3))
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"ta",itau_w,
     $twriteSTD3)
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"zg",itau_w,
     $phiwriteSTD3)
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"hus",itau_w,
     $qwriteSTD3)
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"hur",itau_w,
     $rhwriteSTD3)
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"ua",itau_w,
     $uwriteSTD3)
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"va",itau_w,
     $vwriteSTD3)
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"wap",itau_w,
     $wwriteSTD3)
c
       IF (1.EQ.0) THEN
c
       DO k=1, nlevSTD
        DO i=1, klon
         IF(tnondef(i,k,3).NE.missing_val) THEN
          zx_tmp_fiNC(i,k) = (100.*tnondef(i,k,3))/freq_moyNMC(3)
         ELSE
          zx_tmp_fiNC(i,k) = missing_val
         ENDIF
        ENDDO
       ENDDO !k=1, nlevSTD
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"psbg",itau_w,
     $zx_tmp_fiNC)
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"uv",itau_w,
     $uvsumSTD(:,:,3))
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"vq",itau_w,
     $vqsumSTD(:,:,3))
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"vT",itau_w,
     $vTsumSTD(:,:,3))
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"wq",itau_w,
     $wqsumSTD(:,:,3))
c
      CALL histwrite_phy(nid_hfnmc,lNMC,"vphi",itau_w,
     $vphisumSTD(:,:,3))
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"wT",itau_w,
     $wTsumSTD(:,:,3))
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"uxu",itau_w,
     $u2sumSTD(:,:,3))
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"vxv",itau_w,
     $v2sumSTD(:,:,3))
c
       CALL histwrite_phy(nid_hfnmc,lNMC,"TxT",itau_w,
     $T2sumSTD(:,:,3))
c
       ENDIF !(1.EQ.0) THEN
c
      if (ok_sync) then
c$OMP MASTER
        call histsync(nid_hfnmc)
c$OMP END MASTER
      endif
c
      ENDIF !      (ok_histNMC(3)) THEN
!
! $Header$
!
      IF (ok_histNMC(2)) THEN
c
       ndex3d = 0
       itau_w = itau_phy + itap + start_time * day_step / iphysiq
ccc
c  Champs interpolles sur des niveaux de pression du NMC
c
c     PARAMETER(nout=3) 
c nout=1 : in=pdtphys,    out=mth
c nout=2 : in=pdtphys,    out=day
c nout=3 : in=pdtphys,    out=hf
ccc
      IF(lev_histdayNMC.EQ.nlevSTD) THEN
       CALL histwrite_phy(nid_daynmc,lNMC,"tnondef",itau_w,
     $tnondef(:,:,2))
       CALL histwrite_phy(nid_daynmc,lNMC,"ta",itau_w,
     $twriteSTD(:,:,2))
       CALL histwrite_phy(nid_daynmc,lNMC,"zg",itau_w,
     $phiwriteSTD(:,:,2))
       CALL histwrite_phy(nid_daynmc,lNMC,"hus",itau_w,
     $qwriteSTD(:,:,2))
       CALL histwrite_phy(nid_daynmc,lNMC,"hur",itau_w,
     $rhwriteSTD(:,:,2))
       CALL histwrite_phy(nid_daynmc,lNMC,"ua",itau_w,
     $uwriteSTD(:,:,2))
       CALL histwrite_phy(nid_daynmc,lNMC,"va",itau_w,
     $vwriteSTD(:,:,2))
       CALL histwrite_phy(nid_daynmc,lNMC,"wap",itau_w,
     $wwriteSTD(:,:,2))
      ELSE IF(lev_histdayNMC.EQ.nlevSTD8) THEN
       CALL histwrite_phy(nid_daynmc,lNMC,"tnondef",itau_w,
     $tnondefSTD8)
       CALL histwrite_phy(nid_daynmc,lNMC,"ta",itau_w,
     $twriteSTD8)
       CALL histwrite_phy(nid_daynmc,lNMC,"zg",itau_w,
     $phiwriteSTD8)
       CALL histwrite_phy(nid_daynmc,lNMC,"hus",itau_w,
     $qwriteSTD8)
       CALL histwrite_phy(nid_daynmc,lNMC,"hur",itau_w,
     $rhwriteSTD8)
       CALL histwrite_phy(nid_daynmc,lNMC,"ua",itau_w,
     $uwriteSTD8)
       CALL histwrite_phy(nid_daynmc,lNMC,"va",itau_w,
     $vwriteSTD8)
       CALL histwrite_phy(nid_daynmc,lNMC,"wap",itau_w,
     $wwriteSTD8)
      ENDIF
c
      if (ok_sync) then
c$OMP MASTER
        call histsync(nid_daynmc)
c$OMP END MASTER
      endif
c
      ENDIF ! (ok_histNMC(2)) THEN
!
! $Id: write_histmthNMC.h 1665 2012-10-09 13:35:26Z fairhead $
!
      IF (ok_histNMC(1)) THEN
c
       ndex3d = 0
       itau_w = itau_phy + itap + start_time * day_step / iphysiq
ccc
c  Champs interpolles sur des niveaux de pression du NMC
c
c     PARAMETER(nout=3) 
c nout=1 : in=pdtphys,    out=mth
c nout=2 : in=pdtphys,    out=day
c nout=3 : in=pdtphys,    out=hf
ccc
      CALL histwrite_phy(nid_mthnmc,lNMC,"tnondef",itau_w,
     $tnondef(:,:,1))
c
      CALL histwrite_phy(nid_mthnmc,lNMC,"ta",itau_w,
     $twriteSTD(:,:,1))
c
      CALL histwrite_phy(nid_mthnmc,lNMC,"zg",itau_w,
     $phiwriteSTD(:,:,1))
c
       CALL histwrite_phy(nid_mthnmc,lNMC,"hus",itau_w,
     $qwriteSTD(:,:,1))
c
       CALL histwrite_phy(nid_mthnmc,lNMC,"hur",itau_w,
     $rhwriteSTD(:,:,1))
c
       CALL histwrite_phy(nid_mthnmc,lNMC,"ua",itau_w,
     $uwriteSTD(:,:,1))
c
       CALL histwrite_phy(nid_mthnmc,lNMC,"va",itau_w,
     $vwriteSTD(:,:,1))
c
       CALL histwrite_phy(nid_mthnmc,lNMC,"wap",itau_w,
     $wwriteSTD(:,:,1))
c
       DO k=1, nlevSTD
        DO i=1, klon
         IF(tnondef(i,k,1).NE.missing_val) THEN
          zx_tmp_fiNC(i,k) = (100.*tnondef(i,k,1))/freq_moyNMC(1)
         ELSE
          zx_tmp_fiNC(i,k) = missing_val
         ENDIF
        ENDDO
       ENDDO !k=1, nlevSTD
c
      CALL histwrite_phy(nid_mthnmc,lNMC,"psbg",itau_w,
     $zx_tmp_fiNC)
c
      CALL histwrite_phy(nid_mthnmc,lNMC,"uv",itau_w,
     $uvsumSTD(:,:,1))
c
      CALL histwrite_phy(nid_mthnmc,lNMC,"vq",itau_w,
     $vqsumSTD(:,:,1))
c
      CALL histwrite_phy(nid_mthnmc,lNMC,"vT",itau_w,
     $vTsumSTD(:,:,1))
c
      CALL histwrite_phy(nid_mthnmc,lNMC,"wq",itau_w,
     $wqsumSTD(:,:,1))
c
      CALL histwrite_phy(nid_mthnmc,lNMC,"vphi",itau_w,
     $vphisumSTD(:,:,1))
c
       CALL histwrite_phy(nid_mthnmc,lNMC,"wT",itau_w,
     $wTsumSTD(:,:,1))
c
       CALL histwrite_phy(nid_mthnmc,lNMC,"uxu",itau_w,
     $u2sumSTD(:,:,1))
c
       CALL histwrite_phy(nid_mthnmc,lNMC,"vxv",itau_w,
     $v2sumSTD(:,:,1))
c
       CALL histwrite_phy(nid_mthnmc,lNMC,"TxT",itau_w,
     $T2sumSTD(:,:,1))
c
       DO k=1, nlevSTD
        DO i=1, klon
         IF(O3sumSTD(i,k,1).NE.missing_val) THEN
          zx_tmp_fiNC(i,k) = O3sumSTD(i,k,1) * 1.e+9
         ELSE
          zx_tmp_fiNC(i,k) = missing_val
         ENDIF
        ENDDO
       ENDDO !k=1, nlevSTD
       CALL histwrite_phy(nid_mthnmc,lNMC,"tro3",itau_w,
     $ zx_tmp_fiNC)
c
       if (read_climoz == 2) THEN
       DO k=1, nlevSTD
        DO i=1, klon
         IF(O3daysumSTD(i,k,1).NE.missing_val) THEN
          zx_tmp_fiNC(i,k) = O3daysumSTD(i,k,1) * 1.e+9
         ELSE
          zx_tmp_fiNC(i,k) = missing_val
         ENDIF
        ENDDO
       ENDDO !k=1, nlevSTD
c
        CALL histwrite_phy(nid_mthnmc,lNMC,"tro3_daylight",
     $itau_w, zx_tmp_fiNC)
       endif 
c
      if (ok_sync) then
c$OMP MASTER
        call histsync(nid_mthnmc)
c$OMP END MASTER
      endif
c
      ENDIF !(ok_histNMC(1)) THEN

c
c $Header$
c
      IF (is_sequential) THEN
      
      IF (type_run.EQ."AMIP") THEN
c
      ndex2d = 0
      itau_w = itau_phy + itap + start_time * day_step / iphysiq
c
c Champs 2D:
c
      pi = ACOS(-1.)
      pir = 4.0*ATAN(1.0) / 180.0
c
      DO i=1, klon
       zx_tmp_fi2d(i)=(topsw(i)-toplw(i))
      ENDDO
c
      ok_msk=.FALSE.
      msk(1:klon)=pctsrf(1:klon,is_ter)
      CALL moyglo_pondaire(klon, zx_tmp_fi2d, airephy, 
     .     ok_msk, msk, moyglo)
      zx_tmp_fi2d(1:klon)=moyglo
c
      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
      CALL histwrite(nid_day_seri,"bilTOA",itau_w,
     .               zx_tmp_2d,iim*jjmp1,ndex2d)
c
      ok_msk=.FALSE.
      CALL moyglo_pondaire(klon, bils, airephy, 
     .     ok_msk, msk, moyglo)
      zx_tmp_fi2d(1:klon)=moyglo
c
      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
      CALL histwrite(nid_day_seri,"bils",itau_w,
     .               zx_tmp_2d,iim*jjmp1,ndex2d)
c
      DO k=1, klev
      DO i=1, klon
cIM 080904    zx_tmp_fi3d(i,k)=u(i,k)**2+v(i,k)**2
       zx_tmp_fi3d(i,k)=(u(i,k)**2+v(i,k)**2)/2.
      ENDDO
      ENDDO
c
      CALL moyglo_pondaima(klon, klev, zx_tmp_fi3d, 
     .     airephy, paprs, moyglo)
      zx_tmp_fi2d(1:klon)=moyglo
c
      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
      CALL histwrite(nid_day_seri,"ecin",itau_w,
     .               zx_tmp_2d,iim*jjmp1,ndex2d) 
c
cIM 151004 BEG
      IF(1.EQ.0) THEN
c
      DO k=1, klev
      DO i=1, klon
       zx_tmp_fi3d(i,k)=u_seri(i,k)*RA*cos(pir* rlat(i))
      ENDDO
      ENDDO
c
      CALL moyglo_pondaima(klon, klev, zx_tmp_fi3d, 
     .     airephy, paprs, moyglo)
      zx_tmp_fi2d(1:klon)=moyglo
c
      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
      CALL histwrite(nid_day_seri,"momang",itau_w,zx_tmp_2d,
     .               iim*jjmp1,ndex2d)
c
c friction torque
c
      DO i=1, klon
       zx_tmp_fi2d(i)=zxfluxu(i,1)*RA* cos(pir* rlat(i))
      ENDDO
c
      ok_msk=.FALSE.
      CALL moyglo_pondaire(klon, zx_tmp_fi2d, airephy, 
     .     ok_msk, msk, moyglo)
      zx_tmp_fi2d(1:klon)=moyglo
c
      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
      CALL histwrite(nid_day_seri,"frictor",itau_w,zx_tmp_2d,
     .               iim*jjmp1,ndex2d)
c
c mountain torque
c
cIM 190504 BEG
      CALL gr_fi_dyn(1,klon,iim+1,jjm+1,airephy,airedyn)
      CALL gr_fi_dyn(klev+1,klon,iim+1,jjm+1,paprs,padyn)
      CALL gr_fi_dyn(1,klon,iim+1,jjm+1,rlat,rlatdyn)
      mountor=0.
      airetot=0.
      DO j = 1, jjmp1
       DO i = 1, iim+1
        ij=i+(iim+1)*(j-1)
        zx_tmp(ij)=0.
        DO k = 1, klev
         zx_tmp(ij)=zx_tmp(ij)+dudyn(i,j,k)*airedyn(i,j)*
     $              (padyn(i,j,k+1)-padyn(i,j,k))/RG
         airetot=airetot+airedyn(i,j)
        ENDDO
cIM 190504 mountor=mountor+zx_tmp(ij)*airedyn(i,j)*RA*
        mountor=mountor+zx_tmp(ij)*RA*
     $           cos(pir* rlatdyn(i,j))
       ENDDO
      ENDDO
cIM 151004 BEG
      IF(itap.EQ.1) PRINT*,'airetot=',airetot,airetot/klev
cIM 151004 END
cIM 190504      mountor=mountor/(airetot*airetot)
      mountor=mountor/airetot
c
cIM 190504 END
      zx_tmp_2d(1:iim,1:jjmp1)=mountor
      CALL histwrite(nid_day_seri,"mountor",itau_w,zx_tmp_2d,
     .               iim*jjmp1,ndex2d)
c
      ENDIF !(1.EQ.0) THEN
c
c
      CALL gr_fi_dyn(1,klon,iim+1,jjm+1,airephy,airedyn)
      CALL gr_fi_ecrit(1,klon,iim,jjmp1,airephy,zx_tmp_2d)
      airetot=0.
c     DO j = 1, jjmp1
c      DO i = 1, iim+1
c       ij=i+(iim+1)*(j-1)
c       DO k = 1, klev
c        airetot=airetot+airedyn(i,j)
c        airetot=airetot+airedyn(i,j)
c       ENDDO !k
c      ENDDO !i
c     ENDDO !j
c
      DO i=1, klon
       airetot=airetot+airephy(i)
      ENDDO
c     IF(itap.EQ.1) PRINT*,'airetotphy=',airetot
c
      airetot=0.
      DO j=1, jjmp1
       DO i=1, iim
        airetot=airetot+zx_tmp_2d(i,j)
       ENDDO
      ENDDO
c
c     IF(itap.EQ.1) PRINT*,'airetotij=',airetot,
c    $ '4piR2',4.*pi*RA*RA
c
      zx_tmp_fi2d(1:klon)=aam/airetot
      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
      CALL histwrite(nid_day_seri,"momang",itau_w,zx_tmp_2d,
     .               iim*jjmp1,ndex2d)
c
      zx_tmp_fi2d(1:klon)=torsfc/airetot
      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
      CALL histwrite(nid_day_seri,"torsfc",itau_w,zx_tmp_2d,
     .               iim*jjmp1,ndex2d)
c
cIM 151004 END
c
      CALL moyglo_pondmass(klon, klev, t_seri,
     .     airephy, paprs, moyglo)
      zx_tmp_fi2d(1:klon)=moyglo
c
      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
      CALL histwrite(nid_day_seri,"tamv",itau_w,
     .               zx_tmp_2d,iim*jjmp1,ndex2d)
c
      ok_msk=.FALSE.
      CALL moyglo_pondaire(klon, paprs(:,1), airephy, 
     .     ok_msk, msk, moyglo)
      zx_tmp_fi2d(1:klon)=moyglo
c
      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
      CALL histwrite(nid_day_seri,"psol",itau_w,
     .               zx_tmp_2d,iim*jjmp1,ndex2d)
c
      ok_msk=.FALSE.
      CALL moyglo_pondaire(klon, evap, airephy, 
     .     ok_msk, msk, moyglo)
      zx_tmp_fi2d(1:klon)=moyglo
c
      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
      CALL histwrite(nid_day_seri,"evap",itau_w,
     .               zx_tmp_2d,iim*jjmp1,ndex2d)
c
c     DO i=1, klon
c      zx_tmp_fi2d(i)=SnowFrac(i,is_ter)
c     ENDDO
c
c     ok_msk=.TRUE.
c     msk(1:klon)=pctsrf(1:klon,is_ter)
c     CALL moyglo_pondaire(klon, zx_tmp_fi2d, airephy, 
c    .                     ok_msk, msk, moyglo)
c     zx_tmp_fi2d(1:klon)=moyglo
c
c     CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
c     CALL histwrite(nid_day_seri,"SnowFrac",
c    .               itau_w,zx_tmp_2d,iim*jjmp1,ndex2d) 
c
c     DO i=1, klon
cIM 080904    zx_tmp_fi2d(i)=zsnow_mass(i)/330.*rowl
c      zx_tmp_fi2d(i)=zsnow_mass(i)
c     ENDDO
c
cIM 140904   ok_msk=.FALSE.
c     ok_msk=.TRUE.
c     msk(1:klon)=pctsrf(1:klon,is_ter)
c     CALL moyglo_pondaire(klon, zx_tmp_fi2d, airephy, 
c    .     ok_msk, msk, moyglo)
c     zx_tmp_fi2d(1:klon)=moyglo
c
c     CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
c     CALL histwrite(nid_day_seri,"snow_depth",itau_w,
c    .               zx_tmp_2d,iim*jjmp1,ndex2d)
c
      DO i=1, klon
       zx_tmp_fi2d(i)=ftsol(i,is_oce)
      ENDDO
c
      ok_msk=.TRUE.
      msk(1:klon)=pctsrf(1:klon,is_oce)
      CALL moyglo_pondaire(klon, zx_tmp_fi2d, airephy, 
     .     ok_msk, msk, moyglo)
      zx_tmp_fi2d(1:klon)=moyglo
c
      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d, zx_tmp_2d)
      CALL histwrite(nid_day_seri,"tsol_"//clnsurf(is_oce),
     $               itau_w,zx_tmp_2d,iim*jjmp1,ndex2d) 
c
c=================================================================
c=================================================================
c=================================================================
c
      if (ok_sync) then
        call histsync(nid_day_seri)
      endif
c
      ENDIF !fin test sur type_run.EQ."AMIP"
      
      ENDIF  ! mono_cpu

c
c calcul moyennes globales
c
       zx_tmp_fi2d=bils*airephy
       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gbils)
       zx_tmp_fi2d=evap*airephy
       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gevap)
       zx_tmp_fi2d(:)=fevap(:, is_ter)*airephy(:)
       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gevapt)
       zx_tmp_fi2d=zxfluxlat*airephy
       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,glat)
       zx_tmp_fi2d=(topsw0-toplw0)*airephy
       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gnet0)
       zx_tmp_fi2d=(topsw-toplw)*airephy
       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gnet)
       zx_tmp_fi2d=(rain_fall+snow_fall)*airephy
       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,grain)
       zx_tmp_fi2d=zxtsol*airephy
       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gtsol)
       zx_tmp_fi2d=zt2m*airephy
       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gt2m)
       zx_tmp_fi2d=prw*airephy
       CALL global_mean(zx_tmp_fi2d,airephy,.TRUE.,gprw)
c
c$OMP MASTER
      if (is_mpi_root) then      
c
      ndex2d = 0
      itau_w = itau_phy + itap + start_time * day_step / iphysiq
c
c Variables globales
c
      zx_tmp_0d=R_ecc
      CALL histwrite(nid_ctesGCM,"R_ecc",itau_w,
     .               zx_tmp_0d,np,ndex2d)
c
      zx_tmp_0d=R_peri
      CALL histwrite(nid_ctesGCM,"R_peri",itau_w,
     .               zx_tmp_0d,np,ndex2d)
c
      zx_tmp_0d=R_incl
      CALL histwrite(nid_ctesGCM,"R_incl",itau_w,
     .               zx_tmp_0d,np,ndex2d)
c
      zx_tmp_0d=solaire
      CALL histwrite(nid_ctesGCM,"solaire",itau_w,
     .               zx_tmp_0d,np,ndex2d)
c
      zx_tmp_0d=co2_ppm
      CALL histwrite(nid_ctesGCM,"co2_ppm",itau_w,
     .               zx_tmp_0d,np,ndex2d)
c
      zx_tmp_0d=CH4_ppb
      CALL histwrite(nid_ctesGCM,"CH4_ppb",itau_w,
     .               zx_tmp_0d,np,ndex2d)
c
      zx_tmp_0d=N2O_ppb
      CALL histwrite(nid_ctesGCM,"N2O_ppb",itau_w,
     .               zx_tmp_0d,np,ndex2d)
c
      zx_tmp_0d=CFC11_ppt
      CALL histwrite(nid_ctesGCM,"CFC11_ppt",itau_w,
     .               zx_tmp_0d,np,ndex2d)
c
      zx_tmp_0d=CFC12_ppt
      CALL histwrite(nid_ctesGCM,"CFC12_ppt",itau_w,
     .               zx_tmp_0d,np,ndex2d)
c
c=================================================================
c moyennes globales
c
      CALL histwrite(nid_ctesGCM,"bils",itau_w,
     .               gbils,np,ndex2d)
      CALL histwrite(nid_ctesGCM,"evap",itau_w,
     .               gevap,np,ndex2d)
      CALL histwrite(nid_ctesGCM,"evap_land",itau_w,
     .               gevapt,np,ndex2d)
      CALL histwrite(nid_ctesGCM,"flat",itau_w,
     .               glat,np,ndex2d)
      CALL histwrite(nid_ctesGCM,"nettop0",itau_w,
     .               gnet0,np,ndex2d)
      CALL histwrite(nid_ctesGCM,"nettop",itau_w,
     .               gnet,np,ndex2d)
      CALL histwrite(nid_ctesGCM,"precip",itau_w,
     .               grain,np,ndex2d)
      CALL histwrite(nid_ctesGCM,"tsol",itau_w,
     .               gtsol,np,ndex2d)
      CALL histwrite(nid_ctesGCM,"t2m",itau_w,
     .               gt2m,np,ndex2d)
      CALL histwrite(nid_ctesGCM,"prw",itau_w,
     .               gprw,np,ndex2d)
c=================================================================
c
      if (ok_sync) then
        call histsync(nid_ctesGCM)
      endif
c
      endif !(is_mpi_root) then      
c$OMP END MASTER


c 22.03.04 END
c
c====================================================================
c Si c'est la fin, il faut conserver l'etat de redemarrage
c====================================================================
c
      
!         write(*,*) 'physiq 3738: appel de phyisoredem'
      !ISOVERIF
! 1

c        -----------------------------------------------------------------
c        WSTATS: Saving statistics
c        -----------------------------------------------------------------
c        ("stats" stores and accumulates 8 key variables in file "stats.nc"
c        which can later be used to make the statistic files of the run:
c        "stats")          only possible in 3D runs !

         
         IF (callstats) THEN

           call wstats(klon,o_psol%name,"Surface pressure","Pa"
     &                 ,2,paprs(:,1))
           call wstats(klon,o_tsol%name,"Surface temperature","K",
     &                 2,zxtsol)
           zx_tmp_fi2d(:) = rain_fall(:) + snow_fall(:)
           call wstats(klon,o_precip%name,"Precip Totale liq+sol",
     &                 "kg/(s*m2)",2,zx_tmp_fi2d)
           zx_tmp_fi2d(:) = rain_lsc(:) + snow_lsc(:)
           call wstats(klon,o_plul%name,"Large-scale Precip",
     &                 "kg/(s*m2)",2,zx_tmp_fi2d)
           zx_tmp_fi2d(:) = rain_con(:) + snow_con(:)
           call wstats(klon,o_pluc%name,"Convective Precip",
     &                 "kg/(s*m2)",2,zx_tmp_fi2d)
           call wstats(klon,o_sols%name,"Solar rad. at surf.",
     &                 "W/m2",2,solsw)
           call wstats(klon,o_soll%name,"IR rad. at surf.",
     &                 "W/m2",2,sollw)
          zx_tmp_fi2d(:) = topsw(:)-toplw(:)
          call wstats(klon,o_nettop%name,"Net dn radiatif flux at TOA",
     &                 "W/m2",2,zx_tmp_fi2d)



           call wstats(klon,o_temp%name,"Air temperature","K",
     &                 3,t_seri)
           call wstats(klon,o_vitu%name,"Zonal wind","m.s-1",
     &                 3,u_seri)
           call wstats(klon,o_vitv%name,"Meridional wind",
     &                "m.s-1",3,v_seri)
           call wstats(klon,o_vitw%name,"Vertical wind",
     &                "m.s-1",3,omega)
           call wstats(klon,o_ovap%name,"Specific humidity", "kg/kg",
     &                 3,q_seri)
 


           IF(lafin) THEN
             write (*,*) "Writing stats..."
             call mkstats(ierr)
           ENDIF

         ENDIF !if callstats
     

      IF (lafin) THEN
         itau_phy = itau_phy + itap
         ! on met les isotopes directement ici
         CALL phyredem ("restartphy.nc")
         ! call phyisoredem directement dans phyredem
!         open(97,form="unformatted",file="finbin")
!         write(97) u_seri,v_seri,t_seri,q_seri
!         close(97)
C$OMP MASTER
         if (read_climoz >= 1) then
            if (is_mpi_root) then
               call nf95_close(ncid_climoz)
            end if
            deallocate(press_climoz) ! pointer
         end if
C$OMP END MASTER
      ENDIF
      
!      first=.false.

      RETURN
      END
      FUNCTION qcheck(klon,klev,paprs,q,ql,aire)
      IMPLICIT none
c
c Calculer et imprimer l'eau totale. A utiliser pour verifier
c la conservation de l'eau
c
!
! $Header$
!
!  ATTENTION!!!!: ce fichier include est compatible format fixe/format libre
!                 veillez  n'utiliser que des ! pour les commentaires
!                 et  bien positionner les & des lignes de continuation
!                 (les placer en colonne 6 et en colonne 73)
!
!
! A1.0 Fundamental constants
      REAL RPI,RCLUM,RHPLA,RKBOL,RNAVO
! A1.1 Astronomical constants
      REAL RDAY,REA,REPSM,RSIYEA,RSIDAY,ROMEGA
! A1.1.bis Constantes concernant l'orbite de la Terre:
      REAL R_ecc, R_peri, R_incl
! A1.2 Geoide
      REAL RA,RG,R1SA
! A1.3 Radiation
!     REAL RSIGMA,RI0
      REAL RSIGMA
! A1.4 Thermodynamic gas phase
      REAL R,RMD,RMO3,RMV,RD,RV,RCPD,RCPV,RCVD,RCVV
      REAL RKAPPA,RETV
! A1.5,6 Thermodynamic liquid,solid phases
      REAL RCW,RCS
! A1.7 Thermodynamic transition of phase
      REAL RLVTT,RLSTT,RLMLT,RTT,RATM
! A1.8 Curve of saturation
      REAL RESTT,RALPW,RBETW,RGAMW,RALPS,RBETS,RGAMS
      REAL RALPD,RBETD,RGAMD
!
      COMMON/YOMCST/RPI   ,RCLUM ,RHPLA ,RKBOL ,RNAVO                   &
     &      ,RDAY  ,REA   ,REPSM ,RSIYEA,RSIDAY,ROMEGA                  &
     &      ,R_ecc, R_peri, R_incl                                      &
     &      ,RA    ,RG    ,R1SA                                         &
     &      ,RSIGMA                                                     &
     &      ,R     ,RMD   ,RMO3  ,RMV   ,RD    ,RV    ,RCPD             &
     &      ,RCPV  ,RCVD  ,RCVV  ,RKAPPA,RETV                           &
     &      ,RCW   ,RCS                                                 &
     &      ,RLVTT ,RLSTT ,RLMLT ,RTT   ,RATM                           &
     &      ,RESTT ,RALPW ,RBETW ,RGAMW ,RALPS ,RBETS ,RGAMS            &
     &      ,RALPD ,RBETD ,RGAMD
!    ------------------------------------------------------------------
!$OMP THREADPRIVATE(/YOMCST/)
      INTEGER klon,klev
      REAL paprs(klon,klev+1), q(klon,klev), ql(klon,klev)
      REAL aire(klon)
      REAL qtotal, zx, qcheck
      INTEGER i, k
c
      zx = 0.0
      DO i = 1, klon
         zx = zx + aire(i)
      ENDDO
      qtotal = 0.0
      DO k = 1, klev
      DO i = 1, klon
         qtotal = qtotal + (q(i,k)+ql(i,k)) * aire(i)
     .                     *(paprs(i,k)-paprs(i,k+1))/RG
      ENDDO
      ENDDO
c
      qcheck = qtotal/zx
c
      RETURN
      END
      SUBROUTINE gr_fi_ecrit(nfield,nlon,iim,jjmp1,fi,ecrit)
      IMPLICIT none
c
c Tranformer une variable de la grille physique a
c la grille d'ecriture
c
      INTEGER nfield,nlon,iim,jjmp1, jjm
      REAL fi(nlon,nfield), ecrit(iim*jjmp1,nfield)
c
      INTEGER i, n, ig
c
      jjm = jjmp1 - 1
      DO n = 1, nfield
         DO i=1,iim
            ecrit(i,n) = fi(1,n)
            ecrit(i+jjm*iim,n) = fi(nlon,n)
         ENDDO
         DO ig = 1, nlon - 2
           ecrit(iim+ig,n) = fi(1+ig,n)
         ENDDO
      ENDDO
      RETURN
      END
